#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 882
#define LARGE_STATE_COUNT 329
#define SYMBOL_COUNT 517
#define ALIAS_COUNT 3
#define TOKEN_COUNT 324
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 88

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_pragma = 2,
  anon_sym_PIPE_PIPE = 3,
  anon_sym_DASH = 4,
  anon_sym_solidity = 5,
  aux_sym_pragma_value_token1 = 6,
  sym_solidity_version = 7,
  anon_sym_LT_EQ = 8,
  anon_sym_LT = 9,
  anon_sym_CARET = 10,
  anon_sym_GT = 11,
  anon_sym_GT_EQ = 12,
  anon_sym_TILDE = 13,
  anon_sym_EQ = 14,
  anon_sym_import = 15,
  anon_sym_from = 16,
  anon_sym_STAR = 17,
  anon_sym_LBRACE = 18,
  anon_sym_COMMA = 19,
  anon_sym_RBRACE = 20,
  anon_sym_as = 21,
  anon_sym_type = 22,
  anon_sym_is = 23,
  anon_sym_constant = 24,
  anon_sym_abstract = 25,
  anon_sym_contract = 26,
  anon_sym_error = 27,
  anon_sym_LPAREN = 28,
  anon_sym_RPAREN = 29,
  anon_sym_interface = 30,
  anon_sym_library = 31,
  anon_sym_struct = 32,
  anon_sym_enum = 33,
  anon_sym_event = 34,
  anon_sym_anonymous = 35,
  anon_sym_indexed = 36,
  anon_sym_using = 37,
  anon_sym_for = 38,
  anon_sym_assembly = 39,
  anon_sym_DQUOTEevmasm_DQUOTE = 40,
  anon_sym_COLON = 41,
  sym_yul_leave = 42,
  anon_sym_break = 43,
  anon_sym_continue = 44,
  anon_sym_DOT = 45,
  sym_yul_decimal_number = 46,
  sym_yul_hex_number = 47,
  anon_sym_true = 48,
  anon_sym_false = 49,
  anon_sym_let = 50,
  anon_sym_COLON_EQ = 51,
  anon_sym_if = 52,
  anon_sym_switch = 53,
  anon_sym_default = 54,
  anon_sym_case = 55,
  anon_sym_function = 56,
  anon_sym_DASH_GT = 57,
  anon_sym_stop = 58,
  anon_sym_add = 59,
  anon_sym_sub = 60,
  anon_sym_mul = 61,
  anon_sym_div = 62,
  anon_sym_sdiv = 63,
  anon_sym_mod = 64,
  anon_sym_smod = 65,
  anon_sym_exp = 66,
  anon_sym_not = 67,
  anon_sym_lt = 68,
  anon_sym_gt = 69,
  anon_sym_slt = 70,
  anon_sym_sgt = 71,
  anon_sym_eq = 72,
  anon_sym_iszero = 73,
  anon_sym_and = 74,
  anon_sym_or = 75,
  anon_sym_xor = 76,
  anon_sym_byte = 77,
  anon_sym_shl = 78,
  anon_sym_shr = 79,
  anon_sym_sar = 80,
  anon_sym_addmod = 81,
  anon_sym_mulmod = 82,
  anon_sym_signextend = 83,
  anon_sym_keccak256 = 84,
  anon_sym_pop = 85,
  anon_sym_mload = 86,
  anon_sym_mcopy = 87,
  anon_sym_tload = 88,
  anon_sym_tstore = 89,
  anon_sym_mstore = 90,
  anon_sym_mstore8 = 91,
  anon_sym_sload = 92,
  anon_sym_sstore = 93,
  anon_sym_msize = 94,
  anon_sym_gas = 95,
  anon_sym_address = 96,
  anon_sym_balance = 97,
  anon_sym_selfbalance = 98,
  anon_sym_caller = 99,
  anon_sym_callvalue = 100,
  anon_sym_calldataload = 101,
  anon_sym_calldatasize = 102,
  anon_sym_calldatacopy = 103,
  anon_sym_extcodesize = 104,
  anon_sym_extcodecopy = 105,
  anon_sym_returndatasize = 106,
  anon_sym_returndatacopy = 107,
  anon_sym_extcodehash = 108,
  anon_sym_create = 109,
  anon_sym_create2 = 110,
  anon_sym_call = 111,
  anon_sym_callcode = 112,
  anon_sym_delegatecall = 113,
  anon_sym_staticcall = 114,
  anon_sym_return = 115,
  anon_sym_revert = 116,
  anon_sym_selfdestruct = 117,
  anon_sym_invalid = 118,
  anon_sym_log0 = 119,
  anon_sym_log1 = 120,
  anon_sym_log2 = 121,
  anon_sym_log3 = 122,
  anon_sym_log4 = 123,
  anon_sym_chainid = 124,
  anon_sym_origin = 125,
  anon_sym_gasprice = 126,
  anon_sym_blockhash = 127,
  anon_sym_blobhash = 128,
  anon_sym_basefee = 129,
  anon_sym_blobfee = 130,
  anon_sym_coinbase = 131,
  anon_sym_timestamp = 132,
  anon_sym_number = 133,
  anon_sym_difficulty = 134,
  anon_sym_gaslimit = 135,
  sym_unchecked = 136,
  anon_sym_memory = 137,
  anon_sym_storage = 138,
  anon_sym_calldata = 139,
  anon_sym_var = 140,
  anon_sym_else = 141,
  anon_sym_while = 142,
  anon_sym_do = 143,
  anon_sym_try = 144,
  anon_sym_returns = 145,
  anon_sym_catch = 146,
  anon_sym_emit = 147,
  anon_sym_public = 148,
  anon_sym_internal = 149,
  anon_sym_private = 150,
  anon_sym_external = 151,
  anon_sym_pure = 152,
  anon_sym_view = 153,
  anon_sym_payable = 154,
  anon_sym_transient = 155,
  sym_immutable = 156,
  anon_sym_override = 157,
  anon_sym_modifier = 158,
  anon_sym_constructor = 159,
  anon_sym_fallback = 160,
  anon_sym_receive = 161,
  sym_virtual = 162,
  anon_sym_QMARK = 163,
  anon_sym_new = 164,
  anon_sym_LBRACK = 165,
  anon_sym_RBRACK = 166,
  anon_sym_AMP_AMP = 167,
  anon_sym_EQ_EQ = 168,
  anon_sym_BANG_EQ = 169,
  anon_sym_PIPE = 170,
  anon_sym_AMP = 171,
  anon_sym_LT_LT = 172,
  anon_sym_GT_GT = 173,
  anon_sym_PLUS = 174,
  anon_sym_SLASH = 175,
  anon_sym_PERCENT = 176,
  anon_sym_STAR_STAR = 177,
  anon_sym_delete = 178,
  anon_sym_BANG = 179,
  anon_sym_PLUS_PLUS = 180,
  anon_sym_DASH_DASH = 181,
  anon_sym_PLUS_EQ = 182,
  anon_sym_DASH_EQ = 183,
  anon_sym_STAR_EQ = 184,
  anon_sym_SLASH_EQ = 185,
  anon_sym_PERCENT_EQ = 186,
  anon_sym_CARET_EQ = 187,
  anon_sym_AMP_EQ = 188,
  anon_sym_PIPE_EQ = 189,
  anon_sym_GT_GT_EQ = 190,
  anon_sym_LT_LT_EQ = 191,
  anon_sym_mapping = 192,
  anon_sym_EQ_GT = 193,
  anon_sym_bool = 194,
  anon_sym_string = 195,
  anon_sym_int = 196,
  anon_sym_int8 = 197,
  anon_sym_int16 = 198,
  anon_sym_int24 = 199,
  anon_sym_int32 = 200,
  anon_sym_int40 = 201,
  anon_sym_int48 = 202,
  anon_sym_int56 = 203,
  anon_sym_int64 = 204,
  anon_sym_int72 = 205,
  anon_sym_int80 = 206,
  anon_sym_int88 = 207,
  anon_sym_int96 = 208,
  anon_sym_int104 = 209,
  anon_sym_int112 = 210,
  anon_sym_int120 = 211,
  anon_sym_int128 = 212,
  anon_sym_int136 = 213,
  anon_sym_int144 = 214,
  anon_sym_int152 = 215,
  anon_sym_int160 = 216,
  anon_sym_int168 = 217,
  anon_sym_int176 = 218,
  anon_sym_int184 = 219,
  anon_sym_int192 = 220,
  anon_sym_int200 = 221,
  anon_sym_int208 = 222,
  anon_sym_int216 = 223,
  anon_sym_int224 = 224,
  anon_sym_int232 = 225,
  anon_sym_int240 = 226,
  anon_sym_int248 = 227,
  anon_sym_int256 = 228,
  anon_sym_uint = 229,
  anon_sym_uint8 = 230,
  anon_sym_uint16 = 231,
  anon_sym_uint24 = 232,
  anon_sym_uint32 = 233,
  anon_sym_uint40 = 234,
  anon_sym_uint48 = 235,
  anon_sym_uint56 = 236,
  anon_sym_uint64 = 237,
  anon_sym_uint72 = 238,
  anon_sym_uint80 = 239,
  anon_sym_uint88 = 240,
  anon_sym_uint96 = 241,
  anon_sym_uint104 = 242,
  anon_sym_uint112 = 243,
  anon_sym_uint120 = 244,
  anon_sym_uint128 = 245,
  anon_sym_uint136 = 246,
  anon_sym_uint144 = 247,
  anon_sym_uint152 = 248,
  anon_sym_uint160 = 249,
  anon_sym_uint168 = 250,
  anon_sym_uint176 = 251,
  anon_sym_uint184 = 252,
  anon_sym_uint192 = 253,
  anon_sym_uint200 = 254,
  anon_sym_uint208 = 255,
  anon_sym_uint216 = 256,
  anon_sym_uint224 = 257,
  anon_sym_uint232 = 258,
  anon_sym_uint240 = 259,
  anon_sym_uint248 = 260,
  anon_sym_uint256 = 261,
  anon_sym_bytes = 262,
  anon_sym_bytes1 = 263,
  anon_sym_bytes2 = 264,
  anon_sym_bytes3 = 265,
  anon_sym_bytes4 = 266,
  anon_sym_bytes5 = 267,
  anon_sym_bytes6 = 268,
  anon_sym_bytes7 = 269,
  anon_sym_bytes8 = 270,
  anon_sym_bytes9 = 271,
  anon_sym_bytes10 = 272,
  anon_sym_bytes11 = 273,
  anon_sym_bytes12 = 274,
  anon_sym_bytes13 = 275,
  anon_sym_bytes14 = 276,
  anon_sym_bytes15 = 277,
  anon_sym_bytes16 = 278,
  anon_sym_bytes17 = 279,
  anon_sym_bytes18 = 280,
  anon_sym_bytes19 = 281,
  anon_sym_bytes20 = 282,
  anon_sym_bytes21 = 283,
  anon_sym_bytes22 = 284,
  anon_sym_bytes23 = 285,
  anon_sym_bytes24 = 286,
  anon_sym_bytes25 = 287,
  anon_sym_bytes26 = 288,
  anon_sym_bytes27 = 289,
  anon_sym_bytes28 = 290,
  anon_sym_bytes29 = 291,
  anon_sym_bytes30 = 292,
  anon_sym_bytes31 = 293,
  anon_sym_bytes32 = 294,
  anon_sym_fixed = 295,
  aux_sym__fixed_token1 = 296,
  anon_sym_ufixed = 297,
  aux_sym__ufixed_token1 = 298,
  anon_sym_SEMI = 299,
  aux_sym__decimal_number_token1 = 300,
  aux_sym__decimal_number_token2 = 301,
  aux_sym__hex_number_token1 = 302,
  sym__hex_digit = 303,
  anon_sym_wei = 304,
  anon_sym_szabo = 305,
  anon_sym_finney = 306,
  anon_sym_gwei = 307,
  anon_sym_ether = 308,
  anon_sym_seconds = 309,
  anon_sym_minutes = 310,
  anon_sym_hours = 311,
  anon_sym_days = 312,
  anon_sym_weeks = 313,
  anon_sym_years = 314,
  anon_sym_hex = 315,
  anon_sym_DQUOTE = 316,
  anon_sym__ = 317,
  anon_sym_SQUOTE = 318,
  sym__escape_sequence = 319,
  aux_sym__single_quoted_unicode_char_token1 = 320,
  aux_sym__double_quoted_unicode_char_token1 = 321,
  anon_sym_unicode = 322,
  sym_comment = 323,
  sym_source_file = 324,
  sym__source_unit = 325,
  sym__directive = 326,
  sym_pragma_directive = 327,
  sym_solidity_pragma_token = 328,
  sym_any_pragma_token = 329,
  sym__solidity = 330,
  sym_pragma_value = 331,
  sym__pragma_version_constraint = 332,
  sym_solidity_version_comparison_operator = 333,
  sym_import_directive = 334,
  sym__source_import = 335,
  sym__import_clause = 336,
  sym__from_clause = 337,
  sym__single_import = 338,
  sym__multiple_import = 339,
  sym__import_declaration = 340,
  sym__import_alias = 341,
  sym__declaration = 342,
  sym_user_defined_type_definition = 343,
  sym_constant_variable_declaration = 344,
  sym_contract_declaration = 345,
  sym_error_declaration = 346,
  sym_error_parameter = 347,
  sym_interface_declaration = 348,
  sym_library_declaration = 349,
  sym__class_heritage = 350,
  sym_inheritance_specifier = 351,
  sym_contract_body = 352,
  sym__contract_member = 353,
  sym_struct_declaration = 354,
  sym_struct_member = 355,
  sym_struct_body = 356,
  sym_enum_declaration = 357,
  sym_enum_body = 358,
  sym_event_definition = 359,
  sym__event_parameter_list = 360,
  sym_event_parameter = 361,
  sym_using_directive = 362,
  sym_any_source_type = 363,
  sym_statement = 364,
  sym_assembly_statement = 365,
  sym_assembly_flags = 366,
  sym__yul_statement = 367,
  sym_yul_label = 368,
  sym_yul_break = 369,
  sym_yul_continue = 370,
  sym_yul_identifier = 371,
  sym__yul_expression = 372,
  sym_yul_path = 373,
  sym__yul_literal = 374,
  sym_yul_string_literal = 375,
  sym_yul_boolean = 376,
  sym_yul_block = 377,
  sym_yul_variable_declaration = 378,
  sym__yul_assignment_operator = 379,
  sym_yul_assignment = 380,
  sym_yul_function_call = 381,
  sym_yul_if_statement = 382,
  sym_yul_for_statement = 383,
  sym_yul_switch_statement = 384,
  sym_yul_function_definition = 385,
  sym_yul_evm_builtin = 386,
  sym_block_statement = 387,
  sym_variable_declaration_statement = 388,
  sym_variable_declaration = 389,
  sym_variable_declaration_tuple = 390,
  sym_expression_statement = 391,
  sym_if_statement = 392,
  sym_for_statement = 393,
  sym_while_statement = 394,
  sym_do_while_statement = 395,
  sym_continue_statement = 396,
  sym_break_statement = 397,
  sym_revert_statement = 398,
  sym_try_statement = 399,
  sym_catch_clause = 400,
  sym_return_statement = 401,
  sym_emit_statement = 402,
  sym_state_variable_declaration = 403,
  sym_visibility = 404,
  sym_state_mutability = 405,
  sym_state_location = 406,
  sym_override_specifier = 407,
  sym_modifier_definition = 408,
  sym_constructor_definition = 409,
  sym_fallback_receive_definition = 410,
  sym_function_definition = 411,
  sym_return_type_definition = 412,
  sym_modifier_invocation = 413,
  sym__call_arguments = 414,
  sym_call_argument = 415,
  sym_call_struct_argument = 416,
  sym_function_body = 417,
  sym_expression = 418,
  sym__primary_expression = 419,
  sym_type_cast_expression = 420,
  sym_ternary_expression = 421,
  sym_new_expression = 422,
  sym_tuple_expression = 423,
  sym_inline_array_expression = 424,
  sym_binary_expression = 425,
  sym_unary_expression = 426,
  sym_update_expression = 427,
  sym_member_expression = 428,
  sym_array_access = 429,
  sym_slice_access = 430,
  sym_struct_expression = 431,
  sym_struct_field_assignment = 432,
  sym_parenthesized_expression = 433,
  sym_assignment_expression = 434,
  sym_augmented_assignment_expression = 435,
  sym_call_expression = 436,
  sym_payable_conversion_expression = 437,
  sym_meta_type_expression = 438,
  sym_type_name = 439,
  sym__array_type = 440,
  sym__function_type = 441,
  sym__parameter_list = 442,
  sym__return_parameters = 443,
  sym__nameless_parameter = 444,
  sym_parameter = 445,
  sym__storage_location = 446,
  sym_user_defined_type = 447,
  sym__identifier_path = 448,
  sym__mapping = 449,
  sym__mapping_key = 450,
  sym_primitive_type = 451,
  sym__int = 452,
  sym__uint = 453,
  sym__bytes = 454,
  sym__fixed = 455,
  sym__ufixed = 456,
  sym__semicolon = 457,
  sym__literal = 458,
  sym_string_literal = 459,
  sym_number_literal = 460,
  sym__decimal_number = 461,
  sym__hex_number = 462,
  sym_number_unit = 463,
  sym_true = 464,
  sym_false = 465,
  sym_boolean_literal = 466,
  sym_hex_string_literal = 467,
  sym__single_quoted_unicode_char = 468,
  sym__double_quoted_unicode_char = 469,
  sym_unicode_string_literal = 470,
  sym_string = 471,
  sym__string_immediate_elt_inside_double_quote = 472,
  sym__string_immediate_elt_inside_quote = 473,
  aux_sym_source_file_repeat1 = 474,
  aux_sym_solidity_pragma_token_repeat1 = 475,
  aux_sym__multiple_import_repeat1 = 476,
  aux_sym_error_declaration_repeat1 = 477,
  aux_sym__class_heritage_repeat1 = 478,
  aux_sym_contract_body_repeat1 = 479,
  aux_sym_struct_body_repeat1 = 480,
  aux_sym_enum_body_repeat1 = 481,
  aux_sym__event_parameter_list_repeat1 = 482,
  aux_sym_assembly_statement_repeat1 = 483,
  aux_sym_assembly_flags_repeat1 = 484,
  aux_sym_yul_path_repeat1 = 485,
  aux_sym_yul_variable_declaration_repeat1 = 486,
  aux_sym_yul_assignment_repeat1 = 487,
  aux_sym_yul_function_call_repeat1 = 488,
  aux_sym_yul_switch_statement_repeat1 = 489,
  aux_sym_block_statement_repeat1 = 490,
  aux_sym_variable_declaration_tuple_repeat1 = 491,
  aux_sym_variable_declaration_tuple_repeat2 = 492,
  aux_sym_try_statement_repeat1 = 493,
  aux_sym_state_variable_declaration_repeat1 = 494,
  aux_sym_override_specifier_repeat1 = 495,
  aux_sym_modifier_definition_repeat1 = 496,
  aux_sym_constructor_definition_repeat1 = 497,
  aux_sym_fallback_receive_definition_repeat1 = 498,
  aux_sym_function_definition_repeat1 = 499,
  aux_sym__call_arguments_repeat1 = 500,
  aux_sym_call_argument_repeat1 = 501,
  aux_sym_tuple_expression_repeat1 = 502,
  aux_sym_inline_array_expression_repeat1 = 503,
  aux_sym_struct_expression_repeat1 = 504,
  aux_sym__function_type_repeat1 = 505,
  aux_sym__parameter_list_repeat1 = 506,
  aux_sym__return_parameters_repeat1 = 507,
  aux_sym__identifier_path_repeat1 = 508,
  aux_sym_string_literal_repeat1 = 509,
  aux_sym_hex_string_literal_repeat1 = 510,
  aux_sym_hex_string_literal_repeat2 = 511,
  aux_sym_unicode_string_literal_repeat1 = 512,
  aux_sym_unicode_string_literal_repeat2 = 513,
  aux_sym_unicode_string_literal_repeat3 = 514,
  aux_sym_string_repeat1 = 515,
  aux_sym_string_repeat2 = 516,
  alias_sym_enum_value = 517,
  alias_sym_revert_arguments = 518,
  alias_sym_type_alias = 519,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_pragma] = "pragma",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_DASH] = "-",
  [anon_sym_solidity] = "solidity",
  [aux_sym_pragma_value_token1] = "pragma_value_token1",
  [sym_solidity_version] = "solidity_version",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_CARET] = "^",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ] = "=",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_type] = "type",
  [anon_sym_is] = "is",
  [anon_sym_constant] = "constant",
  [anon_sym_abstract] = "abstract",
  [anon_sym_contract] = "contract",
  [anon_sym_error] = "error",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_interface] = "interface",
  [anon_sym_library] = "library",
  [anon_sym_struct] = "struct",
  [anon_sym_enum] = "enum",
  [anon_sym_event] = "event",
  [anon_sym_anonymous] = "anonymous",
  [anon_sym_indexed] = "indexed",
  [anon_sym_using] = "using",
  [anon_sym_for] = "for",
  [anon_sym_assembly] = "assembly",
  [anon_sym_DQUOTEevmasm_DQUOTE] = "\"evmasm\"",
  [anon_sym_COLON] = ":",
  [sym_yul_leave] = "yul_leave",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_DOT] = ".",
  [sym_yul_decimal_number] = "yul_decimal_number",
  [sym_yul_hex_number] = "yul_hex_number",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_let] = "let",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_default] = "default",
  [anon_sym_case] = "case",
  [anon_sym_function] = "function",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_stop] = "stop",
  [anon_sym_add] = "add",
  [anon_sym_sub] = "sub",
  [anon_sym_mul] = "mul",
  [anon_sym_div] = "div",
  [anon_sym_sdiv] = "sdiv",
  [anon_sym_mod] = "mod",
  [anon_sym_smod] = "smod",
  [anon_sym_exp] = "exp",
  [anon_sym_not] = "not",
  [anon_sym_lt] = "lt",
  [anon_sym_gt] = "gt",
  [anon_sym_slt] = "slt",
  [anon_sym_sgt] = "sgt",
  [anon_sym_eq] = "eq",
  [anon_sym_iszero] = "iszero",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_byte] = "byte",
  [anon_sym_shl] = "shl",
  [anon_sym_shr] = "shr",
  [anon_sym_sar] = "sar",
  [anon_sym_addmod] = "addmod",
  [anon_sym_mulmod] = "mulmod",
  [anon_sym_signextend] = "signextend",
  [anon_sym_keccak256] = "keccak256",
  [anon_sym_pop] = "pop",
  [anon_sym_mload] = "mload",
  [anon_sym_mcopy] = "mcopy",
  [anon_sym_tload] = "tload",
  [anon_sym_tstore] = "tstore",
  [anon_sym_mstore] = "mstore",
  [anon_sym_mstore8] = "mstore8",
  [anon_sym_sload] = "sload",
  [anon_sym_sstore] = "sstore",
  [anon_sym_msize] = "msize",
  [anon_sym_gas] = "gas",
  [anon_sym_address] = "address",
  [anon_sym_balance] = "balance",
  [anon_sym_selfbalance] = "selfbalance",
  [anon_sym_caller] = "caller",
  [anon_sym_callvalue] = "callvalue",
  [anon_sym_calldataload] = "calldataload",
  [anon_sym_calldatasize] = "calldatasize",
  [anon_sym_calldatacopy] = "calldatacopy",
  [anon_sym_extcodesize] = "extcodesize",
  [anon_sym_extcodecopy] = "extcodecopy",
  [anon_sym_returndatasize] = "returndatasize",
  [anon_sym_returndatacopy] = "returndatacopy",
  [anon_sym_extcodehash] = "extcodehash",
  [anon_sym_create] = "create",
  [anon_sym_create2] = "create2",
  [anon_sym_call] = "call",
  [anon_sym_callcode] = "callcode",
  [anon_sym_delegatecall] = "delegatecall",
  [anon_sym_staticcall] = "staticcall",
  [anon_sym_return] = "return",
  [anon_sym_revert] = "revert",
  [anon_sym_selfdestruct] = "selfdestruct",
  [anon_sym_invalid] = "invalid",
  [anon_sym_log0] = "log0",
  [anon_sym_log1] = "log1",
  [anon_sym_log2] = "log2",
  [anon_sym_log3] = "log3",
  [anon_sym_log4] = "log4",
  [anon_sym_chainid] = "chainid",
  [anon_sym_origin] = "origin",
  [anon_sym_gasprice] = "gasprice",
  [anon_sym_blockhash] = "blockhash",
  [anon_sym_blobhash] = "blobhash",
  [anon_sym_basefee] = "basefee",
  [anon_sym_blobfee] = "blobfee",
  [anon_sym_coinbase] = "coinbase",
  [anon_sym_timestamp] = "timestamp",
  [anon_sym_number] = "number",
  [anon_sym_difficulty] = "difficulty",
  [anon_sym_gaslimit] = "gaslimit",
  [sym_unchecked] = "unchecked",
  [anon_sym_memory] = "memory",
  [anon_sym_storage] = "storage",
  [anon_sym_calldata] = "calldata",
  [anon_sym_var] = "var",
  [anon_sym_else] = "else",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_returns] = "returns",
  [anon_sym_catch] = "catch",
  [anon_sym_emit] = "emit",
  [anon_sym_public] = "public",
  [anon_sym_internal] = "internal",
  [anon_sym_private] = "private",
  [anon_sym_external] = "external",
  [anon_sym_pure] = "pure",
  [anon_sym_view] = "view",
  [anon_sym_payable] = "payable",
  [anon_sym_transient] = "transient",
  [sym_immutable] = "immutable",
  [anon_sym_override] = "override",
  [anon_sym_modifier] = "modifier",
  [anon_sym_constructor] = "constructor",
  [anon_sym_fallback] = "fallback",
  [anon_sym_receive] = "receive",
  [sym_virtual] = "virtual",
  [anon_sym_QMARK] = "\?",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_delete] = "delete",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_mapping] = "mapping",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_bool] = "bool",
  [anon_sym_string] = "string",
  [anon_sym_int] = "int",
  [anon_sym_int8] = "int8",
  [anon_sym_int16] = "int16",
  [anon_sym_int24] = "int24",
  [anon_sym_int32] = "int32",
  [anon_sym_int40] = "int40",
  [anon_sym_int48] = "int48",
  [anon_sym_int56] = "int56",
  [anon_sym_int64] = "int64",
  [anon_sym_int72] = "int72",
  [anon_sym_int80] = "int80",
  [anon_sym_int88] = "int88",
  [anon_sym_int96] = "int96",
  [anon_sym_int104] = "int104",
  [anon_sym_int112] = "int112",
  [anon_sym_int120] = "int120",
  [anon_sym_int128] = "int128",
  [anon_sym_int136] = "int136",
  [anon_sym_int144] = "int144",
  [anon_sym_int152] = "int152",
  [anon_sym_int160] = "int160",
  [anon_sym_int168] = "int168",
  [anon_sym_int176] = "int176",
  [anon_sym_int184] = "int184",
  [anon_sym_int192] = "int192",
  [anon_sym_int200] = "int200",
  [anon_sym_int208] = "int208",
  [anon_sym_int216] = "int216",
  [anon_sym_int224] = "int224",
  [anon_sym_int232] = "int232",
  [anon_sym_int240] = "int240",
  [anon_sym_int248] = "int248",
  [anon_sym_int256] = "int256",
  [anon_sym_uint] = "uint",
  [anon_sym_uint8] = "uint8",
  [anon_sym_uint16] = "uint16",
  [anon_sym_uint24] = "uint24",
  [anon_sym_uint32] = "uint32",
  [anon_sym_uint40] = "uint40",
  [anon_sym_uint48] = "uint48",
  [anon_sym_uint56] = "uint56",
  [anon_sym_uint64] = "uint64",
  [anon_sym_uint72] = "uint72",
  [anon_sym_uint80] = "uint80",
  [anon_sym_uint88] = "uint88",
  [anon_sym_uint96] = "uint96",
  [anon_sym_uint104] = "uint104",
  [anon_sym_uint112] = "uint112",
  [anon_sym_uint120] = "uint120",
  [anon_sym_uint128] = "uint128",
  [anon_sym_uint136] = "uint136",
  [anon_sym_uint144] = "uint144",
  [anon_sym_uint152] = "uint152",
  [anon_sym_uint160] = "uint160",
  [anon_sym_uint168] = "uint168",
  [anon_sym_uint176] = "uint176",
  [anon_sym_uint184] = "uint184",
  [anon_sym_uint192] = "uint192",
  [anon_sym_uint200] = "uint200",
  [anon_sym_uint208] = "uint208",
  [anon_sym_uint216] = "uint216",
  [anon_sym_uint224] = "uint224",
  [anon_sym_uint232] = "uint232",
  [anon_sym_uint240] = "uint240",
  [anon_sym_uint248] = "uint248",
  [anon_sym_uint256] = "uint256",
  [anon_sym_bytes] = "bytes",
  [anon_sym_bytes1] = "bytes1",
  [anon_sym_bytes2] = "bytes2",
  [anon_sym_bytes3] = "bytes3",
  [anon_sym_bytes4] = "bytes4",
  [anon_sym_bytes5] = "bytes5",
  [anon_sym_bytes6] = "bytes6",
  [anon_sym_bytes7] = "bytes7",
  [anon_sym_bytes8] = "bytes8",
  [anon_sym_bytes9] = "bytes9",
  [anon_sym_bytes10] = "bytes10",
  [anon_sym_bytes11] = "bytes11",
  [anon_sym_bytes12] = "bytes12",
  [anon_sym_bytes13] = "bytes13",
  [anon_sym_bytes14] = "bytes14",
  [anon_sym_bytes15] = "bytes15",
  [anon_sym_bytes16] = "bytes16",
  [anon_sym_bytes17] = "bytes17",
  [anon_sym_bytes18] = "bytes18",
  [anon_sym_bytes19] = "bytes19",
  [anon_sym_bytes20] = "bytes20",
  [anon_sym_bytes21] = "bytes21",
  [anon_sym_bytes22] = "bytes22",
  [anon_sym_bytes23] = "bytes23",
  [anon_sym_bytes24] = "bytes24",
  [anon_sym_bytes25] = "bytes25",
  [anon_sym_bytes26] = "bytes26",
  [anon_sym_bytes27] = "bytes27",
  [anon_sym_bytes28] = "bytes28",
  [anon_sym_bytes29] = "bytes29",
  [anon_sym_bytes30] = "bytes30",
  [anon_sym_bytes31] = "bytes31",
  [anon_sym_bytes32] = "bytes32",
  [anon_sym_fixed] = "fixed",
  [aux_sym__fixed_token1] = "_fixed_token1",
  [anon_sym_ufixed] = "ufixed",
  [aux_sym__ufixed_token1] = "_ufixed_token1",
  [anon_sym_SEMI] = ";",
  [aux_sym__decimal_number_token1] = "_decimal_number_token1",
  [aux_sym__decimal_number_token2] = "_decimal_number_token2",
  [aux_sym__hex_number_token1] = "_hex_number_token1",
  [sym__hex_digit] = "_hex_digit",
  [anon_sym_wei] = "wei",
  [anon_sym_szabo] = "szabo",
  [anon_sym_finney] = "finney",
  [anon_sym_gwei] = "gwei",
  [anon_sym_ether] = "ether",
  [anon_sym_seconds] = "seconds",
  [anon_sym_minutes] = "minutes",
  [anon_sym_hours] = "hours",
  [anon_sym_days] = "days",
  [anon_sym_weeks] = "weeks",
  [anon_sym_years] = "years",
  [anon_sym_hex] = "hex",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym__] = "_",
  [anon_sym_SQUOTE] = "'",
  [sym__escape_sequence] = "_escape_sequence",
  [aux_sym__single_quoted_unicode_char_token1] = "_single_quoted_unicode_char_token1",
  [aux_sym__double_quoted_unicode_char_token1] = "_double_quoted_unicode_char_token1",
  [anon_sym_unicode] = "unicode",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__source_unit] = "_source_unit",
  [sym__directive] = "_directive",
  [sym_pragma_directive] = "pragma_directive",
  [sym_solidity_pragma_token] = "solidity_pragma_token",
  [sym_any_pragma_token] = "any_pragma_token",
  [sym__solidity] = "_solidity",
  [sym_pragma_value] = "pragma_value",
  [sym__pragma_version_constraint] = "_pragma_version_constraint",
  [sym_solidity_version_comparison_operator] = "solidity_version_comparison_operator",
  [sym_import_directive] = "import_directive",
  [sym__source_import] = "_source_import",
  [sym__import_clause] = "_import_clause",
  [sym__from_clause] = "_from_clause",
  [sym__single_import] = "_single_import",
  [sym__multiple_import] = "_multiple_import",
  [sym__import_declaration] = "_import_declaration",
  [sym__import_alias] = "_import_alias",
  [sym__declaration] = "_declaration",
  [sym_user_defined_type_definition] = "user_defined_type_definition",
  [sym_constant_variable_declaration] = "constant_variable_declaration",
  [sym_contract_declaration] = "contract_declaration",
  [sym_error_declaration] = "error_declaration",
  [sym_error_parameter] = "error_parameter",
  [sym_interface_declaration] = "interface_declaration",
  [sym_library_declaration] = "library_declaration",
  [sym__class_heritage] = "_class_heritage",
  [sym_inheritance_specifier] = "inheritance_specifier",
  [sym_contract_body] = "contract_body",
  [sym__contract_member] = "_contract_member",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_member] = "struct_member",
  [sym_struct_body] = "struct_body",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_event_definition] = "event_definition",
  [sym__event_parameter_list] = "_event_parameter_list",
  [sym_event_parameter] = "event_parameter",
  [sym_using_directive] = "using_directive",
  [sym_any_source_type] = "any_source_type",
  [sym_statement] = "statement",
  [sym_assembly_statement] = "assembly_statement",
  [sym_assembly_flags] = "assembly_flags",
  [sym__yul_statement] = "_yul_statement",
  [sym_yul_label] = "yul_label",
  [sym_yul_break] = "yul_break",
  [sym_yul_continue] = "yul_continue",
  [sym_yul_identifier] = "yul_identifier",
  [sym__yul_expression] = "_yul_expression",
  [sym_yul_path] = "yul_path",
  [sym__yul_literal] = "_yul_literal",
  [sym_yul_string_literal] = "yul_string_literal",
  [sym_yul_boolean] = "yul_boolean",
  [sym_yul_block] = "yul_block",
  [sym_yul_variable_declaration] = "yul_variable_declaration",
  [sym__yul_assignment_operator] = "_yul_assignment_operator",
  [sym_yul_assignment] = "yul_assignment",
  [sym_yul_function_call] = "yul_function_call",
  [sym_yul_if_statement] = "yul_if_statement",
  [sym_yul_for_statement] = "yul_for_statement",
  [sym_yul_switch_statement] = "yul_switch_statement",
  [sym_yul_function_definition] = "yul_function_definition",
  [sym_yul_evm_builtin] = "yul_evm_builtin",
  [sym_block_statement] = "block_statement",
  [sym_variable_declaration_statement] = "variable_declaration_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_variable_declaration_tuple] = "variable_declaration_tuple",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_while_statement] = "do_while_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_revert_statement] = "revert_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_return_statement] = "return_statement",
  [sym_emit_statement] = "emit_statement",
  [sym_state_variable_declaration] = "state_variable_declaration",
  [sym_visibility] = "visibility",
  [sym_state_mutability] = "state_mutability",
  [sym_state_location] = "state_location",
  [sym_override_specifier] = "override_specifier",
  [sym_modifier_definition] = "modifier_definition",
  [sym_constructor_definition] = "constructor_definition",
  [sym_fallback_receive_definition] = "fallback_receive_definition",
  [sym_function_definition] = "function_definition",
  [sym_return_type_definition] = "return_type_definition",
  [sym_modifier_invocation] = "modifier_invocation",
  [sym__call_arguments] = "_call_arguments",
  [sym_call_argument] = "call_argument",
  [sym_call_struct_argument] = "call_struct_argument",
  [sym_function_body] = "function_body",
  [sym_expression] = "expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_new_expression] = "new_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_inline_array_expression] = "inline_array_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_member_expression] = "member_expression",
  [sym_array_access] = "array_access",
  [sym_slice_access] = "slice_access",
  [sym_struct_expression] = "struct_expression",
  [sym_struct_field_assignment] = "struct_field_assignment",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_call_expression] = "call_expression",
  [sym_payable_conversion_expression] = "payable_conversion_expression",
  [sym_meta_type_expression] = "meta_type_expression",
  [sym_type_name] = "type_name",
  [sym__array_type] = "_array_type",
  [sym__function_type] = "_function_type",
  [sym__parameter_list] = "_parameter_list",
  [sym__return_parameters] = "_return_parameters",
  [sym__nameless_parameter] = "return_parameter",
  [sym_parameter] = "parameter",
  [sym__storage_location] = "_storage_location",
  [sym_user_defined_type] = "user_defined_type",
  [sym__identifier_path] = "_identifier_path",
  [sym__mapping] = "_mapping",
  [sym__mapping_key] = "_mapping_key",
  [sym_primitive_type] = "primitive_type",
  [sym__int] = "_int",
  [sym__uint] = "_uint",
  [sym__bytes] = "_bytes",
  [sym__fixed] = "_fixed",
  [sym__ufixed] = "_ufixed",
  [sym__semicolon] = "_semicolon",
  [sym__literal] = "_literal",
  [sym_string_literal] = "string_literal",
  [sym_number_literal] = "number_literal",
  [sym__decimal_number] = "_decimal_number",
  [sym__hex_number] = "_hex_number",
  [sym_number_unit] = "number_unit",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_boolean_literal] = "boolean_literal",
  [sym_hex_string_literal] = "hex_string_literal",
  [sym__single_quoted_unicode_char] = "_single_quoted_unicode_char",
  [sym__double_quoted_unicode_char] = "_double_quoted_unicode_char",
  [sym_unicode_string_literal] = "unicode_string_literal",
  [sym_string] = "string",
  [sym__string_immediate_elt_inside_double_quote] = "_string_immediate_elt_inside_double_quote",
  [sym__string_immediate_elt_inside_quote] = "_string_immediate_elt_inside_quote",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_solidity_pragma_token_repeat1] = "solidity_pragma_token_repeat1",
  [aux_sym__multiple_import_repeat1] = "_multiple_import_repeat1",
  [aux_sym_error_declaration_repeat1] = "error_declaration_repeat1",
  [aux_sym__class_heritage_repeat1] = "_class_heritage_repeat1",
  [aux_sym_contract_body_repeat1] = "contract_body_repeat1",
  [aux_sym_struct_body_repeat1] = "struct_body_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym__event_parameter_list_repeat1] = "_event_parameter_list_repeat1",
  [aux_sym_assembly_statement_repeat1] = "assembly_statement_repeat1",
  [aux_sym_assembly_flags_repeat1] = "assembly_flags_repeat1",
  [aux_sym_yul_path_repeat1] = "yul_path_repeat1",
  [aux_sym_yul_variable_declaration_repeat1] = "yul_variable_declaration_repeat1",
  [aux_sym_yul_assignment_repeat1] = "yul_assignment_repeat1",
  [aux_sym_yul_function_call_repeat1] = "yul_function_call_repeat1",
  [aux_sym_yul_switch_statement_repeat1] = "yul_switch_statement_repeat1",
  [aux_sym_block_statement_repeat1] = "block_statement_repeat1",
  [aux_sym_variable_declaration_tuple_repeat1] = "variable_declaration_tuple_repeat1",
  [aux_sym_variable_declaration_tuple_repeat2] = "variable_declaration_tuple_repeat2",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_state_variable_declaration_repeat1] = "state_variable_declaration_repeat1",
  [aux_sym_override_specifier_repeat1] = "override_specifier_repeat1",
  [aux_sym_modifier_definition_repeat1] = "modifier_definition_repeat1",
  [aux_sym_constructor_definition_repeat1] = "constructor_definition_repeat1",
  [aux_sym_fallback_receive_definition_repeat1] = "fallback_receive_definition_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym__call_arguments_repeat1] = "_call_arguments_repeat1",
  [aux_sym_call_argument_repeat1] = "call_argument_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_inline_array_expression_repeat1] = "inline_array_expression_repeat1",
  [aux_sym_struct_expression_repeat1] = "struct_expression_repeat1",
  [aux_sym__function_type_repeat1] = "_function_type_repeat1",
  [aux_sym__parameter_list_repeat1] = "_parameter_list_repeat1",
  [aux_sym__return_parameters_repeat1] = "_return_parameters_repeat1",
  [aux_sym__identifier_path_repeat1] = "_identifier_path_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_hex_string_literal_repeat1] = "hex_string_literal_repeat1",
  [aux_sym_hex_string_literal_repeat2] = "hex_string_literal_repeat2",
  [aux_sym_unicode_string_literal_repeat1] = "unicode_string_literal_repeat1",
  [aux_sym_unicode_string_literal_repeat2] = "unicode_string_literal_repeat2",
  [aux_sym_unicode_string_literal_repeat3] = "unicode_string_literal_repeat3",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [alias_sym_enum_value] = "enum_value",
  [alias_sym_revert_arguments] = "revert_arguments",
  [alias_sym_type_alias] = "type_alias",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_pragma] = anon_sym_pragma,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_solidity] = anon_sym_solidity,
  [aux_sym_pragma_value_token1] = aux_sym_pragma_value_token1,
  [sym_solidity_version] = sym_solidity_version,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_constant] = anon_sym_constant,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_contract] = anon_sym_contract,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_library] = anon_sym_library,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_anonymous] = anon_sym_anonymous,
  [anon_sym_indexed] = anon_sym_indexed,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_DQUOTEevmasm_DQUOTE] = anon_sym_DQUOTEevmasm_DQUOTE,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_yul_leave] = sym_yul_leave,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_yul_decimal_number] = sym_yul_decimal_number,
  [sym_yul_hex_number] = sym_yul_hex_number,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_stop] = anon_sym_stop,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_div] = anon_sym_div,
  [anon_sym_sdiv] = anon_sym_sdiv,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_smod] = anon_sym_smod,
  [anon_sym_exp] = anon_sym_exp,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_lt] = anon_sym_lt,
  [anon_sym_gt] = anon_sym_gt,
  [anon_sym_slt] = anon_sym_slt,
  [anon_sym_sgt] = anon_sym_sgt,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_iszero] = anon_sym_iszero,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_shr] = anon_sym_shr,
  [anon_sym_sar] = anon_sym_sar,
  [anon_sym_addmod] = anon_sym_addmod,
  [anon_sym_mulmod] = anon_sym_mulmod,
  [anon_sym_signextend] = anon_sym_signextend,
  [anon_sym_keccak256] = anon_sym_keccak256,
  [anon_sym_pop] = anon_sym_pop,
  [anon_sym_mload] = anon_sym_mload,
  [anon_sym_mcopy] = anon_sym_mcopy,
  [anon_sym_tload] = anon_sym_tload,
  [anon_sym_tstore] = anon_sym_tstore,
  [anon_sym_mstore] = anon_sym_mstore,
  [anon_sym_mstore8] = anon_sym_mstore8,
  [anon_sym_sload] = anon_sym_sload,
  [anon_sym_sstore] = anon_sym_sstore,
  [anon_sym_msize] = anon_sym_msize,
  [anon_sym_gas] = anon_sym_gas,
  [anon_sym_address] = anon_sym_address,
  [anon_sym_balance] = anon_sym_balance,
  [anon_sym_selfbalance] = anon_sym_selfbalance,
  [anon_sym_caller] = anon_sym_caller,
  [anon_sym_callvalue] = anon_sym_callvalue,
  [anon_sym_calldataload] = anon_sym_calldataload,
  [anon_sym_calldatasize] = anon_sym_calldatasize,
  [anon_sym_calldatacopy] = anon_sym_calldatacopy,
  [anon_sym_extcodesize] = anon_sym_extcodesize,
  [anon_sym_extcodecopy] = anon_sym_extcodecopy,
  [anon_sym_returndatasize] = anon_sym_returndatasize,
  [anon_sym_returndatacopy] = anon_sym_returndatacopy,
  [anon_sym_extcodehash] = anon_sym_extcodehash,
  [anon_sym_create] = anon_sym_create,
  [anon_sym_create2] = anon_sym_create2,
  [anon_sym_call] = anon_sym_call,
  [anon_sym_callcode] = anon_sym_callcode,
  [anon_sym_delegatecall] = anon_sym_delegatecall,
  [anon_sym_staticcall] = anon_sym_staticcall,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_revert] = anon_sym_revert,
  [anon_sym_selfdestruct] = anon_sym_selfdestruct,
  [anon_sym_invalid] = anon_sym_invalid,
  [anon_sym_log0] = anon_sym_log0,
  [anon_sym_log1] = anon_sym_log1,
  [anon_sym_log2] = anon_sym_log2,
  [anon_sym_log3] = anon_sym_log3,
  [anon_sym_log4] = anon_sym_log4,
  [anon_sym_chainid] = anon_sym_chainid,
  [anon_sym_origin] = anon_sym_origin,
  [anon_sym_gasprice] = anon_sym_gasprice,
  [anon_sym_blockhash] = anon_sym_blockhash,
  [anon_sym_blobhash] = anon_sym_blobhash,
  [anon_sym_basefee] = anon_sym_basefee,
  [anon_sym_blobfee] = anon_sym_blobfee,
  [anon_sym_coinbase] = anon_sym_coinbase,
  [anon_sym_timestamp] = anon_sym_timestamp,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_difficulty] = anon_sym_difficulty,
  [anon_sym_gaslimit] = anon_sym_gaslimit,
  [sym_unchecked] = sym_unchecked,
  [anon_sym_memory] = anon_sym_memory,
  [anon_sym_storage] = anon_sym_storage,
  [anon_sym_calldata] = anon_sym_calldata,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_returns] = anon_sym_returns,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_emit] = anon_sym_emit,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_pure] = anon_sym_pure,
  [anon_sym_view] = anon_sym_view,
  [anon_sym_payable] = anon_sym_payable,
  [anon_sym_transient] = anon_sym_transient,
  [sym_immutable] = sym_immutable,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_modifier] = anon_sym_modifier,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_fallback] = anon_sym_fallback,
  [anon_sym_receive] = anon_sym_receive,
  [sym_virtual] = sym_virtual,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_mapping] = anon_sym_mapping,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_int8] = anon_sym_int8,
  [anon_sym_int16] = anon_sym_int16,
  [anon_sym_int24] = anon_sym_int24,
  [anon_sym_int32] = anon_sym_int32,
  [anon_sym_int40] = anon_sym_int40,
  [anon_sym_int48] = anon_sym_int48,
  [anon_sym_int56] = anon_sym_int56,
  [anon_sym_int64] = anon_sym_int64,
  [anon_sym_int72] = anon_sym_int72,
  [anon_sym_int80] = anon_sym_int80,
  [anon_sym_int88] = anon_sym_int88,
  [anon_sym_int96] = anon_sym_int96,
  [anon_sym_int104] = anon_sym_int104,
  [anon_sym_int112] = anon_sym_int112,
  [anon_sym_int120] = anon_sym_int120,
  [anon_sym_int128] = anon_sym_int128,
  [anon_sym_int136] = anon_sym_int136,
  [anon_sym_int144] = anon_sym_int144,
  [anon_sym_int152] = anon_sym_int152,
  [anon_sym_int160] = anon_sym_int160,
  [anon_sym_int168] = anon_sym_int168,
  [anon_sym_int176] = anon_sym_int176,
  [anon_sym_int184] = anon_sym_int184,
  [anon_sym_int192] = anon_sym_int192,
  [anon_sym_int200] = anon_sym_int200,
  [anon_sym_int208] = anon_sym_int208,
  [anon_sym_int216] = anon_sym_int216,
  [anon_sym_int224] = anon_sym_int224,
  [anon_sym_int232] = anon_sym_int232,
  [anon_sym_int240] = anon_sym_int240,
  [anon_sym_int248] = anon_sym_int248,
  [anon_sym_int256] = anon_sym_int256,
  [anon_sym_uint] = anon_sym_uint,
  [anon_sym_uint8] = anon_sym_uint8,
  [anon_sym_uint16] = anon_sym_uint16,
  [anon_sym_uint24] = anon_sym_uint24,
  [anon_sym_uint32] = anon_sym_uint32,
  [anon_sym_uint40] = anon_sym_uint40,
  [anon_sym_uint48] = anon_sym_uint48,
  [anon_sym_uint56] = anon_sym_uint56,
  [anon_sym_uint64] = anon_sym_uint64,
  [anon_sym_uint72] = anon_sym_uint72,
  [anon_sym_uint80] = anon_sym_uint80,
  [anon_sym_uint88] = anon_sym_uint88,
  [anon_sym_uint96] = anon_sym_uint96,
  [anon_sym_uint104] = anon_sym_uint104,
  [anon_sym_uint112] = anon_sym_uint112,
  [anon_sym_uint120] = anon_sym_uint120,
  [anon_sym_uint128] = anon_sym_uint128,
  [anon_sym_uint136] = anon_sym_uint136,
  [anon_sym_uint144] = anon_sym_uint144,
  [anon_sym_uint152] = anon_sym_uint152,
  [anon_sym_uint160] = anon_sym_uint160,
  [anon_sym_uint168] = anon_sym_uint168,
  [anon_sym_uint176] = anon_sym_uint176,
  [anon_sym_uint184] = anon_sym_uint184,
  [anon_sym_uint192] = anon_sym_uint192,
  [anon_sym_uint200] = anon_sym_uint200,
  [anon_sym_uint208] = anon_sym_uint208,
  [anon_sym_uint216] = anon_sym_uint216,
  [anon_sym_uint224] = anon_sym_uint224,
  [anon_sym_uint232] = anon_sym_uint232,
  [anon_sym_uint240] = anon_sym_uint240,
  [anon_sym_uint248] = anon_sym_uint248,
  [anon_sym_uint256] = anon_sym_uint256,
  [anon_sym_bytes] = anon_sym_bytes,
  [anon_sym_bytes1] = anon_sym_bytes1,
  [anon_sym_bytes2] = anon_sym_bytes2,
  [anon_sym_bytes3] = anon_sym_bytes3,
  [anon_sym_bytes4] = anon_sym_bytes4,
  [anon_sym_bytes5] = anon_sym_bytes5,
  [anon_sym_bytes6] = anon_sym_bytes6,
  [anon_sym_bytes7] = anon_sym_bytes7,
  [anon_sym_bytes8] = anon_sym_bytes8,
  [anon_sym_bytes9] = anon_sym_bytes9,
  [anon_sym_bytes10] = anon_sym_bytes10,
  [anon_sym_bytes11] = anon_sym_bytes11,
  [anon_sym_bytes12] = anon_sym_bytes12,
  [anon_sym_bytes13] = anon_sym_bytes13,
  [anon_sym_bytes14] = anon_sym_bytes14,
  [anon_sym_bytes15] = anon_sym_bytes15,
  [anon_sym_bytes16] = anon_sym_bytes16,
  [anon_sym_bytes17] = anon_sym_bytes17,
  [anon_sym_bytes18] = anon_sym_bytes18,
  [anon_sym_bytes19] = anon_sym_bytes19,
  [anon_sym_bytes20] = anon_sym_bytes20,
  [anon_sym_bytes21] = anon_sym_bytes21,
  [anon_sym_bytes22] = anon_sym_bytes22,
  [anon_sym_bytes23] = anon_sym_bytes23,
  [anon_sym_bytes24] = anon_sym_bytes24,
  [anon_sym_bytes25] = anon_sym_bytes25,
  [anon_sym_bytes26] = anon_sym_bytes26,
  [anon_sym_bytes27] = anon_sym_bytes27,
  [anon_sym_bytes28] = anon_sym_bytes28,
  [anon_sym_bytes29] = anon_sym_bytes29,
  [anon_sym_bytes30] = anon_sym_bytes30,
  [anon_sym_bytes31] = anon_sym_bytes31,
  [anon_sym_bytes32] = anon_sym_bytes32,
  [anon_sym_fixed] = anon_sym_fixed,
  [aux_sym__fixed_token1] = aux_sym__fixed_token1,
  [anon_sym_ufixed] = anon_sym_ufixed,
  [aux_sym__ufixed_token1] = aux_sym__ufixed_token1,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [aux_sym__decimal_number_token1] = aux_sym__decimal_number_token1,
  [aux_sym__decimal_number_token2] = aux_sym__decimal_number_token2,
  [aux_sym__hex_number_token1] = aux_sym__hex_number_token1,
  [sym__hex_digit] = sym__hex_digit,
  [anon_sym_wei] = anon_sym_wei,
  [anon_sym_szabo] = anon_sym_szabo,
  [anon_sym_finney] = anon_sym_finney,
  [anon_sym_gwei] = anon_sym_gwei,
  [anon_sym_ether] = anon_sym_ether,
  [anon_sym_seconds] = anon_sym_seconds,
  [anon_sym_minutes] = anon_sym_minutes,
  [anon_sym_hours] = anon_sym_hours,
  [anon_sym_days] = anon_sym_days,
  [anon_sym_weeks] = anon_sym_weeks,
  [anon_sym_years] = anon_sym_years,
  [anon_sym_hex] = anon_sym_hex,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym__] = anon_sym__,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym__escape_sequence] = sym__escape_sequence,
  [aux_sym__single_quoted_unicode_char_token1] = aux_sym__single_quoted_unicode_char_token1,
  [aux_sym__double_quoted_unicode_char_token1] = aux_sym__double_quoted_unicode_char_token1,
  [anon_sym_unicode] = anon_sym_unicode,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__source_unit] = sym__source_unit,
  [sym__directive] = sym__directive,
  [sym_pragma_directive] = sym_pragma_directive,
  [sym_solidity_pragma_token] = sym_solidity_pragma_token,
  [sym_any_pragma_token] = sym_any_pragma_token,
  [sym__solidity] = sym__solidity,
  [sym_pragma_value] = sym_pragma_value,
  [sym__pragma_version_constraint] = sym__pragma_version_constraint,
  [sym_solidity_version_comparison_operator] = sym_solidity_version_comparison_operator,
  [sym_import_directive] = sym_import_directive,
  [sym__source_import] = sym__source_import,
  [sym__import_clause] = sym__import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym__single_import] = sym__single_import,
  [sym__multiple_import] = sym__multiple_import,
  [sym__import_declaration] = sym__import_declaration,
  [sym__import_alias] = sym__import_alias,
  [sym__declaration] = sym__declaration,
  [sym_user_defined_type_definition] = sym_user_defined_type_definition,
  [sym_constant_variable_declaration] = sym_constant_variable_declaration,
  [sym_contract_declaration] = sym_contract_declaration,
  [sym_error_declaration] = sym_error_declaration,
  [sym_error_parameter] = sym_error_parameter,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_library_declaration] = sym_library_declaration,
  [sym__class_heritage] = sym__class_heritage,
  [sym_inheritance_specifier] = sym_inheritance_specifier,
  [sym_contract_body] = sym_contract_body,
  [sym__contract_member] = sym__contract_member,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_struct_member] = sym_struct_member,
  [sym_struct_body] = sym_struct_body,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_event_definition] = sym_event_definition,
  [sym__event_parameter_list] = sym__event_parameter_list,
  [sym_event_parameter] = sym_event_parameter,
  [sym_using_directive] = sym_using_directive,
  [sym_any_source_type] = sym_any_source_type,
  [sym_statement] = sym_statement,
  [sym_assembly_statement] = sym_assembly_statement,
  [sym_assembly_flags] = sym_assembly_flags,
  [sym__yul_statement] = sym__yul_statement,
  [sym_yul_label] = sym_yul_label,
  [sym_yul_break] = sym_yul_break,
  [sym_yul_continue] = sym_yul_continue,
  [sym_yul_identifier] = sym_yul_identifier,
  [sym__yul_expression] = sym__yul_expression,
  [sym_yul_path] = sym_yul_path,
  [sym__yul_literal] = sym__yul_literal,
  [sym_yul_string_literal] = sym_yul_string_literal,
  [sym_yul_boolean] = sym_yul_boolean,
  [sym_yul_block] = sym_yul_block,
  [sym_yul_variable_declaration] = sym_yul_variable_declaration,
  [sym__yul_assignment_operator] = sym__yul_assignment_operator,
  [sym_yul_assignment] = sym_yul_assignment,
  [sym_yul_function_call] = sym_yul_function_call,
  [sym_yul_if_statement] = sym_yul_if_statement,
  [sym_yul_for_statement] = sym_yul_for_statement,
  [sym_yul_switch_statement] = sym_yul_switch_statement,
  [sym_yul_function_definition] = sym_yul_function_definition,
  [sym_yul_evm_builtin] = sym_yul_evm_builtin,
  [sym_block_statement] = sym_block_statement,
  [sym_variable_declaration_statement] = sym_variable_declaration_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_variable_declaration_tuple] = sym_variable_declaration_tuple,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_while_statement] = sym_do_while_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_revert_statement] = sym_revert_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_return_statement] = sym_return_statement,
  [sym_emit_statement] = sym_emit_statement,
  [sym_state_variable_declaration] = sym_state_variable_declaration,
  [sym_visibility] = sym_visibility,
  [sym_state_mutability] = sym_state_mutability,
  [sym_state_location] = sym_state_location,
  [sym_override_specifier] = sym_override_specifier,
  [sym_modifier_definition] = sym_modifier_definition,
  [sym_constructor_definition] = sym_constructor_definition,
  [sym_fallback_receive_definition] = sym_fallback_receive_definition,
  [sym_function_definition] = sym_function_definition,
  [sym_return_type_definition] = sym_return_type_definition,
  [sym_modifier_invocation] = sym_modifier_invocation,
  [sym__call_arguments] = sym__call_arguments,
  [sym_call_argument] = sym_call_argument,
  [sym_call_struct_argument] = sym_call_struct_argument,
  [sym_function_body] = sym_function_body,
  [sym_expression] = sym_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_inline_array_expression] = sym_inline_array_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_array_access] = sym_array_access,
  [sym_slice_access] = sym_slice_access,
  [sym_struct_expression] = sym_struct_expression,
  [sym_struct_field_assignment] = sym_struct_field_assignment,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_payable_conversion_expression] = sym_payable_conversion_expression,
  [sym_meta_type_expression] = sym_meta_type_expression,
  [sym_type_name] = sym_type_name,
  [sym__array_type] = sym__array_type,
  [sym__function_type] = sym__function_type,
  [sym__parameter_list] = sym__parameter_list,
  [sym__return_parameters] = sym__return_parameters,
  [sym__nameless_parameter] = sym__nameless_parameter,
  [sym_parameter] = sym_parameter,
  [sym__storage_location] = sym__storage_location,
  [sym_user_defined_type] = sym_user_defined_type,
  [sym__identifier_path] = sym__identifier_path,
  [sym__mapping] = sym__mapping,
  [sym__mapping_key] = sym__mapping_key,
  [sym_primitive_type] = sym_primitive_type,
  [sym__int] = sym__int,
  [sym__uint] = sym__uint,
  [sym__bytes] = sym__bytes,
  [sym__fixed] = sym__fixed,
  [sym__ufixed] = sym__ufixed,
  [sym__semicolon] = sym__semicolon,
  [sym__literal] = sym__literal,
  [sym_string_literal] = sym_string_literal,
  [sym_number_literal] = sym_number_literal,
  [sym__decimal_number] = sym__decimal_number,
  [sym__hex_number] = sym__hex_number,
  [sym_number_unit] = sym_number_unit,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_hex_string_literal] = sym_hex_string_literal,
  [sym__single_quoted_unicode_char] = sym__single_quoted_unicode_char,
  [sym__double_quoted_unicode_char] = sym__double_quoted_unicode_char,
  [sym_unicode_string_literal] = sym_unicode_string_literal,
  [sym_string] = sym_string,
  [sym__string_immediate_elt_inside_double_quote] = sym__string_immediate_elt_inside_double_quote,
  [sym__string_immediate_elt_inside_quote] = sym__string_immediate_elt_inside_quote,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_solidity_pragma_token_repeat1] = aux_sym_solidity_pragma_token_repeat1,
  [aux_sym__multiple_import_repeat1] = aux_sym__multiple_import_repeat1,
  [aux_sym_error_declaration_repeat1] = aux_sym_error_declaration_repeat1,
  [aux_sym__class_heritage_repeat1] = aux_sym__class_heritage_repeat1,
  [aux_sym_contract_body_repeat1] = aux_sym_contract_body_repeat1,
  [aux_sym_struct_body_repeat1] = aux_sym_struct_body_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym__event_parameter_list_repeat1] = aux_sym__event_parameter_list_repeat1,
  [aux_sym_assembly_statement_repeat1] = aux_sym_assembly_statement_repeat1,
  [aux_sym_assembly_flags_repeat1] = aux_sym_assembly_flags_repeat1,
  [aux_sym_yul_path_repeat1] = aux_sym_yul_path_repeat1,
  [aux_sym_yul_variable_declaration_repeat1] = aux_sym_yul_variable_declaration_repeat1,
  [aux_sym_yul_assignment_repeat1] = aux_sym_yul_assignment_repeat1,
  [aux_sym_yul_function_call_repeat1] = aux_sym_yul_function_call_repeat1,
  [aux_sym_yul_switch_statement_repeat1] = aux_sym_yul_switch_statement_repeat1,
  [aux_sym_block_statement_repeat1] = aux_sym_block_statement_repeat1,
  [aux_sym_variable_declaration_tuple_repeat1] = aux_sym_variable_declaration_tuple_repeat1,
  [aux_sym_variable_declaration_tuple_repeat2] = aux_sym_variable_declaration_tuple_repeat2,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_state_variable_declaration_repeat1] = aux_sym_state_variable_declaration_repeat1,
  [aux_sym_override_specifier_repeat1] = aux_sym_override_specifier_repeat1,
  [aux_sym_modifier_definition_repeat1] = aux_sym_modifier_definition_repeat1,
  [aux_sym_constructor_definition_repeat1] = aux_sym_constructor_definition_repeat1,
  [aux_sym_fallback_receive_definition_repeat1] = aux_sym_fallback_receive_definition_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym__call_arguments_repeat1] = aux_sym__call_arguments_repeat1,
  [aux_sym_call_argument_repeat1] = aux_sym_call_argument_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_inline_array_expression_repeat1] = aux_sym_inline_array_expression_repeat1,
  [aux_sym_struct_expression_repeat1] = aux_sym_struct_expression_repeat1,
  [aux_sym__function_type_repeat1] = aux_sym__function_type_repeat1,
  [aux_sym__parameter_list_repeat1] = aux_sym__parameter_list_repeat1,
  [aux_sym__return_parameters_repeat1] = aux_sym__return_parameters_repeat1,
  [aux_sym__identifier_path_repeat1] = aux_sym__identifier_path_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_hex_string_literal_repeat1] = aux_sym_hex_string_literal_repeat1,
  [aux_sym_hex_string_literal_repeat2] = aux_sym_hex_string_literal_repeat2,
  [aux_sym_unicode_string_literal_repeat1] = aux_sym_unicode_string_literal_repeat1,
  [aux_sym_unicode_string_literal_repeat2] = aux_sym_unicode_string_literal_repeat2,
  [aux_sym_unicode_string_literal_repeat3] = aux_sym_unicode_string_literal_repeat3,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [alias_sym_enum_value] = alias_sym_enum_value,
  [alias_sym_revert_arguments] = alias_sym_revert_arguments,
  [alias_sym_type_alias] = alias_sym_type_alias,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_pragma] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_solidity] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pragma_value_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_solidity_version] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_contract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_library] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anonymous] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indexed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEevmasm_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_yul_leave] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_yul_decimal_number] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_hex_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_div] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_smod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_slt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iszero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addmod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mulmod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signextend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keccak256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mcopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mstore8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_msize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_address] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_balance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selfbalance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_caller] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldataload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldatasize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldatacopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodesize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodecopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returndatasize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returndatacopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodehash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_create] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_create2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callcode] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegatecall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_staticcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_revert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selfdestruct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invalid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chainid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_origin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gasprice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blockhash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blobhash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_basefee] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blobfee] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coinbase] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_timestamp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_difficulty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gaslimit] = {
    .visible = true,
    .named = false,
  },
  [sym_unchecked] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_storage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returns] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_emit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_view] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_payable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_transient] = {
    .visible = true,
    .named = false,
  },
  [sym_immutable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_modifier] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallback] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_receive] = {
    .visible = true,
    .named = false,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mapping] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int40] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int48] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int56] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int72] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int88] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int96] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int104] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int112] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int120] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int136] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int144] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int152] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int160] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int168] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int176] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int184] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int224] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int232] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint40] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint48] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint56] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint72] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint88] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint96] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint104] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint112] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint120] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint136] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint144] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint152] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint160] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint168] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint176] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint184] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint224] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint232] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes9] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes10] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes11] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes12] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes13] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes14] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes15] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes17] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes18] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes19] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes20] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes21] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes22] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes23] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes25] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes26] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes27] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes28] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes29] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes30] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes31] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__fixed_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_ufixed] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__ufixed_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__decimal_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_number_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hex_number_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__hex_digit] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_wei] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_szabo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finney] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gwei] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ether] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_seconds] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minutes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hours] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_days] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weeks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_years] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hex] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quoted_unicode_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_unicode_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_unicode] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__source_unit] = {
    .visible = false,
    .named = true,
  },
  [sym__directive] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_solidity_pragma_token] = {
    .visible = true,
    .named = true,
  },
  [sym_any_pragma_token] = {
    .visible = true,
    .named = true,
  },
  [sym__solidity] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_value] = {
    .visible = true,
    .named = true,
  },
  [sym__pragma_version_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_solidity_version_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_import_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__source_import] = {
    .visible = false,
    .named = true,
  },
  [sym__import_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__single_import] = {
    .visible = false,
    .named = true,
  },
  [sym__multiple_import] = {
    .visible = false,
    .named = true,
  },
  [sym__import_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__import_alias] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_user_defined_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_contract_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_library_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_heritage] = {
    .visible = false,
    .named = true,
  },
  [sym_inheritance_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_contract_body] = {
    .visible = true,
    .named = true,
  },
  [sym__contract_member] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_member] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_event_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__event_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym_event_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_any_source_type] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assembly_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assembly_flags] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_label] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_break] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_continue] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_path] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_block] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_assignment_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_evm_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_block_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_revert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_emit_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_state_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility] = {
    .visible = true,
    .named = true,
  },
  [sym_state_mutability] = {
    .visible = true,
    .named = true,
  },
  [sym_state_location] = {
    .visible = true,
    .named = true,
  },
  [sym_override_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_fallback_receive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_return_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym__call_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_call_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_call_struct_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_access] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_field_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_payable_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym__array_type] = {
    .visible = false,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__return_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__nameless_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__storage_location] = {
    .visible = false,
    .named = true,
  },
  [sym_user_defined_type] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_path] = {
    .visible = false,
    .named = true,
  },
  [sym__mapping] = {
    .visible = false,
    .named = true,
  },
  [sym__mapping_key] = {
    .visible = false,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym__int] = {
    .visible = false,
    .named = true,
  },
  [sym__uint] = {
    .visible = false,
    .named = true,
  },
  [sym__bytes] = {
    .visible = false,
    .named = true,
  },
  [sym__fixed] = {
    .visible = false,
    .named = true,
  },
  [sym__ufixed] = {
    .visible = false,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__decimal_number] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_number] = {
    .visible = false,
    .named = true,
  },
  [sym_number_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quoted_unicode_char] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quoted_unicode_char] = {
    .visible = false,
    .named = true,
  },
  [sym_unicode_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_immediate_elt_inside_double_quote] = {
    .visible = false,
    .named = true,
  },
  [sym__string_immediate_elt_inside_quote] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_solidity_pragma_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiple_import_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_error_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_heritage_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_contract_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__event_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assembly_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assembly_flags_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_assignment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_function_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_tuple_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_state_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_override_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifier_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fallback_receive_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__call_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inline_array_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__return_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_enum_value] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_revert_arguments] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_alias] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_ancestor = 2,
  field_ancestor_arguments = 3,
  field_argument = 4,
  field_attempt = 5,
  field_base = 6,
  field_body = 7,
  field_condition = 8,
  field_else = 9,
  field_error = 10,
  field_from = 11,
  field_function = 12,
  field_import_name = 13,
  field_index = 14,
  field_initial = 15,
  field_key_identifier = 16,
  field_key_type = 17,
  field_left = 18,
  field_location = 19,
  field_name = 20,
  field_object = 21,
  field_operator = 22,
  field_parameters = 23,
  field_property = 24,
  field_return_type = 25,
  field_right = 26,
  field_source = 27,
  field_to = 28,
  field_type = 29,
  field_update = 30,
  field_value = 31,
  field_value_identifier = 32,
  field_value_type = 33,
  field_version_constraint = 34,
  field_visibility = 35,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_ancestor] = "ancestor",
  [field_ancestor_arguments] = "ancestor_arguments",
  [field_argument] = "argument",
  [field_attempt] = "attempt",
  [field_base] = "base",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_error] = "error",
  [field_from] = "from",
  [field_function] = "function",
  [field_import_name] = "import_name",
  [field_index] = "index",
  [field_initial] = "initial",
  [field_key_identifier] = "key_identifier",
  [field_key_type] = "key_type",
  [field_left] = "left",
  [field_location] = "location",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_to] = "to",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
  [field_value_identifier] = "value_identifier",
  [field_value_type] = "value_type",
  [field_version_constraint] = "version_constraint",
  [field_visibility] = "visibility",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 2},
  [5] = {.index = 8, .length = 1},
  [6] = {.index = 9, .length = 1},
  [7] = {.index = 10, .length = 1},
  [8] = {.index = 11, .length = 1},
  [9] = {.index = 12, .length = 1},
  [10] = {.index = 13, .length = 2},
  [11] = {.index = 15, .length = 2},
  [12] = {.index = 17, .length = 2},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 2},
  [16] = {.index = 24, .length = 1},
  [17] = {.index = 25, .length = 2},
  [18] = {.index = 27, .length = 1},
  [19] = {.index = 28, .length = 3},
  [20] = {.index = 31, .length = 2},
  [21] = {.index = 33, .length = 1},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 1},
  [24] = {.index = 37, .length = 2},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 2},
  [27] = {.index = 43, .length = 2},
  [28] = {.index = 45, .length = 1},
  [29] = {.index = 46, .length = 4},
  [30] = {.index = 50, .length = 4},
  [31] = {.index = 54, .length = 2},
  [32] = {.index = 56, .length = 1},
  [33] = {.index = 57, .length = 1},
  [34] = {.index = 58, .length = 2},
  [36] = {.index = 60, .length = 3},
  [37] = {.index = 63, .length = 3},
  [38] = {.index = 66, .length = 2},
  [39] = {.index = 68, .length = 2},
  [40] = {.index = 70, .length = 2},
  [41] = {.index = 72, .length = 3},
  [42] = {.index = 75, .length = 2},
  [43] = {.index = 77, .length = 1},
  [44] = {.index = 78, .length = 1},
  [45] = {.index = 79, .length = 4},
  [46] = {.index = 83, .length = 2},
  [47] = {.index = 85, .length = 3},
  [48] = {.index = 88, .length = 2},
  [49] = {.index = 90, .length = 2},
  [50] = {.index = 92, .length = 2},
  [51] = {.index = 94, .length = 3},
  [52] = {.index = 97, .length = 2},
  [53] = {.index = 99, .length = 1},
  [54] = {.index = 100, .length = 4},
  [56] = {.index = 104, .length = 1},
  [57] = {.index = 105, .length = 2},
  [58] = {.index = 107, .length = 3},
  [59] = {.index = 110, .length = 3},
  [60] = {.index = 113, .length = 2},
  [61] = {.index = 115, .length = 2},
  [62] = {.index = 117, .length = 2},
  [63] = {.index = 119, .length = 1},
  [64] = {.index = 120, .length = 3},
  [65] = {.index = 123, .length = 1},
  [66] = {.index = 104, .length = 1},
  [67] = {.index = 124, .length = 2},
  [68] = {.index = 126, .length = 1},
  [69] = {.index = 127, .length = 4},
  [70] = {.index = 131, .length = 3},
  [71] = {.index = 134, .length = 5},
  [72] = {.index = 139, .length = 2},
  [73] = {.index = 141, .length = 2},
  [74] = {.index = 143, .length = 1},
  [75] = {.index = 144, .length = 3},
  [76] = {.index = 147, .length = 3},
  [77] = {.index = 150, .length = 2},
  [78] = {.index = 152, .length = 2},
  [79] = {.index = 154, .length = 4},
  [80] = {.index = 158, .length = 4},
  [81] = {.index = 162, .length = 3},
  [82] = {.index = 165, .length = 4},
  [83] = {.index = 169, .length = 2},
  [84] = {.index = 171, .length = 4},
  [85] = {.index = 175, .length = 5},
  [86] = {.index = 180, .length = 5},
  [87] = {.index = 185, .length = 6},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_parameters, 0, .inherited = true},
  [1] =
    {field_key_identifier, 0, .inherited = true},
    {field_key_type, 0, .inherited = true},
    {field_value_identifier, 0, .inherited = true},
    {field_value_type, 0, .inherited = true},
  [5] =
    {field_import_name, 0},
  [6] =
    {field_alias, 0, .inherited = true},
    {field_import_name, 0, .inherited = true},
  [8] =
    {field_source, 0},
  [9] =
    {field_parameters, 1},
  [10] =
    {field_version_constraint, 0},
  [11] =
    {field_version_constraint, 1, .inherited = true},
  [12] =
    {field_alias, 1, .inherited = true},
  [13] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 0},
  [15] =
    {field_alias, 1, .inherited = true},
    {field_source, 1, .inherited = true},
  [17] =
    {field_alias, 1, .inherited = true},
    {field_source, 0},
  [19] =
    {field_body, 2},
    {field_name, 1},
  [21] =
    {field_type, 0},
  [22] =
    {field_version_constraint, 0, .inherited = true},
    {field_version_constraint, 1, .inherited = true},
  [24] =
    {field_alias, 1},
  [25] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 1, .inherited = true},
  [27] =
    {field_source, 1},
  [28] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 1, .inherited = true},
    {field_source, 2, .inherited = true},
  [31] =
    {field_body, 3},
    {field_name, 2},
  [33] =
    {field_ancestor, 0},
  [34] =
    {field_body, 3},
    {field_name, 1},
  [36] =
    {field_name, 1},
  [37] =
    {field_name, 1},
    {field_type, 0},
  [39] =
    {field_location, 1},
    {field_type, 0},
  [41] =
    {field_argument, 1},
    {field_operator, 0},
  [43] =
    {field_argument, 0},
    {field_operator, 1},
  [45] =
    {field_function, 0},
  [46] =
    {field_alias, 1, .inherited = true},
    {field_alias, 2, .inherited = true},
    {field_import_name, 1, .inherited = true},
    {field_import_name, 2, .inherited = true},
  [50] =
    {field_alias, 0, .inherited = true},
    {field_alias, 1, .inherited = true},
    {field_import_name, 0, .inherited = true},
    {field_import_name, 1, .inherited = true},
  [54] =
    {field_body, 4},
    {field_name, 2},
  [56] =
    {field_visibility, 0},
  [57] =
    {field_location, 0},
  [58] =
    {field_ancestor, 0},
    {field_ancestor_arguments, 1},
  [60] =
    {field_location, 1},
    {field_name, 2},
    {field_type, 0},
  [63] =
    {field_body, 4},
    {field_name, 1},
    {field_return_type, 3},
  [66] =
    {field_name, 1},
    {field_return_type, 3},
  [68] =
    {field_body, 4},
    {field_name, 1},
  [70] =
    {field_object, 0},
    {field_property, 2},
  [72] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [75] =
    {field_left, 0},
    {field_right, 2},
  [77] =
    {field_base, 0},
  [78] =
    {field_body, 2},
  [79] =
    {field_location, 0, .inherited = true},
    {field_location, 1, .inherited = true},
    {field_visibility, 0, .inherited = true},
    {field_visibility, 1, .inherited = true},
  [83] =
    {field_name, 2},
    {field_type, 0},
  [85] =
    {field_body, 5},
    {field_name, 1},
    {field_return_type, 4},
  [88] =
    {field_name, 1},
    {field_return_type, 4},
  [90] =
    {field_location, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [92] =
    {field_key_type, 2},
    {field_value_type, 4},
  [94] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 4},
  [97] =
    {field_base, 0},
    {field_index, 2},
  [99] =
    {field_body, 3},
  [100] =
    {field_location, 1, .inherited = true},
    {field_name, 2},
    {field_type, 0},
    {field_visibility, 1, .inherited = true},
  [104] =
    {field_error, 1},
  [105] =
    {field_location, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [107] =
    {field_key_type, 2},
    {field_value_identifier, 5},
    {field_value_type, 4},
  [110] =
    {field_key_identifier, 3},
    {field_key_type, 2},
    {field_value_type, 5},
  [113] =
    {field_name, 0},
    {field_value, 2},
  [115] =
    {field_base, 0},
    {field_to, 3},
  [117] =
    {field_base, 0},
    {field_from, 2},
  [119] =
    {field_source, 3},
  [120] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 3},
  [123] =
    {field_left, 1},
  [124] =
    {field_attempt, 1},
    {field_body, 2},
  [126] =
    {field_value, 2},
  [127] =
    {field_key_identifier, 3},
    {field_key_type, 2},
    {field_value_identifier, 6},
    {field_value_type, 5},
  [131] =
    {field_base, 0},
    {field_from, 2},
    {field_to, 4},
  [134] =
    {field_location, 1, .inherited = true},
    {field_name, 2},
    {field_type, 0},
    {field_value, 4},
    {field_visibility, 1, .inherited = true},
  [139] =
    {field_left, 1},
    {field_left, 2},
  [141] =
    {field_body, 4},
    {field_condition, 2},
  [143] =
    {field_body, 1},
  [144] =
    {field_body, 5},
    {field_condition, 3},
    {field_initial, 2},
  [147] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
  [150] =
    {field_left, 1},
    {field_right, 3},
  [152] =
    {field_attempt, 1},
    {field_body, 4},
  [154] =
    {field_body, 6},
    {field_condition, 3},
    {field_initial, 2},
    {field_update, 4},
  [158] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
  [162] =
    {field_left, 1},
    {field_left, 2},
    {field_right, 4},
  [165] =
    {field_body, 4},
    {field_body, 6},
    {field_condition, 2},
    {field_else, 5},
  [169] =
    {field_body, 1},
    {field_condition, 4},
  [171] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_right, 5},
  [175] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_left, 5},
  [180] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_right, 6},
  [185] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_left, 5},
    {field_right, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [35] = {
    [1] = alias_sym_enum_value,
  },
  [55] = {
    [1] = alias_sym_revert_arguments,
  },
  [63] = {
    [1] = alias_sym_type_alias,
  },
  [66] = {
    [2] = alias_sym_revert_arguments,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__call_arguments, 2,
    sym__call_arguments,
    alias_sym_revert_arguments,
  sym_user_defined_type, 2,
    sym_user_defined_type,
    alias_sym_type_alias,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 3,
  [9] = 9,
  [10] = 10,
  [11] = 4,
  [12] = 12,
  [13] = 12,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 14,
  [19] = 19,
  [20] = 17,
  [21] = 16,
  [22] = 15,
  [23] = 19,
  [24] = 24,
  [25] = 24,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 29,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 34,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 39,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 49,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 54,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 62,
  [81] = 81,
  [82] = 56,
  [83] = 60,
  [84] = 61,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 128,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 133,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 138,
  [143] = 135,
  [144] = 144,
  [145] = 141,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 184,
  [194] = 170,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 190,
  [212] = 179,
  [213] = 165,
  [214] = 168,
  [215] = 162,
  [216] = 163,
  [217] = 191,
  [218] = 158,
  [219] = 192,
  [220] = 176,
  [221] = 189,
  [222] = 172,
  [223] = 181,
  [224] = 183,
  [225] = 187,
  [226] = 164,
  [227] = 169,
  [228] = 185,
  [229] = 171,
  [230] = 178,
  [231] = 175,
  [232] = 180,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 244,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 301,
  [362] = 362,
  [363] = 299,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 434,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 439,
  [447] = 447,
  [448] = 447,
  [449] = 449,
  [450] = 449,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 456,
  [463] = 458,
  [464] = 453,
  [465] = 452,
  [466] = 454,
  [467] = 457,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 471,
  [473] = 473,
  [474] = 362,
  [475] = 475,
  [476] = 476,
  [477] = 476,
  [478] = 478,
  [479] = 478,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 516,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 522,
  [530] = 524,
  [531] = 525,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 541,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 551,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 578,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 618,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 580,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 627,
  [683] = 683,
  [684] = 684,
  [685] = 656,
  [686] = 665,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 696,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 729,
  [746] = 693,
  [747] = 747,
  [748] = 705,
  [749] = 749,
  [750] = 725,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 755,
  [760] = 720,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 763,
  [767] = 719,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 699,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 718,
  [779] = 752,
  [780] = 692,
  [781] = 781,
  [782] = 769,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 749,
  [789] = 789,
  [790] = 790,
  [791] = 738,
  [792] = 792,
  [793] = 777,
  [794] = 794,
  [795] = 114,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 754,
  [801] = 801,
  [802] = 802,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 811,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 830,
  [831] = 831,
  [832] = 832,
  [833] = 833,
  [834] = 834,
  [835] = 835,
  [836] = 836,
  [837] = 837,
  [838] = 838,
  [839] = 839,
  [840] = 840,
  [841] = 841,
  [842] = 842,
  [843] = 843,
  [844] = 844,
  [845] = 845,
  [846] = 846,
  [847] = 847,
  [848] = 848,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 857,
  [858] = 858,
  [859] = 859,
  [860] = 811,
  [861] = 861,
  [862] = 852,
  [863] = 829,
  [864] = 805,
  [865] = 865,
  [866] = 866,
  [867] = 856,
  [868] = 868,
  [869] = 861,
  [870] = 870,
  [871] = 871,
  [872] = 837,
  [873] = 823,
  [874] = 836,
  [875] = 853,
  [876] = 876,
  [877] = 868,
  [878] = 859,
  [879] = 826,
  [880] = 880,
  [881] = 881,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(52);
      ADVANCE_MAP(
        '!', 109,
        '"', 137,
        '%', 106,
        '&', 101,
        '\'', 140,
        '(', 83,
        ')', 84,
        '*', 79,
        '+', 104,
        ',', 81,
        '-', 56,
        '.', 88,
        '/', 105,
        '0', 89,
        ':', 87,
        ';', 123,
        '<', 68,
        '=', 78,
        '>', 73,
        '?', 94,
        '[', 95,
        '\\', 32,
        ']', 96,
        '^', 71,
        '_', 139,
        '{', 80,
        '|', 100,
        '}', 82,
        '~', 75,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(90);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(50);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(13);
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == '\\') ADVANCE(2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(158);
      if (lookahead != 0) ADVANCE(159);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(153);
      if (lookahead == '\r') ADVANCE(142);
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      if (lookahead != 0) ADVANCE(141);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(15);
      if (lookahead == '\'') ADVANCE(140);
      if (lookahead == '/') ADVANCE(148);
      if (lookahead == '\\') ADVANCE(4);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(151);
      if (lookahead != 0) ADVANCE(152);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(146);
      if (lookahead == '\r') ADVANCE(143);
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      if (lookahead != 0) ADVANCE(141);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        ' ', 5,
        '"', 6,
        '-', 54,
        '.', 7,
        '/', 17,
        ';', 123,
        '<', 69,
        '=', 76,
        '>', 72,
        '^', 70,
        '|', 35,
        '~', 75,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(5);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 6:
      if (lookahead == ' ') ADVANCE(37);
      if (lookahead == '.') ADVANCE(7);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 7:
      if (lookahead == ' ') ADVANCE(37);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 8:
      if (lookahead == ' ') ADVANCE(38);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 24,
        '"', 137,
        '%', 106,
        '&', 101,
        '\'', 140,
        '(', 83,
        ')', 84,
        '*', 79,
        '+', 104,
        ',', 81,
        '-', 56,
        '.', 88,
        '/', 105,
        ':', 86,
        ';', 123,
        '<', 68,
        '=', 77,
        '>', 73,
        '?', 94,
        '[', 95,
        ']', 96,
        '^', 71,
        '{', 80,
        '|', 100,
        '}', 82,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(9);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 24,
        '"', 28,
        '%', 106,
        '&', 101,
        '(', 83,
        ')', 84,
        '*', 79,
        '+', 104,
        ',', 81,
        '-', 56,
        '.', 88,
        '/', 105,
        ':', 86,
        ';', 123,
        '<', 68,
        '=', 78,
        '>', 73,
        '?', 94,
        '[', 95,
        ']', 96,
        '^', 71,
        '{', 80,
        '|', 100,
        '}', 82,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(10);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 108,
        '"', 137,
        '\'', 140,
        '(', 83,
        ')', 84,
        '+', 20,
        ',', 81,
        '-', 55,
        '.', 40,
        '/', 17,
        '0', 128,
        ':', 86,
        ';', 123,
        '=', 25,
        '[', 95,
        ']', 96,
        '_', 125,
        '{', 80,
        '}', 82,
        '~', 75,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(129);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(11);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '\'') ADVANCE(140);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '_') ADVANCE(138);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(137);
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(13);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(85);
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(140);
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(15);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '(', 83,
        ')', 84,
        ',', 81,
        '-', 26,
        '.', 88,
        '/', 17,
        ';', 123,
        '=', 25,
        '[', 95,
        '{', 80,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(16);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(162);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '+') ADVANCE(110);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(131);
      END_STATE();
    case 22:
      if (lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(61);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 26:
      if (lookahead == '>') ADVANCE(93);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(31);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 29:
      if (lookahead == 'm') ADVANCE(27);
      END_STATE();
    case 30:
      if (lookahead == 'm') ADVANCE(14);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(30);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(145);
      if (lookahead != 0) ADVANCE(141);
      END_STATE();
    case 33:
      if (lookahead == 'v') ADVANCE(29);
      END_STATE();
    case 34:
      if (lookahead == '{') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 35:
      if (lookahead == '|') ADVANCE(53);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 38:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(132);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(130);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(131);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(141);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(134);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(136);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 50:
      if (eof) ADVANCE(52);
      ADVANCE_MAP(
        '!', 109,
        '"', 137,
        '%', 106,
        '&', 101,
        '\'', 140,
        '(', 83,
        ')', 84,
        '*', 79,
        '+', 104,
        ',', 81,
        '-', 56,
        '.', 88,
        '/', 105,
        '0', 89,
        ':', 87,
        ';', 123,
        '<', 68,
        '=', 78,
        '>', 73,
        '?', 94,
        '[', 95,
        ']', 96,
        '^', 71,
        '_', 139,
        '{', 80,
        '|', 100,
        '}', 82,
        '~', 75,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(90);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(50);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 51:
      if (eof) ADVANCE(52);
      ADVANCE_MAP(
        '!', 24,
        '"', 137,
        '%', 106,
        '&', 101,
        '\'', 140,
        '(', 83,
        ')', 84,
        '*', 79,
        '+', 104,
        ',', 81,
        '-', 56,
        '.', 88,
        '/', 105,
        '0', 89,
        ':', 87,
        ';', 123,
        '<', 68,
        '=', 77,
        '>', 73,
        '?', 94,
        '[', 95,
        ']', 96,
        '^', 71,
        '{', 80,
        '|', 100,
        '}', 82,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(90);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(51);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(111);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(59);
      if (lookahead == '/') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(61);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(58);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(58);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead != 0) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '/') ADVANCE(57);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(61);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_solidity_version);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == ' ') ADVANCE(65);
      if (lookahead == '"') ADVANCE(62);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(62);
      if (lookahead == '.') ADVANCE(8);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(64);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(62);
      if (lookahead == '.') ADVANCE(39);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(62);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(102);
      if (lookahead == '=') ADVANCE(67);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(67);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(74);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(103);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(98);
      if (lookahead == '>') ADVANCE(122);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(107);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_DQUOTEevmasm_DQUOTE);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(92);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_yul_decimal_number);
      if (lookahead == 'x') ADVANCE(91);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_yul_decimal_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(90);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_yul_hex_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(119);
      if (lookahead == '|') ADVANCE(53);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(97);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(110);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(126);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(125);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(126);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(131);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym__decimal_number_token2);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym__decimal_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym__hex_number_token1);
      if (lookahead == '_') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym__hex_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(134);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym__hex_digit);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(127);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym__escape_sequence);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (lookahead == '\n') ADVANCE(153);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (lookahead == '\n') ADVANCE(146);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(141);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(144);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '\r') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(150);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(152);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '/') ADVANCE(148);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(151);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '\r') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(154);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(157);
      if (lookahead == '/') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(159);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '/') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(158);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(159);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(159);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ';') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(162);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'g', 7,
        'h', 8,
        'i', 9,
        'k', 10,
        'l', 11,
        'm', 12,
        'n', 13,
        'o', 14,
        'p', 15,
        'r', 16,
        's', 17,
        't', 18,
        'u', 19,
        'v', 20,
        'w', 21,
        'x', 22,
        'y', 23,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(24);
      if (lookahead == 'd') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(26);
      if (lookahead == 's') ADVANCE(27);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      if (lookahead == 'r') ADVANCE(31);
      if (lookahead == 'y') ADVANCE(32);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'h') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        'l', 41,
        'm', 42,
        'n', 43,
        'q', 44,
        'r', 45,
        't', 46,
        'v', 47,
        'x', 48,
      );
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 't') ADVANCE(55);
      if (lookahead == 'w') ADVANCE(56);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 'o') ADVANCE(58);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(59);
      if (lookahead == 'm') ADVANCE(60);
      if (lookahead == 'n') ADVANCE(61);
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'i') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        'a', 68,
        'c', 69,
        'e', 70,
        'i', 71,
        'l', 72,
        'o', 73,
        's', 74,
        'u', 75,
      );
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 'u') ADVANCE(78);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(79);
      if (lookahead == 'v') ADVANCE(80);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(81);
      if (lookahead == 'o') ADVANCE(82);
      if (lookahead == 'r') ADVANCE(83);
      if (lookahead == 'u') ADVANCE(84);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        'a', 86,
        'd', 87,
        'e', 88,
        'g', 89,
        'h', 90,
        'i', 91,
        'l', 92,
        'm', 93,
        'o', 94,
        's', 95,
        't', 96,
        'u', 97,
        'w', 98,
        'z', 99,
      );
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(100);
      if (lookahead == 'l') ADVANCE(101);
      if (lookahead == 'r') ADVANCE(102);
      if (lookahead == 's') ADVANCE(103);
      if (lookahead == 'y') ADVANCE(104);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(105);
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 'n') ADVANCE(107);
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(109);
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(111);
      if (lookahead == 'h') ADVANCE(112);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(113);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 25:
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 26:
      if (lookahead == 'd') ADVANCE(117);
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(120);
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 29:
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(130);
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 37:
      if (lookahead == 'y') ADVANCE(133);
      END_STATE();
    case 38:
      if (lookahead == 'f') ADVANCE(134);
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 39:
      if (lookahead == 'f') ADVANCE(136);
      if (lookahead == 'v') ADVANCE(137);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 43:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(142);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(147);
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(149);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(151);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_gt);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 57:
      if (lookahead == 'x') ADVANCE(154);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(155);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(156);
      if (lookahead == 'p') ADVANCE(157);
      END_STATE();
    case 61:
      if (lookahead == 'd') ADVANCE(158);
      if (lookahead == 't') ADVANCE(159);
      if (lookahead == 'v') ADVANCE(160);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == 'z') ADVANCE(161);
      END_STATE();
    case 63:
      if (lookahead == 'c') ADVANCE(162);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(163);
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 65:
      if (lookahead == 'b') ADVANCE(165);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(166);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_lt);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(167);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 70:
      if (lookahead == 'm') ADVANCE(169);
      END_STATE();
    case 71:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 72:
      if (lookahead == 'o') ADVANCE(171);
      END_STATE();
    case 73:
      if (lookahead == 'd') ADVANCE(172);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(173);
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(175);
      END_STATE();
    case 76:
      if (lookahead == 'w') ADVANCE(176);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(178);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 81:
      if (lookahead == 'y') ADVANCE(181);
      END_STATE();
    case 82:
      if (lookahead == 'p') ADVANCE(182);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(183);
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 84:
      if (lookahead == 'b') ADVANCE(185);
      if (lookahead == 'r') ADVANCE(186);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      if (lookahead == 'v') ADVANCE(189);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 89:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 90:
      if (lookahead == 'l') ADVANCE(195);
      if (lookahead == 'r') ADVANCE(196);
      END_STATE();
    case 91:
      if (lookahead == 'g') ADVANCE(197);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(198);
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(201);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(203);
      if (lookahead == 'o') ADVANCE(204);
      if (lookahead == 'r') ADVANCE(205);
      END_STATE();
    case 97:
      if (lookahead == 'b') ADVANCE(206);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(208);
      END_STATE();
    case 100:
      if (lookahead == 'm') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 102:
      if (lookahead == 'a') ADVANCE(211);
      if (lookahead == 'u') ADVANCE(212);
      if (lookahead == 'y') ADVANCE(213);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(214);
      END_STATE();
    case 104:
      if (lookahead == 'p') ADVANCE(215);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(216);
      END_STATE();
    case 106:
      if (lookahead == 'n') ADVANCE(217);
      END_STATE();
    case 107:
      if (lookahead == 'c') ADVANCE(218);
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(220);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(222);
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(224);
      if (lookahead == 'i') ADVANCE(225);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(226);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(228);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(229);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'm') ADVANCE(230);
      if (lookahead == 'r') ADVANCE(231);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(232);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(233);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(234);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(235);
      END_STATE();
    case 122:
      if (lookahead == 'b') ADVANCE(236);
      if (lookahead == 'c') ADVANCE(237);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(238);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(240);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(241);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(243);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(245);
      END_STATE();
    case 131:
      if (lookahead == 's') ADVANCE(246);
      if (lookahead == 't') ADVANCE(247);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(248);
      END_STATE();
    case 133:
      if (lookahead == 's') ADVANCE(249);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(250);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(251);
      END_STATE();
    case 136:
      if (lookahead == 'f') ADVANCE(252);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_div);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(253);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(254);
      END_STATE();
    case 140:
      if (lookahead == 'm') ADVANCE(255);
      END_STATE();
    case 141:
      if (lookahead == 'o') ADVANCE(256);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 143:
      if (lookahead == 'n') ADVANCE(258);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_exp);
      END_STATE();
    case 145:
      if (lookahead == 'c') ADVANCE(259);
      if (lookahead == 'e') ADVANCE(260);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(261);
      if (lookahead == 's') ADVANCE(262);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(263);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(264);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 150:
      if (lookahead == 'm') ADVANCE(265);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(266);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_gas);
      if (lookahead == 'l') ADVANCE(267);
      if (lookahead == 'p') ADVANCE(268);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(269);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_hex);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(270);
      END_STATE();
    case 156:
      if (lookahead == 'u') ADVANCE(271);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(272);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(273);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_int);
      ADVANCE_MAP(
        '1', 274,
        '2', 275,
        '3', 276,
        '4', 277,
        '5', 278,
        '6', 279,
        '7', 280,
        '8', 281,
        '9', 282,
        'e', 283,
      );
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(284);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(285);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(286);
      END_STATE();
    case 163:
      if (lookahead == 'v') ADVANCE(287);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(288);
      END_STATE();
    case 166:
      if (lookahead == '0') ADVANCE(289);
      if (lookahead == '1') ADVANCE(290);
      if (lookahead == '2') ADVANCE(291);
      if (lookahead == '3') ADVANCE(292);
      if (lookahead == '4') ADVANCE(293);
      END_STATE();
    case 167:
      if (lookahead == 'p') ADVANCE(294);
      END_STATE();
    case 168:
      if (lookahead == 'p') ADVANCE(295);
      END_STATE();
    case 169:
      if (lookahead == 'o') ADVANCE(296);
      END_STATE();
    case 170:
      if (lookahead == 'u') ADVANCE(297);
      END_STATE();
    case 171:
      if (lookahead == 'a') ADVANCE(298);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_mod);
      if (lookahead == 'i') ADVANCE(299);
      END_STATE();
    case 173:
      if (lookahead == 'z') ADVANCE(300);
      END_STATE();
    case 174:
      if (lookahead == 'o') ADVANCE(301);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_mul);
      if (lookahead == 'm') ADVANCE(302);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 178:
      if (lookahead == 'b') ADVANCE(303);
      END_STATE();
    case 179:
      if (lookahead == 'g') ADVANCE(304);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(305);
      END_STATE();
    case 181:
      if (lookahead == 'a') ADVANCE(306);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_pop);
      END_STATE();
    case 183:
      if (lookahead == 'g') ADVANCE(307);
      END_STATE();
    case 184:
      if (lookahead == 'v') ADVANCE(308);
      END_STATE();
    case 185:
      if (lookahead == 'l') ADVANCE(309);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(311);
      END_STATE();
    case 188:
      if (lookahead == 'u') ADVANCE(312);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_sar);
      END_STATE();
    case 191:
      if (lookahead == 'v') ADVANCE(314);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(315);
      END_STATE();
    case 193:
      if (lookahead == 'f') ADVANCE(316);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_sgt);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_shr);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(317);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(318);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_slt);
      END_STATE();
    case 200:
      if (lookahead == 'd') ADVANCE(319);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(320);
      END_STATE();
    case 202:
      if (lookahead == 'o') ADVANCE(321);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 204:
      if (lookahead == 'p') ADVANCE(323);
      if (lookahead == 'r') ADVANCE(324);
      END_STATE();
    case 205:
      if (lookahead == 'i') ADVANCE(325);
      if (lookahead == 'u') ADVANCE(326);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(327);
      END_STATE();
    case 208:
      if (lookahead == 'b') ADVANCE(328);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(329);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(330);
      END_STATE();
    case 211:
      if (lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 214:
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 215:
      if (lookahead == 'e') ADVANCE(334);
      END_STATE();
    case 216:
      if (lookahead == 'x') ADVANCE(335);
      END_STATE();
    case 217:
      if (lookahead == 't') ADVANCE(336);
      END_STATE();
    case 218:
      if (lookahead == 'h') ADVANCE(337);
      END_STATE();
    case 219:
      if (lookahead == 'c') ADVANCE(338);
      END_STATE();
    case 220:
      if (lookahead == 'n') ADVANCE(339);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 222:
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 223:
      if (lookahead == 't') ADVANCE(341);
      END_STATE();
    case 224:
      if (lookahead == 'k') ADVANCE(342);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_wei);
      END_STATE();
    case 226:
      if (lookahead == 'l') ADVANCE(343);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 228:
      if (lookahead == 'r') ADVANCE(344);
      END_STATE();
    case 229:
      if (lookahead == 'r') ADVANCE(345);
      END_STATE();
    case 230:
      if (lookahead == 'o') ADVANCE(346);
      END_STATE();
    case 231:
      if (lookahead == 'e') ADVANCE(347);
      END_STATE();
    case 232:
      if (lookahead == 'y') ADVANCE(348);
      END_STATE();
    case 233:
      if (lookahead == 'm') ADVANCE(349);
      END_STATE();
    case 234:
      if (lookahead == 'n') ADVANCE(350);
      END_STATE();
    case 235:
      if (lookahead == 'f') ADVANCE(351);
      END_STATE();
    case 236:
      if (lookahead == 'f') ADVANCE(352);
      if (lookahead == 'h') ADVANCE(353);
      END_STATE();
    case 237:
      if (lookahead == 'k') ADVANCE(354);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 239:
      if (lookahead == 'k') ADVANCE(355);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_byte);
      if (lookahead == 's') ADVANCE(356);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == 'c') ADVANCE(357);
      if (lookahead == 'd') ADVANCE(358);
      if (lookahead == 'e') ADVANCE(359);
      if (lookahead == 'v') ADVANCE(360);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 243:
      if (lookahead == 'h') ADVANCE(361);
      END_STATE();
    case 244:
      if (lookahead == 'n') ADVANCE(362);
      END_STATE();
    case 245:
      if (lookahead == 'b') ADVANCE(363);
      END_STATE();
    case 246:
      if (lookahead == 't') ADVANCE(364);
      END_STATE();
    case 247:
      if (lookahead == 'i') ADVANCE(365);
      if (lookahead == 'r') ADVANCE(366);
      END_STATE();
    case 248:
      if (lookahead == 't') ADVANCE(367);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_days);
      END_STATE();
    case 250:
      if (lookahead == 'u') ADVANCE(368);
      END_STATE();
    case 251:
      if (lookahead == 'g') ADVANCE(369);
      if (lookahead == 't') ADVANCE(370);
      END_STATE();
    case 252:
      if (lookahead == 'i') ADVANCE(371);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_emit);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 256:
      if (lookahead == 'r') ADVANCE(372);
      END_STATE();
    case 257:
      if (lookahead == 'r') ADVANCE(373);
      END_STATE();
    case 258:
      if (lookahead == 't') ADVANCE(374);
      END_STATE();
    case 259:
      if (lookahead == 'o') ADVANCE(375);
      END_STATE();
    case 260:
      if (lookahead == 'r') ADVANCE(376);
      END_STATE();
    case 261:
      if (lookahead == 'b') ADVANCE(377);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 263:
      if (lookahead == 'e') ADVANCE(379);
      END_STATE();
    case 264:
      if (lookahead == 'd') ADVANCE(380);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 266:
      if (lookahead == 't') ADVANCE(381);
      END_STATE();
    case 267:
      if (lookahead == 'i') ADVANCE(382);
      END_STATE();
    case 268:
      if (lookahead == 'r') ADVANCE(383);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(anon_sym_gwei);
      END_STATE();
    case 270:
      if (lookahead == 's') ADVANCE(384);
      END_STATE();
    case 271:
      if (lookahead == 't') ADVANCE(385);
      END_STATE();
    case 272:
      if (lookahead == 'r') ADVANCE(386);
      END_STATE();
    case 273:
      if (lookahead == 'x') ADVANCE(387);
      END_STATE();
    case 274:
      ADVANCE_MAP(
        '0', 388,
        '1', 389,
        '2', 390,
        '3', 391,
        '4', 392,
        '5', 393,
        '6', 394,
        '7', 395,
        '8', 396,
        '9', 397,
      );
      END_STATE();
    case 275:
      if (lookahead == '0') ADVANCE(398);
      if (lookahead == '1') ADVANCE(399);
      if (lookahead == '2') ADVANCE(400);
      if (lookahead == '3') ADVANCE(401);
      if (lookahead == '4') ADVANCE(402);
      if (lookahead == '5') ADVANCE(403);
      END_STATE();
    case 276:
      if (lookahead == '2') ADVANCE(404);
      END_STATE();
    case 277:
      if (lookahead == '0') ADVANCE(405);
      if (lookahead == '8') ADVANCE(406);
      END_STATE();
    case 278:
      if (lookahead == '6') ADVANCE(407);
      END_STATE();
    case 279:
      if (lookahead == '4') ADVANCE(408);
      END_STATE();
    case 280:
      if (lookahead == '2') ADVANCE(409);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_int8);
      if (lookahead == '0') ADVANCE(410);
      if (lookahead == '8') ADVANCE(411);
      END_STATE();
    case 282:
      if (lookahead == '6') ADVANCE(412);
      END_STATE();
    case 283:
      if (lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 284:
      if (lookahead == 'l') ADVANCE(414);
      END_STATE();
    case 285:
      if (lookahead == 'r') ADVANCE(415);
      END_STATE();
    case 286:
      if (lookahead == 'a') ADVANCE(416);
      END_STATE();
    case 287:
      if (lookahead == 'e') ADVANCE(417);
      END_STATE();
    case 288:
      if (lookahead == 'a') ADVANCE(418);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_log0);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_log1);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_log2);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_log3);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_log4);
      END_STATE();
    case 294:
      if (lookahead == 'i') ADVANCE(419);
      END_STATE();
    case 295:
      if (lookahead == 'y') ADVANCE(420);
      END_STATE();
    case 296:
      if (lookahead == 'r') ADVANCE(421);
      END_STATE();
    case 297:
      if (lookahead == 't') ADVANCE(422);
      END_STATE();
    case 298:
      if (lookahead == 'd') ADVANCE(423);
      END_STATE();
    case 299:
      if (lookahead == 'f') ADVANCE(424);
      END_STATE();
    case 300:
      if (lookahead == 'e') ADVANCE(425);
      END_STATE();
    case 301:
      if (lookahead == 'r') ADVANCE(426);
      END_STATE();
    case 302:
      if (lookahead == 'o') ADVANCE(427);
      END_STATE();
    case 303:
      if (lookahead == 'e') ADVANCE(428);
      END_STATE();
    case 304:
      if (lookahead == 'i') ADVANCE(429);
      END_STATE();
    case 305:
      if (lookahead == 'r') ADVANCE(430);
      END_STATE();
    case 306:
      if (lookahead == 'b') ADVANCE(431);
      END_STATE();
    case 307:
      if (lookahead == 'm') ADVANCE(432);
      END_STATE();
    case 308:
      if (lookahead == 'a') ADVANCE(433);
      END_STATE();
    case 309:
      if (lookahead == 'i') ADVANCE(434);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_pure);
      END_STATE();
    case 311:
      if (lookahead == 'i') ADVANCE(435);
      END_STATE();
    case 312:
      if (lookahead == 'r') ADVANCE(436);
      END_STATE();
    case 313:
      if (lookahead == 'r') ADVANCE(437);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym_sdiv);
      END_STATE();
    case 315:
      if (lookahead == 'n') ADVANCE(438);
      END_STATE();
    case 316:
      if (lookahead == 'b') ADVANCE(439);
      if (lookahead == 'd') ADVANCE(440);
      END_STATE();
    case 317:
      if (lookahead == 'e') ADVANCE(441);
      END_STATE();
    case 318:
      if (lookahead == 'd') ADVANCE(442);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_smod);
      END_STATE();
    case 320:
      if (lookahead == 'd') ADVANCE(443);
      END_STATE();
    case 321:
      if (lookahead == 'r') ADVANCE(444);
      END_STATE();
    case 322:
      if (lookahead == 'i') ADVANCE(445);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_stop);
      END_STATE();
    case 324:
      if (lookahead == 'a') ADVANCE(446);
      END_STATE();
    case 325:
      if (lookahead == 'n') ADVANCE(447);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(448);
      END_STATE();
    case 327:
      if (lookahead == 'c') ADVANCE(449);
      END_STATE();
    case 328:
      if (lookahead == 'o') ADVANCE(450);
      END_STATE();
    case 329:
      if (lookahead == 's') ADVANCE(451);
      END_STATE();
    case 330:
      if (lookahead == 'd') ADVANCE(452);
      END_STATE();
    case 331:
      if (lookahead == 's') ADVANCE(453);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 333:
      if (lookahead == 'r') ADVANCE(454);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(455);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(anon_sym_uint);
      ADVANCE_MAP(
        '1', 456,
        '2', 457,
        '3', 458,
        '4', 459,
        '5', 460,
        '6', 461,
        '7', 462,
        '8', 463,
        '9', 464,
      );
      END_STATE();
    case 337:
      if (lookahead == 'e') ADVANCE(465);
      END_STATE();
    case 338:
      if (lookahead == 'o') ADVANCE(466);
      END_STATE();
    case 339:
      if (lookahead == 'g') ADVANCE(467);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_view);
      END_STATE();
    case 341:
      if (lookahead == 'u') ADVANCE(468);
      END_STATE();
    case 342:
      if (lookahead == 's') ADVANCE(469);
      END_STATE();
    case 343:
      if (lookahead == 'e') ADVANCE(470);
      END_STATE();
    case 344:
      if (lookahead == 's') ADVANCE(471);
      END_STATE();
    case 345:
      if (lookahead == 'a') ADVANCE(472);
      END_STATE();
    case 346:
      if (lookahead == 'd') ADVANCE(473);
      END_STATE();
    case 347:
      if (lookahead == 's') ADVANCE(474);
      END_STATE();
    case 348:
      if (lookahead == 'm') ADVANCE(475);
      END_STATE();
    case 349:
      if (lookahead == 'b') ADVANCE(476);
      END_STATE();
    case 350:
      if (lookahead == 'c') ADVANCE(477);
      END_STATE();
    case 351:
      if (lookahead == 'e') ADVANCE(478);
      END_STATE();
    case 352:
      if (lookahead == 'e') ADVANCE(479);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(480);
      END_STATE();
    case 354:
      if (lookahead == 'h') ADVANCE(481);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_bytes);
      ADVANCE_MAP(
        '1', 482,
        '2', 483,
        '3', 484,
        '4', 485,
        '5', 486,
        '6', 487,
        '7', 488,
        '8', 489,
        '9', 490,
      );
      END_STATE();
    case 357:
      if (lookahead == 'o') ADVANCE(491);
      END_STATE();
    case 358:
      if (lookahead == 'a') ADVANCE(492);
      END_STATE();
    case 359:
      if (lookahead == 'r') ADVANCE(493);
      END_STATE();
    case 360:
      if (lookahead == 'a') ADVANCE(494);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 362:
      if (lookahead == 'i') ADVANCE(495);
      END_STATE();
    case 363:
      if (lookahead == 'a') ADVANCE(496);
      END_STATE();
    case 364:
      if (lookahead == 'a') ADVANCE(497);
      if (lookahead == 'r') ADVANCE(498);
      END_STATE();
    case 365:
      if (lookahead == 'n') ADVANCE(499);
      END_STATE();
    case 366:
      if (lookahead == 'a') ADVANCE(500);
      END_STATE();
    case 367:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 368:
      if (lookahead == 'l') ADVANCE(502);
      END_STATE();
    case 369:
      if (lookahead == 'a') ADVANCE(503);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(504);
      END_STATE();
    case 371:
      if (lookahead == 'c') ADVANCE(505);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_ether);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 375:
      if (lookahead == 'd') ADVANCE(506);
      END_STATE();
    case 376:
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 377:
      if (lookahead == 'a') ADVANCE(508);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 379:
      if (lookahead == 'y') ADVANCE(509);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_fixed);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(510);
      END_STATE();
    case 381:
      if (lookahead == 'i') ADVANCE(511);
      END_STATE();
    case 382:
      if (lookahead == 'm') ADVANCE(512);
      END_STATE();
    case 383:
      if (lookahead == 'i') ADVANCE(513);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_hours);
      END_STATE();
    case 385:
      if (lookahead == 'a') ADVANCE(514);
      END_STATE();
    case 386:
      if (lookahead == 't') ADVANCE(515);
      END_STATE();
    case 387:
      if (lookahead == 'e') ADVANCE(516);
      END_STATE();
    case 388:
      if (lookahead == '4') ADVANCE(517);
      END_STATE();
    case 389:
      if (lookahead == '2') ADVANCE(518);
      END_STATE();
    case 390:
      if (lookahead == '0') ADVANCE(519);
      if (lookahead == '8') ADVANCE(520);
      END_STATE();
    case 391:
      if (lookahead == '6') ADVANCE(521);
      END_STATE();
    case 392:
      if (lookahead == '4') ADVANCE(522);
      END_STATE();
    case 393:
      if (lookahead == '2') ADVANCE(523);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(anon_sym_int16);
      if (lookahead == '0') ADVANCE(524);
      if (lookahead == '8') ADVANCE(525);
      END_STATE();
    case 395:
      if (lookahead == '6') ADVANCE(526);
      END_STATE();
    case 396:
      if (lookahead == '4') ADVANCE(527);
      END_STATE();
    case 397:
      if (lookahead == '2') ADVANCE(528);
      END_STATE();
    case 398:
      if (lookahead == '0') ADVANCE(529);
      if (lookahead == '8') ADVANCE(530);
      END_STATE();
    case 399:
      if (lookahead == '6') ADVANCE(531);
      END_STATE();
    case 400:
      if (lookahead == '4') ADVANCE(532);
      END_STATE();
    case 401:
      if (lookahead == '2') ADVANCE(533);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_int24);
      if (lookahead == '0') ADVANCE(534);
      if (lookahead == '8') ADVANCE(535);
      END_STATE();
    case 403:
      if (lookahead == '6') ADVANCE(536);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_int32);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_int40);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_int48);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_int56);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_int64);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_int72);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_int80);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_int88);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_int96);
      END_STATE();
    case 413:
      if (lookahead == 'f') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(538);
      END_STATE();
    case 414:
      if (lookahead == 'i') ADVANCE(539);
      END_STATE();
    case 415:
      if (lookahead == 'o') ADVANCE(540);
      END_STATE();
    case 416:
      if (lookahead == 'k') ADVANCE(541);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_yul_leave);
      END_STATE();
    case 418:
      if (lookahead == 'r') ADVANCE(542);
      END_STATE();
    case 419:
      if (lookahead == 'n') ADVANCE(543);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_mcopy);
      END_STATE();
    case 421:
      if (lookahead == 'y') ADVANCE(544);
      END_STATE();
    case 422:
      if (lookahead == 'e') ADVANCE(545);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_mload);
      END_STATE();
    case 424:
      if (lookahead == 'i') ADVANCE(546);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_msize);
      END_STATE();
    case 426:
      if (lookahead == 'e') ADVANCE(547);
      END_STATE();
    case 427:
      if (lookahead == 'd') ADVANCE(548);
      END_STATE();
    case 428:
      if (lookahead == 'r') ADVANCE(549);
      END_STATE();
    case 429:
      if (lookahead == 'n') ADVANCE(550);
      END_STATE();
    case 430:
      if (lookahead == 'i') ADVANCE(551);
      END_STATE();
    case 431:
      if (lookahead == 'l') ADVANCE(552);
      END_STATE();
    case 432:
      if (lookahead == 'a') ADVANCE(553);
      END_STATE();
    case 433:
      if (lookahead == 't') ADVANCE(554);
      END_STATE();
    case 434:
      if (lookahead == 'c') ADVANCE(555);
      END_STATE();
    case 435:
      if (lookahead == 'v') ADVANCE(556);
      END_STATE();
    case 436:
      if (lookahead == 'n') ADVANCE(557);
      END_STATE();
    case 437:
      if (lookahead == 't') ADVANCE(558);
      END_STATE();
    case 438:
      if (lookahead == 'd') ADVANCE(559);
      END_STATE();
    case 439:
      if (lookahead == 'a') ADVANCE(560);
      END_STATE();
    case 440:
      if (lookahead == 'e') ADVANCE(561);
      END_STATE();
    case 441:
      if (lookahead == 'x') ADVANCE(562);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(anon_sym_sload);
      END_STATE();
    case 443:
      if (lookahead == 'i') ADVANCE(563);
      END_STATE();
    case 444:
      if (lookahead == 'e') ADVANCE(564);
      END_STATE();
    case 445:
      if (lookahead == 'c') ADVANCE(565);
      END_STATE();
    case 446:
      if (lookahead == 'g') ADVANCE(566);
      END_STATE();
    case 447:
      if (lookahead == 'g') ADVANCE(567);
      END_STATE();
    case 448:
      if (lookahead == 't') ADVANCE(568);
      END_STATE();
    case 449:
      if (lookahead == 'h') ADVANCE(569);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_szabo);
      END_STATE();
    case 451:
      if (lookahead == 't') ADVANCE(570);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_tload);
      END_STATE();
    case 453:
      if (lookahead == 'i') ADVANCE(571);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(572);
      END_STATE();
    case 455:
      if (lookahead == 'd') ADVANCE(573);
      END_STATE();
    case 456:
      ADVANCE_MAP(
        '0', 574,
        '1', 575,
        '2', 576,
        '3', 577,
        '4', 578,
        '5', 579,
        '6', 580,
        '7', 581,
        '8', 582,
        '9', 583,
      );
      END_STATE();
    case 457:
      if (lookahead == '0') ADVANCE(584);
      if (lookahead == '1') ADVANCE(585);
      if (lookahead == '2') ADVANCE(586);
      if (lookahead == '3') ADVANCE(587);
      if (lookahead == '4') ADVANCE(588);
      if (lookahead == '5') ADVANCE(589);
      END_STATE();
    case 458:
      if (lookahead == '2') ADVANCE(590);
      END_STATE();
    case 459:
      if (lookahead == '0') ADVANCE(591);
      if (lookahead == '8') ADVANCE(592);
      END_STATE();
    case 460:
      if (lookahead == '6') ADVANCE(593);
      END_STATE();
    case 461:
      if (lookahead == '4') ADVANCE(594);
      END_STATE();
    case 462:
      if (lookahead == '2') ADVANCE(595);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_uint8);
      if (lookahead == '0') ADVANCE(596);
      if (lookahead == '8') ADVANCE(597);
      END_STATE();
    case 464:
      if (lookahead == '6') ADVANCE(598);
      END_STATE();
    case 465:
      if (lookahead == 'c') ADVANCE(599);
      END_STATE();
    case 466:
      if (lookahead == 'd') ADVANCE(600);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 468:
      if (lookahead == 'a') ADVANCE(601);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_weeks);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_years);
      END_STATE();
    case 472:
      if (lookahead == 'c') ADVANCE(602);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(anon_sym_addmod);
      END_STATE();
    case 474:
      if (lookahead == 's') ADVANCE(603);
      END_STATE();
    case 475:
      if (lookahead == 'o') ADVANCE(604);
      END_STATE();
    case 476:
      if (lookahead == 'l') ADVANCE(605);
      END_STATE();
    case 477:
      if (lookahead == 'e') ADVANCE(606);
      END_STATE();
    case 478:
      if (lookahead == 'e') ADVANCE(607);
      END_STATE();
    case 479:
      if (lookahead == 'e') ADVANCE(608);
      END_STATE();
    case 480:
      if (lookahead == 's') ADVANCE(609);
      END_STATE();
    case 481:
      if (lookahead == 'a') ADVANCE(610);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_bytes1);
      ADVANCE_MAP(
        '0', 611,
        '1', 612,
        '2', 613,
        '3', 614,
        '4', 615,
        '5', 616,
        '6', 617,
        '7', 618,
        '8', 619,
        '9', 620,
      );
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_bytes2);
      ADVANCE_MAP(
        '0', 621,
        '1', 622,
        '2', 623,
        '3', 624,
        '4', 625,
        '5', 626,
        '6', 627,
        '7', 628,
        '8', 629,
        '9', 630,
      );
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_bytes3);
      if (lookahead == '0') ADVANCE(631);
      if (lookahead == '1') ADVANCE(632);
      if (lookahead == '2') ADVANCE(633);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_bytes4);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_bytes5);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_bytes6);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_bytes7);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(anon_sym_bytes8);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_bytes9);
      END_STATE();
    case 491:
      if (lookahead == 'd') ADVANCE(634);
      END_STATE();
    case 492:
      if (lookahead == 't') ADVANCE(635);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_caller);
      END_STATE();
    case 494:
      if (lookahead == 'l') ADVANCE(636);
      END_STATE();
    case 495:
      if (lookahead == 'd') ADVANCE(637);
      END_STATE();
    case 496:
      if (lookahead == 's') ADVANCE(638);
      END_STATE();
    case 497:
      if (lookahead == 'n') ADVANCE(639);
      END_STATE();
    case 498:
      if (lookahead == 'u') ADVANCE(640);
      END_STATE();
    case 499:
      if (lookahead == 'u') ADVANCE(641);
      END_STATE();
    case 500:
      if (lookahead == 'c') ADVANCE(642);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_create);
      if (lookahead == '2') ADVANCE(643);
      END_STATE();
    case 502:
      if (lookahead == 't') ADVANCE(644);
      END_STATE();
    case 503:
      if (lookahead == 't') ADVANCE(645);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 505:
      if (lookahead == 'u') ADVANCE(646);
      END_STATE();
    case 506:
      if (lookahead == 'e') ADVANCE(647);
      END_STATE();
    case 507:
      if (lookahead == 'a') ADVANCE(648);
      END_STATE();
    case 508:
      if (lookahead == 'c') ADVANCE(649);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(anon_sym_finney);
      END_STATE();
    case 510:
      if (lookahead == 'x') ADVANCE(650);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(510);
      END_STATE();
    case 511:
      if (lookahead == 'o') ADVANCE(651);
      END_STATE();
    case 512:
      if (lookahead == 'i') ADVANCE(652);
      END_STATE();
    case 513:
      if (lookahead == 'c') ADVANCE(653);
      END_STATE();
    case 514:
      if (lookahead == 'b') ADVANCE(654);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 516:
      if (lookahead == 'd') ADVANCE(655);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_int104);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_int112);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_int120);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_int128);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_int136);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_int144);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_int152);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_int160);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_int168);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_int176);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_int184);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_int192);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_int200);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_int208);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_int216);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_int224);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_int232);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(anon_sym_int240);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_int248);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_int256);
      END_STATE();
    case 537:
      if (lookahead == 'a') ADVANCE(656);
      END_STATE();
    case 538:
      if (lookahead == 'a') ADVANCE(657);
      END_STATE();
    case 539:
      if (lookahead == 'd') ADVANCE(658);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(anon_sym_iszero);
      END_STATE();
    case 541:
      if (lookahead == '2') ADVANCE(659);
      END_STATE();
    case 542:
      if (lookahead == 'y') ADVANCE(660);
      END_STATE();
    case 543:
      if (lookahead == 'g') ADVANCE(661);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_memory);
      END_STATE();
    case 545:
      if (lookahead == 's') ADVANCE(662);
      END_STATE();
    case 546:
      if (lookahead == 'e') ADVANCE(663);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_mstore);
      if (lookahead == '8') ADVANCE(664);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_mulmod);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_origin);
      END_STATE();
    case 551:
      if (lookahead == 'd') ADVANCE(665);
      END_STATE();
    case 552:
      if (lookahead == 'e') ADVANCE(666);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(anon_sym_pragma);
      END_STATE();
    case 554:
      if (lookahead == 'e') ADVANCE(667);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 556:
      if (lookahead == 'e') ADVANCE(668);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_return);
      if (lookahead == 'd') ADVANCE(669);
      if (lookahead == 's') ADVANCE(670);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_revert);
      END_STATE();
    case 559:
      if (lookahead == 's') ADVANCE(671);
      END_STATE();
    case 560:
      if (lookahead == 'l') ADVANCE(672);
      END_STATE();
    case 561:
      if (lookahead == 's') ADVANCE(673);
      END_STATE();
    case 562:
      if (lookahead == 't') ADVANCE(674);
      END_STATE();
    case 563:
      if (lookahead == 't') ADVANCE(675);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_sstore);
      END_STATE();
    case 565:
      if (lookahead == 'c') ADVANCE(676);
      END_STATE();
    case 566:
      if (lookahead == 'e') ADVANCE(677);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 570:
      if (lookahead == 'a') ADVANCE(678);
      END_STATE();
    case 571:
      if (lookahead == 'e') ADVANCE(679);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_tstore);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_ufixed);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(680);
      END_STATE();
    case 574:
      if (lookahead == '4') ADVANCE(681);
      END_STATE();
    case 575:
      if (lookahead == '2') ADVANCE(682);
      END_STATE();
    case 576:
      if (lookahead == '0') ADVANCE(683);
      if (lookahead == '8') ADVANCE(684);
      END_STATE();
    case 577:
      if (lookahead == '6') ADVANCE(685);
      END_STATE();
    case 578:
      if (lookahead == '4') ADVANCE(686);
      END_STATE();
    case 579:
      if (lookahead == '2') ADVANCE(687);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_uint16);
      if (lookahead == '0') ADVANCE(688);
      if (lookahead == '8') ADVANCE(689);
      END_STATE();
    case 581:
      if (lookahead == '6') ADVANCE(690);
      END_STATE();
    case 582:
      if (lookahead == '4') ADVANCE(691);
      END_STATE();
    case 583:
      if (lookahead == '2') ADVANCE(692);
      END_STATE();
    case 584:
      if (lookahead == '0') ADVANCE(693);
      if (lookahead == '8') ADVANCE(694);
      END_STATE();
    case 585:
      if (lookahead == '6') ADVANCE(695);
      END_STATE();
    case 586:
      if (lookahead == '4') ADVANCE(696);
      END_STATE();
    case 587:
      if (lookahead == '2') ADVANCE(697);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_uint24);
      if (lookahead == '0') ADVANCE(698);
      if (lookahead == '8') ADVANCE(699);
      END_STATE();
    case 589:
      if (lookahead == '6') ADVANCE(700);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_uint32);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_uint40);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_uint48);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_uint56);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_uint64);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_uint72);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_uint80);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_uint88);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_uint96);
      END_STATE();
    case 599:
      if (lookahead == 'k') ADVANCE(701);
      END_STATE();
    case 600:
      if (lookahead == 'e') ADVANCE(702);
      END_STATE();
    case 601:
      if (lookahead == 'l') ADVANCE(703);
      END_STATE();
    case 602:
      if (lookahead == 't') ADVANCE(704);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_address);
      END_STATE();
    case 604:
      if (lookahead == 'u') ADVANCE(705);
      END_STATE();
    case 605:
      if (lookahead == 'y') ADVANCE(706);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_balance);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_basefee);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_blobfee);
      END_STATE();
    case 609:
      if (lookahead == 'h') ADVANCE(707);
      END_STATE();
    case 610:
      if (lookahead == 's') ADVANCE(708);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_bytes10);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_bytes11);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_bytes12);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_bytes13);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_bytes14);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym_bytes15);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_bytes16);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym_bytes17);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym_bytes18);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_bytes19);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym_bytes20);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_bytes21);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym_bytes22);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_bytes23);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(anon_sym_bytes24);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_bytes25);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_bytes26);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_bytes27);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym_bytes28);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(anon_sym_bytes29);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_bytes30);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_bytes31);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(anon_sym_bytes32);
      END_STATE();
    case 634:
      if (lookahead == 'e') ADVANCE(709);
      END_STATE();
    case 635:
      if (lookahead == 'a') ADVANCE(710);
      END_STATE();
    case 636:
      if (lookahead == 'u') ADVANCE(711);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(anon_sym_chainid);
      END_STATE();
    case 638:
      if (lookahead == 'e') ADVANCE(712);
      END_STATE();
    case 639:
      if (lookahead == 't') ADVANCE(713);
      END_STATE();
    case 640:
      if (lookahead == 'c') ADVANCE(714);
      END_STATE();
    case 641:
      if (lookahead == 'e') ADVANCE(715);
      END_STATE();
    case 642:
      if (lookahead == 't') ADVANCE(716);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(anon_sym_create2);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 645:
      if (lookahead == 'e') ADVANCE(717);
      END_STATE();
    case 646:
      if (lookahead == 'l') ADVANCE(718);
      END_STATE();
    case 647:
      if (lookahead == 'c') ADVANCE(719);
      if (lookahead == 'h') ADVANCE(720);
      if (lookahead == 's') ADVANCE(721);
      END_STATE();
    case 648:
      if (lookahead == 'l') ADVANCE(722);
      END_STATE();
    case 649:
      if (lookahead == 'k') ADVANCE(723);
      END_STATE();
    case 650:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(724);
      END_STATE();
    case 651:
      if (lookahead == 'n') ADVANCE(725);
      END_STATE();
    case 652:
      if (lookahead == 't') ADVANCE(726);
      END_STATE();
    case 653:
      if (lookahead == 'e') ADVANCE(727);
      END_STATE();
    case 654:
      if (lookahead == 'l') ADVANCE(728);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(anon_sym_indexed);
      END_STATE();
    case 656:
      if (lookahead == 'c') ADVANCE(729);
      END_STATE();
    case 657:
      if (lookahead == 'l') ADVANCE(730);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym_invalid);
      END_STATE();
    case 659:
      if (lookahead == '5') ADVANCE(731);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(anon_sym_library);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(anon_sym_mapping);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_minutes);
      END_STATE();
    case 663:
      if (lookahead == 'r') ADVANCE(732);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(anon_sym_mstore8);
      END_STATE();
    case 665:
      if (lookahead == 'e') ADVANCE(733);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym_payable);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(anon_sym_receive);
      END_STATE();
    case 669:
      if (lookahead == 'a') ADVANCE(734);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(anon_sym_returns);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(anon_sym_seconds);
      END_STATE();
    case 672:
      if (lookahead == 'a') ADVANCE(735);
      END_STATE();
    case 673:
      if (lookahead == 't') ADVANCE(736);
      END_STATE();
    case 674:
      if (lookahead == 'e') ADVANCE(737);
      END_STATE();
    case 675:
      if (lookahead == 'y') ADVANCE(738);
      END_STATE();
    case 676:
      if (lookahead == 'a') ADVANCE(739);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(anon_sym_storage);
      END_STATE();
    case 678:
      if (lookahead == 'm') ADVANCE(740);
      END_STATE();
    case 679:
      if (lookahead == 'n') ADVANCE(741);
      END_STATE();
    case 680:
      if (lookahead == 'x') ADVANCE(742);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(680);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(anon_sym_uint104);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(anon_sym_uint112);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(anon_sym_uint120);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(anon_sym_uint128);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(anon_sym_uint136);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(anon_sym_uint144);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(anon_sym_uint152);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(anon_sym_uint160);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(anon_sym_uint168);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(anon_sym_uint176);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(anon_sym_uint184);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(anon_sym_uint192);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(anon_sym_uint200);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym_uint208);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(anon_sym_uint216);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(anon_sym_uint224);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(anon_sym_uint232);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(anon_sym_uint240);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(anon_sym_uint248);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(anon_sym_uint256);
      END_STATE();
    case 701:
      if (lookahead == 'e') ADVANCE(743);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(anon_sym_unicode);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym_virtual);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 705:
      if (lookahead == 's') ADVANCE(744);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(anon_sym_blobhash);
      END_STATE();
    case 708:
      if (lookahead == 'h') ADVANCE(745);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(anon_sym_callcode);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(anon_sym_calldata);
      if (lookahead == 'c') ADVANCE(746);
      if (lookahead == 'l') ADVANCE(747);
      if (lookahead == 's') ADVANCE(748);
      END_STATE();
    case 711:
      if (lookahead == 'e') ADVANCE(749);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(anon_sym_coinbase);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(anon_sym_constant);
      END_STATE();
    case 714:
      if (lookahead == 't') ADVANCE(750);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(anon_sym_contract);
      END_STATE();
    case 717:
      if (lookahead == 'c') ADVANCE(751);
      END_STATE();
    case 718:
      if (lookahead == 't') ADVANCE(752);
      END_STATE();
    case 719:
      if (lookahead == 'o') ADVANCE(753);
      END_STATE();
    case 720:
      if (lookahead == 'a') ADVANCE(754);
      END_STATE();
    case 721:
      if (lookahead == 'i') ADVANCE(755);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(anon_sym_fallback);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(aux_sym__fixed_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(724);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(anon_sym_gaslimit);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(anon_sym_gasprice);
      END_STATE();
    case 728:
      if (lookahead == 'e') ADVANCE(756);
      END_STATE();
    case 729:
      if (lookahead == 'e') ADVANCE(757);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 731:
      if (lookahead == '6') ADVANCE(758);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(anon_sym_modifier);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 734:
      if (lookahead == 't') ADVANCE(759);
      END_STATE();
    case 735:
      if (lookahead == 'n') ADVANCE(760);
      END_STATE();
    case 736:
      if (lookahead == 'r') ADVANCE(761);
      END_STATE();
    case 737:
      if (lookahead == 'n') ADVANCE(762);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(anon_sym_solidity);
      END_STATE();
    case 739:
      if (lookahead == 'l') ADVANCE(763);
      END_STATE();
    case 740:
      if (lookahead == 'p') ADVANCE(764);
      END_STATE();
    case 741:
      if (lookahead == 't') ADVANCE(765);
      END_STATE();
    case 742:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 743:
      if (lookahead == 'd') ADVANCE(767);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(anon_sym_anonymous);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(anon_sym_blockhash);
      END_STATE();
    case 746:
      if (lookahead == 'o') ADVANCE(768);
      END_STATE();
    case 747:
      if (lookahead == 'o') ADVANCE(769);
      END_STATE();
    case 748:
      if (lookahead == 'i') ADVANCE(770);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(anon_sym_callvalue);
      END_STATE();
    case 750:
      if (lookahead == 'o') ADVANCE(771);
      END_STATE();
    case 751:
      if (lookahead == 'a') ADVANCE(772);
      END_STATE();
    case 752:
      if (lookahead == 'y') ADVANCE(773);
      END_STATE();
    case 753:
      if (lookahead == 'p') ADVANCE(774);
      END_STATE();
    case 754:
      if (lookahead == 's') ADVANCE(775);
      END_STATE();
    case 755:
      if (lookahead == 'z') ADVANCE(776);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym_immutable);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(anon_sym_keccak256);
      END_STATE();
    case 759:
      if (lookahead == 'a') ADVANCE(777);
      END_STATE();
    case 760:
      if (lookahead == 'c') ADVANCE(778);
      END_STATE();
    case 761:
      if (lookahead == 'u') ADVANCE(779);
      END_STATE();
    case 762:
      if (lookahead == 'd') ADVANCE(780);
      END_STATE();
    case 763:
      if (lookahead == 'l') ADVANCE(781);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(anon_sym_timestamp);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(anon_sym_transient);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(aux_sym__ufixed_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(sym_unchecked);
      END_STATE();
    case 768:
      if (lookahead == 'p') ADVANCE(782);
      END_STATE();
    case 769:
      if (lookahead == 'a') ADVANCE(783);
      END_STATE();
    case 770:
      if (lookahead == 'z') ADVANCE(784);
      END_STATE();
    case 771:
      if (lookahead == 'r') ADVANCE(785);
      END_STATE();
    case 772:
      if (lookahead == 'l') ADVANCE(786);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(anon_sym_difficulty);
      END_STATE();
    case 774:
      if (lookahead == 'y') ADVANCE(787);
      END_STATE();
    case 775:
      if (lookahead == 'h') ADVANCE(788);
      END_STATE();
    case 776:
      if (lookahead == 'e') ADVANCE(789);
      END_STATE();
    case 777:
      if (lookahead == 'c') ADVANCE(790);
      if (lookahead == 's') ADVANCE(791);
      END_STATE();
    case 778:
      if (lookahead == 'e') ADVANCE(792);
      END_STATE();
    case 779:
      if (lookahead == 'c') ADVANCE(793);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(anon_sym_signextend);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(anon_sym_staticcall);
      END_STATE();
    case 782:
      if (lookahead == 'y') ADVANCE(794);
      END_STATE();
    case 783:
      if (lookahead == 'd') ADVANCE(795);
      END_STATE();
    case 784:
      if (lookahead == 'e') ADVANCE(796);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    case 786:
      if (lookahead == 'l') ADVANCE(797);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(anon_sym_extcodecopy);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(anon_sym_extcodehash);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(anon_sym_extcodesize);
      END_STATE();
    case 790:
      if (lookahead == 'o') ADVANCE(798);
      END_STATE();
    case 791:
      if (lookahead == 'i') ADVANCE(799);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(anon_sym_selfbalance);
      END_STATE();
    case 793:
      if (lookahead == 't') ADVANCE(800);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(anon_sym_calldatacopy);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(anon_sym_calldataload);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(anon_sym_calldatasize);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(anon_sym_delegatecall);
      END_STATE();
    case 798:
      if (lookahead == 'p') ADVANCE(801);
      END_STATE();
    case 799:
      if (lookahead == 'z') ADVANCE(802);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(anon_sym_selfdestruct);
      END_STATE();
    case 801:
      if (lookahead == 'y') ADVANCE(803);
      END_STATE();
    case 802:
      if (lookahead == 'e') ADVANCE(804);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(anon_sym_returndatacopy);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(anon_sym_returndatasize);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 51},
  [2] = {.lex_state = 11},
  [3] = {.lex_state = 11},
  [4] = {.lex_state = 11},
  [5] = {.lex_state = 11},
  [6] = {.lex_state = 11},
  [7] = {.lex_state = 11},
  [8] = {.lex_state = 11},
  [9] = {.lex_state = 11},
  [10] = {.lex_state = 11},
  [11] = {.lex_state = 11},
  [12] = {.lex_state = 11},
  [13] = {.lex_state = 11},
  [14] = {.lex_state = 11},
  [15] = {.lex_state = 11},
  [16] = {.lex_state = 11},
  [17] = {.lex_state = 11},
  [18] = {.lex_state = 11},
  [19] = {.lex_state = 11},
  [20] = {.lex_state = 11},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 11},
  [24] = {.lex_state = 11},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 11},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 11},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 11},
  [38] = {.lex_state = 11},
  [39] = {.lex_state = 11},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 11},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 11},
  [44] = {.lex_state = 11},
  [45] = {.lex_state = 11},
  [46] = {.lex_state = 11},
  [47] = {.lex_state = 11},
  [48] = {.lex_state = 11},
  [49] = {.lex_state = 11},
  [50] = {.lex_state = 11},
  [51] = {.lex_state = 11},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 11},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 11},
  [56] = {.lex_state = 11},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 11},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 11},
  [62] = {.lex_state = 11},
  [63] = {.lex_state = 11},
  [64] = {.lex_state = 11},
  [65] = {.lex_state = 11},
  [66] = {.lex_state = 11},
  [67] = {.lex_state = 11},
  [68] = {.lex_state = 11},
  [69] = {.lex_state = 11},
  [70] = {.lex_state = 11},
  [71] = {.lex_state = 11},
  [72] = {.lex_state = 11},
  [73] = {.lex_state = 11},
  [74] = {.lex_state = 11},
  [75] = {.lex_state = 11},
  [76] = {.lex_state = 11},
  [77] = {.lex_state = 11},
  [78] = {.lex_state = 11},
  [79] = {.lex_state = 11},
  [80] = {.lex_state = 11},
  [81] = {.lex_state = 11},
  [82] = {.lex_state = 11},
  [83] = {.lex_state = 11},
  [84] = {.lex_state = 11},
  [85] = {.lex_state = 11},
  [86] = {.lex_state = 11},
  [87] = {.lex_state = 51},
  [88] = {.lex_state = 51},
  [89] = {.lex_state = 11},
  [90] = {.lex_state = 11},
  [91] = {.lex_state = 11},
  [92] = {.lex_state = 11},
  [93] = {.lex_state = 11},
  [94] = {.lex_state = 11},
  [95] = {.lex_state = 51},
  [96] = {.lex_state = 11},
  [97] = {.lex_state = 51},
  [98] = {.lex_state = 11},
  [99] = {.lex_state = 11},
  [100] = {.lex_state = 51},
  [101] = {.lex_state = 11},
  [102] = {.lex_state = 11},
  [103] = {.lex_state = 11},
  [104] = {.lex_state = 11},
  [105] = {.lex_state = 11},
  [106] = {.lex_state = 11},
  [107] = {.lex_state = 11},
  [108] = {.lex_state = 11},
  [109] = {.lex_state = 11},
  [110] = {.lex_state = 11},
  [111] = {.lex_state = 11},
  [112] = {.lex_state = 11},
  [113] = {.lex_state = 11},
  [114] = {.lex_state = 11},
  [115] = {.lex_state = 11},
  [116] = {.lex_state = 11},
  [117] = {.lex_state = 11},
  [118] = {.lex_state = 11},
  [119] = {.lex_state = 11},
  [120] = {.lex_state = 11},
  [121] = {.lex_state = 11},
  [122] = {.lex_state = 11},
  [123] = {.lex_state = 11},
  [124] = {.lex_state = 51},
  [125] = {.lex_state = 51},
  [126] = {.lex_state = 51},
  [127] = {.lex_state = 51},
  [128] = {.lex_state = 51},
  [129] = {.lex_state = 51},
  [130] = {.lex_state = 51},
  [131] = {.lex_state = 51},
  [132] = {.lex_state = 51},
  [133] = {.lex_state = 51},
  [134] = {.lex_state = 51},
  [135] = {.lex_state = 51},
  [136] = {.lex_state = 51},
  [137] = {.lex_state = 51},
  [138] = {.lex_state = 51},
  [139] = {.lex_state = 51},
  [140] = {.lex_state = 51},
  [141] = {.lex_state = 51},
  [142] = {.lex_state = 51},
  [143] = {.lex_state = 51},
  [144] = {.lex_state = 51},
  [145] = {.lex_state = 51},
  [146] = {.lex_state = 51},
  [147] = {.lex_state = 51},
  [148] = {.lex_state = 51},
  [149] = {.lex_state = 51},
  [150] = {.lex_state = 51},
  [151] = {.lex_state = 51},
  [152] = {.lex_state = 51},
  [153] = {.lex_state = 51},
  [154] = {.lex_state = 51},
  [155] = {.lex_state = 51},
  [156] = {.lex_state = 51},
  [157] = {.lex_state = 51},
  [158] = {.lex_state = 51},
  [159] = {.lex_state = 51},
  [160] = {.lex_state = 51},
  [161] = {.lex_state = 51},
  [162] = {.lex_state = 51},
  [163] = {.lex_state = 51},
  [164] = {.lex_state = 51},
  [165] = {.lex_state = 51},
  [166] = {.lex_state = 51},
  [167] = {.lex_state = 51},
  [168] = {.lex_state = 51},
  [169] = {.lex_state = 51},
  [170] = {.lex_state = 51},
  [171] = {.lex_state = 51},
  [172] = {.lex_state = 51},
  [173] = {.lex_state = 51},
  [174] = {.lex_state = 51},
  [175] = {.lex_state = 51},
  [176] = {.lex_state = 51},
  [177] = {.lex_state = 51},
  [178] = {.lex_state = 51},
  [179] = {.lex_state = 51},
  [180] = {.lex_state = 51},
  [181] = {.lex_state = 51},
  [182] = {.lex_state = 51},
  [183] = {.lex_state = 51},
  [184] = {.lex_state = 51},
  [185] = {.lex_state = 51},
  [186] = {.lex_state = 51},
  [187] = {.lex_state = 51},
  [188] = {.lex_state = 51},
  [189] = {.lex_state = 51},
  [190] = {.lex_state = 51},
  [191] = {.lex_state = 51},
  [192] = {.lex_state = 51},
  [193] = {.lex_state = 51},
  [194] = {.lex_state = 51},
  [195] = {.lex_state = 51},
  [196] = {.lex_state = 51},
  [197] = {.lex_state = 51},
  [198] = {.lex_state = 51},
  [199] = {.lex_state = 51},
  [200] = {.lex_state = 51},
  [201] = {.lex_state = 51},
  [202] = {.lex_state = 51},
  [203] = {.lex_state = 51},
  [204] = {.lex_state = 51},
  [205] = {.lex_state = 51},
  [206] = {.lex_state = 51},
  [207] = {.lex_state = 51},
  [208] = {.lex_state = 51},
  [209] = {.lex_state = 51},
  [210] = {.lex_state = 51},
  [211] = {.lex_state = 51},
  [212] = {.lex_state = 51},
  [213] = {.lex_state = 51},
  [214] = {.lex_state = 51},
  [215] = {.lex_state = 51},
  [216] = {.lex_state = 51},
  [217] = {.lex_state = 51},
  [218] = {.lex_state = 51},
  [219] = {.lex_state = 51},
  [220] = {.lex_state = 51},
  [221] = {.lex_state = 51},
  [222] = {.lex_state = 51},
  [223] = {.lex_state = 51},
  [224] = {.lex_state = 51},
  [225] = {.lex_state = 51},
  [226] = {.lex_state = 51},
  [227] = {.lex_state = 51},
  [228] = {.lex_state = 51},
  [229] = {.lex_state = 51},
  [230] = {.lex_state = 51},
  [231] = {.lex_state = 51},
  [232] = {.lex_state = 51},
  [233] = {.lex_state = 51},
  [234] = {.lex_state = 51},
  [235] = {.lex_state = 51},
  [236] = {.lex_state = 51},
  [237] = {.lex_state = 51},
  [238] = {.lex_state = 51},
  [239] = {.lex_state = 51},
  [240] = {.lex_state = 51},
  [241] = {.lex_state = 51},
  [242] = {.lex_state = 51},
  [243] = {.lex_state = 51},
  [244] = {.lex_state = 51},
  [245] = {.lex_state = 51},
  [246] = {.lex_state = 51},
  [247] = {.lex_state = 51},
  [248] = {.lex_state = 51},
  [249] = {.lex_state = 51},
  [250] = {.lex_state = 51},
  [251] = {.lex_state = 51},
  [252] = {.lex_state = 51},
  [253] = {.lex_state = 51},
  [254] = {.lex_state = 51},
  [255] = {.lex_state = 51},
  [256] = {.lex_state = 51},
  [257] = {.lex_state = 51},
  [258] = {.lex_state = 51},
  [259] = {.lex_state = 51},
  [260] = {.lex_state = 51},
  [261] = {.lex_state = 51},
  [262] = {.lex_state = 51},
  [263] = {.lex_state = 51},
  [264] = {.lex_state = 51},
  [265] = {.lex_state = 51},
  [266] = {.lex_state = 51},
  [267] = {.lex_state = 51},
  [268] = {.lex_state = 51},
  [269] = {.lex_state = 51},
  [270] = {.lex_state = 51},
  [271] = {.lex_state = 51},
  [272] = {.lex_state = 51},
  [273] = {.lex_state = 51},
  [274] = {.lex_state = 51},
  [275] = {.lex_state = 51},
  [276] = {.lex_state = 51},
  [277] = {.lex_state = 51},
  [278] = {.lex_state = 51},
  [279] = {.lex_state = 51},
  [280] = {.lex_state = 51},
  [281] = {.lex_state = 51},
  [282] = {.lex_state = 51},
  [283] = {.lex_state = 51},
  [284] = {.lex_state = 51},
  [285] = {.lex_state = 51},
  [286] = {.lex_state = 51},
  [287] = {.lex_state = 51},
  [288] = {.lex_state = 51},
  [289] = {.lex_state = 51},
  [290] = {.lex_state = 51},
  [291] = {.lex_state = 51},
  [292] = {.lex_state = 51},
  [293] = {.lex_state = 51},
  [294] = {.lex_state = 51},
  [295] = {.lex_state = 51},
  [296] = {.lex_state = 51},
  [297] = {.lex_state = 51},
  [298] = {.lex_state = 51},
  [299] = {.lex_state = 51},
  [300] = {.lex_state = 51},
  [301] = {.lex_state = 51},
  [302] = {.lex_state = 51},
  [303] = {.lex_state = 51},
  [304] = {.lex_state = 51},
  [305] = {.lex_state = 51},
  [306] = {.lex_state = 51},
  [307] = {.lex_state = 51},
  [308] = {.lex_state = 51},
  [309] = {.lex_state = 51},
  [310] = {.lex_state = 51},
  [311] = {.lex_state = 51},
  [312] = {.lex_state = 51},
  [313] = {.lex_state = 51},
  [314] = {.lex_state = 51},
  [315] = {.lex_state = 51},
  [316] = {.lex_state = 51},
  [317] = {.lex_state = 51},
  [318] = {.lex_state = 51},
  [319] = {.lex_state = 51},
  [320] = {.lex_state = 51},
  [321] = {.lex_state = 51},
  [322] = {.lex_state = 51},
  [323] = {.lex_state = 51},
  [324] = {.lex_state = 51},
  [325] = {.lex_state = 10},
  [326] = {.lex_state = 9},
  [327] = {.lex_state = 10},
  [328] = {.lex_state = 9},
  [329] = {.lex_state = 9},
  [330] = {.lex_state = 9},
  [331] = {.lex_state = 9},
  [332] = {.lex_state = 9},
  [333] = {.lex_state = 9},
  [334] = {.lex_state = 9},
  [335] = {.lex_state = 9},
  [336] = {.lex_state = 10},
  [337] = {.lex_state = 10},
  [338] = {.lex_state = 10},
  [339] = {.lex_state = 10},
  [340] = {.lex_state = 9},
  [341] = {.lex_state = 9},
  [342] = {.lex_state = 9},
  [343] = {.lex_state = 9},
  [344] = {.lex_state = 9},
  [345] = {.lex_state = 9},
  [346] = {.lex_state = 9},
  [347] = {.lex_state = 9},
  [348] = {.lex_state = 9},
  [349] = {.lex_state = 9},
  [350] = {.lex_state = 9},
  [351] = {.lex_state = 9},
  [352] = {.lex_state = 9},
  [353] = {.lex_state = 9},
  [354] = {.lex_state = 9},
  [355] = {.lex_state = 9},
  [356] = {.lex_state = 9},
  [357] = {.lex_state = 9},
  [358] = {.lex_state = 9},
  [359] = {.lex_state = 9},
  [360] = {.lex_state = 9},
  [361] = {.lex_state = 9},
  [362] = {.lex_state = 9},
  [363] = {.lex_state = 9},
  [364] = {.lex_state = 9},
  [365] = {.lex_state = 9},
  [366] = {.lex_state = 9},
  [367] = {.lex_state = 9},
  [368] = {.lex_state = 9},
  [369] = {.lex_state = 9},
  [370] = {.lex_state = 9},
  [371] = {.lex_state = 9},
  [372] = {.lex_state = 9},
  [373] = {.lex_state = 9},
  [374] = {.lex_state = 9},
  [375] = {.lex_state = 9},
  [376] = {.lex_state = 9},
  [377] = {.lex_state = 9},
  [378] = {.lex_state = 9},
  [379] = {.lex_state = 9},
  [380] = {.lex_state = 9},
  [381] = {.lex_state = 9},
  [382] = {.lex_state = 9},
  [383] = {.lex_state = 9},
  [384] = {.lex_state = 9},
  [385] = {.lex_state = 9},
  [386] = {.lex_state = 9},
  [387] = {.lex_state = 9},
  [388] = {.lex_state = 9},
  [389] = {.lex_state = 9},
  [390] = {.lex_state = 9},
  [391] = {.lex_state = 9},
  [392] = {.lex_state = 9},
  [393] = {.lex_state = 9},
  [394] = {.lex_state = 9},
  [395] = {.lex_state = 9},
  [396] = {.lex_state = 9},
  [397] = {.lex_state = 9},
  [398] = {.lex_state = 9},
  [399] = {.lex_state = 9},
  [400] = {.lex_state = 9},
  [401] = {.lex_state = 9},
  [402] = {.lex_state = 9},
  [403] = {.lex_state = 51},
  [404] = {.lex_state = 9},
  [405] = {.lex_state = 9},
  [406] = {.lex_state = 9},
  [407] = {.lex_state = 9},
  [408] = {.lex_state = 9},
  [409] = {.lex_state = 9},
  [410] = {.lex_state = 9},
  [411] = {.lex_state = 9},
  [412] = {.lex_state = 9},
  [413] = {.lex_state = 9},
  [414] = {.lex_state = 9},
  [415] = {.lex_state = 9},
  [416] = {.lex_state = 9},
  [417] = {.lex_state = 9},
  [418] = {.lex_state = 9},
  [419] = {.lex_state = 9},
  [420] = {.lex_state = 9},
  [421] = {.lex_state = 9},
  [422] = {.lex_state = 9},
  [423] = {.lex_state = 9},
  [424] = {.lex_state = 9},
  [425] = {.lex_state = 9},
  [426] = {.lex_state = 9},
  [427] = {.lex_state = 51},
  [428] = {.lex_state = 9},
  [429] = {.lex_state = 51},
  [430] = {.lex_state = 51},
  [431] = {.lex_state = 51},
  [432] = {.lex_state = 51},
  [433] = {.lex_state = 51},
  [434] = {.lex_state = 51},
  [435] = {.lex_state = 51},
  [436] = {.lex_state = 51},
  [437] = {.lex_state = 51},
  [438] = {.lex_state = 51},
  [439] = {.lex_state = 51},
  [440] = {.lex_state = 51},
  [441] = {.lex_state = 51},
  [442] = {.lex_state = 51},
  [443] = {.lex_state = 51},
  [444] = {.lex_state = 51},
  [445] = {.lex_state = 9},
  [446] = {.lex_state = 51},
  [447] = {.lex_state = 51},
  [448] = {.lex_state = 51},
  [449] = {.lex_state = 51},
  [450] = {.lex_state = 51},
  [451] = {.lex_state = 51},
  [452] = {.lex_state = 51},
  [453] = {.lex_state = 51},
  [454] = {.lex_state = 51},
  [455] = {.lex_state = 9},
  [456] = {.lex_state = 51},
  [457] = {.lex_state = 51},
  [458] = {.lex_state = 51},
  [459] = {.lex_state = 51},
  [460] = {.lex_state = 51},
  [461] = {.lex_state = 51},
  [462] = {.lex_state = 51},
  [463] = {.lex_state = 51},
  [464] = {.lex_state = 51},
  [465] = {.lex_state = 51},
  [466] = {.lex_state = 51},
  [467] = {.lex_state = 51},
  [468] = {.lex_state = 51},
  [469] = {.lex_state = 51},
  [470] = {.lex_state = 51},
  [471] = {.lex_state = 51},
  [472] = {.lex_state = 51},
  [473] = {.lex_state = 16},
  [474] = {.lex_state = 16},
  [475] = {.lex_state = 51},
  [476] = {.lex_state = 51},
  [477] = {.lex_state = 51},
  [478] = {.lex_state = 51},
  [479] = {.lex_state = 51},
  [480] = {.lex_state = 51},
  [481] = {.lex_state = 51},
  [482] = {.lex_state = 51},
  [483] = {.lex_state = 51},
  [484] = {.lex_state = 51},
  [485] = {.lex_state = 51},
  [486] = {.lex_state = 51},
  [487] = {.lex_state = 51},
  [488] = {.lex_state = 51},
  [489] = {.lex_state = 51},
  [490] = {.lex_state = 51},
  [491] = {.lex_state = 51},
  [492] = {.lex_state = 51},
  [493] = {.lex_state = 51},
  [494] = {.lex_state = 5},
  [495] = {.lex_state = 5},
  [496] = {.lex_state = 5},
  [497] = {.lex_state = 5},
  [498] = {.lex_state = 5},
  [499] = {.lex_state = 51},
  [500] = {.lex_state = 51},
  [501] = {.lex_state = 51},
  [502] = {.lex_state = 51},
  [503] = {.lex_state = 51},
  [504] = {.lex_state = 51},
  [505] = {.lex_state = 5},
  [506] = {.lex_state = 51},
  [507] = {.lex_state = 51},
  [508] = {.lex_state = 51},
  [509] = {.lex_state = 51},
  [510] = {.lex_state = 51},
  [511] = {.lex_state = 51},
  [512] = {.lex_state = 51},
  [513] = {.lex_state = 51},
  [514] = {.lex_state = 51},
  [515] = {.lex_state = 51},
  [516] = {.lex_state = 1},
  [517] = {.lex_state = 51},
  [518] = {.lex_state = 51},
  [519] = {.lex_state = 51},
  [520] = {.lex_state = 12},
  [521] = {.lex_state = 1},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 1},
  [525] = {.lex_state = 3},
  [526] = {.lex_state = 51},
  [527] = {.lex_state = 51},
  [528] = {.lex_state = 1},
  [529] = {.lex_state = 3},
  [530] = {.lex_state = 1},
  [531] = {.lex_state = 3},
  [532] = {.lex_state = 12},
  [533] = {.lex_state = 0},
  [534] = {.lex_state = 51},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 0},
  [537] = {.lex_state = 3},
  [538] = {.lex_state = 51},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 51},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 51},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 51},
  [545] = {.lex_state = 12},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 51},
  [548] = {.lex_state = 51},
  [549] = {.lex_state = 0},
  [550] = {.lex_state = 12},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 51},
  [553] = {.lex_state = 1},
  [554] = {.lex_state = 10},
  [555] = {.lex_state = 3},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 1},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 12},
  [560] = {.lex_state = 51},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 51},
  [563] = {.lex_state = 51},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 1},
  [567] = {.lex_state = 51},
  [568] = {.lex_state = 51},
  [569] = {.lex_state = 3},
  [570] = {.lex_state = 51},
  [571] = {.lex_state = 51},
  [572] = {.lex_state = 51},
  [573] = {.lex_state = 12},
  [574] = {.lex_state = 51},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 51},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 51},
  [580] = {.lex_state = 51},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 51},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 51},
  [586] = {.lex_state = 51},
  [587] = {.lex_state = 51},
  [588] = {.lex_state = 51},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 51},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 51},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 51},
  [602] = {.lex_state = 51},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 51},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 51},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 51},
  [610] = {.lex_state = 51},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 51},
  [613] = {.lex_state = 51},
  [614] = {.lex_state = 51},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 51},
  [617] = {.lex_state = 51},
  [618] = {.lex_state = 51},
  [619] = {.lex_state = 51},
  [620] = {.lex_state = 51},
  [621] = {.lex_state = 51},
  [622] = {.lex_state = 51},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 16},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 51},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 51},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 51},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 51},
  [639] = {.lex_state = 16},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 51},
  [643] = {.lex_state = 51},
  [644] = {.lex_state = 51},
  [645] = {.lex_state = 51},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 16},
  [648] = {.lex_state = 51},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 16},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 51},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 51},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 51},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 51},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 51},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 51},
  [676] = {.lex_state = 51},
  [677] = {.lex_state = 51},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 51},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 51},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 51},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 51},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 51},
  [701] = {.lex_state = 51},
  [702] = {.lex_state = 51},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 51},
  [705] = {.lex_state = 0},
  [706] = {.lex_state = 51},
  [707] = {.lex_state = 0},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 16},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 51},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 0},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 51},
  [725] = {.lex_state = 0},
  [726] = {.lex_state = 51},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 51},
  [729] = {.lex_state = 0},
  [730] = {.lex_state = 51},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 51},
  [739] = {.lex_state = 0},
  [740] = {.lex_state = 51},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 51},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 51},
  [750] = {.lex_state = 0},
  [751] = {.lex_state = 51},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 51},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 0},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 51},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 0},
  [777] = {.lex_state = 0},
  [778] = {.lex_state = 0},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 51},
  [783] = {.lex_state = 51},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 51},
  [789] = {.lex_state = 51},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 51},
  [792] = {.lex_state = 23},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 0},
  [795] = {.lex_state = 51},
  [796] = {.lex_state = 0},
  [797] = {.lex_state = 12},
  [798] = {.lex_state = 12},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 51},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 51},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 51},
  [807] = {.lex_state = 11},
  [808] = {.lex_state = 51},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 5},
  [811] = {.lex_state = 51},
  [812] = {.lex_state = 51},
  [813] = {.lex_state = 51},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 11},
  [817] = {.lex_state = 51},
  [818] = {.lex_state = 51},
  [819] = {.lex_state = 51},
  [820] = {.lex_state = 51},
  [821] = {.lex_state = 51},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 51},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 51},
  [826] = {.lex_state = 51},
  [827] = {.lex_state = 51},
  [828] = {.lex_state = 51},
  [829] = {.lex_state = 51},
  [830] = {.lex_state = 5},
  [831] = {.lex_state = 51},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 11},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 51},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 51},
  [842] = {.lex_state = 51},
  [843] = {.lex_state = 51},
  [844] = {.lex_state = 0},
  [845] = {.lex_state = 51},
  [846] = {.lex_state = 51},
  [847] = {.lex_state = 51},
  [848] = {.lex_state = 51},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 51},
  [852] = {.lex_state = 51},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 12},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 51},
  [857] = {.lex_state = 51},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 51},
  [861] = {.lex_state = 51},
  [862] = {.lex_state = 51},
  [863] = {.lex_state = 51},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 51},
  [866] = {.lex_state = 51},
  [867] = {.lex_state = 51},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 51},
  [870] = {.lex_state = 51},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 51},
  [873] = {.lex_state = 51},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 51},
  [880] = {.lex_state = 51},
  [881] = {.lex_state = 51},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_pragma] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_solidity] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_constant] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_contract] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_library] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_anonymous] = ACTIONS(1),
    [anon_sym_indexed] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_yul_leave] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_yul_decimal_number] = ACTIONS(1),
    [sym_yul_hex_number] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_stop] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_div] = ACTIONS(1),
    [anon_sym_sdiv] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_smod] = ACTIONS(1),
    [anon_sym_exp] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_lt] = ACTIONS(1),
    [anon_sym_gt] = ACTIONS(1),
    [anon_sym_slt] = ACTIONS(1),
    [anon_sym_sgt] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_iszero] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_shr] = ACTIONS(1),
    [anon_sym_sar] = ACTIONS(1),
    [anon_sym_addmod] = ACTIONS(1),
    [anon_sym_mulmod] = ACTIONS(1),
    [anon_sym_signextend] = ACTIONS(1),
    [anon_sym_keccak256] = ACTIONS(1),
    [anon_sym_pop] = ACTIONS(1),
    [anon_sym_mload] = ACTIONS(1),
    [anon_sym_mcopy] = ACTIONS(1),
    [anon_sym_tload] = ACTIONS(1),
    [anon_sym_tstore] = ACTIONS(1),
    [anon_sym_mstore] = ACTIONS(1),
    [anon_sym_mstore8] = ACTIONS(1),
    [anon_sym_sload] = ACTIONS(1),
    [anon_sym_sstore] = ACTIONS(1),
    [anon_sym_msize] = ACTIONS(1),
    [anon_sym_gas] = ACTIONS(1),
    [anon_sym_address] = ACTIONS(1),
    [anon_sym_balance] = ACTIONS(1),
    [anon_sym_selfbalance] = ACTIONS(1),
    [anon_sym_caller] = ACTIONS(1),
    [anon_sym_callvalue] = ACTIONS(1),
    [anon_sym_calldataload] = ACTIONS(1),
    [anon_sym_calldatasize] = ACTIONS(1),
    [anon_sym_calldatacopy] = ACTIONS(1),
    [anon_sym_extcodesize] = ACTIONS(1),
    [anon_sym_extcodecopy] = ACTIONS(1),
    [anon_sym_returndatasize] = ACTIONS(1),
    [anon_sym_returndatacopy] = ACTIONS(1),
    [anon_sym_extcodehash] = ACTIONS(1),
    [anon_sym_create] = ACTIONS(1),
    [anon_sym_create2] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [anon_sym_callcode] = ACTIONS(1),
    [anon_sym_delegatecall] = ACTIONS(1),
    [anon_sym_staticcall] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_revert] = ACTIONS(1),
    [anon_sym_selfdestruct] = ACTIONS(1),
    [anon_sym_invalid] = ACTIONS(1),
    [anon_sym_log0] = ACTIONS(1),
    [anon_sym_log1] = ACTIONS(1),
    [anon_sym_log2] = ACTIONS(1),
    [anon_sym_log3] = ACTIONS(1),
    [anon_sym_log4] = ACTIONS(1),
    [anon_sym_chainid] = ACTIONS(1),
    [anon_sym_origin] = ACTIONS(1),
    [anon_sym_gasprice] = ACTIONS(1),
    [anon_sym_blockhash] = ACTIONS(1),
    [anon_sym_blobhash] = ACTIONS(1),
    [anon_sym_basefee] = ACTIONS(1),
    [anon_sym_blobfee] = ACTIONS(1),
    [anon_sym_coinbase] = ACTIONS(1),
    [anon_sym_timestamp] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_difficulty] = ACTIONS(1),
    [anon_sym_gaslimit] = ACTIONS(1),
    [sym_unchecked] = ACTIONS(1),
    [anon_sym_memory] = ACTIONS(1),
    [anon_sym_storage] = ACTIONS(1),
    [anon_sym_calldata] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_returns] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_emit] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_pure] = ACTIONS(1),
    [anon_sym_view] = ACTIONS(1),
    [anon_sym_payable] = ACTIONS(1),
    [anon_sym_transient] = ACTIONS(1),
    [sym_immutable] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_modifier] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_fallback] = ACTIONS(1),
    [anon_sym_receive] = ACTIONS(1),
    [sym_virtual] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_mapping] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_int8] = ACTIONS(1),
    [anon_sym_int16] = ACTIONS(1),
    [anon_sym_int24] = ACTIONS(1),
    [anon_sym_int32] = ACTIONS(1),
    [anon_sym_int40] = ACTIONS(1),
    [anon_sym_int48] = ACTIONS(1),
    [anon_sym_int56] = ACTIONS(1),
    [anon_sym_int64] = ACTIONS(1),
    [anon_sym_int72] = ACTIONS(1),
    [anon_sym_int80] = ACTIONS(1),
    [anon_sym_int88] = ACTIONS(1),
    [anon_sym_int96] = ACTIONS(1),
    [anon_sym_int104] = ACTIONS(1),
    [anon_sym_int112] = ACTIONS(1),
    [anon_sym_int120] = ACTIONS(1),
    [anon_sym_int128] = ACTIONS(1),
    [anon_sym_int136] = ACTIONS(1),
    [anon_sym_int144] = ACTIONS(1),
    [anon_sym_int152] = ACTIONS(1),
    [anon_sym_int160] = ACTIONS(1),
    [anon_sym_int168] = ACTIONS(1),
    [anon_sym_int176] = ACTIONS(1),
    [anon_sym_int184] = ACTIONS(1),
    [anon_sym_int192] = ACTIONS(1),
    [anon_sym_int200] = ACTIONS(1),
    [anon_sym_int208] = ACTIONS(1),
    [anon_sym_int216] = ACTIONS(1),
    [anon_sym_int224] = ACTIONS(1),
    [anon_sym_int232] = ACTIONS(1),
    [anon_sym_int240] = ACTIONS(1),
    [anon_sym_int248] = ACTIONS(1),
    [anon_sym_int256] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_uint8] = ACTIONS(1),
    [anon_sym_uint16] = ACTIONS(1),
    [anon_sym_uint24] = ACTIONS(1),
    [anon_sym_uint32] = ACTIONS(1),
    [anon_sym_uint40] = ACTIONS(1),
    [anon_sym_uint48] = ACTIONS(1),
    [anon_sym_uint56] = ACTIONS(1),
    [anon_sym_uint64] = ACTIONS(1),
    [anon_sym_uint72] = ACTIONS(1),
    [anon_sym_uint80] = ACTIONS(1),
    [anon_sym_uint88] = ACTIONS(1),
    [anon_sym_uint96] = ACTIONS(1),
    [anon_sym_uint104] = ACTIONS(1),
    [anon_sym_uint112] = ACTIONS(1),
    [anon_sym_uint120] = ACTIONS(1),
    [anon_sym_uint128] = ACTIONS(1),
    [anon_sym_uint136] = ACTIONS(1),
    [anon_sym_uint144] = ACTIONS(1),
    [anon_sym_uint152] = ACTIONS(1),
    [anon_sym_uint160] = ACTIONS(1),
    [anon_sym_uint168] = ACTIONS(1),
    [anon_sym_uint176] = ACTIONS(1),
    [anon_sym_uint184] = ACTIONS(1),
    [anon_sym_uint192] = ACTIONS(1),
    [anon_sym_uint200] = ACTIONS(1),
    [anon_sym_uint208] = ACTIONS(1),
    [anon_sym_uint216] = ACTIONS(1),
    [anon_sym_uint224] = ACTIONS(1),
    [anon_sym_uint232] = ACTIONS(1),
    [anon_sym_uint240] = ACTIONS(1),
    [anon_sym_uint248] = ACTIONS(1),
    [anon_sym_uint256] = ACTIONS(1),
    [anon_sym_bytes] = ACTIONS(1),
    [anon_sym_bytes1] = ACTIONS(1),
    [anon_sym_bytes2] = ACTIONS(1),
    [anon_sym_bytes3] = ACTIONS(1),
    [anon_sym_bytes4] = ACTIONS(1),
    [anon_sym_bytes5] = ACTIONS(1),
    [anon_sym_bytes6] = ACTIONS(1),
    [anon_sym_bytes7] = ACTIONS(1),
    [anon_sym_bytes8] = ACTIONS(1),
    [anon_sym_bytes9] = ACTIONS(1),
    [anon_sym_bytes10] = ACTIONS(1),
    [anon_sym_bytes11] = ACTIONS(1),
    [anon_sym_bytes12] = ACTIONS(1),
    [anon_sym_bytes13] = ACTIONS(1),
    [anon_sym_bytes14] = ACTIONS(1),
    [anon_sym_bytes15] = ACTIONS(1),
    [anon_sym_bytes16] = ACTIONS(1),
    [anon_sym_bytes17] = ACTIONS(1),
    [anon_sym_bytes18] = ACTIONS(1),
    [anon_sym_bytes19] = ACTIONS(1),
    [anon_sym_bytes20] = ACTIONS(1),
    [anon_sym_bytes21] = ACTIONS(1),
    [anon_sym_bytes22] = ACTIONS(1),
    [anon_sym_bytes23] = ACTIONS(1),
    [anon_sym_bytes24] = ACTIONS(1),
    [anon_sym_bytes25] = ACTIONS(1),
    [anon_sym_bytes26] = ACTIONS(1),
    [anon_sym_bytes27] = ACTIONS(1),
    [anon_sym_bytes28] = ACTIONS(1),
    [anon_sym_bytes29] = ACTIONS(1),
    [anon_sym_bytes30] = ACTIONS(1),
    [anon_sym_bytes31] = ACTIONS(1),
    [anon_sym_bytes32] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [aux_sym__fixed_token1] = ACTIONS(1),
    [anon_sym_ufixed] = ACTIONS(1),
    [aux_sym__ufixed_token1] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_wei] = ACTIONS(1),
    [anon_sym_szabo] = ACTIONS(1),
    [anon_sym_finney] = ACTIONS(1),
    [anon_sym_gwei] = ACTIONS(1),
    [anon_sym_ether] = ACTIONS(1),
    [anon_sym_seconds] = ACTIONS(1),
    [anon_sym_minutes] = ACTIONS(1),
    [anon_sym_hours] = ACTIONS(1),
    [anon_sym_days] = ACTIONS(1),
    [anon_sym_weeks] = ACTIONS(1),
    [anon_sym_years] = ACTIONS(1),
    [anon_sym_hex] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym__escape_sequence] = ACTIONS(1),
    [anon_sym_unicode] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(839),
    [sym__source_unit] = STATE(88),
    [sym__directive] = STATE(88),
    [sym_pragma_directive] = STATE(88),
    [sym_import_directive] = STATE(88),
    [sym__declaration] = STATE(88),
    [sym_user_defined_type_definition] = STATE(88),
    [sym_constant_variable_declaration] = STATE(88),
    [sym_contract_declaration] = STATE(88),
    [sym_error_declaration] = STATE(88),
    [sym_interface_declaration] = STATE(88),
    [sym_library_declaration] = STATE(88),
    [sym_struct_declaration] = STATE(88),
    [sym_enum_declaration] = STATE(88),
    [sym_event_definition] = STATE(88),
    [sym_function_definition] = STATE(88),
    [sym_type_name] = STATE(789),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_source_file_repeat1] = STATE(88),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pragma] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_contract] = ACTIONS(17),
    [anon_sym_error] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_library] = ACTIONS(23),
    [anon_sym_struct] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_event] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_statement] = STATE(6),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_struct_field_assignment] = STATE(625),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(6),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(47),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_statement] = STATE(7),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(107),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_statement] = STATE(8),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(8),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_statement] = STATE(6),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(6),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_statement] = STATE(7),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_statement] = STATE(7),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(118),
    [anon_sym_TILDE] = ACTIONS(121),
    [anon_sym_LBRACE] = ACTIONS(124),
    [anon_sym_RBRACE] = ACTIONS(127),
    [anon_sym_type] = ACTIONS(129),
    [anon_sym_LPAREN] = ACTIONS(132),
    [anon_sym_for] = ACTIONS(135),
    [anon_sym_assembly] = ACTIONS(138),
    [anon_sym_break] = ACTIONS(141),
    [anon_sym_continue] = ACTIONS(144),
    [anon_sym_true] = ACTIONS(147),
    [anon_sym_false] = ACTIONS(150),
    [anon_sym_if] = ACTIONS(153),
    [anon_sym_function] = ACTIONS(156),
    [anon_sym_byte] = ACTIONS(159),
    [anon_sym_address] = ACTIONS(162),
    [anon_sym_return] = ACTIONS(165),
    [anon_sym_revert] = ACTIONS(168),
    [sym_unchecked] = ACTIONS(171),
    [anon_sym_var] = ACTIONS(174),
    [anon_sym_while] = ACTIONS(177),
    [anon_sym_do] = ACTIONS(180),
    [anon_sym_try] = ACTIONS(183),
    [anon_sym_emit] = ACTIONS(186),
    [anon_sym_payable] = ACTIONS(189),
    [anon_sym_new] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_delete] = ACTIONS(118),
    [anon_sym_BANG] = ACTIONS(121),
    [anon_sym_PLUS_PLUS] = ACTIONS(198),
    [anon_sym_DASH_DASH] = ACTIONS(198),
    [anon_sym_mapping] = ACTIONS(201),
    [anon_sym_bool] = ACTIONS(159),
    [anon_sym_string] = ACTIONS(159),
    [anon_sym_int] = ACTIONS(159),
    [anon_sym_int8] = ACTIONS(159),
    [anon_sym_int16] = ACTIONS(159),
    [anon_sym_int24] = ACTIONS(159),
    [anon_sym_int32] = ACTIONS(159),
    [anon_sym_int40] = ACTIONS(159),
    [anon_sym_int48] = ACTIONS(159),
    [anon_sym_int56] = ACTIONS(159),
    [anon_sym_int64] = ACTIONS(159),
    [anon_sym_int72] = ACTIONS(159),
    [anon_sym_int80] = ACTIONS(159),
    [anon_sym_int88] = ACTIONS(159),
    [anon_sym_int96] = ACTIONS(159),
    [anon_sym_int104] = ACTIONS(159),
    [anon_sym_int112] = ACTIONS(159),
    [anon_sym_int120] = ACTIONS(159),
    [anon_sym_int128] = ACTIONS(159),
    [anon_sym_int136] = ACTIONS(159),
    [anon_sym_int144] = ACTIONS(159),
    [anon_sym_int152] = ACTIONS(159),
    [anon_sym_int160] = ACTIONS(159),
    [anon_sym_int168] = ACTIONS(159),
    [anon_sym_int176] = ACTIONS(159),
    [anon_sym_int184] = ACTIONS(159),
    [anon_sym_int192] = ACTIONS(159),
    [anon_sym_int200] = ACTIONS(159),
    [anon_sym_int208] = ACTIONS(159),
    [anon_sym_int216] = ACTIONS(159),
    [anon_sym_int224] = ACTIONS(159),
    [anon_sym_int232] = ACTIONS(159),
    [anon_sym_int240] = ACTIONS(159),
    [anon_sym_int248] = ACTIONS(159),
    [anon_sym_int256] = ACTIONS(159),
    [anon_sym_uint] = ACTIONS(159),
    [anon_sym_uint8] = ACTIONS(159),
    [anon_sym_uint16] = ACTIONS(159),
    [anon_sym_uint24] = ACTIONS(159),
    [anon_sym_uint32] = ACTIONS(159),
    [anon_sym_uint40] = ACTIONS(159),
    [anon_sym_uint48] = ACTIONS(159),
    [anon_sym_uint56] = ACTIONS(159),
    [anon_sym_uint64] = ACTIONS(159),
    [anon_sym_uint72] = ACTIONS(159),
    [anon_sym_uint80] = ACTIONS(159),
    [anon_sym_uint88] = ACTIONS(159),
    [anon_sym_uint96] = ACTIONS(159),
    [anon_sym_uint104] = ACTIONS(159),
    [anon_sym_uint112] = ACTIONS(159),
    [anon_sym_uint120] = ACTIONS(159),
    [anon_sym_uint128] = ACTIONS(159),
    [anon_sym_uint136] = ACTIONS(159),
    [anon_sym_uint144] = ACTIONS(159),
    [anon_sym_uint152] = ACTIONS(159),
    [anon_sym_uint160] = ACTIONS(159),
    [anon_sym_uint168] = ACTIONS(159),
    [anon_sym_uint176] = ACTIONS(159),
    [anon_sym_uint184] = ACTIONS(159),
    [anon_sym_uint192] = ACTIONS(159),
    [anon_sym_uint200] = ACTIONS(159),
    [anon_sym_uint208] = ACTIONS(159),
    [anon_sym_uint216] = ACTIONS(159),
    [anon_sym_uint224] = ACTIONS(159),
    [anon_sym_uint232] = ACTIONS(159),
    [anon_sym_uint240] = ACTIONS(159),
    [anon_sym_uint248] = ACTIONS(159),
    [anon_sym_uint256] = ACTIONS(159),
    [anon_sym_bytes] = ACTIONS(159),
    [anon_sym_bytes1] = ACTIONS(159),
    [anon_sym_bytes2] = ACTIONS(159),
    [anon_sym_bytes3] = ACTIONS(159),
    [anon_sym_bytes4] = ACTIONS(159),
    [anon_sym_bytes5] = ACTIONS(159),
    [anon_sym_bytes6] = ACTIONS(159),
    [anon_sym_bytes7] = ACTIONS(159),
    [anon_sym_bytes8] = ACTIONS(159),
    [anon_sym_bytes9] = ACTIONS(159),
    [anon_sym_bytes10] = ACTIONS(159),
    [anon_sym_bytes11] = ACTIONS(159),
    [anon_sym_bytes12] = ACTIONS(159),
    [anon_sym_bytes13] = ACTIONS(159),
    [anon_sym_bytes14] = ACTIONS(159),
    [anon_sym_bytes15] = ACTIONS(159),
    [anon_sym_bytes16] = ACTIONS(159),
    [anon_sym_bytes17] = ACTIONS(159),
    [anon_sym_bytes18] = ACTIONS(159),
    [anon_sym_bytes19] = ACTIONS(159),
    [anon_sym_bytes20] = ACTIONS(159),
    [anon_sym_bytes21] = ACTIONS(159),
    [anon_sym_bytes22] = ACTIONS(159),
    [anon_sym_bytes23] = ACTIONS(159),
    [anon_sym_bytes24] = ACTIONS(159),
    [anon_sym_bytes25] = ACTIONS(159),
    [anon_sym_bytes26] = ACTIONS(159),
    [anon_sym_bytes27] = ACTIONS(159),
    [anon_sym_bytes28] = ACTIONS(159),
    [anon_sym_bytes29] = ACTIONS(159),
    [anon_sym_bytes30] = ACTIONS(159),
    [anon_sym_bytes31] = ACTIONS(159),
    [anon_sym_bytes32] = ACTIONS(159),
    [anon_sym_fixed] = ACTIONS(159),
    [aux_sym__fixed_token1] = ACTIONS(159),
    [anon_sym_ufixed] = ACTIONS(159),
    [aux_sym__ufixed_token1] = ACTIONS(159),
    [aux_sym__decimal_number_token1] = ACTIONS(204),
    [aux_sym__decimal_number_token2] = ACTIONS(207),
    [aux_sym__hex_number_token1] = ACTIONS(207),
    [anon_sym_hex] = ACTIONS(210),
    [anon_sym_DQUOTE] = ACTIONS(213),
    [anon_sym_SQUOTE] = ACTIONS(216),
    [anon_sym_unicode] = ACTIONS(219),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_statement] = STATE(7),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(222),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_statement] = STATE(10),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(10),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(113),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_statement] = STATE(7),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(224),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_statement] = STATE(3),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_block_statement_repeat1] = STATE(3),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(226),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_statement] = STATE(879),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_statement] = STATE(826),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_statement] = STATE(114),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_statement] = STATE(116),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_statement] = STATE(118),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_statement] = STATE(115),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_statement] = STATE(795),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_statement] = STATE(119),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_statement] = STATE(115),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_statement] = STATE(118),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_statement] = STATE(116),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_statement] = STATE(119),
    [sym_assembly_statement] = STATE(109),
    [sym_block_statement] = STATE(109),
    [sym_variable_declaration_statement] = STATE(109),
    [sym_variable_declaration] = STATE(670),
    [sym_variable_declaration_tuple] = STATE(867),
    [sym_expression_statement] = STATE(109),
    [sym_if_statement] = STATE(109),
    [sym_for_statement] = STATE(109),
    [sym_while_statement] = STATE(109),
    [sym_do_while_statement] = STATE(109),
    [sym_continue_statement] = STATE(109),
    [sym_break_statement] = STATE(109),
    [sym_revert_statement] = STATE(109),
    [sym_try_statement] = STATE(109),
    [sym_return_statement] = STATE(109),
    [sym_emit_statement] = STATE(109),
    [sym_expression] = STATE(446),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(228),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(230),
    [anon_sym_continue] = ACTIONS(232),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(234),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(236),
    [anon_sym_revert] = ACTIONS(238),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(240),
    [anon_sym_do] = ACTIONS(242),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(244),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_variable_declaration_statement] = STATE(34),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(34),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(34),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(246),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_variable_declaration_statement] = STATE(36),
    [sym_variable_declaration] = STATE(580),
    [sym_variable_declaration_tuple] = STATE(856),
    [sym_expression_statement] = STATE(36),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(36),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(248),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_variable_declaration] = STATE(666),
    [sym_expression] = STATE(430),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_variable_declaration_tuple_repeat1] = STATE(667),
    [aux_sym_tuple_expression_repeat1] = STATE(679),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_variable_declaration] = STATE(773),
    [sym_expression] = STATE(443),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(427),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(403),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(256),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(259),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_call_argument] = STATE(604),
    [sym_expression] = STATE(433),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_tuple_expression_repeat1] = STATE(679),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym__call_arguments] = STATE(763),
    [sym_expression] = STATE(449),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(105),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(269),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_call_argument] = STATE(761),
    [sym_expression] = STATE(444),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(271),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_expression] = STATE(430),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_tuple_expression_repeat1] = STATE(679),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(263),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(273),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym__call_arguments] = STATE(766),
    [sym_expression] = STATE(450),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(105),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(269),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_call_argument] = STATE(761),
    [sym_expression] = STATE(444),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_expression_statement] = STATE(49),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(49),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(277),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_call_argument] = STATE(604),
    [sym_expression] = STATE(444),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(279),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_expression_statement] = STATE(52),
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(52),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(281),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_call_argument] = STATE(761),
    [sym_expression] = STATE(444),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(261),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_expression] = STATE(445),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(285),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_expression] = STATE(447),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(123),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(287),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_expression] = STATE(443),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(291),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_expression] = STATE(448),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__semicolon] = STATE(123),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [anon_sym_SEMI] = ACTIONS(287),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_expression] = STATE(443),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(293),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_expression] = STATE(443),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_expression] = STATE(443),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_expression] = STATE(460),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(297),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_expression] = STATE(461),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(299),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_expression] = STATE(432),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(301),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_expression] = STATE(451),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(303),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_expression] = STATE(454),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_expression] = STATE(451),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(307),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_expression] = STATE(459),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(309),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_expression] = STATE(466),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RPAREN] = ACTIONS(311),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_expression] = STATE(437),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_expression] = STATE(467),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_expression] = STATE(431),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_expression] = STATE(471),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_expression] = STATE(388),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_expression] = STATE(436),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_expression] = STATE(393),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_expression] = STATE(453),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_expression] = STATE(452),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_expression] = STATE(434),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_expression] = STATE(380),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_expression] = STATE(438),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_expression] = STATE(441),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_expression] = STATE(451),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_expression] = STATE(442),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_expression] = STATE(457),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_expression] = STATE(392),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_expression] = STATE(372),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_expression] = STATE(373),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_expression] = STATE(374),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_expression] = STATE(375),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_expression] = STATE(376),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_expression] = STATE(455),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_expression] = STATE(381),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_expression] = STATE(382),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_expression] = STATE(385),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_expression] = STATE(386),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_expression] = STATE(435),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_expression] = STATE(371),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_expression] = STATE(472),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_expression] = STATE(464),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_expression] = STATE(465),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_expression] = STATE(390),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_expression] = STATE(391),
    [sym__primary_expression] = STATE(406),
    [sym_type_cast_expression] = STATE(406),
    [sym_ternary_expression] = STATE(406),
    [sym_new_expression] = STATE(406),
    [sym_tuple_expression] = STATE(406),
    [sym_inline_array_expression] = STATE(406),
    [sym_binary_expression] = STATE(406),
    [sym_unary_expression] = STATE(406),
    [sym_update_expression] = STATE(406),
    [sym_member_expression] = STATE(406),
    [sym_array_access] = STATE(406),
    [sym_slice_access] = STATE(406),
    [sym_struct_expression] = STATE(406),
    [sym_parenthesized_expression] = STATE(406),
    [sym_assignment_expression] = STATE(406),
    [sym_augmented_assignment_expression] = STATE(406),
    [sym_call_expression] = STATE(406),
    [sym_payable_conversion_expression] = STATE(406),
    [sym_meta_type_expression] = STATE(406),
    [sym_user_defined_type] = STATE(406),
    [sym__identifier_path] = STATE(336),
    [sym_primitive_type] = STATE(377),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym__literal] = STATE(406),
    [sym_string_literal] = STATE(406),
    [sym_number_literal] = STATE(406),
    [sym__decimal_number] = STATE(355),
    [sym__hex_number] = STATE(355),
    [sym_true] = STATE(424),
    [sym_false] = STATE(424),
    [sym_boolean_literal] = STATE(406),
    [sym_hex_string_literal] = STATE(406),
    [sym_unicode_string_literal] = STATE(406),
    [sym_string] = STATE(364),
    [aux_sym_string_literal_repeat1] = STATE(364),
    [aux_sym_hex_string_literal_repeat2] = STATE(367),
    [aux_sym_unicode_string_literal_repeat3] = STATE(368),
    [sym_identifier] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_delete] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_PLUS_PLUS] = ACTIONS(91),
    [anon_sym_DASH_DASH] = ACTIONS(91),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(93),
    [aux_sym__decimal_number_token2] = ACTIONS(95),
    [aux_sym__hex_number_token1] = ACTIONS(95),
    [anon_sym_hex] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_unicode] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym__source_unit] = STATE(87),
    [sym__directive] = STATE(87),
    [sym_pragma_directive] = STATE(87),
    [sym_import_directive] = STATE(87),
    [sym__declaration] = STATE(87),
    [sym_user_defined_type_definition] = STATE(87),
    [sym_constant_variable_declaration] = STATE(87),
    [sym_contract_declaration] = STATE(87),
    [sym_error_declaration] = STATE(87),
    [sym_interface_declaration] = STATE(87),
    [sym_library_declaration] = STATE(87),
    [sym_struct_declaration] = STATE(87),
    [sym_enum_declaration] = STATE(87),
    [sym_event_definition] = STATE(87),
    [sym_function_definition] = STATE(87),
    [sym_type_name] = STATE(789),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_source_file_repeat1] = STATE(87),
    [ts_builtin_sym_end] = ACTIONS(313),
    [sym_identifier] = ACTIONS(315),
    [anon_sym_pragma] = ACTIONS(318),
    [anon_sym_import] = ACTIONS(321),
    [anon_sym_type] = ACTIONS(324),
    [anon_sym_abstract] = ACTIONS(327),
    [anon_sym_contract] = ACTIONS(330),
    [anon_sym_error] = ACTIONS(333),
    [anon_sym_interface] = ACTIONS(336),
    [anon_sym_library] = ACTIONS(339),
    [anon_sym_struct] = ACTIONS(342),
    [anon_sym_enum] = ACTIONS(345),
    [anon_sym_event] = ACTIONS(348),
    [anon_sym_function] = ACTIONS(351),
    [anon_sym_byte] = ACTIONS(354),
    [anon_sym_address] = ACTIONS(357),
    [anon_sym_var] = ACTIONS(354),
    [anon_sym_mapping] = ACTIONS(360),
    [anon_sym_bool] = ACTIONS(354),
    [anon_sym_string] = ACTIONS(354),
    [anon_sym_int] = ACTIONS(354),
    [anon_sym_int8] = ACTIONS(354),
    [anon_sym_int16] = ACTIONS(354),
    [anon_sym_int24] = ACTIONS(354),
    [anon_sym_int32] = ACTIONS(354),
    [anon_sym_int40] = ACTIONS(354),
    [anon_sym_int48] = ACTIONS(354),
    [anon_sym_int56] = ACTIONS(354),
    [anon_sym_int64] = ACTIONS(354),
    [anon_sym_int72] = ACTIONS(354),
    [anon_sym_int80] = ACTIONS(354),
    [anon_sym_int88] = ACTIONS(354),
    [anon_sym_int96] = ACTIONS(354),
    [anon_sym_int104] = ACTIONS(354),
    [anon_sym_int112] = ACTIONS(354),
    [anon_sym_int120] = ACTIONS(354),
    [anon_sym_int128] = ACTIONS(354),
    [anon_sym_int136] = ACTIONS(354),
    [anon_sym_int144] = ACTIONS(354),
    [anon_sym_int152] = ACTIONS(354),
    [anon_sym_int160] = ACTIONS(354),
    [anon_sym_int168] = ACTIONS(354),
    [anon_sym_int176] = ACTIONS(354),
    [anon_sym_int184] = ACTIONS(354),
    [anon_sym_int192] = ACTIONS(354),
    [anon_sym_int200] = ACTIONS(354),
    [anon_sym_int208] = ACTIONS(354),
    [anon_sym_int216] = ACTIONS(354),
    [anon_sym_int224] = ACTIONS(354),
    [anon_sym_int232] = ACTIONS(354),
    [anon_sym_int240] = ACTIONS(354),
    [anon_sym_int248] = ACTIONS(354),
    [anon_sym_int256] = ACTIONS(354),
    [anon_sym_uint] = ACTIONS(354),
    [anon_sym_uint8] = ACTIONS(354),
    [anon_sym_uint16] = ACTIONS(354),
    [anon_sym_uint24] = ACTIONS(354),
    [anon_sym_uint32] = ACTIONS(354),
    [anon_sym_uint40] = ACTIONS(354),
    [anon_sym_uint48] = ACTIONS(354),
    [anon_sym_uint56] = ACTIONS(354),
    [anon_sym_uint64] = ACTIONS(354),
    [anon_sym_uint72] = ACTIONS(354),
    [anon_sym_uint80] = ACTIONS(354),
    [anon_sym_uint88] = ACTIONS(354),
    [anon_sym_uint96] = ACTIONS(354),
    [anon_sym_uint104] = ACTIONS(354),
    [anon_sym_uint112] = ACTIONS(354),
    [anon_sym_uint120] = ACTIONS(354),
    [anon_sym_uint128] = ACTIONS(354),
    [anon_sym_uint136] = ACTIONS(354),
    [anon_sym_uint144] = ACTIONS(354),
    [anon_sym_uint152] = ACTIONS(354),
    [anon_sym_uint160] = ACTIONS(354),
    [anon_sym_uint168] = ACTIONS(354),
    [anon_sym_uint176] = ACTIONS(354),
    [anon_sym_uint184] = ACTIONS(354),
    [anon_sym_uint192] = ACTIONS(354),
    [anon_sym_uint200] = ACTIONS(354),
    [anon_sym_uint208] = ACTIONS(354),
    [anon_sym_uint216] = ACTIONS(354),
    [anon_sym_uint224] = ACTIONS(354),
    [anon_sym_uint232] = ACTIONS(354),
    [anon_sym_uint240] = ACTIONS(354),
    [anon_sym_uint248] = ACTIONS(354),
    [anon_sym_uint256] = ACTIONS(354),
    [anon_sym_bytes] = ACTIONS(354),
    [anon_sym_bytes1] = ACTIONS(354),
    [anon_sym_bytes2] = ACTIONS(354),
    [anon_sym_bytes3] = ACTIONS(354),
    [anon_sym_bytes4] = ACTIONS(354),
    [anon_sym_bytes5] = ACTIONS(354),
    [anon_sym_bytes6] = ACTIONS(354),
    [anon_sym_bytes7] = ACTIONS(354),
    [anon_sym_bytes8] = ACTIONS(354),
    [anon_sym_bytes9] = ACTIONS(354),
    [anon_sym_bytes10] = ACTIONS(354),
    [anon_sym_bytes11] = ACTIONS(354),
    [anon_sym_bytes12] = ACTIONS(354),
    [anon_sym_bytes13] = ACTIONS(354),
    [anon_sym_bytes14] = ACTIONS(354),
    [anon_sym_bytes15] = ACTIONS(354),
    [anon_sym_bytes16] = ACTIONS(354),
    [anon_sym_bytes17] = ACTIONS(354),
    [anon_sym_bytes18] = ACTIONS(354),
    [anon_sym_bytes19] = ACTIONS(354),
    [anon_sym_bytes20] = ACTIONS(354),
    [anon_sym_bytes21] = ACTIONS(354),
    [anon_sym_bytes22] = ACTIONS(354),
    [anon_sym_bytes23] = ACTIONS(354),
    [anon_sym_bytes24] = ACTIONS(354),
    [anon_sym_bytes25] = ACTIONS(354),
    [anon_sym_bytes26] = ACTIONS(354),
    [anon_sym_bytes27] = ACTIONS(354),
    [anon_sym_bytes28] = ACTIONS(354),
    [anon_sym_bytes29] = ACTIONS(354),
    [anon_sym_bytes30] = ACTIONS(354),
    [anon_sym_bytes31] = ACTIONS(354),
    [anon_sym_bytes32] = ACTIONS(354),
    [anon_sym_fixed] = ACTIONS(354),
    [aux_sym__fixed_token1] = ACTIONS(354),
    [anon_sym_ufixed] = ACTIONS(354),
    [aux_sym__ufixed_token1] = ACTIONS(354),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym__source_unit] = STATE(87),
    [sym__directive] = STATE(87),
    [sym_pragma_directive] = STATE(87),
    [sym_import_directive] = STATE(87),
    [sym__declaration] = STATE(87),
    [sym_user_defined_type_definition] = STATE(87),
    [sym_constant_variable_declaration] = STATE(87),
    [sym_contract_declaration] = STATE(87),
    [sym_error_declaration] = STATE(87),
    [sym_interface_declaration] = STATE(87),
    [sym_library_declaration] = STATE(87),
    [sym_struct_declaration] = STATE(87),
    [sym_enum_declaration] = STATE(87),
    [sym_event_definition] = STATE(87),
    [sym_function_definition] = STATE(87),
    [sym_type_name] = STATE(789),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_source_file_repeat1] = STATE(87),
    [ts_builtin_sym_end] = ACTIONS(363),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pragma] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_contract] = ACTIONS(17),
    [anon_sym_error] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_library] = ACTIONS(23),
    [anon_sym_struct] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_event] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_catch_clause] = STATE(90),
    [aux_sym_try_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(365),
    [anon_sym_DASH] = ACTIONS(365),
    [anon_sym_TILDE] = ACTIONS(367),
    [anon_sym_LBRACE] = ACTIONS(367),
    [anon_sym_RBRACE] = ACTIONS(367),
    [anon_sym_type] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_assembly] = ACTIONS(365),
    [anon_sym_break] = ACTIONS(365),
    [anon_sym_continue] = ACTIONS(365),
    [anon_sym_true] = ACTIONS(365),
    [anon_sym_false] = ACTIONS(365),
    [anon_sym_if] = ACTIONS(365),
    [anon_sym_function] = ACTIONS(365),
    [anon_sym_byte] = ACTIONS(365),
    [anon_sym_address] = ACTIONS(365),
    [anon_sym_return] = ACTIONS(365),
    [anon_sym_revert] = ACTIONS(365),
    [sym_unchecked] = ACTIONS(365),
    [anon_sym_var] = ACTIONS(365),
    [anon_sym_else] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(365),
    [anon_sym_do] = ACTIONS(365),
    [anon_sym_try] = ACTIONS(365),
    [anon_sym_catch] = ACTIONS(369),
    [anon_sym_emit] = ACTIONS(365),
    [anon_sym_payable] = ACTIONS(365),
    [anon_sym_new] = ACTIONS(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_delete] = ACTIONS(365),
    [anon_sym_BANG] = ACTIONS(367),
    [anon_sym_PLUS_PLUS] = ACTIONS(367),
    [anon_sym_DASH_DASH] = ACTIONS(367),
    [anon_sym_mapping] = ACTIONS(365),
    [anon_sym_bool] = ACTIONS(365),
    [anon_sym_string] = ACTIONS(365),
    [anon_sym_int] = ACTIONS(365),
    [anon_sym_int8] = ACTIONS(365),
    [anon_sym_int16] = ACTIONS(365),
    [anon_sym_int24] = ACTIONS(365),
    [anon_sym_int32] = ACTIONS(365),
    [anon_sym_int40] = ACTIONS(365),
    [anon_sym_int48] = ACTIONS(365),
    [anon_sym_int56] = ACTIONS(365),
    [anon_sym_int64] = ACTIONS(365),
    [anon_sym_int72] = ACTIONS(365),
    [anon_sym_int80] = ACTIONS(365),
    [anon_sym_int88] = ACTIONS(365),
    [anon_sym_int96] = ACTIONS(365),
    [anon_sym_int104] = ACTIONS(365),
    [anon_sym_int112] = ACTIONS(365),
    [anon_sym_int120] = ACTIONS(365),
    [anon_sym_int128] = ACTIONS(365),
    [anon_sym_int136] = ACTIONS(365),
    [anon_sym_int144] = ACTIONS(365),
    [anon_sym_int152] = ACTIONS(365),
    [anon_sym_int160] = ACTIONS(365),
    [anon_sym_int168] = ACTIONS(365),
    [anon_sym_int176] = ACTIONS(365),
    [anon_sym_int184] = ACTIONS(365),
    [anon_sym_int192] = ACTIONS(365),
    [anon_sym_int200] = ACTIONS(365),
    [anon_sym_int208] = ACTIONS(365),
    [anon_sym_int216] = ACTIONS(365),
    [anon_sym_int224] = ACTIONS(365),
    [anon_sym_int232] = ACTIONS(365),
    [anon_sym_int240] = ACTIONS(365),
    [anon_sym_int248] = ACTIONS(365),
    [anon_sym_int256] = ACTIONS(365),
    [anon_sym_uint] = ACTIONS(365),
    [anon_sym_uint8] = ACTIONS(365),
    [anon_sym_uint16] = ACTIONS(365),
    [anon_sym_uint24] = ACTIONS(365),
    [anon_sym_uint32] = ACTIONS(365),
    [anon_sym_uint40] = ACTIONS(365),
    [anon_sym_uint48] = ACTIONS(365),
    [anon_sym_uint56] = ACTIONS(365),
    [anon_sym_uint64] = ACTIONS(365),
    [anon_sym_uint72] = ACTIONS(365),
    [anon_sym_uint80] = ACTIONS(365),
    [anon_sym_uint88] = ACTIONS(365),
    [anon_sym_uint96] = ACTIONS(365),
    [anon_sym_uint104] = ACTIONS(365),
    [anon_sym_uint112] = ACTIONS(365),
    [anon_sym_uint120] = ACTIONS(365),
    [anon_sym_uint128] = ACTIONS(365),
    [anon_sym_uint136] = ACTIONS(365),
    [anon_sym_uint144] = ACTIONS(365),
    [anon_sym_uint152] = ACTIONS(365),
    [anon_sym_uint160] = ACTIONS(365),
    [anon_sym_uint168] = ACTIONS(365),
    [anon_sym_uint176] = ACTIONS(365),
    [anon_sym_uint184] = ACTIONS(365),
    [anon_sym_uint192] = ACTIONS(365),
    [anon_sym_uint200] = ACTIONS(365),
    [anon_sym_uint208] = ACTIONS(365),
    [anon_sym_uint216] = ACTIONS(365),
    [anon_sym_uint224] = ACTIONS(365),
    [anon_sym_uint232] = ACTIONS(365),
    [anon_sym_uint240] = ACTIONS(365),
    [anon_sym_uint248] = ACTIONS(365),
    [anon_sym_uint256] = ACTIONS(365),
    [anon_sym_bytes] = ACTIONS(365),
    [anon_sym_bytes1] = ACTIONS(365),
    [anon_sym_bytes2] = ACTIONS(365),
    [anon_sym_bytes3] = ACTIONS(365),
    [anon_sym_bytes4] = ACTIONS(365),
    [anon_sym_bytes5] = ACTIONS(365),
    [anon_sym_bytes6] = ACTIONS(365),
    [anon_sym_bytes7] = ACTIONS(365),
    [anon_sym_bytes8] = ACTIONS(365),
    [anon_sym_bytes9] = ACTIONS(365),
    [anon_sym_bytes10] = ACTIONS(365),
    [anon_sym_bytes11] = ACTIONS(365),
    [anon_sym_bytes12] = ACTIONS(365),
    [anon_sym_bytes13] = ACTIONS(365),
    [anon_sym_bytes14] = ACTIONS(365),
    [anon_sym_bytes15] = ACTIONS(365),
    [anon_sym_bytes16] = ACTIONS(365),
    [anon_sym_bytes17] = ACTIONS(365),
    [anon_sym_bytes18] = ACTIONS(365),
    [anon_sym_bytes19] = ACTIONS(365),
    [anon_sym_bytes20] = ACTIONS(365),
    [anon_sym_bytes21] = ACTIONS(365),
    [anon_sym_bytes22] = ACTIONS(365),
    [anon_sym_bytes23] = ACTIONS(365),
    [anon_sym_bytes24] = ACTIONS(365),
    [anon_sym_bytes25] = ACTIONS(365),
    [anon_sym_bytes26] = ACTIONS(365),
    [anon_sym_bytes27] = ACTIONS(365),
    [anon_sym_bytes28] = ACTIONS(365),
    [anon_sym_bytes29] = ACTIONS(365),
    [anon_sym_bytes30] = ACTIONS(365),
    [anon_sym_bytes31] = ACTIONS(365),
    [anon_sym_bytes32] = ACTIONS(365),
    [anon_sym_fixed] = ACTIONS(365),
    [aux_sym__fixed_token1] = ACTIONS(365),
    [anon_sym_ufixed] = ACTIONS(365),
    [aux_sym__ufixed_token1] = ACTIONS(365),
    [aux_sym__decimal_number_token1] = ACTIONS(365),
    [aux_sym__decimal_number_token2] = ACTIONS(367),
    [aux_sym__hex_number_token1] = ACTIONS(367),
    [anon_sym_hex] = ACTIONS(365),
    [anon_sym_DQUOTE] = ACTIONS(367),
    [anon_sym_SQUOTE] = ACTIONS(367),
    [anon_sym_unicode] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_catch_clause] = STATE(90),
    [aux_sym_try_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_RBRACE] = ACTIONS(373),
    [anon_sym_type] = ACTIONS(371),
    [anon_sym_LPAREN] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_assembly] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(371),
    [anon_sym_false] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(371),
    [anon_sym_address] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_revert] = ACTIONS(371),
    [sym_unchecked] = ACTIONS(371),
    [anon_sym_var] = ACTIONS(371),
    [anon_sym_else] = ACTIONS(371),
    [anon_sym_while] = ACTIONS(371),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_try] = ACTIONS(371),
    [anon_sym_catch] = ACTIONS(375),
    [anon_sym_emit] = ACTIONS(371),
    [anon_sym_payable] = ACTIONS(371),
    [anon_sym_new] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(373),
    [anon_sym_delete] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_PLUS_PLUS] = ACTIONS(373),
    [anon_sym_DASH_DASH] = ACTIONS(373),
    [anon_sym_mapping] = ACTIONS(371),
    [anon_sym_bool] = ACTIONS(371),
    [anon_sym_string] = ACTIONS(371),
    [anon_sym_int] = ACTIONS(371),
    [anon_sym_int8] = ACTIONS(371),
    [anon_sym_int16] = ACTIONS(371),
    [anon_sym_int24] = ACTIONS(371),
    [anon_sym_int32] = ACTIONS(371),
    [anon_sym_int40] = ACTIONS(371),
    [anon_sym_int48] = ACTIONS(371),
    [anon_sym_int56] = ACTIONS(371),
    [anon_sym_int64] = ACTIONS(371),
    [anon_sym_int72] = ACTIONS(371),
    [anon_sym_int80] = ACTIONS(371),
    [anon_sym_int88] = ACTIONS(371),
    [anon_sym_int96] = ACTIONS(371),
    [anon_sym_int104] = ACTIONS(371),
    [anon_sym_int112] = ACTIONS(371),
    [anon_sym_int120] = ACTIONS(371),
    [anon_sym_int128] = ACTIONS(371),
    [anon_sym_int136] = ACTIONS(371),
    [anon_sym_int144] = ACTIONS(371),
    [anon_sym_int152] = ACTIONS(371),
    [anon_sym_int160] = ACTIONS(371),
    [anon_sym_int168] = ACTIONS(371),
    [anon_sym_int176] = ACTIONS(371),
    [anon_sym_int184] = ACTIONS(371),
    [anon_sym_int192] = ACTIONS(371),
    [anon_sym_int200] = ACTIONS(371),
    [anon_sym_int208] = ACTIONS(371),
    [anon_sym_int216] = ACTIONS(371),
    [anon_sym_int224] = ACTIONS(371),
    [anon_sym_int232] = ACTIONS(371),
    [anon_sym_int240] = ACTIONS(371),
    [anon_sym_int248] = ACTIONS(371),
    [anon_sym_int256] = ACTIONS(371),
    [anon_sym_uint] = ACTIONS(371),
    [anon_sym_uint8] = ACTIONS(371),
    [anon_sym_uint16] = ACTIONS(371),
    [anon_sym_uint24] = ACTIONS(371),
    [anon_sym_uint32] = ACTIONS(371),
    [anon_sym_uint40] = ACTIONS(371),
    [anon_sym_uint48] = ACTIONS(371),
    [anon_sym_uint56] = ACTIONS(371),
    [anon_sym_uint64] = ACTIONS(371),
    [anon_sym_uint72] = ACTIONS(371),
    [anon_sym_uint80] = ACTIONS(371),
    [anon_sym_uint88] = ACTIONS(371),
    [anon_sym_uint96] = ACTIONS(371),
    [anon_sym_uint104] = ACTIONS(371),
    [anon_sym_uint112] = ACTIONS(371),
    [anon_sym_uint120] = ACTIONS(371),
    [anon_sym_uint128] = ACTIONS(371),
    [anon_sym_uint136] = ACTIONS(371),
    [anon_sym_uint144] = ACTIONS(371),
    [anon_sym_uint152] = ACTIONS(371),
    [anon_sym_uint160] = ACTIONS(371),
    [anon_sym_uint168] = ACTIONS(371),
    [anon_sym_uint176] = ACTIONS(371),
    [anon_sym_uint184] = ACTIONS(371),
    [anon_sym_uint192] = ACTIONS(371),
    [anon_sym_uint200] = ACTIONS(371),
    [anon_sym_uint208] = ACTIONS(371),
    [anon_sym_uint216] = ACTIONS(371),
    [anon_sym_uint224] = ACTIONS(371),
    [anon_sym_uint232] = ACTIONS(371),
    [anon_sym_uint240] = ACTIONS(371),
    [anon_sym_uint248] = ACTIONS(371),
    [anon_sym_uint256] = ACTIONS(371),
    [anon_sym_bytes] = ACTIONS(371),
    [anon_sym_bytes1] = ACTIONS(371),
    [anon_sym_bytes2] = ACTIONS(371),
    [anon_sym_bytes3] = ACTIONS(371),
    [anon_sym_bytes4] = ACTIONS(371),
    [anon_sym_bytes5] = ACTIONS(371),
    [anon_sym_bytes6] = ACTIONS(371),
    [anon_sym_bytes7] = ACTIONS(371),
    [anon_sym_bytes8] = ACTIONS(371),
    [anon_sym_bytes9] = ACTIONS(371),
    [anon_sym_bytes10] = ACTIONS(371),
    [anon_sym_bytes11] = ACTIONS(371),
    [anon_sym_bytes12] = ACTIONS(371),
    [anon_sym_bytes13] = ACTIONS(371),
    [anon_sym_bytes14] = ACTIONS(371),
    [anon_sym_bytes15] = ACTIONS(371),
    [anon_sym_bytes16] = ACTIONS(371),
    [anon_sym_bytes17] = ACTIONS(371),
    [anon_sym_bytes18] = ACTIONS(371),
    [anon_sym_bytes19] = ACTIONS(371),
    [anon_sym_bytes20] = ACTIONS(371),
    [anon_sym_bytes21] = ACTIONS(371),
    [anon_sym_bytes22] = ACTIONS(371),
    [anon_sym_bytes23] = ACTIONS(371),
    [anon_sym_bytes24] = ACTIONS(371),
    [anon_sym_bytes25] = ACTIONS(371),
    [anon_sym_bytes26] = ACTIONS(371),
    [anon_sym_bytes27] = ACTIONS(371),
    [anon_sym_bytes28] = ACTIONS(371),
    [anon_sym_bytes29] = ACTIONS(371),
    [anon_sym_bytes30] = ACTIONS(371),
    [anon_sym_bytes31] = ACTIONS(371),
    [anon_sym_bytes32] = ACTIONS(371),
    [anon_sym_fixed] = ACTIONS(371),
    [aux_sym__fixed_token1] = ACTIONS(371),
    [anon_sym_ufixed] = ACTIONS(371),
    [aux_sym__ufixed_token1] = ACTIONS(371),
    [aux_sym__decimal_number_token1] = ACTIONS(371),
    [aux_sym__decimal_number_token2] = ACTIONS(373),
    [aux_sym__hex_number_token1] = ACTIONS(373),
    [anon_sym_hex] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(373),
    [anon_sym_unicode] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_catch_clause] = STATE(90),
    [aux_sym_try_statement_repeat1] = STATE(90),
    [sym_identifier] = ACTIONS(378),
    [anon_sym_DASH] = ACTIONS(378),
    [anon_sym_TILDE] = ACTIONS(380),
    [anon_sym_LBRACE] = ACTIONS(380),
    [anon_sym_RBRACE] = ACTIONS(380),
    [anon_sym_type] = ACTIONS(378),
    [anon_sym_LPAREN] = ACTIONS(380),
    [anon_sym_for] = ACTIONS(378),
    [anon_sym_assembly] = ACTIONS(378),
    [anon_sym_break] = ACTIONS(378),
    [anon_sym_continue] = ACTIONS(378),
    [anon_sym_true] = ACTIONS(378),
    [anon_sym_false] = ACTIONS(378),
    [anon_sym_if] = ACTIONS(378),
    [anon_sym_function] = ACTIONS(378),
    [anon_sym_byte] = ACTIONS(378),
    [anon_sym_address] = ACTIONS(378),
    [anon_sym_return] = ACTIONS(378),
    [anon_sym_revert] = ACTIONS(378),
    [sym_unchecked] = ACTIONS(378),
    [anon_sym_var] = ACTIONS(378),
    [anon_sym_else] = ACTIONS(378),
    [anon_sym_while] = ACTIONS(378),
    [anon_sym_do] = ACTIONS(378),
    [anon_sym_try] = ACTIONS(378),
    [anon_sym_catch] = ACTIONS(369),
    [anon_sym_emit] = ACTIONS(378),
    [anon_sym_payable] = ACTIONS(378),
    [anon_sym_new] = ACTIONS(378),
    [anon_sym_LBRACK] = ACTIONS(380),
    [anon_sym_delete] = ACTIONS(378),
    [anon_sym_BANG] = ACTIONS(380),
    [anon_sym_PLUS_PLUS] = ACTIONS(380),
    [anon_sym_DASH_DASH] = ACTIONS(380),
    [anon_sym_mapping] = ACTIONS(378),
    [anon_sym_bool] = ACTIONS(378),
    [anon_sym_string] = ACTIONS(378),
    [anon_sym_int] = ACTIONS(378),
    [anon_sym_int8] = ACTIONS(378),
    [anon_sym_int16] = ACTIONS(378),
    [anon_sym_int24] = ACTIONS(378),
    [anon_sym_int32] = ACTIONS(378),
    [anon_sym_int40] = ACTIONS(378),
    [anon_sym_int48] = ACTIONS(378),
    [anon_sym_int56] = ACTIONS(378),
    [anon_sym_int64] = ACTIONS(378),
    [anon_sym_int72] = ACTIONS(378),
    [anon_sym_int80] = ACTIONS(378),
    [anon_sym_int88] = ACTIONS(378),
    [anon_sym_int96] = ACTIONS(378),
    [anon_sym_int104] = ACTIONS(378),
    [anon_sym_int112] = ACTIONS(378),
    [anon_sym_int120] = ACTIONS(378),
    [anon_sym_int128] = ACTIONS(378),
    [anon_sym_int136] = ACTIONS(378),
    [anon_sym_int144] = ACTIONS(378),
    [anon_sym_int152] = ACTIONS(378),
    [anon_sym_int160] = ACTIONS(378),
    [anon_sym_int168] = ACTIONS(378),
    [anon_sym_int176] = ACTIONS(378),
    [anon_sym_int184] = ACTIONS(378),
    [anon_sym_int192] = ACTIONS(378),
    [anon_sym_int200] = ACTIONS(378),
    [anon_sym_int208] = ACTIONS(378),
    [anon_sym_int216] = ACTIONS(378),
    [anon_sym_int224] = ACTIONS(378),
    [anon_sym_int232] = ACTIONS(378),
    [anon_sym_int240] = ACTIONS(378),
    [anon_sym_int248] = ACTIONS(378),
    [anon_sym_int256] = ACTIONS(378),
    [anon_sym_uint] = ACTIONS(378),
    [anon_sym_uint8] = ACTIONS(378),
    [anon_sym_uint16] = ACTIONS(378),
    [anon_sym_uint24] = ACTIONS(378),
    [anon_sym_uint32] = ACTIONS(378),
    [anon_sym_uint40] = ACTIONS(378),
    [anon_sym_uint48] = ACTIONS(378),
    [anon_sym_uint56] = ACTIONS(378),
    [anon_sym_uint64] = ACTIONS(378),
    [anon_sym_uint72] = ACTIONS(378),
    [anon_sym_uint80] = ACTIONS(378),
    [anon_sym_uint88] = ACTIONS(378),
    [anon_sym_uint96] = ACTIONS(378),
    [anon_sym_uint104] = ACTIONS(378),
    [anon_sym_uint112] = ACTIONS(378),
    [anon_sym_uint120] = ACTIONS(378),
    [anon_sym_uint128] = ACTIONS(378),
    [anon_sym_uint136] = ACTIONS(378),
    [anon_sym_uint144] = ACTIONS(378),
    [anon_sym_uint152] = ACTIONS(378),
    [anon_sym_uint160] = ACTIONS(378),
    [anon_sym_uint168] = ACTIONS(378),
    [anon_sym_uint176] = ACTIONS(378),
    [anon_sym_uint184] = ACTIONS(378),
    [anon_sym_uint192] = ACTIONS(378),
    [anon_sym_uint200] = ACTIONS(378),
    [anon_sym_uint208] = ACTIONS(378),
    [anon_sym_uint216] = ACTIONS(378),
    [anon_sym_uint224] = ACTIONS(378),
    [anon_sym_uint232] = ACTIONS(378),
    [anon_sym_uint240] = ACTIONS(378),
    [anon_sym_uint248] = ACTIONS(378),
    [anon_sym_uint256] = ACTIONS(378),
    [anon_sym_bytes] = ACTIONS(378),
    [anon_sym_bytes1] = ACTIONS(378),
    [anon_sym_bytes2] = ACTIONS(378),
    [anon_sym_bytes3] = ACTIONS(378),
    [anon_sym_bytes4] = ACTIONS(378),
    [anon_sym_bytes5] = ACTIONS(378),
    [anon_sym_bytes6] = ACTIONS(378),
    [anon_sym_bytes7] = ACTIONS(378),
    [anon_sym_bytes8] = ACTIONS(378),
    [anon_sym_bytes9] = ACTIONS(378),
    [anon_sym_bytes10] = ACTIONS(378),
    [anon_sym_bytes11] = ACTIONS(378),
    [anon_sym_bytes12] = ACTIONS(378),
    [anon_sym_bytes13] = ACTIONS(378),
    [anon_sym_bytes14] = ACTIONS(378),
    [anon_sym_bytes15] = ACTIONS(378),
    [anon_sym_bytes16] = ACTIONS(378),
    [anon_sym_bytes17] = ACTIONS(378),
    [anon_sym_bytes18] = ACTIONS(378),
    [anon_sym_bytes19] = ACTIONS(378),
    [anon_sym_bytes20] = ACTIONS(378),
    [anon_sym_bytes21] = ACTIONS(378),
    [anon_sym_bytes22] = ACTIONS(378),
    [anon_sym_bytes23] = ACTIONS(378),
    [anon_sym_bytes24] = ACTIONS(378),
    [anon_sym_bytes25] = ACTIONS(378),
    [anon_sym_bytes26] = ACTIONS(378),
    [anon_sym_bytes27] = ACTIONS(378),
    [anon_sym_bytes28] = ACTIONS(378),
    [anon_sym_bytes29] = ACTIONS(378),
    [anon_sym_bytes30] = ACTIONS(378),
    [anon_sym_bytes31] = ACTIONS(378),
    [anon_sym_bytes32] = ACTIONS(378),
    [anon_sym_fixed] = ACTIONS(378),
    [aux_sym__fixed_token1] = ACTIONS(378),
    [anon_sym_ufixed] = ACTIONS(378),
    [aux_sym__ufixed_token1] = ACTIONS(378),
    [aux_sym__decimal_number_token1] = ACTIONS(378),
    [aux_sym__decimal_number_token2] = ACTIONS(380),
    [aux_sym__hex_number_token1] = ACTIONS(380),
    [anon_sym_hex] = ACTIONS(378),
    [anon_sym_DQUOTE] = ACTIONS(380),
    [anon_sym_SQUOTE] = ACTIONS(380),
    [anon_sym_unicode] = ACTIONS(378),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(382),
    [anon_sym_TILDE] = ACTIONS(384),
    [anon_sym_LBRACE] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_type] = ACTIONS(382),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(384),
    [anon_sym_for] = ACTIONS(382),
    [anon_sym_assembly] = ACTIONS(382),
    [anon_sym_break] = ACTIONS(382),
    [anon_sym_continue] = ACTIONS(382),
    [anon_sym_true] = ACTIONS(382),
    [anon_sym_false] = ACTIONS(382),
    [anon_sym_if] = ACTIONS(382),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_byte] = ACTIONS(382),
    [anon_sym_address] = ACTIONS(382),
    [anon_sym_return] = ACTIONS(382),
    [anon_sym_revert] = ACTIONS(382),
    [sym_unchecked] = ACTIONS(382),
    [anon_sym_var] = ACTIONS(382),
    [anon_sym_else] = ACTIONS(382),
    [anon_sym_while] = ACTIONS(382),
    [anon_sym_do] = ACTIONS(382),
    [anon_sym_try] = ACTIONS(382),
    [anon_sym_emit] = ACTIONS(382),
    [anon_sym_payable] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(382),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_delete] = ACTIONS(382),
    [anon_sym_BANG] = ACTIONS(384),
    [anon_sym_PLUS_PLUS] = ACTIONS(384),
    [anon_sym_DASH_DASH] = ACTIONS(384),
    [anon_sym_mapping] = ACTIONS(382),
    [anon_sym_bool] = ACTIONS(382),
    [anon_sym_string] = ACTIONS(382),
    [anon_sym_int] = ACTIONS(382),
    [anon_sym_int8] = ACTIONS(382),
    [anon_sym_int16] = ACTIONS(382),
    [anon_sym_int24] = ACTIONS(382),
    [anon_sym_int32] = ACTIONS(382),
    [anon_sym_int40] = ACTIONS(382),
    [anon_sym_int48] = ACTIONS(382),
    [anon_sym_int56] = ACTIONS(382),
    [anon_sym_int64] = ACTIONS(382),
    [anon_sym_int72] = ACTIONS(382),
    [anon_sym_int80] = ACTIONS(382),
    [anon_sym_int88] = ACTIONS(382),
    [anon_sym_int96] = ACTIONS(382),
    [anon_sym_int104] = ACTIONS(382),
    [anon_sym_int112] = ACTIONS(382),
    [anon_sym_int120] = ACTIONS(382),
    [anon_sym_int128] = ACTIONS(382),
    [anon_sym_int136] = ACTIONS(382),
    [anon_sym_int144] = ACTIONS(382),
    [anon_sym_int152] = ACTIONS(382),
    [anon_sym_int160] = ACTIONS(382),
    [anon_sym_int168] = ACTIONS(382),
    [anon_sym_int176] = ACTIONS(382),
    [anon_sym_int184] = ACTIONS(382),
    [anon_sym_int192] = ACTIONS(382),
    [anon_sym_int200] = ACTIONS(382),
    [anon_sym_int208] = ACTIONS(382),
    [anon_sym_int216] = ACTIONS(382),
    [anon_sym_int224] = ACTIONS(382),
    [anon_sym_int232] = ACTIONS(382),
    [anon_sym_int240] = ACTIONS(382),
    [anon_sym_int248] = ACTIONS(382),
    [anon_sym_int256] = ACTIONS(382),
    [anon_sym_uint] = ACTIONS(382),
    [anon_sym_uint8] = ACTIONS(382),
    [anon_sym_uint16] = ACTIONS(382),
    [anon_sym_uint24] = ACTIONS(382),
    [anon_sym_uint32] = ACTIONS(382),
    [anon_sym_uint40] = ACTIONS(382),
    [anon_sym_uint48] = ACTIONS(382),
    [anon_sym_uint56] = ACTIONS(382),
    [anon_sym_uint64] = ACTIONS(382),
    [anon_sym_uint72] = ACTIONS(382),
    [anon_sym_uint80] = ACTIONS(382),
    [anon_sym_uint88] = ACTIONS(382),
    [anon_sym_uint96] = ACTIONS(382),
    [anon_sym_uint104] = ACTIONS(382),
    [anon_sym_uint112] = ACTIONS(382),
    [anon_sym_uint120] = ACTIONS(382),
    [anon_sym_uint128] = ACTIONS(382),
    [anon_sym_uint136] = ACTIONS(382),
    [anon_sym_uint144] = ACTIONS(382),
    [anon_sym_uint152] = ACTIONS(382),
    [anon_sym_uint160] = ACTIONS(382),
    [anon_sym_uint168] = ACTIONS(382),
    [anon_sym_uint176] = ACTIONS(382),
    [anon_sym_uint184] = ACTIONS(382),
    [anon_sym_uint192] = ACTIONS(382),
    [anon_sym_uint200] = ACTIONS(382),
    [anon_sym_uint208] = ACTIONS(382),
    [anon_sym_uint216] = ACTIONS(382),
    [anon_sym_uint224] = ACTIONS(382),
    [anon_sym_uint232] = ACTIONS(382),
    [anon_sym_uint240] = ACTIONS(382),
    [anon_sym_uint248] = ACTIONS(382),
    [anon_sym_uint256] = ACTIONS(382),
    [anon_sym_bytes] = ACTIONS(382),
    [anon_sym_bytes1] = ACTIONS(382),
    [anon_sym_bytes2] = ACTIONS(382),
    [anon_sym_bytes3] = ACTIONS(382),
    [anon_sym_bytes4] = ACTIONS(382),
    [anon_sym_bytes5] = ACTIONS(382),
    [anon_sym_bytes6] = ACTIONS(382),
    [anon_sym_bytes7] = ACTIONS(382),
    [anon_sym_bytes8] = ACTIONS(382),
    [anon_sym_bytes9] = ACTIONS(382),
    [anon_sym_bytes10] = ACTIONS(382),
    [anon_sym_bytes11] = ACTIONS(382),
    [anon_sym_bytes12] = ACTIONS(382),
    [anon_sym_bytes13] = ACTIONS(382),
    [anon_sym_bytes14] = ACTIONS(382),
    [anon_sym_bytes15] = ACTIONS(382),
    [anon_sym_bytes16] = ACTIONS(382),
    [anon_sym_bytes17] = ACTIONS(382),
    [anon_sym_bytes18] = ACTIONS(382),
    [anon_sym_bytes19] = ACTIONS(382),
    [anon_sym_bytes20] = ACTIONS(382),
    [anon_sym_bytes21] = ACTIONS(382),
    [anon_sym_bytes22] = ACTIONS(382),
    [anon_sym_bytes23] = ACTIONS(382),
    [anon_sym_bytes24] = ACTIONS(382),
    [anon_sym_bytes25] = ACTIONS(382),
    [anon_sym_bytes26] = ACTIONS(382),
    [anon_sym_bytes27] = ACTIONS(382),
    [anon_sym_bytes28] = ACTIONS(382),
    [anon_sym_bytes29] = ACTIONS(382),
    [anon_sym_bytes30] = ACTIONS(382),
    [anon_sym_bytes31] = ACTIONS(382),
    [anon_sym_bytes32] = ACTIONS(382),
    [anon_sym_fixed] = ACTIONS(382),
    [aux_sym__fixed_token1] = ACTIONS(382),
    [anon_sym_ufixed] = ACTIONS(382),
    [aux_sym__ufixed_token1] = ACTIONS(382),
    [anon_sym_SEMI] = ACTIONS(384),
    [aux_sym__decimal_number_token1] = ACTIONS(382),
    [aux_sym__decimal_number_token2] = ACTIONS(384),
    [aux_sym__hex_number_token1] = ACTIONS(384),
    [anon_sym_hex] = ACTIONS(382),
    [anon_sym_DQUOTE] = ACTIONS(384),
    [anon_sym_SQUOTE] = ACTIONS(384),
    [anon_sym_unicode] = ACTIONS(382),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(386),
    [anon_sym_TILDE] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(388),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_type] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_for] = ACTIONS(386),
    [anon_sym_assembly] = ACTIONS(386),
    [anon_sym_break] = ACTIONS(386),
    [anon_sym_continue] = ACTIONS(386),
    [anon_sym_true] = ACTIONS(386),
    [anon_sym_false] = ACTIONS(386),
    [anon_sym_if] = ACTIONS(386),
    [anon_sym_function] = ACTIONS(386),
    [anon_sym_byte] = ACTIONS(386),
    [anon_sym_address] = ACTIONS(386),
    [anon_sym_return] = ACTIONS(386),
    [anon_sym_revert] = ACTIONS(386),
    [sym_unchecked] = ACTIONS(386),
    [anon_sym_var] = ACTIONS(386),
    [anon_sym_else] = ACTIONS(386),
    [anon_sym_while] = ACTIONS(386),
    [anon_sym_do] = ACTIONS(386),
    [anon_sym_try] = ACTIONS(386),
    [anon_sym_emit] = ACTIONS(386),
    [anon_sym_payable] = ACTIONS(386),
    [anon_sym_new] = ACTIONS(386),
    [anon_sym_LBRACK] = ACTIONS(388),
    [anon_sym_delete] = ACTIONS(386),
    [anon_sym_BANG] = ACTIONS(388),
    [anon_sym_PLUS_PLUS] = ACTIONS(388),
    [anon_sym_DASH_DASH] = ACTIONS(388),
    [anon_sym_mapping] = ACTIONS(386),
    [anon_sym_bool] = ACTIONS(386),
    [anon_sym_string] = ACTIONS(386),
    [anon_sym_int] = ACTIONS(386),
    [anon_sym_int8] = ACTIONS(386),
    [anon_sym_int16] = ACTIONS(386),
    [anon_sym_int24] = ACTIONS(386),
    [anon_sym_int32] = ACTIONS(386),
    [anon_sym_int40] = ACTIONS(386),
    [anon_sym_int48] = ACTIONS(386),
    [anon_sym_int56] = ACTIONS(386),
    [anon_sym_int64] = ACTIONS(386),
    [anon_sym_int72] = ACTIONS(386),
    [anon_sym_int80] = ACTIONS(386),
    [anon_sym_int88] = ACTIONS(386),
    [anon_sym_int96] = ACTIONS(386),
    [anon_sym_int104] = ACTIONS(386),
    [anon_sym_int112] = ACTIONS(386),
    [anon_sym_int120] = ACTIONS(386),
    [anon_sym_int128] = ACTIONS(386),
    [anon_sym_int136] = ACTIONS(386),
    [anon_sym_int144] = ACTIONS(386),
    [anon_sym_int152] = ACTIONS(386),
    [anon_sym_int160] = ACTIONS(386),
    [anon_sym_int168] = ACTIONS(386),
    [anon_sym_int176] = ACTIONS(386),
    [anon_sym_int184] = ACTIONS(386),
    [anon_sym_int192] = ACTIONS(386),
    [anon_sym_int200] = ACTIONS(386),
    [anon_sym_int208] = ACTIONS(386),
    [anon_sym_int216] = ACTIONS(386),
    [anon_sym_int224] = ACTIONS(386),
    [anon_sym_int232] = ACTIONS(386),
    [anon_sym_int240] = ACTIONS(386),
    [anon_sym_int248] = ACTIONS(386),
    [anon_sym_int256] = ACTIONS(386),
    [anon_sym_uint] = ACTIONS(386),
    [anon_sym_uint8] = ACTIONS(386),
    [anon_sym_uint16] = ACTIONS(386),
    [anon_sym_uint24] = ACTIONS(386),
    [anon_sym_uint32] = ACTIONS(386),
    [anon_sym_uint40] = ACTIONS(386),
    [anon_sym_uint48] = ACTIONS(386),
    [anon_sym_uint56] = ACTIONS(386),
    [anon_sym_uint64] = ACTIONS(386),
    [anon_sym_uint72] = ACTIONS(386),
    [anon_sym_uint80] = ACTIONS(386),
    [anon_sym_uint88] = ACTIONS(386),
    [anon_sym_uint96] = ACTIONS(386),
    [anon_sym_uint104] = ACTIONS(386),
    [anon_sym_uint112] = ACTIONS(386),
    [anon_sym_uint120] = ACTIONS(386),
    [anon_sym_uint128] = ACTIONS(386),
    [anon_sym_uint136] = ACTIONS(386),
    [anon_sym_uint144] = ACTIONS(386),
    [anon_sym_uint152] = ACTIONS(386),
    [anon_sym_uint160] = ACTIONS(386),
    [anon_sym_uint168] = ACTIONS(386),
    [anon_sym_uint176] = ACTIONS(386),
    [anon_sym_uint184] = ACTIONS(386),
    [anon_sym_uint192] = ACTIONS(386),
    [anon_sym_uint200] = ACTIONS(386),
    [anon_sym_uint208] = ACTIONS(386),
    [anon_sym_uint216] = ACTIONS(386),
    [anon_sym_uint224] = ACTIONS(386),
    [anon_sym_uint232] = ACTIONS(386),
    [anon_sym_uint240] = ACTIONS(386),
    [anon_sym_uint248] = ACTIONS(386),
    [anon_sym_uint256] = ACTIONS(386),
    [anon_sym_bytes] = ACTIONS(386),
    [anon_sym_bytes1] = ACTIONS(386),
    [anon_sym_bytes2] = ACTIONS(386),
    [anon_sym_bytes3] = ACTIONS(386),
    [anon_sym_bytes4] = ACTIONS(386),
    [anon_sym_bytes5] = ACTIONS(386),
    [anon_sym_bytes6] = ACTIONS(386),
    [anon_sym_bytes7] = ACTIONS(386),
    [anon_sym_bytes8] = ACTIONS(386),
    [anon_sym_bytes9] = ACTIONS(386),
    [anon_sym_bytes10] = ACTIONS(386),
    [anon_sym_bytes11] = ACTIONS(386),
    [anon_sym_bytes12] = ACTIONS(386),
    [anon_sym_bytes13] = ACTIONS(386),
    [anon_sym_bytes14] = ACTIONS(386),
    [anon_sym_bytes15] = ACTIONS(386),
    [anon_sym_bytes16] = ACTIONS(386),
    [anon_sym_bytes17] = ACTIONS(386),
    [anon_sym_bytes18] = ACTIONS(386),
    [anon_sym_bytes19] = ACTIONS(386),
    [anon_sym_bytes20] = ACTIONS(386),
    [anon_sym_bytes21] = ACTIONS(386),
    [anon_sym_bytes22] = ACTIONS(386),
    [anon_sym_bytes23] = ACTIONS(386),
    [anon_sym_bytes24] = ACTIONS(386),
    [anon_sym_bytes25] = ACTIONS(386),
    [anon_sym_bytes26] = ACTIONS(386),
    [anon_sym_bytes27] = ACTIONS(386),
    [anon_sym_bytes28] = ACTIONS(386),
    [anon_sym_bytes29] = ACTIONS(386),
    [anon_sym_bytes30] = ACTIONS(386),
    [anon_sym_bytes31] = ACTIONS(386),
    [anon_sym_bytes32] = ACTIONS(386),
    [anon_sym_fixed] = ACTIONS(386),
    [aux_sym__fixed_token1] = ACTIONS(386),
    [anon_sym_ufixed] = ACTIONS(386),
    [aux_sym__ufixed_token1] = ACTIONS(386),
    [anon_sym_SEMI] = ACTIONS(388),
    [aux_sym__decimal_number_token1] = ACTIONS(386),
    [aux_sym__decimal_number_token2] = ACTIONS(388),
    [aux_sym__hex_number_token1] = ACTIONS(388),
    [anon_sym_hex] = ACTIONS(386),
    [anon_sym_DQUOTE] = ACTIONS(388),
    [anon_sym_SQUOTE] = ACTIONS(388),
    [anon_sym_unicode] = ACTIONS(386),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(390),
    [anon_sym_TILDE] = ACTIONS(392),
    [anon_sym_LBRACE] = ACTIONS(392),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_type] = ACTIONS(390),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_for] = ACTIONS(390),
    [anon_sym_assembly] = ACTIONS(390),
    [anon_sym_break] = ACTIONS(390),
    [anon_sym_continue] = ACTIONS(390),
    [anon_sym_true] = ACTIONS(390),
    [anon_sym_false] = ACTIONS(390),
    [anon_sym_if] = ACTIONS(390),
    [anon_sym_function] = ACTIONS(390),
    [anon_sym_byte] = ACTIONS(390),
    [anon_sym_address] = ACTIONS(390),
    [anon_sym_return] = ACTIONS(390),
    [anon_sym_revert] = ACTIONS(390),
    [sym_unchecked] = ACTIONS(390),
    [anon_sym_var] = ACTIONS(390),
    [anon_sym_else] = ACTIONS(390),
    [anon_sym_while] = ACTIONS(390),
    [anon_sym_do] = ACTIONS(390),
    [anon_sym_try] = ACTIONS(390),
    [anon_sym_catch] = ACTIONS(390),
    [anon_sym_emit] = ACTIONS(390),
    [anon_sym_payable] = ACTIONS(390),
    [anon_sym_new] = ACTIONS(390),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_delete] = ACTIONS(390),
    [anon_sym_BANG] = ACTIONS(392),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_mapping] = ACTIONS(390),
    [anon_sym_bool] = ACTIONS(390),
    [anon_sym_string] = ACTIONS(390),
    [anon_sym_int] = ACTIONS(390),
    [anon_sym_int8] = ACTIONS(390),
    [anon_sym_int16] = ACTIONS(390),
    [anon_sym_int24] = ACTIONS(390),
    [anon_sym_int32] = ACTIONS(390),
    [anon_sym_int40] = ACTIONS(390),
    [anon_sym_int48] = ACTIONS(390),
    [anon_sym_int56] = ACTIONS(390),
    [anon_sym_int64] = ACTIONS(390),
    [anon_sym_int72] = ACTIONS(390),
    [anon_sym_int80] = ACTIONS(390),
    [anon_sym_int88] = ACTIONS(390),
    [anon_sym_int96] = ACTIONS(390),
    [anon_sym_int104] = ACTIONS(390),
    [anon_sym_int112] = ACTIONS(390),
    [anon_sym_int120] = ACTIONS(390),
    [anon_sym_int128] = ACTIONS(390),
    [anon_sym_int136] = ACTIONS(390),
    [anon_sym_int144] = ACTIONS(390),
    [anon_sym_int152] = ACTIONS(390),
    [anon_sym_int160] = ACTIONS(390),
    [anon_sym_int168] = ACTIONS(390),
    [anon_sym_int176] = ACTIONS(390),
    [anon_sym_int184] = ACTIONS(390),
    [anon_sym_int192] = ACTIONS(390),
    [anon_sym_int200] = ACTIONS(390),
    [anon_sym_int208] = ACTIONS(390),
    [anon_sym_int216] = ACTIONS(390),
    [anon_sym_int224] = ACTIONS(390),
    [anon_sym_int232] = ACTIONS(390),
    [anon_sym_int240] = ACTIONS(390),
    [anon_sym_int248] = ACTIONS(390),
    [anon_sym_int256] = ACTIONS(390),
    [anon_sym_uint] = ACTIONS(390),
    [anon_sym_uint8] = ACTIONS(390),
    [anon_sym_uint16] = ACTIONS(390),
    [anon_sym_uint24] = ACTIONS(390),
    [anon_sym_uint32] = ACTIONS(390),
    [anon_sym_uint40] = ACTIONS(390),
    [anon_sym_uint48] = ACTIONS(390),
    [anon_sym_uint56] = ACTIONS(390),
    [anon_sym_uint64] = ACTIONS(390),
    [anon_sym_uint72] = ACTIONS(390),
    [anon_sym_uint80] = ACTIONS(390),
    [anon_sym_uint88] = ACTIONS(390),
    [anon_sym_uint96] = ACTIONS(390),
    [anon_sym_uint104] = ACTIONS(390),
    [anon_sym_uint112] = ACTIONS(390),
    [anon_sym_uint120] = ACTIONS(390),
    [anon_sym_uint128] = ACTIONS(390),
    [anon_sym_uint136] = ACTIONS(390),
    [anon_sym_uint144] = ACTIONS(390),
    [anon_sym_uint152] = ACTIONS(390),
    [anon_sym_uint160] = ACTIONS(390),
    [anon_sym_uint168] = ACTIONS(390),
    [anon_sym_uint176] = ACTIONS(390),
    [anon_sym_uint184] = ACTIONS(390),
    [anon_sym_uint192] = ACTIONS(390),
    [anon_sym_uint200] = ACTIONS(390),
    [anon_sym_uint208] = ACTIONS(390),
    [anon_sym_uint216] = ACTIONS(390),
    [anon_sym_uint224] = ACTIONS(390),
    [anon_sym_uint232] = ACTIONS(390),
    [anon_sym_uint240] = ACTIONS(390),
    [anon_sym_uint248] = ACTIONS(390),
    [anon_sym_uint256] = ACTIONS(390),
    [anon_sym_bytes] = ACTIONS(390),
    [anon_sym_bytes1] = ACTIONS(390),
    [anon_sym_bytes2] = ACTIONS(390),
    [anon_sym_bytes3] = ACTIONS(390),
    [anon_sym_bytes4] = ACTIONS(390),
    [anon_sym_bytes5] = ACTIONS(390),
    [anon_sym_bytes6] = ACTIONS(390),
    [anon_sym_bytes7] = ACTIONS(390),
    [anon_sym_bytes8] = ACTIONS(390),
    [anon_sym_bytes9] = ACTIONS(390),
    [anon_sym_bytes10] = ACTIONS(390),
    [anon_sym_bytes11] = ACTIONS(390),
    [anon_sym_bytes12] = ACTIONS(390),
    [anon_sym_bytes13] = ACTIONS(390),
    [anon_sym_bytes14] = ACTIONS(390),
    [anon_sym_bytes15] = ACTIONS(390),
    [anon_sym_bytes16] = ACTIONS(390),
    [anon_sym_bytes17] = ACTIONS(390),
    [anon_sym_bytes18] = ACTIONS(390),
    [anon_sym_bytes19] = ACTIONS(390),
    [anon_sym_bytes20] = ACTIONS(390),
    [anon_sym_bytes21] = ACTIONS(390),
    [anon_sym_bytes22] = ACTIONS(390),
    [anon_sym_bytes23] = ACTIONS(390),
    [anon_sym_bytes24] = ACTIONS(390),
    [anon_sym_bytes25] = ACTIONS(390),
    [anon_sym_bytes26] = ACTIONS(390),
    [anon_sym_bytes27] = ACTIONS(390),
    [anon_sym_bytes28] = ACTIONS(390),
    [anon_sym_bytes29] = ACTIONS(390),
    [anon_sym_bytes30] = ACTIONS(390),
    [anon_sym_bytes31] = ACTIONS(390),
    [anon_sym_bytes32] = ACTIONS(390),
    [anon_sym_fixed] = ACTIONS(390),
    [aux_sym__fixed_token1] = ACTIONS(390),
    [anon_sym_ufixed] = ACTIONS(390),
    [aux_sym__ufixed_token1] = ACTIONS(390),
    [aux_sym__decimal_number_token1] = ACTIONS(390),
    [aux_sym__decimal_number_token2] = ACTIONS(392),
    [aux_sym__hex_number_token1] = ACTIONS(392),
    [anon_sym_hex] = ACTIONS(390),
    [anon_sym_DQUOTE] = ACTIONS(392),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [anon_sym_unicode] = ACTIONS(390),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_user_defined_type_definition] = STATE(100),
    [sym_error_declaration] = STATE(100),
    [sym__contract_member] = STATE(100),
    [sym_struct_declaration] = STATE(100),
    [sym_enum_declaration] = STATE(100),
    [sym_event_definition] = STATE(100),
    [sym_using_directive] = STATE(100),
    [sym_state_variable_declaration] = STATE(100),
    [sym_modifier_definition] = STATE(100),
    [sym_constructor_definition] = STATE(100),
    [sym_fallback_receive_definition] = STATE(100),
    [sym_function_definition] = STATE(100),
    [sym_type_name] = STATE(490),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_contract_body_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_type] = ACTIONS(396),
    [anon_sym_error] = ACTIONS(398),
    [anon_sym_struct] = ACTIONS(400),
    [anon_sym_enum] = ACTIONS(402),
    [anon_sym_event] = ACTIONS(404),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(408),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_modifier] = ACTIONS(410),
    [anon_sym_constructor] = ACTIONS(412),
    [anon_sym_fallback] = ACTIONS(414),
    [anon_sym_receive] = ACTIONS(414),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(416),
    [anon_sym_DASH] = ACTIONS(416),
    [anon_sym_TILDE] = ACTIONS(418),
    [anon_sym_LBRACE] = ACTIONS(418),
    [anon_sym_RBRACE] = ACTIONS(418),
    [anon_sym_type] = ACTIONS(416),
    [anon_sym_LPAREN] = ACTIONS(418),
    [anon_sym_for] = ACTIONS(416),
    [anon_sym_assembly] = ACTIONS(416),
    [anon_sym_break] = ACTIONS(416),
    [anon_sym_continue] = ACTIONS(416),
    [anon_sym_true] = ACTIONS(416),
    [anon_sym_false] = ACTIONS(416),
    [anon_sym_if] = ACTIONS(416),
    [anon_sym_function] = ACTIONS(416),
    [anon_sym_byte] = ACTIONS(416),
    [anon_sym_address] = ACTIONS(416),
    [anon_sym_return] = ACTIONS(416),
    [anon_sym_revert] = ACTIONS(416),
    [sym_unchecked] = ACTIONS(416),
    [anon_sym_var] = ACTIONS(416),
    [anon_sym_else] = ACTIONS(416),
    [anon_sym_while] = ACTIONS(416),
    [anon_sym_do] = ACTIONS(416),
    [anon_sym_try] = ACTIONS(416),
    [anon_sym_emit] = ACTIONS(416),
    [anon_sym_payable] = ACTIONS(416),
    [anon_sym_new] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(418),
    [anon_sym_delete] = ACTIONS(416),
    [anon_sym_BANG] = ACTIONS(418),
    [anon_sym_PLUS_PLUS] = ACTIONS(418),
    [anon_sym_DASH_DASH] = ACTIONS(418),
    [anon_sym_mapping] = ACTIONS(416),
    [anon_sym_bool] = ACTIONS(416),
    [anon_sym_string] = ACTIONS(416),
    [anon_sym_int] = ACTIONS(416),
    [anon_sym_int8] = ACTIONS(416),
    [anon_sym_int16] = ACTIONS(416),
    [anon_sym_int24] = ACTIONS(416),
    [anon_sym_int32] = ACTIONS(416),
    [anon_sym_int40] = ACTIONS(416),
    [anon_sym_int48] = ACTIONS(416),
    [anon_sym_int56] = ACTIONS(416),
    [anon_sym_int64] = ACTIONS(416),
    [anon_sym_int72] = ACTIONS(416),
    [anon_sym_int80] = ACTIONS(416),
    [anon_sym_int88] = ACTIONS(416),
    [anon_sym_int96] = ACTIONS(416),
    [anon_sym_int104] = ACTIONS(416),
    [anon_sym_int112] = ACTIONS(416),
    [anon_sym_int120] = ACTIONS(416),
    [anon_sym_int128] = ACTIONS(416),
    [anon_sym_int136] = ACTIONS(416),
    [anon_sym_int144] = ACTIONS(416),
    [anon_sym_int152] = ACTIONS(416),
    [anon_sym_int160] = ACTIONS(416),
    [anon_sym_int168] = ACTIONS(416),
    [anon_sym_int176] = ACTIONS(416),
    [anon_sym_int184] = ACTIONS(416),
    [anon_sym_int192] = ACTIONS(416),
    [anon_sym_int200] = ACTIONS(416),
    [anon_sym_int208] = ACTIONS(416),
    [anon_sym_int216] = ACTIONS(416),
    [anon_sym_int224] = ACTIONS(416),
    [anon_sym_int232] = ACTIONS(416),
    [anon_sym_int240] = ACTIONS(416),
    [anon_sym_int248] = ACTIONS(416),
    [anon_sym_int256] = ACTIONS(416),
    [anon_sym_uint] = ACTIONS(416),
    [anon_sym_uint8] = ACTIONS(416),
    [anon_sym_uint16] = ACTIONS(416),
    [anon_sym_uint24] = ACTIONS(416),
    [anon_sym_uint32] = ACTIONS(416),
    [anon_sym_uint40] = ACTIONS(416),
    [anon_sym_uint48] = ACTIONS(416),
    [anon_sym_uint56] = ACTIONS(416),
    [anon_sym_uint64] = ACTIONS(416),
    [anon_sym_uint72] = ACTIONS(416),
    [anon_sym_uint80] = ACTIONS(416),
    [anon_sym_uint88] = ACTIONS(416),
    [anon_sym_uint96] = ACTIONS(416),
    [anon_sym_uint104] = ACTIONS(416),
    [anon_sym_uint112] = ACTIONS(416),
    [anon_sym_uint120] = ACTIONS(416),
    [anon_sym_uint128] = ACTIONS(416),
    [anon_sym_uint136] = ACTIONS(416),
    [anon_sym_uint144] = ACTIONS(416),
    [anon_sym_uint152] = ACTIONS(416),
    [anon_sym_uint160] = ACTIONS(416),
    [anon_sym_uint168] = ACTIONS(416),
    [anon_sym_uint176] = ACTIONS(416),
    [anon_sym_uint184] = ACTIONS(416),
    [anon_sym_uint192] = ACTIONS(416),
    [anon_sym_uint200] = ACTIONS(416),
    [anon_sym_uint208] = ACTIONS(416),
    [anon_sym_uint216] = ACTIONS(416),
    [anon_sym_uint224] = ACTIONS(416),
    [anon_sym_uint232] = ACTIONS(416),
    [anon_sym_uint240] = ACTIONS(416),
    [anon_sym_uint248] = ACTIONS(416),
    [anon_sym_uint256] = ACTIONS(416),
    [anon_sym_bytes] = ACTIONS(416),
    [anon_sym_bytes1] = ACTIONS(416),
    [anon_sym_bytes2] = ACTIONS(416),
    [anon_sym_bytes3] = ACTIONS(416),
    [anon_sym_bytes4] = ACTIONS(416),
    [anon_sym_bytes5] = ACTIONS(416),
    [anon_sym_bytes6] = ACTIONS(416),
    [anon_sym_bytes7] = ACTIONS(416),
    [anon_sym_bytes8] = ACTIONS(416),
    [anon_sym_bytes9] = ACTIONS(416),
    [anon_sym_bytes10] = ACTIONS(416),
    [anon_sym_bytes11] = ACTIONS(416),
    [anon_sym_bytes12] = ACTIONS(416),
    [anon_sym_bytes13] = ACTIONS(416),
    [anon_sym_bytes14] = ACTIONS(416),
    [anon_sym_bytes15] = ACTIONS(416),
    [anon_sym_bytes16] = ACTIONS(416),
    [anon_sym_bytes17] = ACTIONS(416),
    [anon_sym_bytes18] = ACTIONS(416),
    [anon_sym_bytes19] = ACTIONS(416),
    [anon_sym_bytes20] = ACTIONS(416),
    [anon_sym_bytes21] = ACTIONS(416),
    [anon_sym_bytes22] = ACTIONS(416),
    [anon_sym_bytes23] = ACTIONS(416),
    [anon_sym_bytes24] = ACTIONS(416),
    [anon_sym_bytes25] = ACTIONS(416),
    [anon_sym_bytes26] = ACTIONS(416),
    [anon_sym_bytes27] = ACTIONS(416),
    [anon_sym_bytes28] = ACTIONS(416),
    [anon_sym_bytes29] = ACTIONS(416),
    [anon_sym_bytes30] = ACTIONS(416),
    [anon_sym_bytes31] = ACTIONS(416),
    [anon_sym_bytes32] = ACTIONS(416),
    [anon_sym_fixed] = ACTIONS(416),
    [aux_sym__fixed_token1] = ACTIONS(416),
    [anon_sym_ufixed] = ACTIONS(416),
    [aux_sym__ufixed_token1] = ACTIONS(416),
    [anon_sym_SEMI] = ACTIONS(418),
    [aux_sym__decimal_number_token1] = ACTIONS(416),
    [aux_sym__decimal_number_token2] = ACTIONS(418),
    [aux_sym__hex_number_token1] = ACTIONS(418),
    [anon_sym_hex] = ACTIONS(416),
    [anon_sym_DQUOTE] = ACTIONS(418),
    [anon_sym_SQUOTE] = ACTIONS(418),
    [anon_sym_unicode] = ACTIONS(416),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_user_defined_type_definition] = STATE(95),
    [sym_error_declaration] = STATE(95),
    [sym__contract_member] = STATE(95),
    [sym_struct_declaration] = STATE(95),
    [sym_enum_declaration] = STATE(95),
    [sym_event_definition] = STATE(95),
    [sym_using_directive] = STATE(95),
    [sym_state_variable_declaration] = STATE(95),
    [sym_modifier_definition] = STATE(95),
    [sym_constructor_definition] = STATE(95),
    [sym_fallback_receive_definition] = STATE(95),
    [sym_function_definition] = STATE(95),
    [sym_type_name] = STATE(490),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_contract_body_repeat1] = STATE(95),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(420),
    [anon_sym_type] = ACTIONS(396),
    [anon_sym_error] = ACTIONS(398),
    [anon_sym_struct] = ACTIONS(400),
    [anon_sym_enum] = ACTIONS(402),
    [anon_sym_event] = ACTIONS(404),
    [anon_sym_using] = ACTIONS(406),
    [anon_sym_function] = ACTIONS(408),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_modifier] = ACTIONS(410),
    [anon_sym_constructor] = ACTIONS(412),
    [anon_sym_fallback] = ACTIONS(414),
    [anon_sym_receive] = ACTIONS(414),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(422),
    [anon_sym_DASH] = ACTIONS(422),
    [anon_sym_TILDE] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(424),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_type] = ACTIONS(422),
    [anon_sym_LPAREN] = ACTIONS(424),
    [anon_sym_for] = ACTIONS(422),
    [anon_sym_assembly] = ACTIONS(422),
    [anon_sym_break] = ACTIONS(422),
    [anon_sym_continue] = ACTIONS(422),
    [anon_sym_true] = ACTIONS(422),
    [anon_sym_false] = ACTIONS(422),
    [anon_sym_if] = ACTIONS(422),
    [anon_sym_function] = ACTIONS(422),
    [anon_sym_byte] = ACTIONS(422),
    [anon_sym_address] = ACTIONS(422),
    [anon_sym_return] = ACTIONS(422),
    [anon_sym_revert] = ACTIONS(422),
    [sym_unchecked] = ACTIONS(422),
    [anon_sym_var] = ACTIONS(422),
    [anon_sym_else] = ACTIONS(422),
    [anon_sym_while] = ACTIONS(422),
    [anon_sym_do] = ACTIONS(422),
    [anon_sym_try] = ACTIONS(422),
    [anon_sym_catch] = ACTIONS(422),
    [anon_sym_emit] = ACTIONS(422),
    [anon_sym_payable] = ACTIONS(422),
    [anon_sym_new] = ACTIONS(422),
    [anon_sym_LBRACK] = ACTIONS(424),
    [anon_sym_delete] = ACTIONS(422),
    [anon_sym_BANG] = ACTIONS(424),
    [anon_sym_PLUS_PLUS] = ACTIONS(424),
    [anon_sym_DASH_DASH] = ACTIONS(424),
    [anon_sym_mapping] = ACTIONS(422),
    [anon_sym_bool] = ACTIONS(422),
    [anon_sym_string] = ACTIONS(422),
    [anon_sym_int] = ACTIONS(422),
    [anon_sym_int8] = ACTIONS(422),
    [anon_sym_int16] = ACTIONS(422),
    [anon_sym_int24] = ACTIONS(422),
    [anon_sym_int32] = ACTIONS(422),
    [anon_sym_int40] = ACTIONS(422),
    [anon_sym_int48] = ACTIONS(422),
    [anon_sym_int56] = ACTIONS(422),
    [anon_sym_int64] = ACTIONS(422),
    [anon_sym_int72] = ACTIONS(422),
    [anon_sym_int80] = ACTIONS(422),
    [anon_sym_int88] = ACTIONS(422),
    [anon_sym_int96] = ACTIONS(422),
    [anon_sym_int104] = ACTIONS(422),
    [anon_sym_int112] = ACTIONS(422),
    [anon_sym_int120] = ACTIONS(422),
    [anon_sym_int128] = ACTIONS(422),
    [anon_sym_int136] = ACTIONS(422),
    [anon_sym_int144] = ACTIONS(422),
    [anon_sym_int152] = ACTIONS(422),
    [anon_sym_int160] = ACTIONS(422),
    [anon_sym_int168] = ACTIONS(422),
    [anon_sym_int176] = ACTIONS(422),
    [anon_sym_int184] = ACTIONS(422),
    [anon_sym_int192] = ACTIONS(422),
    [anon_sym_int200] = ACTIONS(422),
    [anon_sym_int208] = ACTIONS(422),
    [anon_sym_int216] = ACTIONS(422),
    [anon_sym_int224] = ACTIONS(422),
    [anon_sym_int232] = ACTIONS(422),
    [anon_sym_int240] = ACTIONS(422),
    [anon_sym_int248] = ACTIONS(422),
    [anon_sym_int256] = ACTIONS(422),
    [anon_sym_uint] = ACTIONS(422),
    [anon_sym_uint8] = ACTIONS(422),
    [anon_sym_uint16] = ACTIONS(422),
    [anon_sym_uint24] = ACTIONS(422),
    [anon_sym_uint32] = ACTIONS(422),
    [anon_sym_uint40] = ACTIONS(422),
    [anon_sym_uint48] = ACTIONS(422),
    [anon_sym_uint56] = ACTIONS(422),
    [anon_sym_uint64] = ACTIONS(422),
    [anon_sym_uint72] = ACTIONS(422),
    [anon_sym_uint80] = ACTIONS(422),
    [anon_sym_uint88] = ACTIONS(422),
    [anon_sym_uint96] = ACTIONS(422),
    [anon_sym_uint104] = ACTIONS(422),
    [anon_sym_uint112] = ACTIONS(422),
    [anon_sym_uint120] = ACTIONS(422),
    [anon_sym_uint128] = ACTIONS(422),
    [anon_sym_uint136] = ACTIONS(422),
    [anon_sym_uint144] = ACTIONS(422),
    [anon_sym_uint152] = ACTIONS(422),
    [anon_sym_uint160] = ACTIONS(422),
    [anon_sym_uint168] = ACTIONS(422),
    [anon_sym_uint176] = ACTIONS(422),
    [anon_sym_uint184] = ACTIONS(422),
    [anon_sym_uint192] = ACTIONS(422),
    [anon_sym_uint200] = ACTIONS(422),
    [anon_sym_uint208] = ACTIONS(422),
    [anon_sym_uint216] = ACTIONS(422),
    [anon_sym_uint224] = ACTIONS(422),
    [anon_sym_uint232] = ACTIONS(422),
    [anon_sym_uint240] = ACTIONS(422),
    [anon_sym_uint248] = ACTIONS(422),
    [anon_sym_uint256] = ACTIONS(422),
    [anon_sym_bytes] = ACTIONS(422),
    [anon_sym_bytes1] = ACTIONS(422),
    [anon_sym_bytes2] = ACTIONS(422),
    [anon_sym_bytes3] = ACTIONS(422),
    [anon_sym_bytes4] = ACTIONS(422),
    [anon_sym_bytes5] = ACTIONS(422),
    [anon_sym_bytes6] = ACTIONS(422),
    [anon_sym_bytes7] = ACTIONS(422),
    [anon_sym_bytes8] = ACTIONS(422),
    [anon_sym_bytes9] = ACTIONS(422),
    [anon_sym_bytes10] = ACTIONS(422),
    [anon_sym_bytes11] = ACTIONS(422),
    [anon_sym_bytes12] = ACTIONS(422),
    [anon_sym_bytes13] = ACTIONS(422),
    [anon_sym_bytes14] = ACTIONS(422),
    [anon_sym_bytes15] = ACTIONS(422),
    [anon_sym_bytes16] = ACTIONS(422),
    [anon_sym_bytes17] = ACTIONS(422),
    [anon_sym_bytes18] = ACTIONS(422),
    [anon_sym_bytes19] = ACTIONS(422),
    [anon_sym_bytes20] = ACTIONS(422),
    [anon_sym_bytes21] = ACTIONS(422),
    [anon_sym_bytes22] = ACTIONS(422),
    [anon_sym_bytes23] = ACTIONS(422),
    [anon_sym_bytes24] = ACTIONS(422),
    [anon_sym_bytes25] = ACTIONS(422),
    [anon_sym_bytes26] = ACTIONS(422),
    [anon_sym_bytes27] = ACTIONS(422),
    [anon_sym_bytes28] = ACTIONS(422),
    [anon_sym_bytes29] = ACTIONS(422),
    [anon_sym_bytes30] = ACTIONS(422),
    [anon_sym_bytes31] = ACTIONS(422),
    [anon_sym_bytes32] = ACTIONS(422),
    [anon_sym_fixed] = ACTIONS(422),
    [aux_sym__fixed_token1] = ACTIONS(422),
    [anon_sym_ufixed] = ACTIONS(422),
    [aux_sym__ufixed_token1] = ACTIONS(422),
    [aux_sym__decimal_number_token1] = ACTIONS(422),
    [aux_sym__decimal_number_token2] = ACTIONS(424),
    [aux_sym__hex_number_token1] = ACTIONS(424),
    [anon_sym_hex] = ACTIONS(422),
    [anon_sym_DQUOTE] = ACTIONS(424),
    [anon_sym_SQUOTE] = ACTIONS(424),
    [anon_sym_unicode] = ACTIONS(422),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_identifier] = ACTIONS(426),
    [anon_sym_DASH] = ACTIONS(426),
    [anon_sym_TILDE] = ACTIONS(428),
    [anon_sym_LBRACE] = ACTIONS(428),
    [anon_sym_RBRACE] = ACTIONS(428),
    [anon_sym_type] = ACTIONS(426),
    [anon_sym_LPAREN] = ACTIONS(428),
    [anon_sym_for] = ACTIONS(426),
    [anon_sym_assembly] = ACTIONS(426),
    [anon_sym_break] = ACTIONS(426),
    [anon_sym_continue] = ACTIONS(426),
    [anon_sym_true] = ACTIONS(426),
    [anon_sym_false] = ACTIONS(426),
    [anon_sym_if] = ACTIONS(426),
    [anon_sym_function] = ACTIONS(426),
    [anon_sym_byte] = ACTIONS(426),
    [anon_sym_address] = ACTIONS(426),
    [anon_sym_return] = ACTIONS(426),
    [anon_sym_revert] = ACTIONS(426),
    [sym_unchecked] = ACTIONS(426),
    [anon_sym_var] = ACTIONS(426),
    [anon_sym_else] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(426),
    [anon_sym_do] = ACTIONS(426),
    [anon_sym_try] = ACTIONS(426),
    [anon_sym_catch] = ACTIONS(426),
    [anon_sym_emit] = ACTIONS(426),
    [anon_sym_payable] = ACTIONS(426),
    [anon_sym_new] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(428),
    [anon_sym_delete] = ACTIONS(426),
    [anon_sym_BANG] = ACTIONS(428),
    [anon_sym_PLUS_PLUS] = ACTIONS(428),
    [anon_sym_DASH_DASH] = ACTIONS(428),
    [anon_sym_mapping] = ACTIONS(426),
    [anon_sym_bool] = ACTIONS(426),
    [anon_sym_string] = ACTIONS(426),
    [anon_sym_int] = ACTIONS(426),
    [anon_sym_int8] = ACTIONS(426),
    [anon_sym_int16] = ACTIONS(426),
    [anon_sym_int24] = ACTIONS(426),
    [anon_sym_int32] = ACTIONS(426),
    [anon_sym_int40] = ACTIONS(426),
    [anon_sym_int48] = ACTIONS(426),
    [anon_sym_int56] = ACTIONS(426),
    [anon_sym_int64] = ACTIONS(426),
    [anon_sym_int72] = ACTIONS(426),
    [anon_sym_int80] = ACTIONS(426),
    [anon_sym_int88] = ACTIONS(426),
    [anon_sym_int96] = ACTIONS(426),
    [anon_sym_int104] = ACTIONS(426),
    [anon_sym_int112] = ACTIONS(426),
    [anon_sym_int120] = ACTIONS(426),
    [anon_sym_int128] = ACTIONS(426),
    [anon_sym_int136] = ACTIONS(426),
    [anon_sym_int144] = ACTIONS(426),
    [anon_sym_int152] = ACTIONS(426),
    [anon_sym_int160] = ACTIONS(426),
    [anon_sym_int168] = ACTIONS(426),
    [anon_sym_int176] = ACTIONS(426),
    [anon_sym_int184] = ACTIONS(426),
    [anon_sym_int192] = ACTIONS(426),
    [anon_sym_int200] = ACTIONS(426),
    [anon_sym_int208] = ACTIONS(426),
    [anon_sym_int216] = ACTIONS(426),
    [anon_sym_int224] = ACTIONS(426),
    [anon_sym_int232] = ACTIONS(426),
    [anon_sym_int240] = ACTIONS(426),
    [anon_sym_int248] = ACTIONS(426),
    [anon_sym_int256] = ACTIONS(426),
    [anon_sym_uint] = ACTIONS(426),
    [anon_sym_uint8] = ACTIONS(426),
    [anon_sym_uint16] = ACTIONS(426),
    [anon_sym_uint24] = ACTIONS(426),
    [anon_sym_uint32] = ACTIONS(426),
    [anon_sym_uint40] = ACTIONS(426),
    [anon_sym_uint48] = ACTIONS(426),
    [anon_sym_uint56] = ACTIONS(426),
    [anon_sym_uint64] = ACTIONS(426),
    [anon_sym_uint72] = ACTIONS(426),
    [anon_sym_uint80] = ACTIONS(426),
    [anon_sym_uint88] = ACTIONS(426),
    [anon_sym_uint96] = ACTIONS(426),
    [anon_sym_uint104] = ACTIONS(426),
    [anon_sym_uint112] = ACTIONS(426),
    [anon_sym_uint120] = ACTIONS(426),
    [anon_sym_uint128] = ACTIONS(426),
    [anon_sym_uint136] = ACTIONS(426),
    [anon_sym_uint144] = ACTIONS(426),
    [anon_sym_uint152] = ACTIONS(426),
    [anon_sym_uint160] = ACTIONS(426),
    [anon_sym_uint168] = ACTIONS(426),
    [anon_sym_uint176] = ACTIONS(426),
    [anon_sym_uint184] = ACTIONS(426),
    [anon_sym_uint192] = ACTIONS(426),
    [anon_sym_uint200] = ACTIONS(426),
    [anon_sym_uint208] = ACTIONS(426),
    [anon_sym_uint216] = ACTIONS(426),
    [anon_sym_uint224] = ACTIONS(426),
    [anon_sym_uint232] = ACTIONS(426),
    [anon_sym_uint240] = ACTIONS(426),
    [anon_sym_uint248] = ACTIONS(426),
    [anon_sym_uint256] = ACTIONS(426),
    [anon_sym_bytes] = ACTIONS(426),
    [anon_sym_bytes1] = ACTIONS(426),
    [anon_sym_bytes2] = ACTIONS(426),
    [anon_sym_bytes3] = ACTIONS(426),
    [anon_sym_bytes4] = ACTIONS(426),
    [anon_sym_bytes5] = ACTIONS(426),
    [anon_sym_bytes6] = ACTIONS(426),
    [anon_sym_bytes7] = ACTIONS(426),
    [anon_sym_bytes8] = ACTIONS(426),
    [anon_sym_bytes9] = ACTIONS(426),
    [anon_sym_bytes10] = ACTIONS(426),
    [anon_sym_bytes11] = ACTIONS(426),
    [anon_sym_bytes12] = ACTIONS(426),
    [anon_sym_bytes13] = ACTIONS(426),
    [anon_sym_bytes14] = ACTIONS(426),
    [anon_sym_bytes15] = ACTIONS(426),
    [anon_sym_bytes16] = ACTIONS(426),
    [anon_sym_bytes17] = ACTIONS(426),
    [anon_sym_bytes18] = ACTIONS(426),
    [anon_sym_bytes19] = ACTIONS(426),
    [anon_sym_bytes20] = ACTIONS(426),
    [anon_sym_bytes21] = ACTIONS(426),
    [anon_sym_bytes22] = ACTIONS(426),
    [anon_sym_bytes23] = ACTIONS(426),
    [anon_sym_bytes24] = ACTIONS(426),
    [anon_sym_bytes25] = ACTIONS(426),
    [anon_sym_bytes26] = ACTIONS(426),
    [anon_sym_bytes27] = ACTIONS(426),
    [anon_sym_bytes28] = ACTIONS(426),
    [anon_sym_bytes29] = ACTIONS(426),
    [anon_sym_bytes30] = ACTIONS(426),
    [anon_sym_bytes31] = ACTIONS(426),
    [anon_sym_bytes32] = ACTIONS(426),
    [anon_sym_fixed] = ACTIONS(426),
    [aux_sym__fixed_token1] = ACTIONS(426),
    [anon_sym_ufixed] = ACTIONS(426),
    [aux_sym__ufixed_token1] = ACTIONS(426),
    [aux_sym__decimal_number_token1] = ACTIONS(426),
    [aux_sym__decimal_number_token2] = ACTIONS(428),
    [aux_sym__hex_number_token1] = ACTIONS(428),
    [anon_sym_hex] = ACTIONS(426),
    [anon_sym_DQUOTE] = ACTIONS(428),
    [anon_sym_SQUOTE] = ACTIONS(428),
    [anon_sym_unicode] = ACTIONS(426),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_user_defined_type_definition] = STATE(100),
    [sym_error_declaration] = STATE(100),
    [sym__contract_member] = STATE(100),
    [sym_struct_declaration] = STATE(100),
    [sym_enum_declaration] = STATE(100),
    [sym_event_definition] = STATE(100),
    [sym_using_directive] = STATE(100),
    [sym_state_variable_declaration] = STATE(100),
    [sym_modifier_definition] = STATE(100),
    [sym_constructor_definition] = STATE(100),
    [sym_fallback_receive_definition] = STATE(100),
    [sym_function_definition] = STATE(100),
    [sym_type_name] = STATE(490),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_contract_body_repeat1] = STATE(100),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_RBRACE] = ACTIONS(433),
    [anon_sym_type] = ACTIONS(435),
    [anon_sym_error] = ACTIONS(438),
    [anon_sym_struct] = ACTIONS(441),
    [anon_sym_enum] = ACTIONS(444),
    [anon_sym_event] = ACTIONS(447),
    [anon_sym_using] = ACTIONS(450),
    [anon_sym_function] = ACTIONS(453),
    [anon_sym_byte] = ACTIONS(456),
    [anon_sym_address] = ACTIONS(459),
    [anon_sym_var] = ACTIONS(456),
    [anon_sym_modifier] = ACTIONS(462),
    [anon_sym_constructor] = ACTIONS(465),
    [anon_sym_fallback] = ACTIONS(468),
    [anon_sym_receive] = ACTIONS(468),
    [anon_sym_mapping] = ACTIONS(471),
    [anon_sym_bool] = ACTIONS(456),
    [anon_sym_string] = ACTIONS(456),
    [anon_sym_int] = ACTIONS(456),
    [anon_sym_int8] = ACTIONS(456),
    [anon_sym_int16] = ACTIONS(456),
    [anon_sym_int24] = ACTIONS(456),
    [anon_sym_int32] = ACTIONS(456),
    [anon_sym_int40] = ACTIONS(456),
    [anon_sym_int48] = ACTIONS(456),
    [anon_sym_int56] = ACTIONS(456),
    [anon_sym_int64] = ACTIONS(456),
    [anon_sym_int72] = ACTIONS(456),
    [anon_sym_int80] = ACTIONS(456),
    [anon_sym_int88] = ACTIONS(456),
    [anon_sym_int96] = ACTIONS(456),
    [anon_sym_int104] = ACTIONS(456),
    [anon_sym_int112] = ACTIONS(456),
    [anon_sym_int120] = ACTIONS(456),
    [anon_sym_int128] = ACTIONS(456),
    [anon_sym_int136] = ACTIONS(456),
    [anon_sym_int144] = ACTIONS(456),
    [anon_sym_int152] = ACTIONS(456),
    [anon_sym_int160] = ACTIONS(456),
    [anon_sym_int168] = ACTIONS(456),
    [anon_sym_int176] = ACTIONS(456),
    [anon_sym_int184] = ACTIONS(456),
    [anon_sym_int192] = ACTIONS(456),
    [anon_sym_int200] = ACTIONS(456),
    [anon_sym_int208] = ACTIONS(456),
    [anon_sym_int216] = ACTIONS(456),
    [anon_sym_int224] = ACTIONS(456),
    [anon_sym_int232] = ACTIONS(456),
    [anon_sym_int240] = ACTIONS(456),
    [anon_sym_int248] = ACTIONS(456),
    [anon_sym_int256] = ACTIONS(456),
    [anon_sym_uint] = ACTIONS(456),
    [anon_sym_uint8] = ACTIONS(456),
    [anon_sym_uint16] = ACTIONS(456),
    [anon_sym_uint24] = ACTIONS(456),
    [anon_sym_uint32] = ACTIONS(456),
    [anon_sym_uint40] = ACTIONS(456),
    [anon_sym_uint48] = ACTIONS(456),
    [anon_sym_uint56] = ACTIONS(456),
    [anon_sym_uint64] = ACTIONS(456),
    [anon_sym_uint72] = ACTIONS(456),
    [anon_sym_uint80] = ACTIONS(456),
    [anon_sym_uint88] = ACTIONS(456),
    [anon_sym_uint96] = ACTIONS(456),
    [anon_sym_uint104] = ACTIONS(456),
    [anon_sym_uint112] = ACTIONS(456),
    [anon_sym_uint120] = ACTIONS(456),
    [anon_sym_uint128] = ACTIONS(456),
    [anon_sym_uint136] = ACTIONS(456),
    [anon_sym_uint144] = ACTIONS(456),
    [anon_sym_uint152] = ACTIONS(456),
    [anon_sym_uint160] = ACTIONS(456),
    [anon_sym_uint168] = ACTIONS(456),
    [anon_sym_uint176] = ACTIONS(456),
    [anon_sym_uint184] = ACTIONS(456),
    [anon_sym_uint192] = ACTIONS(456),
    [anon_sym_uint200] = ACTIONS(456),
    [anon_sym_uint208] = ACTIONS(456),
    [anon_sym_uint216] = ACTIONS(456),
    [anon_sym_uint224] = ACTIONS(456),
    [anon_sym_uint232] = ACTIONS(456),
    [anon_sym_uint240] = ACTIONS(456),
    [anon_sym_uint248] = ACTIONS(456),
    [anon_sym_uint256] = ACTIONS(456),
    [anon_sym_bytes] = ACTIONS(456),
    [anon_sym_bytes1] = ACTIONS(456),
    [anon_sym_bytes2] = ACTIONS(456),
    [anon_sym_bytes3] = ACTIONS(456),
    [anon_sym_bytes4] = ACTIONS(456),
    [anon_sym_bytes5] = ACTIONS(456),
    [anon_sym_bytes6] = ACTIONS(456),
    [anon_sym_bytes7] = ACTIONS(456),
    [anon_sym_bytes8] = ACTIONS(456),
    [anon_sym_bytes9] = ACTIONS(456),
    [anon_sym_bytes10] = ACTIONS(456),
    [anon_sym_bytes11] = ACTIONS(456),
    [anon_sym_bytes12] = ACTIONS(456),
    [anon_sym_bytes13] = ACTIONS(456),
    [anon_sym_bytes14] = ACTIONS(456),
    [anon_sym_bytes15] = ACTIONS(456),
    [anon_sym_bytes16] = ACTIONS(456),
    [anon_sym_bytes17] = ACTIONS(456),
    [anon_sym_bytes18] = ACTIONS(456),
    [anon_sym_bytes19] = ACTIONS(456),
    [anon_sym_bytes20] = ACTIONS(456),
    [anon_sym_bytes21] = ACTIONS(456),
    [anon_sym_bytes22] = ACTIONS(456),
    [anon_sym_bytes23] = ACTIONS(456),
    [anon_sym_bytes24] = ACTIONS(456),
    [anon_sym_bytes25] = ACTIONS(456),
    [anon_sym_bytes26] = ACTIONS(456),
    [anon_sym_bytes27] = ACTIONS(456),
    [anon_sym_bytes28] = ACTIONS(456),
    [anon_sym_bytes29] = ACTIONS(456),
    [anon_sym_bytes30] = ACTIONS(456),
    [anon_sym_bytes31] = ACTIONS(456),
    [anon_sym_bytes32] = ACTIONS(456),
    [anon_sym_fixed] = ACTIONS(456),
    [aux_sym__fixed_token1] = ACTIONS(456),
    [anon_sym_ufixed] = ACTIONS(456),
    [aux_sym__ufixed_token1] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(474),
    [anon_sym_DASH] = ACTIONS(474),
    [anon_sym_TILDE] = ACTIONS(476),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_RBRACE] = ACTIONS(476),
    [anon_sym_type] = ACTIONS(474),
    [anon_sym_LPAREN] = ACTIONS(476),
    [anon_sym_for] = ACTIONS(474),
    [anon_sym_assembly] = ACTIONS(474),
    [anon_sym_break] = ACTIONS(474),
    [anon_sym_continue] = ACTIONS(474),
    [anon_sym_true] = ACTIONS(474),
    [anon_sym_false] = ACTIONS(474),
    [anon_sym_if] = ACTIONS(474),
    [anon_sym_function] = ACTIONS(474),
    [anon_sym_byte] = ACTIONS(474),
    [anon_sym_address] = ACTIONS(474),
    [anon_sym_return] = ACTIONS(474),
    [anon_sym_revert] = ACTIONS(474),
    [sym_unchecked] = ACTIONS(474),
    [anon_sym_var] = ACTIONS(474),
    [anon_sym_else] = ACTIONS(474),
    [anon_sym_while] = ACTIONS(474),
    [anon_sym_do] = ACTIONS(474),
    [anon_sym_try] = ACTIONS(474),
    [anon_sym_catch] = ACTIONS(474),
    [anon_sym_emit] = ACTIONS(474),
    [anon_sym_payable] = ACTIONS(474),
    [anon_sym_new] = ACTIONS(474),
    [anon_sym_LBRACK] = ACTIONS(476),
    [anon_sym_delete] = ACTIONS(474),
    [anon_sym_BANG] = ACTIONS(476),
    [anon_sym_PLUS_PLUS] = ACTIONS(476),
    [anon_sym_DASH_DASH] = ACTIONS(476),
    [anon_sym_mapping] = ACTIONS(474),
    [anon_sym_bool] = ACTIONS(474),
    [anon_sym_string] = ACTIONS(474),
    [anon_sym_int] = ACTIONS(474),
    [anon_sym_int8] = ACTIONS(474),
    [anon_sym_int16] = ACTIONS(474),
    [anon_sym_int24] = ACTIONS(474),
    [anon_sym_int32] = ACTIONS(474),
    [anon_sym_int40] = ACTIONS(474),
    [anon_sym_int48] = ACTIONS(474),
    [anon_sym_int56] = ACTIONS(474),
    [anon_sym_int64] = ACTIONS(474),
    [anon_sym_int72] = ACTIONS(474),
    [anon_sym_int80] = ACTIONS(474),
    [anon_sym_int88] = ACTIONS(474),
    [anon_sym_int96] = ACTIONS(474),
    [anon_sym_int104] = ACTIONS(474),
    [anon_sym_int112] = ACTIONS(474),
    [anon_sym_int120] = ACTIONS(474),
    [anon_sym_int128] = ACTIONS(474),
    [anon_sym_int136] = ACTIONS(474),
    [anon_sym_int144] = ACTIONS(474),
    [anon_sym_int152] = ACTIONS(474),
    [anon_sym_int160] = ACTIONS(474),
    [anon_sym_int168] = ACTIONS(474),
    [anon_sym_int176] = ACTIONS(474),
    [anon_sym_int184] = ACTIONS(474),
    [anon_sym_int192] = ACTIONS(474),
    [anon_sym_int200] = ACTIONS(474),
    [anon_sym_int208] = ACTIONS(474),
    [anon_sym_int216] = ACTIONS(474),
    [anon_sym_int224] = ACTIONS(474),
    [anon_sym_int232] = ACTIONS(474),
    [anon_sym_int240] = ACTIONS(474),
    [anon_sym_int248] = ACTIONS(474),
    [anon_sym_int256] = ACTIONS(474),
    [anon_sym_uint] = ACTIONS(474),
    [anon_sym_uint8] = ACTIONS(474),
    [anon_sym_uint16] = ACTIONS(474),
    [anon_sym_uint24] = ACTIONS(474),
    [anon_sym_uint32] = ACTIONS(474),
    [anon_sym_uint40] = ACTIONS(474),
    [anon_sym_uint48] = ACTIONS(474),
    [anon_sym_uint56] = ACTIONS(474),
    [anon_sym_uint64] = ACTIONS(474),
    [anon_sym_uint72] = ACTIONS(474),
    [anon_sym_uint80] = ACTIONS(474),
    [anon_sym_uint88] = ACTIONS(474),
    [anon_sym_uint96] = ACTIONS(474),
    [anon_sym_uint104] = ACTIONS(474),
    [anon_sym_uint112] = ACTIONS(474),
    [anon_sym_uint120] = ACTIONS(474),
    [anon_sym_uint128] = ACTIONS(474),
    [anon_sym_uint136] = ACTIONS(474),
    [anon_sym_uint144] = ACTIONS(474),
    [anon_sym_uint152] = ACTIONS(474),
    [anon_sym_uint160] = ACTIONS(474),
    [anon_sym_uint168] = ACTIONS(474),
    [anon_sym_uint176] = ACTIONS(474),
    [anon_sym_uint184] = ACTIONS(474),
    [anon_sym_uint192] = ACTIONS(474),
    [anon_sym_uint200] = ACTIONS(474),
    [anon_sym_uint208] = ACTIONS(474),
    [anon_sym_uint216] = ACTIONS(474),
    [anon_sym_uint224] = ACTIONS(474),
    [anon_sym_uint232] = ACTIONS(474),
    [anon_sym_uint240] = ACTIONS(474),
    [anon_sym_uint248] = ACTIONS(474),
    [anon_sym_uint256] = ACTIONS(474),
    [anon_sym_bytes] = ACTIONS(474),
    [anon_sym_bytes1] = ACTIONS(474),
    [anon_sym_bytes2] = ACTIONS(474),
    [anon_sym_bytes3] = ACTIONS(474),
    [anon_sym_bytes4] = ACTIONS(474),
    [anon_sym_bytes5] = ACTIONS(474),
    [anon_sym_bytes6] = ACTIONS(474),
    [anon_sym_bytes7] = ACTIONS(474),
    [anon_sym_bytes8] = ACTIONS(474),
    [anon_sym_bytes9] = ACTIONS(474),
    [anon_sym_bytes10] = ACTIONS(474),
    [anon_sym_bytes11] = ACTIONS(474),
    [anon_sym_bytes12] = ACTIONS(474),
    [anon_sym_bytes13] = ACTIONS(474),
    [anon_sym_bytes14] = ACTIONS(474),
    [anon_sym_bytes15] = ACTIONS(474),
    [anon_sym_bytes16] = ACTIONS(474),
    [anon_sym_bytes17] = ACTIONS(474),
    [anon_sym_bytes18] = ACTIONS(474),
    [anon_sym_bytes19] = ACTIONS(474),
    [anon_sym_bytes20] = ACTIONS(474),
    [anon_sym_bytes21] = ACTIONS(474),
    [anon_sym_bytes22] = ACTIONS(474),
    [anon_sym_bytes23] = ACTIONS(474),
    [anon_sym_bytes24] = ACTIONS(474),
    [anon_sym_bytes25] = ACTIONS(474),
    [anon_sym_bytes26] = ACTIONS(474),
    [anon_sym_bytes27] = ACTIONS(474),
    [anon_sym_bytes28] = ACTIONS(474),
    [anon_sym_bytes29] = ACTIONS(474),
    [anon_sym_bytes30] = ACTIONS(474),
    [anon_sym_bytes31] = ACTIONS(474),
    [anon_sym_bytes32] = ACTIONS(474),
    [anon_sym_fixed] = ACTIONS(474),
    [aux_sym__fixed_token1] = ACTIONS(474),
    [anon_sym_ufixed] = ACTIONS(474),
    [aux_sym__ufixed_token1] = ACTIONS(474),
    [aux_sym__decimal_number_token1] = ACTIONS(474),
    [aux_sym__decimal_number_token2] = ACTIONS(476),
    [aux_sym__hex_number_token1] = ACTIONS(476),
    [anon_sym_hex] = ACTIONS(474),
    [anon_sym_DQUOTE] = ACTIONS(476),
    [anon_sym_SQUOTE] = ACTIONS(476),
    [anon_sym_unicode] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(478),
    [anon_sym_DASH] = ACTIONS(478),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_LBRACE] = ACTIONS(480),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_type] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_for] = ACTIONS(478),
    [anon_sym_assembly] = ACTIONS(478),
    [anon_sym_break] = ACTIONS(478),
    [anon_sym_continue] = ACTIONS(478),
    [anon_sym_true] = ACTIONS(478),
    [anon_sym_false] = ACTIONS(478),
    [anon_sym_if] = ACTIONS(478),
    [anon_sym_function] = ACTIONS(478),
    [anon_sym_byte] = ACTIONS(478),
    [anon_sym_address] = ACTIONS(478),
    [anon_sym_return] = ACTIONS(478),
    [anon_sym_revert] = ACTIONS(478),
    [sym_unchecked] = ACTIONS(478),
    [anon_sym_var] = ACTIONS(478),
    [anon_sym_else] = ACTIONS(478),
    [anon_sym_while] = ACTIONS(478),
    [anon_sym_do] = ACTIONS(478),
    [anon_sym_try] = ACTIONS(478),
    [anon_sym_catch] = ACTIONS(478),
    [anon_sym_emit] = ACTIONS(478),
    [anon_sym_payable] = ACTIONS(478),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_LBRACK] = ACTIONS(480),
    [anon_sym_delete] = ACTIONS(478),
    [anon_sym_BANG] = ACTIONS(480),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_mapping] = ACTIONS(478),
    [anon_sym_bool] = ACTIONS(478),
    [anon_sym_string] = ACTIONS(478),
    [anon_sym_int] = ACTIONS(478),
    [anon_sym_int8] = ACTIONS(478),
    [anon_sym_int16] = ACTIONS(478),
    [anon_sym_int24] = ACTIONS(478),
    [anon_sym_int32] = ACTIONS(478),
    [anon_sym_int40] = ACTIONS(478),
    [anon_sym_int48] = ACTIONS(478),
    [anon_sym_int56] = ACTIONS(478),
    [anon_sym_int64] = ACTIONS(478),
    [anon_sym_int72] = ACTIONS(478),
    [anon_sym_int80] = ACTIONS(478),
    [anon_sym_int88] = ACTIONS(478),
    [anon_sym_int96] = ACTIONS(478),
    [anon_sym_int104] = ACTIONS(478),
    [anon_sym_int112] = ACTIONS(478),
    [anon_sym_int120] = ACTIONS(478),
    [anon_sym_int128] = ACTIONS(478),
    [anon_sym_int136] = ACTIONS(478),
    [anon_sym_int144] = ACTIONS(478),
    [anon_sym_int152] = ACTIONS(478),
    [anon_sym_int160] = ACTIONS(478),
    [anon_sym_int168] = ACTIONS(478),
    [anon_sym_int176] = ACTIONS(478),
    [anon_sym_int184] = ACTIONS(478),
    [anon_sym_int192] = ACTIONS(478),
    [anon_sym_int200] = ACTIONS(478),
    [anon_sym_int208] = ACTIONS(478),
    [anon_sym_int216] = ACTIONS(478),
    [anon_sym_int224] = ACTIONS(478),
    [anon_sym_int232] = ACTIONS(478),
    [anon_sym_int240] = ACTIONS(478),
    [anon_sym_int248] = ACTIONS(478),
    [anon_sym_int256] = ACTIONS(478),
    [anon_sym_uint] = ACTIONS(478),
    [anon_sym_uint8] = ACTIONS(478),
    [anon_sym_uint16] = ACTIONS(478),
    [anon_sym_uint24] = ACTIONS(478),
    [anon_sym_uint32] = ACTIONS(478),
    [anon_sym_uint40] = ACTIONS(478),
    [anon_sym_uint48] = ACTIONS(478),
    [anon_sym_uint56] = ACTIONS(478),
    [anon_sym_uint64] = ACTIONS(478),
    [anon_sym_uint72] = ACTIONS(478),
    [anon_sym_uint80] = ACTIONS(478),
    [anon_sym_uint88] = ACTIONS(478),
    [anon_sym_uint96] = ACTIONS(478),
    [anon_sym_uint104] = ACTIONS(478),
    [anon_sym_uint112] = ACTIONS(478),
    [anon_sym_uint120] = ACTIONS(478),
    [anon_sym_uint128] = ACTIONS(478),
    [anon_sym_uint136] = ACTIONS(478),
    [anon_sym_uint144] = ACTIONS(478),
    [anon_sym_uint152] = ACTIONS(478),
    [anon_sym_uint160] = ACTIONS(478),
    [anon_sym_uint168] = ACTIONS(478),
    [anon_sym_uint176] = ACTIONS(478),
    [anon_sym_uint184] = ACTIONS(478),
    [anon_sym_uint192] = ACTIONS(478),
    [anon_sym_uint200] = ACTIONS(478),
    [anon_sym_uint208] = ACTIONS(478),
    [anon_sym_uint216] = ACTIONS(478),
    [anon_sym_uint224] = ACTIONS(478),
    [anon_sym_uint232] = ACTIONS(478),
    [anon_sym_uint240] = ACTIONS(478),
    [anon_sym_uint248] = ACTIONS(478),
    [anon_sym_uint256] = ACTIONS(478),
    [anon_sym_bytes] = ACTIONS(478),
    [anon_sym_bytes1] = ACTIONS(478),
    [anon_sym_bytes2] = ACTIONS(478),
    [anon_sym_bytes3] = ACTIONS(478),
    [anon_sym_bytes4] = ACTIONS(478),
    [anon_sym_bytes5] = ACTIONS(478),
    [anon_sym_bytes6] = ACTIONS(478),
    [anon_sym_bytes7] = ACTIONS(478),
    [anon_sym_bytes8] = ACTIONS(478),
    [anon_sym_bytes9] = ACTIONS(478),
    [anon_sym_bytes10] = ACTIONS(478),
    [anon_sym_bytes11] = ACTIONS(478),
    [anon_sym_bytes12] = ACTIONS(478),
    [anon_sym_bytes13] = ACTIONS(478),
    [anon_sym_bytes14] = ACTIONS(478),
    [anon_sym_bytes15] = ACTIONS(478),
    [anon_sym_bytes16] = ACTIONS(478),
    [anon_sym_bytes17] = ACTIONS(478),
    [anon_sym_bytes18] = ACTIONS(478),
    [anon_sym_bytes19] = ACTIONS(478),
    [anon_sym_bytes20] = ACTIONS(478),
    [anon_sym_bytes21] = ACTIONS(478),
    [anon_sym_bytes22] = ACTIONS(478),
    [anon_sym_bytes23] = ACTIONS(478),
    [anon_sym_bytes24] = ACTIONS(478),
    [anon_sym_bytes25] = ACTIONS(478),
    [anon_sym_bytes26] = ACTIONS(478),
    [anon_sym_bytes27] = ACTIONS(478),
    [anon_sym_bytes28] = ACTIONS(478),
    [anon_sym_bytes29] = ACTIONS(478),
    [anon_sym_bytes30] = ACTIONS(478),
    [anon_sym_bytes31] = ACTIONS(478),
    [anon_sym_bytes32] = ACTIONS(478),
    [anon_sym_fixed] = ACTIONS(478),
    [aux_sym__fixed_token1] = ACTIONS(478),
    [anon_sym_ufixed] = ACTIONS(478),
    [aux_sym__ufixed_token1] = ACTIONS(478),
    [aux_sym__decimal_number_token1] = ACTIONS(478),
    [aux_sym__decimal_number_token2] = ACTIONS(480),
    [aux_sym__hex_number_token1] = ACTIONS(480),
    [anon_sym_hex] = ACTIONS(478),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(480),
    [anon_sym_unicode] = ACTIONS(478),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(482),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_LBRACE] = ACTIONS(484),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_type] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_for] = ACTIONS(482),
    [anon_sym_assembly] = ACTIONS(482),
    [anon_sym_break] = ACTIONS(482),
    [anon_sym_continue] = ACTIONS(482),
    [anon_sym_true] = ACTIONS(482),
    [anon_sym_false] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(482),
    [anon_sym_function] = ACTIONS(482),
    [anon_sym_byte] = ACTIONS(482),
    [anon_sym_address] = ACTIONS(482),
    [anon_sym_return] = ACTIONS(482),
    [anon_sym_revert] = ACTIONS(482),
    [sym_unchecked] = ACTIONS(482),
    [anon_sym_var] = ACTIONS(482),
    [anon_sym_else] = ACTIONS(482),
    [anon_sym_while] = ACTIONS(482),
    [anon_sym_do] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(482),
    [anon_sym_catch] = ACTIONS(482),
    [anon_sym_emit] = ACTIONS(482),
    [anon_sym_payable] = ACTIONS(482),
    [anon_sym_new] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(484),
    [anon_sym_delete] = ACTIONS(482),
    [anon_sym_BANG] = ACTIONS(484),
    [anon_sym_PLUS_PLUS] = ACTIONS(484),
    [anon_sym_DASH_DASH] = ACTIONS(484),
    [anon_sym_mapping] = ACTIONS(482),
    [anon_sym_bool] = ACTIONS(482),
    [anon_sym_string] = ACTIONS(482),
    [anon_sym_int] = ACTIONS(482),
    [anon_sym_int8] = ACTIONS(482),
    [anon_sym_int16] = ACTIONS(482),
    [anon_sym_int24] = ACTIONS(482),
    [anon_sym_int32] = ACTIONS(482),
    [anon_sym_int40] = ACTIONS(482),
    [anon_sym_int48] = ACTIONS(482),
    [anon_sym_int56] = ACTIONS(482),
    [anon_sym_int64] = ACTIONS(482),
    [anon_sym_int72] = ACTIONS(482),
    [anon_sym_int80] = ACTIONS(482),
    [anon_sym_int88] = ACTIONS(482),
    [anon_sym_int96] = ACTIONS(482),
    [anon_sym_int104] = ACTIONS(482),
    [anon_sym_int112] = ACTIONS(482),
    [anon_sym_int120] = ACTIONS(482),
    [anon_sym_int128] = ACTIONS(482),
    [anon_sym_int136] = ACTIONS(482),
    [anon_sym_int144] = ACTIONS(482),
    [anon_sym_int152] = ACTIONS(482),
    [anon_sym_int160] = ACTIONS(482),
    [anon_sym_int168] = ACTIONS(482),
    [anon_sym_int176] = ACTIONS(482),
    [anon_sym_int184] = ACTIONS(482),
    [anon_sym_int192] = ACTIONS(482),
    [anon_sym_int200] = ACTIONS(482),
    [anon_sym_int208] = ACTIONS(482),
    [anon_sym_int216] = ACTIONS(482),
    [anon_sym_int224] = ACTIONS(482),
    [anon_sym_int232] = ACTIONS(482),
    [anon_sym_int240] = ACTIONS(482),
    [anon_sym_int248] = ACTIONS(482),
    [anon_sym_int256] = ACTIONS(482),
    [anon_sym_uint] = ACTIONS(482),
    [anon_sym_uint8] = ACTIONS(482),
    [anon_sym_uint16] = ACTIONS(482),
    [anon_sym_uint24] = ACTIONS(482),
    [anon_sym_uint32] = ACTIONS(482),
    [anon_sym_uint40] = ACTIONS(482),
    [anon_sym_uint48] = ACTIONS(482),
    [anon_sym_uint56] = ACTIONS(482),
    [anon_sym_uint64] = ACTIONS(482),
    [anon_sym_uint72] = ACTIONS(482),
    [anon_sym_uint80] = ACTIONS(482),
    [anon_sym_uint88] = ACTIONS(482),
    [anon_sym_uint96] = ACTIONS(482),
    [anon_sym_uint104] = ACTIONS(482),
    [anon_sym_uint112] = ACTIONS(482),
    [anon_sym_uint120] = ACTIONS(482),
    [anon_sym_uint128] = ACTIONS(482),
    [anon_sym_uint136] = ACTIONS(482),
    [anon_sym_uint144] = ACTIONS(482),
    [anon_sym_uint152] = ACTIONS(482),
    [anon_sym_uint160] = ACTIONS(482),
    [anon_sym_uint168] = ACTIONS(482),
    [anon_sym_uint176] = ACTIONS(482),
    [anon_sym_uint184] = ACTIONS(482),
    [anon_sym_uint192] = ACTIONS(482),
    [anon_sym_uint200] = ACTIONS(482),
    [anon_sym_uint208] = ACTIONS(482),
    [anon_sym_uint216] = ACTIONS(482),
    [anon_sym_uint224] = ACTIONS(482),
    [anon_sym_uint232] = ACTIONS(482),
    [anon_sym_uint240] = ACTIONS(482),
    [anon_sym_uint248] = ACTIONS(482),
    [anon_sym_uint256] = ACTIONS(482),
    [anon_sym_bytes] = ACTIONS(482),
    [anon_sym_bytes1] = ACTIONS(482),
    [anon_sym_bytes2] = ACTIONS(482),
    [anon_sym_bytes3] = ACTIONS(482),
    [anon_sym_bytes4] = ACTIONS(482),
    [anon_sym_bytes5] = ACTIONS(482),
    [anon_sym_bytes6] = ACTIONS(482),
    [anon_sym_bytes7] = ACTIONS(482),
    [anon_sym_bytes8] = ACTIONS(482),
    [anon_sym_bytes9] = ACTIONS(482),
    [anon_sym_bytes10] = ACTIONS(482),
    [anon_sym_bytes11] = ACTIONS(482),
    [anon_sym_bytes12] = ACTIONS(482),
    [anon_sym_bytes13] = ACTIONS(482),
    [anon_sym_bytes14] = ACTIONS(482),
    [anon_sym_bytes15] = ACTIONS(482),
    [anon_sym_bytes16] = ACTIONS(482),
    [anon_sym_bytes17] = ACTIONS(482),
    [anon_sym_bytes18] = ACTIONS(482),
    [anon_sym_bytes19] = ACTIONS(482),
    [anon_sym_bytes20] = ACTIONS(482),
    [anon_sym_bytes21] = ACTIONS(482),
    [anon_sym_bytes22] = ACTIONS(482),
    [anon_sym_bytes23] = ACTIONS(482),
    [anon_sym_bytes24] = ACTIONS(482),
    [anon_sym_bytes25] = ACTIONS(482),
    [anon_sym_bytes26] = ACTIONS(482),
    [anon_sym_bytes27] = ACTIONS(482),
    [anon_sym_bytes28] = ACTIONS(482),
    [anon_sym_bytes29] = ACTIONS(482),
    [anon_sym_bytes30] = ACTIONS(482),
    [anon_sym_bytes31] = ACTIONS(482),
    [anon_sym_bytes32] = ACTIONS(482),
    [anon_sym_fixed] = ACTIONS(482),
    [aux_sym__fixed_token1] = ACTIONS(482),
    [anon_sym_ufixed] = ACTIONS(482),
    [aux_sym__ufixed_token1] = ACTIONS(482),
    [aux_sym__decimal_number_token1] = ACTIONS(482),
    [aux_sym__decimal_number_token2] = ACTIONS(484),
    [aux_sym__hex_number_token1] = ACTIONS(484),
    [anon_sym_hex] = ACTIONS(482),
    [anon_sym_DQUOTE] = ACTIONS(484),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [anon_sym_unicode] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(486),
    [anon_sym_DASH] = ACTIONS(486),
    [anon_sym_TILDE] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(488),
    [anon_sym_RBRACE] = ACTIONS(488),
    [anon_sym_type] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(488),
    [anon_sym_for] = ACTIONS(486),
    [anon_sym_assembly] = ACTIONS(486),
    [anon_sym_break] = ACTIONS(486),
    [anon_sym_continue] = ACTIONS(486),
    [anon_sym_true] = ACTIONS(486),
    [anon_sym_false] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_function] = ACTIONS(486),
    [anon_sym_byte] = ACTIONS(486),
    [anon_sym_address] = ACTIONS(486),
    [anon_sym_return] = ACTIONS(486),
    [anon_sym_revert] = ACTIONS(486),
    [sym_unchecked] = ACTIONS(486),
    [anon_sym_var] = ACTIONS(486),
    [anon_sym_else] = ACTIONS(486),
    [anon_sym_while] = ACTIONS(486),
    [anon_sym_do] = ACTIONS(486),
    [anon_sym_try] = ACTIONS(486),
    [anon_sym_emit] = ACTIONS(486),
    [anon_sym_payable] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(488),
    [anon_sym_delete] = ACTIONS(486),
    [anon_sym_BANG] = ACTIONS(488),
    [anon_sym_PLUS_PLUS] = ACTIONS(488),
    [anon_sym_DASH_DASH] = ACTIONS(488),
    [anon_sym_mapping] = ACTIONS(486),
    [anon_sym_bool] = ACTIONS(486),
    [anon_sym_string] = ACTIONS(486),
    [anon_sym_int] = ACTIONS(486),
    [anon_sym_int8] = ACTIONS(486),
    [anon_sym_int16] = ACTIONS(486),
    [anon_sym_int24] = ACTIONS(486),
    [anon_sym_int32] = ACTIONS(486),
    [anon_sym_int40] = ACTIONS(486),
    [anon_sym_int48] = ACTIONS(486),
    [anon_sym_int56] = ACTIONS(486),
    [anon_sym_int64] = ACTIONS(486),
    [anon_sym_int72] = ACTIONS(486),
    [anon_sym_int80] = ACTIONS(486),
    [anon_sym_int88] = ACTIONS(486),
    [anon_sym_int96] = ACTIONS(486),
    [anon_sym_int104] = ACTIONS(486),
    [anon_sym_int112] = ACTIONS(486),
    [anon_sym_int120] = ACTIONS(486),
    [anon_sym_int128] = ACTIONS(486),
    [anon_sym_int136] = ACTIONS(486),
    [anon_sym_int144] = ACTIONS(486),
    [anon_sym_int152] = ACTIONS(486),
    [anon_sym_int160] = ACTIONS(486),
    [anon_sym_int168] = ACTIONS(486),
    [anon_sym_int176] = ACTIONS(486),
    [anon_sym_int184] = ACTIONS(486),
    [anon_sym_int192] = ACTIONS(486),
    [anon_sym_int200] = ACTIONS(486),
    [anon_sym_int208] = ACTIONS(486),
    [anon_sym_int216] = ACTIONS(486),
    [anon_sym_int224] = ACTIONS(486),
    [anon_sym_int232] = ACTIONS(486),
    [anon_sym_int240] = ACTIONS(486),
    [anon_sym_int248] = ACTIONS(486),
    [anon_sym_int256] = ACTIONS(486),
    [anon_sym_uint] = ACTIONS(486),
    [anon_sym_uint8] = ACTIONS(486),
    [anon_sym_uint16] = ACTIONS(486),
    [anon_sym_uint24] = ACTIONS(486),
    [anon_sym_uint32] = ACTIONS(486),
    [anon_sym_uint40] = ACTIONS(486),
    [anon_sym_uint48] = ACTIONS(486),
    [anon_sym_uint56] = ACTIONS(486),
    [anon_sym_uint64] = ACTIONS(486),
    [anon_sym_uint72] = ACTIONS(486),
    [anon_sym_uint80] = ACTIONS(486),
    [anon_sym_uint88] = ACTIONS(486),
    [anon_sym_uint96] = ACTIONS(486),
    [anon_sym_uint104] = ACTIONS(486),
    [anon_sym_uint112] = ACTIONS(486),
    [anon_sym_uint120] = ACTIONS(486),
    [anon_sym_uint128] = ACTIONS(486),
    [anon_sym_uint136] = ACTIONS(486),
    [anon_sym_uint144] = ACTIONS(486),
    [anon_sym_uint152] = ACTIONS(486),
    [anon_sym_uint160] = ACTIONS(486),
    [anon_sym_uint168] = ACTIONS(486),
    [anon_sym_uint176] = ACTIONS(486),
    [anon_sym_uint184] = ACTIONS(486),
    [anon_sym_uint192] = ACTIONS(486),
    [anon_sym_uint200] = ACTIONS(486),
    [anon_sym_uint208] = ACTIONS(486),
    [anon_sym_uint216] = ACTIONS(486),
    [anon_sym_uint224] = ACTIONS(486),
    [anon_sym_uint232] = ACTIONS(486),
    [anon_sym_uint240] = ACTIONS(486),
    [anon_sym_uint248] = ACTIONS(486),
    [anon_sym_uint256] = ACTIONS(486),
    [anon_sym_bytes] = ACTIONS(486),
    [anon_sym_bytes1] = ACTIONS(486),
    [anon_sym_bytes2] = ACTIONS(486),
    [anon_sym_bytes3] = ACTIONS(486),
    [anon_sym_bytes4] = ACTIONS(486),
    [anon_sym_bytes5] = ACTIONS(486),
    [anon_sym_bytes6] = ACTIONS(486),
    [anon_sym_bytes7] = ACTIONS(486),
    [anon_sym_bytes8] = ACTIONS(486),
    [anon_sym_bytes9] = ACTIONS(486),
    [anon_sym_bytes10] = ACTIONS(486),
    [anon_sym_bytes11] = ACTIONS(486),
    [anon_sym_bytes12] = ACTIONS(486),
    [anon_sym_bytes13] = ACTIONS(486),
    [anon_sym_bytes14] = ACTIONS(486),
    [anon_sym_bytes15] = ACTIONS(486),
    [anon_sym_bytes16] = ACTIONS(486),
    [anon_sym_bytes17] = ACTIONS(486),
    [anon_sym_bytes18] = ACTIONS(486),
    [anon_sym_bytes19] = ACTIONS(486),
    [anon_sym_bytes20] = ACTIONS(486),
    [anon_sym_bytes21] = ACTIONS(486),
    [anon_sym_bytes22] = ACTIONS(486),
    [anon_sym_bytes23] = ACTIONS(486),
    [anon_sym_bytes24] = ACTIONS(486),
    [anon_sym_bytes25] = ACTIONS(486),
    [anon_sym_bytes26] = ACTIONS(486),
    [anon_sym_bytes27] = ACTIONS(486),
    [anon_sym_bytes28] = ACTIONS(486),
    [anon_sym_bytes29] = ACTIONS(486),
    [anon_sym_bytes30] = ACTIONS(486),
    [anon_sym_bytes31] = ACTIONS(486),
    [anon_sym_bytes32] = ACTIONS(486),
    [anon_sym_fixed] = ACTIONS(486),
    [aux_sym__fixed_token1] = ACTIONS(486),
    [anon_sym_ufixed] = ACTIONS(486),
    [aux_sym__ufixed_token1] = ACTIONS(486),
    [aux_sym__decimal_number_token1] = ACTIONS(486),
    [aux_sym__decimal_number_token2] = ACTIONS(488),
    [aux_sym__hex_number_token1] = ACTIONS(488),
    [anon_sym_hex] = ACTIONS(486),
    [anon_sym_DQUOTE] = ACTIONS(488),
    [anon_sym_SQUOTE] = ACTIONS(488),
    [anon_sym_unicode] = ACTIONS(486),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_identifier] = ACTIONS(490),
    [anon_sym_DASH] = ACTIONS(490),
    [anon_sym_TILDE] = ACTIONS(492),
    [anon_sym_LBRACE] = ACTIONS(492),
    [anon_sym_RBRACE] = ACTIONS(492),
    [anon_sym_type] = ACTIONS(490),
    [anon_sym_LPAREN] = ACTIONS(492),
    [anon_sym_for] = ACTIONS(490),
    [anon_sym_assembly] = ACTIONS(490),
    [anon_sym_break] = ACTIONS(490),
    [anon_sym_continue] = ACTIONS(490),
    [anon_sym_true] = ACTIONS(490),
    [anon_sym_false] = ACTIONS(490),
    [anon_sym_if] = ACTIONS(490),
    [anon_sym_function] = ACTIONS(490),
    [anon_sym_byte] = ACTIONS(490),
    [anon_sym_address] = ACTIONS(490),
    [anon_sym_return] = ACTIONS(490),
    [anon_sym_revert] = ACTIONS(490),
    [sym_unchecked] = ACTIONS(490),
    [anon_sym_var] = ACTIONS(490),
    [anon_sym_else] = ACTIONS(490),
    [anon_sym_while] = ACTIONS(490),
    [anon_sym_do] = ACTIONS(490),
    [anon_sym_try] = ACTIONS(490),
    [anon_sym_emit] = ACTIONS(490),
    [anon_sym_payable] = ACTIONS(490),
    [anon_sym_new] = ACTIONS(490),
    [anon_sym_LBRACK] = ACTIONS(492),
    [anon_sym_delete] = ACTIONS(490),
    [anon_sym_BANG] = ACTIONS(492),
    [anon_sym_PLUS_PLUS] = ACTIONS(492),
    [anon_sym_DASH_DASH] = ACTIONS(492),
    [anon_sym_mapping] = ACTIONS(490),
    [anon_sym_bool] = ACTIONS(490),
    [anon_sym_string] = ACTIONS(490),
    [anon_sym_int] = ACTIONS(490),
    [anon_sym_int8] = ACTIONS(490),
    [anon_sym_int16] = ACTIONS(490),
    [anon_sym_int24] = ACTIONS(490),
    [anon_sym_int32] = ACTIONS(490),
    [anon_sym_int40] = ACTIONS(490),
    [anon_sym_int48] = ACTIONS(490),
    [anon_sym_int56] = ACTIONS(490),
    [anon_sym_int64] = ACTIONS(490),
    [anon_sym_int72] = ACTIONS(490),
    [anon_sym_int80] = ACTIONS(490),
    [anon_sym_int88] = ACTIONS(490),
    [anon_sym_int96] = ACTIONS(490),
    [anon_sym_int104] = ACTIONS(490),
    [anon_sym_int112] = ACTIONS(490),
    [anon_sym_int120] = ACTIONS(490),
    [anon_sym_int128] = ACTIONS(490),
    [anon_sym_int136] = ACTIONS(490),
    [anon_sym_int144] = ACTIONS(490),
    [anon_sym_int152] = ACTIONS(490),
    [anon_sym_int160] = ACTIONS(490),
    [anon_sym_int168] = ACTIONS(490),
    [anon_sym_int176] = ACTIONS(490),
    [anon_sym_int184] = ACTIONS(490),
    [anon_sym_int192] = ACTIONS(490),
    [anon_sym_int200] = ACTIONS(490),
    [anon_sym_int208] = ACTIONS(490),
    [anon_sym_int216] = ACTIONS(490),
    [anon_sym_int224] = ACTIONS(490),
    [anon_sym_int232] = ACTIONS(490),
    [anon_sym_int240] = ACTIONS(490),
    [anon_sym_int248] = ACTIONS(490),
    [anon_sym_int256] = ACTIONS(490),
    [anon_sym_uint] = ACTIONS(490),
    [anon_sym_uint8] = ACTIONS(490),
    [anon_sym_uint16] = ACTIONS(490),
    [anon_sym_uint24] = ACTIONS(490),
    [anon_sym_uint32] = ACTIONS(490),
    [anon_sym_uint40] = ACTIONS(490),
    [anon_sym_uint48] = ACTIONS(490),
    [anon_sym_uint56] = ACTIONS(490),
    [anon_sym_uint64] = ACTIONS(490),
    [anon_sym_uint72] = ACTIONS(490),
    [anon_sym_uint80] = ACTIONS(490),
    [anon_sym_uint88] = ACTIONS(490),
    [anon_sym_uint96] = ACTIONS(490),
    [anon_sym_uint104] = ACTIONS(490),
    [anon_sym_uint112] = ACTIONS(490),
    [anon_sym_uint120] = ACTIONS(490),
    [anon_sym_uint128] = ACTIONS(490),
    [anon_sym_uint136] = ACTIONS(490),
    [anon_sym_uint144] = ACTIONS(490),
    [anon_sym_uint152] = ACTIONS(490),
    [anon_sym_uint160] = ACTIONS(490),
    [anon_sym_uint168] = ACTIONS(490),
    [anon_sym_uint176] = ACTIONS(490),
    [anon_sym_uint184] = ACTIONS(490),
    [anon_sym_uint192] = ACTIONS(490),
    [anon_sym_uint200] = ACTIONS(490),
    [anon_sym_uint208] = ACTIONS(490),
    [anon_sym_uint216] = ACTIONS(490),
    [anon_sym_uint224] = ACTIONS(490),
    [anon_sym_uint232] = ACTIONS(490),
    [anon_sym_uint240] = ACTIONS(490),
    [anon_sym_uint248] = ACTIONS(490),
    [anon_sym_uint256] = ACTIONS(490),
    [anon_sym_bytes] = ACTIONS(490),
    [anon_sym_bytes1] = ACTIONS(490),
    [anon_sym_bytes2] = ACTIONS(490),
    [anon_sym_bytes3] = ACTIONS(490),
    [anon_sym_bytes4] = ACTIONS(490),
    [anon_sym_bytes5] = ACTIONS(490),
    [anon_sym_bytes6] = ACTIONS(490),
    [anon_sym_bytes7] = ACTIONS(490),
    [anon_sym_bytes8] = ACTIONS(490),
    [anon_sym_bytes9] = ACTIONS(490),
    [anon_sym_bytes10] = ACTIONS(490),
    [anon_sym_bytes11] = ACTIONS(490),
    [anon_sym_bytes12] = ACTIONS(490),
    [anon_sym_bytes13] = ACTIONS(490),
    [anon_sym_bytes14] = ACTIONS(490),
    [anon_sym_bytes15] = ACTIONS(490),
    [anon_sym_bytes16] = ACTIONS(490),
    [anon_sym_bytes17] = ACTIONS(490),
    [anon_sym_bytes18] = ACTIONS(490),
    [anon_sym_bytes19] = ACTIONS(490),
    [anon_sym_bytes20] = ACTIONS(490),
    [anon_sym_bytes21] = ACTIONS(490),
    [anon_sym_bytes22] = ACTIONS(490),
    [anon_sym_bytes23] = ACTIONS(490),
    [anon_sym_bytes24] = ACTIONS(490),
    [anon_sym_bytes25] = ACTIONS(490),
    [anon_sym_bytes26] = ACTIONS(490),
    [anon_sym_bytes27] = ACTIONS(490),
    [anon_sym_bytes28] = ACTIONS(490),
    [anon_sym_bytes29] = ACTIONS(490),
    [anon_sym_bytes30] = ACTIONS(490),
    [anon_sym_bytes31] = ACTIONS(490),
    [anon_sym_bytes32] = ACTIONS(490),
    [anon_sym_fixed] = ACTIONS(490),
    [aux_sym__fixed_token1] = ACTIONS(490),
    [anon_sym_ufixed] = ACTIONS(490),
    [aux_sym__ufixed_token1] = ACTIONS(490),
    [aux_sym__decimal_number_token1] = ACTIONS(490),
    [aux_sym__decimal_number_token2] = ACTIONS(492),
    [aux_sym__hex_number_token1] = ACTIONS(492),
    [anon_sym_hex] = ACTIONS(490),
    [anon_sym_DQUOTE] = ACTIONS(492),
    [anon_sym_SQUOTE] = ACTIONS(492),
    [anon_sym_unicode] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_identifier] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(494),
    [anon_sym_TILDE] = ACTIONS(496),
    [anon_sym_LBRACE] = ACTIONS(496),
    [anon_sym_RBRACE] = ACTIONS(496),
    [anon_sym_type] = ACTIONS(494),
    [anon_sym_LPAREN] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(494),
    [anon_sym_assembly] = ACTIONS(494),
    [anon_sym_break] = ACTIONS(494),
    [anon_sym_continue] = ACTIONS(494),
    [anon_sym_true] = ACTIONS(494),
    [anon_sym_false] = ACTIONS(494),
    [anon_sym_if] = ACTIONS(494),
    [anon_sym_function] = ACTIONS(494),
    [anon_sym_byte] = ACTIONS(494),
    [anon_sym_address] = ACTIONS(494),
    [anon_sym_return] = ACTIONS(494),
    [anon_sym_revert] = ACTIONS(494),
    [sym_unchecked] = ACTIONS(494),
    [anon_sym_var] = ACTIONS(494),
    [anon_sym_else] = ACTIONS(494),
    [anon_sym_while] = ACTIONS(494),
    [anon_sym_do] = ACTIONS(494),
    [anon_sym_try] = ACTIONS(494),
    [anon_sym_emit] = ACTIONS(494),
    [anon_sym_payable] = ACTIONS(494),
    [anon_sym_new] = ACTIONS(494),
    [anon_sym_LBRACK] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(494),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_PLUS_PLUS] = ACTIONS(496),
    [anon_sym_DASH_DASH] = ACTIONS(496),
    [anon_sym_mapping] = ACTIONS(494),
    [anon_sym_bool] = ACTIONS(494),
    [anon_sym_string] = ACTIONS(494),
    [anon_sym_int] = ACTIONS(494),
    [anon_sym_int8] = ACTIONS(494),
    [anon_sym_int16] = ACTIONS(494),
    [anon_sym_int24] = ACTIONS(494),
    [anon_sym_int32] = ACTIONS(494),
    [anon_sym_int40] = ACTIONS(494),
    [anon_sym_int48] = ACTIONS(494),
    [anon_sym_int56] = ACTIONS(494),
    [anon_sym_int64] = ACTIONS(494),
    [anon_sym_int72] = ACTIONS(494),
    [anon_sym_int80] = ACTIONS(494),
    [anon_sym_int88] = ACTIONS(494),
    [anon_sym_int96] = ACTIONS(494),
    [anon_sym_int104] = ACTIONS(494),
    [anon_sym_int112] = ACTIONS(494),
    [anon_sym_int120] = ACTIONS(494),
    [anon_sym_int128] = ACTIONS(494),
    [anon_sym_int136] = ACTIONS(494),
    [anon_sym_int144] = ACTIONS(494),
    [anon_sym_int152] = ACTIONS(494),
    [anon_sym_int160] = ACTIONS(494),
    [anon_sym_int168] = ACTIONS(494),
    [anon_sym_int176] = ACTIONS(494),
    [anon_sym_int184] = ACTIONS(494),
    [anon_sym_int192] = ACTIONS(494),
    [anon_sym_int200] = ACTIONS(494),
    [anon_sym_int208] = ACTIONS(494),
    [anon_sym_int216] = ACTIONS(494),
    [anon_sym_int224] = ACTIONS(494),
    [anon_sym_int232] = ACTIONS(494),
    [anon_sym_int240] = ACTIONS(494),
    [anon_sym_int248] = ACTIONS(494),
    [anon_sym_int256] = ACTIONS(494),
    [anon_sym_uint] = ACTIONS(494),
    [anon_sym_uint8] = ACTIONS(494),
    [anon_sym_uint16] = ACTIONS(494),
    [anon_sym_uint24] = ACTIONS(494),
    [anon_sym_uint32] = ACTIONS(494),
    [anon_sym_uint40] = ACTIONS(494),
    [anon_sym_uint48] = ACTIONS(494),
    [anon_sym_uint56] = ACTIONS(494),
    [anon_sym_uint64] = ACTIONS(494),
    [anon_sym_uint72] = ACTIONS(494),
    [anon_sym_uint80] = ACTIONS(494),
    [anon_sym_uint88] = ACTIONS(494),
    [anon_sym_uint96] = ACTIONS(494),
    [anon_sym_uint104] = ACTIONS(494),
    [anon_sym_uint112] = ACTIONS(494),
    [anon_sym_uint120] = ACTIONS(494),
    [anon_sym_uint128] = ACTIONS(494),
    [anon_sym_uint136] = ACTIONS(494),
    [anon_sym_uint144] = ACTIONS(494),
    [anon_sym_uint152] = ACTIONS(494),
    [anon_sym_uint160] = ACTIONS(494),
    [anon_sym_uint168] = ACTIONS(494),
    [anon_sym_uint176] = ACTIONS(494),
    [anon_sym_uint184] = ACTIONS(494),
    [anon_sym_uint192] = ACTIONS(494),
    [anon_sym_uint200] = ACTIONS(494),
    [anon_sym_uint208] = ACTIONS(494),
    [anon_sym_uint216] = ACTIONS(494),
    [anon_sym_uint224] = ACTIONS(494),
    [anon_sym_uint232] = ACTIONS(494),
    [anon_sym_uint240] = ACTIONS(494),
    [anon_sym_uint248] = ACTIONS(494),
    [anon_sym_uint256] = ACTIONS(494),
    [anon_sym_bytes] = ACTIONS(494),
    [anon_sym_bytes1] = ACTIONS(494),
    [anon_sym_bytes2] = ACTIONS(494),
    [anon_sym_bytes3] = ACTIONS(494),
    [anon_sym_bytes4] = ACTIONS(494),
    [anon_sym_bytes5] = ACTIONS(494),
    [anon_sym_bytes6] = ACTIONS(494),
    [anon_sym_bytes7] = ACTIONS(494),
    [anon_sym_bytes8] = ACTIONS(494),
    [anon_sym_bytes9] = ACTIONS(494),
    [anon_sym_bytes10] = ACTIONS(494),
    [anon_sym_bytes11] = ACTIONS(494),
    [anon_sym_bytes12] = ACTIONS(494),
    [anon_sym_bytes13] = ACTIONS(494),
    [anon_sym_bytes14] = ACTIONS(494),
    [anon_sym_bytes15] = ACTIONS(494),
    [anon_sym_bytes16] = ACTIONS(494),
    [anon_sym_bytes17] = ACTIONS(494),
    [anon_sym_bytes18] = ACTIONS(494),
    [anon_sym_bytes19] = ACTIONS(494),
    [anon_sym_bytes20] = ACTIONS(494),
    [anon_sym_bytes21] = ACTIONS(494),
    [anon_sym_bytes22] = ACTIONS(494),
    [anon_sym_bytes23] = ACTIONS(494),
    [anon_sym_bytes24] = ACTIONS(494),
    [anon_sym_bytes25] = ACTIONS(494),
    [anon_sym_bytes26] = ACTIONS(494),
    [anon_sym_bytes27] = ACTIONS(494),
    [anon_sym_bytes28] = ACTIONS(494),
    [anon_sym_bytes29] = ACTIONS(494),
    [anon_sym_bytes30] = ACTIONS(494),
    [anon_sym_bytes31] = ACTIONS(494),
    [anon_sym_bytes32] = ACTIONS(494),
    [anon_sym_fixed] = ACTIONS(494),
    [aux_sym__fixed_token1] = ACTIONS(494),
    [anon_sym_ufixed] = ACTIONS(494),
    [aux_sym__ufixed_token1] = ACTIONS(494),
    [aux_sym__decimal_number_token1] = ACTIONS(494),
    [aux_sym__decimal_number_token2] = ACTIONS(496),
    [aux_sym__hex_number_token1] = ACTIONS(496),
    [anon_sym_hex] = ACTIONS(494),
    [anon_sym_DQUOTE] = ACTIONS(496),
    [anon_sym_SQUOTE] = ACTIONS(496),
    [anon_sym_unicode] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_identifier] = ACTIONS(498),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_TILDE] = ACTIONS(500),
    [anon_sym_LBRACE] = ACTIONS(500),
    [anon_sym_RBRACE] = ACTIONS(500),
    [anon_sym_type] = ACTIONS(498),
    [anon_sym_LPAREN] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(498),
    [anon_sym_assembly] = ACTIONS(498),
    [anon_sym_break] = ACTIONS(498),
    [anon_sym_continue] = ACTIONS(498),
    [anon_sym_true] = ACTIONS(498),
    [anon_sym_false] = ACTIONS(498),
    [anon_sym_if] = ACTIONS(498),
    [anon_sym_function] = ACTIONS(498),
    [anon_sym_byte] = ACTIONS(498),
    [anon_sym_address] = ACTIONS(498),
    [anon_sym_return] = ACTIONS(498),
    [anon_sym_revert] = ACTIONS(498),
    [sym_unchecked] = ACTIONS(498),
    [anon_sym_var] = ACTIONS(498),
    [anon_sym_else] = ACTIONS(498),
    [anon_sym_while] = ACTIONS(498),
    [anon_sym_do] = ACTIONS(498),
    [anon_sym_try] = ACTIONS(498),
    [anon_sym_emit] = ACTIONS(498),
    [anon_sym_payable] = ACTIONS(498),
    [anon_sym_new] = ACTIONS(498),
    [anon_sym_LBRACK] = ACTIONS(500),
    [anon_sym_delete] = ACTIONS(498),
    [anon_sym_BANG] = ACTIONS(500),
    [anon_sym_PLUS_PLUS] = ACTIONS(500),
    [anon_sym_DASH_DASH] = ACTIONS(500),
    [anon_sym_mapping] = ACTIONS(498),
    [anon_sym_bool] = ACTIONS(498),
    [anon_sym_string] = ACTIONS(498),
    [anon_sym_int] = ACTIONS(498),
    [anon_sym_int8] = ACTIONS(498),
    [anon_sym_int16] = ACTIONS(498),
    [anon_sym_int24] = ACTIONS(498),
    [anon_sym_int32] = ACTIONS(498),
    [anon_sym_int40] = ACTIONS(498),
    [anon_sym_int48] = ACTIONS(498),
    [anon_sym_int56] = ACTIONS(498),
    [anon_sym_int64] = ACTIONS(498),
    [anon_sym_int72] = ACTIONS(498),
    [anon_sym_int80] = ACTIONS(498),
    [anon_sym_int88] = ACTIONS(498),
    [anon_sym_int96] = ACTIONS(498),
    [anon_sym_int104] = ACTIONS(498),
    [anon_sym_int112] = ACTIONS(498),
    [anon_sym_int120] = ACTIONS(498),
    [anon_sym_int128] = ACTIONS(498),
    [anon_sym_int136] = ACTIONS(498),
    [anon_sym_int144] = ACTIONS(498),
    [anon_sym_int152] = ACTIONS(498),
    [anon_sym_int160] = ACTIONS(498),
    [anon_sym_int168] = ACTIONS(498),
    [anon_sym_int176] = ACTIONS(498),
    [anon_sym_int184] = ACTIONS(498),
    [anon_sym_int192] = ACTIONS(498),
    [anon_sym_int200] = ACTIONS(498),
    [anon_sym_int208] = ACTIONS(498),
    [anon_sym_int216] = ACTIONS(498),
    [anon_sym_int224] = ACTIONS(498),
    [anon_sym_int232] = ACTIONS(498),
    [anon_sym_int240] = ACTIONS(498),
    [anon_sym_int248] = ACTIONS(498),
    [anon_sym_int256] = ACTIONS(498),
    [anon_sym_uint] = ACTIONS(498),
    [anon_sym_uint8] = ACTIONS(498),
    [anon_sym_uint16] = ACTIONS(498),
    [anon_sym_uint24] = ACTIONS(498),
    [anon_sym_uint32] = ACTIONS(498),
    [anon_sym_uint40] = ACTIONS(498),
    [anon_sym_uint48] = ACTIONS(498),
    [anon_sym_uint56] = ACTIONS(498),
    [anon_sym_uint64] = ACTIONS(498),
    [anon_sym_uint72] = ACTIONS(498),
    [anon_sym_uint80] = ACTIONS(498),
    [anon_sym_uint88] = ACTIONS(498),
    [anon_sym_uint96] = ACTIONS(498),
    [anon_sym_uint104] = ACTIONS(498),
    [anon_sym_uint112] = ACTIONS(498),
    [anon_sym_uint120] = ACTIONS(498),
    [anon_sym_uint128] = ACTIONS(498),
    [anon_sym_uint136] = ACTIONS(498),
    [anon_sym_uint144] = ACTIONS(498),
    [anon_sym_uint152] = ACTIONS(498),
    [anon_sym_uint160] = ACTIONS(498),
    [anon_sym_uint168] = ACTIONS(498),
    [anon_sym_uint176] = ACTIONS(498),
    [anon_sym_uint184] = ACTIONS(498),
    [anon_sym_uint192] = ACTIONS(498),
    [anon_sym_uint200] = ACTIONS(498),
    [anon_sym_uint208] = ACTIONS(498),
    [anon_sym_uint216] = ACTIONS(498),
    [anon_sym_uint224] = ACTIONS(498),
    [anon_sym_uint232] = ACTIONS(498),
    [anon_sym_uint240] = ACTIONS(498),
    [anon_sym_uint248] = ACTIONS(498),
    [anon_sym_uint256] = ACTIONS(498),
    [anon_sym_bytes] = ACTIONS(498),
    [anon_sym_bytes1] = ACTIONS(498),
    [anon_sym_bytes2] = ACTIONS(498),
    [anon_sym_bytes3] = ACTIONS(498),
    [anon_sym_bytes4] = ACTIONS(498),
    [anon_sym_bytes5] = ACTIONS(498),
    [anon_sym_bytes6] = ACTIONS(498),
    [anon_sym_bytes7] = ACTIONS(498),
    [anon_sym_bytes8] = ACTIONS(498),
    [anon_sym_bytes9] = ACTIONS(498),
    [anon_sym_bytes10] = ACTIONS(498),
    [anon_sym_bytes11] = ACTIONS(498),
    [anon_sym_bytes12] = ACTIONS(498),
    [anon_sym_bytes13] = ACTIONS(498),
    [anon_sym_bytes14] = ACTIONS(498),
    [anon_sym_bytes15] = ACTIONS(498),
    [anon_sym_bytes16] = ACTIONS(498),
    [anon_sym_bytes17] = ACTIONS(498),
    [anon_sym_bytes18] = ACTIONS(498),
    [anon_sym_bytes19] = ACTIONS(498),
    [anon_sym_bytes20] = ACTIONS(498),
    [anon_sym_bytes21] = ACTIONS(498),
    [anon_sym_bytes22] = ACTIONS(498),
    [anon_sym_bytes23] = ACTIONS(498),
    [anon_sym_bytes24] = ACTIONS(498),
    [anon_sym_bytes25] = ACTIONS(498),
    [anon_sym_bytes26] = ACTIONS(498),
    [anon_sym_bytes27] = ACTIONS(498),
    [anon_sym_bytes28] = ACTIONS(498),
    [anon_sym_bytes29] = ACTIONS(498),
    [anon_sym_bytes30] = ACTIONS(498),
    [anon_sym_bytes31] = ACTIONS(498),
    [anon_sym_bytes32] = ACTIONS(498),
    [anon_sym_fixed] = ACTIONS(498),
    [aux_sym__fixed_token1] = ACTIONS(498),
    [anon_sym_ufixed] = ACTIONS(498),
    [aux_sym__ufixed_token1] = ACTIONS(498),
    [aux_sym__decimal_number_token1] = ACTIONS(498),
    [aux_sym__decimal_number_token2] = ACTIONS(500),
    [aux_sym__hex_number_token1] = ACTIONS(500),
    [anon_sym_hex] = ACTIONS(498),
    [anon_sym_DQUOTE] = ACTIONS(500),
    [anon_sym_SQUOTE] = ACTIONS(500),
    [anon_sym_unicode] = ACTIONS(498),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_identifier] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(504),
    [anon_sym_RBRACE] = ACTIONS(504),
    [anon_sym_type] = ACTIONS(502),
    [anon_sym_LPAREN] = ACTIONS(504),
    [anon_sym_for] = ACTIONS(502),
    [anon_sym_assembly] = ACTIONS(502),
    [anon_sym_break] = ACTIONS(502),
    [anon_sym_continue] = ACTIONS(502),
    [anon_sym_true] = ACTIONS(502),
    [anon_sym_false] = ACTIONS(502),
    [anon_sym_if] = ACTIONS(502),
    [anon_sym_function] = ACTIONS(502),
    [anon_sym_byte] = ACTIONS(502),
    [anon_sym_address] = ACTIONS(502),
    [anon_sym_return] = ACTIONS(502),
    [anon_sym_revert] = ACTIONS(502),
    [sym_unchecked] = ACTIONS(502),
    [anon_sym_var] = ACTIONS(502),
    [anon_sym_else] = ACTIONS(502),
    [anon_sym_while] = ACTIONS(502),
    [anon_sym_do] = ACTIONS(502),
    [anon_sym_try] = ACTIONS(502),
    [anon_sym_emit] = ACTIONS(502),
    [anon_sym_payable] = ACTIONS(502),
    [anon_sym_new] = ACTIONS(502),
    [anon_sym_LBRACK] = ACTIONS(504),
    [anon_sym_delete] = ACTIONS(502),
    [anon_sym_BANG] = ACTIONS(504),
    [anon_sym_PLUS_PLUS] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(504),
    [anon_sym_mapping] = ACTIONS(502),
    [anon_sym_bool] = ACTIONS(502),
    [anon_sym_string] = ACTIONS(502),
    [anon_sym_int] = ACTIONS(502),
    [anon_sym_int8] = ACTIONS(502),
    [anon_sym_int16] = ACTIONS(502),
    [anon_sym_int24] = ACTIONS(502),
    [anon_sym_int32] = ACTIONS(502),
    [anon_sym_int40] = ACTIONS(502),
    [anon_sym_int48] = ACTIONS(502),
    [anon_sym_int56] = ACTIONS(502),
    [anon_sym_int64] = ACTIONS(502),
    [anon_sym_int72] = ACTIONS(502),
    [anon_sym_int80] = ACTIONS(502),
    [anon_sym_int88] = ACTIONS(502),
    [anon_sym_int96] = ACTIONS(502),
    [anon_sym_int104] = ACTIONS(502),
    [anon_sym_int112] = ACTIONS(502),
    [anon_sym_int120] = ACTIONS(502),
    [anon_sym_int128] = ACTIONS(502),
    [anon_sym_int136] = ACTIONS(502),
    [anon_sym_int144] = ACTIONS(502),
    [anon_sym_int152] = ACTIONS(502),
    [anon_sym_int160] = ACTIONS(502),
    [anon_sym_int168] = ACTIONS(502),
    [anon_sym_int176] = ACTIONS(502),
    [anon_sym_int184] = ACTIONS(502),
    [anon_sym_int192] = ACTIONS(502),
    [anon_sym_int200] = ACTIONS(502),
    [anon_sym_int208] = ACTIONS(502),
    [anon_sym_int216] = ACTIONS(502),
    [anon_sym_int224] = ACTIONS(502),
    [anon_sym_int232] = ACTIONS(502),
    [anon_sym_int240] = ACTIONS(502),
    [anon_sym_int248] = ACTIONS(502),
    [anon_sym_int256] = ACTIONS(502),
    [anon_sym_uint] = ACTIONS(502),
    [anon_sym_uint8] = ACTIONS(502),
    [anon_sym_uint16] = ACTIONS(502),
    [anon_sym_uint24] = ACTIONS(502),
    [anon_sym_uint32] = ACTIONS(502),
    [anon_sym_uint40] = ACTIONS(502),
    [anon_sym_uint48] = ACTIONS(502),
    [anon_sym_uint56] = ACTIONS(502),
    [anon_sym_uint64] = ACTIONS(502),
    [anon_sym_uint72] = ACTIONS(502),
    [anon_sym_uint80] = ACTIONS(502),
    [anon_sym_uint88] = ACTIONS(502),
    [anon_sym_uint96] = ACTIONS(502),
    [anon_sym_uint104] = ACTIONS(502),
    [anon_sym_uint112] = ACTIONS(502),
    [anon_sym_uint120] = ACTIONS(502),
    [anon_sym_uint128] = ACTIONS(502),
    [anon_sym_uint136] = ACTIONS(502),
    [anon_sym_uint144] = ACTIONS(502),
    [anon_sym_uint152] = ACTIONS(502),
    [anon_sym_uint160] = ACTIONS(502),
    [anon_sym_uint168] = ACTIONS(502),
    [anon_sym_uint176] = ACTIONS(502),
    [anon_sym_uint184] = ACTIONS(502),
    [anon_sym_uint192] = ACTIONS(502),
    [anon_sym_uint200] = ACTIONS(502),
    [anon_sym_uint208] = ACTIONS(502),
    [anon_sym_uint216] = ACTIONS(502),
    [anon_sym_uint224] = ACTIONS(502),
    [anon_sym_uint232] = ACTIONS(502),
    [anon_sym_uint240] = ACTIONS(502),
    [anon_sym_uint248] = ACTIONS(502),
    [anon_sym_uint256] = ACTIONS(502),
    [anon_sym_bytes] = ACTIONS(502),
    [anon_sym_bytes1] = ACTIONS(502),
    [anon_sym_bytes2] = ACTIONS(502),
    [anon_sym_bytes3] = ACTIONS(502),
    [anon_sym_bytes4] = ACTIONS(502),
    [anon_sym_bytes5] = ACTIONS(502),
    [anon_sym_bytes6] = ACTIONS(502),
    [anon_sym_bytes7] = ACTIONS(502),
    [anon_sym_bytes8] = ACTIONS(502),
    [anon_sym_bytes9] = ACTIONS(502),
    [anon_sym_bytes10] = ACTIONS(502),
    [anon_sym_bytes11] = ACTIONS(502),
    [anon_sym_bytes12] = ACTIONS(502),
    [anon_sym_bytes13] = ACTIONS(502),
    [anon_sym_bytes14] = ACTIONS(502),
    [anon_sym_bytes15] = ACTIONS(502),
    [anon_sym_bytes16] = ACTIONS(502),
    [anon_sym_bytes17] = ACTIONS(502),
    [anon_sym_bytes18] = ACTIONS(502),
    [anon_sym_bytes19] = ACTIONS(502),
    [anon_sym_bytes20] = ACTIONS(502),
    [anon_sym_bytes21] = ACTIONS(502),
    [anon_sym_bytes22] = ACTIONS(502),
    [anon_sym_bytes23] = ACTIONS(502),
    [anon_sym_bytes24] = ACTIONS(502),
    [anon_sym_bytes25] = ACTIONS(502),
    [anon_sym_bytes26] = ACTIONS(502),
    [anon_sym_bytes27] = ACTIONS(502),
    [anon_sym_bytes28] = ACTIONS(502),
    [anon_sym_bytes29] = ACTIONS(502),
    [anon_sym_bytes30] = ACTIONS(502),
    [anon_sym_bytes31] = ACTIONS(502),
    [anon_sym_bytes32] = ACTIONS(502),
    [anon_sym_fixed] = ACTIONS(502),
    [aux_sym__fixed_token1] = ACTIONS(502),
    [anon_sym_ufixed] = ACTIONS(502),
    [aux_sym__ufixed_token1] = ACTIONS(502),
    [aux_sym__decimal_number_token1] = ACTIONS(502),
    [aux_sym__decimal_number_token2] = ACTIONS(504),
    [aux_sym__hex_number_token1] = ACTIONS(504),
    [anon_sym_hex] = ACTIONS(502),
    [anon_sym_DQUOTE] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(504),
    [anon_sym_unicode] = ACTIONS(502),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_identifier] = ACTIONS(506),
    [anon_sym_DASH] = ACTIONS(506),
    [anon_sym_TILDE] = ACTIONS(508),
    [anon_sym_LBRACE] = ACTIONS(508),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_type] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(508),
    [anon_sym_for] = ACTIONS(506),
    [anon_sym_assembly] = ACTIONS(506),
    [anon_sym_break] = ACTIONS(506),
    [anon_sym_continue] = ACTIONS(506),
    [anon_sym_true] = ACTIONS(506),
    [anon_sym_false] = ACTIONS(506),
    [anon_sym_if] = ACTIONS(506),
    [anon_sym_function] = ACTIONS(506),
    [anon_sym_byte] = ACTIONS(506),
    [anon_sym_address] = ACTIONS(506),
    [anon_sym_return] = ACTIONS(506),
    [anon_sym_revert] = ACTIONS(506),
    [sym_unchecked] = ACTIONS(506),
    [anon_sym_var] = ACTIONS(506),
    [anon_sym_else] = ACTIONS(506),
    [anon_sym_while] = ACTIONS(506),
    [anon_sym_do] = ACTIONS(506),
    [anon_sym_try] = ACTIONS(506),
    [anon_sym_emit] = ACTIONS(506),
    [anon_sym_payable] = ACTIONS(506),
    [anon_sym_new] = ACTIONS(506),
    [anon_sym_LBRACK] = ACTIONS(508),
    [anon_sym_delete] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(508),
    [anon_sym_PLUS_PLUS] = ACTIONS(508),
    [anon_sym_DASH_DASH] = ACTIONS(508),
    [anon_sym_mapping] = ACTIONS(506),
    [anon_sym_bool] = ACTIONS(506),
    [anon_sym_string] = ACTIONS(506),
    [anon_sym_int] = ACTIONS(506),
    [anon_sym_int8] = ACTIONS(506),
    [anon_sym_int16] = ACTIONS(506),
    [anon_sym_int24] = ACTIONS(506),
    [anon_sym_int32] = ACTIONS(506),
    [anon_sym_int40] = ACTIONS(506),
    [anon_sym_int48] = ACTIONS(506),
    [anon_sym_int56] = ACTIONS(506),
    [anon_sym_int64] = ACTIONS(506),
    [anon_sym_int72] = ACTIONS(506),
    [anon_sym_int80] = ACTIONS(506),
    [anon_sym_int88] = ACTIONS(506),
    [anon_sym_int96] = ACTIONS(506),
    [anon_sym_int104] = ACTIONS(506),
    [anon_sym_int112] = ACTIONS(506),
    [anon_sym_int120] = ACTIONS(506),
    [anon_sym_int128] = ACTIONS(506),
    [anon_sym_int136] = ACTIONS(506),
    [anon_sym_int144] = ACTIONS(506),
    [anon_sym_int152] = ACTIONS(506),
    [anon_sym_int160] = ACTIONS(506),
    [anon_sym_int168] = ACTIONS(506),
    [anon_sym_int176] = ACTIONS(506),
    [anon_sym_int184] = ACTIONS(506),
    [anon_sym_int192] = ACTIONS(506),
    [anon_sym_int200] = ACTIONS(506),
    [anon_sym_int208] = ACTIONS(506),
    [anon_sym_int216] = ACTIONS(506),
    [anon_sym_int224] = ACTIONS(506),
    [anon_sym_int232] = ACTIONS(506),
    [anon_sym_int240] = ACTIONS(506),
    [anon_sym_int248] = ACTIONS(506),
    [anon_sym_int256] = ACTIONS(506),
    [anon_sym_uint] = ACTIONS(506),
    [anon_sym_uint8] = ACTIONS(506),
    [anon_sym_uint16] = ACTIONS(506),
    [anon_sym_uint24] = ACTIONS(506),
    [anon_sym_uint32] = ACTIONS(506),
    [anon_sym_uint40] = ACTIONS(506),
    [anon_sym_uint48] = ACTIONS(506),
    [anon_sym_uint56] = ACTIONS(506),
    [anon_sym_uint64] = ACTIONS(506),
    [anon_sym_uint72] = ACTIONS(506),
    [anon_sym_uint80] = ACTIONS(506),
    [anon_sym_uint88] = ACTIONS(506),
    [anon_sym_uint96] = ACTIONS(506),
    [anon_sym_uint104] = ACTIONS(506),
    [anon_sym_uint112] = ACTIONS(506),
    [anon_sym_uint120] = ACTIONS(506),
    [anon_sym_uint128] = ACTIONS(506),
    [anon_sym_uint136] = ACTIONS(506),
    [anon_sym_uint144] = ACTIONS(506),
    [anon_sym_uint152] = ACTIONS(506),
    [anon_sym_uint160] = ACTIONS(506),
    [anon_sym_uint168] = ACTIONS(506),
    [anon_sym_uint176] = ACTIONS(506),
    [anon_sym_uint184] = ACTIONS(506),
    [anon_sym_uint192] = ACTIONS(506),
    [anon_sym_uint200] = ACTIONS(506),
    [anon_sym_uint208] = ACTIONS(506),
    [anon_sym_uint216] = ACTIONS(506),
    [anon_sym_uint224] = ACTIONS(506),
    [anon_sym_uint232] = ACTIONS(506),
    [anon_sym_uint240] = ACTIONS(506),
    [anon_sym_uint248] = ACTIONS(506),
    [anon_sym_uint256] = ACTIONS(506),
    [anon_sym_bytes] = ACTIONS(506),
    [anon_sym_bytes1] = ACTIONS(506),
    [anon_sym_bytes2] = ACTIONS(506),
    [anon_sym_bytes3] = ACTIONS(506),
    [anon_sym_bytes4] = ACTIONS(506),
    [anon_sym_bytes5] = ACTIONS(506),
    [anon_sym_bytes6] = ACTIONS(506),
    [anon_sym_bytes7] = ACTIONS(506),
    [anon_sym_bytes8] = ACTIONS(506),
    [anon_sym_bytes9] = ACTIONS(506),
    [anon_sym_bytes10] = ACTIONS(506),
    [anon_sym_bytes11] = ACTIONS(506),
    [anon_sym_bytes12] = ACTIONS(506),
    [anon_sym_bytes13] = ACTIONS(506),
    [anon_sym_bytes14] = ACTIONS(506),
    [anon_sym_bytes15] = ACTIONS(506),
    [anon_sym_bytes16] = ACTIONS(506),
    [anon_sym_bytes17] = ACTIONS(506),
    [anon_sym_bytes18] = ACTIONS(506),
    [anon_sym_bytes19] = ACTIONS(506),
    [anon_sym_bytes20] = ACTIONS(506),
    [anon_sym_bytes21] = ACTIONS(506),
    [anon_sym_bytes22] = ACTIONS(506),
    [anon_sym_bytes23] = ACTIONS(506),
    [anon_sym_bytes24] = ACTIONS(506),
    [anon_sym_bytes25] = ACTIONS(506),
    [anon_sym_bytes26] = ACTIONS(506),
    [anon_sym_bytes27] = ACTIONS(506),
    [anon_sym_bytes28] = ACTIONS(506),
    [anon_sym_bytes29] = ACTIONS(506),
    [anon_sym_bytes30] = ACTIONS(506),
    [anon_sym_bytes31] = ACTIONS(506),
    [anon_sym_bytes32] = ACTIONS(506),
    [anon_sym_fixed] = ACTIONS(506),
    [aux_sym__fixed_token1] = ACTIONS(506),
    [anon_sym_ufixed] = ACTIONS(506),
    [aux_sym__ufixed_token1] = ACTIONS(506),
    [aux_sym__decimal_number_token1] = ACTIONS(506),
    [aux_sym__decimal_number_token2] = ACTIONS(508),
    [aux_sym__hex_number_token1] = ACTIONS(508),
    [anon_sym_hex] = ACTIONS(506),
    [anon_sym_DQUOTE] = ACTIONS(508),
    [anon_sym_SQUOTE] = ACTIONS(508),
    [anon_sym_unicode] = ACTIONS(506),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_identifier] = ACTIONS(510),
    [anon_sym_DASH] = ACTIONS(510),
    [anon_sym_TILDE] = ACTIONS(512),
    [anon_sym_LBRACE] = ACTIONS(512),
    [anon_sym_RBRACE] = ACTIONS(512),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_LPAREN] = ACTIONS(512),
    [anon_sym_for] = ACTIONS(510),
    [anon_sym_assembly] = ACTIONS(510),
    [anon_sym_break] = ACTIONS(510),
    [anon_sym_continue] = ACTIONS(510),
    [anon_sym_true] = ACTIONS(510),
    [anon_sym_false] = ACTIONS(510),
    [anon_sym_if] = ACTIONS(510),
    [anon_sym_function] = ACTIONS(510),
    [anon_sym_byte] = ACTIONS(510),
    [anon_sym_address] = ACTIONS(510),
    [anon_sym_return] = ACTIONS(510),
    [anon_sym_revert] = ACTIONS(510),
    [sym_unchecked] = ACTIONS(510),
    [anon_sym_var] = ACTIONS(510),
    [anon_sym_else] = ACTIONS(510),
    [anon_sym_while] = ACTIONS(510),
    [anon_sym_do] = ACTIONS(510),
    [anon_sym_try] = ACTIONS(510),
    [anon_sym_emit] = ACTIONS(510),
    [anon_sym_payable] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(510),
    [anon_sym_LBRACK] = ACTIONS(512),
    [anon_sym_delete] = ACTIONS(510),
    [anon_sym_BANG] = ACTIONS(512),
    [anon_sym_PLUS_PLUS] = ACTIONS(512),
    [anon_sym_DASH_DASH] = ACTIONS(512),
    [anon_sym_mapping] = ACTIONS(510),
    [anon_sym_bool] = ACTIONS(510),
    [anon_sym_string] = ACTIONS(510),
    [anon_sym_int] = ACTIONS(510),
    [anon_sym_int8] = ACTIONS(510),
    [anon_sym_int16] = ACTIONS(510),
    [anon_sym_int24] = ACTIONS(510),
    [anon_sym_int32] = ACTIONS(510),
    [anon_sym_int40] = ACTIONS(510),
    [anon_sym_int48] = ACTIONS(510),
    [anon_sym_int56] = ACTIONS(510),
    [anon_sym_int64] = ACTIONS(510),
    [anon_sym_int72] = ACTIONS(510),
    [anon_sym_int80] = ACTIONS(510),
    [anon_sym_int88] = ACTIONS(510),
    [anon_sym_int96] = ACTIONS(510),
    [anon_sym_int104] = ACTIONS(510),
    [anon_sym_int112] = ACTIONS(510),
    [anon_sym_int120] = ACTIONS(510),
    [anon_sym_int128] = ACTIONS(510),
    [anon_sym_int136] = ACTIONS(510),
    [anon_sym_int144] = ACTIONS(510),
    [anon_sym_int152] = ACTIONS(510),
    [anon_sym_int160] = ACTIONS(510),
    [anon_sym_int168] = ACTIONS(510),
    [anon_sym_int176] = ACTIONS(510),
    [anon_sym_int184] = ACTIONS(510),
    [anon_sym_int192] = ACTIONS(510),
    [anon_sym_int200] = ACTIONS(510),
    [anon_sym_int208] = ACTIONS(510),
    [anon_sym_int216] = ACTIONS(510),
    [anon_sym_int224] = ACTIONS(510),
    [anon_sym_int232] = ACTIONS(510),
    [anon_sym_int240] = ACTIONS(510),
    [anon_sym_int248] = ACTIONS(510),
    [anon_sym_int256] = ACTIONS(510),
    [anon_sym_uint] = ACTIONS(510),
    [anon_sym_uint8] = ACTIONS(510),
    [anon_sym_uint16] = ACTIONS(510),
    [anon_sym_uint24] = ACTIONS(510),
    [anon_sym_uint32] = ACTIONS(510),
    [anon_sym_uint40] = ACTIONS(510),
    [anon_sym_uint48] = ACTIONS(510),
    [anon_sym_uint56] = ACTIONS(510),
    [anon_sym_uint64] = ACTIONS(510),
    [anon_sym_uint72] = ACTIONS(510),
    [anon_sym_uint80] = ACTIONS(510),
    [anon_sym_uint88] = ACTIONS(510),
    [anon_sym_uint96] = ACTIONS(510),
    [anon_sym_uint104] = ACTIONS(510),
    [anon_sym_uint112] = ACTIONS(510),
    [anon_sym_uint120] = ACTIONS(510),
    [anon_sym_uint128] = ACTIONS(510),
    [anon_sym_uint136] = ACTIONS(510),
    [anon_sym_uint144] = ACTIONS(510),
    [anon_sym_uint152] = ACTIONS(510),
    [anon_sym_uint160] = ACTIONS(510),
    [anon_sym_uint168] = ACTIONS(510),
    [anon_sym_uint176] = ACTIONS(510),
    [anon_sym_uint184] = ACTIONS(510),
    [anon_sym_uint192] = ACTIONS(510),
    [anon_sym_uint200] = ACTIONS(510),
    [anon_sym_uint208] = ACTIONS(510),
    [anon_sym_uint216] = ACTIONS(510),
    [anon_sym_uint224] = ACTIONS(510),
    [anon_sym_uint232] = ACTIONS(510),
    [anon_sym_uint240] = ACTIONS(510),
    [anon_sym_uint248] = ACTIONS(510),
    [anon_sym_uint256] = ACTIONS(510),
    [anon_sym_bytes] = ACTIONS(510),
    [anon_sym_bytes1] = ACTIONS(510),
    [anon_sym_bytes2] = ACTIONS(510),
    [anon_sym_bytes3] = ACTIONS(510),
    [anon_sym_bytes4] = ACTIONS(510),
    [anon_sym_bytes5] = ACTIONS(510),
    [anon_sym_bytes6] = ACTIONS(510),
    [anon_sym_bytes7] = ACTIONS(510),
    [anon_sym_bytes8] = ACTIONS(510),
    [anon_sym_bytes9] = ACTIONS(510),
    [anon_sym_bytes10] = ACTIONS(510),
    [anon_sym_bytes11] = ACTIONS(510),
    [anon_sym_bytes12] = ACTIONS(510),
    [anon_sym_bytes13] = ACTIONS(510),
    [anon_sym_bytes14] = ACTIONS(510),
    [anon_sym_bytes15] = ACTIONS(510),
    [anon_sym_bytes16] = ACTIONS(510),
    [anon_sym_bytes17] = ACTIONS(510),
    [anon_sym_bytes18] = ACTIONS(510),
    [anon_sym_bytes19] = ACTIONS(510),
    [anon_sym_bytes20] = ACTIONS(510),
    [anon_sym_bytes21] = ACTIONS(510),
    [anon_sym_bytes22] = ACTIONS(510),
    [anon_sym_bytes23] = ACTIONS(510),
    [anon_sym_bytes24] = ACTIONS(510),
    [anon_sym_bytes25] = ACTIONS(510),
    [anon_sym_bytes26] = ACTIONS(510),
    [anon_sym_bytes27] = ACTIONS(510),
    [anon_sym_bytes28] = ACTIONS(510),
    [anon_sym_bytes29] = ACTIONS(510),
    [anon_sym_bytes30] = ACTIONS(510),
    [anon_sym_bytes31] = ACTIONS(510),
    [anon_sym_bytes32] = ACTIONS(510),
    [anon_sym_fixed] = ACTIONS(510),
    [aux_sym__fixed_token1] = ACTIONS(510),
    [anon_sym_ufixed] = ACTIONS(510),
    [aux_sym__ufixed_token1] = ACTIONS(510),
    [aux_sym__decimal_number_token1] = ACTIONS(510),
    [aux_sym__decimal_number_token2] = ACTIONS(512),
    [aux_sym__hex_number_token1] = ACTIONS(512),
    [anon_sym_hex] = ACTIONS(510),
    [anon_sym_DQUOTE] = ACTIONS(512),
    [anon_sym_SQUOTE] = ACTIONS(512),
    [anon_sym_unicode] = ACTIONS(510),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_identifier] = ACTIONS(514),
    [anon_sym_DASH] = ACTIONS(514),
    [anon_sym_TILDE] = ACTIONS(516),
    [anon_sym_LBRACE] = ACTIONS(516),
    [anon_sym_RBRACE] = ACTIONS(516),
    [anon_sym_type] = ACTIONS(514),
    [anon_sym_LPAREN] = ACTIONS(516),
    [anon_sym_for] = ACTIONS(514),
    [anon_sym_assembly] = ACTIONS(514),
    [anon_sym_break] = ACTIONS(514),
    [anon_sym_continue] = ACTIONS(514),
    [anon_sym_true] = ACTIONS(514),
    [anon_sym_false] = ACTIONS(514),
    [anon_sym_if] = ACTIONS(514),
    [anon_sym_function] = ACTIONS(514),
    [anon_sym_byte] = ACTIONS(514),
    [anon_sym_address] = ACTIONS(514),
    [anon_sym_return] = ACTIONS(514),
    [anon_sym_revert] = ACTIONS(514),
    [sym_unchecked] = ACTIONS(514),
    [anon_sym_var] = ACTIONS(514),
    [anon_sym_else] = ACTIONS(514),
    [anon_sym_while] = ACTIONS(514),
    [anon_sym_do] = ACTIONS(514),
    [anon_sym_try] = ACTIONS(514),
    [anon_sym_emit] = ACTIONS(514),
    [anon_sym_payable] = ACTIONS(514),
    [anon_sym_new] = ACTIONS(514),
    [anon_sym_LBRACK] = ACTIONS(516),
    [anon_sym_delete] = ACTIONS(514),
    [anon_sym_BANG] = ACTIONS(516),
    [anon_sym_PLUS_PLUS] = ACTIONS(516),
    [anon_sym_DASH_DASH] = ACTIONS(516),
    [anon_sym_mapping] = ACTIONS(514),
    [anon_sym_bool] = ACTIONS(514),
    [anon_sym_string] = ACTIONS(514),
    [anon_sym_int] = ACTIONS(514),
    [anon_sym_int8] = ACTIONS(514),
    [anon_sym_int16] = ACTIONS(514),
    [anon_sym_int24] = ACTIONS(514),
    [anon_sym_int32] = ACTIONS(514),
    [anon_sym_int40] = ACTIONS(514),
    [anon_sym_int48] = ACTIONS(514),
    [anon_sym_int56] = ACTIONS(514),
    [anon_sym_int64] = ACTIONS(514),
    [anon_sym_int72] = ACTIONS(514),
    [anon_sym_int80] = ACTIONS(514),
    [anon_sym_int88] = ACTIONS(514),
    [anon_sym_int96] = ACTIONS(514),
    [anon_sym_int104] = ACTIONS(514),
    [anon_sym_int112] = ACTIONS(514),
    [anon_sym_int120] = ACTIONS(514),
    [anon_sym_int128] = ACTIONS(514),
    [anon_sym_int136] = ACTIONS(514),
    [anon_sym_int144] = ACTIONS(514),
    [anon_sym_int152] = ACTIONS(514),
    [anon_sym_int160] = ACTIONS(514),
    [anon_sym_int168] = ACTIONS(514),
    [anon_sym_int176] = ACTIONS(514),
    [anon_sym_int184] = ACTIONS(514),
    [anon_sym_int192] = ACTIONS(514),
    [anon_sym_int200] = ACTIONS(514),
    [anon_sym_int208] = ACTIONS(514),
    [anon_sym_int216] = ACTIONS(514),
    [anon_sym_int224] = ACTIONS(514),
    [anon_sym_int232] = ACTIONS(514),
    [anon_sym_int240] = ACTIONS(514),
    [anon_sym_int248] = ACTIONS(514),
    [anon_sym_int256] = ACTIONS(514),
    [anon_sym_uint] = ACTIONS(514),
    [anon_sym_uint8] = ACTIONS(514),
    [anon_sym_uint16] = ACTIONS(514),
    [anon_sym_uint24] = ACTIONS(514),
    [anon_sym_uint32] = ACTIONS(514),
    [anon_sym_uint40] = ACTIONS(514),
    [anon_sym_uint48] = ACTIONS(514),
    [anon_sym_uint56] = ACTIONS(514),
    [anon_sym_uint64] = ACTIONS(514),
    [anon_sym_uint72] = ACTIONS(514),
    [anon_sym_uint80] = ACTIONS(514),
    [anon_sym_uint88] = ACTIONS(514),
    [anon_sym_uint96] = ACTIONS(514),
    [anon_sym_uint104] = ACTIONS(514),
    [anon_sym_uint112] = ACTIONS(514),
    [anon_sym_uint120] = ACTIONS(514),
    [anon_sym_uint128] = ACTIONS(514),
    [anon_sym_uint136] = ACTIONS(514),
    [anon_sym_uint144] = ACTIONS(514),
    [anon_sym_uint152] = ACTIONS(514),
    [anon_sym_uint160] = ACTIONS(514),
    [anon_sym_uint168] = ACTIONS(514),
    [anon_sym_uint176] = ACTIONS(514),
    [anon_sym_uint184] = ACTIONS(514),
    [anon_sym_uint192] = ACTIONS(514),
    [anon_sym_uint200] = ACTIONS(514),
    [anon_sym_uint208] = ACTIONS(514),
    [anon_sym_uint216] = ACTIONS(514),
    [anon_sym_uint224] = ACTIONS(514),
    [anon_sym_uint232] = ACTIONS(514),
    [anon_sym_uint240] = ACTIONS(514),
    [anon_sym_uint248] = ACTIONS(514),
    [anon_sym_uint256] = ACTIONS(514),
    [anon_sym_bytes] = ACTIONS(514),
    [anon_sym_bytes1] = ACTIONS(514),
    [anon_sym_bytes2] = ACTIONS(514),
    [anon_sym_bytes3] = ACTIONS(514),
    [anon_sym_bytes4] = ACTIONS(514),
    [anon_sym_bytes5] = ACTIONS(514),
    [anon_sym_bytes6] = ACTIONS(514),
    [anon_sym_bytes7] = ACTIONS(514),
    [anon_sym_bytes8] = ACTIONS(514),
    [anon_sym_bytes9] = ACTIONS(514),
    [anon_sym_bytes10] = ACTIONS(514),
    [anon_sym_bytes11] = ACTIONS(514),
    [anon_sym_bytes12] = ACTIONS(514),
    [anon_sym_bytes13] = ACTIONS(514),
    [anon_sym_bytes14] = ACTIONS(514),
    [anon_sym_bytes15] = ACTIONS(514),
    [anon_sym_bytes16] = ACTIONS(514),
    [anon_sym_bytes17] = ACTIONS(514),
    [anon_sym_bytes18] = ACTIONS(514),
    [anon_sym_bytes19] = ACTIONS(514),
    [anon_sym_bytes20] = ACTIONS(514),
    [anon_sym_bytes21] = ACTIONS(514),
    [anon_sym_bytes22] = ACTIONS(514),
    [anon_sym_bytes23] = ACTIONS(514),
    [anon_sym_bytes24] = ACTIONS(514),
    [anon_sym_bytes25] = ACTIONS(514),
    [anon_sym_bytes26] = ACTIONS(514),
    [anon_sym_bytes27] = ACTIONS(514),
    [anon_sym_bytes28] = ACTIONS(514),
    [anon_sym_bytes29] = ACTIONS(514),
    [anon_sym_bytes30] = ACTIONS(514),
    [anon_sym_bytes31] = ACTIONS(514),
    [anon_sym_bytes32] = ACTIONS(514),
    [anon_sym_fixed] = ACTIONS(514),
    [aux_sym__fixed_token1] = ACTIONS(514),
    [anon_sym_ufixed] = ACTIONS(514),
    [aux_sym__ufixed_token1] = ACTIONS(514),
    [aux_sym__decimal_number_token1] = ACTIONS(514),
    [aux_sym__decimal_number_token2] = ACTIONS(516),
    [aux_sym__hex_number_token1] = ACTIONS(516),
    [anon_sym_hex] = ACTIONS(514),
    [anon_sym_DQUOTE] = ACTIONS(516),
    [anon_sym_SQUOTE] = ACTIONS(516),
    [anon_sym_unicode] = ACTIONS(514),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_identifier] = ACTIONS(518),
    [anon_sym_DASH] = ACTIONS(518),
    [anon_sym_TILDE] = ACTIONS(520),
    [anon_sym_LBRACE] = ACTIONS(520),
    [anon_sym_RBRACE] = ACTIONS(520),
    [anon_sym_type] = ACTIONS(518),
    [anon_sym_LPAREN] = ACTIONS(520),
    [anon_sym_for] = ACTIONS(518),
    [anon_sym_assembly] = ACTIONS(518),
    [anon_sym_break] = ACTIONS(518),
    [anon_sym_continue] = ACTIONS(518),
    [anon_sym_true] = ACTIONS(518),
    [anon_sym_false] = ACTIONS(518),
    [anon_sym_if] = ACTIONS(518),
    [anon_sym_function] = ACTIONS(518),
    [anon_sym_byte] = ACTIONS(518),
    [anon_sym_address] = ACTIONS(518),
    [anon_sym_return] = ACTIONS(518),
    [anon_sym_revert] = ACTIONS(518),
    [sym_unchecked] = ACTIONS(518),
    [anon_sym_var] = ACTIONS(518),
    [anon_sym_else] = ACTIONS(518),
    [anon_sym_while] = ACTIONS(518),
    [anon_sym_do] = ACTIONS(518),
    [anon_sym_try] = ACTIONS(518),
    [anon_sym_emit] = ACTIONS(518),
    [anon_sym_payable] = ACTIONS(518),
    [anon_sym_new] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(520),
    [anon_sym_delete] = ACTIONS(518),
    [anon_sym_BANG] = ACTIONS(520),
    [anon_sym_PLUS_PLUS] = ACTIONS(520),
    [anon_sym_DASH_DASH] = ACTIONS(520),
    [anon_sym_mapping] = ACTIONS(518),
    [anon_sym_bool] = ACTIONS(518),
    [anon_sym_string] = ACTIONS(518),
    [anon_sym_int] = ACTIONS(518),
    [anon_sym_int8] = ACTIONS(518),
    [anon_sym_int16] = ACTIONS(518),
    [anon_sym_int24] = ACTIONS(518),
    [anon_sym_int32] = ACTIONS(518),
    [anon_sym_int40] = ACTIONS(518),
    [anon_sym_int48] = ACTIONS(518),
    [anon_sym_int56] = ACTIONS(518),
    [anon_sym_int64] = ACTIONS(518),
    [anon_sym_int72] = ACTIONS(518),
    [anon_sym_int80] = ACTIONS(518),
    [anon_sym_int88] = ACTIONS(518),
    [anon_sym_int96] = ACTIONS(518),
    [anon_sym_int104] = ACTIONS(518),
    [anon_sym_int112] = ACTIONS(518),
    [anon_sym_int120] = ACTIONS(518),
    [anon_sym_int128] = ACTIONS(518),
    [anon_sym_int136] = ACTIONS(518),
    [anon_sym_int144] = ACTIONS(518),
    [anon_sym_int152] = ACTIONS(518),
    [anon_sym_int160] = ACTIONS(518),
    [anon_sym_int168] = ACTIONS(518),
    [anon_sym_int176] = ACTIONS(518),
    [anon_sym_int184] = ACTIONS(518),
    [anon_sym_int192] = ACTIONS(518),
    [anon_sym_int200] = ACTIONS(518),
    [anon_sym_int208] = ACTIONS(518),
    [anon_sym_int216] = ACTIONS(518),
    [anon_sym_int224] = ACTIONS(518),
    [anon_sym_int232] = ACTIONS(518),
    [anon_sym_int240] = ACTIONS(518),
    [anon_sym_int248] = ACTIONS(518),
    [anon_sym_int256] = ACTIONS(518),
    [anon_sym_uint] = ACTIONS(518),
    [anon_sym_uint8] = ACTIONS(518),
    [anon_sym_uint16] = ACTIONS(518),
    [anon_sym_uint24] = ACTIONS(518),
    [anon_sym_uint32] = ACTIONS(518),
    [anon_sym_uint40] = ACTIONS(518),
    [anon_sym_uint48] = ACTIONS(518),
    [anon_sym_uint56] = ACTIONS(518),
    [anon_sym_uint64] = ACTIONS(518),
    [anon_sym_uint72] = ACTIONS(518),
    [anon_sym_uint80] = ACTIONS(518),
    [anon_sym_uint88] = ACTIONS(518),
    [anon_sym_uint96] = ACTIONS(518),
    [anon_sym_uint104] = ACTIONS(518),
    [anon_sym_uint112] = ACTIONS(518),
    [anon_sym_uint120] = ACTIONS(518),
    [anon_sym_uint128] = ACTIONS(518),
    [anon_sym_uint136] = ACTIONS(518),
    [anon_sym_uint144] = ACTIONS(518),
    [anon_sym_uint152] = ACTIONS(518),
    [anon_sym_uint160] = ACTIONS(518),
    [anon_sym_uint168] = ACTIONS(518),
    [anon_sym_uint176] = ACTIONS(518),
    [anon_sym_uint184] = ACTIONS(518),
    [anon_sym_uint192] = ACTIONS(518),
    [anon_sym_uint200] = ACTIONS(518),
    [anon_sym_uint208] = ACTIONS(518),
    [anon_sym_uint216] = ACTIONS(518),
    [anon_sym_uint224] = ACTIONS(518),
    [anon_sym_uint232] = ACTIONS(518),
    [anon_sym_uint240] = ACTIONS(518),
    [anon_sym_uint248] = ACTIONS(518),
    [anon_sym_uint256] = ACTIONS(518),
    [anon_sym_bytes] = ACTIONS(518),
    [anon_sym_bytes1] = ACTIONS(518),
    [anon_sym_bytes2] = ACTIONS(518),
    [anon_sym_bytes3] = ACTIONS(518),
    [anon_sym_bytes4] = ACTIONS(518),
    [anon_sym_bytes5] = ACTIONS(518),
    [anon_sym_bytes6] = ACTIONS(518),
    [anon_sym_bytes7] = ACTIONS(518),
    [anon_sym_bytes8] = ACTIONS(518),
    [anon_sym_bytes9] = ACTIONS(518),
    [anon_sym_bytes10] = ACTIONS(518),
    [anon_sym_bytes11] = ACTIONS(518),
    [anon_sym_bytes12] = ACTIONS(518),
    [anon_sym_bytes13] = ACTIONS(518),
    [anon_sym_bytes14] = ACTIONS(518),
    [anon_sym_bytes15] = ACTIONS(518),
    [anon_sym_bytes16] = ACTIONS(518),
    [anon_sym_bytes17] = ACTIONS(518),
    [anon_sym_bytes18] = ACTIONS(518),
    [anon_sym_bytes19] = ACTIONS(518),
    [anon_sym_bytes20] = ACTIONS(518),
    [anon_sym_bytes21] = ACTIONS(518),
    [anon_sym_bytes22] = ACTIONS(518),
    [anon_sym_bytes23] = ACTIONS(518),
    [anon_sym_bytes24] = ACTIONS(518),
    [anon_sym_bytes25] = ACTIONS(518),
    [anon_sym_bytes26] = ACTIONS(518),
    [anon_sym_bytes27] = ACTIONS(518),
    [anon_sym_bytes28] = ACTIONS(518),
    [anon_sym_bytes29] = ACTIONS(518),
    [anon_sym_bytes30] = ACTIONS(518),
    [anon_sym_bytes31] = ACTIONS(518),
    [anon_sym_bytes32] = ACTIONS(518),
    [anon_sym_fixed] = ACTIONS(518),
    [aux_sym__fixed_token1] = ACTIONS(518),
    [anon_sym_ufixed] = ACTIONS(518),
    [aux_sym__ufixed_token1] = ACTIONS(518),
    [aux_sym__decimal_number_token1] = ACTIONS(518),
    [aux_sym__decimal_number_token2] = ACTIONS(520),
    [aux_sym__hex_number_token1] = ACTIONS(520),
    [anon_sym_hex] = ACTIONS(518),
    [anon_sym_DQUOTE] = ACTIONS(520),
    [anon_sym_SQUOTE] = ACTIONS(520),
    [anon_sym_unicode] = ACTIONS(518),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_identifier] = ACTIONS(522),
    [anon_sym_DASH] = ACTIONS(522),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_LBRACE] = ACTIONS(524),
    [anon_sym_RBRACE] = ACTIONS(524),
    [anon_sym_type] = ACTIONS(522),
    [anon_sym_LPAREN] = ACTIONS(524),
    [anon_sym_for] = ACTIONS(522),
    [anon_sym_assembly] = ACTIONS(522),
    [anon_sym_break] = ACTIONS(522),
    [anon_sym_continue] = ACTIONS(522),
    [anon_sym_true] = ACTIONS(522),
    [anon_sym_false] = ACTIONS(522),
    [anon_sym_if] = ACTIONS(522),
    [anon_sym_function] = ACTIONS(522),
    [anon_sym_byte] = ACTIONS(522),
    [anon_sym_address] = ACTIONS(522),
    [anon_sym_return] = ACTIONS(522),
    [anon_sym_revert] = ACTIONS(522),
    [sym_unchecked] = ACTIONS(522),
    [anon_sym_var] = ACTIONS(522),
    [anon_sym_else] = ACTIONS(522),
    [anon_sym_while] = ACTIONS(522),
    [anon_sym_do] = ACTIONS(522),
    [anon_sym_try] = ACTIONS(522),
    [anon_sym_emit] = ACTIONS(522),
    [anon_sym_payable] = ACTIONS(522),
    [anon_sym_new] = ACTIONS(522),
    [anon_sym_LBRACK] = ACTIONS(524),
    [anon_sym_delete] = ACTIONS(522),
    [anon_sym_BANG] = ACTIONS(524),
    [anon_sym_PLUS_PLUS] = ACTIONS(524),
    [anon_sym_DASH_DASH] = ACTIONS(524),
    [anon_sym_mapping] = ACTIONS(522),
    [anon_sym_bool] = ACTIONS(522),
    [anon_sym_string] = ACTIONS(522),
    [anon_sym_int] = ACTIONS(522),
    [anon_sym_int8] = ACTIONS(522),
    [anon_sym_int16] = ACTIONS(522),
    [anon_sym_int24] = ACTIONS(522),
    [anon_sym_int32] = ACTIONS(522),
    [anon_sym_int40] = ACTIONS(522),
    [anon_sym_int48] = ACTIONS(522),
    [anon_sym_int56] = ACTIONS(522),
    [anon_sym_int64] = ACTIONS(522),
    [anon_sym_int72] = ACTIONS(522),
    [anon_sym_int80] = ACTIONS(522),
    [anon_sym_int88] = ACTIONS(522),
    [anon_sym_int96] = ACTIONS(522),
    [anon_sym_int104] = ACTIONS(522),
    [anon_sym_int112] = ACTIONS(522),
    [anon_sym_int120] = ACTIONS(522),
    [anon_sym_int128] = ACTIONS(522),
    [anon_sym_int136] = ACTIONS(522),
    [anon_sym_int144] = ACTIONS(522),
    [anon_sym_int152] = ACTIONS(522),
    [anon_sym_int160] = ACTIONS(522),
    [anon_sym_int168] = ACTIONS(522),
    [anon_sym_int176] = ACTIONS(522),
    [anon_sym_int184] = ACTIONS(522),
    [anon_sym_int192] = ACTIONS(522),
    [anon_sym_int200] = ACTIONS(522),
    [anon_sym_int208] = ACTIONS(522),
    [anon_sym_int216] = ACTIONS(522),
    [anon_sym_int224] = ACTIONS(522),
    [anon_sym_int232] = ACTIONS(522),
    [anon_sym_int240] = ACTIONS(522),
    [anon_sym_int248] = ACTIONS(522),
    [anon_sym_int256] = ACTIONS(522),
    [anon_sym_uint] = ACTIONS(522),
    [anon_sym_uint8] = ACTIONS(522),
    [anon_sym_uint16] = ACTIONS(522),
    [anon_sym_uint24] = ACTIONS(522),
    [anon_sym_uint32] = ACTIONS(522),
    [anon_sym_uint40] = ACTIONS(522),
    [anon_sym_uint48] = ACTIONS(522),
    [anon_sym_uint56] = ACTIONS(522),
    [anon_sym_uint64] = ACTIONS(522),
    [anon_sym_uint72] = ACTIONS(522),
    [anon_sym_uint80] = ACTIONS(522),
    [anon_sym_uint88] = ACTIONS(522),
    [anon_sym_uint96] = ACTIONS(522),
    [anon_sym_uint104] = ACTIONS(522),
    [anon_sym_uint112] = ACTIONS(522),
    [anon_sym_uint120] = ACTIONS(522),
    [anon_sym_uint128] = ACTIONS(522),
    [anon_sym_uint136] = ACTIONS(522),
    [anon_sym_uint144] = ACTIONS(522),
    [anon_sym_uint152] = ACTIONS(522),
    [anon_sym_uint160] = ACTIONS(522),
    [anon_sym_uint168] = ACTIONS(522),
    [anon_sym_uint176] = ACTIONS(522),
    [anon_sym_uint184] = ACTIONS(522),
    [anon_sym_uint192] = ACTIONS(522),
    [anon_sym_uint200] = ACTIONS(522),
    [anon_sym_uint208] = ACTIONS(522),
    [anon_sym_uint216] = ACTIONS(522),
    [anon_sym_uint224] = ACTIONS(522),
    [anon_sym_uint232] = ACTIONS(522),
    [anon_sym_uint240] = ACTIONS(522),
    [anon_sym_uint248] = ACTIONS(522),
    [anon_sym_uint256] = ACTIONS(522),
    [anon_sym_bytes] = ACTIONS(522),
    [anon_sym_bytes1] = ACTIONS(522),
    [anon_sym_bytes2] = ACTIONS(522),
    [anon_sym_bytes3] = ACTIONS(522),
    [anon_sym_bytes4] = ACTIONS(522),
    [anon_sym_bytes5] = ACTIONS(522),
    [anon_sym_bytes6] = ACTIONS(522),
    [anon_sym_bytes7] = ACTIONS(522),
    [anon_sym_bytes8] = ACTIONS(522),
    [anon_sym_bytes9] = ACTIONS(522),
    [anon_sym_bytes10] = ACTIONS(522),
    [anon_sym_bytes11] = ACTIONS(522),
    [anon_sym_bytes12] = ACTIONS(522),
    [anon_sym_bytes13] = ACTIONS(522),
    [anon_sym_bytes14] = ACTIONS(522),
    [anon_sym_bytes15] = ACTIONS(522),
    [anon_sym_bytes16] = ACTIONS(522),
    [anon_sym_bytes17] = ACTIONS(522),
    [anon_sym_bytes18] = ACTIONS(522),
    [anon_sym_bytes19] = ACTIONS(522),
    [anon_sym_bytes20] = ACTIONS(522),
    [anon_sym_bytes21] = ACTIONS(522),
    [anon_sym_bytes22] = ACTIONS(522),
    [anon_sym_bytes23] = ACTIONS(522),
    [anon_sym_bytes24] = ACTIONS(522),
    [anon_sym_bytes25] = ACTIONS(522),
    [anon_sym_bytes26] = ACTIONS(522),
    [anon_sym_bytes27] = ACTIONS(522),
    [anon_sym_bytes28] = ACTIONS(522),
    [anon_sym_bytes29] = ACTIONS(522),
    [anon_sym_bytes30] = ACTIONS(522),
    [anon_sym_bytes31] = ACTIONS(522),
    [anon_sym_bytes32] = ACTIONS(522),
    [anon_sym_fixed] = ACTIONS(522),
    [aux_sym__fixed_token1] = ACTIONS(522),
    [anon_sym_ufixed] = ACTIONS(522),
    [aux_sym__ufixed_token1] = ACTIONS(522),
    [aux_sym__decimal_number_token1] = ACTIONS(522),
    [aux_sym__decimal_number_token2] = ACTIONS(524),
    [aux_sym__hex_number_token1] = ACTIONS(524),
    [anon_sym_hex] = ACTIONS(522),
    [anon_sym_DQUOTE] = ACTIONS(524),
    [anon_sym_SQUOTE] = ACTIONS(524),
    [anon_sym_unicode] = ACTIONS(522),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_identifier] = ACTIONS(526),
    [anon_sym_DASH] = ACTIONS(526),
    [anon_sym_TILDE] = ACTIONS(528),
    [anon_sym_LBRACE] = ACTIONS(528),
    [anon_sym_RBRACE] = ACTIONS(528),
    [anon_sym_type] = ACTIONS(526),
    [anon_sym_LPAREN] = ACTIONS(528),
    [anon_sym_for] = ACTIONS(526),
    [anon_sym_assembly] = ACTIONS(526),
    [anon_sym_break] = ACTIONS(526),
    [anon_sym_continue] = ACTIONS(526),
    [anon_sym_true] = ACTIONS(526),
    [anon_sym_false] = ACTIONS(526),
    [anon_sym_if] = ACTIONS(526),
    [anon_sym_function] = ACTIONS(526),
    [anon_sym_byte] = ACTIONS(526),
    [anon_sym_address] = ACTIONS(526),
    [anon_sym_return] = ACTIONS(526),
    [anon_sym_revert] = ACTIONS(526),
    [sym_unchecked] = ACTIONS(526),
    [anon_sym_var] = ACTIONS(526),
    [anon_sym_else] = ACTIONS(530),
    [anon_sym_while] = ACTIONS(526),
    [anon_sym_do] = ACTIONS(526),
    [anon_sym_try] = ACTIONS(526),
    [anon_sym_emit] = ACTIONS(526),
    [anon_sym_payable] = ACTIONS(526),
    [anon_sym_new] = ACTIONS(526),
    [anon_sym_LBRACK] = ACTIONS(528),
    [anon_sym_delete] = ACTIONS(526),
    [anon_sym_BANG] = ACTIONS(528),
    [anon_sym_PLUS_PLUS] = ACTIONS(528),
    [anon_sym_DASH_DASH] = ACTIONS(528),
    [anon_sym_mapping] = ACTIONS(526),
    [anon_sym_bool] = ACTIONS(526),
    [anon_sym_string] = ACTIONS(526),
    [anon_sym_int] = ACTIONS(526),
    [anon_sym_int8] = ACTIONS(526),
    [anon_sym_int16] = ACTIONS(526),
    [anon_sym_int24] = ACTIONS(526),
    [anon_sym_int32] = ACTIONS(526),
    [anon_sym_int40] = ACTIONS(526),
    [anon_sym_int48] = ACTIONS(526),
    [anon_sym_int56] = ACTIONS(526),
    [anon_sym_int64] = ACTIONS(526),
    [anon_sym_int72] = ACTIONS(526),
    [anon_sym_int80] = ACTIONS(526),
    [anon_sym_int88] = ACTIONS(526),
    [anon_sym_int96] = ACTIONS(526),
    [anon_sym_int104] = ACTIONS(526),
    [anon_sym_int112] = ACTIONS(526),
    [anon_sym_int120] = ACTIONS(526),
    [anon_sym_int128] = ACTIONS(526),
    [anon_sym_int136] = ACTIONS(526),
    [anon_sym_int144] = ACTIONS(526),
    [anon_sym_int152] = ACTIONS(526),
    [anon_sym_int160] = ACTIONS(526),
    [anon_sym_int168] = ACTIONS(526),
    [anon_sym_int176] = ACTIONS(526),
    [anon_sym_int184] = ACTIONS(526),
    [anon_sym_int192] = ACTIONS(526),
    [anon_sym_int200] = ACTIONS(526),
    [anon_sym_int208] = ACTIONS(526),
    [anon_sym_int216] = ACTIONS(526),
    [anon_sym_int224] = ACTIONS(526),
    [anon_sym_int232] = ACTIONS(526),
    [anon_sym_int240] = ACTIONS(526),
    [anon_sym_int248] = ACTIONS(526),
    [anon_sym_int256] = ACTIONS(526),
    [anon_sym_uint] = ACTIONS(526),
    [anon_sym_uint8] = ACTIONS(526),
    [anon_sym_uint16] = ACTIONS(526),
    [anon_sym_uint24] = ACTIONS(526),
    [anon_sym_uint32] = ACTIONS(526),
    [anon_sym_uint40] = ACTIONS(526),
    [anon_sym_uint48] = ACTIONS(526),
    [anon_sym_uint56] = ACTIONS(526),
    [anon_sym_uint64] = ACTIONS(526),
    [anon_sym_uint72] = ACTIONS(526),
    [anon_sym_uint80] = ACTIONS(526),
    [anon_sym_uint88] = ACTIONS(526),
    [anon_sym_uint96] = ACTIONS(526),
    [anon_sym_uint104] = ACTIONS(526),
    [anon_sym_uint112] = ACTIONS(526),
    [anon_sym_uint120] = ACTIONS(526),
    [anon_sym_uint128] = ACTIONS(526),
    [anon_sym_uint136] = ACTIONS(526),
    [anon_sym_uint144] = ACTIONS(526),
    [anon_sym_uint152] = ACTIONS(526),
    [anon_sym_uint160] = ACTIONS(526),
    [anon_sym_uint168] = ACTIONS(526),
    [anon_sym_uint176] = ACTIONS(526),
    [anon_sym_uint184] = ACTIONS(526),
    [anon_sym_uint192] = ACTIONS(526),
    [anon_sym_uint200] = ACTIONS(526),
    [anon_sym_uint208] = ACTIONS(526),
    [anon_sym_uint216] = ACTIONS(526),
    [anon_sym_uint224] = ACTIONS(526),
    [anon_sym_uint232] = ACTIONS(526),
    [anon_sym_uint240] = ACTIONS(526),
    [anon_sym_uint248] = ACTIONS(526),
    [anon_sym_uint256] = ACTIONS(526),
    [anon_sym_bytes] = ACTIONS(526),
    [anon_sym_bytes1] = ACTIONS(526),
    [anon_sym_bytes2] = ACTIONS(526),
    [anon_sym_bytes3] = ACTIONS(526),
    [anon_sym_bytes4] = ACTIONS(526),
    [anon_sym_bytes5] = ACTIONS(526),
    [anon_sym_bytes6] = ACTIONS(526),
    [anon_sym_bytes7] = ACTIONS(526),
    [anon_sym_bytes8] = ACTIONS(526),
    [anon_sym_bytes9] = ACTIONS(526),
    [anon_sym_bytes10] = ACTIONS(526),
    [anon_sym_bytes11] = ACTIONS(526),
    [anon_sym_bytes12] = ACTIONS(526),
    [anon_sym_bytes13] = ACTIONS(526),
    [anon_sym_bytes14] = ACTIONS(526),
    [anon_sym_bytes15] = ACTIONS(526),
    [anon_sym_bytes16] = ACTIONS(526),
    [anon_sym_bytes17] = ACTIONS(526),
    [anon_sym_bytes18] = ACTIONS(526),
    [anon_sym_bytes19] = ACTIONS(526),
    [anon_sym_bytes20] = ACTIONS(526),
    [anon_sym_bytes21] = ACTIONS(526),
    [anon_sym_bytes22] = ACTIONS(526),
    [anon_sym_bytes23] = ACTIONS(526),
    [anon_sym_bytes24] = ACTIONS(526),
    [anon_sym_bytes25] = ACTIONS(526),
    [anon_sym_bytes26] = ACTIONS(526),
    [anon_sym_bytes27] = ACTIONS(526),
    [anon_sym_bytes28] = ACTIONS(526),
    [anon_sym_bytes29] = ACTIONS(526),
    [anon_sym_bytes30] = ACTIONS(526),
    [anon_sym_bytes31] = ACTIONS(526),
    [anon_sym_bytes32] = ACTIONS(526),
    [anon_sym_fixed] = ACTIONS(526),
    [aux_sym__fixed_token1] = ACTIONS(526),
    [anon_sym_ufixed] = ACTIONS(526),
    [aux_sym__ufixed_token1] = ACTIONS(526),
    [aux_sym__decimal_number_token1] = ACTIONS(526),
    [aux_sym__decimal_number_token2] = ACTIONS(528),
    [aux_sym__hex_number_token1] = ACTIONS(528),
    [anon_sym_hex] = ACTIONS(526),
    [anon_sym_DQUOTE] = ACTIONS(528),
    [anon_sym_SQUOTE] = ACTIONS(528),
    [anon_sym_unicode] = ACTIONS(526),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_identifier] = ACTIONS(532),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(534),
    [anon_sym_LBRACE] = ACTIONS(534),
    [anon_sym_RBRACE] = ACTIONS(534),
    [anon_sym_type] = ACTIONS(532),
    [anon_sym_LPAREN] = ACTIONS(534),
    [anon_sym_for] = ACTIONS(532),
    [anon_sym_assembly] = ACTIONS(532),
    [anon_sym_break] = ACTIONS(532),
    [anon_sym_continue] = ACTIONS(532),
    [anon_sym_true] = ACTIONS(532),
    [anon_sym_false] = ACTIONS(532),
    [anon_sym_if] = ACTIONS(532),
    [anon_sym_function] = ACTIONS(532),
    [anon_sym_byte] = ACTIONS(532),
    [anon_sym_address] = ACTIONS(532),
    [anon_sym_return] = ACTIONS(532),
    [anon_sym_revert] = ACTIONS(532),
    [sym_unchecked] = ACTIONS(532),
    [anon_sym_var] = ACTIONS(532),
    [anon_sym_else] = ACTIONS(532),
    [anon_sym_while] = ACTIONS(532),
    [anon_sym_do] = ACTIONS(532),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_emit] = ACTIONS(532),
    [anon_sym_payable] = ACTIONS(532),
    [anon_sym_new] = ACTIONS(532),
    [anon_sym_LBRACK] = ACTIONS(534),
    [anon_sym_delete] = ACTIONS(532),
    [anon_sym_BANG] = ACTIONS(534),
    [anon_sym_PLUS_PLUS] = ACTIONS(534),
    [anon_sym_DASH_DASH] = ACTIONS(534),
    [anon_sym_mapping] = ACTIONS(532),
    [anon_sym_bool] = ACTIONS(532),
    [anon_sym_string] = ACTIONS(532),
    [anon_sym_int] = ACTIONS(532),
    [anon_sym_int8] = ACTIONS(532),
    [anon_sym_int16] = ACTIONS(532),
    [anon_sym_int24] = ACTIONS(532),
    [anon_sym_int32] = ACTIONS(532),
    [anon_sym_int40] = ACTIONS(532),
    [anon_sym_int48] = ACTIONS(532),
    [anon_sym_int56] = ACTIONS(532),
    [anon_sym_int64] = ACTIONS(532),
    [anon_sym_int72] = ACTIONS(532),
    [anon_sym_int80] = ACTIONS(532),
    [anon_sym_int88] = ACTIONS(532),
    [anon_sym_int96] = ACTIONS(532),
    [anon_sym_int104] = ACTIONS(532),
    [anon_sym_int112] = ACTIONS(532),
    [anon_sym_int120] = ACTIONS(532),
    [anon_sym_int128] = ACTIONS(532),
    [anon_sym_int136] = ACTIONS(532),
    [anon_sym_int144] = ACTIONS(532),
    [anon_sym_int152] = ACTIONS(532),
    [anon_sym_int160] = ACTIONS(532),
    [anon_sym_int168] = ACTIONS(532),
    [anon_sym_int176] = ACTIONS(532),
    [anon_sym_int184] = ACTIONS(532),
    [anon_sym_int192] = ACTIONS(532),
    [anon_sym_int200] = ACTIONS(532),
    [anon_sym_int208] = ACTIONS(532),
    [anon_sym_int216] = ACTIONS(532),
    [anon_sym_int224] = ACTIONS(532),
    [anon_sym_int232] = ACTIONS(532),
    [anon_sym_int240] = ACTIONS(532),
    [anon_sym_int248] = ACTIONS(532),
    [anon_sym_int256] = ACTIONS(532),
    [anon_sym_uint] = ACTIONS(532),
    [anon_sym_uint8] = ACTIONS(532),
    [anon_sym_uint16] = ACTIONS(532),
    [anon_sym_uint24] = ACTIONS(532),
    [anon_sym_uint32] = ACTIONS(532),
    [anon_sym_uint40] = ACTIONS(532),
    [anon_sym_uint48] = ACTIONS(532),
    [anon_sym_uint56] = ACTIONS(532),
    [anon_sym_uint64] = ACTIONS(532),
    [anon_sym_uint72] = ACTIONS(532),
    [anon_sym_uint80] = ACTIONS(532),
    [anon_sym_uint88] = ACTIONS(532),
    [anon_sym_uint96] = ACTIONS(532),
    [anon_sym_uint104] = ACTIONS(532),
    [anon_sym_uint112] = ACTIONS(532),
    [anon_sym_uint120] = ACTIONS(532),
    [anon_sym_uint128] = ACTIONS(532),
    [anon_sym_uint136] = ACTIONS(532),
    [anon_sym_uint144] = ACTIONS(532),
    [anon_sym_uint152] = ACTIONS(532),
    [anon_sym_uint160] = ACTIONS(532),
    [anon_sym_uint168] = ACTIONS(532),
    [anon_sym_uint176] = ACTIONS(532),
    [anon_sym_uint184] = ACTIONS(532),
    [anon_sym_uint192] = ACTIONS(532),
    [anon_sym_uint200] = ACTIONS(532),
    [anon_sym_uint208] = ACTIONS(532),
    [anon_sym_uint216] = ACTIONS(532),
    [anon_sym_uint224] = ACTIONS(532),
    [anon_sym_uint232] = ACTIONS(532),
    [anon_sym_uint240] = ACTIONS(532),
    [anon_sym_uint248] = ACTIONS(532),
    [anon_sym_uint256] = ACTIONS(532),
    [anon_sym_bytes] = ACTIONS(532),
    [anon_sym_bytes1] = ACTIONS(532),
    [anon_sym_bytes2] = ACTIONS(532),
    [anon_sym_bytes3] = ACTIONS(532),
    [anon_sym_bytes4] = ACTIONS(532),
    [anon_sym_bytes5] = ACTIONS(532),
    [anon_sym_bytes6] = ACTIONS(532),
    [anon_sym_bytes7] = ACTIONS(532),
    [anon_sym_bytes8] = ACTIONS(532),
    [anon_sym_bytes9] = ACTIONS(532),
    [anon_sym_bytes10] = ACTIONS(532),
    [anon_sym_bytes11] = ACTIONS(532),
    [anon_sym_bytes12] = ACTIONS(532),
    [anon_sym_bytes13] = ACTIONS(532),
    [anon_sym_bytes14] = ACTIONS(532),
    [anon_sym_bytes15] = ACTIONS(532),
    [anon_sym_bytes16] = ACTIONS(532),
    [anon_sym_bytes17] = ACTIONS(532),
    [anon_sym_bytes18] = ACTIONS(532),
    [anon_sym_bytes19] = ACTIONS(532),
    [anon_sym_bytes20] = ACTIONS(532),
    [anon_sym_bytes21] = ACTIONS(532),
    [anon_sym_bytes22] = ACTIONS(532),
    [anon_sym_bytes23] = ACTIONS(532),
    [anon_sym_bytes24] = ACTIONS(532),
    [anon_sym_bytes25] = ACTIONS(532),
    [anon_sym_bytes26] = ACTIONS(532),
    [anon_sym_bytes27] = ACTIONS(532),
    [anon_sym_bytes28] = ACTIONS(532),
    [anon_sym_bytes29] = ACTIONS(532),
    [anon_sym_bytes30] = ACTIONS(532),
    [anon_sym_bytes31] = ACTIONS(532),
    [anon_sym_bytes32] = ACTIONS(532),
    [anon_sym_fixed] = ACTIONS(532),
    [aux_sym__fixed_token1] = ACTIONS(532),
    [anon_sym_ufixed] = ACTIONS(532),
    [aux_sym__ufixed_token1] = ACTIONS(532),
    [aux_sym__decimal_number_token1] = ACTIONS(532),
    [aux_sym__decimal_number_token2] = ACTIONS(534),
    [aux_sym__hex_number_token1] = ACTIONS(534),
    [anon_sym_hex] = ACTIONS(532),
    [anon_sym_DQUOTE] = ACTIONS(534),
    [anon_sym_SQUOTE] = ACTIONS(534),
    [anon_sym_unicode] = ACTIONS(532),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_identifier] = ACTIONS(536),
    [anon_sym_DASH] = ACTIONS(536),
    [anon_sym_TILDE] = ACTIONS(538),
    [anon_sym_LBRACE] = ACTIONS(538),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_type] = ACTIONS(536),
    [anon_sym_LPAREN] = ACTIONS(538),
    [anon_sym_for] = ACTIONS(536),
    [anon_sym_assembly] = ACTIONS(536),
    [anon_sym_break] = ACTIONS(536),
    [anon_sym_continue] = ACTIONS(536),
    [anon_sym_true] = ACTIONS(536),
    [anon_sym_false] = ACTIONS(536),
    [anon_sym_if] = ACTIONS(536),
    [anon_sym_function] = ACTIONS(536),
    [anon_sym_byte] = ACTIONS(536),
    [anon_sym_address] = ACTIONS(536),
    [anon_sym_return] = ACTIONS(536),
    [anon_sym_revert] = ACTIONS(536),
    [sym_unchecked] = ACTIONS(536),
    [anon_sym_var] = ACTIONS(536),
    [anon_sym_else] = ACTIONS(536),
    [anon_sym_while] = ACTIONS(536),
    [anon_sym_do] = ACTIONS(536),
    [anon_sym_try] = ACTIONS(536),
    [anon_sym_emit] = ACTIONS(536),
    [anon_sym_payable] = ACTIONS(536),
    [anon_sym_new] = ACTIONS(536),
    [anon_sym_LBRACK] = ACTIONS(538),
    [anon_sym_delete] = ACTIONS(536),
    [anon_sym_BANG] = ACTIONS(538),
    [anon_sym_PLUS_PLUS] = ACTIONS(538),
    [anon_sym_DASH_DASH] = ACTIONS(538),
    [anon_sym_mapping] = ACTIONS(536),
    [anon_sym_bool] = ACTIONS(536),
    [anon_sym_string] = ACTIONS(536),
    [anon_sym_int] = ACTIONS(536),
    [anon_sym_int8] = ACTIONS(536),
    [anon_sym_int16] = ACTIONS(536),
    [anon_sym_int24] = ACTIONS(536),
    [anon_sym_int32] = ACTIONS(536),
    [anon_sym_int40] = ACTIONS(536),
    [anon_sym_int48] = ACTIONS(536),
    [anon_sym_int56] = ACTIONS(536),
    [anon_sym_int64] = ACTIONS(536),
    [anon_sym_int72] = ACTIONS(536),
    [anon_sym_int80] = ACTIONS(536),
    [anon_sym_int88] = ACTIONS(536),
    [anon_sym_int96] = ACTIONS(536),
    [anon_sym_int104] = ACTIONS(536),
    [anon_sym_int112] = ACTIONS(536),
    [anon_sym_int120] = ACTIONS(536),
    [anon_sym_int128] = ACTIONS(536),
    [anon_sym_int136] = ACTIONS(536),
    [anon_sym_int144] = ACTIONS(536),
    [anon_sym_int152] = ACTIONS(536),
    [anon_sym_int160] = ACTIONS(536),
    [anon_sym_int168] = ACTIONS(536),
    [anon_sym_int176] = ACTIONS(536),
    [anon_sym_int184] = ACTIONS(536),
    [anon_sym_int192] = ACTIONS(536),
    [anon_sym_int200] = ACTIONS(536),
    [anon_sym_int208] = ACTIONS(536),
    [anon_sym_int216] = ACTIONS(536),
    [anon_sym_int224] = ACTIONS(536),
    [anon_sym_int232] = ACTIONS(536),
    [anon_sym_int240] = ACTIONS(536),
    [anon_sym_int248] = ACTIONS(536),
    [anon_sym_int256] = ACTIONS(536),
    [anon_sym_uint] = ACTIONS(536),
    [anon_sym_uint8] = ACTIONS(536),
    [anon_sym_uint16] = ACTIONS(536),
    [anon_sym_uint24] = ACTIONS(536),
    [anon_sym_uint32] = ACTIONS(536),
    [anon_sym_uint40] = ACTIONS(536),
    [anon_sym_uint48] = ACTIONS(536),
    [anon_sym_uint56] = ACTIONS(536),
    [anon_sym_uint64] = ACTIONS(536),
    [anon_sym_uint72] = ACTIONS(536),
    [anon_sym_uint80] = ACTIONS(536),
    [anon_sym_uint88] = ACTIONS(536),
    [anon_sym_uint96] = ACTIONS(536),
    [anon_sym_uint104] = ACTIONS(536),
    [anon_sym_uint112] = ACTIONS(536),
    [anon_sym_uint120] = ACTIONS(536),
    [anon_sym_uint128] = ACTIONS(536),
    [anon_sym_uint136] = ACTIONS(536),
    [anon_sym_uint144] = ACTIONS(536),
    [anon_sym_uint152] = ACTIONS(536),
    [anon_sym_uint160] = ACTIONS(536),
    [anon_sym_uint168] = ACTIONS(536),
    [anon_sym_uint176] = ACTIONS(536),
    [anon_sym_uint184] = ACTIONS(536),
    [anon_sym_uint192] = ACTIONS(536),
    [anon_sym_uint200] = ACTIONS(536),
    [anon_sym_uint208] = ACTIONS(536),
    [anon_sym_uint216] = ACTIONS(536),
    [anon_sym_uint224] = ACTIONS(536),
    [anon_sym_uint232] = ACTIONS(536),
    [anon_sym_uint240] = ACTIONS(536),
    [anon_sym_uint248] = ACTIONS(536),
    [anon_sym_uint256] = ACTIONS(536),
    [anon_sym_bytes] = ACTIONS(536),
    [anon_sym_bytes1] = ACTIONS(536),
    [anon_sym_bytes2] = ACTIONS(536),
    [anon_sym_bytes3] = ACTIONS(536),
    [anon_sym_bytes4] = ACTIONS(536),
    [anon_sym_bytes5] = ACTIONS(536),
    [anon_sym_bytes6] = ACTIONS(536),
    [anon_sym_bytes7] = ACTIONS(536),
    [anon_sym_bytes8] = ACTIONS(536),
    [anon_sym_bytes9] = ACTIONS(536),
    [anon_sym_bytes10] = ACTIONS(536),
    [anon_sym_bytes11] = ACTIONS(536),
    [anon_sym_bytes12] = ACTIONS(536),
    [anon_sym_bytes13] = ACTIONS(536),
    [anon_sym_bytes14] = ACTIONS(536),
    [anon_sym_bytes15] = ACTIONS(536),
    [anon_sym_bytes16] = ACTIONS(536),
    [anon_sym_bytes17] = ACTIONS(536),
    [anon_sym_bytes18] = ACTIONS(536),
    [anon_sym_bytes19] = ACTIONS(536),
    [anon_sym_bytes20] = ACTIONS(536),
    [anon_sym_bytes21] = ACTIONS(536),
    [anon_sym_bytes22] = ACTIONS(536),
    [anon_sym_bytes23] = ACTIONS(536),
    [anon_sym_bytes24] = ACTIONS(536),
    [anon_sym_bytes25] = ACTIONS(536),
    [anon_sym_bytes26] = ACTIONS(536),
    [anon_sym_bytes27] = ACTIONS(536),
    [anon_sym_bytes28] = ACTIONS(536),
    [anon_sym_bytes29] = ACTIONS(536),
    [anon_sym_bytes30] = ACTIONS(536),
    [anon_sym_bytes31] = ACTIONS(536),
    [anon_sym_bytes32] = ACTIONS(536),
    [anon_sym_fixed] = ACTIONS(536),
    [aux_sym__fixed_token1] = ACTIONS(536),
    [anon_sym_ufixed] = ACTIONS(536),
    [aux_sym__ufixed_token1] = ACTIONS(536),
    [aux_sym__decimal_number_token1] = ACTIONS(536),
    [aux_sym__decimal_number_token2] = ACTIONS(538),
    [aux_sym__hex_number_token1] = ACTIONS(538),
    [anon_sym_hex] = ACTIONS(536),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [anon_sym_SQUOTE] = ACTIONS(538),
    [anon_sym_unicode] = ACTIONS(536),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(540),
    [anon_sym_DASH] = ACTIONS(540),
    [anon_sym_TILDE] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_type] = ACTIONS(540),
    [anon_sym_LPAREN] = ACTIONS(542),
    [anon_sym_for] = ACTIONS(540),
    [anon_sym_assembly] = ACTIONS(540),
    [anon_sym_break] = ACTIONS(540),
    [anon_sym_continue] = ACTIONS(540),
    [anon_sym_true] = ACTIONS(540),
    [anon_sym_false] = ACTIONS(540),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_function] = ACTIONS(540),
    [anon_sym_byte] = ACTIONS(540),
    [anon_sym_address] = ACTIONS(540),
    [anon_sym_return] = ACTIONS(540),
    [anon_sym_revert] = ACTIONS(540),
    [sym_unchecked] = ACTIONS(540),
    [anon_sym_var] = ACTIONS(540),
    [anon_sym_else] = ACTIONS(540),
    [anon_sym_while] = ACTIONS(540),
    [anon_sym_do] = ACTIONS(540),
    [anon_sym_try] = ACTIONS(540),
    [anon_sym_emit] = ACTIONS(540),
    [anon_sym_payable] = ACTIONS(540),
    [anon_sym_new] = ACTIONS(540),
    [anon_sym_LBRACK] = ACTIONS(542),
    [anon_sym_delete] = ACTIONS(540),
    [anon_sym_BANG] = ACTIONS(542),
    [anon_sym_PLUS_PLUS] = ACTIONS(542),
    [anon_sym_DASH_DASH] = ACTIONS(542),
    [anon_sym_mapping] = ACTIONS(540),
    [anon_sym_bool] = ACTIONS(540),
    [anon_sym_string] = ACTIONS(540),
    [anon_sym_int] = ACTIONS(540),
    [anon_sym_int8] = ACTIONS(540),
    [anon_sym_int16] = ACTIONS(540),
    [anon_sym_int24] = ACTIONS(540),
    [anon_sym_int32] = ACTIONS(540),
    [anon_sym_int40] = ACTIONS(540),
    [anon_sym_int48] = ACTIONS(540),
    [anon_sym_int56] = ACTIONS(540),
    [anon_sym_int64] = ACTIONS(540),
    [anon_sym_int72] = ACTIONS(540),
    [anon_sym_int80] = ACTIONS(540),
    [anon_sym_int88] = ACTIONS(540),
    [anon_sym_int96] = ACTIONS(540),
    [anon_sym_int104] = ACTIONS(540),
    [anon_sym_int112] = ACTIONS(540),
    [anon_sym_int120] = ACTIONS(540),
    [anon_sym_int128] = ACTIONS(540),
    [anon_sym_int136] = ACTIONS(540),
    [anon_sym_int144] = ACTIONS(540),
    [anon_sym_int152] = ACTIONS(540),
    [anon_sym_int160] = ACTIONS(540),
    [anon_sym_int168] = ACTIONS(540),
    [anon_sym_int176] = ACTIONS(540),
    [anon_sym_int184] = ACTIONS(540),
    [anon_sym_int192] = ACTIONS(540),
    [anon_sym_int200] = ACTIONS(540),
    [anon_sym_int208] = ACTIONS(540),
    [anon_sym_int216] = ACTIONS(540),
    [anon_sym_int224] = ACTIONS(540),
    [anon_sym_int232] = ACTIONS(540),
    [anon_sym_int240] = ACTIONS(540),
    [anon_sym_int248] = ACTIONS(540),
    [anon_sym_int256] = ACTIONS(540),
    [anon_sym_uint] = ACTIONS(540),
    [anon_sym_uint8] = ACTIONS(540),
    [anon_sym_uint16] = ACTIONS(540),
    [anon_sym_uint24] = ACTIONS(540),
    [anon_sym_uint32] = ACTIONS(540),
    [anon_sym_uint40] = ACTIONS(540),
    [anon_sym_uint48] = ACTIONS(540),
    [anon_sym_uint56] = ACTIONS(540),
    [anon_sym_uint64] = ACTIONS(540),
    [anon_sym_uint72] = ACTIONS(540),
    [anon_sym_uint80] = ACTIONS(540),
    [anon_sym_uint88] = ACTIONS(540),
    [anon_sym_uint96] = ACTIONS(540),
    [anon_sym_uint104] = ACTIONS(540),
    [anon_sym_uint112] = ACTIONS(540),
    [anon_sym_uint120] = ACTIONS(540),
    [anon_sym_uint128] = ACTIONS(540),
    [anon_sym_uint136] = ACTIONS(540),
    [anon_sym_uint144] = ACTIONS(540),
    [anon_sym_uint152] = ACTIONS(540),
    [anon_sym_uint160] = ACTIONS(540),
    [anon_sym_uint168] = ACTIONS(540),
    [anon_sym_uint176] = ACTIONS(540),
    [anon_sym_uint184] = ACTIONS(540),
    [anon_sym_uint192] = ACTIONS(540),
    [anon_sym_uint200] = ACTIONS(540),
    [anon_sym_uint208] = ACTIONS(540),
    [anon_sym_uint216] = ACTIONS(540),
    [anon_sym_uint224] = ACTIONS(540),
    [anon_sym_uint232] = ACTIONS(540),
    [anon_sym_uint240] = ACTIONS(540),
    [anon_sym_uint248] = ACTIONS(540),
    [anon_sym_uint256] = ACTIONS(540),
    [anon_sym_bytes] = ACTIONS(540),
    [anon_sym_bytes1] = ACTIONS(540),
    [anon_sym_bytes2] = ACTIONS(540),
    [anon_sym_bytes3] = ACTIONS(540),
    [anon_sym_bytes4] = ACTIONS(540),
    [anon_sym_bytes5] = ACTIONS(540),
    [anon_sym_bytes6] = ACTIONS(540),
    [anon_sym_bytes7] = ACTIONS(540),
    [anon_sym_bytes8] = ACTIONS(540),
    [anon_sym_bytes9] = ACTIONS(540),
    [anon_sym_bytes10] = ACTIONS(540),
    [anon_sym_bytes11] = ACTIONS(540),
    [anon_sym_bytes12] = ACTIONS(540),
    [anon_sym_bytes13] = ACTIONS(540),
    [anon_sym_bytes14] = ACTIONS(540),
    [anon_sym_bytes15] = ACTIONS(540),
    [anon_sym_bytes16] = ACTIONS(540),
    [anon_sym_bytes17] = ACTIONS(540),
    [anon_sym_bytes18] = ACTIONS(540),
    [anon_sym_bytes19] = ACTIONS(540),
    [anon_sym_bytes20] = ACTIONS(540),
    [anon_sym_bytes21] = ACTIONS(540),
    [anon_sym_bytes22] = ACTIONS(540),
    [anon_sym_bytes23] = ACTIONS(540),
    [anon_sym_bytes24] = ACTIONS(540),
    [anon_sym_bytes25] = ACTIONS(540),
    [anon_sym_bytes26] = ACTIONS(540),
    [anon_sym_bytes27] = ACTIONS(540),
    [anon_sym_bytes28] = ACTIONS(540),
    [anon_sym_bytes29] = ACTIONS(540),
    [anon_sym_bytes30] = ACTIONS(540),
    [anon_sym_bytes31] = ACTIONS(540),
    [anon_sym_bytes32] = ACTIONS(540),
    [anon_sym_fixed] = ACTIONS(540),
    [aux_sym__fixed_token1] = ACTIONS(540),
    [anon_sym_ufixed] = ACTIONS(540),
    [aux_sym__ufixed_token1] = ACTIONS(540),
    [aux_sym__decimal_number_token1] = ACTIONS(540),
    [aux_sym__decimal_number_token2] = ACTIONS(542),
    [aux_sym__hex_number_token1] = ACTIONS(542),
    [anon_sym_hex] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [anon_sym_SQUOTE] = ACTIONS(542),
    [anon_sym_unicode] = ACTIONS(540),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_identifier] = ACTIONS(544),
    [anon_sym_DASH] = ACTIONS(544),
    [anon_sym_TILDE] = ACTIONS(546),
    [anon_sym_LBRACE] = ACTIONS(546),
    [anon_sym_RBRACE] = ACTIONS(546),
    [anon_sym_type] = ACTIONS(544),
    [anon_sym_LPAREN] = ACTIONS(546),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_assembly] = ACTIONS(544),
    [anon_sym_break] = ACTIONS(544),
    [anon_sym_continue] = ACTIONS(544),
    [anon_sym_true] = ACTIONS(544),
    [anon_sym_false] = ACTIONS(544),
    [anon_sym_if] = ACTIONS(544),
    [anon_sym_function] = ACTIONS(544),
    [anon_sym_byte] = ACTIONS(544),
    [anon_sym_address] = ACTIONS(544),
    [anon_sym_return] = ACTIONS(544),
    [anon_sym_revert] = ACTIONS(544),
    [sym_unchecked] = ACTIONS(544),
    [anon_sym_var] = ACTIONS(544),
    [anon_sym_else] = ACTIONS(544),
    [anon_sym_while] = ACTIONS(544),
    [anon_sym_do] = ACTIONS(544),
    [anon_sym_try] = ACTIONS(544),
    [anon_sym_emit] = ACTIONS(544),
    [anon_sym_payable] = ACTIONS(544),
    [anon_sym_new] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(546),
    [anon_sym_delete] = ACTIONS(544),
    [anon_sym_BANG] = ACTIONS(546),
    [anon_sym_PLUS_PLUS] = ACTIONS(546),
    [anon_sym_DASH_DASH] = ACTIONS(546),
    [anon_sym_mapping] = ACTIONS(544),
    [anon_sym_bool] = ACTIONS(544),
    [anon_sym_string] = ACTIONS(544),
    [anon_sym_int] = ACTIONS(544),
    [anon_sym_int8] = ACTIONS(544),
    [anon_sym_int16] = ACTIONS(544),
    [anon_sym_int24] = ACTIONS(544),
    [anon_sym_int32] = ACTIONS(544),
    [anon_sym_int40] = ACTIONS(544),
    [anon_sym_int48] = ACTIONS(544),
    [anon_sym_int56] = ACTIONS(544),
    [anon_sym_int64] = ACTIONS(544),
    [anon_sym_int72] = ACTIONS(544),
    [anon_sym_int80] = ACTIONS(544),
    [anon_sym_int88] = ACTIONS(544),
    [anon_sym_int96] = ACTIONS(544),
    [anon_sym_int104] = ACTIONS(544),
    [anon_sym_int112] = ACTIONS(544),
    [anon_sym_int120] = ACTIONS(544),
    [anon_sym_int128] = ACTIONS(544),
    [anon_sym_int136] = ACTIONS(544),
    [anon_sym_int144] = ACTIONS(544),
    [anon_sym_int152] = ACTIONS(544),
    [anon_sym_int160] = ACTIONS(544),
    [anon_sym_int168] = ACTIONS(544),
    [anon_sym_int176] = ACTIONS(544),
    [anon_sym_int184] = ACTIONS(544),
    [anon_sym_int192] = ACTIONS(544),
    [anon_sym_int200] = ACTIONS(544),
    [anon_sym_int208] = ACTIONS(544),
    [anon_sym_int216] = ACTIONS(544),
    [anon_sym_int224] = ACTIONS(544),
    [anon_sym_int232] = ACTIONS(544),
    [anon_sym_int240] = ACTIONS(544),
    [anon_sym_int248] = ACTIONS(544),
    [anon_sym_int256] = ACTIONS(544),
    [anon_sym_uint] = ACTIONS(544),
    [anon_sym_uint8] = ACTIONS(544),
    [anon_sym_uint16] = ACTIONS(544),
    [anon_sym_uint24] = ACTIONS(544),
    [anon_sym_uint32] = ACTIONS(544),
    [anon_sym_uint40] = ACTIONS(544),
    [anon_sym_uint48] = ACTIONS(544),
    [anon_sym_uint56] = ACTIONS(544),
    [anon_sym_uint64] = ACTIONS(544),
    [anon_sym_uint72] = ACTIONS(544),
    [anon_sym_uint80] = ACTIONS(544),
    [anon_sym_uint88] = ACTIONS(544),
    [anon_sym_uint96] = ACTIONS(544),
    [anon_sym_uint104] = ACTIONS(544),
    [anon_sym_uint112] = ACTIONS(544),
    [anon_sym_uint120] = ACTIONS(544),
    [anon_sym_uint128] = ACTIONS(544),
    [anon_sym_uint136] = ACTIONS(544),
    [anon_sym_uint144] = ACTIONS(544),
    [anon_sym_uint152] = ACTIONS(544),
    [anon_sym_uint160] = ACTIONS(544),
    [anon_sym_uint168] = ACTIONS(544),
    [anon_sym_uint176] = ACTIONS(544),
    [anon_sym_uint184] = ACTIONS(544),
    [anon_sym_uint192] = ACTIONS(544),
    [anon_sym_uint200] = ACTIONS(544),
    [anon_sym_uint208] = ACTIONS(544),
    [anon_sym_uint216] = ACTIONS(544),
    [anon_sym_uint224] = ACTIONS(544),
    [anon_sym_uint232] = ACTIONS(544),
    [anon_sym_uint240] = ACTIONS(544),
    [anon_sym_uint248] = ACTIONS(544),
    [anon_sym_uint256] = ACTIONS(544),
    [anon_sym_bytes] = ACTIONS(544),
    [anon_sym_bytes1] = ACTIONS(544),
    [anon_sym_bytes2] = ACTIONS(544),
    [anon_sym_bytes3] = ACTIONS(544),
    [anon_sym_bytes4] = ACTIONS(544),
    [anon_sym_bytes5] = ACTIONS(544),
    [anon_sym_bytes6] = ACTIONS(544),
    [anon_sym_bytes7] = ACTIONS(544),
    [anon_sym_bytes8] = ACTIONS(544),
    [anon_sym_bytes9] = ACTIONS(544),
    [anon_sym_bytes10] = ACTIONS(544),
    [anon_sym_bytes11] = ACTIONS(544),
    [anon_sym_bytes12] = ACTIONS(544),
    [anon_sym_bytes13] = ACTIONS(544),
    [anon_sym_bytes14] = ACTIONS(544),
    [anon_sym_bytes15] = ACTIONS(544),
    [anon_sym_bytes16] = ACTIONS(544),
    [anon_sym_bytes17] = ACTIONS(544),
    [anon_sym_bytes18] = ACTIONS(544),
    [anon_sym_bytes19] = ACTIONS(544),
    [anon_sym_bytes20] = ACTIONS(544),
    [anon_sym_bytes21] = ACTIONS(544),
    [anon_sym_bytes22] = ACTIONS(544),
    [anon_sym_bytes23] = ACTIONS(544),
    [anon_sym_bytes24] = ACTIONS(544),
    [anon_sym_bytes25] = ACTIONS(544),
    [anon_sym_bytes26] = ACTIONS(544),
    [anon_sym_bytes27] = ACTIONS(544),
    [anon_sym_bytes28] = ACTIONS(544),
    [anon_sym_bytes29] = ACTIONS(544),
    [anon_sym_bytes30] = ACTIONS(544),
    [anon_sym_bytes31] = ACTIONS(544),
    [anon_sym_bytes32] = ACTIONS(544),
    [anon_sym_fixed] = ACTIONS(544),
    [aux_sym__fixed_token1] = ACTIONS(544),
    [anon_sym_ufixed] = ACTIONS(544),
    [aux_sym__ufixed_token1] = ACTIONS(544),
    [aux_sym__decimal_number_token1] = ACTIONS(544),
    [aux_sym__decimal_number_token2] = ACTIONS(546),
    [aux_sym__hex_number_token1] = ACTIONS(546),
    [anon_sym_hex] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(546),
    [anon_sym_SQUOTE] = ACTIONS(546),
    [anon_sym_unicode] = ACTIONS(544),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_identifier] = ACTIONS(548),
    [anon_sym_DASH] = ACTIONS(548),
    [anon_sym_TILDE] = ACTIONS(550),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_RBRACE] = ACTIONS(550),
    [anon_sym_type] = ACTIONS(548),
    [anon_sym_LPAREN] = ACTIONS(550),
    [anon_sym_for] = ACTIONS(548),
    [anon_sym_assembly] = ACTIONS(548),
    [anon_sym_break] = ACTIONS(548),
    [anon_sym_continue] = ACTIONS(548),
    [anon_sym_true] = ACTIONS(548),
    [anon_sym_false] = ACTIONS(548),
    [anon_sym_if] = ACTIONS(548),
    [anon_sym_function] = ACTIONS(548),
    [anon_sym_byte] = ACTIONS(548),
    [anon_sym_address] = ACTIONS(548),
    [anon_sym_return] = ACTIONS(548),
    [anon_sym_revert] = ACTIONS(548),
    [sym_unchecked] = ACTIONS(548),
    [anon_sym_var] = ACTIONS(548),
    [anon_sym_else] = ACTIONS(548),
    [anon_sym_while] = ACTIONS(548),
    [anon_sym_do] = ACTIONS(548),
    [anon_sym_try] = ACTIONS(548),
    [anon_sym_emit] = ACTIONS(548),
    [anon_sym_payable] = ACTIONS(548),
    [anon_sym_new] = ACTIONS(548),
    [anon_sym_LBRACK] = ACTIONS(550),
    [anon_sym_delete] = ACTIONS(548),
    [anon_sym_BANG] = ACTIONS(550),
    [anon_sym_PLUS_PLUS] = ACTIONS(550),
    [anon_sym_DASH_DASH] = ACTIONS(550),
    [anon_sym_mapping] = ACTIONS(548),
    [anon_sym_bool] = ACTIONS(548),
    [anon_sym_string] = ACTIONS(548),
    [anon_sym_int] = ACTIONS(548),
    [anon_sym_int8] = ACTIONS(548),
    [anon_sym_int16] = ACTIONS(548),
    [anon_sym_int24] = ACTIONS(548),
    [anon_sym_int32] = ACTIONS(548),
    [anon_sym_int40] = ACTIONS(548),
    [anon_sym_int48] = ACTIONS(548),
    [anon_sym_int56] = ACTIONS(548),
    [anon_sym_int64] = ACTIONS(548),
    [anon_sym_int72] = ACTIONS(548),
    [anon_sym_int80] = ACTIONS(548),
    [anon_sym_int88] = ACTIONS(548),
    [anon_sym_int96] = ACTIONS(548),
    [anon_sym_int104] = ACTIONS(548),
    [anon_sym_int112] = ACTIONS(548),
    [anon_sym_int120] = ACTIONS(548),
    [anon_sym_int128] = ACTIONS(548),
    [anon_sym_int136] = ACTIONS(548),
    [anon_sym_int144] = ACTIONS(548),
    [anon_sym_int152] = ACTIONS(548),
    [anon_sym_int160] = ACTIONS(548),
    [anon_sym_int168] = ACTIONS(548),
    [anon_sym_int176] = ACTIONS(548),
    [anon_sym_int184] = ACTIONS(548),
    [anon_sym_int192] = ACTIONS(548),
    [anon_sym_int200] = ACTIONS(548),
    [anon_sym_int208] = ACTIONS(548),
    [anon_sym_int216] = ACTIONS(548),
    [anon_sym_int224] = ACTIONS(548),
    [anon_sym_int232] = ACTIONS(548),
    [anon_sym_int240] = ACTIONS(548),
    [anon_sym_int248] = ACTIONS(548),
    [anon_sym_int256] = ACTIONS(548),
    [anon_sym_uint] = ACTIONS(548),
    [anon_sym_uint8] = ACTIONS(548),
    [anon_sym_uint16] = ACTIONS(548),
    [anon_sym_uint24] = ACTIONS(548),
    [anon_sym_uint32] = ACTIONS(548),
    [anon_sym_uint40] = ACTIONS(548),
    [anon_sym_uint48] = ACTIONS(548),
    [anon_sym_uint56] = ACTIONS(548),
    [anon_sym_uint64] = ACTIONS(548),
    [anon_sym_uint72] = ACTIONS(548),
    [anon_sym_uint80] = ACTIONS(548),
    [anon_sym_uint88] = ACTIONS(548),
    [anon_sym_uint96] = ACTIONS(548),
    [anon_sym_uint104] = ACTIONS(548),
    [anon_sym_uint112] = ACTIONS(548),
    [anon_sym_uint120] = ACTIONS(548),
    [anon_sym_uint128] = ACTIONS(548),
    [anon_sym_uint136] = ACTIONS(548),
    [anon_sym_uint144] = ACTIONS(548),
    [anon_sym_uint152] = ACTIONS(548),
    [anon_sym_uint160] = ACTIONS(548),
    [anon_sym_uint168] = ACTIONS(548),
    [anon_sym_uint176] = ACTIONS(548),
    [anon_sym_uint184] = ACTIONS(548),
    [anon_sym_uint192] = ACTIONS(548),
    [anon_sym_uint200] = ACTIONS(548),
    [anon_sym_uint208] = ACTIONS(548),
    [anon_sym_uint216] = ACTIONS(548),
    [anon_sym_uint224] = ACTIONS(548),
    [anon_sym_uint232] = ACTIONS(548),
    [anon_sym_uint240] = ACTIONS(548),
    [anon_sym_uint248] = ACTIONS(548),
    [anon_sym_uint256] = ACTIONS(548),
    [anon_sym_bytes] = ACTIONS(548),
    [anon_sym_bytes1] = ACTIONS(548),
    [anon_sym_bytes2] = ACTIONS(548),
    [anon_sym_bytes3] = ACTIONS(548),
    [anon_sym_bytes4] = ACTIONS(548),
    [anon_sym_bytes5] = ACTIONS(548),
    [anon_sym_bytes6] = ACTIONS(548),
    [anon_sym_bytes7] = ACTIONS(548),
    [anon_sym_bytes8] = ACTIONS(548),
    [anon_sym_bytes9] = ACTIONS(548),
    [anon_sym_bytes10] = ACTIONS(548),
    [anon_sym_bytes11] = ACTIONS(548),
    [anon_sym_bytes12] = ACTIONS(548),
    [anon_sym_bytes13] = ACTIONS(548),
    [anon_sym_bytes14] = ACTIONS(548),
    [anon_sym_bytes15] = ACTIONS(548),
    [anon_sym_bytes16] = ACTIONS(548),
    [anon_sym_bytes17] = ACTIONS(548),
    [anon_sym_bytes18] = ACTIONS(548),
    [anon_sym_bytes19] = ACTIONS(548),
    [anon_sym_bytes20] = ACTIONS(548),
    [anon_sym_bytes21] = ACTIONS(548),
    [anon_sym_bytes22] = ACTIONS(548),
    [anon_sym_bytes23] = ACTIONS(548),
    [anon_sym_bytes24] = ACTIONS(548),
    [anon_sym_bytes25] = ACTIONS(548),
    [anon_sym_bytes26] = ACTIONS(548),
    [anon_sym_bytes27] = ACTIONS(548),
    [anon_sym_bytes28] = ACTIONS(548),
    [anon_sym_bytes29] = ACTIONS(548),
    [anon_sym_bytes30] = ACTIONS(548),
    [anon_sym_bytes31] = ACTIONS(548),
    [anon_sym_bytes32] = ACTIONS(548),
    [anon_sym_fixed] = ACTIONS(548),
    [aux_sym__fixed_token1] = ACTIONS(548),
    [anon_sym_ufixed] = ACTIONS(548),
    [aux_sym__ufixed_token1] = ACTIONS(548),
    [aux_sym__decimal_number_token1] = ACTIONS(548),
    [aux_sym__decimal_number_token2] = ACTIONS(550),
    [aux_sym__hex_number_token1] = ACTIONS(550),
    [anon_sym_hex] = ACTIONS(548),
    [anon_sym_DQUOTE] = ACTIONS(550),
    [anon_sym_SQUOTE] = ACTIONS(550),
    [anon_sym_unicode] = ACTIONS(548),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_identifier] = ACTIONS(552),
    [anon_sym_DASH] = ACTIONS(552),
    [anon_sym_TILDE] = ACTIONS(554),
    [anon_sym_LBRACE] = ACTIONS(554),
    [anon_sym_RBRACE] = ACTIONS(554),
    [anon_sym_type] = ACTIONS(552),
    [anon_sym_LPAREN] = ACTIONS(554),
    [anon_sym_for] = ACTIONS(552),
    [anon_sym_assembly] = ACTIONS(552),
    [anon_sym_break] = ACTIONS(552),
    [anon_sym_continue] = ACTIONS(552),
    [anon_sym_true] = ACTIONS(552),
    [anon_sym_false] = ACTIONS(552),
    [anon_sym_if] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(552),
    [anon_sym_byte] = ACTIONS(552),
    [anon_sym_address] = ACTIONS(552),
    [anon_sym_return] = ACTIONS(552),
    [anon_sym_revert] = ACTIONS(552),
    [sym_unchecked] = ACTIONS(552),
    [anon_sym_var] = ACTIONS(552),
    [anon_sym_else] = ACTIONS(552),
    [anon_sym_while] = ACTIONS(552),
    [anon_sym_do] = ACTIONS(552),
    [anon_sym_try] = ACTIONS(552),
    [anon_sym_emit] = ACTIONS(552),
    [anon_sym_payable] = ACTIONS(552),
    [anon_sym_new] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(554),
    [anon_sym_delete] = ACTIONS(552),
    [anon_sym_BANG] = ACTIONS(554),
    [anon_sym_PLUS_PLUS] = ACTIONS(554),
    [anon_sym_DASH_DASH] = ACTIONS(554),
    [anon_sym_mapping] = ACTIONS(552),
    [anon_sym_bool] = ACTIONS(552),
    [anon_sym_string] = ACTIONS(552),
    [anon_sym_int] = ACTIONS(552),
    [anon_sym_int8] = ACTIONS(552),
    [anon_sym_int16] = ACTIONS(552),
    [anon_sym_int24] = ACTIONS(552),
    [anon_sym_int32] = ACTIONS(552),
    [anon_sym_int40] = ACTIONS(552),
    [anon_sym_int48] = ACTIONS(552),
    [anon_sym_int56] = ACTIONS(552),
    [anon_sym_int64] = ACTIONS(552),
    [anon_sym_int72] = ACTIONS(552),
    [anon_sym_int80] = ACTIONS(552),
    [anon_sym_int88] = ACTIONS(552),
    [anon_sym_int96] = ACTIONS(552),
    [anon_sym_int104] = ACTIONS(552),
    [anon_sym_int112] = ACTIONS(552),
    [anon_sym_int120] = ACTIONS(552),
    [anon_sym_int128] = ACTIONS(552),
    [anon_sym_int136] = ACTIONS(552),
    [anon_sym_int144] = ACTIONS(552),
    [anon_sym_int152] = ACTIONS(552),
    [anon_sym_int160] = ACTIONS(552),
    [anon_sym_int168] = ACTIONS(552),
    [anon_sym_int176] = ACTIONS(552),
    [anon_sym_int184] = ACTIONS(552),
    [anon_sym_int192] = ACTIONS(552),
    [anon_sym_int200] = ACTIONS(552),
    [anon_sym_int208] = ACTIONS(552),
    [anon_sym_int216] = ACTIONS(552),
    [anon_sym_int224] = ACTIONS(552),
    [anon_sym_int232] = ACTIONS(552),
    [anon_sym_int240] = ACTIONS(552),
    [anon_sym_int248] = ACTIONS(552),
    [anon_sym_int256] = ACTIONS(552),
    [anon_sym_uint] = ACTIONS(552),
    [anon_sym_uint8] = ACTIONS(552),
    [anon_sym_uint16] = ACTIONS(552),
    [anon_sym_uint24] = ACTIONS(552),
    [anon_sym_uint32] = ACTIONS(552),
    [anon_sym_uint40] = ACTIONS(552),
    [anon_sym_uint48] = ACTIONS(552),
    [anon_sym_uint56] = ACTIONS(552),
    [anon_sym_uint64] = ACTIONS(552),
    [anon_sym_uint72] = ACTIONS(552),
    [anon_sym_uint80] = ACTIONS(552),
    [anon_sym_uint88] = ACTIONS(552),
    [anon_sym_uint96] = ACTIONS(552),
    [anon_sym_uint104] = ACTIONS(552),
    [anon_sym_uint112] = ACTIONS(552),
    [anon_sym_uint120] = ACTIONS(552),
    [anon_sym_uint128] = ACTIONS(552),
    [anon_sym_uint136] = ACTIONS(552),
    [anon_sym_uint144] = ACTIONS(552),
    [anon_sym_uint152] = ACTIONS(552),
    [anon_sym_uint160] = ACTIONS(552),
    [anon_sym_uint168] = ACTIONS(552),
    [anon_sym_uint176] = ACTIONS(552),
    [anon_sym_uint184] = ACTIONS(552),
    [anon_sym_uint192] = ACTIONS(552),
    [anon_sym_uint200] = ACTIONS(552),
    [anon_sym_uint208] = ACTIONS(552),
    [anon_sym_uint216] = ACTIONS(552),
    [anon_sym_uint224] = ACTIONS(552),
    [anon_sym_uint232] = ACTIONS(552),
    [anon_sym_uint240] = ACTIONS(552),
    [anon_sym_uint248] = ACTIONS(552),
    [anon_sym_uint256] = ACTIONS(552),
    [anon_sym_bytes] = ACTIONS(552),
    [anon_sym_bytes1] = ACTIONS(552),
    [anon_sym_bytes2] = ACTIONS(552),
    [anon_sym_bytes3] = ACTIONS(552),
    [anon_sym_bytes4] = ACTIONS(552),
    [anon_sym_bytes5] = ACTIONS(552),
    [anon_sym_bytes6] = ACTIONS(552),
    [anon_sym_bytes7] = ACTIONS(552),
    [anon_sym_bytes8] = ACTIONS(552),
    [anon_sym_bytes9] = ACTIONS(552),
    [anon_sym_bytes10] = ACTIONS(552),
    [anon_sym_bytes11] = ACTIONS(552),
    [anon_sym_bytes12] = ACTIONS(552),
    [anon_sym_bytes13] = ACTIONS(552),
    [anon_sym_bytes14] = ACTIONS(552),
    [anon_sym_bytes15] = ACTIONS(552),
    [anon_sym_bytes16] = ACTIONS(552),
    [anon_sym_bytes17] = ACTIONS(552),
    [anon_sym_bytes18] = ACTIONS(552),
    [anon_sym_bytes19] = ACTIONS(552),
    [anon_sym_bytes20] = ACTIONS(552),
    [anon_sym_bytes21] = ACTIONS(552),
    [anon_sym_bytes22] = ACTIONS(552),
    [anon_sym_bytes23] = ACTIONS(552),
    [anon_sym_bytes24] = ACTIONS(552),
    [anon_sym_bytes25] = ACTIONS(552),
    [anon_sym_bytes26] = ACTIONS(552),
    [anon_sym_bytes27] = ACTIONS(552),
    [anon_sym_bytes28] = ACTIONS(552),
    [anon_sym_bytes29] = ACTIONS(552),
    [anon_sym_bytes30] = ACTIONS(552),
    [anon_sym_bytes31] = ACTIONS(552),
    [anon_sym_bytes32] = ACTIONS(552),
    [anon_sym_fixed] = ACTIONS(552),
    [aux_sym__fixed_token1] = ACTIONS(552),
    [anon_sym_ufixed] = ACTIONS(552),
    [aux_sym__ufixed_token1] = ACTIONS(552),
    [aux_sym__decimal_number_token1] = ACTIONS(552),
    [aux_sym__decimal_number_token2] = ACTIONS(554),
    [aux_sym__hex_number_token1] = ACTIONS(554),
    [anon_sym_hex] = ACTIONS(552),
    [anon_sym_DQUOTE] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(554),
    [anon_sym_unicode] = ACTIONS(552),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_identifier] = ACTIONS(556),
    [anon_sym_DASH] = ACTIONS(556),
    [anon_sym_TILDE] = ACTIONS(558),
    [anon_sym_LBRACE] = ACTIONS(558),
    [anon_sym_RBRACE] = ACTIONS(558),
    [anon_sym_type] = ACTIONS(556),
    [anon_sym_LPAREN] = ACTIONS(558),
    [anon_sym_for] = ACTIONS(556),
    [anon_sym_assembly] = ACTIONS(556),
    [anon_sym_break] = ACTIONS(556),
    [anon_sym_continue] = ACTIONS(556),
    [anon_sym_true] = ACTIONS(556),
    [anon_sym_false] = ACTIONS(556),
    [anon_sym_if] = ACTIONS(556),
    [anon_sym_function] = ACTIONS(556),
    [anon_sym_byte] = ACTIONS(556),
    [anon_sym_address] = ACTIONS(556),
    [anon_sym_return] = ACTIONS(556),
    [anon_sym_revert] = ACTIONS(556),
    [sym_unchecked] = ACTIONS(556),
    [anon_sym_var] = ACTIONS(556),
    [anon_sym_else] = ACTIONS(556),
    [anon_sym_while] = ACTIONS(556),
    [anon_sym_do] = ACTIONS(556),
    [anon_sym_try] = ACTIONS(556),
    [anon_sym_emit] = ACTIONS(556),
    [anon_sym_payable] = ACTIONS(556),
    [anon_sym_new] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(558),
    [anon_sym_delete] = ACTIONS(556),
    [anon_sym_BANG] = ACTIONS(558),
    [anon_sym_PLUS_PLUS] = ACTIONS(558),
    [anon_sym_DASH_DASH] = ACTIONS(558),
    [anon_sym_mapping] = ACTIONS(556),
    [anon_sym_bool] = ACTIONS(556),
    [anon_sym_string] = ACTIONS(556),
    [anon_sym_int] = ACTIONS(556),
    [anon_sym_int8] = ACTIONS(556),
    [anon_sym_int16] = ACTIONS(556),
    [anon_sym_int24] = ACTIONS(556),
    [anon_sym_int32] = ACTIONS(556),
    [anon_sym_int40] = ACTIONS(556),
    [anon_sym_int48] = ACTIONS(556),
    [anon_sym_int56] = ACTIONS(556),
    [anon_sym_int64] = ACTIONS(556),
    [anon_sym_int72] = ACTIONS(556),
    [anon_sym_int80] = ACTIONS(556),
    [anon_sym_int88] = ACTIONS(556),
    [anon_sym_int96] = ACTIONS(556),
    [anon_sym_int104] = ACTIONS(556),
    [anon_sym_int112] = ACTIONS(556),
    [anon_sym_int120] = ACTIONS(556),
    [anon_sym_int128] = ACTIONS(556),
    [anon_sym_int136] = ACTIONS(556),
    [anon_sym_int144] = ACTIONS(556),
    [anon_sym_int152] = ACTIONS(556),
    [anon_sym_int160] = ACTIONS(556),
    [anon_sym_int168] = ACTIONS(556),
    [anon_sym_int176] = ACTIONS(556),
    [anon_sym_int184] = ACTIONS(556),
    [anon_sym_int192] = ACTIONS(556),
    [anon_sym_int200] = ACTIONS(556),
    [anon_sym_int208] = ACTIONS(556),
    [anon_sym_int216] = ACTIONS(556),
    [anon_sym_int224] = ACTIONS(556),
    [anon_sym_int232] = ACTIONS(556),
    [anon_sym_int240] = ACTIONS(556),
    [anon_sym_int248] = ACTIONS(556),
    [anon_sym_int256] = ACTIONS(556),
    [anon_sym_uint] = ACTIONS(556),
    [anon_sym_uint8] = ACTIONS(556),
    [anon_sym_uint16] = ACTIONS(556),
    [anon_sym_uint24] = ACTIONS(556),
    [anon_sym_uint32] = ACTIONS(556),
    [anon_sym_uint40] = ACTIONS(556),
    [anon_sym_uint48] = ACTIONS(556),
    [anon_sym_uint56] = ACTIONS(556),
    [anon_sym_uint64] = ACTIONS(556),
    [anon_sym_uint72] = ACTIONS(556),
    [anon_sym_uint80] = ACTIONS(556),
    [anon_sym_uint88] = ACTIONS(556),
    [anon_sym_uint96] = ACTIONS(556),
    [anon_sym_uint104] = ACTIONS(556),
    [anon_sym_uint112] = ACTIONS(556),
    [anon_sym_uint120] = ACTIONS(556),
    [anon_sym_uint128] = ACTIONS(556),
    [anon_sym_uint136] = ACTIONS(556),
    [anon_sym_uint144] = ACTIONS(556),
    [anon_sym_uint152] = ACTIONS(556),
    [anon_sym_uint160] = ACTIONS(556),
    [anon_sym_uint168] = ACTIONS(556),
    [anon_sym_uint176] = ACTIONS(556),
    [anon_sym_uint184] = ACTIONS(556),
    [anon_sym_uint192] = ACTIONS(556),
    [anon_sym_uint200] = ACTIONS(556),
    [anon_sym_uint208] = ACTIONS(556),
    [anon_sym_uint216] = ACTIONS(556),
    [anon_sym_uint224] = ACTIONS(556),
    [anon_sym_uint232] = ACTIONS(556),
    [anon_sym_uint240] = ACTIONS(556),
    [anon_sym_uint248] = ACTIONS(556),
    [anon_sym_uint256] = ACTIONS(556),
    [anon_sym_bytes] = ACTIONS(556),
    [anon_sym_bytes1] = ACTIONS(556),
    [anon_sym_bytes2] = ACTIONS(556),
    [anon_sym_bytes3] = ACTIONS(556),
    [anon_sym_bytes4] = ACTIONS(556),
    [anon_sym_bytes5] = ACTIONS(556),
    [anon_sym_bytes6] = ACTIONS(556),
    [anon_sym_bytes7] = ACTIONS(556),
    [anon_sym_bytes8] = ACTIONS(556),
    [anon_sym_bytes9] = ACTIONS(556),
    [anon_sym_bytes10] = ACTIONS(556),
    [anon_sym_bytes11] = ACTIONS(556),
    [anon_sym_bytes12] = ACTIONS(556),
    [anon_sym_bytes13] = ACTIONS(556),
    [anon_sym_bytes14] = ACTIONS(556),
    [anon_sym_bytes15] = ACTIONS(556),
    [anon_sym_bytes16] = ACTIONS(556),
    [anon_sym_bytes17] = ACTIONS(556),
    [anon_sym_bytes18] = ACTIONS(556),
    [anon_sym_bytes19] = ACTIONS(556),
    [anon_sym_bytes20] = ACTIONS(556),
    [anon_sym_bytes21] = ACTIONS(556),
    [anon_sym_bytes22] = ACTIONS(556),
    [anon_sym_bytes23] = ACTIONS(556),
    [anon_sym_bytes24] = ACTIONS(556),
    [anon_sym_bytes25] = ACTIONS(556),
    [anon_sym_bytes26] = ACTIONS(556),
    [anon_sym_bytes27] = ACTIONS(556),
    [anon_sym_bytes28] = ACTIONS(556),
    [anon_sym_bytes29] = ACTIONS(556),
    [anon_sym_bytes30] = ACTIONS(556),
    [anon_sym_bytes31] = ACTIONS(556),
    [anon_sym_bytes32] = ACTIONS(556),
    [anon_sym_fixed] = ACTIONS(556),
    [aux_sym__fixed_token1] = ACTIONS(556),
    [anon_sym_ufixed] = ACTIONS(556),
    [aux_sym__ufixed_token1] = ACTIONS(556),
    [aux_sym__decimal_number_token1] = ACTIONS(556),
    [aux_sym__decimal_number_token2] = ACTIONS(558),
    [aux_sym__hex_number_token1] = ACTIONS(558),
    [anon_sym_hex] = ACTIONS(556),
    [anon_sym_DQUOTE] = ACTIONS(558),
    [anon_sym_SQUOTE] = ACTIONS(558),
    [anon_sym_unicode] = ACTIONS(556),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_identifier] = ACTIONS(560),
    [anon_sym_DASH] = ACTIONS(560),
    [anon_sym_TILDE] = ACTIONS(562),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_type] = ACTIONS(560),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(560),
    [anon_sym_assembly] = ACTIONS(560),
    [anon_sym_break] = ACTIONS(560),
    [anon_sym_continue] = ACTIONS(560),
    [anon_sym_true] = ACTIONS(560),
    [anon_sym_false] = ACTIONS(560),
    [anon_sym_if] = ACTIONS(560),
    [anon_sym_function] = ACTIONS(560),
    [anon_sym_byte] = ACTIONS(560),
    [anon_sym_address] = ACTIONS(560),
    [anon_sym_return] = ACTIONS(560),
    [anon_sym_revert] = ACTIONS(560),
    [sym_unchecked] = ACTIONS(560),
    [anon_sym_var] = ACTIONS(560),
    [anon_sym_else] = ACTIONS(560),
    [anon_sym_while] = ACTIONS(560),
    [anon_sym_do] = ACTIONS(560),
    [anon_sym_try] = ACTIONS(560),
    [anon_sym_emit] = ACTIONS(560),
    [anon_sym_payable] = ACTIONS(560),
    [anon_sym_new] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(562),
    [anon_sym_delete] = ACTIONS(560),
    [anon_sym_BANG] = ACTIONS(562),
    [anon_sym_PLUS_PLUS] = ACTIONS(562),
    [anon_sym_DASH_DASH] = ACTIONS(562),
    [anon_sym_mapping] = ACTIONS(560),
    [anon_sym_bool] = ACTIONS(560),
    [anon_sym_string] = ACTIONS(560),
    [anon_sym_int] = ACTIONS(560),
    [anon_sym_int8] = ACTIONS(560),
    [anon_sym_int16] = ACTIONS(560),
    [anon_sym_int24] = ACTIONS(560),
    [anon_sym_int32] = ACTIONS(560),
    [anon_sym_int40] = ACTIONS(560),
    [anon_sym_int48] = ACTIONS(560),
    [anon_sym_int56] = ACTIONS(560),
    [anon_sym_int64] = ACTIONS(560),
    [anon_sym_int72] = ACTIONS(560),
    [anon_sym_int80] = ACTIONS(560),
    [anon_sym_int88] = ACTIONS(560),
    [anon_sym_int96] = ACTIONS(560),
    [anon_sym_int104] = ACTIONS(560),
    [anon_sym_int112] = ACTIONS(560),
    [anon_sym_int120] = ACTIONS(560),
    [anon_sym_int128] = ACTIONS(560),
    [anon_sym_int136] = ACTIONS(560),
    [anon_sym_int144] = ACTIONS(560),
    [anon_sym_int152] = ACTIONS(560),
    [anon_sym_int160] = ACTIONS(560),
    [anon_sym_int168] = ACTIONS(560),
    [anon_sym_int176] = ACTIONS(560),
    [anon_sym_int184] = ACTIONS(560),
    [anon_sym_int192] = ACTIONS(560),
    [anon_sym_int200] = ACTIONS(560),
    [anon_sym_int208] = ACTIONS(560),
    [anon_sym_int216] = ACTIONS(560),
    [anon_sym_int224] = ACTIONS(560),
    [anon_sym_int232] = ACTIONS(560),
    [anon_sym_int240] = ACTIONS(560),
    [anon_sym_int248] = ACTIONS(560),
    [anon_sym_int256] = ACTIONS(560),
    [anon_sym_uint] = ACTIONS(560),
    [anon_sym_uint8] = ACTIONS(560),
    [anon_sym_uint16] = ACTIONS(560),
    [anon_sym_uint24] = ACTIONS(560),
    [anon_sym_uint32] = ACTIONS(560),
    [anon_sym_uint40] = ACTIONS(560),
    [anon_sym_uint48] = ACTIONS(560),
    [anon_sym_uint56] = ACTIONS(560),
    [anon_sym_uint64] = ACTIONS(560),
    [anon_sym_uint72] = ACTIONS(560),
    [anon_sym_uint80] = ACTIONS(560),
    [anon_sym_uint88] = ACTIONS(560),
    [anon_sym_uint96] = ACTIONS(560),
    [anon_sym_uint104] = ACTIONS(560),
    [anon_sym_uint112] = ACTIONS(560),
    [anon_sym_uint120] = ACTIONS(560),
    [anon_sym_uint128] = ACTIONS(560),
    [anon_sym_uint136] = ACTIONS(560),
    [anon_sym_uint144] = ACTIONS(560),
    [anon_sym_uint152] = ACTIONS(560),
    [anon_sym_uint160] = ACTIONS(560),
    [anon_sym_uint168] = ACTIONS(560),
    [anon_sym_uint176] = ACTIONS(560),
    [anon_sym_uint184] = ACTIONS(560),
    [anon_sym_uint192] = ACTIONS(560),
    [anon_sym_uint200] = ACTIONS(560),
    [anon_sym_uint208] = ACTIONS(560),
    [anon_sym_uint216] = ACTIONS(560),
    [anon_sym_uint224] = ACTIONS(560),
    [anon_sym_uint232] = ACTIONS(560),
    [anon_sym_uint240] = ACTIONS(560),
    [anon_sym_uint248] = ACTIONS(560),
    [anon_sym_uint256] = ACTIONS(560),
    [anon_sym_bytes] = ACTIONS(560),
    [anon_sym_bytes1] = ACTIONS(560),
    [anon_sym_bytes2] = ACTIONS(560),
    [anon_sym_bytes3] = ACTIONS(560),
    [anon_sym_bytes4] = ACTIONS(560),
    [anon_sym_bytes5] = ACTIONS(560),
    [anon_sym_bytes6] = ACTIONS(560),
    [anon_sym_bytes7] = ACTIONS(560),
    [anon_sym_bytes8] = ACTIONS(560),
    [anon_sym_bytes9] = ACTIONS(560),
    [anon_sym_bytes10] = ACTIONS(560),
    [anon_sym_bytes11] = ACTIONS(560),
    [anon_sym_bytes12] = ACTIONS(560),
    [anon_sym_bytes13] = ACTIONS(560),
    [anon_sym_bytes14] = ACTIONS(560),
    [anon_sym_bytes15] = ACTIONS(560),
    [anon_sym_bytes16] = ACTIONS(560),
    [anon_sym_bytes17] = ACTIONS(560),
    [anon_sym_bytes18] = ACTIONS(560),
    [anon_sym_bytes19] = ACTIONS(560),
    [anon_sym_bytes20] = ACTIONS(560),
    [anon_sym_bytes21] = ACTIONS(560),
    [anon_sym_bytes22] = ACTIONS(560),
    [anon_sym_bytes23] = ACTIONS(560),
    [anon_sym_bytes24] = ACTIONS(560),
    [anon_sym_bytes25] = ACTIONS(560),
    [anon_sym_bytes26] = ACTIONS(560),
    [anon_sym_bytes27] = ACTIONS(560),
    [anon_sym_bytes28] = ACTIONS(560),
    [anon_sym_bytes29] = ACTIONS(560),
    [anon_sym_bytes30] = ACTIONS(560),
    [anon_sym_bytes31] = ACTIONS(560),
    [anon_sym_bytes32] = ACTIONS(560),
    [anon_sym_fixed] = ACTIONS(560),
    [aux_sym__fixed_token1] = ACTIONS(560),
    [anon_sym_ufixed] = ACTIONS(560),
    [aux_sym__ufixed_token1] = ACTIONS(560),
    [aux_sym__decimal_number_token1] = ACTIONS(560),
    [aux_sym__decimal_number_token2] = ACTIONS(562),
    [aux_sym__hex_number_token1] = ACTIONS(562),
    [anon_sym_hex] = ACTIONS(560),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [anon_sym_SQUOTE] = ACTIONS(562),
    [anon_sym_unicode] = ACTIONS(560),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_identifier] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(566),
    [anon_sym_LBRACE] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_type] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(566),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_assembly] = ACTIONS(564),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_true] = ACTIONS(564),
    [anon_sym_false] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_function] = ACTIONS(564),
    [anon_sym_byte] = ACTIONS(564),
    [anon_sym_address] = ACTIONS(564),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_revert] = ACTIONS(564),
    [sym_unchecked] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_do] = ACTIONS(564),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_emit] = ACTIONS(564),
    [anon_sym_payable] = ACTIONS(564),
    [anon_sym_new] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(566),
    [anon_sym_delete] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(566),
    [anon_sym_PLUS_PLUS] = ACTIONS(566),
    [anon_sym_DASH_DASH] = ACTIONS(566),
    [anon_sym_mapping] = ACTIONS(564),
    [anon_sym_bool] = ACTIONS(564),
    [anon_sym_string] = ACTIONS(564),
    [anon_sym_int] = ACTIONS(564),
    [anon_sym_int8] = ACTIONS(564),
    [anon_sym_int16] = ACTIONS(564),
    [anon_sym_int24] = ACTIONS(564),
    [anon_sym_int32] = ACTIONS(564),
    [anon_sym_int40] = ACTIONS(564),
    [anon_sym_int48] = ACTIONS(564),
    [anon_sym_int56] = ACTIONS(564),
    [anon_sym_int64] = ACTIONS(564),
    [anon_sym_int72] = ACTIONS(564),
    [anon_sym_int80] = ACTIONS(564),
    [anon_sym_int88] = ACTIONS(564),
    [anon_sym_int96] = ACTIONS(564),
    [anon_sym_int104] = ACTIONS(564),
    [anon_sym_int112] = ACTIONS(564),
    [anon_sym_int120] = ACTIONS(564),
    [anon_sym_int128] = ACTIONS(564),
    [anon_sym_int136] = ACTIONS(564),
    [anon_sym_int144] = ACTIONS(564),
    [anon_sym_int152] = ACTIONS(564),
    [anon_sym_int160] = ACTIONS(564),
    [anon_sym_int168] = ACTIONS(564),
    [anon_sym_int176] = ACTIONS(564),
    [anon_sym_int184] = ACTIONS(564),
    [anon_sym_int192] = ACTIONS(564),
    [anon_sym_int200] = ACTIONS(564),
    [anon_sym_int208] = ACTIONS(564),
    [anon_sym_int216] = ACTIONS(564),
    [anon_sym_int224] = ACTIONS(564),
    [anon_sym_int232] = ACTIONS(564),
    [anon_sym_int240] = ACTIONS(564),
    [anon_sym_int248] = ACTIONS(564),
    [anon_sym_int256] = ACTIONS(564),
    [anon_sym_uint] = ACTIONS(564),
    [anon_sym_uint8] = ACTIONS(564),
    [anon_sym_uint16] = ACTIONS(564),
    [anon_sym_uint24] = ACTIONS(564),
    [anon_sym_uint32] = ACTIONS(564),
    [anon_sym_uint40] = ACTIONS(564),
    [anon_sym_uint48] = ACTIONS(564),
    [anon_sym_uint56] = ACTIONS(564),
    [anon_sym_uint64] = ACTIONS(564),
    [anon_sym_uint72] = ACTIONS(564),
    [anon_sym_uint80] = ACTIONS(564),
    [anon_sym_uint88] = ACTIONS(564),
    [anon_sym_uint96] = ACTIONS(564),
    [anon_sym_uint104] = ACTIONS(564),
    [anon_sym_uint112] = ACTIONS(564),
    [anon_sym_uint120] = ACTIONS(564),
    [anon_sym_uint128] = ACTIONS(564),
    [anon_sym_uint136] = ACTIONS(564),
    [anon_sym_uint144] = ACTIONS(564),
    [anon_sym_uint152] = ACTIONS(564),
    [anon_sym_uint160] = ACTIONS(564),
    [anon_sym_uint168] = ACTIONS(564),
    [anon_sym_uint176] = ACTIONS(564),
    [anon_sym_uint184] = ACTIONS(564),
    [anon_sym_uint192] = ACTIONS(564),
    [anon_sym_uint200] = ACTIONS(564),
    [anon_sym_uint208] = ACTIONS(564),
    [anon_sym_uint216] = ACTIONS(564),
    [anon_sym_uint224] = ACTIONS(564),
    [anon_sym_uint232] = ACTIONS(564),
    [anon_sym_uint240] = ACTIONS(564),
    [anon_sym_uint248] = ACTIONS(564),
    [anon_sym_uint256] = ACTIONS(564),
    [anon_sym_bytes] = ACTIONS(564),
    [anon_sym_bytes1] = ACTIONS(564),
    [anon_sym_bytes2] = ACTIONS(564),
    [anon_sym_bytes3] = ACTIONS(564),
    [anon_sym_bytes4] = ACTIONS(564),
    [anon_sym_bytes5] = ACTIONS(564),
    [anon_sym_bytes6] = ACTIONS(564),
    [anon_sym_bytes7] = ACTIONS(564),
    [anon_sym_bytes8] = ACTIONS(564),
    [anon_sym_bytes9] = ACTIONS(564),
    [anon_sym_bytes10] = ACTIONS(564),
    [anon_sym_bytes11] = ACTIONS(564),
    [anon_sym_bytes12] = ACTIONS(564),
    [anon_sym_bytes13] = ACTIONS(564),
    [anon_sym_bytes14] = ACTIONS(564),
    [anon_sym_bytes15] = ACTIONS(564),
    [anon_sym_bytes16] = ACTIONS(564),
    [anon_sym_bytes17] = ACTIONS(564),
    [anon_sym_bytes18] = ACTIONS(564),
    [anon_sym_bytes19] = ACTIONS(564),
    [anon_sym_bytes20] = ACTIONS(564),
    [anon_sym_bytes21] = ACTIONS(564),
    [anon_sym_bytes22] = ACTIONS(564),
    [anon_sym_bytes23] = ACTIONS(564),
    [anon_sym_bytes24] = ACTIONS(564),
    [anon_sym_bytes25] = ACTIONS(564),
    [anon_sym_bytes26] = ACTIONS(564),
    [anon_sym_bytes27] = ACTIONS(564),
    [anon_sym_bytes28] = ACTIONS(564),
    [anon_sym_bytes29] = ACTIONS(564),
    [anon_sym_bytes30] = ACTIONS(564),
    [anon_sym_bytes31] = ACTIONS(564),
    [anon_sym_bytes32] = ACTIONS(564),
    [anon_sym_fixed] = ACTIONS(564),
    [aux_sym__fixed_token1] = ACTIONS(564),
    [anon_sym_ufixed] = ACTIONS(564),
    [aux_sym__ufixed_token1] = ACTIONS(564),
    [aux_sym__decimal_number_token1] = ACTIONS(564),
    [aux_sym__decimal_number_token2] = ACTIONS(566),
    [aux_sym__hex_number_token1] = ACTIONS(566),
    [anon_sym_hex] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(566),
    [anon_sym_SQUOTE] = ACTIONS(566),
    [anon_sym_unicode] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_struct_member] = STATE(124),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_struct_body_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(568),
    [anon_sym_RBRACE] = ACTIONS(571),
    [anon_sym_function] = ACTIONS(573),
    [anon_sym_byte] = ACTIONS(576),
    [anon_sym_address] = ACTIONS(579),
    [anon_sym_var] = ACTIONS(576),
    [anon_sym_mapping] = ACTIONS(582),
    [anon_sym_bool] = ACTIONS(576),
    [anon_sym_string] = ACTIONS(576),
    [anon_sym_int] = ACTIONS(576),
    [anon_sym_int8] = ACTIONS(576),
    [anon_sym_int16] = ACTIONS(576),
    [anon_sym_int24] = ACTIONS(576),
    [anon_sym_int32] = ACTIONS(576),
    [anon_sym_int40] = ACTIONS(576),
    [anon_sym_int48] = ACTIONS(576),
    [anon_sym_int56] = ACTIONS(576),
    [anon_sym_int64] = ACTIONS(576),
    [anon_sym_int72] = ACTIONS(576),
    [anon_sym_int80] = ACTIONS(576),
    [anon_sym_int88] = ACTIONS(576),
    [anon_sym_int96] = ACTIONS(576),
    [anon_sym_int104] = ACTIONS(576),
    [anon_sym_int112] = ACTIONS(576),
    [anon_sym_int120] = ACTIONS(576),
    [anon_sym_int128] = ACTIONS(576),
    [anon_sym_int136] = ACTIONS(576),
    [anon_sym_int144] = ACTIONS(576),
    [anon_sym_int152] = ACTIONS(576),
    [anon_sym_int160] = ACTIONS(576),
    [anon_sym_int168] = ACTIONS(576),
    [anon_sym_int176] = ACTIONS(576),
    [anon_sym_int184] = ACTIONS(576),
    [anon_sym_int192] = ACTIONS(576),
    [anon_sym_int200] = ACTIONS(576),
    [anon_sym_int208] = ACTIONS(576),
    [anon_sym_int216] = ACTIONS(576),
    [anon_sym_int224] = ACTIONS(576),
    [anon_sym_int232] = ACTIONS(576),
    [anon_sym_int240] = ACTIONS(576),
    [anon_sym_int248] = ACTIONS(576),
    [anon_sym_int256] = ACTIONS(576),
    [anon_sym_uint] = ACTIONS(576),
    [anon_sym_uint8] = ACTIONS(576),
    [anon_sym_uint16] = ACTIONS(576),
    [anon_sym_uint24] = ACTIONS(576),
    [anon_sym_uint32] = ACTIONS(576),
    [anon_sym_uint40] = ACTIONS(576),
    [anon_sym_uint48] = ACTIONS(576),
    [anon_sym_uint56] = ACTIONS(576),
    [anon_sym_uint64] = ACTIONS(576),
    [anon_sym_uint72] = ACTIONS(576),
    [anon_sym_uint80] = ACTIONS(576),
    [anon_sym_uint88] = ACTIONS(576),
    [anon_sym_uint96] = ACTIONS(576),
    [anon_sym_uint104] = ACTIONS(576),
    [anon_sym_uint112] = ACTIONS(576),
    [anon_sym_uint120] = ACTIONS(576),
    [anon_sym_uint128] = ACTIONS(576),
    [anon_sym_uint136] = ACTIONS(576),
    [anon_sym_uint144] = ACTIONS(576),
    [anon_sym_uint152] = ACTIONS(576),
    [anon_sym_uint160] = ACTIONS(576),
    [anon_sym_uint168] = ACTIONS(576),
    [anon_sym_uint176] = ACTIONS(576),
    [anon_sym_uint184] = ACTIONS(576),
    [anon_sym_uint192] = ACTIONS(576),
    [anon_sym_uint200] = ACTIONS(576),
    [anon_sym_uint208] = ACTIONS(576),
    [anon_sym_uint216] = ACTIONS(576),
    [anon_sym_uint224] = ACTIONS(576),
    [anon_sym_uint232] = ACTIONS(576),
    [anon_sym_uint240] = ACTIONS(576),
    [anon_sym_uint248] = ACTIONS(576),
    [anon_sym_uint256] = ACTIONS(576),
    [anon_sym_bytes] = ACTIONS(576),
    [anon_sym_bytes1] = ACTIONS(576),
    [anon_sym_bytes2] = ACTIONS(576),
    [anon_sym_bytes3] = ACTIONS(576),
    [anon_sym_bytes4] = ACTIONS(576),
    [anon_sym_bytes5] = ACTIONS(576),
    [anon_sym_bytes6] = ACTIONS(576),
    [anon_sym_bytes7] = ACTIONS(576),
    [anon_sym_bytes8] = ACTIONS(576),
    [anon_sym_bytes9] = ACTIONS(576),
    [anon_sym_bytes10] = ACTIONS(576),
    [anon_sym_bytes11] = ACTIONS(576),
    [anon_sym_bytes12] = ACTIONS(576),
    [anon_sym_bytes13] = ACTIONS(576),
    [anon_sym_bytes14] = ACTIONS(576),
    [anon_sym_bytes15] = ACTIONS(576),
    [anon_sym_bytes16] = ACTIONS(576),
    [anon_sym_bytes17] = ACTIONS(576),
    [anon_sym_bytes18] = ACTIONS(576),
    [anon_sym_bytes19] = ACTIONS(576),
    [anon_sym_bytes20] = ACTIONS(576),
    [anon_sym_bytes21] = ACTIONS(576),
    [anon_sym_bytes22] = ACTIONS(576),
    [anon_sym_bytes23] = ACTIONS(576),
    [anon_sym_bytes24] = ACTIONS(576),
    [anon_sym_bytes25] = ACTIONS(576),
    [anon_sym_bytes26] = ACTIONS(576),
    [anon_sym_bytes27] = ACTIONS(576),
    [anon_sym_bytes28] = ACTIONS(576),
    [anon_sym_bytes29] = ACTIONS(576),
    [anon_sym_bytes30] = ACTIONS(576),
    [anon_sym_bytes31] = ACTIONS(576),
    [anon_sym_bytes32] = ACTIONS(576),
    [anon_sym_fixed] = ACTIONS(576),
    [aux_sym__fixed_token1] = ACTIONS(576),
    [anon_sym_ufixed] = ACTIONS(576),
    [aux_sym__ufixed_token1] = ACTIONS(576),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_variable_declaration] = STATE(773),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(587),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_variable_declaration] = STATE(773),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_variable_declaration] = STATE(773),
    [sym_type_name] = STATE(526),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_struct_member] = STATE(124),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_struct_body_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_struct_member] = STATE(124),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_struct_body_repeat1] = STATE(124),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_event_parameter] = STATE(635),
    [sym_type_name] = STATE(518),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_type_name] = STATE(509),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_parameter] = STATE(657),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(597),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_type_name] = STATE(513),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym__nameless_parameter] = STATE(735),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(599),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_error_parameter] = STATE(721),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_any_source_type] = STATE(722),
    [sym_type_name] = STATE(655),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(603),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_error_parameter] = STATE(721),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_type_name] = STATE(513),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym__nameless_parameter] = STATE(735),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(607),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_error_parameter] = STATE(721),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(609),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_error_parameter] = STATE(627),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(611),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_event_parameter] = STATE(741),
    [sym_type_name] = STATE(518),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(613),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_type_name] = STATE(509),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_parameter] = STATE(690),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(615),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_struct_member] = STATE(128),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_struct_body_repeat1] = STATE(128),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_error_parameter] = STATE(682),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_error_parameter] = STATE(721),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_event_parameter] = STATE(741),
    [sym_type_name] = STATE(518),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(621),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_struct_member] = STATE(129),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [aux_sym_struct_body_repeat1] = STATE(129),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_type_name] = STATE(509),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_parameter] = STATE(690),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_error_parameter] = STATE(721),
    [sym_type_name] = STATE(574),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_event_parameter] = STATE(741),
    [sym_type_name] = STATE(518),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_type_name] = STATE(513),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym__nameless_parameter] = STATE(595),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_type_name] = STATE(509),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_parameter] = STATE(690),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_type_name] = STATE(513),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym__nameless_parameter] = STATE(735),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(625),
    [sym_identifier] = ACTIONS(627),
    [anon_sym_pragma] = ACTIONS(627),
    [anon_sym_import] = ACTIONS(627),
    [anon_sym_type] = ACTIONS(627),
    [anon_sym_abstract] = ACTIONS(627),
    [anon_sym_contract] = ACTIONS(627),
    [anon_sym_error] = ACTIONS(627),
    [anon_sym_interface] = ACTIONS(627),
    [anon_sym_library] = ACTIONS(627),
    [anon_sym_struct] = ACTIONS(627),
    [anon_sym_enum] = ACTIONS(627),
    [anon_sym_event] = ACTIONS(627),
    [anon_sym_function] = ACTIONS(627),
    [anon_sym_byte] = ACTIONS(627),
    [anon_sym_address] = ACTIONS(627),
    [anon_sym_var] = ACTIONS(627),
    [anon_sym_mapping] = ACTIONS(627),
    [anon_sym_bool] = ACTIONS(627),
    [anon_sym_string] = ACTIONS(627),
    [anon_sym_int] = ACTIONS(627),
    [anon_sym_int8] = ACTIONS(627),
    [anon_sym_int16] = ACTIONS(627),
    [anon_sym_int24] = ACTIONS(627),
    [anon_sym_int32] = ACTIONS(627),
    [anon_sym_int40] = ACTIONS(627),
    [anon_sym_int48] = ACTIONS(627),
    [anon_sym_int56] = ACTIONS(627),
    [anon_sym_int64] = ACTIONS(627),
    [anon_sym_int72] = ACTIONS(627),
    [anon_sym_int80] = ACTIONS(627),
    [anon_sym_int88] = ACTIONS(627),
    [anon_sym_int96] = ACTIONS(627),
    [anon_sym_int104] = ACTIONS(627),
    [anon_sym_int112] = ACTIONS(627),
    [anon_sym_int120] = ACTIONS(627),
    [anon_sym_int128] = ACTIONS(627),
    [anon_sym_int136] = ACTIONS(627),
    [anon_sym_int144] = ACTIONS(627),
    [anon_sym_int152] = ACTIONS(627),
    [anon_sym_int160] = ACTIONS(627),
    [anon_sym_int168] = ACTIONS(627),
    [anon_sym_int176] = ACTIONS(627),
    [anon_sym_int184] = ACTIONS(627),
    [anon_sym_int192] = ACTIONS(627),
    [anon_sym_int200] = ACTIONS(627),
    [anon_sym_int208] = ACTIONS(627),
    [anon_sym_int216] = ACTIONS(627),
    [anon_sym_int224] = ACTIONS(627),
    [anon_sym_int232] = ACTIONS(627),
    [anon_sym_int240] = ACTIONS(627),
    [anon_sym_int248] = ACTIONS(627),
    [anon_sym_int256] = ACTIONS(627),
    [anon_sym_uint] = ACTIONS(627),
    [anon_sym_uint8] = ACTIONS(627),
    [anon_sym_uint16] = ACTIONS(627),
    [anon_sym_uint24] = ACTIONS(627),
    [anon_sym_uint32] = ACTIONS(627),
    [anon_sym_uint40] = ACTIONS(627),
    [anon_sym_uint48] = ACTIONS(627),
    [anon_sym_uint56] = ACTIONS(627),
    [anon_sym_uint64] = ACTIONS(627),
    [anon_sym_uint72] = ACTIONS(627),
    [anon_sym_uint80] = ACTIONS(627),
    [anon_sym_uint88] = ACTIONS(627),
    [anon_sym_uint96] = ACTIONS(627),
    [anon_sym_uint104] = ACTIONS(627),
    [anon_sym_uint112] = ACTIONS(627),
    [anon_sym_uint120] = ACTIONS(627),
    [anon_sym_uint128] = ACTIONS(627),
    [anon_sym_uint136] = ACTIONS(627),
    [anon_sym_uint144] = ACTIONS(627),
    [anon_sym_uint152] = ACTIONS(627),
    [anon_sym_uint160] = ACTIONS(627),
    [anon_sym_uint168] = ACTIONS(627),
    [anon_sym_uint176] = ACTIONS(627),
    [anon_sym_uint184] = ACTIONS(627),
    [anon_sym_uint192] = ACTIONS(627),
    [anon_sym_uint200] = ACTIONS(627),
    [anon_sym_uint208] = ACTIONS(627),
    [anon_sym_uint216] = ACTIONS(627),
    [anon_sym_uint224] = ACTIONS(627),
    [anon_sym_uint232] = ACTIONS(627),
    [anon_sym_uint240] = ACTIONS(627),
    [anon_sym_uint248] = ACTIONS(627),
    [anon_sym_uint256] = ACTIONS(627),
    [anon_sym_bytes] = ACTIONS(627),
    [anon_sym_bytes1] = ACTIONS(627),
    [anon_sym_bytes2] = ACTIONS(627),
    [anon_sym_bytes3] = ACTIONS(627),
    [anon_sym_bytes4] = ACTIONS(627),
    [anon_sym_bytes5] = ACTIONS(627),
    [anon_sym_bytes6] = ACTIONS(627),
    [anon_sym_bytes7] = ACTIONS(627),
    [anon_sym_bytes8] = ACTIONS(627),
    [anon_sym_bytes9] = ACTIONS(627),
    [anon_sym_bytes10] = ACTIONS(627),
    [anon_sym_bytes11] = ACTIONS(627),
    [anon_sym_bytes12] = ACTIONS(627),
    [anon_sym_bytes13] = ACTIONS(627),
    [anon_sym_bytes14] = ACTIONS(627),
    [anon_sym_bytes15] = ACTIONS(627),
    [anon_sym_bytes16] = ACTIONS(627),
    [anon_sym_bytes17] = ACTIONS(627),
    [anon_sym_bytes18] = ACTIONS(627),
    [anon_sym_bytes19] = ACTIONS(627),
    [anon_sym_bytes20] = ACTIONS(627),
    [anon_sym_bytes21] = ACTIONS(627),
    [anon_sym_bytes22] = ACTIONS(627),
    [anon_sym_bytes23] = ACTIONS(627),
    [anon_sym_bytes24] = ACTIONS(627),
    [anon_sym_bytes25] = ACTIONS(627),
    [anon_sym_bytes26] = ACTIONS(627),
    [anon_sym_bytes27] = ACTIONS(627),
    [anon_sym_bytes28] = ACTIONS(627),
    [anon_sym_bytes29] = ACTIONS(627),
    [anon_sym_bytes30] = ACTIONS(627),
    [anon_sym_bytes31] = ACTIONS(627),
    [anon_sym_bytes32] = ACTIONS(627),
    [anon_sym_fixed] = ACTIONS(627),
    [aux_sym__fixed_token1] = ACTIONS(627),
    [anon_sym_ufixed] = ACTIONS(627),
    [aux_sym__ufixed_token1] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_type_name] = STATE(634),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(629),
    [sym_identifier] = ACTIONS(631),
    [anon_sym_pragma] = ACTIONS(631),
    [anon_sym_import] = ACTIONS(631),
    [anon_sym_type] = ACTIONS(631),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_contract] = ACTIONS(631),
    [anon_sym_error] = ACTIONS(631),
    [anon_sym_interface] = ACTIONS(631),
    [anon_sym_library] = ACTIONS(631),
    [anon_sym_struct] = ACTIONS(631),
    [anon_sym_enum] = ACTIONS(631),
    [anon_sym_event] = ACTIONS(631),
    [anon_sym_function] = ACTIONS(631),
    [anon_sym_byte] = ACTIONS(631),
    [anon_sym_address] = ACTIONS(631),
    [anon_sym_var] = ACTIONS(631),
    [anon_sym_mapping] = ACTIONS(631),
    [anon_sym_bool] = ACTIONS(631),
    [anon_sym_string] = ACTIONS(631),
    [anon_sym_int] = ACTIONS(631),
    [anon_sym_int8] = ACTIONS(631),
    [anon_sym_int16] = ACTIONS(631),
    [anon_sym_int24] = ACTIONS(631),
    [anon_sym_int32] = ACTIONS(631),
    [anon_sym_int40] = ACTIONS(631),
    [anon_sym_int48] = ACTIONS(631),
    [anon_sym_int56] = ACTIONS(631),
    [anon_sym_int64] = ACTIONS(631),
    [anon_sym_int72] = ACTIONS(631),
    [anon_sym_int80] = ACTIONS(631),
    [anon_sym_int88] = ACTIONS(631),
    [anon_sym_int96] = ACTIONS(631),
    [anon_sym_int104] = ACTIONS(631),
    [anon_sym_int112] = ACTIONS(631),
    [anon_sym_int120] = ACTIONS(631),
    [anon_sym_int128] = ACTIONS(631),
    [anon_sym_int136] = ACTIONS(631),
    [anon_sym_int144] = ACTIONS(631),
    [anon_sym_int152] = ACTIONS(631),
    [anon_sym_int160] = ACTIONS(631),
    [anon_sym_int168] = ACTIONS(631),
    [anon_sym_int176] = ACTIONS(631),
    [anon_sym_int184] = ACTIONS(631),
    [anon_sym_int192] = ACTIONS(631),
    [anon_sym_int200] = ACTIONS(631),
    [anon_sym_int208] = ACTIONS(631),
    [anon_sym_int216] = ACTIONS(631),
    [anon_sym_int224] = ACTIONS(631),
    [anon_sym_int232] = ACTIONS(631),
    [anon_sym_int240] = ACTIONS(631),
    [anon_sym_int248] = ACTIONS(631),
    [anon_sym_int256] = ACTIONS(631),
    [anon_sym_uint] = ACTIONS(631),
    [anon_sym_uint8] = ACTIONS(631),
    [anon_sym_uint16] = ACTIONS(631),
    [anon_sym_uint24] = ACTIONS(631),
    [anon_sym_uint32] = ACTIONS(631),
    [anon_sym_uint40] = ACTIONS(631),
    [anon_sym_uint48] = ACTIONS(631),
    [anon_sym_uint56] = ACTIONS(631),
    [anon_sym_uint64] = ACTIONS(631),
    [anon_sym_uint72] = ACTIONS(631),
    [anon_sym_uint80] = ACTIONS(631),
    [anon_sym_uint88] = ACTIONS(631),
    [anon_sym_uint96] = ACTIONS(631),
    [anon_sym_uint104] = ACTIONS(631),
    [anon_sym_uint112] = ACTIONS(631),
    [anon_sym_uint120] = ACTIONS(631),
    [anon_sym_uint128] = ACTIONS(631),
    [anon_sym_uint136] = ACTIONS(631),
    [anon_sym_uint144] = ACTIONS(631),
    [anon_sym_uint152] = ACTIONS(631),
    [anon_sym_uint160] = ACTIONS(631),
    [anon_sym_uint168] = ACTIONS(631),
    [anon_sym_uint176] = ACTIONS(631),
    [anon_sym_uint184] = ACTIONS(631),
    [anon_sym_uint192] = ACTIONS(631),
    [anon_sym_uint200] = ACTIONS(631),
    [anon_sym_uint208] = ACTIONS(631),
    [anon_sym_uint216] = ACTIONS(631),
    [anon_sym_uint224] = ACTIONS(631),
    [anon_sym_uint232] = ACTIONS(631),
    [anon_sym_uint240] = ACTIONS(631),
    [anon_sym_uint248] = ACTIONS(631),
    [anon_sym_uint256] = ACTIONS(631),
    [anon_sym_bytes] = ACTIONS(631),
    [anon_sym_bytes1] = ACTIONS(631),
    [anon_sym_bytes2] = ACTIONS(631),
    [anon_sym_bytes3] = ACTIONS(631),
    [anon_sym_bytes4] = ACTIONS(631),
    [anon_sym_bytes5] = ACTIONS(631),
    [anon_sym_bytes6] = ACTIONS(631),
    [anon_sym_bytes7] = ACTIONS(631),
    [anon_sym_bytes8] = ACTIONS(631),
    [anon_sym_bytes9] = ACTIONS(631),
    [anon_sym_bytes10] = ACTIONS(631),
    [anon_sym_bytes11] = ACTIONS(631),
    [anon_sym_bytes12] = ACTIONS(631),
    [anon_sym_bytes13] = ACTIONS(631),
    [anon_sym_bytes14] = ACTIONS(631),
    [anon_sym_bytes15] = ACTIONS(631),
    [anon_sym_bytes16] = ACTIONS(631),
    [anon_sym_bytes17] = ACTIONS(631),
    [anon_sym_bytes18] = ACTIONS(631),
    [anon_sym_bytes19] = ACTIONS(631),
    [anon_sym_bytes20] = ACTIONS(631),
    [anon_sym_bytes21] = ACTIONS(631),
    [anon_sym_bytes22] = ACTIONS(631),
    [anon_sym_bytes23] = ACTIONS(631),
    [anon_sym_bytes24] = ACTIONS(631),
    [anon_sym_bytes25] = ACTIONS(631),
    [anon_sym_bytes26] = ACTIONS(631),
    [anon_sym_bytes27] = ACTIONS(631),
    [anon_sym_bytes28] = ACTIONS(631),
    [anon_sym_bytes29] = ACTIONS(631),
    [anon_sym_bytes30] = ACTIONS(631),
    [anon_sym_bytes31] = ACTIONS(631),
    [anon_sym_bytes32] = ACTIONS(631),
    [anon_sym_fixed] = ACTIONS(631),
    [aux_sym__fixed_token1] = ACTIONS(631),
    [anon_sym_ufixed] = ACTIONS(631),
    [aux_sym__ufixed_token1] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(633),
    [sym_identifier] = ACTIONS(635),
    [anon_sym_pragma] = ACTIONS(635),
    [anon_sym_import] = ACTIONS(635),
    [anon_sym_type] = ACTIONS(635),
    [anon_sym_abstract] = ACTIONS(635),
    [anon_sym_contract] = ACTIONS(635),
    [anon_sym_error] = ACTIONS(635),
    [anon_sym_interface] = ACTIONS(635),
    [anon_sym_library] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(635),
    [anon_sym_enum] = ACTIONS(635),
    [anon_sym_event] = ACTIONS(635),
    [anon_sym_function] = ACTIONS(635),
    [anon_sym_byte] = ACTIONS(635),
    [anon_sym_address] = ACTIONS(635),
    [anon_sym_var] = ACTIONS(635),
    [anon_sym_mapping] = ACTIONS(635),
    [anon_sym_bool] = ACTIONS(635),
    [anon_sym_string] = ACTIONS(635),
    [anon_sym_int] = ACTIONS(635),
    [anon_sym_int8] = ACTIONS(635),
    [anon_sym_int16] = ACTIONS(635),
    [anon_sym_int24] = ACTIONS(635),
    [anon_sym_int32] = ACTIONS(635),
    [anon_sym_int40] = ACTIONS(635),
    [anon_sym_int48] = ACTIONS(635),
    [anon_sym_int56] = ACTIONS(635),
    [anon_sym_int64] = ACTIONS(635),
    [anon_sym_int72] = ACTIONS(635),
    [anon_sym_int80] = ACTIONS(635),
    [anon_sym_int88] = ACTIONS(635),
    [anon_sym_int96] = ACTIONS(635),
    [anon_sym_int104] = ACTIONS(635),
    [anon_sym_int112] = ACTIONS(635),
    [anon_sym_int120] = ACTIONS(635),
    [anon_sym_int128] = ACTIONS(635),
    [anon_sym_int136] = ACTIONS(635),
    [anon_sym_int144] = ACTIONS(635),
    [anon_sym_int152] = ACTIONS(635),
    [anon_sym_int160] = ACTIONS(635),
    [anon_sym_int168] = ACTIONS(635),
    [anon_sym_int176] = ACTIONS(635),
    [anon_sym_int184] = ACTIONS(635),
    [anon_sym_int192] = ACTIONS(635),
    [anon_sym_int200] = ACTIONS(635),
    [anon_sym_int208] = ACTIONS(635),
    [anon_sym_int216] = ACTIONS(635),
    [anon_sym_int224] = ACTIONS(635),
    [anon_sym_int232] = ACTIONS(635),
    [anon_sym_int240] = ACTIONS(635),
    [anon_sym_int248] = ACTIONS(635),
    [anon_sym_int256] = ACTIONS(635),
    [anon_sym_uint] = ACTIONS(635),
    [anon_sym_uint8] = ACTIONS(635),
    [anon_sym_uint16] = ACTIONS(635),
    [anon_sym_uint24] = ACTIONS(635),
    [anon_sym_uint32] = ACTIONS(635),
    [anon_sym_uint40] = ACTIONS(635),
    [anon_sym_uint48] = ACTIONS(635),
    [anon_sym_uint56] = ACTIONS(635),
    [anon_sym_uint64] = ACTIONS(635),
    [anon_sym_uint72] = ACTIONS(635),
    [anon_sym_uint80] = ACTIONS(635),
    [anon_sym_uint88] = ACTIONS(635),
    [anon_sym_uint96] = ACTIONS(635),
    [anon_sym_uint104] = ACTIONS(635),
    [anon_sym_uint112] = ACTIONS(635),
    [anon_sym_uint120] = ACTIONS(635),
    [anon_sym_uint128] = ACTIONS(635),
    [anon_sym_uint136] = ACTIONS(635),
    [anon_sym_uint144] = ACTIONS(635),
    [anon_sym_uint152] = ACTIONS(635),
    [anon_sym_uint160] = ACTIONS(635),
    [anon_sym_uint168] = ACTIONS(635),
    [anon_sym_uint176] = ACTIONS(635),
    [anon_sym_uint184] = ACTIONS(635),
    [anon_sym_uint192] = ACTIONS(635),
    [anon_sym_uint200] = ACTIONS(635),
    [anon_sym_uint208] = ACTIONS(635),
    [anon_sym_uint216] = ACTIONS(635),
    [anon_sym_uint224] = ACTIONS(635),
    [anon_sym_uint232] = ACTIONS(635),
    [anon_sym_uint240] = ACTIONS(635),
    [anon_sym_uint248] = ACTIONS(635),
    [anon_sym_uint256] = ACTIONS(635),
    [anon_sym_bytes] = ACTIONS(635),
    [anon_sym_bytes1] = ACTIONS(635),
    [anon_sym_bytes2] = ACTIONS(635),
    [anon_sym_bytes3] = ACTIONS(635),
    [anon_sym_bytes4] = ACTIONS(635),
    [anon_sym_bytes5] = ACTIONS(635),
    [anon_sym_bytes6] = ACTIONS(635),
    [anon_sym_bytes7] = ACTIONS(635),
    [anon_sym_bytes8] = ACTIONS(635),
    [anon_sym_bytes9] = ACTIONS(635),
    [anon_sym_bytes10] = ACTIONS(635),
    [anon_sym_bytes11] = ACTIONS(635),
    [anon_sym_bytes12] = ACTIONS(635),
    [anon_sym_bytes13] = ACTIONS(635),
    [anon_sym_bytes14] = ACTIONS(635),
    [anon_sym_bytes15] = ACTIONS(635),
    [anon_sym_bytes16] = ACTIONS(635),
    [anon_sym_bytes17] = ACTIONS(635),
    [anon_sym_bytes18] = ACTIONS(635),
    [anon_sym_bytes19] = ACTIONS(635),
    [anon_sym_bytes20] = ACTIONS(635),
    [anon_sym_bytes21] = ACTIONS(635),
    [anon_sym_bytes22] = ACTIONS(635),
    [anon_sym_bytes23] = ACTIONS(635),
    [anon_sym_bytes24] = ACTIONS(635),
    [anon_sym_bytes25] = ACTIONS(635),
    [anon_sym_bytes26] = ACTIONS(635),
    [anon_sym_bytes27] = ACTIONS(635),
    [anon_sym_bytes28] = ACTIONS(635),
    [anon_sym_bytes29] = ACTIONS(635),
    [anon_sym_bytes30] = ACTIONS(635),
    [anon_sym_bytes31] = ACTIONS(635),
    [anon_sym_bytes32] = ACTIONS(635),
    [anon_sym_fixed] = ACTIONS(635),
    [aux_sym__fixed_token1] = ACTIONS(635),
    [anon_sym_ufixed] = ACTIONS(635),
    [aux_sym__ufixed_token1] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(637),
    [sym_identifier] = ACTIONS(639),
    [anon_sym_pragma] = ACTIONS(639),
    [anon_sym_import] = ACTIONS(639),
    [anon_sym_type] = ACTIONS(639),
    [anon_sym_abstract] = ACTIONS(639),
    [anon_sym_contract] = ACTIONS(639),
    [anon_sym_error] = ACTIONS(639),
    [anon_sym_interface] = ACTIONS(639),
    [anon_sym_library] = ACTIONS(639),
    [anon_sym_struct] = ACTIONS(639),
    [anon_sym_enum] = ACTIONS(639),
    [anon_sym_event] = ACTIONS(639),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_byte] = ACTIONS(639),
    [anon_sym_address] = ACTIONS(639),
    [anon_sym_var] = ACTIONS(639),
    [anon_sym_mapping] = ACTIONS(639),
    [anon_sym_bool] = ACTIONS(639),
    [anon_sym_string] = ACTIONS(639),
    [anon_sym_int] = ACTIONS(639),
    [anon_sym_int8] = ACTIONS(639),
    [anon_sym_int16] = ACTIONS(639),
    [anon_sym_int24] = ACTIONS(639),
    [anon_sym_int32] = ACTIONS(639),
    [anon_sym_int40] = ACTIONS(639),
    [anon_sym_int48] = ACTIONS(639),
    [anon_sym_int56] = ACTIONS(639),
    [anon_sym_int64] = ACTIONS(639),
    [anon_sym_int72] = ACTIONS(639),
    [anon_sym_int80] = ACTIONS(639),
    [anon_sym_int88] = ACTIONS(639),
    [anon_sym_int96] = ACTIONS(639),
    [anon_sym_int104] = ACTIONS(639),
    [anon_sym_int112] = ACTIONS(639),
    [anon_sym_int120] = ACTIONS(639),
    [anon_sym_int128] = ACTIONS(639),
    [anon_sym_int136] = ACTIONS(639),
    [anon_sym_int144] = ACTIONS(639),
    [anon_sym_int152] = ACTIONS(639),
    [anon_sym_int160] = ACTIONS(639),
    [anon_sym_int168] = ACTIONS(639),
    [anon_sym_int176] = ACTIONS(639),
    [anon_sym_int184] = ACTIONS(639),
    [anon_sym_int192] = ACTIONS(639),
    [anon_sym_int200] = ACTIONS(639),
    [anon_sym_int208] = ACTIONS(639),
    [anon_sym_int216] = ACTIONS(639),
    [anon_sym_int224] = ACTIONS(639),
    [anon_sym_int232] = ACTIONS(639),
    [anon_sym_int240] = ACTIONS(639),
    [anon_sym_int248] = ACTIONS(639),
    [anon_sym_int256] = ACTIONS(639),
    [anon_sym_uint] = ACTIONS(639),
    [anon_sym_uint8] = ACTIONS(639),
    [anon_sym_uint16] = ACTIONS(639),
    [anon_sym_uint24] = ACTIONS(639),
    [anon_sym_uint32] = ACTIONS(639),
    [anon_sym_uint40] = ACTIONS(639),
    [anon_sym_uint48] = ACTIONS(639),
    [anon_sym_uint56] = ACTIONS(639),
    [anon_sym_uint64] = ACTIONS(639),
    [anon_sym_uint72] = ACTIONS(639),
    [anon_sym_uint80] = ACTIONS(639),
    [anon_sym_uint88] = ACTIONS(639),
    [anon_sym_uint96] = ACTIONS(639),
    [anon_sym_uint104] = ACTIONS(639),
    [anon_sym_uint112] = ACTIONS(639),
    [anon_sym_uint120] = ACTIONS(639),
    [anon_sym_uint128] = ACTIONS(639),
    [anon_sym_uint136] = ACTIONS(639),
    [anon_sym_uint144] = ACTIONS(639),
    [anon_sym_uint152] = ACTIONS(639),
    [anon_sym_uint160] = ACTIONS(639),
    [anon_sym_uint168] = ACTIONS(639),
    [anon_sym_uint176] = ACTIONS(639),
    [anon_sym_uint184] = ACTIONS(639),
    [anon_sym_uint192] = ACTIONS(639),
    [anon_sym_uint200] = ACTIONS(639),
    [anon_sym_uint208] = ACTIONS(639),
    [anon_sym_uint216] = ACTIONS(639),
    [anon_sym_uint224] = ACTIONS(639),
    [anon_sym_uint232] = ACTIONS(639),
    [anon_sym_uint240] = ACTIONS(639),
    [anon_sym_uint248] = ACTIONS(639),
    [anon_sym_uint256] = ACTIONS(639),
    [anon_sym_bytes] = ACTIONS(639),
    [anon_sym_bytes1] = ACTIONS(639),
    [anon_sym_bytes2] = ACTIONS(639),
    [anon_sym_bytes3] = ACTIONS(639),
    [anon_sym_bytes4] = ACTIONS(639),
    [anon_sym_bytes5] = ACTIONS(639),
    [anon_sym_bytes6] = ACTIONS(639),
    [anon_sym_bytes7] = ACTIONS(639),
    [anon_sym_bytes8] = ACTIONS(639),
    [anon_sym_bytes9] = ACTIONS(639),
    [anon_sym_bytes10] = ACTIONS(639),
    [anon_sym_bytes11] = ACTIONS(639),
    [anon_sym_bytes12] = ACTIONS(639),
    [anon_sym_bytes13] = ACTIONS(639),
    [anon_sym_bytes14] = ACTIONS(639),
    [anon_sym_bytes15] = ACTIONS(639),
    [anon_sym_bytes16] = ACTIONS(639),
    [anon_sym_bytes17] = ACTIONS(639),
    [anon_sym_bytes18] = ACTIONS(639),
    [anon_sym_bytes19] = ACTIONS(639),
    [anon_sym_bytes20] = ACTIONS(639),
    [anon_sym_bytes21] = ACTIONS(639),
    [anon_sym_bytes22] = ACTIONS(639),
    [anon_sym_bytes23] = ACTIONS(639),
    [anon_sym_bytes24] = ACTIONS(639),
    [anon_sym_bytes25] = ACTIONS(639),
    [anon_sym_bytes26] = ACTIONS(639),
    [anon_sym_bytes27] = ACTIONS(639),
    [anon_sym_bytes28] = ACTIONS(639),
    [anon_sym_bytes29] = ACTIONS(639),
    [anon_sym_bytes30] = ACTIONS(639),
    [anon_sym_bytes31] = ACTIONS(639),
    [anon_sym_bytes32] = ACTIONS(639),
    [anon_sym_fixed] = ACTIONS(639),
    [aux_sym__fixed_token1] = ACTIONS(639),
    [anon_sym_ufixed] = ACTIONS(639),
    [aux_sym__ufixed_token1] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(641),
    [sym_identifier] = ACTIONS(643),
    [anon_sym_pragma] = ACTIONS(643),
    [anon_sym_import] = ACTIONS(643),
    [anon_sym_type] = ACTIONS(643),
    [anon_sym_abstract] = ACTIONS(643),
    [anon_sym_contract] = ACTIONS(643),
    [anon_sym_error] = ACTIONS(643),
    [anon_sym_interface] = ACTIONS(643),
    [anon_sym_library] = ACTIONS(643),
    [anon_sym_struct] = ACTIONS(643),
    [anon_sym_enum] = ACTIONS(643),
    [anon_sym_event] = ACTIONS(643),
    [anon_sym_function] = ACTIONS(643),
    [anon_sym_byte] = ACTIONS(643),
    [anon_sym_address] = ACTIONS(643),
    [anon_sym_var] = ACTIONS(643),
    [anon_sym_mapping] = ACTIONS(643),
    [anon_sym_bool] = ACTIONS(643),
    [anon_sym_string] = ACTIONS(643),
    [anon_sym_int] = ACTIONS(643),
    [anon_sym_int8] = ACTIONS(643),
    [anon_sym_int16] = ACTIONS(643),
    [anon_sym_int24] = ACTIONS(643),
    [anon_sym_int32] = ACTIONS(643),
    [anon_sym_int40] = ACTIONS(643),
    [anon_sym_int48] = ACTIONS(643),
    [anon_sym_int56] = ACTIONS(643),
    [anon_sym_int64] = ACTIONS(643),
    [anon_sym_int72] = ACTIONS(643),
    [anon_sym_int80] = ACTIONS(643),
    [anon_sym_int88] = ACTIONS(643),
    [anon_sym_int96] = ACTIONS(643),
    [anon_sym_int104] = ACTIONS(643),
    [anon_sym_int112] = ACTIONS(643),
    [anon_sym_int120] = ACTIONS(643),
    [anon_sym_int128] = ACTIONS(643),
    [anon_sym_int136] = ACTIONS(643),
    [anon_sym_int144] = ACTIONS(643),
    [anon_sym_int152] = ACTIONS(643),
    [anon_sym_int160] = ACTIONS(643),
    [anon_sym_int168] = ACTIONS(643),
    [anon_sym_int176] = ACTIONS(643),
    [anon_sym_int184] = ACTIONS(643),
    [anon_sym_int192] = ACTIONS(643),
    [anon_sym_int200] = ACTIONS(643),
    [anon_sym_int208] = ACTIONS(643),
    [anon_sym_int216] = ACTIONS(643),
    [anon_sym_int224] = ACTIONS(643),
    [anon_sym_int232] = ACTIONS(643),
    [anon_sym_int240] = ACTIONS(643),
    [anon_sym_int248] = ACTIONS(643),
    [anon_sym_int256] = ACTIONS(643),
    [anon_sym_uint] = ACTIONS(643),
    [anon_sym_uint8] = ACTIONS(643),
    [anon_sym_uint16] = ACTIONS(643),
    [anon_sym_uint24] = ACTIONS(643),
    [anon_sym_uint32] = ACTIONS(643),
    [anon_sym_uint40] = ACTIONS(643),
    [anon_sym_uint48] = ACTIONS(643),
    [anon_sym_uint56] = ACTIONS(643),
    [anon_sym_uint64] = ACTIONS(643),
    [anon_sym_uint72] = ACTIONS(643),
    [anon_sym_uint80] = ACTIONS(643),
    [anon_sym_uint88] = ACTIONS(643),
    [anon_sym_uint96] = ACTIONS(643),
    [anon_sym_uint104] = ACTIONS(643),
    [anon_sym_uint112] = ACTIONS(643),
    [anon_sym_uint120] = ACTIONS(643),
    [anon_sym_uint128] = ACTIONS(643),
    [anon_sym_uint136] = ACTIONS(643),
    [anon_sym_uint144] = ACTIONS(643),
    [anon_sym_uint152] = ACTIONS(643),
    [anon_sym_uint160] = ACTIONS(643),
    [anon_sym_uint168] = ACTIONS(643),
    [anon_sym_uint176] = ACTIONS(643),
    [anon_sym_uint184] = ACTIONS(643),
    [anon_sym_uint192] = ACTIONS(643),
    [anon_sym_uint200] = ACTIONS(643),
    [anon_sym_uint208] = ACTIONS(643),
    [anon_sym_uint216] = ACTIONS(643),
    [anon_sym_uint224] = ACTIONS(643),
    [anon_sym_uint232] = ACTIONS(643),
    [anon_sym_uint240] = ACTIONS(643),
    [anon_sym_uint248] = ACTIONS(643),
    [anon_sym_uint256] = ACTIONS(643),
    [anon_sym_bytes] = ACTIONS(643),
    [anon_sym_bytes1] = ACTIONS(643),
    [anon_sym_bytes2] = ACTIONS(643),
    [anon_sym_bytes3] = ACTIONS(643),
    [anon_sym_bytes4] = ACTIONS(643),
    [anon_sym_bytes5] = ACTIONS(643),
    [anon_sym_bytes6] = ACTIONS(643),
    [anon_sym_bytes7] = ACTIONS(643),
    [anon_sym_bytes8] = ACTIONS(643),
    [anon_sym_bytes9] = ACTIONS(643),
    [anon_sym_bytes10] = ACTIONS(643),
    [anon_sym_bytes11] = ACTIONS(643),
    [anon_sym_bytes12] = ACTIONS(643),
    [anon_sym_bytes13] = ACTIONS(643),
    [anon_sym_bytes14] = ACTIONS(643),
    [anon_sym_bytes15] = ACTIONS(643),
    [anon_sym_bytes16] = ACTIONS(643),
    [anon_sym_bytes17] = ACTIONS(643),
    [anon_sym_bytes18] = ACTIONS(643),
    [anon_sym_bytes19] = ACTIONS(643),
    [anon_sym_bytes20] = ACTIONS(643),
    [anon_sym_bytes21] = ACTIONS(643),
    [anon_sym_bytes22] = ACTIONS(643),
    [anon_sym_bytes23] = ACTIONS(643),
    [anon_sym_bytes24] = ACTIONS(643),
    [anon_sym_bytes25] = ACTIONS(643),
    [anon_sym_bytes26] = ACTIONS(643),
    [anon_sym_bytes27] = ACTIONS(643),
    [anon_sym_bytes28] = ACTIONS(643),
    [anon_sym_bytes29] = ACTIONS(643),
    [anon_sym_bytes30] = ACTIONS(643),
    [anon_sym_bytes31] = ACTIONS(643),
    [anon_sym_bytes32] = ACTIONS(643),
    [anon_sym_fixed] = ACTIONS(643),
    [aux_sym__fixed_token1] = ACTIONS(643),
    [anon_sym_ufixed] = ACTIONS(643),
    [aux_sym__ufixed_token1] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(645),
    [sym_identifier] = ACTIONS(647),
    [anon_sym_pragma] = ACTIONS(647),
    [anon_sym_import] = ACTIONS(647),
    [anon_sym_type] = ACTIONS(647),
    [anon_sym_abstract] = ACTIONS(647),
    [anon_sym_contract] = ACTIONS(647),
    [anon_sym_error] = ACTIONS(647),
    [anon_sym_interface] = ACTIONS(647),
    [anon_sym_library] = ACTIONS(647),
    [anon_sym_struct] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(647),
    [anon_sym_event] = ACTIONS(647),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_byte] = ACTIONS(647),
    [anon_sym_address] = ACTIONS(647),
    [anon_sym_var] = ACTIONS(647),
    [anon_sym_mapping] = ACTIONS(647),
    [anon_sym_bool] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_int8] = ACTIONS(647),
    [anon_sym_int16] = ACTIONS(647),
    [anon_sym_int24] = ACTIONS(647),
    [anon_sym_int32] = ACTIONS(647),
    [anon_sym_int40] = ACTIONS(647),
    [anon_sym_int48] = ACTIONS(647),
    [anon_sym_int56] = ACTIONS(647),
    [anon_sym_int64] = ACTIONS(647),
    [anon_sym_int72] = ACTIONS(647),
    [anon_sym_int80] = ACTIONS(647),
    [anon_sym_int88] = ACTIONS(647),
    [anon_sym_int96] = ACTIONS(647),
    [anon_sym_int104] = ACTIONS(647),
    [anon_sym_int112] = ACTIONS(647),
    [anon_sym_int120] = ACTIONS(647),
    [anon_sym_int128] = ACTIONS(647),
    [anon_sym_int136] = ACTIONS(647),
    [anon_sym_int144] = ACTIONS(647),
    [anon_sym_int152] = ACTIONS(647),
    [anon_sym_int160] = ACTIONS(647),
    [anon_sym_int168] = ACTIONS(647),
    [anon_sym_int176] = ACTIONS(647),
    [anon_sym_int184] = ACTIONS(647),
    [anon_sym_int192] = ACTIONS(647),
    [anon_sym_int200] = ACTIONS(647),
    [anon_sym_int208] = ACTIONS(647),
    [anon_sym_int216] = ACTIONS(647),
    [anon_sym_int224] = ACTIONS(647),
    [anon_sym_int232] = ACTIONS(647),
    [anon_sym_int240] = ACTIONS(647),
    [anon_sym_int248] = ACTIONS(647),
    [anon_sym_int256] = ACTIONS(647),
    [anon_sym_uint] = ACTIONS(647),
    [anon_sym_uint8] = ACTIONS(647),
    [anon_sym_uint16] = ACTIONS(647),
    [anon_sym_uint24] = ACTIONS(647),
    [anon_sym_uint32] = ACTIONS(647),
    [anon_sym_uint40] = ACTIONS(647),
    [anon_sym_uint48] = ACTIONS(647),
    [anon_sym_uint56] = ACTIONS(647),
    [anon_sym_uint64] = ACTIONS(647),
    [anon_sym_uint72] = ACTIONS(647),
    [anon_sym_uint80] = ACTIONS(647),
    [anon_sym_uint88] = ACTIONS(647),
    [anon_sym_uint96] = ACTIONS(647),
    [anon_sym_uint104] = ACTIONS(647),
    [anon_sym_uint112] = ACTIONS(647),
    [anon_sym_uint120] = ACTIONS(647),
    [anon_sym_uint128] = ACTIONS(647),
    [anon_sym_uint136] = ACTIONS(647),
    [anon_sym_uint144] = ACTIONS(647),
    [anon_sym_uint152] = ACTIONS(647),
    [anon_sym_uint160] = ACTIONS(647),
    [anon_sym_uint168] = ACTIONS(647),
    [anon_sym_uint176] = ACTIONS(647),
    [anon_sym_uint184] = ACTIONS(647),
    [anon_sym_uint192] = ACTIONS(647),
    [anon_sym_uint200] = ACTIONS(647),
    [anon_sym_uint208] = ACTIONS(647),
    [anon_sym_uint216] = ACTIONS(647),
    [anon_sym_uint224] = ACTIONS(647),
    [anon_sym_uint232] = ACTIONS(647),
    [anon_sym_uint240] = ACTIONS(647),
    [anon_sym_uint248] = ACTIONS(647),
    [anon_sym_uint256] = ACTIONS(647),
    [anon_sym_bytes] = ACTIONS(647),
    [anon_sym_bytes1] = ACTIONS(647),
    [anon_sym_bytes2] = ACTIONS(647),
    [anon_sym_bytes3] = ACTIONS(647),
    [anon_sym_bytes4] = ACTIONS(647),
    [anon_sym_bytes5] = ACTIONS(647),
    [anon_sym_bytes6] = ACTIONS(647),
    [anon_sym_bytes7] = ACTIONS(647),
    [anon_sym_bytes8] = ACTIONS(647),
    [anon_sym_bytes9] = ACTIONS(647),
    [anon_sym_bytes10] = ACTIONS(647),
    [anon_sym_bytes11] = ACTIONS(647),
    [anon_sym_bytes12] = ACTIONS(647),
    [anon_sym_bytes13] = ACTIONS(647),
    [anon_sym_bytes14] = ACTIONS(647),
    [anon_sym_bytes15] = ACTIONS(647),
    [anon_sym_bytes16] = ACTIONS(647),
    [anon_sym_bytes17] = ACTIONS(647),
    [anon_sym_bytes18] = ACTIONS(647),
    [anon_sym_bytes19] = ACTIONS(647),
    [anon_sym_bytes20] = ACTIONS(647),
    [anon_sym_bytes21] = ACTIONS(647),
    [anon_sym_bytes22] = ACTIONS(647),
    [anon_sym_bytes23] = ACTIONS(647),
    [anon_sym_bytes24] = ACTIONS(647),
    [anon_sym_bytes25] = ACTIONS(647),
    [anon_sym_bytes26] = ACTIONS(647),
    [anon_sym_bytes27] = ACTIONS(647),
    [anon_sym_bytes28] = ACTIONS(647),
    [anon_sym_bytes29] = ACTIONS(647),
    [anon_sym_bytes30] = ACTIONS(647),
    [anon_sym_bytes31] = ACTIONS(647),
    [anon_sym_bytes32] = ACTIONS(647),
    [anon_sym_fixed] = ACTIONS(647),
    [aux_sym__fixed_token1] = ACTIONS(647),
    [anon_sym_ufixed] = ACTIONS(647),
    [aux_sym__ufixed_token1] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [ts_builtin_sym_end] = ACTIONS(649),
    [sym_identifier] = ACTIONS(651),
    [anon_sym_pragma] = ACTIONS(651),
    [anon_sym_import] = ACTIONS(651),
    [anon_sym_type] = ACTIONS(651),
    [anon_sym_abstract] = ACTIONS(651),
    [anon_sym_contract] = ACTIONS(651),
    [anon_sym_error] = ACTIONS(651),
    [anon_sym_interface] = ACTIONS(651),
    [anon_sym_library] = ACTIONS(651),
    [anon_sym_struct] = ACTIONS(651),
    [anon_sym_enum] = ACTIONS(651),
    [anon_sym_event] = ACTIONS(651),
    [anon_sym_function] = ACTIONS(651),
    [anon_sym_byte] = ACTIONS(651),
    [anon_sym_address] = ACTIONS(651),
    [anon_sym_var] = ACTIONS(651),
    [anon_sym_mapping] = ACTIONS(651),
    [anon_sym_bool] = ACTIONS(651),
    [anon_sym_string] = ACTIONS(651),
    [anon_sym_int] = ACTIONS(651),
    [anon_sym_int8] = ACTIONS(651),
    [anon_sym_int16] = ACTIONS(651),
    [anon_sym_int24] = ACTIONS(651),
    [anon_sym_int32] = ACTIONS(651),
    [anon_sym_int40] = ACTIONS(651),
    [anon_sym_int48] = ACTIONS(651),
    [anon_sym_int56] = ACTIONS(651),
    [anon_sym_int64] = ACTIONS(651),
    [anon_sym_int72] = ACTIONS(651),
    [anon_sym_int80] = ACTIONS(651),
    [anon_sym_int88] = ACTIONS(651),
    [anon_sym_int96] = ACTIONS(651),
    [anon_sym_int104] = ACTIONS(651),
    [anon_sym_int112] = ACTIONS(651),
    [anon_sym_int120] = ACTIONS(651),
    [anon_sym_int128] = ACTIONS(651),
    [anon_sym_int136] = ACTIONS(651),
    [anon_sym_int144] = ACTIONS(651),
    [anon_sym_int152] = ACTIONS(651),
    [anon_sym_int160] = ACTIONS(651),
    [anon_sym_int168] = ACTIONS(651),
    [anon_sym_int176] = ACTIONS(651),
    [anon_sym_int184] = ACTIONS(651),
    [anon_sym_int192] = ACTIONS(651),
    [anon_sym_int200] = ACTIONS(651),
    [anon_sym_int208] = ACTIONS(651),
    [anon_sym_int216] = ACTIONS(651),
    [anon_sym_int224] = ACTIONS(651),
    [anon_sym_int232] = ACTIONS(651),
    [anon_sym_int240] = ACTIONS(651),
    [anon_sym_int248] = ACTIONS(651),
    [anon_sym_int256] = ACTIONS(651),
    [anon_sym_uint] = ACTIONS(651),
    [anon_sym_uint8] = ACTIONS(651),
    [anon_sym_uint16] = ACTIONS(651),
    [anon_sym_uint24] = ACTIONS(651),
    [anon_sym_uint32] = ACTIONS(651),
    [anon_sym_uint40] = ACTIONS(651),
    [anon_sym_uint48] = ACTIONS(651),
    [anon_sym_uint56] = ACTIONS(651),
    [anon_sym_uint64] = ACTIONS(651),
    [anon_sym_uint72] = ACTIONS(651),
    [anon_sym_uint80] = ACTIONS(651),
    [anon_sym_uint88] = ACTIONS(651),
    [anon_sym_uint96] = ACTIONS(651),
    [anon_sym_uint104] = ACTIONS(651),
    [anon_sym_uint112] = ACTIONS(651),
    [anon_sym_uint120] = ACTIONS(651),
    [anon_sym_uint128] = ACTIONS(651),
    [anon_sym_uint136] = ACTIONS(651),
    [anon_sym_uint144] = ACTIONS(651),
    [anon_sym_uint152] = ACTIONS(651),
    [anon_sym_uint160] = ACTIONS(651),
    [anon_sym_uint168] = ACTIONS(651),
    [anon_sym_uint176] = ACTIONS(651),
    [anon_sym_uint184] = ACTIONS(651),
    [anon_sym_uint192] = ACTIONS(651),
    [anon_sym_uint200] = ACTIONS(651),
    [anon_sym_uint208] = ACTIONS(651),
    [anon_sym_uint216] = ACTIONS(651),
    [anon_sym_uint224] = ACTIONS(651),
    [anon_sym_uint232] = ACTIONS(651),
    [anon_sym_uint240] = ACTIONS(651),
    [anon_sym_uint248] = ACTIONS(651),
    [anon_sym_uint256] = ACTIONS(651),
    [anon_sym_bytes] = ACTIONS(651),
    [anon_sym_bytes1] = ACTIONS(651),
    [anon_sym_bytes2] = ACTIONS(651),
    [anon_sym_bytes3] = ACTIONS(651),
    [anon_sym_bytes4] = ACTIONS(651),
    [anon_sym_bytes5] = ACTIONS(651),
    [anon_sym_bytes6] = ACTIONS(651),
    [anon_sym_bytes7] = ACTIONS(651),
    [anon_sym_bytes8] = ACTIONS(651),
    [anon_sym_bytes9] = ACTIONS(651),
    [anon_sym_bytes10] = ACTIONS(651),
    [anon_sym_bytes11] = ACTIONS(651),
    [anon_sym_bytes12] = ACTIONS(651),
    [anon_sym_bytes13] = ACTIONS(651),
    [anon_sym_bytes14] = ACTIONS(651),
    [anon_sym_bytes15] = ACTIONS(651),
    [anon_sym_bytes16] = ACTIONS(651),
    [anon_sym_bytes17] = ACTIONS(651),
    [anon_sym_bytes18] = ACTIONS(651),
    [anon_sym_bytes19] = ACTIONS(651),
    [anon_sym_bytes20] = ACTIONS(651),
    [anon_sym_bytes21] = ACTIONS(651),
    [anon_sym_bytes22] = ACTIONS(651),
    [anon_sym_bytes23] = ACTIONS(651),
    [anon_sym_bytes24] = ACTIONS(651),
    [anon_sym_bytes25] = ACTIONS(651),
    [anon_sym_bytes26] = ACTIONS(651),
    [anon_sym_bytes27] = ACTIONS(651),
    [anon_sym_bytes28] = ACTIONS(651),
    [anon_sym_bytes29] = ACTIONS(651),
    [anon_sym_bytes30] = ACTIONS(651),
    [anon_sym_bytes31] = ACTIONS(651),
    [anon_sym_bytes32] = ACTIONS(651),
    [anon_sym_fixed] = ACTIONS(651),
    [aux_sym__fixed_token1] = ACTIONS(651),
    [anon_sym_ufixed] = ACTIONS(651),
    [aux_sym__ufixed_token1] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(653),
    [sym_identifier] = ACTIONS(655),
    [anon_sym_pragma] = ACTIONS(655),
    [anon_sym_import] = ACTIONS(655),
    [anon_sym_type] = ACTIONS(655),
    [anon_sym_abstract] = ACTIONS(655),
    [anon_sym_contract] = ACTIONS(655),
    [anon_sym_error] = ACTIONS(655),
    [anon_sym_interface] = ACTIONS(655),
    [anon_sym_library] = ACTIONS(655),
    [anon_sym_struct] = ACTIONS(655),
    [anon_sym_enum] = ACTIONS(655),
    [anon_sym_event] = ACTIONS(655),
    [anon_sym_function] = ACTIONS(655),
    [anon_sym_byte] = ACTIONS(655),
    [anon_sym_address] = ACTIONS(655),
    [anon_sym_var] = ACTIONS(655),
    [anon_sym_mapping] = ACTIONS(655),
    [anon_sym_bool] = ACTIONS(655),
    [anon_sym_string] = ACTIONS(655),
    [anon_sym_int] = ACTIONS(655),
    [anon_sym_int8] = ACTIONS(655),
    [anon_sym_int16] = ACTIONS(655),
    [anon_sym_int24] = ACTIONS(655),
    [anon_sym_int32] = ACTIONS(655),
    [anon_sym_int40] = ACTIONS(655),
    [anon_sym_int48] = ACTIONS(655),
    [anon_sym_int56] = ACTIONS(655),
    [anon_sym_int64] = ACTIONS(655),
    [anon_sym_int72] = ACTIONS(655),
    [anon_sym_int80] = ACTIONS(655),
    [anon_sym_int88] = ACTIONS(655),
    [anon_sym_int96] = ACTIONS(655),
    [anon_sym_int104] = ACTIONS(655),
    [anon_sym_int112] = ACTIONS(655),
    [anon_sym_int120] = ACTIONS(655),
    [anon_sym_int128] = ACTIONS(655),
    [anon_sym_int136] = ACTIONS(655),
    [anon_sym_int144] = ACTIONS(655),
    [anon_sym_int152] = ACTIONS(655),
    [anon_sym_int160] = ACTIONS(655),
    [anon_sym_int168] = ACTIONS(655),
    [anon_sym_int176] = ACTIONS(655),
    [anon_sym_int184] = ACTIONS(655),
    [anon_sym_int192] = ACTIONS(655),
    [anon_sym_int200] = ACTIONS(655),
    [anon_sym_int208] = ACTIONS(655),
    [anon_sym_int216] = ACTIONS(655),
    [anon_sym_int224] = ACTIONS(655),
    [anon_sym_int232] = ACTIONS(655),
    [anon_sym_int240] = ACTIONS(655),
    [anon_sym_int248] = ACTIONS(655),
    [anon_sym_int256] = ACTIONS(655),
    [anon_sym_uint] = ACTIONS(655),
    [anon_sym_uint8] = ACTIONS(655),
    [anon_sym_uint16] = ACTIONS(655),
    [anon_sym_uint24] = ACTIONS(655),
    [anon_sym_uint32] = ACTIONS(655),
    [anon_sym_uint40] = ACTIONS(655),
    [anon_sym_uint48] = ACTIONS(655),
    [anon_sym_uint56] = ACTIONS(655),
    [anon_sym_uint64] = ACTIONS(655),
    [anon_sym_uint72] = ACTIONS(655),
    [anon_sym_uint80] = ACTIONS(655),
    [anon_sym_uint88] = ACTIONS(655),
    [anon_sym_uint96] = ACTIONS(655),
    [anon_sym_uint104] = ACTIONS(655),
    [anon_sym_uint112] = ACTIONS(655),
    [anon_sym_uint120] = ACTIONS(655),
    [anon_sym_uint128] = ACTIONS(655),
    [anon_sym_uint136] = ACTIONS(655),
    [anon_sym_uint144] = ACTIONS(655),
    [anon_sym_uint152] = ACTIONS(655),
    [anon_sym_uint160] = ACTIONS(655),
    [anon_sym_uint168] = ACTIONS(655),
    [anon_sym_uint176] = ACTIONS(655),
    [anon_sym_uint184] = ACTIONS(655),
    [anon_sym_uint192] = ACTIONS(655),
    [anon_sym_uint200] = ACTIONS(655),
    [anon_sym_uint208] = ACTIONS(655),
    [anon_sym_uint216] = ACTIONS(655),
    [anon_sym_uint224] = ACTIONS(655),
    [anon_sym_uint232] = ACTIONS(655),
    [anon_sym_uint240] = ACTIONS(655),
    [anon_sym_uint248] = ACTIONS(655),
    [anon_sym_uint256] = ACTIONS(655),
    [anon_sym_bytes] = ACTIONS(655),
    [anon_sym_bytes1] = ACTIONS(655),
    [anon_sym_bytes2] = ACTIONS(655),
    [anon_sym_bytes3] = ACTIONS(655),
    [anon_sym_bytes4] = ACTIONS(655),
    [anon_sym_bytes5] = ACTIONS(655),
    [anon_sym_bytes6] = ACTIONS(655),
    [anon_sym_bytes7] = ACTIONS(655),
    [anon_sym_bytes8] = ACTIONS(655),
    [anon_sym_bytes9] = ACTIONS(655),
    [anon_sym_bytes10] = ACTIONS(655),
    [anon_sym_bytes11] = ACTIONS(655),
    [anon_sym_bytes12] = ACTIONS(655),
    [anon_sym_bytes13] = ACTIONS(655),
    [anon_sym_bytes14] = ACTIONS(655),
    [anon_sym_bytes15] = ACTIONS(655),
    [anon_sym_bytes16] = ACTIONS(655),
    [anon_sym_bytes17] = ACTIONS(655),
    [anon_sym_bytes18] = ACTIONS(655),
    [anon_sym_bytes19] = ACTIONS(655),
    [anon_sym_bytes20] = ACTIONS(655),
    [anon_sym_bytes21] = ACTIONS(655),
    [anon_sym_bytes22] = ACTIONS(655),
    [anon_sym_bytes23] = ACTIONS(655),
    [anon_sym_bytes24] = ACTIONS(655),
    [anon_sym_bytes25] = ACTIONS(655),
    [anon_sym_bytes26] = ACTIONS(655),
    [anon_sym_bytes27] = ACTIONS(655),
    [anon_sym_bytes28] = ACTIONS(655),
    [anon_sym_bytes29] = ACTIONS(655),
    [anon_sym_bytes30] = ACTIONS(655),
    [anon_sym_bytes31] = ACTIONS(655),
    [anon_sym_bytes32] = ACTIONS(655),
    [anon_sym_fixed] = ACTIONS(655),
    [aux_sym__fixed_token1] = ACTIONS(655),
    [anon_sym_ufixed] = ACTIONS(655),
    [aux_sym__ufixed_token1] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(657),
    [sym_identifier] = ACTIONS(659),
    [anon_sym_pragma] = ACTIONS(659),
    [anon_sym_import] = ACTIONS(659),
    [anon_sym_type] = ACTIONS(659),
    [anon_sym_abstract] = ACTIONS(659),
    [anon_sym_contract] = ACTIONS(659),
    [anon_sym_error] = ACTIONS(659),
    [anon_sym_interface] = ACTIONS(659),
    [anon_sym_library] = ACTIONS(659),
    [anon_sym_struct] = ACTIONS(659),
    [anon_sym_enum] = ACTIONS(659),
    [anon_sym_event] = ACTIONS(659),
    [anon_sym_function] = ACTIONS(659),
    [anon_sym_byte] = ACTIONS(659),
    [anon_sym_address] = ACTIONS(659),
    [anon_sym_var] = ACTIONS(659),
    [anon_sym_mapping] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_string] = ACTIONS(659),
    [anon_sym_int] = ACTIONS(659),
    [anon_sym_int8] = ACTIONS(659),
    [anon_sym_int16] = ACTIONS(659),
    [anon_sym_int24] = ACTIONS(659),
    [anon_sym_int32] = ACTIONS(659),
    [anon_sym_int40] = ACTIONS(659),
    [anon_sym_int48] = ACTIONS(659),
    [anon_sym_int56] = ACTIONS(659),
    [anon_sym_int64] = ACTIONS(659),
    [anon_sym_int72] = ACTIONS(659),
    [anon_sym_int80] = ACTIONS(659),
    [anon_sym_int88] = ACTIONS(659),
    [anon_sym_int96] = ACTIONS(659),
    [anon_sym_int104] = ACTIONS(659),
    [anon_sym_int112] = ACTIONS(659),
    [anon_sym_int120] = ACTIONS(659),
    [anon_sym_int128] = ACTIONS(659),
    [anon_sym_int136] = ACTIONS(659),
    [anon_sym_int144] = ACTIONS(659),
    [anon_sym_int152] = ACTIONS(659),
    [anon_sym_int160] = ACTIONS(659),
    [anon_sym_int168] = ACTIONS(659),
    [anon_sym_int176] = ACTIONS(659),
    [anon_sym_int184] = ACTIONS(659),
    [anon_sym_int192] = ACTIONS(659),
    [anon_sym_int200] = ACTIONS(659),
    [anon_sym_int208] = ACTIONS(659),
    [anon_sym_int216] = ACTIONS(659),
    [anon_sym_int224] = ACTIONS(659),
    [anon_sym_int232] = ACTIONS(659),
    [anon_sym_int240] = ACTIONS(659),
    [anon_sym_int248] = ACTIONS(659),
    [anon_sym_int256] = ACTIONS(659),
    [anon_sym_uint] = ACTIONS(659),
    [anon_sym_uint8] = ACTIONS(659),
    [anon_sym_uint16] = ACTIONS(659),
    [anon_sym_uint24] = ACTIONS(659),
    [anon_sym_uint32] = ACTIONS(659),
    [anon_sym_uint40] = ACTIONS(659),
    [anon_sym_uint48] = ACTIONS(659),
    [anon_sym_uint56] = ACTIONS(659),
    [anon_sym_uint64] = ACTIONS(659),
    [anon_sym_uint72] = ACTIONS(659),
    [anon_sym_uint80] = ACTIONS(659),
    [anon_sym_uint88] = ACTIONS(659),
    [anon_sym_uint96] = ACTIONS(659),
    [anon_sym_uint104] = ACTIONS(659),
    [anon_sym_uint112] = ACTIONS(659),
    [anon_sym_uint120] = ACTIONS(659),
    [anon_sym_uint128] = ACTIONS(659),
    [anon_sym_uint136] = ACTIONS(659),
    [anon_sym_uint144] = ACTIONS(659),
    [anon_sym_uint152] = ACTIONS(659),
    [anon_sym_uint160] = ACTIONS(659),
    [anon_sym_uint168] = ACTIONS(659),
    [anon_sym_uint176] = ACTIONS(659),
    [anon_sym_uint184] = ACTIONS(659),
    [anon_sym_uint192] = ACTIONS(659),
    [anon_sym_uint200] = ACTIONS(659),
    [anon_sym_uint208] = ACTIONS(659),
    [anon_sym_uint216] = ACTIONS(659),
    [anon_sym_uint224] = ACTIONS(659),
    [anon_sym_uint232] = ACTIONS(659),
    [anon_sym_uint240] = ACTIONS(659),
    [anon_sym_uint248] = ACTIONS(659),
    [anon_sym_uint256] = ACTIONS(659),
    [anon_sym_bytes] = ACTIONS(659),
    [anon_sym_bytes1] = ACTIONS(659),
    [anon_sym_bytes2] = ACTIONS(659),
    [anon_sym_bytes3] = ACTIONS(659),
    [anon_sym_bytes4] = ACTIONS(659),
    [anon_sym_bytes5] = ACTIONS(659),
    [anon_sym_bytes6] = ACTIONS(659),
    [anon_sym_bytes7] = ACTIONS(659),
    [anon_sym_bytes8] = ACTIONS(659),
    [anon_sym_bytes9] = ACTIONS(659),
    [anon_sym_bytes10] = ACTIONS(659),
    [anon_sym_bytes11] = ACTIONS(659),
    [anon_sym_bytes12] = ACTIONS(659),
    [anon_sym_bytes13] = ACTIONS(659),
    [anon_sym_bytes14] = ACTIONS(659),
    [anon_sym_bytes15] = ACTIONS(659),
    [anon_sym_bytes16] = ACTIONS(659),
    [anon_sym_bytes17] = ACTIONS(659),
    [anon_sym_bytes18] = ACTIONS(659),
    [anon_sym_bytes19] = ACTIONS(659),
    [anon_sym_bytes20] = ACTIONS(659),
    [anon_sym_bytes21] = ACTIONS(659),
    [anon_sym_bytes22] = ACTIONS(659),
    [anon_sym_bytes23] = ACTIONS(659),
    [anon_sym_bytes24] = ACTIONS(659),
    [anon_sym_bytes25] = ACTIONS(659),
    [anon_sym_bytes26] = ACTIONS(659),
    [anon_sym_bytes27] = ACTIONS(659),
    [anon_sym_bytes28] = ACTIONS(659),
    [anon_sym_bytes29] = ACTIONS(659),
    [anon_sym_bytes30] = ACTIONS(659),
    [anon_sym_bytes31] = ACTIONS(659),
    [anon_sym_bytes32] = ACTIONS(659),
    [anon_sym_fixed] = ACTIONS(659),
    [aux_sym__fixed_token1] = ACTIONS(659),
    [anon_sym_ufixed] = ACTIONS(659),
    [aux_sym__ufixed_token1] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(661),
    [sym_identifier] = ACTIONS(663),
    [anon_sym_pragma] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(663),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_abstract] = ACTIONS(663),
    [anon_sym_contract] = ACTIONS(663),
    [anon_sym_error] = ACTIONS(663),
    [anon_sym_interface] = ACTIONS(663),
    [anon_sym_library] = ACTIONS(663),
    [anon_sym_struct] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(663),
    [anon_sym_event] = ACTIONS(663),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_byte] = ACTIONS(663),
    [anon_sym_address] = ACTIONS(663),
    [anon_sym_var] = ACTIONS(663),
    [anon_sym_mapping] = ACTIONS(663),
    [anon_sym_bool] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_int] = ACTIONS(663),
    [anon_sym_int8] = ACTIONS(663),
    [anon_sym_int16] = ACTIONS(663),
    [anon_sym_int24] = ACTIONS(663),
    [anon_sym_int32] = ACTIONS(663),
    [anon_sym_int40] = ACTIONS(663),
    [anon_sym_int48] = ACTIONS(663),
    [anon_sym_int56] = ACTIONS(663),
    [anon_sym_int64] = ACTIONS(663),
    [anon_sym_int72] = ACTIONS(663),
    [anon_sym_int80] = ACTIONS(663),
    [anon_sym_int88] = ACTIONS(663),
    [anon_sym_int96] = ACTIONS(663),
    [anon_sym_int104] = ACTIONS(663),
    [anon_sym_int112] = ACTIONS(663),
    [anon_sym_int120] = ACTIONS(663),
    [anon_sym_int128] = ACTIONS(663),
    [anon_sym_int136] = ACTIONS(663),
    [anon_sym_int144] = ACTIONS(663),
    [anon_sym_int152] = ACTIONS(663),
    [anon_sym_int160] = ACTIONS(663),
    [anon_sym_int168] = ACTIONS(663),
    [anon_sym_int176] = ACTIONS(663),
    [anon_sym_int184] = ACTIONS(663),
    [anon_sym_int192] = ACTIONS(663),
    [anon_sym_int200] = ACTIONS(663),
    [anon_sym_int208] = ACTIONS(663),
    [anon_sym_int216] = ACTIONS(663),
    [anon_sym_int224] = ACTIONS(663),
    [anon_sym_int232] = ACTIONS(663),
    [anon_sym_int240] = ACTIONS(663),
    [anon_sym_int248] = ACTIONS(663),
    [anon_sym_int256] = ACTIONS(663),
    [anon_sym_uint] = ACTIONS(663),
    [anon_sym_uint8] = ACTIONS(663),
    [anon_sym_uint16] = ACTIONS(663),
    [anon_sym_uint24] = ACTIONS(663),
    [anon_sym_uint32] = ACTIONS(663),
    [anon_sym_uint40] = ACTIONS(663),
    [anon_sym_uint48] = ACTIONS(663),
    [anon_sym_uint56] = ACTIONS(663),
    [anon_sym_uint64] = ACTIONS(663),
    [anon_sym_uint72] = ACTIONS(663),
    [anon_sym_uint80] = ACTIONS(663),
    [anon_sym_uint88] = ACTIONS(663),
    [anon_sym_uint96] = ACTIONS(663),
    [anon_sym_uint104] = ACTIONS(663),
    [anon_sym_uint112] = ACTIONS(663),
    [anon_sym_uint120] = ACTIONS(663),
    [anon_sym_uint128] = ACTIONS(663),
    [anon_sym_uint136] = ACTIONS(663),
    [anon_sym_uint144] = ACTIONS(663),
    [anon_sym_uint152] = ACTIONS(663),
    [anon_sym_uint160] = ACTIONS(663),
    [anon_sym_uint168] = ACTIONS(663),
    [anon_sym_uint176] = ACTIONS(663),
    [anon_sym_uint184] = ACTIONS(663),
    [anon_sym_uint192] = ACTIONS(663),
    [anon_sym_uint200] = ACTIONS(663),
    [anon_sym_uint208] = ACTIONS(663),
    [anon_sym_uint216] = ACTIONS(663),
    [anon_sym_uint224] = ACTIONS(663),
    [anon_sym_uint232] = ACTIONS(663),
    [anon_sym_uint240] = ACTIONS(663),
    [anon_sym_uint248] = ACTIONS(663),
    [anon_sym_uint256] = ACTIONS(663),
    [anon_sym_bytes] = ACTIONS(663),
    [anon_sym_bytes1] = ACTIONS(663),
    [anon_sym_bytes2] = ACTIONS(663),
    [anon_sym_bytes3] = ACTIONS(663),
    [anon_sym_bytes4] = ACTIONS(663),
    [anon_sym_bytes5] = ACTIONS(663),
    [anon_sym_bytes6] = ACTIONS(663),
    [anon_sym_bytes7] = ACTIONS(663),
    [anon_sym_bytes8] = ACTIONS(663),
    [anon_sym_bytes9] = ACTIONS(663),
    [anon_sym_bytes10] = ACTIONS(663),
    [anon_sym_bytes11] = ACTIONS(663),
    [anon_sym_bytes12] = ACTIONS(663),
    [anon_sym_bytes13] = ACTIONS(663),
    [anon_sym_bytes14] = ACTIONS(663),
    [anon_sym_bytes15] = ACTIONS(663),
    [anon_sym_bytes16] = ACTIONS(663),
    [anon_sym_bytes17] = ACTIONS(663),
    [anon_sym_bytes18] = ACTIONS(663),
    [anon_sym_bytes19] = ACTIONS(663),
    [anon_sym_bytes20] = ACTIONS(663),
    [anon_sym_bytes21] = ACTIONS(663),
    [anon_sym_bytes22] = ACTIONS(663),
    [anon_sym_bytes23] = ACTIONS(663),
    [anon_sym_bytes24] = ACTIONS(663),
    [anon_sym_bytes25] = ACTIONS(663),
    [anon_sym_bytes26] = ACTIONS(663),
    [anon_sym_bytes27] = ACTIONS(663),
    [anon_sym_bytes28] = ACTIONS(663),
    [anon_sym_bytes29] = ACTIONS(663),
    [anon_sym_bytes30] = ACTIONS(663),
    [anon_sym_bytes31] = ACTIONS(663),
    [anon_sym_bytes32] = ACTIONS(663),
    [anon_sym_fixed] = ACTIONS(663),
    [aux_sym__fixed_token1] = ACTIONS(663),
    [anon_sym_ufixed] = ACTIONS(663),
    [aux_sym__ufixed_token1] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(665),
    [sym_identifier] = ACTIONS(667),
    [anon_sym_pragma] = ACTIONS(667),
    [anon_sym_import] = ACTIONS(667),
    [anon_sym_type] = ACTIONS(667),
    [anon_sym_abstract] = ACTIONS(667),
    [anon_sym_contract] = ACTIONS(667),
    [anon_sym_error] = ACTIONS(667),
    [anon_sym_interface] = ACTIONS(667),
    [anon_sym_library] = ACTIONS(667),
    [anon_sym_struct] = ACTIONS(667),
    [anon_sym_enum] = ACTIONS(667),
    [anon_sym_event] = ACTIONS(667),
    [anon_sym_function] = ACTIONS(667),
    [anon_sym_byte] = ACTIONS(667),
    [anon_sym_address] = ACTIONS(667),
    [anon_sym_var] = ACTIONS(667),
    [anon_sym_mapping] = ACTIONS(667),
    [anon_sym_bool] = ACTIONS(667),
    [anon_sym_string] = ACTIONS(667),
    [anon_sym_int] = ACTIONS(667),
    [anon_sym_int8] = ACTIONS(667),
    [anon_sym_int16] = ACTIONS(667),
    [anon_sym_int24] = ACTIONS(667),
    [anon_sym_int32] = ACTIONS(667),
    [anon_sym_int40] = ACTIONS(667),
    [anon_sym_int48] = ACTIONS(667),
    [anon_sym_int56] = ACTIONS(667),
    [anon_sym_int64] = ACTIONS(667),
    [anon_sym_int72] = ACTIONS(667),
    [anon_sym_int80] = ACTIONS(667),
    [anon_sym_int88] = ACTIONS(667),
    [anon_sym_int96] = ACTIONS(667),
    [anon_sym_int104] = ACTIONS(667),
    [anon_sym_int112] = ACTIONS(667),
    [anon_sym_int120] = ACTIONS(667),
    [anon_sym_int128] = ACTIONS(667),
    [anon_sym_int136] = ACTIONS(667),
    [anon_sym_int144] = ACTIONS(667),
    [anon_sym_int152] = ACTIONS(667),
    [anon_sym_int160] = ACTIONS(667),
    [anon_sym_int168] = ACTIONS(667),
    [anon_sym_int176] = ACTIONS(667),
    [anon_sym_int184] = ACTIONS(667),
    [anon_sym_int192] = ACTIONS(667),
    [anon_sym_int200] = ACTIONS(667),
    [anon_sym_int208] = ACTIONS(667),
    [anon_sym_int216] = ACTIONS(667),
    [anon_sym_int224] = ACTIONS(667),
    [anon_sym_int232] = ACTIONS(667),
    [anon_sym_int240] = ACTIONS(667),
    [anon_sym_int248] = ACTIONS(667),
    [anon_sym_int256] = ACTIONS(667),
    [anon_sym_uint] = ACTIONS(667),
    [anon_sym_uint8] = ACTIONS(667),
    [anon_sym_uint16] = ACTIONS(667),
    [anon_sym_uint24] = ACTIONS(667),
    [anon_sym_uint32] = ACTIONS(667),
    [anon_sym_uint40] = ACTIONS(667),
    [anon_sym_uint48] = ACTIONS(667),
    [anon_sym_uint56] = ACTIONS(667),
    [anon_sym_uint64] = ACTIONS(667),
    [anon_sym_uint72] = ACTIONS(667),
    [anon_sym_uint80] = ACTIONS(667),
    [anon_sym_uint88] = ACTIONS(667),
    [anon_sym_uint96] = ACTIONS(667),
    [anon_sym_uint104] = ACTIONS(667),
    [anon_sym_uint112] = ACTIONS(667),
    [anon_sym_uint120] = ACTIONS(667),
    [anon_sym_uint128] = ACTIONS(667),
    [anon_sym_uint136] = ACTIONS(667),
    [anon_sym_uint144] = ACTIONS(667),
    [anon_sym_uint152] = ACTIONS(667),
    [anon_sym_uint160] = ACTIONS(667),
    [anon_sym_uint168] = ACTIONS(667),
    [anon_sym_uint176] = ACTIONS(667),
    [anon_sym_uint184] = ACTIONS(667),
    [anon_sym_uint192] = ACTIONS(667),
    [anon_sym_uint200] = ACTIONS(667),
    [anon_sym_uint208] = ACTIONS(667),
    [anon_sym_uint216] = ACTIONS(667),
    [anon_sym_uint224] = ACTIONS(667),
    [anon_sym_uint232] = ACTIONS(667),
    [anon_sym_uint240] = ACTIONS(667),
    [anon_sym_uint248] = ACTIONS(667),
    [anon_sym_uint256] = ACTIONS(667),
    [anon_sym_bytes] = ACTIONS(667),
    [anon_sym_bytes1] = ACTIONS(667),
    [anon_sym_bytes2] = ACTIONS(667),
    [anon_sym_bytes3] = ACTIONS(667),
    [anon_sym_bytes4] = ACTIONS(667),
    [anon_sym_bytes5] = ACTIONS(667),
    [anon_sym_bytes6] = ACTIONS(667),
    [anon_sym_bytes7] = ACTIONS(667),
    [anon_sym_bytes8] = ACTIONS(667),
    [anon_sym_bytes9] = ACTIONS(667),
    [anon_sym_bytes10] = ACTIONS(667),
    [anon_sym_bytes11] = ACTIONS(667),
    [anon_sym_bytes12] = ACTIONS(667),
    [anon_sym_bytes13] = ACTIONS(667),
    [anon_sym_bytes14] = ACTIONS(667),
    [anon_sym_bytes15] = ACTIONS(667),
    [anon_sym_bytes16] = ACTIONS(667),
    [anon_sym_bytes17] = ACTIONS(667),
    [anon_sym_bytes18] = ACTIONS(667),
    [anon_sym_bytes19] = ACTIONS(667),
    [anon_sym_bytes20] = ACTIONS(667),
    [anon_sym_bytes21] = ACTIONS(667),
    [anon_sym_bytes22] = ACTIONS(667),
    [anon_sym_bytes23] = ACTIONS(667),
    [anon_sym_bytes24] = ACTIONS(667),
    [anon_sym_bytes25] = ACTIONS(667),
    [anon_sym_bytes26] = ACTIONS(667),
    [anon_sym_bytes27] = ACTIONS(667),
    [anon_sym_bytes28] = ACTIONS(667),
    [anon_sym_bytes29] = ACTIONS(667),
    [anon_sym_bytes30] = ACTIONS(667),
    [anon_sym_bytes31] = ACTIONS(667),
    [anon_sym_bytes32] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(667),
    [aux_sym__fixed_token1] = ACTIONS(667),
    [anon_sym_ufixed] = ACTIONS(667),
    [aux_sym__ufixed_token1] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(669),
    [sym_identifier] = ACTIONS(671),
    [anon_sym_pragma] = ACTIONS(671),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_abstract] = ACTIONS(671),
    [anon_sym_contract] = ACTIONS(671),
    [anon_sym_error] = ACTIONS(671),
    [anon_sym_interface] = ACTIONS(671),
    [anon_sym_library] = ACTIONS(671),
    [anon_sym_struct] = ACTIONS(671),
    [anon_sym_enum] = ACTIONS(671),
    [anon_sym_event] = ACTIONS(671),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_byte] = ACTIONS(671),
    [anon_sym_address] = ACTIONS(671),
    [anon_sym_var] = ACTIONS(671),
    [anon_sym_mapping] = ACTIONS(671),
    [anon_sym_bool] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_int] = ACTIONS(671),
    [anon_sym_int8] = ACTIONS(671),
    [anon_sym_int16] = ACTIONS(671),
    [anon_sym_int24] = ACTIONS(671),
    [anon_sym_int32] = ACTIONS(671),
    [anon_sym_int40] = ACTIONS(671),
    [anon_sym_int48] = ACTIONS(671),
    [anon_sym_int56] = ACTIONS(671),
    [anon_sym_int64] = ACTIONS(671),
    [anon_sym_int72] = ACTIONS(671),
    [anon_sym_int80] = ACTIONS(671),
    [anon_sym_int88] = ACTIONS(671),
    [anon_sym_int96] = ACTIONS(671),
    [anon_sym_int104] = ACTIONS(671),
    [anon_sym_int112] = ACTIONS(671),
    [anon_sym_int120] = ACTIONS(671),
    [anon_sym_int128] = ACTIONS(671),
    [anon_sym_int136] = ACTIONS(671),
    [anon_sym_int144] = ACTIONS(671),
    [anon_sym_int152] = ACTIONS(671),
    [anon_sym_int160] = ACTIONS(671),
    [anon_sym_int168] = ACTIONS(671),
    [anon_sym_int176] = ACTIONS(671),
    [anon_sym_int184] = ACTIONS(671),
    [anon_sym_int192] = ACTIONS(671),
    [anon_sym_int200] = ACTIONS(671),
    [anon_sym_int208] = ACTIONS(671),
    [anon_sym_int216] = ACTIONS(671),
    [anon_sym_int224] = ACTIONS(671),
    [anon_sym_int232] = ACTIONS(671),
    [anon_sym_int240] = ACTIONS(671),
    [anon_sym_int248] = ACTIONS(671),
    [anon_sym_int256] = ACTIONS(671),
    [anon_sym_uint] = ACTIONS(671),
    [anon_sym_uint8] = ACTIONS(671),
    [anon_sym_uint16] = ACTIONS(671),
    [anon_sym_uint24] = ACTIONS(671),
    [anon_sym_uint32] = ACTIONS(671),
    [anon_sym_uint40] = ACTIONS(671),
    [anon_sym_uint48] = ACTIONS(671),
    [anon_sym_uint56] = ACTIONS(671),
    [anon_sym_uint64] = ACTIONS(671),
    [anon_sym_uint72] = ACTIONS(671),
    [anon_sym_uint80] = ACTIONS(671),
    [anon_sym_uint88] = ACTIONS(671),
    [anon_sym_uint96] = ACTIONS(671),
    [anon_sym_uint104] = ACTIONS(671),
    [anon_sym_uint112] = ACTIONS(671),
    [anon_sym_uint120] = ACTIONS(671),
    [anon_sym_uint128] = ACTIONS(671),
    [anon_sym_uint136] = ACTIONS(671),
    [anon_sym_uint144] = ACTIONS(671),
    [anon_sym_uint152] = ACTIONS(671),
    [anon_sym_uint160] = ACTIONS(671),
    [anon_sym_uint168] = ACTIONS(671),
    [anon_sym_uint176] = ACTIONS(671),
    [anon_sym_uint184] = ACTIONS(671),
    [anon_sym_uint192] = ACTIONS(671),
    [anon_sym_uint200] = ACTIONS(671),
    [anon_sym_uint208] = ACTIONS(671),
    [anon_sym_uint216] = ACTIONS(671),
    [anon_sym_uint224] = ACTIONS(671),
    [anon_sym_uint232] = ACTIONS(671),
    [anon_sym_uint240] = ACTIONS(671),
    [anon_sym_uint248] = ACTIONS(671),
    [anon_sym_uint256] = ACTIONS(671),
    [anon_sym_bytes] = ACTIONS(671),
    [anon_sym_bytes1] = ACTIONS(671),
    [anon_sym_bytes2] = ACTIONS(671),
    [anon_sym_bytes3] = ACTIONS(671),
    [anon_sym_bytes4] = ACTIONS(671),
    [anon_sym_bytes5] = ACTIONS(671),
    [anon_sym_bytes6] = ACTIONS(671),
    [anon_sym_bytes7] = ACTIONS(671),
    [anon_sym_bytes8] = ACTIONS(671),
    [anon_sym_bytes9] = ACTIONS(671),
    [anon_sym_bytes10] = ACTIONS(671),
    [anon_sym_bytes11] = ACTIONS(671),
    [anon_sym_bytes12] = ACTIONS(671),
    [anon_sym_bytes13] = ACTIONS(671),
    [anon_sym_bytes14] = ACTIONS(671),
    [anon_sym_bytes15] = ACTIONS(671),
    [anon_sym_bytes16] = ACTIONS(671),
    [anon_sym_bytes17] = ACTIONS(671),
    [anon_sym_bytes18] = ACTIONS(671),
    [anon_sym_bytes19] = ACTIONS(671),
    [anon_sym_bytes20] = ACTIONS(671),
    [anon_sym_bytes21] = ACTIONS(671),
    [anon_sym_bytes22] = ACTIONS(671),
    [anon_sym_bytes23] = ACTIONS(671),
    [anon_sym_bytes24] = ACTIONS(671),
    [anon_sym_bytes25] = ACTIONS(671),
    [anon_sym_bytes26] = ACTIONS(671),
    [anon_sym_bytes27] = ACTIONS(671),
    [anon_sym_bytes28] = ACTIONS(671),
    [anon_sym_bytes29] = ACTIONS(671),
    [anon_sym_bytes30] = ACTIONS(671),
    [anon_sym_bytes31] = ACTIONS(671),
    [anon_sym_bytes32] = ACTIONS(671),
    [anon_sym_fixed] = ACTIONS(671),
    [aux_sym__fixed_token1] = ACTIONS(671),
    [anon_sym_ufixed] = ACTIONS(671),
    [aux_sym__ufixed_token1] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(673),
    [sym_identifier] = ACTIONS(675),
    [anon_sym_pragma] = ACTIONS(675),
    [anon_sym_import] = ACTIONS(675),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_abstract] = ACTIONS(675),
    [anon_sym_contract] = ACTIONS(675),
    [anon_sym_error] = ACTIONS(675),
    [anon_sym_interface] = ACTIONS(675),
    [anon_sym_library] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_event] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(675),
    [anon_sym_byte] = ACTIONS(675),
    [anon_sym_address] = ACTIONS(675),
    [anon_sym_var] = ACTIONS(675),
    [anon_sym_mapping] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_string] = ACTIONS(675),
    [anon_sym_int] = ACTIONS(675),
    [anon_sym_int8] = ACTIONS(675),
    [anon_sym_int16] = ACTIONS(675),
    [anon_sym_int24] = ACTIONS(675),
    [anon_sym_int32] = ACTIONS(675),
    [anon_sym_int40] = ACTIONS(675),
    [anon_sym_int48] = ACTIONS(675),
    [anon_sym_int56] = ACTIONS(675),
    [anon_sym_int64] = ACTIONS(675),
    [anon_sym_int72] = ACTIONS(675),
    [anon_sym_int80] = ACTIONS(675),
    [anon_sym_int88] = ACTIONS(675),
    [anon_sym_int96] = ACTIONS(675),
    [anon_sym_int104] = ACTIONS(675),
    [anon_sym_int112] = ACTIONS(675),
    [anon_sym_int120] = ACTIONS(675),
    [anon_sym_int128] = ACTIONS(675),
    [anon_sym_int136] = ACTIONS(675),
    [anon_sym_int144] = ACTIONS(675),
    [anon_sym_int152] = ACTIONS(675),
    [anon_sym_int160] = ACTIONS(675),
    [anon_sym_int168] = ACTIONS(675),
    [anon_sym_int176] = ACTIONS(675),
    [anon_sym_int184] = ACTIONS(675),
    [anon_sym_int192] = ACTIONS(675),
    [anon_sym_int200] = ACTIONS(675),
    [anon_sym_int208] = ACTIONS(675),
    [anon_sym_int216] = ACTIONS(675),
    [anon_sym_int224] = ACTIONS(675),
    [anon_sym_int232] = ACTIONS(675),
    [anon_sym_int240] = ACTIONS(675),
    [anon_sym_int248] = ACTIONS(675),
    [anon_sym_int256] = ACTIONS(675),
    [anon_sym_uint] = ACTIONS(675),
    [anon_sym_uint8] = ACTIONS(675),
    [anon_sym_uint16] = ACTIONS(675),
    [anon_sym_uint24] = ACTIONS(675),
    [anon_sym_uint32] = ACTIONS(675),
    [anon_sym_uint40] = ACTIONS(675),
    [anon_sym_uint48] = ACTIONS(675),
    [anon_sym_uint56] = ACTIONS(675),
    [anon_sym_uint64] = ACTIONS(675),
    [anon_sym_uint72] = ACTIONS(675),
    [anon_sym_uint80] = ACTIONS(675),
    [anon_sym_uint88] = ACTIONS(675),
    [anon_sym_uint96] = ACTIONS(675),
    [anon_sym_uint104] = ACTIONS(675),
    [anon_sym_uint112] = ACTIONS(675),
    [anon_sym_uint120] = ACTIONS(675),
    [anon_sym_uint128] = ACTIONS(675),
    [anon_sym_uint136] = ACTIONS(675),
    [anon_sym_uint144] = ACTIONS(675),
    [anon_sym_uint152] = ACTIONS(675),
    [anon_sym_uint160] = ACTIONS(675),
    [anon_sym_uint168] = ACTIONS(675),
    [anon_sym_uint176] = ACTIONS(675),
    [anon_sym_uint184] = ACTIONS(675),
    [anon_sym_uint192] = ACTIONS(675),
    [anon_sym_uint200] = ACTIONS(675),
    [anon_sym_uint208] = ACTIONS(675),
    [anon_sym_uint216] = ACTIONS(675),
    [anon_sym_uint224] = ACTIONS(675),
    [anon_sym_uint232] = ACTIONS(675),
    [anon_sym_uint240] = ACTIONS(675),
    [anon_sym_uint248] = ACTIONS(675),
    [anon_sym_uint256] = ACTIONS(675),
    [anon_sym_bytes] = ACTIONS(675),
    [anon_sym_bytes1] = ACTIONS(675),
    [anon_sym_bytes2] = ACTIONS(675),
    [anon_sym_bytes3] = ACTIONS(675),
    [anon_sym_bytes4] = ACTIONS(675),
    [anon_sym_bytes5] = ACTIONS(675),
    [anon_sym_bytes6] = ACTIONS(675),
    [anon_sym_bytes7] = ACTIONS(675),
    [anon_sym_bytes8] = ACTIONS(675),
    [anon_sym_bytes9] = ACTIONS(675),
    [anon_sym_bytes10] = ACTIONS(675),
    [anon_sym_bytes11] = ACTIONS(675),
    [anon_sym_bytes12] = ACTIONS(675),
    [anon_sym_bytes13] = ACTIONS(675),
    [anon_sym_bytes14] = ACTIONS(675),
    [anon_sym_bytes15] = ACTIONS(675),
    [anon_sym_bytes16] = ACTIONS(675),
    [anon_sym_bytes17] = ACTIONS(675),
    [anon_sym_bytes18] = ACTIONS(675),
    [anon_sym_bytes19] = ACTIONS(675),
    [anon_sym_bytes20] = ACTIONS(675),
    [anon_sym_bytes21] = ACTIONS(675),
    [anon_sym_bytes22] = ACTIONS(675),
    [anon_sym_bytes23] = ACTIONS(675),
    [anon_sym_bytes24] = ACTIONS(675),
    [anon_sym_bytes25] = ACTIONS(675),
    [anon_sym_bytes26] = ACTIONS(675),
    [anon_sym_bytes27] = ACTIONS(675),
    [anon_sym_bytes28] = ACTIONS(675),
    [anon_sym_bytes29] = ACTIONS(675),
    [anon_sym_bytes30] = ACTIONS(675),
    [anon_sym_bytes31] = ACTIONS(675),
    [anon_sym_bytes32] = ACTIONS(675),
    [anon_sym_fixed] = ACTIONS(675),
    [aux_sym__fixed_token1] = ACTIONS(675),
    [anon_sym_ufixed] = ACTIONS(675),
    [aux_sym__ufixed_token1] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [ts_builtin_sym_end] = ACTIONS(677),
    [sym_identifier] = ACTIONS(679),
    [anon_sym_pragma] = ACTIONS(679),
    [anon_sym_import] = ACTIONS(679),
    [anon_sym_type] = ACTIONS(679),
    [anon_sym_abstract] = ACTIONS(679),
    [anon_sym_contract] = ACTIONS(679),
    [anon_sym_error] = ACTIONS(679),
    [anon_sym_interface] = ACTIONS(679),
    [anon_sym_library] = ACTIONS(679),
    [anon_sym_struct] = ACTIONS(679),
    [anon_sym_enum] = ACTIONS(679),
    [anon_sym_event] = ACTIONS(679),
    [anon_sym_function] = ACTIONS(679),
    [anon_sym_byte] = ACTIONS(679),
    [anon_sym_address] = ACTIONS(679),
    [anon_sym_var] = ACTIONS(679),
    [anon_sym_mapping] = ACTIONS(679),
    [anon_sym_bool] = ACTIONS(679),
    [anon_sym_string] = ACTIONS(679),
    [anon_sym_int] = ACTIONS(679),
    [anon_sym_int8] = ACTIONS(679),
    [anon_sym_int16] = ACTIONS(679),
    [anon_sym_int24] = ACTIONS(679),
    [anon_sym_int32] = ACTIONS(679),
    [anon_sym_int40] = ACTIONS(679),
    [anon_sym_int48] = ACTIONS(679),
    [anon_sym_int56] = ACTIONS(679),
    [anon_sym_int64] = ACTIONS(679),
    [anon_sym_int72] = ACTIONS(679),
    [anon_sym_int80] = ACTIONS(679),
    [anon_sym_int88] = ACTIONS(679),
    [anon_sym_int96] = ACTIONS(679),
    [anon_sym_int104] = ACTIONS(679),
    [anon_sym_int112] = ACTIONS(679),
    [anon_sym_int120] = ACTIONS(679),
    [anon_sym_int128] = ACTIONS(679),
    [anon_sym_int136] = ACTIONS(679),
    [anon_sym_int144] = ACTIONS(679),
    [anon_sym_int152] = ACTIONS(679),
    [anon_sym_int160] = ACTIONS(679),
    [anon_sym_int168] = ACTIONS(679),
    [anon_sym_int176] = ACTIONS(679),
    [anon_sym_int184] = ACTIONS(679),
    [anon_sym_int192] = ACTIONS(679),
    [anon_sym_int200] = ACTIONS(679),
    [anon_sym_int208] = ACTIONS(679),
    [anon_sym_int216] = ACTIONS(679),
    [anon_sym_int224] = ACTIONS(679),
    [anon_sym_int232] = ACTIONS(679),
    [anon_sym_int240] = ACTIONS(679),
    [anon_sym_int248] = ACTIONS(679),
    [anon_sym_int256] = ACTIONS(679),
    [anon_sym_uint] = ACTIONS(679),
    [anon_sym_uint8] = ACTIONS(679),
    [anon_sym_uint16] = ACTIONS(679),
    [anon_sym_uint24] = ACTIONS(679),
    [anon_sym_uint32] = ACTIONS(679),
    [anon_sym_uint40] = ACTIONS(679),
    [anon_sym_uint48] = ACTIONS(679),
    [anon_sym_uint56] = ACTIONS(679),
    [anon_sym_uint64] = ACTIONS(679),
    [anon_sym_uint72] = ACTIONS(679),
    [anon_sym_uint80] = ACTIONS(679),
    [anon_sym_uint88] = ACTIONS(679),
    [anon_sym_uint96] = ACTIONS(679),
    [anon_sym_uint104] = ACTIONS(679),
    [anon_sym_uint112] = ACTIONS(679),
    [anon_sym_uint120] = ACTIONS(679),
    [anon_sym_uint128] = ACTIONS(679),
    [anon_sym_uint136] = ACTIONS(679),
    [anon_sym_uint144] = ACTIONS(679),
    [anon_sym_uint152] = ACTIONS(679),
    [anon_sym_uint160] = ACTIONS(679),
    [anon_sym_uint168] = ACTIONS(679),
    [anon_sym_uint176] = ACTIONS(679),
    [anon_sym_uint184] = ACTIONS(679),
    [anon_sym_uint192] = ACTIONS(679),
    [anon_sym_uint200] = ACTIONS(679),
    [anon_sym_uint208] = ACTIONS(679),
    [anon_sym_uint216] = ACTIONS(679),
    [anon_sym_uint224] = ACTIONS(679),
    [anon_sym_uint232] = ACTIONS(679),
    [anon_sym_uint240] = ACTIONS(679),
    [anon_sym_uint248] = ACTIONS(679),
    [anon_sym_uint256] = ACTIONS(679),
    [anon_sym_bytes] = ACTIONS(679),
    [anon_sym_bytes1] = ACTIONS(679),
    [anon_sym_bytes2] = ACTIONS(679),
    [anon_sym_bytes3] = ACTIONS(679),
    [anon_sym_bytes4] = ACTIONS(679),
    [anon_sym_bytes5] = ACTIONS(679),
    [anon_sym_bytes6] = ACTIONS(679),
    [anon_sym_bytes7] = ACTIONS(679),
    [anon_sym_bytes8] = ACTIONS(679),
    [anon_sym_bytes9] = ACTIONS(679),
    [anon_sym_bytes10] = ACTIONS(679),
    [anon_sym_bytes11] = ACTIONS(679),
    [anon_sym_bytes12] = ACTIONS(679),
    [anon_sym_bytes13] = ACTIONS(679),
    [anon_sym_bytes14] = ACTIONS(679),
    [anon_sym_bytes15] = ACTIONS(679),
    [anon_sym_bytes16] = ACTIONS(679),
    [anon_sym_bytes17] = ACTIONS(679),
    [anon_sym_bytes18] = ACTIONS(679),
    [anon_sym_bytes19] = ACTIONS(679),
    [anon_sym_bytes20] = ACTIONS(679),
    [anon_sym_bytes21] = ACTIONS(679),
    [anon_sym_bytes22] = ACTIONS(679),
    [anon_sym_bytes23] = ACTIONS(679),
    [anon_sym_bytes24] = ACTIONS(679),
    [anon_sym_bytes25] = ACTIONS(679),
    [anon_sym_bytes26] = ACTIONS(679),
    [anon_sym_bytes27] = ACTIONS(679),
    [anon_sym_bytes28] = ACTIONS(679),
    [anon_sym_bytes29] = ACTIONS(679),
    [anon_sym_bytes30] = ACTIONS(679),
    [anon_sym_bytes31] = ACTIONS(679),
    [anon_sym_bytes32] = ACTIONS(679),
    [anon_sym_fixed] = ACTIONS(679),
    [aux_sym__fixed_token1] = ACTIONS(679),
    [anon_sym_ufixed] = ACTIONS(679),
    [aux_sym__ufixed_token1] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(681),
    [sym_identifier] = ACTIONS(683),
    [anon_sym_pragma] = ACTIONS(683),
    [anon_sym_import] = ACTIONS(683),
    [anon_sym_type] = ACTIONS(683),
    [anon_sym_abstract] = ACTIONS(683),
    [anon_sym_contract] = ACTIONS(683),
    [anon_sym_error] = ACTIONS(683),
    [anon_sym_interface] = ACTIONS(683),
    [anon_sym_library] = ACTIONS(683),
    [anon_sym_struct] = ACTIONS(683),
    [anon_sym_enum] = ACTIONS(683),
    [anon_sym_event] = ACTIONS(683),
    [anon_sym_function] = ACTIONS(683),
    [anon_sym_byte] = ACTIONS(683),
    [anon_sym_address] = ACTIONS(683),
    [anon_sym_var] = ACTIONS(683),
    [anon_sym_mapping] = ACTIONS(683),
    [anon_sym_bool] = ACTIONS(683),
    [anon_sym_string] = ACTIONS(683),
    [anon_sym_int] = ACTIONS(683),
    [anon_sym_int8] = ACTIONS(683),
    [anon_sym_int16] = ACTIONS(683),
    [anon_sym_int24] = ACTIONS(683),
    [anon_sym_int32] = ACTIONS(683),
    [anon_sym_int40] = ACTIONS(683),
    [anon_sym_int48] = ACTIONS(683),
    [anon_sym_int56] = ACTIONS(683),
    [anon_sym_int64] = ACTIONS(683),
    [anon_sym_int72] = ACTIONS(683),
    [anon_sym_int80] = ACTIONS(683),
    [anon_sym_int88] = ACTIONS(683),
    [anon_sym_int96] = ACTIONS(683),
    [anon_sym_int104] = ACTIONS(683),
    [anon_sym_int112] = ACTIONS(683),
    [anon_sym_int120] = ACTIONS(683),
    [anon_sym_int128] = ACTIONS(683),
    [anon_sym_int136] = ACTIONS(683),
    [anon_sym_int144] = ACTIONS(683),
    [anon_sym_int152] = ACTIONS(683),
    [anon_sym_int160] = ACTIONS(683),
    [anon_sym_int168] = ACTIONS(683),
    [anon_sym_int176] = ACTIONS(683),
    [anon_sym_int184] = ACTIONS(683),
    [anon_sym_int192] = ACTIONS(683),
    [anon_sym_int200] = ACTIONS(683),
    [anon_sym_int208] = ACTIONS(683),
    [anon_sym_int216] = ACTIONS(683),
    [anon_sym_int224] = ACTIONS(683),
    [anon_sym_int232] = ACTIONS(683),
    [anon_sym_int240] = ACTIONS(683),
    [anon_sym_int248] = ACTIONS(683),
    [anon_sym_int256] = ACTIONS(683),
    [anon_sym_uint] = ACTIONS(683),
    [anon_sym_uint8] = ACTIONS(683),
    [anon_sym_uint16] = ACTIONS(683),
    [anon_sym_uint24] = ACTIONS(683),
    [anon_sym_uint32] = ACTIONS(683),
    [anon_sym_uint40] = ACTIONS(683),
    [anon_sym_uint48] = ACTIONS(683),
    [anon_sym_uint56] = ACTIONS(683),
    [anon_sym_uint64] = ACTIONS(683),
    [anon_sym_uint72] = ACTIONS(683),
    [anon_sym_uint80] = ACTIONS(683),
    [anon_sym_uint88] = ACTIONS(683),
    [anon_sym_uint96] = ACTIONS(683),
    [anon_sym_uint104] = ACTIONS(683),
    [anon_sym_uint112] = ACTIONS(683),
    [anon_sym_uint120] = ACTIONS(683),
    [anon_sym_uint128] = ACTIONS(683),
    [anon_sym_uint136] = ACTIONS(683),
    [anon_sym_uint144] = ACTIONS(683),
    [anon_sym_uint152] = ACTIONS(683),
    [anon_sym_uint160] = ACTIONS(683),
    [anon_sym_uint168] = ACTIONS(683),
    [anon_sym_uint176] = ACTIONS(683),
    [anon_sym_uint184] = ACTIONS(683),
    [anon_sym_uint192] = ACTIONS(683),
    [anon_sym_uint200] = ACTIONS(683),
    [anon_sym_uint208] = ACTIONS(683),
    [anon_sym_uint216] = ACTIONS(683),
    [anon_sym_uint224] = ACTIONS(683),
    [anon_sym_uint232] = ACTIONS(683),
    [anon_sym_uint240] = ACTIONS(683),
    [anon_sym_uint248] = ACTIONS(683),
    [anon_sym_uint256] = ACTIONS(683),
    [anon_sym_bytes] = ACTIONS(683),
    [anon_sym_bytes1] = ACTIONS(683),
    [anon_sym_bytes2] = ACTIONS(683),
    [anon_sym_bytes3] = ACTIONS(683),
    [anon_sym_bytes4] = ACTIONS(683),
    [anon_sym_bytes5] = ACTIONS(683),
    [anon_sym_bytes6] = ACTIONS(683),
    [anon_sym_bytes7] = ACTIONS(683),
    [anon_sym_bytes8] = ACTIONS(683),
    [anon_sym_bytes9] = ACTIONS(683),
    [anon_sym_bytes10] = ACTIONS(683),
    [anon_sym_bytes11] = ACTIONS(683),
    [anon_sym_bytes12] = ACTIONS(683),
    [anon_sym_bytes13] = ACTIONS(683),
    [anon_sym_bytes14] = ACTIONS(683),
    [anon_sym_bytes15] = ACTIONS(683),
    [anon_sym_bytes16] = ACTIONS(683),
    [anon_sym_bytes17] = ACTIONS(683),
    [anon_sym_bytes18] = ACTIONS(683),
    [anon_sym_bytes19] = ACTIONS(683),
    [anon_sym_bytes20] = ACTIONS(683),
    [anon_sym_bytes21] = ACTIONS(683),
    [anon_sym_bytes22] = ACTIONS(683),
    [anon_sym_bytes23] = ACTIONS(683),
    [anon_sym_bytes24] = ACTIONS(683),
    [anon_sym_bytes25] = ACTIONS(683),
    [anon_sym_bytes26] = ACTIONS(683),
    [anon_sym_bytes27] = ACTIONS(683),
    [anon_sym_bytes28] = ACTIONS(683),
    [anon_sym_bytes29] = ACTIONS(683),
    [anon_sym_bytes30] = ACTIONS(683),
    [anon_sym_bytes31] = ACTIONS(683),
    [anon_sym_bytes32] = ACTIONS(683),
    [anon_sym_fixed] = ACTIONS(683),
    [aux_sym__fixed_token1] = ACTIONS(683),
    [anon_sym_ufixed] = ACTIONS(683),
    [aux_sym__ufixed_token1] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(685),
    [sym_identifier] = ACTIONS(687),
    [anon_sym_pragma] = ACTIONS(687),
    [anon_sym_import] = ACTIONS(687),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_abstract] = ACTIONS(687),
    [anon_sym_contract] = ACTIONS(687),
    [anon_sym_error] = ACTIONS(687),
    [anon_sym_interface] = ACTIONS(687),
    [anon_sym_library] = ACTIONS(687),
    [anon_sym_struct] = ACTIONS(687),
    [anon_sym_enum] = ACTIONS(687),
    [anon_sym_event] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_byte] = ACTIONS(687),
    [anon_sym_address] = ACTIONS(687),
    [anon_sym_var] = ACTIONS(687),
    [anon_sym_mapping] = ACTIONS(687),
    [anon_sym_bool] = ACTIONS(687),
    [anon_sym_string] = ACTIONS(687),
    [anon_sym_int] = ACTIONS(687),
    [anon_sym_int8] = ACTIONS(687),
    [anon_sym_int16] = ACTIONS(687),
    [anon_sym_int24] = ACTIONS(687),
    [anon_sym_int32] = ACTIONS(687),
    [anon_sym_int40] = ACTIONS(687),
    [anon_sym_int48] = ACTIONS(687),
    [anon_sym_int56] = ACTIONS(687),
    [anon_sym_int64] = ACTIONS(687),
    [anon_sym_int72] = ACTIONS(687),
    [anon_sym_int80] = ACTIONS(687),
    [anon_sym_int88] = ACTIONS(687),
    [anon_sym_int96] = ACTIONS(687),
    [anon_sym_int104] = ACTIONS(687),
    [anon_sym_int112] = ACTIONS(687),
    [anon_sym_int120] = ACTIONS(687),
    [anon_sym_int128] = ACTIONS(687),
    [anon_sym_int136] = ACTIONS(687),
    [anon_sym_int144] = ACTIONS(687),
    [anon_sym_int152] = ACTIONS(687),
    [anon_sym_int160] = ACTIONS(687),
    [anon_sym_int168] = ACTIONS(687),
    [anon_sym_int176] = ACTIONS(687),
    [anon_sym_int184] = ACTIONS(687),
    [anon_sym_int192] = ACTIONS(687),
    [anon_sym_int200] = ACTIONS(687),
    [anon_sym_int208] = ACTIONS(687),
    [anon_sym_int216] = ACTIONS(687),
    [anon_sym_int224] = ACTIONS(687),
    [anon_sym_int232] = ACTIONS(687),
    [anon_sym_int240] = ACTIONS(687),
    [anon_sym_int248] = ACTIONS(687),
    [anon_sym_int256] = ACTIONS(687),
    [anon_sym_uint] = ACTIONS(687),
    [anon_sym_uint8] = ACTIONS(687),
    [anon_sym_uint16] = ACTIONS(687),
    [anon_sym_uint24] = ACTIONS(687),
    [anon_sym_uint32] = ACTIONS(687),
    [anon_sym_uint40] = ACTIONS(687),
    [anon_sym_uint48] = ACTIONS(687),
    [anon_sym_uint56] = ACTIONS(687),
    [anon_sym_uint64] = ACTIONS(687),
    [anon_sym_uint72] = ACTIONS(687),
    [anon_sym_uint80] = ACTIONS(687),
    [anon_sym_uint88] = ACTIONS(687),
    [anon_sym_uint96] = ACTIONS(687),
    [anon_sym_uint104] = ACTIONS(687),
    [anon_sym_uint112] = ACTIONS(687),
    [anon_sym_uint120] = ACTIONS(687),
    [anon_sym_uint128] = ACTIONS(687),
    [anon_sym_uint136] = ACTIONS(687),
    [anon_sym_uint144] = ACTIONS(687),
    [anon_sym_uint152] = ACTIONS(687),
    [anon_sym_uint160] = ACTIONS(687),
    [anon_sym_uint168] = ACTIONS(687),
    [anon_sym_uint176] = ACTIONS(687),
    [anon_sym_uint184] = ACTIONS(687),
    [anon_sym_uint192] = ACTIONS(687),
    [anon_sym_uint200] = ACTIONS(687),
    [anon_sym_uint208] = ACTIONS(687),
    [anon_sym_uint216] = ACTIONS(687),
    [anon_sym_uint224] = ACTIONS(687),
    [anon_sym_uint232] = ACTIONS(687),
    [anon_sym_uint240] = ACTIONS(687),
    [anon_sym_uint248] = ACTIONS(687),
    [anon_sym_uint256] = ACTIONS(687),
    [anon_sym_bytes] = ACTIONS(687),
    [anon_sym_bytes1] = ACTIONS(687),
    [anon_sym_bytes2] = ACTIONS(687),
    [anon_sym_bytes3] = ACTIONS(687),
    [anon_sym_bytes4] = ACTIONS(687),
    [anon_sym_bytes5] = ACTIONS(687),
    [anon_sym_bytes6] = ACTIONS(687),
    [anon_sym_bytes7] = ACTIONS(687),
    [anon_sym_bytes8] = ACTIONS(687),
    [anon_sym_bytes9] = ACTIONS(687),
    [anon_sym_bytes10] = ACTIONS(687),
    [anon_sym_bytes11] = ACTIONS(687),
    [anon_sym_bytes12] = ACTIONS(687),
    [anon_sym_bytes13] = ACTIONS(687),
    [anon_sym_bytes14] = ACTIONS(687),
    [anon_sym_bytes15] = ACTIONS(687),
    [anon_sym_bytes16] = ACTIONS(687),
    [anon_sym_bytes17] = ACTIONS(687),
    [anon_sym_bytes18] = ACTIONS(687),
    [anon_sym_bytes19] = ACTIONS(687),
    [anon_sym_bytes20] = ACTIONS(687),
    [anon_sym_bytes21] = ACTIONS(687),
    [anon_sym_bytes22] = ACTIONS(687),
    [anon_sym_bytes23] = ACTIONS(687),
    [anon_sym_bytes24] = ACTIONS(687),
    [anon_sym_bytes25] = ACTIONS(687),
    [anon_sym_bytes26] = ACTIONS(687),
    [anon_sym_bytes27] = ACTIONS(687),
    [anon_sym_bytes28] = ACTIONS(687),
    [anon_sym_bytes29] = ACTIONS(687),
    [anon_sym_bytes30] = ACTIONS(687),
    [anon_sym_bytes31] = ACTIONS(687),
    [anon_sym_bytes32] = ACTIONS(687),
    [anon_sym_fixed] = ACTIONS(687),
    [aux_sym__fixed_token1] = ACTIONS(687),
    [anon_sym_ufixed] = ACTIONS(687),
    [aux_sym__ufixed_token1] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(689),
    [sym_identifier] = ACTIONS(691),
    [anon_sym_pragma] = ACTIONS(691),
    [anon_sym_import] = ACTIONS(691),
    [anon_sym_type] = ACTIONS(691),
    [anon_sym_abstract] = ACTIONS(691),
    [anon_sym_contract] = ACTIONS(691),
    [anon_sym_error] = ACTIONS(691),
    [anon_sym_interface] = ACTIONS(691),
    [anon_sym_library] = ACTIONS(691),
    [anon_sym_struct] = ACTIONS(691),
    [anon_sym_enum] = ACTIONS(691),
    [anon_sym_event] = ACTIONS(691),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_byte] = ACTIONS(691),
    [anon_sym_address] = ACTIONS(691),
    [anon_sym_var] = ACTIONS(691),
    [anon_sym_mapping] = ACTIONS(691),
    [anon_sym_bool] = ACTIONS(691),
    [anon_sym_string] = ACTIONS(691),
    [anon_sym_int] = ACTIONS(691),
    [anon_sym_int8] = ACTIONS(691),
    [anon_sym_int16] = ACTIONS(691),
    [anon_sym_int24] = ACTIONS(691),
    [anon_sym_int32] = ACTIONS(691),
    [anon_sym_int40] = ACTIONS(691),
    [anon_sym_int48] = ACTIONS(691),
    [anon_sym_int56] = ACTIONS(691),
    [anon_sym_int64] = ACTIONS(691),
    [anon_sym_int72] = ACTIONS(691),
    [anon_sym_int80] = ACTIONS(691),
    [anon_sym_int88] = ACTIONS(691),
    [anon_sym_int96] = ACTIONS(691),
    [anon_sym_int104] = ACTIONS(691),
    [anon_sym_int112] = ACTIONS(691),
    [anon_sym_int120] = ACTIONS(691),
    [anon_sym_int128] = ACTIONS(691),
    [anon_sym_int136] = ACTIONS(691),
    [anon_sym_int144] = ACTIONS(691),
    [anon_sym_int152] = ACTIONS(691),
    [anon_sym_int160] = ACTIONS(691),
    [anon_sym_int168] = ACTIONS(691),
    [anon_sym_int176] = ACTIONS(691),
    [anon_sym_int184] = ACTIONS(691),
    [anon_sym_int192] = ACTIONS(691),
    [anon_sym_int200] = ACTIONS(691),
    [anon_sym_int208] = ACTIONS(691),
    [anon_sym_int216] = ACTIONS(691),
    [anon_sym_int224] = ACTIONS(691),
    [anon_sym_int232] = ACTIONS(691),
    [anon_sym_int240] = ACTIONS(691),
    [anon_sym_int248] = ACTIONS(691),
    [anon_sym_int256] = ACTIONS(691),
    [anon_sym_uint] = ACTIONS(691),
    [anon_sym_uint8] = ACTIONS(691),
    [anon_sym_uint16] = ACTIONS(691),
    [anon_sym_uint24] = ACTIONS(691),
    [anon_sym_uint32] = ACTIONS(691),
    [anon_sym_uint40] = ACTIONS(691),
    [anon_sym_uint48] = ACTIONS(691),
    [anon_sym_uint56] = ACTIONS(691),
    [anon_sym_uint64] = ACTIONS(691),
    [anon_sym_uint72] = ACTIONS(691),
    [anon_sym_uint80] = ACTIONS(691),
    [anon_sym_uint88] = ACTIONS(691),
    [anon_sym_uint96] = ACTIONS(691),
    [anon_sym_uint104] = ACTIONS(691),
    [anon_sym_uint112] = ACTIONS(691),
    [anon_sym_uint120] = ACTIONS(691),
    [anon_sym_uint128] = ACTIONS(691),
    [anon_sym_uint136] = ACTIONS(691),
    [anon_sym_uint144] = ACTIONS(691),
    [anon_sym_uint152] = ACTIONS(691),
    [anon_sym_uint160] = ACTIONS(691),
    [anon_sym_uint168] = ACTIONS(691),
    [anon_sym_uint176] = ACTIONS(691),
    [anon_sym_uint184] = ACTIONS(691),
    [anon_sym_uint192] = ACTIONS(691),
    [anon_sym_uint200] = ACTIONS(691),
    [anon_sym_uint208] = ACTIONS(691),
    [anon_sym_uint216] = ACTIONS(691),
    [anon_sym_uint224] = ACTIONS(691),
    [anon_sym_uint232] = ACTIONS(691),
    [anon_sym_uint240] = ACTIONS(691),
    [anon_sym_uint248] = ACTIONS(691),
    [anon_sym_uint256] = ACTIONS(691),
    [anon_sym_bytes] = ACTIONS(691),
    [anon_sym_bytes1] = ACTIONS(691),
    [anon_sym_bytes2] = ACTIONS(691),
    [anon_sym_bytes3] = ACTIONS(691),
    [anon_sym_bytes4] = ACTIONS(691),
    [anon_sym_bytes5] = ACTIONS(691),
    [anon_sym_bytes6] = ACTIONS(691),
    [anon_sym_bytes7] = ACTIONS(691),
    [anon_sym_bytes8] = ACTIONS(691),
    [anon_sym_bytes9] = ACTIONS(691),
    [anon_sym_bytes10] = ACTIONS(691),
    [anon_sym_bytes11] = ACTIONS(691),
    [anon_sym_bytes12] = ACTIONS(691),
    [anon_sym_bytes13] = ACTIONS(691),
    [anon_sym_bytes14] = ACTIONS(691),
    [anon_sym_bytes15] = ACTIONS(691),
    [anon_sym_bytes16] = ACTIONS(691),
    [anon_sym_bytes17] = ACTIONS(691),
    [anon_sym_bytes18] = ACTIONS(691),
    [anon_sym_bytes19] = ACTIONS(691),
    [anon_sym_bytes20] = ACTIONS(691),
    [anon_sym_bytes21] = ACTIONS(691),
    [anon_sym_bytes22] = ACTIONS(691),
    [anon_sym_bytes23] = ACTIONS(691),
    [anon_sym_bytes24] = ACTIONS(691),
    [anon_sym_bytes25] = ACTIONS(691),
    [anon_sym_bytes26] = ACTIONS(691),
    [anon_sym_bytes27] = ACTIONS(691),
    [anon_sym_bytes28] = ACTIONS(691),
    [anon_sym_bytes29] = ACTIONS(691),
    [anon_sym_bytes30] = ACTIONS(691),
    [anon_sym_bytes31] = ACTIONS(691),
    [anon_sym_bytes32] = ACTIONS(691),
    [anon_sym_fixed] = ACTIONS(691),
    [aux_sym__fixed_token1] = ACTIONS(691),
    [anon_sym_ufixed] = ACTIONS(691),
    [aux_sym__ufixed_token1] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(693),
    [sym_identifier] = ACTIONS(695),
    [anon_sym_pragma] = ACTIONS(695),
    [anon_sym_import] = ACTIONS(695),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_abstract] = ACTIONS(695),
    [anon_sym_contract] = ACTIONS(695),
    [anon_sym_error] = ACTIONS(695),
    [anon_sym_interface] = ACTIONS(695),
    [anon_sym_library] = ACTIONS(695),
    [anon_sym_struct] = ACTIONS(695),
    [anon_sym_enum] = ACTIONS(695),
    [anon_sym_event] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_byte] = ACTIONS(695),
    [anon_sym_address] = ACTIONS(695),
    [anon_sym_var] = ACTIONS(695),
    [anon_sym_mapping] = ACTIONS(695),
    [anon_sym_bool] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_int] = ACTIONS(695),
    [anon_sym_int8] = ACTIONS(695),
    [anon_sym_int16] = ACTIONS(695),
    [anon_sym_int24] = ACTIONS(695),
    [anon_sym_int32] = ACTIONS(695),
    [anon_sym_int40] = ACTIONS(695),
    [anon_sym_int48] = ACTIONS(695),
    [anon_sym_int56] = ACTIONS(695),
    [anon_sym_int64] = ACTIONS(695),
    [anon_sym_int72] = ACTIONS(695),
    [anon_sym_int80] = ACTIONS(695),
    [anon_sym_int88] = ACTIONS(695),
    [anon_sym_int96] = ACTIONS(695),
    [anon_sym_int104] = ACTIONS(695),
    [anon_sym_int112] = ACTIONS(695),
    [anon_sym_int120] = ACTIONS(695),
    [anon_sym_int128] = ACTIONS(695),
    [anon_sym_int136] = ACTIONS(695),
    [anon_sym_int144] = ACTIONS(695),
    [anon_sym_int152] = ACTIONS(695),
    [anon_sym_int160] = ACTIONS(695),
    [anon_sym_int168] = ACTIONS(695),
    [anon_sym_int176] = ACTIONS(695),
    [anon_sym_int184] = ACTIONS(695),
    [anon_sym_int192] = ACTIONS(695),
    [anon_sym_int200] = ACTIONS(695),
    [anon_sym_int208] = ACTIONS(695),
    [anon_sym_int216] = ACTIONS(695),
    [anon_sym_int224] = ACTIONS(695),
    [anon_sym_int232] = ACTIONS(695),
    [anon_sym_int240] = ACTIONS(695),
    [anon_sym_int248] = ACTIONS(695),
    [anon_sym_int256] = ACTIONS(695),
    [anon_sym_uint] = ACTIONS(695),
    [anon_sym_uint8] = ACTIONS(695),
    [anon_sym_uint16] = ACTIONS(695),
    [anon_sym_uint24] = ACTIONS(695),
    [anon_sym_uint32] = ACTIONS(695),
    [anon_sym_uint40] = ACTIONS(695),
    [anon_sym_uint48] = ACTIONS(695),
    [anon_sym_uint56] = ACTIONS(695),
    [anon_sym_uint64] = ACTIONS(695),
    [anon_sym_uint72] = ACTIONS(695),
    [anon_sym_uint80] = ACTIONS(695),
    [anon_sym_uint88] = ACTIONS(695),
    [anon_sym_uint96] = ACTIONS(695),
    [anon_sym_uint104] = ACTIONS(695),
    [anon_sym_uint112] = ACTIONS(695),
    [anon_sym_uint120] = ACTIONS(695),
    [anon_sym_uint128] = ACTIONS(695),
    [anon_sym_uint136] = ACTIONS(695),
    [anon_sym_uint144] = ACTIONS(695),
    [anon_sym_uint152] = ACTIONS(695),
    [anon_sym_uint160] = ACTIONS(695),
    [anon_sym_uint168] = ACTIONS(695),
    [anon_sym_uint176] = ACTIONS(695),
    [anon_sym_uint184] = ACTIONS(695),
    [anon_sym_uint192] = ACTIONS(695),
    [anon_sym_uint200] = ACTIONS(695),
    [anon_sym_uint208] = ACTIONS(695),
    [anon_sym_uint216] = ACTIONS(695),
    [anon_sym_uint224] = ACTIONS(695),
    [anon_sym_uint232] = ACTIONS(695),
    [anon_sym_uint240] = ACTIONS(695),
    [anon_sym_uint248] = ACTIONS(695),
    [anon_sym_uint256] = ACTIONS(695),
    [anon_sym_bytes] = ACTIONS(695),
    [anon_sym_bytes1] = ACTIONS(695),
    [anon_sym_bytes2] = ACTIONS(695),
    [anon_sym_bytes3] = ACTIONS(695),
    [anon_sym_bytes4] = ACTIONS(695),
    [anon_sym_bytes5] = ACTIONS(695),
    [anon_sym_bytes6] = ACTIONS(695),
    [anon_sym_bytes7] = ACTIONS(695),
    [anon_sym_bytes8] = ACTIONS(695),
    [anon_sym_bytes9] = ACTIONS(695),
    [anon_sym_bytes10] = ACTIONS(695),
    [anon_sym_bytes11] = ACTIONS(695),
    [anon_sym_bytes12] = ACTIONS(695),
    [anon_sym_bytes13] = ACTIONS(695),
    [anon_sym_bytes14] = ACTIONS(695),
    [anon_sym_bytes15] = ACTIONS(695),
    [anon_sym_bytes16] = ACTIONS(695),
    [anon_sym_bytes17] = ACTIONS(695),
    [anon_sym_bytes18] = ACTIONS(695),
    [anon_sym_bytes19] = ACTIONS(695),
    [anon_sym_bytes20] = ACTIONS(695),
    [anon_sym_bytes21] = ACTIONS(695),
    [anon_sym_bytes22] = ACTIONS(695),
    [anon_sym_bytes23] = ACTIONS(695),
    [anon_sym_bytes24] = ACTIONS(695),
    [anon_sym_bytes25] = ACTIONS(695),
    [anon_sym_bytes26] = ACTIONS(695),
    [anon_sym_bytes27] = ACTIONS(695),
    [anon_sym_bytes28] = ACTIONS(695),
    [anon_sym_bytes29] = ACTIONS(695),
    [anon_sym_bytes30] = ACTIONS(695),
    [anon_sym_bytes31] = ACTIONS(695),
    [anon_sym_bytes32] = ACTIONS(695),
    [anon_sym_fixed] = ACTIONS(695),
    [aux_sym__fixed_token1] = ACTIONS(695),
    [anon_sym_ufixed] = ACTIONS(695),
    [aux_sym__ufixed_token1] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [ts_builtin_sym_end] = ACTIONS(697),
    [sym_identifier] = ACTIONS(699),
    [anon_sym_pragma] = ACTIONS(699),
    [anon_sym_import] = ACTIONS(699),
    [anon_sym_type] = ACTIONS(699),
    [anon_sym_abstract] = ACTIONS(699),
    [anon_sym_contract] = ACTIONS(699),
    [anon_sym_error] = ACTIONS(699),
    [anon_sym_interface] = ACTIONS(699),
    [anon_sym_library] = ACTIONS(699),
    [anon_sym_struct] = ACTIONS(699),
    [anon_sym_enum] = ACTIONS(699),
    [anon_sym_event] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_byte] = ACTIONS(699),
    [anon_sym_address] = ACTIONS(699),
    [anon_sym_var] = ACTIONS(699),
    [anon_sym_mapping] = ACTIONS(699),
    [anon_sym_bool] = ACTIONS(699),
    [anon_sym_string] = ACTIONS(699),
    [anon_sym_int] = ACTIONS(699),
    [anon_sym_int8] = ACTIONS(699),
    [anon_sym_int16] = ACTIONS(699),
    [anon_sym_int24] = ACTIONS(699),
    [anon_sym_int32] = ACTIONS(699),
    [anon_sym_int40] = ACTIONS(699),
    [anon_sym_int48] = ACTIONS(699),
    [anon_sym_int56] = ACTIONS(699),
    [anon_sym_int64] = ACTIONS(699),
    [anon_sym_int72] = ACTIONS(699),
    [anon_sym_int80] = ACTIONS(699),
    [anon_sym_int88] = ACTIONS(699),
    [anon_sym_int96] = ACTIONS(699),
    [anon_sym_int104] = ACTIONS(699),
    [anon_sym_int112] = ACTIONS(699),
    [anon_sym_int120] = ACTIONS(699),
    [anon_sym_int128] = ACTIONS(699),
    [anon_sym_int136] = ACTIONS(699),
    [anon_sym_int144] = ACTIONS(699),
    [anon_sym_int152] = ACTIONS(699),
    [anon_sym_int160] = ACTIONS(699),
    [anon_sym_int168] = ACTIONS(699),
    [anon_sym_int176] = ACTIONS(699),
    [anon_sym_int184] = ACTIONS(699),
    [anon_sym_int192] = ACTIONS(699),
    [anon_sym_int200] = ACTIONS(699),
    [anon_sym_int208] = ACTIONS(699),
    [anon_sym_int216] = ACTIONS(699),
    [anon_sym_int224] = ACTIONS(699),
    [anon_sym_int232] = ACTIONS(699),
    [anon_sym_int240] = ACTIONS(699),
    [anon_sym_int248] = ACTIONS(699),
    [anon_sym_int256] = ACTIONS(699),
    [anon_sym_uint] = ACTIONS(699),
    [anon_sym_uint8] = ACTIONS(699),
    [anon_sym_uint16] = ACTIONS(699),
    [anon_sym_uint24] = ACTIONS(699),
    [anon_sym_uint32] = ACTIONS(699),
    [anon_sym_uint40] = ACTIONS(699),
    [anon_sym_uint48] = ACTIONS(699),
    [anon_sym_uint56] = ACTIONS(699),
    [anon_sym_uint64] = ACTIONS(699),
    [anon_sym_uint72] = ACTIONS(699),
    [anon_sym_uint80] = ACTIONS(699),
    [anon_sym_uint88] = ACTIONS(699),
    [anon_sym_uint96] = ACTIONS(699),
    [anon_sym_uint104] = ACTIONS(699),
    [anon_sym_uint112] = ACTIONS(699),
    [anon_sym_uint120] = ACTIONS(699),
    [anon_sym_uint128] = ACTIONS(699),
    [anon_sym_uint136] = ACTIONS(699),
    [anon_sym_uint144] = ACTIONS(699),
    [anon_sym_uint152] = ACTIONS(699),
    [anon_sym_uint160] = ACTIONS(699),
    [anon_sym_uint168] = ACTIONS(699),
    [anon_sym_uint176] = ACTIONS(699),
    [anon_sym_uint184] = ACTIONS(699),
    [anon_sym_uint192] = ACTIONS(699),
    [anon_sym_uint200] = ACTIONS(699),
    [anon_sym_uint208] = ACTIONS(699),
    [anon_sym_uint216] = ACTIONS(699),
    [anon_sym_uint224] = ACTIONS(699),
    [anon_sym_uint232] = ACTIONS(699),
    [anon_sym_uint240] = ACTIONS(699),
    [anon_sym_uint248] = ACTIONS(699),
    [anon_sym_uint256] = ACTIONS(699),
    [anon_sym_bytes] = ACTIONS(699),
    [anon_sym_bytes1] = ACTIONS(699),
    [anon_sym_bytes2] = ACTIONS(699),
    [anon_sym_bytes3] = ACTIONS(699),
    [anon_sym_bytes4] = ACTIONS(699),
    [anon_sym_bytes5] = ACTIONS(699),
    [anon_sym_bytes6] = ACTIONS(699),
    [anon_sym_bytes7] = ACTIONS(699),
    [anon_sym_bytes8] = ACTIONS(699),
    [anon_sym_bytes9] = ACTIONS(699),
    [anon_sym_bytes10] = ACTIONS(699),
    [anon_sym_bytes11] = ACTIONS(699),
    [anon_sym_bytes12] = ACTIONS(699),
    [anon_sym_bytes13] = ACTIONS(699),
    [anon_sym_bytes14] = ACTIONS(699),
    [anon_sym_bytes15] = ACTIONS(699),
    [anon_sym_bytes16] = ACTIONS(699),
    [anon_sym_bytes17] = ACTIONS(699),
    [anon_sym_bytes18] = ACTIONS(699),
    [anon_sym_bytes19] = ACTIONS(699),
    [anon_sym_bytes20] = ACTIONS(699),
    [anon_sym_bytes21] = ACTIONS(699),
    [anon_sym_bytes22] = ACTIONS(699),
    [anon_sym_bytes23] = ACTIONS(699),
    [anon_sym_bytes24] = ACTIONS(699),
    [anon_sym_bytes25] = ACTIONS(699),
    [anon_sym_bytes26] = ACTIONS(699),
    [anon_sym_bytes27] = ACTIONS(699),
    [anon_sym_bytes28] = ACTIONS(699),
    [anon_sym_bytes29] = ACTIONS(699),
    [anon_sym_bytes30] = ACTIONS(699),
    [anon_sym_bytes31] = ACTIONS(699),
    [anon_sym_bytes32] = ACTIONS(699),
    [anon_sym_fixed] = ACTIONS(699),
    [aux_sym__fixed_token1] = ACTIONS(699),
    [anon_sym_ufixed] = ACTIONS(699),
    [aux_sym__ufixed_token1] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(701),
    [sym_identifier] = ACTIONS(703),
    [anon_sym_pragma] = ACTIONS(703),
    [anon_sym_import] = ACTIONS(703),
    [anon_sym_type] = ACTIONS(703),
    [anon_sym_abstract] = ACTIONS(703),
    [anon_sym_contract] = ACTIONS(703),
    [anon_sym_error] = ACTIONS(703),
    [anon_sym_interface] = ACTIONS(703),
    [anon_sym_library] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_event] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_byte] = ACTIONS(703),
    [anon_sym_address] = ACTIONS(703),
    [anon_sym_var] = ACTIONS(703),
    [anon_sym_mapping] = ACTIONS(703),
    [anon_sym_bool] = ACTIONS(703),
    [anon_sym_string] = ACTIONS(703),
    [anon_sym_int] = ACTIONS(703),
    [anon_sym_int8] = ACTIONS(703),
    [anon_sym_int16] = ACTIONS(703),
    [anon_sym_int24] = ACTIONS(703),
    [anon_sym_int32] = ACTIONS(703),
    [anon_sym_int40] = ACTIONS(703),
    [anon_sym_int48] = ACTIONS(703),
    [anon_sym_int56] = ACTIONS(703),
    [anon_sym_int64] = ACTIONS(703),
    [anon_sym_int72] = ACTIONS(703),
    [anon_sym_int80] = ACTIONS(703),
    [anon_sym_int88] = ACTIONS(703),
    [anon_sym_int96] = ACTIONS(703),
    [anon_sym_int104] = ACTIONS(703),
    [anon_sym_int112] = ACTIONS(703),
    [anon_sym_int120] = ACTIONS(703),
    [anon_sym_int128] = ACTIONS(703),
    [anon_sym_int136] = ACTIONS(703),
    [anon_sym_int144] = ACTIONS(703),
    [anon_sym_int152] = ACTIONS(703),
    [anon_sym_int160] = ACTIONS(703),
    [anon_sym_int168] = ACTIONS(703),
    [anon_sym_int176] = ACTIONS(703),
    [anon_sym_int184] = ACTIONS(703),
    [anon_sym_int192] = ACTIONS(703),
    [anon_sym_int200] = ACTIONS(703),
    [anon_sym_int208] = ACTIONS(703),
    [anon_sym_int216] = ACTIONS(703),
    [anon_sym_int224] = ACTIONS(703),
    [anon_sym_int232] = ACTIONS(703),
    [anon_sym_int240] = ACTIONS(703),
    [anon_sym_int248] = ACTIONS(703),
    [anon_sym_int256] = ACTIONS(703),
    [anon_sym_uint] = ACTIONS(703),
    [anon_sym_uint8] = ACTIONS(703),
    [anon_sym_uint16] = ACTIONS(703),
    [anon_sym_uint24] = ACTIONS(703),
    [anon_sym_uint32] = ACTIONS(703),
    [anon_sym_uint40] = ACTIONS(703),
    [anon_sym_uint48] = ACTIONS(703),
    [anon_sym_uint56] = ACTIONS(703),
    [anon_sym_uint64] = ACTIONS(703),
    [anon_sym_uint72] = ACTIONS(703),
    [anon_sym_uint80] = ACTIONS(703),
    [anon_sym_uint88] = ACTIONS(703),
    [anon_sym_uint96] = ACTIONS(703),
    [anon_sym_uint104] = ACTIONS(703),
    [anon_sym_uint112] = ACTIONS(703),
    [anon_sym_uint120] = ACTIONS(703),
    [anon_sym_uint128] = ACTIONS(703),
    [anon_sym_uint136] = ACTIONS(703),
    [anon_sym_uint144] = ACTIONS(703),
    [anon_sym_uint152] = ACTIONS(703),
    [anon_sym_uint160] = ACTIONS(703),
    [anon_sym_uint168] = ACTIONS(703),
    [anon_sym_uint176] = ACTIONS(703),
    [anon_sym_uint184] = ACTIONS(703),
    [anon_sym_uint192] = ACTIONS(703),
    [anon_sym_uint200] = ACTIONS(703),
    [anon_sym_uint208] = ACTIONS(703),
    [anon_sym_uint216] = ACTIONS(703),
    [anon_sym_uint224] = ACTIONS(703),
    [anon_sym_uint232] = ACTIONS(703),
    [anon_sym_uint240] = ACTIONS(703),
    [anon_sym_uint248] = ACTIONS(703),
    [anon_sym_uint256] = ACTIONS(703),
    [anon_sym_bytes] = ACTIONS(703),
    [anon_sym_bytes1] = ACTIONS(703),
    [anon_sym_bytes2] = ACTIONS(703),
    [anon_sym_bytes3] = ACTIONS(703),
    [anon_sym_bytes4] = ACTIONS(703),
    [anon_sym_bytes5] = ACTIONS(703),
    [anon_sym_bytes6] = ACTIONS(703),
    [anon_sym_bytes7] = ACTIONS(703),
    [anon_sym_bytes8] = ACTIONS(703),
    [anon_sym_bytes9] = ACTIONS(703),
    [anon_sym_bytes10] = ACTIONS(703),
    [anon_sym_bytes11] = ACTIONS(703),
    [anon_sym_bytes12] = ACTIONS(703),
    [anon_sym_bytes13] = ACTIONS(703),
    [anon_sym_bytes14] = ACTIONS(703),
    [anon_sym_bytes15] = ACTIONS(703),
    [anon_sym_bytes16] = ACTIONS(703),
    [anon_sym_bytes17] = ACTIONS(703),
    [anon_sym_bytes18] = ACTIONS(703),
    [anon_sym_bytes19] = ACTIONS(703),
    [anon_sym_bytes20] = ACTIONS(703),
    [anon_sym_bytes21] = ACTIONS(703),
    [anon_sym_bytes22] = ACTIONS(703),
    [anon_sym_bytes23] = ACTIONS(703),
    [anon_sym_bytes24] = ACTIONS(703),
    [anon_sym_bytes25] = ACTIONS(703),
    [anon_sym_bytes26] = ACTIONS(703),
    [anon_sym_bytes27] = ACTIONS(703),
    [anon_sym_bytes28] = ACTIONS(703),
    [anon_sym_bytes29] = ACTIONS(703),
    [anon_sym_bytes30] = ACTIONS(703),
    [anon_sym_bytes31] = ACTIONS(703),
    [anon_sym_bytes32] = ACTIONS(703),
    [anon_sym_fixed] = ACTIONS(703),
    [aux_sym__fixed_token1] = ACTIONS(703),
    [anon_sym_ufixed] = ACTIONS(703),
    [aux_sym__ufixed_token1] = ACTIONS(703),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_type_name] = STATE(378),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(705),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [ts_builtin_sym_end] = ACTIONS(707),
    [sym_identifier] = ACTIONS(709),
    [anon_sym_pragma] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(709),
    [anon_sym_type] = ACTIONS(709),
    [anon_sym_abstract] = ACTIONS(709),
    [anon_sym_contract] = ACTIONS(709),
    [anon_sym_error] = ACTIONS(709),
    [anon_sym_interface] = ACTIONS(709),
    [anon_sym_library] = ACTIONS(709),
    [anon_sym_struct] = ACTIONS(709),
    [anon_sym_enum] = ACTIONS(709),
    [anon_sym_event] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(709),
    [anon_sym_byte] = ACTIONS(709),
    [anon_sym_address] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_mapping] = ACTIONS(709),
    [anon_sym_bool] = ACTIONS(709),
    [anon_sym_string] = ACTIONS(709),
    [anon_sym_int] = ACTIONS(709),
    [anon_sym_int8] = ACTIONS(709),
    [anon_sym_int16] = ACTIONS(709),
    [anon_sym_int24] = ACTIONS(709),
    [anon_sym_int32] = ACTIONS(709),
    [anon_sym_int40] = ACTIONS(709),
    [anon_sym_int48] = ACTIONS(709),
    [anon_sym_int56] = ACTIONS(709),
    [anon_sym_int64] = ACTIONS(709),
    [anon_sym_int72] = ACTIONS(709),
    [anon_sym_int80] = ACTIONS(709),
    [anon_sym_int88] = ACTIONS(709),
    [anon_sym_int96] = ACTIONS(709),
    [anon_sym_int104] = ACTIONS(709),
    [anon_sym_int112] = ACTIONS(709),
    [anon_sym_int120] = ACTIONS(709),
    [anon_sym_int128] = ACTIONS(709),
    [anon_sym_int136] = ACTIONS(709),
    [anon_sym_int144] = ACTIONS(709),
    [anon_sym_int152] = ACTIONS(709),
    [anon_sym_int160] = ACTIONS(709),
    [anon_sym_int168] = ACTIONS(709),
    [anon_sym_int176] = ACTIONS(709),
    [anon_sym_int184] = ACTIONS(709),
    [anon_sym_int192] = ACTIONS(709),
    [anon_sym_int200] = ACTIONS(709),
    [anon_sym_int208] = ACTIONS(709),
    [anon_sym_int216] = ACTIONS(709),
    [anon_sym_int224] = ACTIONS(709),
    [anon_sym_int232] = ACTIONS(709),
    [anon_sym_int240] = ACTIONS(709),
    [anon_sym_int248] = ACTIONS(709),
    [anon_sym_int256] = ACTIONS(709),
    [anon_sym_uint] = ACTIONS(709),
    [anon_sym_uint8] = ACTIONS(709),
    [anon_sym_uint16] = ACTIONS(709),
    [anon_sym_uint24] = ACTIONS(709),
    [anon_sym_uint32] = ACTIONS(709),
    [anon_sym_uint40] = ACTIONS(709),
    [anon_sym_uint48] = ACTIONS(709),
    [anon_sym_uint56] = ACTIONS(709),
    [anon_sym_uint64] = ACTIONS(709),
    [anon_sym_uint72] = ACTIONS(709),
    [anon_sym_uint80] = ACTIONS(709),
    [anon_sym_uint88] = ACTIONS(709),
    [anon_sym_uint96] = ACTIONS(709),
    [anon_sym_uint104] = ACTIONS(709),
    [anon_sym_uint112] = ACTIONS(709),
    [anon_sym_uint120] = ACTIONS(709),
    [anon_sym_uint128] = ACTIONS(709),
    [anon_sym_uint136] = ACTIONS(709),
    [anon_sym_uint144] = ACTIONS(709),
    [anon_sym_uint152] = ACTIONS(709),
    [anon_sym_uint160] = ACTIONS(709),
    [anon_sym_uint168] = ACTIONS(709),
    [anon_sym_uint176] = ACTIONS(709),
    [anon_sym_uint184] = ACTIONS(709),
    [anon_sym_uint192] = ACTIONS(709),
    [anon_sym_uint200] = ACTIONS(709),
    [anon_sym_uint208] = ACTIONS(709),
    [anon_sym_uint216] = ACTIONS(709),
    [anon_sym_uint224] = ACTIONS(709),
    [anon_sym_uint232] = ACTIONS(709),
    [anon_sym_uint240] = ACTIONS(709),
    [anon_sym_uint248] = ACTIONS(709),
    [anon_sym_uint256] = ACTIONS(709),
    [anon_sym_bytes] = ACTIONS(709),
    [anon_sym_bytes1] = ACTIONS(709),
    [anon_sym_bytes2] = ACTIONS(709),
    [anon_sym_bytes3] = ACTIONS(709),
    [anon_sym_bytes4] = ACTIONS(709),
    [anon_sym_bytes5] = ACTIONS(709),
    [anon_sym_bytes6] = ACTIONS(709),
    [anon_sym_bytes7] = ACTIONS(709),
    [anon_sym_bytes8] = ACTIONS(709),
    [anon_sym_bytes9] = ACTIONS(709),
    [anon_sym_bytes10] = ACTIONS(709),
    [anon_sym_bytes11] = ACTIONS(709),
    [anon_sym_bytes12] = ACTIONS(709),
    [anon_sym_bytes13] = ACTIONS(709),
    [anon_sym_bytes14] = ACTIONS(709),
    [anon_sym_bytes15] = ACTIONS(709),
    [anon_sym_bytes16] = ACTIONS(709),
    [anon_sym_bytes17] = ACTIONS(709),
    [anon_sym_bytes18] = ACTIONS(709),
    [anon_sym_bytes19] = ACTIONS(709),
    [anon_sym_bytes20] = ACTIONS(709),
    [anon_sym_bytes21] = ACTIONS(709),
    [anon_sym_bytes22] = ACTIONS(709),
    [anon_sym_bytes23] = ACTIONS(709),
    [anon_sym_bytes24] = ACTIONS(709),
    [anon_sym_bytes25] = ACTIONS(709),
    [anon_sym_bytes26] = ACTIONS(709),
    [anon_sym_bytes27] = ACTIONS(709),
    [anon_sym_bytes28] = ACTIONS(709),
    [anon_sym_bytes29] = ACTIONS(709),
    [anon_sym_bytes30] = ACTIONS(709),
    [anon_sym_bytes31] = ACTIONS(709),
    [anon_sym_bytes32] = ACTIONS(709),
    [anon_sym_fixed] = ACTIONS(709),
    [aux_sym__fixed_token1] = ACTIONS(709),
    [anon_sym_ufixed] = ACTIONS(709),
    [aux_sym__ufixed_token1] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [ts_builtin_sym_end] = ACTIONS(711),
    [sym_identifier] = ACTIONS(713),
    [anon_sym_pragma] = ACTIONS(713),
    [anon_sym_import] = ACTIONS(713),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_abstract] = ACTIONS(713),
    [anon_sym_contract] = ACTIONS(713),
    [anon_sym_error] = ACTIONS(713),
    [anon_sym_interface] = ACTIONS(713),
    [anon_sym_library] = ACTIONS(713),
    [anon_sym_struct] = ACTIONS(713),
    [anon_sym_enum] = ACTIONS(713),
    [anon_sym_event] = ACTIONS(713),
    [anon_sym_function] = ACTIONS(713),
    [anon_sym_byte] = ACTIONS(713),
    [anon_sym_address] = ACTIONS(713),
    [anon_sym_var] = ACTIONS(713),
    [anon_sym_mapping] = ACTIONS(713),
    [anon_sym_bool] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_int] = ACTIONS(713),
    [anon_sym_int8] = ACTIONS(713),
    [anon_sym_int16] = ACTIONS(713),
    [anon_sym_int24] = ACTIONS(713),
    [anon_sym_int32] = ACTIONS(713),
    [anon_sym_int40] = ACTIONS(713),
    [anon_sym_int48] = ACTIONS(713),
    [anon_sym_int56] = ACTIONS(713),
    [anon_sym_int64] = ACTIONS(713),
    [anon_sym_int72] = ACTIONS(713),
    [anon_sym_int80] = ACTIONS(713),
    [anon_sym_int88] = ACTIONS(713),
    [anon_sym_int96] = ACTIONS(713),
    [anon_sym_int104] = ACTIONS(713),
    [anon_sym_int112] = ACTIONS(713),
    [anon_sym_int120] = ACTIONS(713),
    [anon_sym_int128] = ACTIONS(713),
    [anon_sym_int136] = ACTIONS(713),
    [anon_sym_int144] = ACTIONS(713),
    [anon_sym_int152] = ACTIONS(713),
    [anon_sym_int160] = ACTIONS(713),
    [anon_sym_int168] = ACTIONS(713),
    [anon_sym_int176] = ACTIONS(713),
    [anon_sym_int184] = ACTIONS(713),
    [anon_sym_int192] = ACTIONS(713),
    [anon_sym_int200] = ACTIONS(713),
    [anon_sym_int208] = ACTIONS(713),
    [anon_sym_int216] = ACTIONS(713),
    [anon_sym_int224] = ACTIONS(713),
    [anon_sym_int232] = ACTIONS(713),
    [anon_sym_int240] = ACTIONS(713),
    [anon_sym_int248] = ACTIONS(713),
    [anon_sym_int256] = ACTIONS(713),
    [anon_sym_uint] = ACTIONS(713),
    [anon_sym_uint8] = ACTIONS(713),
    [anon_sym_uint16] = ACTIONS(713),
    [anon_sym_uint24] = ACTIONS(713),
    [anon_sym_uint32] = ACTIONS(713),
    [anon_sym_uint40] = ACTIONS(713),
    [anon_sym_uint48] = ACTIONS(713),
    [anon_sym_uint56] = ACTIONS(713),
    [anon_sym_uint64] = ACTIONS(713),
    [anon_sym_uint72] = ACTIONS(713),
    [anon_sym_uint80] = ACTIONS(713),
    [anon_sym_uint88] = ACTIONS(713),
    [anon_sym_uint96] = ACTIONS(713),
    [anon_sym_uint104] = ACTIONS(713),
    [anon_sym_uint112] = ACTIONS(713),
    [anon_sym_uint120] = ACTIONS(713),
    [anon_sym_uint128] = ACTIONS(713),
    [anon_sym_uint136] = ACTIONS(713),
    [anon_sym_uint144] = ACTIONS(713),
    [anon_sym_uint152] = ACTIONS(713),
    [anon_sym_uint160] = ACTIONS(713),
    [anon_sym_uint168] = ACTIONS(713),
    [anon_sym_uint176] = ACTIONS(713),
    [anon_sym_uint184] = ACTIONS(713),
    [anon_sym_uint192] = ACTIONS(713),
    [anon_sym_uint200] = ACTIONS(713),
    [anon_sym_uint208] = ACTIONS(713),
    [anon_sym_uint216] = ACTIONS(713),
    [anon_sym_uint224] = ACTIONS(713),
    [anon_sym_uint232] = ACTIONS(713),
    [anon_sym_uint240] = ACTIONS(713),
    [anon_sym_uint248] = ACTIONS(713),
    [anon_sym_uint256] = ACTIONS(713),
    [anon_sym_bytes] = ACTIONS(713),
    [anon_sym_bytes1] = ACTIONS(713),
    [anon_sym_bytes2] = ACTIONS(713),
    [anon_sym_bytes3] = ACTIONS(713),
    [anon_sym_bytes4] = ACTIONS(713),
    [anon_sym_bytes5] = ACTIONS(713),
    [anon_sym_bytes6] = ACTIONS(713),
    [anon_sym_bytes7] = ACTIONS(713),
    [anon_sym_bytes8] = ACTIONS(713),
    [anon_sym_bytes9] = ACTIONS(713),
    [anon_sym_bytes10] = ACTIONS(713),
    [anon_sym_bytes11] = ACTIONS(713),
    [anon_sym_bytes12] = ACTIONS(713),
    [anon_sym_bytes13] = ACTIONS(713),
    [anon_sym_bytes14] = ACTIONS(713),
    [anon_sym_bytes15] = ACTIONS(713),
    [anon_sym_bytes16] = ACTIONS(713),
    [anon_sym_bytes17] = ACTIONS(713),
    [anon_sym_bytes18] = ACTIONS(713),
    [anon_sym_bytes19] = ACTIONS(713),
    [anon_sym_bytes20] = ACTIONS(713),
    [anon_sym_bytes21] = ACTIONS(713),
    [anon_sym_bytes22] = ACTIONS(713),
    [anon_sym_bytes23] = ACTIONS(713),
    [anon_sym_bytes24] = ACTIONS(713),
    [anon_sym_bytes25] = ACTIONS(713),
    [anon_sym_bytes26] = ACTIONS(713),
    [anon_sym_bytes27] = ACTIONS(713),
    [anon_sym_bytes28] = ACTIONS(713),
    [anon_sym_bytes29] = ACTIONS(713),
    [anon_sym_bytes30] = ACTIONS(713),
    [anon_sym_bytes31] = ACTIONS(713),
    [anon_sym_bytes32] = ACTIONS(713),
    [anon_sym_fixed] = ACTIONS(713),
    [aux_sym__fixed_token1] = ACTIONS(713),
    [anon_sym_ufixed] = ACTIONS(713),
    [aux_sym__ufixed_token1] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [ts_builtin_sym_end] = ACTIONS(715),
    [sym_identifier] = ACTIONS(717),
    [anon_sym_pragma] = ACTIONS(717),
    [anon_sym_import] = ACTIONS(717),
    [anon_sym_type] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(717),
    [anon_sym_contract] = ACTIONS(717),
    [anon_sym_error] = ACTIONS(717),
    [anon_sym_interface] = ACTIONS(717),
    [anon_sym_library] = ACTIONS(717),
    [anon_sym_struct] = ACTIONS(717),
    [anon_sym_enum] = ACTIONS(717),
    [anon_sym_event] = ACTIONS(717),
    [anon_sym_function] = ACTIONS(717),
    [anon_sym_byte] = ACTIONS(717),
    [anon_sym_address] = ACTIONS(717),
    [anon_sym_var] = ACTIONS(717),
    [anon_sym_mapping] = ACTIONS(717),
    [anon_sym_bool] = ACTIONS(717),
    [anon_sym_string] = ACTIONS(717),
    [anon_sym_int] = ACTIONS(717),
    [anon_sym_int8] = ACTIONS(717),
    [anon_sym_int16] = ACTIONS(717),
    [anon_sym_int24] = ACTIONS(717),
    [anon_sym_int32] = ACTIONS(717),
    [anon_sym_int40] = ACTIONS(717),
    [anon_sym_int48] = ACTIONS(717),
    [anon_sym_int56] = ACTIONS(717),
    [anon_sym_int64] = ACTIONS(717),
    [anon_sym_int72] = ACTIONS(717),
    [anon_sym_int80] = ACTIONS(717),
    [anon_sym_int88] = ACTIONS(717),
    [anon_sym_int96] = ACTIONS(717),
    [anon_sym_int104] = ACTIONS(717),
    [anon_sym_int112] = ACTIONS(717),
    [anon_sym_int120] = ACTIONS(717),
    [anon_sym_int128] = ACTIONS(717),
    [anon_sym_int136] = ACTIONS(717),
    [anon_sym_int144] = ACTIONS(717),
    [anon_sym_int152] = ACTIONS(717),
    [anon_sym_int160] = ACTIONS(717),
    [anon_sym_int168] = ACTIONS(717),
    [anon_sym_int176] = ACTIONS(717),
    [anon_sym_int184] = ACTIONS(717),
    [anon_sym_int192] = ACTIONS(717),
    [anon_sym_int200] = ACTIONS(717),
    [anon_sym_int208] = ACTIONS(717),
    [anon_sym_int216] = ACTIONS(717),
    [anon_sym_int224] = ACTIONS(717),
    [anon_sym_int232] = ACTIONS(717),
    [anon_sym_int240] = ACTIONS(717),
    [anon_sym_int248] = ACTIONS(717),
    [anon_sym_int256] = ACTIONS(717),
    [anon_sym_uint] = ACTIONS(717),
    [anon_sym_uint8] = ACTIONS(717),
    [anon_sym_uint16] = ACTIONS(717),
    [anon_sym_uint24] = ACTIONS(717),
    [anon_sym_uint32] = ACTIONS(717),
    [anon_sym_uint40] = ACTIONS(717),
    [anon_sym_uint48] = ACTIONS(717),
    [anon_sym_uint56] = ACTIONS(717),
    [anon_sym_uint64] = ACTIONS(717),
    [anon_sym_uint72] = ACTIONS(717),
    [anon_sym_uint80] = ACTIONS(717),
    [anon_sym_uint88] = ACTIONS(717),
    [anon_sym_uint96] = ACTIONS(717),
    [anon_sym_uint104] = ACTIONS(717),
    [anon_sym_uint112] = ACTIONS(717),
    [anon_sym_uint120] = ACTIONS(717),
    [anon_sym_uint128] = ACTIONS(717),
    [anon_sym_uint136] = ACTIONS(717),
    [anon_sym_uint144] = ACTIONS(717),
    [anon_sym_uint152] = ACTIONS(717),
    [anon_sym_uint160] = ACTIONS(717),
    [anon_sym_uint168] = ACTIONS(717),
    [anon_sym_uint176] = ACTIONS(717),
    [anon_sym_uint184] = ACTIONS(717),
    [anon_sym_uint192] = ACTIONS(717),
    [anon_sym_uint200] = ACTIONS(717),
    [anon_sym_uint208] = ACTIONS(717),
    [anon_sym_uint216] = ACTIONS(717),
    [anon_sym_uint224] = ACTIONS(717),
    [anon_sym_uint232] = ACTIONS(717),
    [anon_sym_uint240] = ACTIONS(717),
    [anon_sym_uint248] = ACTIONS(717),
    [anon_sym_uint256] = ACTIONS(717),
    [anon_sym_bytes] = ACTIONS(717),
    [anon_sym_bytes1] = ACTIONS(717),
    [anon_sym_bytes2] = ACTIONS(717),
    [anon_sym_bytes3] = ACTIONS(717),
    [anon_sym_bytes4] = ACTIONS(717),
    [anon_sym_bytes5] = ACTIONS(717),
    [anon_sym_bytes6] = ACTIONS(717),
    [anon_sym_bytes7] = ACTIONS(717),
    [anon_sym_bytes8] = ACTIONS(717),
    [anon_sym_bytes9] = ACTIONS(717),
    [anon_sym_bytes10] = ACTIONS(717),
    [anon_sym_bytes11] = ACTIONS(717),
    [anon_sym_bytes12] = ACTIONS(717),
    [anon_sym_bytes13] = ACTIONS(717),
    [anon_sym_bytes14] = ACTIONS(717),
    [anon_sym_bytes15] = ACTIONS(717),
    [anon_sym_bytes16] = ACTIONS(717),
    [anon_sym_bytes17] = ACTIONS(717),
    [anon_sym_bytes18] = ACTIONS(717),
    [anon_sym_bytes19] = ACTIONS(717),
    [anon_sym_bytes20] = ACTIONS(717),
    [anon_sym_bytes21] = ACTIONS(717),
    [anon_sym_bytes22] = ACTIONS(717),
    [anon_sym_bytes23] = ACTIONS(717),
    [anon_sym_bytes24] = ACTIONS(717),
    [anon_sym_bytes25] = ACTIONS(717),
    [anon_sym_bytes26] = ACTIONS(717),
    [anon_sym_bytes27] = ACTIONS(717),
    [anon_sym_bytes28] = ACTIONS(717),
    [anon_sym_bytes29] = ACTIONS(717),
    [anon_sym_bytes30] = ACTIONS(717),
    [anon_sym_bytes31] = ACTIONS(717),
    [anon_sym_bytes32] = ACTIONS(717),
    [anon_sym_fixed] = ACTIONS(717),
    [aux_sym__fixed_token1] = ACTIONS(717),
    [anon_sym_ufixed] = ACTIONS(717),
    [aux_sym__ufixed_token1] = ACTIONS(717),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_type_name] = STATE(596),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [ts_builtin_sym_end] = ACTIONS(719),
    [sym_identifier] = ACTIONS(721),
    [anon_sym_pragma] = ACTIONS(721),
    [anon_sym_import] = ACTIONS(721),
    [anon_sym_type] = ACTIONS(721),
    [anon_sym_abstract] = ACTIONS(721),
    [anon_sym_contract] = ACTIONS(721),
    [anon_sym_error] = ACTIONS(721),
    [anon_sym_interface] = ACTIONS(721),
    [anon_sym_library] = ACTIONS(721),
    [anon_sym_struct] = ACTIONS(721),
    [anon_sym_enum] = ACTIONS(721),
    [anon_sym_event] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(721),
    [anon_sym_byte] = ACTIONS(721),
    [anon_sym_address] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(721),
    [anon_sym_mapping] = ACTIONS(721),
    [anon_sym_bool] = ACTIONS(721),
    [anon_sym_string] = ACTIONS(721),
    [anon_sym_int] = ACTIONS(721),
    [anon_sym_int8] = ACTIONS(721),
    [anon_sym_int16] = ACTIONS(721),
    [anon_sym_int24] = ACTIONS(721),
    [anon_sym_int32] = ACTIONS(721),
    [anon_sym_int40] = ACTIONS(721),
    [anon_sym_int48] = ACTIONS(721),
    [anon_sym_int56] = ACTIONS(721),
    [anon_sym_int64] = ACTIONS(721),
    [anon_sym_int72] = ACTIONS(721),
    [anon_sym_int80] = ACTIONS(721),
    [anon_sym_int88] = ACTIONS(721),
    [anon_sym_int96] = ACTIONS(721),
    [anon_sym_int104] = ACTIONS(721),
    [anon_sym_int112] = ACTIONS(721),
    [anon_sym_int120] = ACTIONS(721),
    [anon_sym_int128] = ACTIONS(721),
    [anon_sym_int136] = ACTIONS(721),
    [anon_sym_int144] = ACTIONS(721),
    [anon_sym_int152] = ACTIONS(721),
    [anon_sym_int160] = ACTIONS(721),
    [anon_sym_int168] = ACTIONS(721),
    [anon_sym_int176] = ACTIONS(721),
    [anon_sym_int184] = ACTIONS(721),
    [anon_sym_int192] = ACTIONS(721),
    [anon_sym_int200] = ACTIONS(721),
    [anon_sym_int208] = ACTIONS(721),
    [anon_sym_int216] = ACTIONS(721),
    [anon_sym_int224] = ACTIONS(721),
    [anon_sym_int232] = ACTIONS(721),
    [anon_sym_int240] = ACTIONS(721),
    [anon_sym_int248] = ACTIONS(721),
    [anon_sym_int256] = ACTIONS(721),
    [anon_sym_uint] = ACTIONS(721),
    [anon_sym_uint8] = ACTIONS(721),
    [anon_sym_uint16] = ACTIONS(721),
    [anon_sym_uint24] = ACTIONS(721),
    [anon_sym_uint32] = ACTIONS(721),
    [anon_sym_uint40] = ACTIONS(721),
    [anon_sym_uint48] = ACTIONS(721),
    [anon_sym_uint56] = ACTIONS(721),
    [anon_sym_uint64] = ACTIONS(721),
    [anon_sym_uint72] = ACTIONS(721),
    [anon_sym_uint80] = ACTIONS(721),
    [anon_sym_uint88] = ACTIONS(721),
    [anon_sym_uint96] = ACTIONS(721),
    [anon_sym_uint104] = ACTIONS(721),
    [anon_sym_uint112] = ACTIONS(721),
    [anon_sym_uint120] = ACTIONS(721),
    [anon_sym_uint128] = ACTIONS(721),
    [anon_sym_uint136] = ACTIONS(721),
    [anon_sym_uint144] = ACTIONS(721),
    [anon_sym_uint152] = ACTIONS(721),
    [anon_sym_uint160] = ACTIONS(721),
    [anon_sym_uint168] = ACTIONS(721),
    [anon_sym_uint176] = ACTIONS(721),
    [anon_sym_uint184] = ACTIONS(721),
    [anon_sym_uint192] = ACTIONS(721),
    [anon_sym_uint200] = ACTIONS(721),
    [anon_sym_uint208] = ACTIONS(721),
    [anon_sym_uint216] = ACTIONS(721),
    [anon_sym_uint224] = ACTIONS(721),
    [anon_sym_uint232] = ACTIONS(721),
    [anon_sym_uint240] = ACTIONS(721),
    [anon_sym_uint248] = ACTIONS(721),
    [anon_sym_uint256] = ACTIONS(721),
    [anon_sym_bytes] = ACTIONS(721),
    [anon_sym_bytes1] = ACTIONS(721),
    [anon_sym_bytes2] = ACTIONS(721),
    [anon_sym_bytes3] = ACTIONS(721),
    [anon_sym_bytes4] = ACTIONS(721),
    [anon_sym_bytes5] = ACTIONS(721),
    [anon_sym_bytes6] = ACTIONS(721),
    [anon_sym_bytes7] = ACTIONS(721),
    [anon_sym_bytes8] = ACTIONS(721),
    [anon_sym_bytes9] = ACTIONS(721),
    [anon_sym_bytes10] = ACTIONS(721),
    [anon_sym_bytes11] = ACTIONS(721),
    [anon_sym_bytes12] = ACTIONS(721),
    [anon_sym_bytes13] = ACTIONS(721),
    [anon_sym_bytes14] = ACTIONS(721),
    [anon_sym_bytes15] = ACTIONS(721),
    [anon_sym_bytes16] = ACTIONS(721),
    [anon_sym_bytes17] = ACTIONS(721),
    [anon_sym_bytes18] = ACTIONS(721),
    [anon_sym_bytes19] = ACTIONS(721),
    [anon_sym_bytes20] = ACTIONS(721),
    [anon_sym_bytes21] = ACTIONS(721),
    [anon_sym_bytes22] = ACTIONS(721),
    [anon_sym_bytes23] = ACTIONS(721),
    [anon_sym_bytes24] = ACTIONS(721),
    [anon_sym_bytes25] = ACTIONS(721),
    [anon_sym_bytes26] = ACTIONS(721),
    [anon_sym_bytes27] = ACTIONS(721),
    [anon_sym_bytes28] = ACTIONS(721),
    [anon_sym_bytes29] = ACTIONS(721),
    [anon_sym_bytes30] = ACTIONS(721),
    [anon_sym_bytes31] = ACTIONS(721),
    [anon_sym_bytes32] = ACTIONS(721),
    [anon_sym_fixed] = ACTIONS(721),
    [aux_sym__fixed_token1] = ACTIONS(721),
    [anon_sym_ufixed] = ACTIONS(721),
    [aux_sym__ufixed_token1] = ACTIONS(721),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [ts_builtin_sym_end] = ACTIONS(723),
    [sym_identifier] = ACTIONS(725),
    [anon_sym_pragma] = ACTIONS(725),
    [anon_sym_import] = ACTIONS(725),
    [anon_sym_type] = ACTIONS(725),
    [anon_sym_abstract] = ACTIONS(725),
    [anon_sym_contract] = ACTIONS(725),
    [anon_sym_error] = ACTIONS(725),
    [anon_sym_interface] = ACTIONS(725),
    [anon_sym_library] = ACTIONS(725),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_enum] = ACTIONS(725),
    [anon_sym_event] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(725),
    [anon_sym_byte] = ACTIONS(725),
    [anon_sym_address] = ACTIONS(725),
    [anon_sym_var] = ACTIONS(725),
    [anon_sym_mapping] = ACTIONS(725),
    [anon_sym_bool] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_int] = ACTIONS(725),
    [anon_sym_int8] = ACTIONS(725),
    [anon_sym_int16] = ACTIONS(725),
    [anon_sym_int24] = ACTIONS(725),
    [anon_sym_int32] = ACTIONS(725),
    [anon_sym_int40] = ACTIONS(725),
    [anon_sym_int48] = ACTIONS(725),
    [anon_sym_int56] = ACTIONS(725),
    [anon_sym_int64] = ACTIONS(725),
    [anon_sym_int72] = ACTIONS(725),
    [anon_sym_int80] = ACTIONS(725),
    [anon_sym_int88] = ACTIONS(725),
    [anon_sym_int96] = ACTIONS(725),
    [anon_sym_int104] = ACTIONS(725),
    [anon_sym_int112] = ACTIONS(725),
    [anon_sym_int120] = ACTIONS(725),
    [anon_sym_int128] = ACTIONS(725),
    [anon_sym_int136] = ACTIONS(725),
    [anon_sym_int144] = ACTIONS(725),
    [anon_sym_int152] = ACTIONS(725),
    [anon_sym_int160] = ACTIONS(725),
    [anon_sym_int168] = ACTIONS(725),
    [anon_sym_int176] = ACTIONS(725),
    [anon_sym_int184] = ACTIONS(725),
    [anon_sym_int192] = ACTIONS(725),
    [anon_sym_int200] = ACTIONS(725),
    [anon_sym_int208] = ACTIONS(725),
    [anon_sym_int216] = ACTIONS(725),
    [anon_sym_int224] = ACTIONS(725),
    [anon_sym_int232] = ACTIONS(725),
    [anon_sym_int240] = ACTIONS(725),
    [anon_sym_int248] = ACTIONS(725),
    [anon_sym_int256] = ACTIONS(725),
    [anon_sym_uint] = ACTIONS(725),
    [anon_sym_uint8] = ACTIONS(725),
    [anon_sym_uint16] = ACTIONS(725),
    [anon_sym_uint24] = ACTIONS(725),
    [anon_sym_uint32] = ACTIONS(725),
    [anon_sym_uint40] = ACTIONS(725),
    [anon_sym_uint48] = ACTIONS(725),
    [anon_sym_uint56] = ACTIONS(725),
    [anon_sym_uint64] = ACTIONS(725),
    [anon_sym_uint72] = ACTIONS(725),
    [anon_sym_uint80] = ACTIONS(725),
    [anon_sym_uint88] = ACTIONS(725),
    [anon_sym_uint96] = ACTIONS(725),
    [anon_sym_uint104] = ACTIONS(725),
    [anon_sym_uint112] = ACTIONS(725),
    [anon_sym_uint120] = ACTIONS(725),
    [anon_sym_uint128] = ACTIONS(725),
    [anon_sym_uint136] = ACTIONS(725),
    [anon_sym_uint144] = ACTIONS(725),
    [anon_sym_uint152] = ACTIONS(725),
    [anon_sym_uint160] = ACTIONS(725),
    [anon_sym_uint168] = ACTIONS(725),
    [anon_sym_uint176] = ACTIONS(725),
    [anon_sym_uint184] = ACTIONS(725),
    [anon_sym_uint192] = ACTIONS(725),
    [anon_sym_uint200] = ACTIONS(725),
    [anon_sym_uint208] = ACTIONS(725),
    [anon_sym_uint216] = ACTIONS(725),
    [anon_sym_uint224] = ACTIONS(725),
    [anon_sym_uint232] = ACTIONS(725),
    [anon_sym_uint240] = ACTIONS(725),
    [anon_sym_uint248] = ACTIONS(725),
    [anon_sym_uint256] = ACTIONS(725),
    [anon_sym_bytes] = ACTIONS(725),
    [anon_sym_bytes1] = ACTIONS(725),
    [anon_sym_bytes2] = ACTIONS(725),
    [anon_sym_bytes3] = ACTIONS(725),
    [anon_sym_bytes4] = ACTIONS(725),
    [anon_sym_bytes5] = ACTIONS(725),
    [anon_sym_bytes6] = ACTIONS(725),
    [anon_sym_bytes7] = ACTIONS(725),
    [anon_sym_bytes8] = ACTIONS(725),
    [anon_sym_bytes9] = ACTIONS(725),
    [anon_sym_bytes10] = ACTIONS(725),
    [anon_sym_bytes11] = ACTIONS(725),
    [anon_sym_bytes12] = ACTIONS(725),
    [anon_sym_bytes13] = ACTIONS(725),
    [anon_sym_bytes14] = ACTIONS(725),
    [anon_sym_bytes15] = ACTIONS(725),
    [anon_sym_bytes16] = ACTIONS(725),
    [anon_sym_bytes17] = ACTIONS(725),
    [anon_sym_bytes18] = ACTIONS(725),
    [anon_sym_bytes19] = ACTIONS(725),
    [anon_sym_bytes20] = ACTIONS(725),
    [anon_sym_bytes21] = ACTIONS(725),
    [anon_sym_bytes22] = ACTIONS(725),
    [anon_sym_bytes23] = ACTIONS(725),
    [anon_sym_bytes24] = ACTIONS(725),
    [anon_sym_bytes25] = ACTIONS(725),
    [anon_sym_bytes26] = ACTIONS(725),
    [anon_sym_bytes27] = ACTIONS(725),
    [anon_sym_bytes28] = ACTIONS(725),
    [anon_sym_bytes29] = ACTIONS(725),
    [anon_sym_bytes30] = ACTIONS(725),
    [anon_sym_bytes31] = ACTIONS(725),
    [anon_sym_bytes32] = ACTIONS(725),
    [anon_sym_fixed] = ACTIONS(725),
    [aux_sym__fixed_token1] = ACTIONS(725),
    [anon_sym_ufixed] = ACTIONS(725),
    [aux_sym__ufixed_token1] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(727),
    [sym_identifier] = ACTIONS(729),
    [anon_sym_pragma] = ACTIONS(729),
    [anon_sym_import] = ACTIONS(729),
    [anon_sym_type] = ACTIONS(729),
    [anon_sym_abstract] = ACTIONS(729),
    [anon_sym_contract] = ACTIONS(729),
    [anon_sym_error] = ACTIONS(729),
    [anon_sym_interface] = ACTIONS(729),
    [anon_sym_library] = ACTIONS(729),
    [anon_sym_struct] = ACTIONS(729),
    [anon_sym_enum] = ACTIONS(729),
    [anon_sym_event] = ACTIONS(729),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_byte] = ACTIONS(729),
    [anon_sym_address] = ACTIONS(729),
    [anon_sym_var] = ACTIONS(729),
    [anon_sym_mapping] = ACTIONS(729),
    [anon_sym_bool] = ACTIONS(729),
    [anon_sym_string] = ACTIONS(729),
    [anon_sym_int] = ACTIONS(729),
    [anon_sym_int8] = ACTIONS(729),
    [anon_sym_int16] = ACTIONS(729),
    [anon_sym_int24] = ACTIONS(729),
    [anon_sym_int32] = ACTIONS(729),
    [anon_sym_int40] = ACTIONS(729),
    [anon_sym_int48] = ACTIONS(729),
    [anon_sym_int56] = ACTIONS(729),
    [anon_sym_int64] = ACTIONS(729),
    [anon_sym_int72] = ACTIONS(729),
    [anon_sym_int80] = ACTIONS(729),
    [anon_sym_int88] = ACTIONS(729),
    [anon_sym_int96] = ACTIONS(729),
    [anon_sym_int104] = ACTIONS(729),
    [anon_sym_int112] = ACTIONS(729),
    [anon_sym_int120] = ACTIONS(729),
    [anon_sym_int128] = ACTIONS(729),
    [anon_sym_int136] = ACTIONS(729),
    [anon_sym_int144] = ACTIONS(729),
    [anon_sym_int152] = ACTIONS(729),
    [anon_sym_int160] = ACTIONS(729),
    [anon_sym_int168] = ACTIONS(729),
    [anon_sym_int176] = ACTIONS(729),
    [anon_sym_int184] = ACTIONS(729),
    [anon_sym_int192] = ACTIONS(729),
    [anon_sym_int200] = ACTIONS(729),
    [anon_sym_int208] = ACTIONS(729),
    [anon_sym_int216] = ACTIONS(729),
    [anon_sym_int224] = ACTIONS(729),
    [anon_sym_int232] = ACTIONS(729),
    [anon_sym_int240] = ACTIONS(729),
    [anon_sym_int248] = ACTIONS(729),
    [anon_sym_int256] = ACTIONS(729),
    [anon_sym_uint] = ACTIONS(729),
    [anon_sym_uint8] = ACTIONS(729),
    [anon_sym_uint16] = ACTIONS(729),
    [anon_sym_uint24] = ACTIONS(729),
    [anon_sym_uint32] = ACTIONS(729),
    [anon_sym_uint40] = ACTIONS(729),
    [anon_sym_uint48] = ACTIONS(729),
    [anon_sym_uint56] = ACTIONS(729),
    [anon_sym_uint64] = ACTIONS(729),
    [anon_sym_uint72] = ACTIONS(729),
    [anon_sym_uint80] = ACTIONS(729),
    [anon_sym_uint88] = ACTIONS(729),
    [anon_sym_uint96] = ACTIONS(729),
    [anon_sym_uint104] = ACTIONS(729),
    [anon_sym_uint112] = ACTIONS(729),
    [anon_sym_uint120] = ACTIONS(729),
    [anon_sym_uint128] = ACTIONS(729),
    [anon_sym_uint136] = ACTIONS(729),
    [anon_sym_uint144] = ACTIONS(729),
    [anon_sym_uint152] = ACTIONS(729),
    [anon_sym_uint160] = ACTIONS(729),
    [anon_sym_uint168] = ACTIONS(729),
    [anon_sym_uint176] = ACTIONS(729),
    [anon_sym_uint184] = ACTIONS(729),
    [anon_sym_uint192] = ACTIONS(729),
    [anon_sym_uint200] = ACTIONS(729),
    [anon_sym_uint208] = ACTIONS(729),
    [anon_sym_uint216] = ACTIONS(729),
    [anon_sym_uint224] = ACTIONS(729),
    [anon_sym_uint232] = ACTIONS(729),
    [anon_sym_uint240] = ACTIONS(729),
    [anon_sym_uint248] = ACTIONS(729),
    [anon_sym_uint256] = ACTIONS(729),
    [anon_sym_bytes] = ACTIONS(729),
    [anon_sym_bytes1] = ACTIONS(729),
    [anon_sym_bytes2] = ACTIONS(729),
    [anon_sym_bytes3] = ACTIONS(729),
    [anon_sym_bytes4] = ACTIONS(729),
    [anon_sym_bytes5] = ACTIONS(729),
    [anon_sym_bytes6] = ACTIONS(729),
    [anon_sym_bytes7] = ACTIONS(729),
    [anon_sym_bytes8] = ACTIONS(729),
    [anon_sym_bytes9] = ACTIONS(729),
    [anon_sym_bytes10] = ACTIONS(729),
    [anon_sym_bytes11] = ACTIONS(729),
    [anon_sym_bytes12] = ACTIONS(729),
    [anon_sym_bytes13] = ACTIONS(729),
    [anon_sym_bytes14] = ACTIONS(729),
    [anon_sym_bytes15] = ACTIONS(729),
    [anon_sym_bytes16] = ACTIONS(729),
    [anon_sym_bytes17] = ACTIONS(729),
    [anon_sym_bytes18] = ACTIONS(729),
    [anon_sym_bytes19] = ACTIONS(729),
    [anon_sym_bytes20] = ACTIONS(729),
    [anon_sym_bytes21] = ACTIONS(729),
    [anon_sym_bytes22] = ACTIONS(729),
    [anon_sym_bytes23] = ACTIONS(729),
    [anon_sym_bytes24] = ACTIONS(729),
    [anon_sym_bytes25] = ACTIONS(729),
    [anon_sym_bytes26] = ACTIONS(729),
    [anon_sym_bytes27] = ACTIONS(729),
    [anon_sym_bytes28] = ACTIONS(729),
    [anon_sym_bytes29] = ACTIONS(729),
    [anon_sym_bytes30] = ACTIONS(729),
    [anon_sym_bytes31] = ACTIONS(729),
    [anon_sym_bytes32] = ACTIONS(729),
    [anon_sym_fixed] = ACTIONS(729),
    [aux_sym__fixed_token1] = ACTIONS(729),
    [anon_sym_ufixed] = ACTIONS(729),
    [aux_sym__ufixed_token1] = ACTIONS(729),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(731),
    [sym_identifier] = ACTIONS(733),
    [anon_sym_pragma] = ACTIONS(733),
    [anon_sym_import] = ACTIONS(733),
    [anon_sym_type] = ACTIONS(733),
    [anon_sym_abstract] = ACTIONS(733),
    [anon_sym_contract] = ACTIONS(733),
    [anon_sym_error] = ACTIONS(733),
    [anon_sym_interface] = ACTIONS(733),
    [anon_sym_library] = ACTIONS(733),
    [anon_sym_struct] = ACTIONS(733),
    [anon_sym_enum] = ACTIONS(733),
    [anon_sym_event] = ACTIONS(733),
    [anon_sym_function] = ACTIONS(733),
    [anon_sym_byte] = ACTIONS(733),
    [anon_sym_address] = ACTIONS(733),
    [anon_sym_var] = ACTIONS(733),
    [anon_sym_mapping] = ACTIONS(733),
    [anon_sym_bool] = ACTIONS(733),
    [anon_sym_string] = ACTIONS(733),
    [anon_sym_int] = ACTIONS(733),
    [anon_sym_int8] = ACTIONS(733),
    [anon_sym_int16] = ACTIONS(733),
    [anon_sym_int24] = ACTIONS(733),
    [anon_sym_int32] = ACTIONS(733),
    [anon_sym_int40] = ACTIONS(733),
    [anon_sym_int48] = ACTIONS(733),
    [anon_sym_int56] = ACTIONS(733),
    [anon_sym_int64] = ACTIONS(733),
    [anon_sym_int72] = ACTIONS(733),
    [anon_sym_int80] = ACTIONS(733),
    [anon_sym_int88] = ACTIONS(733),
    [anon_sym_int96] = ACTIONS(733),
    [anon_sym_int104] = ACTIONS(733),
    [anon_sym_int112] = ACTIONS(733),
    [anon_sym_int120] = ACTIONS(733),
    [anon_sym_int128] = ACTIONS(733),
    [anon_sym_int136] = ACTIONS(733),
    [anon_sym_int144] = ACTIONS(733),
    [anon_sym_int152] = ACTIONS(733),
    [anon_sym_int160] = ACTIONS(733),
    [anon_sym_int168] = ACTIONS(733),
    [anon_sym_int176] = ACTIONS(733),
    [anon_sym_int184] = ACTIONS(733),
    [anon_sym_int192] = ACTIONS(733),
    [anon_sym_int200] = ACTIONS(733),
    [anon_sym_int208] = ACTIONS(733),
    [anon_sym_int216] = ACTIONS(733),
    [anon_sym_int224] = ACTIONS(733),
    [anon_sym_int232] = ACTIONS(733),
    [anon_sym_int240] = ACTIONS(733),
    [anon_sym_int248] = ACTIONS(733),
    [anon_sym_int256] = ACTIONS(733),
    [anon_sym_uint] = ACTIONS(733),
    [anon_sym_uint8] = ACTIONS(733),
    [anon_sym_uint16] = ACTIONS(733),
    [anon_sym_uint24] = ACTIONS(733),
    [anon_sym_uint32] = ACTIONS(733),
    [anon_sym_uint40] = ACTIONS(733),
    [anon_sym_uint48] = ACTIONS(733),
    [anon_sym_uint56] = ACTIONS(733),
    [anon_sym_uint64] = ACTIONS(733),
    [anon_sym_uint72] = ACTIONS(733),
    [anon_sym_uint80] = ACTIONS(733),
    [anon_sym_uint88] = ACTIONS(733),
    [anon_sym_uint96] = ACTIONS(733),
    [anon_sym_uint104] = ACTIONS(733),
    [anon_sym_uint112] = ACTIONS(733),
    [anon_sym_uint120] = ACTIONS(733),
    [anon_sym_uint128] = ACTIONS(733),
    [anon_sym_uint136] = ACTIONS(733),
    [anon_sym_uint144] = ACTIONS(733),
    [anon_sym_uint152] = ACTIONS(733),
    [anon_sym_uint160] = ACTIONS(733),
    [anon_sym_uint168] = ACTIONS(733),
    [anon_sym_uint176] = ACTIONS(733),
    [anon_sym_uint184] = ACTIONS(733),
    [anon_sym_uint192] = ACTIONS(733),
    [anon_sym_uint200] = ACTIONS(733),
    [anon_sym_uint208] = ACTIONS(733),
    [anon_sym_uint216] = ACTIONS(733),
    [anon_sym_uint224] = ACTIONS(733),
    [anon_sym_uint232] = ACTIONS(733),
    [anon_sym_uint240] = ACTIONS(733),
    [anon_sym_uint248] = ACTIONS(733),
    [anon_sym_uint256] = ACTIONS(733),
    [anon_sym_bytes] = ACTIONS(733),
    [anon_sym_bytes1] = ACTIONS(733),
    [anon_sym_bytes2] = ACTIONS(733),
    [anon_sym_bytes3] = ACTIONS(733),
    [anon_sym_bytes4] = ACTIONS(733),
    [anon_sym_bytes5] = ACTIONS(733),
    [anon_sym_bytes6] = ACTIONS(733),
    [anon_sym_bytes7] = ACTIONS(733),
    [anon_sym_bytes8] = ACTIONS(733),
    [anon_sym_bytes9] = ACTIONS(733),
    [anon_sym_bytes10] = ACTIONS(733),
    [anon_sym_bytes11] = ACTIONS(733),
    [anon_sym_bytes12] = ACTIONS(733),
    [anon_sym_bytes13] = ACTIONS(733),
    [anon_sym_bytes14] = ACTIONS(733),
    [anon_sym_bytes15] = ACTIONS(733),
    [anon_sym_bytes16] = ACTIONS(733),
    [anon_sym_bytes17] = ACTIONS(733),
    [anon_sym_bytes18] = ACTIONS(733),
    [anon_sym_bytes19] = ACTIONS(733),
    [anon_sym_bytes20] = ACTIONS(733),
    [anon_sym_bytes21] = ACTIONS(733),
    [anon_sym_bytes22] = ACTIONS(733),
    [anon_sym_bytes23] = ACTIONS(733),
    [anon_sym_bytes24] = ACTIONS(733),
    [anon_sym_bytes25] = ACTIONS(733),
    [anon_sym_bytes26] = ACTIONS(733),
    [anon_sym_bytes27] = ACTIONS(733),
    [anon_sym_bytes28] = ACTIONS(733),
    [anon_sym_bytes29] = ACTIONS(733),
    [anon_sym_bytes30] = ACTIONS(733),
    [anon_sym_bytes31] = ACTIONS(733),
    [anon_sym_bytes32] = ACTIONS(733),
    [anon_sym_fixed] = ACTIONS(733),
    [aux_sym__fixed_token1] = ACTIONS(733),
    [anon_sym_ufixed] = ACTIONS(733),
    [aux_sym__ufixed_token1] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_type_name] = STATE(707),
    [sym__array_type] = STATE(345),
    [sym__function_type] = STATE(351),
    [sym_user_defined_type] = STATE(345),
    [sym__identifier_path] = STATE(336),
    [sym__mapping] = STATE(353),
    [sym_primitive_type] = STATE(345),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [ts_builtin_sym_end] = ACTIONS(735),
    [sym_identifier] = ACTIONS(737),
    [anon_sym_pragma] = ACTIONS(737),
    [anon_sym_import] = ACTIONS(737),
    [anon_sym_type] = ACTIONS(737),
    [anon_sym_abstract] = ACTIONS(737),
    [anon_sym_contract] = ACTIONS(737),
    [anon_sym_error] = ACTIONS(737),
    [anon_sym_interface] = ACTIONS(737),
    [anon_sym_library] = ACTIONS(737),
    [anon_sym_struct] = ACTIONS(737),
    [anon_sym_enum] = ACTIONS(737),
    [anon_sym_event] = ACTIONS(737),
    [anon_sym_function] = ACTIONS(737),
    [anon_sym_byte] = ACTIONS(737),
    [anon_sym_address] = ACTIONS(737),
    [anon_sym_var] = ACTIONS(737),
    [anon_sym_mapping] = ACTIONS(737),
    [anon_sym_bool] = ACTIONS(737),
    [anon_sym_string] = ACTIONS(737),
    [anon_sym_int] = ACTIONS(737),
    [anon_sym_int8] = ACTIONS(737),
    [anon_sym_int16] = ACTIONS(737),
    [anon_sym_int24] = ACTIONS(737),
    [anon_sym_int32] = ACTIONS(737),
    [anon_sym_int40] = ACTIONS(737),
    [anon_sym_int48] = ACTIONS(737),
    [anon_sym_int56] = ACTIONS(737),
    [anon_sym_int64] = ACTIONS(737),
    [anon_sym_int72] = ACTIONS(737),
    [anon_sym_int80] = ACTIONS(737),
    [anon_sym_int88] = ACTIONS(737),
    [anon_sym_int96] = ACTIONS(737),
    [anon_sym_int104] = ACTIONS(737),
    [anon_sym_int112] = ACTIONS(737),
    [anon_sym_int120] = ACTIONS(737),
    [anon_sym_int128] = ACTIONS(737),
    [anon_sym_int136] = ACTIONS(737),
    [anon_sym_int144] = ACTIONS(737),
    [anon_sym_int152] = ACTIONS(737),
    [anon_sym_int160] = ACTIONS(737),
    [anon_sym_int168] = ACTIONS(737),
    [anon_sym_int176] = ACTIONS(737),
    [anon_sym_int184] = ACTIONS(737),
    [anon_sym_int192] = ACTIONS(737),
    [anon_sym_int200] = ACTIONS(737),
    [anon_sym_int208] = ACTIONS(737),
    [anon_sym_int216] = ACTIONS(737),
    [anon_sym_int224] = ACTIONS(737),
    [anon_sym_int232] = ACTIONS(737),
    [anon_sym_int240] = ACTIONS(737),
    [anon_sym_int248] = ACTIONS(737),
    [anon_sym_int256] = ACTIONS(737),
    [anon_sym_uint] = ACTIONS(737),
    [anon_sym_uint8] = ACTIONS(737),
    [anon_sym_uint16] = ACTIONS(737),
    [anon_sym_uint24] = ACTIONS(737),
    [anon_sym_uint32] = ACTIONS(737),
    [anon_sym_uint40] = ACTIONS(737),
    [anon_sym_uint48] = ACTIONS(737),
    [anon_sym_uint56] = ACTIONS(737),
    [anon_sym_uint64] = ACTIONS(737),
    [anon_sym_uint72] = ACTIONS(737),
    [anon_sym_uint80] = ACTIONS(737),
    [anon_sym_uint88] = ACTIONS(737),
    [anon_sym_uint96] = ACTIONS(737),
    [anon_sym_uint104] = ACTIONS(737),
    [anon_sym_uint112] = ACTIONS(737),
    [anon_sym_uint120] = ACTIONS(737),
    [anon_sym_uint128] = ACTIONS(737),
    [anon_sym_uint136] = ACTIONS(737),
    [anon_sym_uint144] = ACTIONS(737),
    [anon_sym_uint152] = ACTIONS(737),
    [anon_sym_uint160] = ACTIONS(737),
    [anon_sym_uint168] = ACTIONS(737),
    [anon_sym_uint176] = ACTIONS(737),
    [anon_sym_uint184] = ACTIONS(737),
    [anon_sym_uint192] = ACTIONS(737),
    [anon_sym_uint200] = ACTIONS(737),
    [anon_sym_uint208] = ACTIONS(737),
    [anon_sym_uint216] = ACTIONS(737),
    [anon_sym_uint224] = ACTIONS(737),
    [anon_sym_uint232] = ACTIONS(737),
    [anon_sym_uint240] = ACTIONS(737),
    [anon_sym_uint248] = ACTIONS(737),
    [anon_sym_uint256] = ACTIONS(737),
    [anon_sym_bytes] = ACTIONS(737),
    [anon_sym_bytes1] = ACTIONS(737),
    [anon_sym_bytes2] = ACTIONS(737),
    [anon_sym_bytes3] = ACTIONS(737),
    [anon_sym_bytes4] = ACTIONS(737),
    [anon_sym_bytes5] = ACTIONS(737),
    [anon_sym_bytes6] = ACTIONS(737),
    [anon_sym_bytes7] = ACTIONS(737),
    [anon_sym_bytes8] = ACTIONS(737),
    [anon_sym_bytes9] = ACTIONS(737),
    [anon_sym_bytes10] = ACTIONS(737),
    [anon_sym_bytes11] = ACTIONS(737),
    [anon_sym_bytes12] = ACTIONS(737),
    [anon_sym_bytes13] = ACTIONS(737),
    [anon_sym_bytes14] = ACTIONS(737),
    [anon_sym_bytes15] = ACTIONS(737),
    [anon_sym_bytes16] = ACTIONS(737),
    [anon_sym_bytes17] = ACTIONS(737),
    [anon_sym_bytes18] = ACTIONS(737),
    [anon_sym_bytes19] = ACTIONS(737),
    [anon_sym_bytes20] = ACTIONS(737),
    [anon_sym_bytes21] = ACTIONS(737),
    [anon_sym_bytes22] = ACTIONS(737),
    [anon_sym_bytes23] = ACTIONS(737),
    [anon_sym_bytes24] = ACTIONS(737),
    [anon_sym_bytes25] = ACTIONS(737),
    [anon_sym_bytes26] = ACTIONS(737),
    [anon_sym_bytes27] = ACTIONS(737),
    [anon_sym_bytes28] = ACTIONS(737),
    [anon_sym_bytes29] = ACTIONS(737),
    [anon_sym_bytes30] = ACTIONS(737),
    [anon_sym_bytes31] = ACTIONS(737),
    [anon_sym_bytes32] = ACTIONS(737),
    [anon_sym_fixed] = ACTIONS(737),
    [aux_sym__fixed_token1] = ACTIONS(737),
    [anon_sym_ufixed] = ACTIONS(737),
    [aux_sym__ufixed_token1] = ACTIONS(737),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [ts_builtin_sym_end] = ACTIONS(739),
    [sym_identifier] = ACTIONS(741),
    [anon_sym_pragma] = ACTIONS(741),
    [anon_sym_import] = ACTIONS(741),
    [anon_sym_type] = ACTIONS(741),
    [anon_sym_abstract] = ACTIONS(741),
    [anon_sym_contract] = ACTIONS(741),
    [anon_sym_error] = ACTIONS(741),
    [anon_sym_interface] = ACTIONS(741),
    [anon_sym_library] = ACTIONS(741),
    [anon_sym_struct] = ACTIONS(741),
    [anon_sym_enum] = ACTIONS(741),
    [anon_sym_event] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_byte] = ACTIONS(741),
    [anon_sym_address] = ACTIONS(741),
    [anon_sym_var] = ACTIONS(741),
    [anon_sym_mapping] = ACTIONS(741),
    [anon_sym_bool] = ACTIONS(741),
    [anon_sym_string] = ACTIONS(741),
    [anon_sym_int] = ACTIONS(741),
    [anon_sym_int8] = ACTIONS(741),
    [anon_sym_int16] = ACTIONS(741),
    [anon_sym_int24] = ACTIONS(741),
    [anon_sym_int32] = ACTIONS(741),
    [anon_sym_int40] = ACTIONS(741),
    [anon_sym_int48] = ACTIONS(741),
    [anon_sym_int56] = ACTIONS(741),
    [anon_sym_int64] = ACTIONS(741),
    [anon_sym_int72] = ACTIONS(741),
    [anon_sym_int80] = ACTIONS(741),
    [anon_sym_int88] = ACTIONS(741),
    [anon_sym_int96] = ACTIONS(741),
    [anon_sym_int104] = ACTIONS(741),
    [anon_sym_int112] = ACTIONS(741),
    [anon_sym_int120] = ACTIONS(741),
    [anon_sym_int128] = ACTIONS(741),
    [anon_sym_int136] = ACTIONS(741),
    [anon_sym_int144] = ACTIONS(741),
    [anon_sym_int152] = ACTIONS(741),
    [anon_sym_int160] = ACTIONS(741),
    [anon_sym_int168] = ACTIONS(741),
    [anon_sym_int176] = ACTIONS(741),
    [anon_sym_int184] = ACTIONS(741),
    [anon_sym_int192] = ACTIONS(741),
    [anon_sym_int200] = ACTIONS(741),
    [anon_sym_int208] = ACTIONS(741),
    [anon_sym_int216] = ACTIONS(741),
    [anon_sym_int224] = ACTIONS(741),
    [anon_sym_int232] = ACTIONS(741),
    [anon_sym_int240] = ACTIONS(741),
    [anon_sym_int248] = ACTIONS(741),
    [anon_sym_int256] = ACTIONS(741),
    [anon_sym_uint] = ACTIONS(741),
    [anon_sym_uint8] = ACTIONS(741),
    [anon_sym_uint16] = ACTIONS(741),
    [anon_sym_uint24] = ACTIONS(741),
    [anon_sym_uint32] = ACTIONS(741),
    [anon_sym_uint40] = ACTIONS(741),
    [anon_sym_uint48] = ACTIONS(741),
    [anon_sym_uint56] = ACTIONS(741),
    [anon_sym_uint64] = ACTIONS(741),
    [anon_sym_uint72] = ACTIONS(741),
    [anon_sym_uint80] = ACTIONS(741),
    [anon_sym_uint88] = ACTIONS(741),
    [anon_sym_uint96] = ACTIONS(741),
    [anon_sym_uint104] = ACTIONS(741),
    [anon_sym_uint112] = ACTIONS(741),
    [anon_sym_uint120] = ACTIONS(741),
    [anon_sym_uint128] = ACTIONS(741),
    [anon_sym_uint136] = ACTIONS(741),
    [anon_sym_uint144] = ACTIONS(741),
    [anon_sym_uint152] = ACTIONS(741),
    [anon_sym_uint160] = ACTIONS(741),
    [anon_sym_uint168] = ACTIONS(741),
    [anon_sym_uint176] = ACTIONS(741),
    [anon_sym_uint184] = ACTIONS(741),
    [anon_sym_uint192] = ACTIONS(741),
    [anon_sym_uint200] = ACTIONS(741),
    [anon_sym_uint208] = ACTIONS(741),
    [anon_sym_uint216] = ACTIONS(741),
    [anon_sym_uint224] = ACTIONS(741),
    [anon_sym_uint232] = ACTIONS(741),
    [anon_sym_uint240] = ACTIONS(741),
    [anon_sym_uint248] = ACTIONS(741),
    [anon_sym_uint256] = ACTIONS(741),
    [anon_sym_bytes] = ACTIONS(741),
    [anon_sym_bytes1] = ACTIONS(741),
    [anon_sym_bytes2] = ACTIONS(741),
    [anon_sym_bytes3] = ACTIONS(741),
    [anon_sym_bytes4] = ACTIONS(741),
    [anon_sym_bytes5] = ACTIONS(741),
    [anon_sym_bytes6] = ACTIONS(741),
    [anon_sym_bytes7] = ACTIONS(741),
    [anon_sym_bytes8] = ACTIONS(741),
    [anon_sym_bytes9] = ACTIONS(741),
    [anon_sym_bytes10] = ACTIONS(741),
    [anon_sym_bytes11] = ACTIONS(741),
    [anon_sym_bytes12] = ACTIONS(741),
    [anon_sym_bytes13] = ACTIONS(741),
    [anon_sym_bytes14] = ACTIONS(741),
    [anon_sym_bytes15] = ACTIONS(741),
    [anon_sym_bytes16] = ACTIONS(741),
    [anon_sym_bytes17] = ACTIONS(741),
    [anon_sym_bytes18] = ACTIONS(741),
    [anon_sym_bytes19] = ACTIONS(741),
    [anon_sym_bytes20] = ACTIONS(741),
    [anon_sym_bytes21] = ACTIONS(741),
    [anon_sym_bytes22] = ACTIONS(741),
    [anon_sym_bytes23] = ACTIONS(741),
    [anon_sym_bytes24] = ACTIONS(741),
    [anon_sym_bytes25] = ACTIONS(741),
    [anon_sym_bytes26] = ACTIONS(741),
    [anon_sym_bytes27] = ACTIONS(741),
    [anon_sym_bytes28] = ACTIONS(741),
    [anon_sym_bytes29] = ACTIONS(741),
    [anon_sym_bytes30] = ACTIONS(741),
    [anon_sym_bytes31] = ACTIONS(741),
    [anon_sym_bytes32] = ACTIONS(741),
    [anon_sym_fixed] = ACTIONS(741),
    [aux_sym__fixed_token1] = ACTIONS(741),
    [anon_sym_ufixed] = ACTIONS(741),
    [aux_sym__ufixed_token1] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [ts_builtin_sym_end] = ACTIONS(743),
    [sym_identifier] = ACTIONS(745),
    [anon_sym_pragma] = ACTIONS(745),
    [anon_sym_import] = ACTIONS(745),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_abstract] = ACTIONS(745),
    [anon_sym_contract] = ACTIONS(745),
    [anon_sym_error] = ACTIONS(745),
    [anon_sym_interface] = ACTIONS(745),
    [anon_sym_library] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_event] = ACTIONS(745),
    [anon_sym_function] = ACTIONS(745),
    [anon_sym_byte] = ACTIONS(745),
    [anon_sym_address] = ACTIONS(745),
    [anon_sym_var] = ACTIONS(745),
    [anon_sym_mapping] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_int8] = ACTIONS(745),
    [anon_sym_int16] = ACTIONS(745),
    [anon_sym_int24] = ACTIONS(745),
    [anon_sym_int32] = ACTIONS(745),
    [anon_sym_int40] = ACTIONS(745),
    [anon_sym_int48] = ACTIONS(745),
    [anon_sym_int56] = ACTIONS(745),
    [anon_sym_int64] = ACTIONS(745),
    [anon_sym_int72] = ACTIONS(745),
    [anon_sym_int80] = ACTIONS(745),
    [anon_sym_int88] = ACTIONS(745),
    [anon_sym_int96] = ACTIONS(745),
    [anon_sym_int104] = ACTIONS(745),
    [anon_sym_int112] = ACTIONS(745),
    [anon_sym_int120] = ACTIONS(745),
    [anon_sym_int128] = ACTIONS(745),
    [anon_sym_int136] = ACTIONS(745),
    [anon_sym_int144] = ACTIONS(745),
    [anon_sym_int152] = ACTIONS(745),
    [anon_sym_int160] = ACTIONS(745),
    [anon_sym_int168] = ACTIONS(745),
    [anon_sym_int176] = ACTIONS(745),
    [anon_sym_int184] = ACTIONS(745),
    [anon_sym_int192] = ACTIONS(745),
    [anon_sym_int200] = ACTIONS(745),
    [anon_sym_int208] = ACTIONS(745),
    [anon_sym_int216] = ACTIONS(745),
    [anon_sym_int224] = ACTIONS(745),
    [anon_sym_int232] = ACTIONS(745),
    [anon_sym_int240] = ACTIONS(745),
    [anon_sym_int248] = ACTIONS(745),
    [anon_sym_int256] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_uint8] = ACTIONS(745),
    [anon_sym_uint16] = ACTIONS(745),
    [anon_sym_uint24] = ACTIONS(745),
    [anon_sym_uint32] = ACTIONS(745),
    [anon_sym_uint40] = ACTIONS(745),
    [anon_sym_uint48] = ACTIONS(745),
    [anon_sym_uint56] = ACTIONS(745),
    [anon_sym_uint64] = ACTIONS(745),
    [anon_sym_uint72] = ACTIONS(745),
    [anon_sym_uint80] = ACTIONS(745),
    [anon_sym_uint88] = ACTIONS(745),
    [anon_sym_uint96] = ACTIONS(745),
    [anon_sym_uint104] = ACTIONS(745),
    [anon_sym_uint112] = ACTIONS(745),
    [anon_sym_uint120] = ACTIONS(745),
    [anon_sym_uint128] = ACTIONS(745),
    [anon_sym_uint136] = ACTIONS(745),
    [anon_sym_uint144] = ACTIONS(745),
    [anon_sym_uint152] = ACTIONS(745),
    [anon_sym_uint160] = ACTIONS(745),
    [anon_sym_uint168] = ACTIONS(745),
    [anon_sym_uint176] = ACTIONS(745),
    [anon_sym_uint184] = ACTIONS(745),
    [anon_sym_uint192] = ACTIONS(745),
    [anon_sym_uint200] = ACTIONS(745),
    [anon_sym_uint208] = ACTIONS(745),
    [anon_sym_uint216] = ACTIONS(745),
    [anon_sym_uint224] = ACTIONS(745),
    [anon_sym_uint232] = ACTIONS(745),
    [anon_sym_uint240] = ACTIONS(745),
    [anon_sym_uint248] = ACTIONS(745),
    [anon_sym_uint256] = ACTIONS(745),
    [anon_sym_bytes] = ACTIONS(745),
    [anon_sym_bytes1] = ACTIONS(745),
    [anon_sym_bytes2] = ACTIONS(745),
    [anon_sym_bytes3] = ACTIONS(745),
    [anon_sym_bytes4] = ACTIONS(745),
    [anon_sym_bytes5] = ACTIONS(745),
    [anon_sym_bytes6] = ACTIONS(745),
    [anon_sym_bytes7] = ACTIONS(745),
    [anon_sym_bytes8] = ACTIONS(745),
    [anon_sym_bytes9] = ACTIONS(745),
    [anon_sym_bytes10] = ACTIONS(745),
    [anon_sym_bytes11] = ACTIONS(745),
    [anon_sym_bytes12] = ACTIONS(745),
    [anon_sym_bytes13] = ACTIONS(745),
    [anon_sym_bytes14] = ACTIONS(745),
    [anon_sym_bytes15] = ACTIONS(745),
    [anon_sym_bytes16] = ACTIONS(745),
    [anon_sym_bytes17] = ACTIONS(745),
    [anon_sym_bytes18] = ACTIONS(745),
    [anon_sym_bytes19] = ACTIONS(745),
    [anon_sym_bytes20] = ACTIONS(745),
    [anon_sym_bytes21] = ACTIONS(745),
    [anon_sym_bytes22] = ACTIONS(745),
    [anon_sym_bytes23] = ACTIONS(745),
    [anon_sym_bytes24] = ACTIONS(745),
    [anon_sym_bytes25] = ACTIONS(745),
    [anon_sym_bytes26] = ACTIONS(745),
    [anon_sym_bytes27] = ACTIONS(745),
    [anon_sym_bytes28] = ACTIONS(745),
    [anon_sym_bytes29] = ACTIONS(745),
    [anon_sym_bytes30] = ACTIONS(745),
    [anon_sym_bytes31] = ACTIONS(745),
    [anon_sym_bytes32] = ACTIONS(745),
    [anon_sym_fixed] = ACTIONS(745),
    [aux_sym__fixed_token1] = ACTIONS(745),
    [anon_sym_ufixed] = ACTIONS(745),
    [aux_sym__ufixed_token1] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [ts_builtin_sym_end] = ACTIONS(747),
    [sym_identifier] = ACTIONS(749),
    [anon_sym_pragma] = ACTIONS(749),
    [anon_sym_import] = ACTIONS(749),
    [anon_sym_type] = ACTIONS(749),
    [anon_sym_abstract] = ACTIONS(749),
    [anon_sym_contract] = ACTIONS(749),
    [anon_sym_error] = ACTIONS(749),
    [anon_sym_interface] = ACTIONS(749),
    [anon_sym_library] = ACTIONS(749),
    [anon_sym_struct] = ACTIONS(749),
    [anon_sym_enum] = ACTIONS(749),
    [anon_sym_event] = ACTIONS(749),
    [anon_sym_function] = ACTIONS(749),
    [anon_sym_byte] = ACTIONS(749),
    [anon_sym_address] = ACTIONS(749),
    [anon_sym_var] = ACTIONS(749),
    [anon_sym_mapping] = ACTIONS(749),
    [anon_sym_bool] = ACTIONS(749),
    [anon_sym_string] = ACTIONS(749),
    [anon_sym_int] = ACTIONS(749),
    [anon_sym_int8] = ACTIONS(749),
    [anon_sym_int16] = ACTIONS(749),
    [anon_sym_int24] = ACTIONS(749),
    [anon_sym_int32] = ACTIONS(749),
    [anon_sym_int40] = ACTIONS(749),
    [anon_sym_int48] = ACTIONS(749),
    [anon_sym_int56] = ACTIONS(749),
    [anon_sym_int64] = ACTIONS(749),
    [anon_sym_int72] = ACTIONS(749),
    [anon_sym_int80] = ACTIONS(749),
    [anon_sym_int88] = ACTIONS(749),
    [anon_sym_int96] = ACTIONS(749),
    [anon_sym_int104] = ACTIONS(749),
    [anon_sym_int112] = ACTIONS(749),
    [anon_sym_int120] = ACTIONS(749),
    [anon_sym_int128] = ACTIONS(749),
    [anon_sym_int136] = ACTIONS(749),
    [anon_sym_int144] = ACTIONS(749),
    [anon_sym_int152] = ACTIONS(749),
    [anon_sym_int160] = ACTIONS(749),
    [anon_sym_int168] = ACTIONS(749),
    [anon_sym_int176] = ACTIONS(749),
    [anon_sym_int184] = ACTIONS(749),
    [anon_sym_int192] = ACTIONS(749),
    [anon_sym_int200] = ACTIONS(749),
    [anon_sym_int208] = ACTIONS(749),
    [anon_sym_int216] = ACTIONS(749),
    [anon_sym_int224] = ACTIONS(749),
    [anon_sym_int232] = ACTIONS(749),
    [anon_sym_int240] = ACTIONS(749),
    [anon_sym_int248] = ACTIONS(749),
    [anon_sym_int256] = ACTIONS(749),
    [anon_sym_uint] = ACTIONS(749),
    [anon_sym_uint8] = ACTIONS(749),
    [anon_sym_uint16] = ACTIONS(749),
    [anon_sym_uint24] = ACTIONS(749),
    [anon_sym_uint32] = ACTIONS(749),
    [anon_sym_uint40] = ACTIONS(749),
    [anon_sym_uint48] = ACTIONS(749),
    [anon_sym_uint56] = ACTIONS(749),
    [anon_sym_uint64] = ACTIONS(749),
    [anon_sym_uint72] = ACTIONS(749),
    [anon_sym_uint80] = ACTIONS(749),
    [anon_sym_uint88] = ACTIONS(749),
    [anon_sym_uint96] = ACTIONS(749),
    [anon_sym_uint104] = ACTIONS(749),
    [anon_sym_uint112] = ACTIONS(749),
    [anon_sym_uint120] = ACTIONS(749),
    [anon_sym_uint128] = ACTIONS(749),
    [anon_sym_uint136] = ACTIONS(749),
    [anon_sym_uint144] = ACTIONS(749),
    [anon_sym_uint152] = ACTIONS(749),
    [anon_sym_uint160] = ACTIONS(749),
    [anon_sym_uint168] = ACTIONS(749),
    [anon_sym_uint176] = ACTIONS(749),
    [anon_sym_uint184] = ACTIONS(749),
    [anon_sym_uint192] = ACTIONS(749),
    [anon_sym_uint200] = ACTIONS(749),
    [anon_sym_uint208] = ACTIONS(749),
    [anon_sym_uint216] = ACTIONS(749),
    [anon_sym_uint224] = ACTIONS(749),
    [anon_sym_uint232] = ACTIONS(749),
    [anon_sym_uint240] = ACTIONS(749),
    [anon_sym_uint248] = ACTIONS(749),
    [anon_sym_uint256] = ACTIONS(749),
    [anon_sym_bytes] = ACTIONS(749),
    [anon_sym_bytes1] = ACTIONS(749),
    [anon_sym_bytes2] = ACTIONS(749),
    [anon_sym_bytes3] = ACTIONS(749),
    [anon_sym_bytes4] = ACTIONS(749),
    [anon_sym_bytes5] = ACTIONS(749),
    [anon_sym_bytes6] = ACTIONS(749),
    [anon_sym_bytes7] = ACTIONS(749),
    [anon_sym_bytes8] = ACTIONS(749),
    [anon_sym_bytes9] = ACTIONS(749),
    [anon_sym_bytes10] = ACTIONS(749),
    [anon_sym_bytes11] = ACTIONS(749),
    [anon_sym_bytes12] = ACTIONS(749),
    [anon_sym_bytes13] = ACTIONS(749),
    [anon_sym_bytes14] = ACTIONS(749),
    [anon_sym_bytes15] = ACTIONS(749),
    [anon_sym_bytes16] = ACTIONS(749),
    [anon_sym_bytes17] = ACTIONS(749),
    [anon_sym_bytes18] = ACTIONS(749),
    [anon_sym_bytes19] = ACTIONS(749),
    [anon_sym_bytes20] = ACTIONS(749),
    [anon_sym_bytes21] = ACTIONS(749),
    [anon_sym_bytes22] = ACTIONS(749),
    [anon_sym_bytes23] = ACTIONS(749),
    [anon_sym_bytes24] = ACTIONS(749),
    [anon_sym_bytes25] = ACTIONS(749),
    [anon_sym_bytes26] = ACTIONS(749),
    [anon_sym_bytes27] = ACTIONS(749),
    [anon_sym_bytes28] = ACTIONS(749),
    [anon_sym_bytes29] = ACTIONS(749),
    [anon_sym_bytes30] = ACTIONS(749),
    [anon_sym_bytes31] = ACTIONS(749),
    [anon_sym_bytes32] = ACTIONS(749),
    [anon_sym_fixed] = ACTIONS(749),
    [aux_sym__fixed_token1] = ACTIONS(749),
    [anon_sym_ufixed] = ACTIONS(749),
    [aux_sym__ufixed_token1] = ACTIONS(749),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [ts_builtin_sym_end] = ACTIONS(751),
    [sym_identifier] = ACTIONS(753),
    [anon_sym_pragma] = ACTIONS(753),
    [anon_sym_import] = ACTIONS(753),
    [anon_sym_type] = ACTIONS(753),
    [anon_sym_abstract] = ACTIONS(753),
    [anon_sym_contract] = ACTIONS(753),
    [anon_sym_error] = ACTIONS(753),
    [anon_sym_interface] = ACTIONS(753),
    [anon_sym_library] = ACTIONS(753),
    [anon_sym_struct] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(753),
    [anon_sym_event] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_byte] = ACTIONS(753),
    [anon_sym_address] = ACTIONS(753),
    [anon_sym_var] = ACTIONS(753),
    [anon_sym_mapping] = ACTIONS(753),
    [anon_sym_bool] = ACTIONS(753),
    [anon_sym_string] = ACTIONS(753),
    [anon_sym_int] = ACTIONS(753),
    [anon_sym_int8] = ACTIONS(753),
    [anon_sym_int16] = ACTIONS(753),
    [anon_sym_int24] = ACTIONS(753),
    [anon_sym_int32] = ACTIONS(753),
    [anon_sym_int40] = ACTIONS(753),
    [anon_sym_int48] = ACTIONS(753),
    [anon_sym_int56] = ACTIONS(753),
    [anon_sym_int64] = ACTIONS(753),
    [anon_sym_int72] = ACTIONS(753),
    [anon_sym_int80] = ACTIONS(753),
    [anon_sym_int88] = ACTIONS(753),
    [anon_sym_int96] = ACTIONS(753),
    [anon_sym_int104] = ACTIONS(753),
    [anon_sym_int112] = ACTIONS(753),
    [anon_sym_int120] = ACTIONS(753),
    [anon_sym_int128] = ACTIONS(753),
    [anon_sym_int136] = ACTIONS(753),
    [anon_sym_int144] = ACTIONS(753),
    [anon_sym_int152] = ACTIONS(753),
    [anon_sym_int160] = ACTIONS(753),
    [anon_sym_int168] = ACTIONS(753),
    [anon_sym_int176] = ACTIONS(753),
    [anon_sym_int184] = ACTIONS(753),
    [anon_sym_int192] = ACTIONS(753),
    [anon_sym_int200] = ACTIONS(753),
    [anon_sym_int208] = ACTIONS(753),
    [anon_sym_int216] = ACTIONS(753),
    [anon_sym_int224] = ACTIONS(753),
    [anon_sym_int232] = ACTIONS(753),
    [anon_sym_int240] = ACTIONS(753),
    [anon_sym_int248] = ACTIONS(753),
    [anon_sym_int256] = ACTIONS(753),
    [anon_sym_uint] = ACTIONS(753),
    [anon_sym_uint8] = ACTIONS(753),
    [anon_sym_uint16] = ACTIONS(753),
    [anon_sym_uint24] = ACTIONS(753),
    [anon_sym_uint32] = ACTIONS(753),
    [anon_sym_uint40] = ACTIONS(753),
    [anon_sym_uint48] = ACTIONS(753),
    [anon_sym_uint56] = ACTIONS(753),
    [anon_sym_uint64] = ACTIONS(753),
    [anon_sym_uint72] = ACTIONS(753),
    [anon_sym_uint80] = ACTIONS(753),
    [anon_sym_uint88] = ACTIONS(753),
    [anon_sym_uint96] = ACTIONS(753),
    [anon_sym_uint104] = ACTIONS(753),
    [anon_sym_uint112] = ACTIONS(753),
    [anon_sym_uint120] = ACTIONS(753),
    [anon_sym_uint128] = ACTIONS(753),
    [anon_sym_uint136] = ACTIONS(753),
    [anon_sym_uint144] = ACTIONS(753),
    [anon_sym_uint152] = ACTIONS(753),
    [anon_sym_uint160] = ACTIONS(753),
    [anon_sym_uint168] = ACTIONS(753),
    [anon_sym_uint176] = ACTIONS(753),
    [anon_sym_uint184] = ACTIONS(753),
    [anon_sym_uint192] = ACTIONS(753),
    [anon_sym_uint200] = ACTIONS(753),
    [anon_sym_uint208] = ACTIONS(753),
    [anon_sym_uint216] = ACTIONS(753),
    [anon_sym_uint224] = ACTIONS(753),
    [anon_sym_uint232] = ACTIONS(753),
    [anon_sym_uint240] = ACTIONS(753),
    [anon_sym_uint248] = ACTIONS(753),
    [anon_sym_uint256] = ACTIONS(753),
    [anon_sym_bytes] = ACTIONS(753),
    [anon_sym_bytes1] = ACTIONS(753),
    [anon_sym_bytes2] = ACTIONS(753),
    [anon_sym_bytes3] = ACTIONS(753),
    [anon_sym_bytes4] = ACTIONS(753),
    [anon_sym_bytes5] = ACTIONS(753),
    [anon_sym_bytes6] = ACTIONS(753),
    [anon_sym_bytes7] = ACTIONS(753),
    [anon_sym_bytes8] = ACTIONS(753),
    [anon_sym_bytes9] = ACTIONS(753),
    [anon_sym_bytes10] = ACTIONS(753),
    [anon_sym_bytes11] = ACTIONS(753),
    [anon_sym_bytes12] = ACTIONS(753),
    [anon_sym_bytes13] = ACTIONS(753),
    [anon_sym_bytes14] = ACTIONS(753),
    [anon_sym_bytes15] = ACTIONS(753),
    [anon_sym_bytes16] = ACTIONS(753),
    [anon_sym_bytes17] = ACTIONS(753),
    [anon_sym_bytes18] = ACTIONS(753),
    [anon_sym_bytes19] = ACTIONS(753),
    [anon_sym_bytes20] = ACTIONS(753),
    [anon_sym_bytes21] = ACTIONS(753),
    [anon_sym_bytes22] = ACTIONS(753),
    [anon_sym_bytes23] = ACTIONS(753),
    [anon_sym_bytes24] = ACTIONS(753),
    [anon_sym_bytes25] = ACTIONS(753),
    [anon_sym_bytes26] = ACTIONS(753),
    [anon_sym_bytes27] = ACTIONS(753),
    [anon_sym_bytes28] = ACTIONS(753),
    [anon_sym_bytes29] = ACTIONS(753),
    [anon_sym_bytes30] = ACTIONS(753),
    [anon_sym_bytes31] = ACTIONS(753),
    [anon_sym_bytes32] = ACTIONS(753),
    [anon_sym_fixed] = ACTIONS(753),
    [aux_sym__fixed_token1] = ACTIONS(753),
    [anon_sym_ufixed] = ACTIONS(753),
    [aux_sym__ufixed_token1] = ACTIONS(753),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [ts_builtin_sym_end] = ACTIONS(755),
    [sym_identifier] = ACTIONS(757),
    [anon_sym_pragma] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(757),
    [anon_sym_type] = ACTIONS(757),
    [anon_sym_abstract] = ACTIONS(757),
    [anon_sym_contract] = ACTIONS(757),
    [anon_sym_error] = ACTIONS(757),
    [anon_sym_interface] = ACTIONS(757),
    [anon_sym_library] = ACTIONS(757),
    [anon_sym_struct] = ACTIONS(757),
    [anon_sym_enum] = ACTIONS(757),
    [anon_sym_event] = ACTIONS(757),
    [anon_sym_function] = ACTIONS(757),
    [anon_sym_byte] = ACTIONS(757),
    [anon_sym_address] = ACTIONS(757),
    [anon_sym_var] = ACTIONS(757),
    [anon_sym_mapping] = ACTIONS(757),
    [anon_sym_bool] = ACTIONS(757),
    [anon_sym_string] = ACTIONS(757),
    [anon_sym_int] = ACTIONS(757),
    [anon_sym_int8] = ACTIONS(757),
    [anon_sym_int16] = ACTIONS(757),
    [anon_sym_int24] = ACTIONS(757),
    [anon_sym_int32] = ACTIONS(757),
    [anon_sym_int40] = ACTIONS(757),
    [anon_sym_int48] = ACTIONS(757),
    [anon_sym_int56] = ACTIONS(757),
    [anon_sym_int64] = ACTIONS(757),
    [anon_sym_int72] = ACTIONS(757),
    [anon_sym_int80] = ACTIONS(757),
    [anon_sym_int88] = ACTIONS(757),
    [anon_sym_int96] = ACTIONS(757),
    [anon_sym_int104] = ACTIONS(757),
    [anon_sym_int112] = ACTIONS(757),
    [anon_sym_int120] = ACTIONS(757),
    [anon_sym_int128] = ACTIONS(757),
    [anon_sym_int136] = ACTIONS(757),
    [anon_sym_int144] = ACTIONS(757),
    [anon_sym_int152] = ACTIONS(757),
    [anon_sym_int160] = ACTIONS(757),
    [anon_sym_int168] = ACTIONS(757),
    [anon_sym_int176] = ACTIONS(757),
    [anon_sym_int184] = ACTIONS(757),
    [anon_sym_int192] = ACTIONS(757),
    [anon_sym_int200] = ACTIONS(757),
    [anon_sym_int208] = ACTIONS(757),
    [anon_sym_int216] = ACTIONS(757),
    [anon_sym_int224] = ACTIONS(757),
    [anon_sym_int232] = ACTIONS(757),
    [anon_sym_int240] = ACTIONS(757),
    [anon_sym_int248] = ACTIONS(757),
    [anon_sym_int256] = ACTIONS(757),
    [anon_sym_uint] = ACTIONS(757),
    [anon_sym_uint8] = ACTIONS(757),
    [anon_sym_uint16] = ACTIONS(757),
    [anon_sym_uint24] = ACTIONS(757),
    [anon_sym_uint32] = ACTIONS(757),
    [anon_sym_uint40] = ACTIONS(757),
    [anon_sym_uint48] = ACTIONS(757),
    [anon_sym_uint56] = ACTIONS(757),
    [anon_sym_uint64] = ACTIONS(757),
    [anon_sym_uint72] = ACTIONS(757),
    [anon_sym_uint80] = ACTIONS(757),
    [anon_sym_uint88] = ACTIONS(757),
    [anon_sym_uint96] = ACTIONS(757),
    [anon_sym_uint104] = ACTIONS(757),
    [anon_sym_uint112] = ACTIONS(757),
    [anon_sym_uint120] = ACTIONS(757),
    [anon_sym_uint128] = ACTIONS(757),
    [anon_sym_uint136] = ACTIONS(757),
    [anon_sym_uint144] = ACTIONS(757),
    [anon_sym_uint152] = ACTIONS(757),
    [anon_sym_uint160] = ACTIONS(757),
    [anon_sym_uint168] = ACTIONS(757),
    [anon_sym_uint176] = ACTIONS(757),
    [anon_sym_uint184] = ACTIONS(757),
    [anon_sym_uint192] = ACTIONS(757),
    [anon_sym_uint200] = ACTIONS(757),
    [anon_sym_uint208] = ACTIONS(757),
    [anon_sym_uint216] = ACTIONS(757),
    [anon_sym_uint224] = ACTIONS(757),
    [anon_sym_uint232] = ACTIONS(757),
    [anon_sym_uint240] = ACTIONS(757),
    [anon_sym_uint248] = ACTIONS(757),
    [anon_sym_uint256] = ACTIONS(757),
    [anon_sym_bytes] = ACTIONS(757),
    [anon_sym_bytes1] = ACTIONS(757),
    [anon_sym_bytes2] = ACTIONS(757),
    [anon_sym_bytes3] = ACTIONS(757),
    [anon_sym_bytes4] = ACTIONS(757),
    [anon_sym_bytes5] = ACTIONS(757),
    [anon_sym_bytes6] = ACTIONS(757),
    [anon_sym_bytes7] = ACTIONS(757),
    [anon_sym_bytes8] = ACTIONS(757),
    [anon_sym_bytes9] = ACTIONS(757),
    [anon_sym_bytes10] = ACTIONS(757),
    [anon_sym_bytes11] = ACTIONS(757),
    [anon_sym_bytes12] = ACTIONS(757),
    [anon_sym_bytes13] = ACTIONS(757),
    [anon_sym_bytes14] = ACTIONS(757),
    [anon_sym_bytes15] = ACTIONS(757),
    [anon_sym_bytes16] = ACTIONS(757),
    [anon_sym_bytes17] = ACTIONS(757),
    [anon_sym_bytes18] = ACTIONS(757),
    [anon_sym_bytes19] = ACTIONS(757),
    [anon_sym_bytes20] = ACTIONS(757),
    [anon_sym_bytes21] = ACTIONS(757),
    [anon_sym_bytes22] = ACTIONS(757),
    [anon_sym_bytes23] = ACTIONS(757),
    [anon_sym_bytes24] = ACTIONS(757),
    [anon_sym_bytes25] = ACTIONS(757),
    [anon_sym_bytes26] = ACTIONS(757),
    [anon_sym_bytes27] = ACTIONS(757),
    [anon_sym_bytes28] = ACTIONS(757),
    [anon_sym_bytes29] = ACTIONS(757),
    [anon_sym_bytes30] = ACTIONS(757),
    [anon_sym_bytes31] = ACTIONS(757),
    [anon_sym_bytes32] = ACTIONS(757),
    [anon_sym_fixed] = ACTIONS(757),
    [aux_sym__fixed_token1] = ACTIONS(757),
    [anon_sym_ufixed] = ACTIONS(757),
    [aux_sym__ufixed_token1] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [ts_builtin_sym_end] = ACTIONS(759),
    [sym_identifier] = ACTIONS(761),
    [anon_sym_pragma] = ACTIONS(761),
    [anon_sym_import] = ACTIONS(761),
    [anon_sym_type] = ACTIONS(761),
    [anon_sym_abstract] = ACTIONS(761),
    [anon_sym_contract] = ACTIONS(761),
    [anon_sym_error] = ACTIONS(761),
    [anon_sym_interface] = ACTIONS(761),
    [anon_sym_library] = ACTIONS(761),
    [anon_sym_struct] = ACTIONS(761),
    [anon_sym_enum] = ACTIONS(761),
    [anon_sym_event] = ACTIONS(761),
    [anon_sym_function] = ACTIONS(761),
    [anon_sym_byte] = ACTIONS(761),
    [anon_sym_address] = ACTIONS(761),
    [anon_sym_var] = ACTIONS(761),
    [anon_sym_mapping] = ACTIONS(761),
    [anon_sym_bool] = ACTIONS(761),
    [anon_sym_string] = ACTIONS(761),
    [anon_sym_int] = ACTIONS(761),
    [anon_sym_int8] = ACTIONS(761),
    [anon_sym_int16] = ACTIONS(761),
    [anon_sym_int24] = ACTIONS(761),
    [anon_sym_int32] = ACTIONS(761),
    [anon_sym_int40] = ACTIONS(761),
    [anon_sym_int48] = ACTIONS(761),
    [anon_sym_int56] = ACTIONS(761),
    [anon_sym_int64] = ACTIONS(761),
    [anon_sym_int72] = ACTIONS(761),
    [anon_sym_int80] = ACTIONS(761),
    [anon_sym_int88] = ACTIONS(761),
    [anon_sym_int96] = ACTIONS(761),
    [anon_sym_int104] = ACTIONS(761),
    [anon_sym_int112] = ACTIONS(761),
    [anon_sym_int120] = ACTIONS(761),
    [anon_sym_int128] = ACTIONS(761),
    [anon_sym_int136] = ACTIONS(761),
    [anon_sym_int144] = ACTIONS(761),
    [anon_sym_int152] = ACTIONS(761),
    [anon_sym_int160] = ACTIONS(761),
    [anon_sym_int168] = ACTIONS(761),
    [anon_sym_int176] = ACTIONS(761),
    [anon_sym_int184] = ACTIONS(761),
    [anon_sym_int192] = ACTIONS(761),
    [anon_sym_int200] = ACTIONS(761),
    [anon_sym_int208] = ACTIONS(761),
    [anon_sym_int216] = ACTIONS(761),
    [anon_sym_int224] = ACTIONS(761),
    [anon_sym_int232] = ACTIONS(761),
    [anon_sym_int240] = ACTIONS(761),
    [anon_sym_int248] = ACTIONS(761),
    [anon_sym_int256] = ACTIONS(761),
    [anon_sym_uint] = ACTIONS(761),
    [anon_sym_uint8] = ACTIONS(761),
    [anon_sym_uint16] = ACTIONS(761),
    [anon_sym_uint24] = ACTIONS(761),
    [anon_sym_uint32] = ACTIONS(761),
    [anon_sym_uint40] = ACTIONS(761),
    [anon_sym_uint48] = ACTIONS(761),
    [anon_sym_uint56] = ACTIONS(761),
    [anon_sym_uint64] = ACTIONS(761),
    [anon_sym_uint72] = ACTIONS(761),
    [anon_sym_uint80] = ACTIONS(761),
    [anon_sym_uint88] = ACTIONS(761),
    [anon_sym_uint96] = ACTIONS(761),
    [anon_sym_uint104] = ACTIONS(761),
    [anon_sym_uint112] = ACTIONS(761),
    [anon_sym_uint120] = ACTIONS(761),
    [anon_sym_uint128] = ACTIONS(761),
    [anon_sym_uint136] = ACTIONS(761),
    [anon_sym_uint144] = ACTIONS(761),
    [anon_sym_uint152] = ACTIONS(761),
    [anon_sym_uint160] = ACTIONS(761),
    [anon_sym_uint168] = ACTIONS(761),
    [anon_sym_uint176] = ACTIONS(761),
    [anon_sym_uint184] = ACTIONS(761),
    [anon_sym_uint192] = ACTIONS(761),
    [anon_sym_uint200] = ACTIONS(761),
    [anon_sym_uint208] = ACTIONS(761),
    [anon_sym_uint216] = ACTIONS(761),
    [anon_sym_uint224] = ACTIONS(761),
    [anon_sym_uint232] = ACTIONS(761),
    [anon_sym_uint240] = ACTIONS(761),
    [anon_sym_uint248] = ACTIONS(761),
    [anon_sym_uint256] = ACTIONS(761),
    [anon_sym_bytes] = ACTIONS(761),
    [anon_sym_bytes1] = ACTIONS(761),
    [anon_sym_bytes2] = ACTIONS(761),
    [anon_sym_bytes3] = ACTIONS(761),
    [anon_sym_bytes4] = ACTIONS(761),
    [anon_sym_bytes5] = ACTIONS(761),
    [anon_sym_bytes6] = ACTIONS(761),
    [anon_sym_bytes7] = ACTIONS(761),
    [anon_sym_bytes8] = ACTIONS(761),
    [anon_sym_bytes9] = ACTIONS(761),
    [anon_sym_bytes10] = ACTIONS(761),
    [anon_sym_bytes11] = ACTIONS(761),
    [anon_sym_bytes12] = ACTIONS(761),
    [anon_sym_bytes13] = ACTIONS(761),
    [anon_sym_bytes14] = ACTIONS(761),
    [anon_sym_bytes15] = ACTIONS(761),
    [anon_sym_bytes16] = ACTIONS(761),
    [anon_sym_bytes17] = ACTIONS(761),
    [anon_sym_bytes18] = ACTIONS(761),
    [anon_sym_bytes19] = ACTIONS(761),
    [anon_sym_bytes20] = ACTIONS(761),
    [anon_sym_bytes21] = ACTIONS(761),
    [anon_sym_bytes22] = ACTIONS(761),
    [anon_sym_bytes23] = ACTIONS(761),
    [anon_sym_bytes24] = ACTIONS(761),
    [anon_sym_bytes25] = ACTIONS(761),
    [anon_sym_bytes26] = ACTIONS(761),
    [anon_sym_bytes27] = ACTIONS(761),
    [anon_sym_bytes28] = ACTIONS(761),
    [anon_sym_bytes29] = ACTIONS(761),
    [anon_sym_bytes30] = ACTIONS(761),
    [anon_sym_bytes31] = ACTIONS(761),
    [anon_sym_bytes32] = ACTIONS(761),
    [anon_sym_fixed] = ACTIONS(761),
    [aux_sym__fixed_token1] = ACTIONS(761),
    [anon_sym_ufixed] = ACTIONS(761),
    [aux_sym__ufixed_token1] = ACTIONS(761),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [ts_builtin_sym_end] = ACTIONS(763),
    [sym_identifier] = ACTIONS(765),
    [anon_sym_pragma] = ACTIONS(765),
    [anon_sym_import] = ACTIONS(765),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_abstract] = ACTIONS(765),
    [anon_sym_contract] = ACTIONS(765),
    [anon_sym_error] = ACTIONS(765),
    [anon_sym_interface] = ACTIONS(765),
    [anon_sym_library] = ACTIONS(765),
    [anon_sym_struct] = ACTIONS(765),
    [anon_sym_enum] = ACTIONS(765),
    [anon_sym_event] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_byte] = ACTIONS(765),
    [anon_sym_address] = ACTIONS(765),
    [anon_sym_var] = ACTIONS(765),
    [anon_sym_mapping] = ACTIONS(765),
    [anon_sym_bool] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_int] = ACTIONS(765),
    [anon_sym_int8] = ACTIONS(765),
    [anon_sym_int16] = ACTIONS(765),
    [anon_sym_int24] = ACTIONS(765),
    [anon_sym_int32] = ACTIONS(765),
    [anon_sym_int40] = ACTIONS(765),
    [anon_sym_int48] = ACTIONS(765),
    [anon_sym_int56] = ACTIONS(765),
    [anon_sym_int64] = ACTIONS(765),
    [anon_sym_int72] = ACTIONS(765),
    [anon_sym_int80] = ACTIONS(765),
    [anon_sym_int88] = ACTIONS(765),
    [anon_sym_int96] = ACTIONS(765),
    [anon_sym_int104] = ACTIONS(765),
    [anon_sym_int112] = ACTIONS(765),
    [anon_sym_int120] = ACTIONS(765),
    [anon_sym_int128] = ACTIONS(765),
    [anon_sym_int136] = ACTIONS(765),
    [anon_sym_int144] = ACTIONS(765),
    [anon_sym_int152] = ACTIONS(765),
    [anon_sym_int160] = ACTIONS(765),
    [anon_sym_int168] = ACTIONS(765),
    [anon_sym_int176] = ACTIONS(765),
    [anon_sym_int184] = ACTIONS(765),
    [anon_sym_int192] = ACTIONS(765),
    [anon_sym_int200] = ACTIONS(765),
    [anon_sym_int208] = ACTIONS(765),
    [anon_sym_int216] = ACTIONS(765),
    [anon_sym_int224] = ACTIONS(765),
    [anon_sym_int232] = ACTIONS(765),
    [anon_sym_int240] = ACTIONS(765),
    [anon_sym_int248] = ACTIONS(765),
    [anon_sym_int256] = ACTIONS(765),
    [anon_sym_uint] = ACTIONS(765),
    [anon_sym_uint8] = ACTIONS(765),
    [anon_sym_uint16] = ACTIONS(765),
    [anon_sym_uint24] = ACTIONS(765),
    [anon_sym_uint32] = ACTIONS(765),
    [anon_sym_uint40] = ACTIONS(765),
    [anon_sym_uint48] = ACTIONS(765),
    [anon_sym_uint56] = ACTIONS(765),
    [anon_sym_uint64] = ACTIONS(765),
    [anon_sym_uint72] = ACTIONS(765),
    [anon_sym_uint80] = ACTIONS(765),
    [anon_sym_uint88] = ACTIONS(765),
    [anon_sym_uint96] = ACTIONS(765),
    [anon_sym_uint104] = ACTIONS(765),
    [anon_sym_uint112] = ACTIONS(765),
    [anon_sym_uint120] = ACTIONS(765),
    [anon_sym_uint128] = ACTIONS(765),
    [anon_sym_uint136] = ACTIONS(765),
    [anon_sym_uint144] = ACTIONS(765),
    [anon_sym_uint152] = ACTIONS(765),
    [anon_sym_uint160] = ACTIONS(765),
    [anon_sym_uint168] = ACTIONS(765),
    [anon_sym_uint176] = ACTIONS(765),
    [anon_sym_uint184] = ACTIONS(765),
    [anon_sym_uint192] = ACTIONS(765),
    [anon_sym_uint200] = ACTIONS(765),
    [anon_sym_uint208] = ACTIONS(765),
    [anon_sym_uint216] = ACTIONS(765),
    [anon_sym_uint224] = ACTIONS(765),
    [anon_sym_uint232] = ACTIONS(765),
    [anon_sym_uint240] = ACTIONS(765),
    [anon_sym_uint248] = ACTIONS(765),
    [anon_sym_uint256] = ACTIONS(765),
    [anon_sym_bytes] = ACTIONS(765),
    [anon_sym_bytes1] = ACTIONS(765),
    [anon_sym_bytes2] = ACTIONS(765),
    [anon_sym_bytes3] = ACTIONS(765),
    [anon_sym_bytes4] = ACTIONS(765),
    [anon_sym_bytes5] = ACTIONS(765),
    [anon_sym_bytes6] = ACTIONS(765),
    [anon_sym_bytes7] = ACTIONS(765),
    [anon_sym_bytes8] = ACTIONS(765),
    [anon_sym_bytes9] = ACTIONS(765),
    [anon_sym_bytes10] = ACTIONS(765),
    [anon_sym_bytes11] = ACTIONS(765),
    [anon_sym_bytes12] = ACTIONS(765),
    [anon_sym_bytes13] = ACTIONS(765),
    [anon_sym_bytes14] = ACTIONS(765),
    [anon_sym_bytes15] = ACTIONS(765),
    [anon_sym_bytes16] = ACTIONS(765),
    [anon_sym_bytes17] = ACTIONS(765),
    [anon_sym_bytes18] = ACTIONS(765),
    [anon_sym_bytes19] = ACTIONS(765),
    [anon_sym_bytes20] = ACTIONS(765),
    [anon_sym_bytes21] = ACTIONS(765),
    [anon_sym_bytes22] = ACTIONS(765),
    [anon_sym_bytes23] = ACTIONS(765),
    [anon_sym_bytes24] = ACTIONS(765),
    [anon_sym_bytes25] = ACTIONS(765),
    [anon_sym_bytes26] = ACTIONS(765),
    [anon_sym_bytes27] = ACTIONS(765),
    [anon_sym_bytes28] = ACTIONS(765),
    [anon_sym_bytes29] = ACTIONS(765),
    [anon_sym_bytes30] = ACTIONS(765),
    [anon_sym_bytes31] = ACTIONS(765),
    [anon_sym_bytes32] = ACTIONS(765),
    [anon_sym_fixed] = ACTIONS(765),
    [aux_sym__fixed_token1] = ACTIONS(765),
    [anon_sym_ufixed] = ACTIONS(765),
    [aux_sym__ufixed_token1] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [ts_builtin_sym_end] = ACTIONS(767),
    [sym_identifier] = ACTIONS(769),
    [anon_sym_pragma] = ACTIONS(769),
    [anon_sym_import] = ACTIONS(769),
    [anon_sym_type] = ACTIONS(769),
    [anon_sym_abstract] = ACTIONS(769),
    [anon_sym_contract] = ACTIONS(769),
    [anon_sym_error] = ACTIONS(769),
    [anon_sym_interface] = ACTIONS(769),
    [anon_sym_library] = ACTIONS(769),
    [anon_sym_struct] = ACTIONS(769),
    [anon_sym_enum] = ACTIONS(769),
    [anon_sym_event] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(769),
    [anon_sym_byte] = ACTIONS(769),
    [anon_sym_address] = ACTIONS(769),
    [anon_sym_var] = ACTIONS(769),
    [anon_sym_mapping] = ACTIONS(769),
    [anon_sym_bool] = ACTIONS(769),
    [anon_sym_string] = ACTIONS(769),
    [anon_sym_int] = ACTIONS(769),
    [anon_sym_int8] = ACTIONS(769),
    [anon_sym_int16] = ACTIONS(769),
    [anon_sym_int24] = ACTIONS(769),
    [anon_sym_int32] = ACTIONS(769),
    [anon_sym_int40] = ACTIONS(769),
    [anon_sym_int48] = ACTIONS(769),
    [anon_sym_int56] = ACTIONS(769),
    [anon_sym_int64] = ACTIONS(769),
    [anon_sym_int72] = ACTIONS(769),
    [anon_sym_int80] = ACTIONS(769),
    [anon_sym_int88] = ACTIONS(769),
    [anon_sym_int96] = ACTIONS(769),
    [anon_sym_int104] = ACTIONS(769),
    [anon_sym_int112] = ACTIONS(769),
    [anon_sym_int120] = ACTIONS(769),
    [anon_sym_int128] = ACTIONS(769),
    [anon_sym_int136] = ACTIONS(769),
    [anon_sym_int144] = ACTIONS(769),
    [anon_sym_int152] = ACTIONS(769),
    [anon_sym_int160] = ACTIONS(769),
    [anon_sym_int168] = ACTIONS(769),
    [anon_sym_int176] = ACTIONS(769),
    [anon_sym_int184] = ACTIONS(769),
    [anon_sym_int192] = ACTIONS(769),
    [anon_sym_int200] = ACTIONS(769),
    [anon_sym_int208] = ACTIONS(769),
    [anon_sym_int216] = ACTIONS(769),
    [anon_sym_int224] = ACTIONS(769),
    [anon_sym_int232] = ACTIONS(769),
    [anon_sym_int240] = ACTIONS(769),
    [anon_sym_int248] = ACTIONS(769),
    [anon_sym_int256] = ACTIONS(769),
    [anon_sym_uint] = ACTIONS(769),
    [anon_sym_uint8] = ACTIONS(769),
    [anon_sym_uint16] = ACTIONS(769),
    [anon_sym_uint24] = ACTIONS(769),
    [anon_sym_uint32] = ACTIONS(769),
    [anon_sym_uint40] = ACTIONS(769),
    [anon_sym_uint48] = ACTIONS(769),
    [anon_sym_uint56] = ACTIONS(769),
    [anon_sym_uint64] = ACTIONS(769),
    [anon_sym_uint72] = ACTIONS(769),
    [anon_sym_uint80] = ACTIONS(769),
    [anon_sym_uint88] = ACTIONS(769),
    [anon_sym_uint96] = ACTIONS(769),
    [anon_sym_uint104] = ACTIONS(769),
    [anon_sym_uint112] = ACTIONS(769),
    [anon_sym_uint120] = ACTIONS(769),
    [anon_sym_uint128] = ACTIONS(769),
    [anon_sym_uint136] = ACTIONS(769),
    [anon_sym_uint144] = ACTIONS(769),
    [anon_sym_uint152] = ACTIONS(769),
    [anon_sym_uint160] = ACTIONS(769),
    [anon_sym_uint168] = ACTIONS(769),
    [anon_sym_uint176] = ACTIONS(769),
    [anon_sym_uint184] = ACTIONS(769),
    [anon_sym_uint192] = ACTIONS(769),
    [anon_sym_uint200] = ACTIONS(769),
    [anon_sym_uint208] = ACTIONS(769),
    [anon_sym_uint216] = ACTIONS(769),
    [anon_sym_uint224] = ACTIONS(769),
    [anon_sym_uint232] = ACTIONS(769),
    [anon_sym_uint240] = ACTIONS(769),
    [anon_sym_uint248] = ACTIONS(769),
    [anon_sym_uint256] = ACTIONS(769),
    [anon_sym_bytes] = ACTIONS(769),
    [anon_sym_bytes1] = ACTIONS(769),
    [anon_sym_bytes2] = ACTIONS(769),
    [anon_sym_bytes3] = ACTIONS(769),
    [anon_sym_bytes4] = ACTIONS(769),
    [anon_sym_bytes5] = ACTIONS(769),
    [anon_sym_bytes6] = ACTIONS(769),
    [anon_sym_bytes7] = ACTIONS(769),
    [anon_sym_bytes8] = ACTIONS(769),
    [anon_sym_bytes9] = ACTIONS(769),
    [anon_sym_bytes10] = ACTIONS(769),
    [anon_sym_bytes11] = ACTIONS(769),
    [anon_sym_bytes12] = ACTIONS(769),
    [anon_sym_bytes13] = ACTIONS(769),
    [anon_sym_bytes14] = ACTIONS(769),
    [anon_sym_bytes15] = ACTIONS(769),
    [anon_sym_bytes16] = ACTIONS(769),
    [anon_sym_bytes17] = ACTIONS(769),
    [anon_sym_bytes18] = ACTIONS(769),
    [anon_sym_bytes19] = ACTIONS(769),
    [anon_sym_bytes20] = ACTIONS(769),
    [anon_sym_bytes21] = ACTIONS(769),
    [anon_sym_bytes22] = ACTIONS(769),
    [anon_sym_bytes23] = ACTIONS(769),
    [anon_sym_bytes24] = ACTIONS(769),
    [anon_sym_bytes25] = ACTIONS(769),
    [anon_sym_bytes26] = ACTIONS(769),
    [anon_sym_bytes27] = ACTIONS(769),
    [anon_sym_bytes28] = ACTIONS(769),
    [anon_sym_bytes29] = ACTIONS(769),
    [anon_sym_bytes30] = ACTIONS(769),
    [anon_sym_bytes31] = ACTIONS(769),
    [anon_sym_bytes32] = ACTIONS(769),
    [anon_sym_fixed] = ACTIONS(769),
    [aux_sym__fixed_token1] = ACTIONS(769),
    [anon_sym_ufixed] = ACTIONS(769),
    [aux_sym__ufixed_token1] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [ts_builtin_sym_end] = ACTIONS(771),
    [sym_identifier] = ACTIONS(773),
    [anon_sym_pragma] = ACTIONS(773),
    [anon_sym_import] = ACTIONS(773),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_abstract] = ACTIONS(773),
    [anon_sym_contract] = ACTIONS(773),
    [anon_sym_error] = ACTIONS(773),
    [anon_sym_interface] = ACTIONS(773),
    [anon_sym_library] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(773),
    [anon_sym_enum] = ACTIONS(773),
    [anon_sym_event] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(773),
    [anon_sym_byte] = ACTIONS(773),
    [anon_sym_address] = ACTIONS(773),
    [anon_sym_var] = ACTIONS(773),
    [anon_sym_mapping] = ACTIONS(773),
    [anon_sym_bool] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_int] = ACTIONS(773),
    [anon_sym_int8] = ACTIONS(773),
    [anon_sym_int16] = ACTIONS(773),
    [anon_sym_int24] = ACTIONS(773),
    [anon_sym_int32] = ACTIONS(773),
    [anon_sym_int40] = ACTIONS(773),
    [anon_sym_int48] = ACTIONS(773),
    [anon_sym_int56] = ACTIONS(773),
    [anon_sym_int64] = ACTIONS(773),
    [anon_sym_int72] = ACTIONS(773),
    [anon_sym_int80] = ACTIONS(773),
    [anon_sym_int88] = ACTIONS(773),
    [anon_sym_int96] = ACTIONS(773),
    [anon_sym_int104] = ACTIONS(773),
    [anon_sym_int112] = ACTIONS(773),
    [anon_sym_int120] = ACTIONS(773),
    [anon_sym_int128] = ACTIONS(773),
    [anon_sym_int136] = ACTIONS(773),
    [anon_sym_int144] = ACTIONS(773),
    [anon_sym_int152] = ACTIONS(773),
    [anon_sym_int160] = ACTIONS(773),
    [anon_sym_int168] = ACTIONS(773),
    [anon_sym_int176] = ACTIONS(773),
    [anon_sym_int184] = ACTIONS(773),
    [anon_sym_int192] = ACTIONS(773),
    [anon_sym_int200] = ACTIONS(773),
    [anon_sym_int208] = ACTIONS(773),
    [anon_sym_int216] = ACTIONS(773),
    [anon_sym_int224] = ACTIONS(773),
    [anon_sym_int232] = ACTIONS(773),
    [anon_sym_int240] = ACTIONS(773),
    [anon_sym_int248] = ACTIONS(773),
    [anon_sym_int256] = ACTIONS(773),
    [anon_sym_uint] = ACTIONS(773),
    [anon_sym_uint8] = ACTIONS(773),
    [anon_sym_uint16] = ACTIONS(773),
    [anon_sym_uint24] = ACTIONS(773),
    [anon_sym_uint32] = ACTIONS(773),
    [anon_sym_uint40] = ACTIONS(773),
    [anon_sym_uint48] = ACTIONS(773),
    [anon_sym_uint56] = ACTIONS(773),
    [anon_sym_uint64] = ACTIONS(773),
    [anon_sym_uint72] = ACTIONS(773),
    [anon_sym_uint80] = ACTIONS(773),
    [anon_sym_uint88] = ACTIONS(773),
    [anon_sym_uint96] = ACTIONS(773),
    [anon_sym_uint104] = ACTIONS(773),
    [anon_sym_uint112] = ACTIONS(773),
    [anon_sym_uint120] = ACTIONS(773),
    [anon_sym_uint128] = ACTIONS(773),
    [anon_sym_uint136] = ACTIONS(773),
    [anon_sym_uint144] = ACTIONS(773),
    [anon_sym_uint152] = ACTIONS(773),
    [anon_sym_uint160] = ACTIONS(773),
    [anon_sym_uint168] = ACTIONS(773),
    [anon_sym_uint176] = ACTIONS(773),
    [anon_sym_uint184] = ACTIONS(773),
    [anon_sym_uint192] = ACTIONS(773),
    [anon_sym_uint200] = ACTIONS(773),
    [anon_sym_uint208] = ACTIONS(773),
    [anon_sym_uint216] = ACTIONS(773),
    [anon_sym_uint224] = ACTIONS(773),
    [anon_sym_uint232] = ACTIONS(773),
    [anon_sym_uint240] = ACTIONS(773),
    [anon_sym_uint248] = ACTIONS(773),
    [anon_sym_uint256] = ACTIONS(773),
    [anon_sym_bytes] = ACTIONS(773),
    [anon_sym_bytes1] = ACTIONS(773),
    [anon_sym_bytes2] = ACTIONS(773),
    [anon_sym_bytes3] = ACTIONS(773),
    [anon_sym_bytes4] = ACTIONS(773),
    [anon_sym_bytes5] = ACTIONS(773),
    [anon_sym_bytes6] = ACTIONS(773),
    [anon_sym_bytes7] = ACTIONS(773),
    [anon_sym_bytes8] = ACTIONS(773),
    [anon_sym_bytes9] = ACTIONS(773),
    [anon_sym_bytes10] = ACTIONS(773),
    [anon_sym_bytes11] = ACTIONS(773),
    [anon_sym_bytes12] = ACTIONS(773),
    [anon_sym_bytes13] = ACTIONS(773),
    [anon_sym_bytes14] = ACTIONS(773),
    [anon_sym_bytes15] = ACTIONS(773),
    [anon_sym_bytes16] = ACTIONS(773),
    [anon_sym_bytes17] = ACTIONS(773),
    [anon_sym_bytes18] = ACTIONS(773),
    [anon_sym_bytes19] = ACTIONS(773),
    [anon_sym_bytes20] = ACTIONS(773),
    [anon_sym_bytes21] = ACTIONS(773),
    [anon_sym_bytes22] = ACTIONS(773),
    [anon_sym_bytes23] = ACTIONS(773),
    [anon_sym_bytes24] = ACTIONS(773),
    [anon_sym_bytes25] = ACTIONS(773),
    [anon_sym_bytes26] = ACTIONS(773),
    [anon_sym_bytes27] = ACTIONS(773),
    [anon_sym_bytes28] = ACTIONS(773),
    [anon_sym_bytes29] = ACTIONS(773),
    [anon_sym_bytes30] = ACTIONS(773),
    [anon_sym_bytes31] = ACTIONS(773),
    [anon_sym_bytes32] = ACTIONS(773),
    [anon_sym_fixed] = ACTIONS(773),
    [aux_sym__fixed_token1] = ACTIONS(773),
    [anon_sym_ufixed] = ACTIONS(773),
    [aux_sym__ufixed_token1] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_identifier] = ACTIONS(741),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_type] = ACTIONS(741),
    [anon_sym_error] = ACTIONS(741),
    [anon_sym_struct] = ACTIONS(741),
    [anon_sym_enum] = ACTIONS(741),
    [anon_sym_event] = ACTIONS(741),
    [anon_sym_using] = ACTIONS(741),
    [anon_sym_function] = ACTIONS(741),
    [anon_sym_byte] = ACTIONS(741),
    [anon_sym_address] = ACTIONS(741),
    [anon_sym_var] = ACTIONS(741),
    [anon_sym_modifier] = ACTIONS(741),
    [anon_sym_constructor] = ACTIONS(741),
    [anon_sym_fallback] = ACTIONS(741),
    [anon_sym_receive] = ACTIONS(741),
    [anon_sym_mapping] = ACTIONS(741),
    [anon_sym_bool] = ACTIONS(741),
    [anon_sym_string] = ACTIONS(741),
    [anon_sym_int] = ACTIONS(741),
    [anon_sym_int8] = ACTIONS(741),
    [anon_sym_int16] = ACTIONS(741),
    [anon_sym_int24] = ACTIONS(741),
    [anon_sym_int32] = ACTIONS(741),
    [anon_sym_int40] = ACTIONS(741),
    [anon_sym_int48] = ACTIONS(741),
    [anon_sym_int56] = ACTIONS(741),
    [anon_sym_int64] = ACTIONS(741),
    [anon_sym_int72] = ACTIONS(741),
    [anon_sym_int80] = ACTIONS(741),
    [anon_sym_int88] = ACTIONS(741),
    [anon_sym_int96] = ACTIONS(741),
    [anon_sym_int104] = ACTIONS(741),
    [anon_sym_int112] = ACTIONS(741),
    [anon_sym_int120] = ACTIONS(741),
    [anon_sym_int128] = ACTIONS(741),
    [anon_sym_int136] = ACTIONS(741),
    [anon_sym_int144] = ACTIONS(741),
    [anon_sym_int152] = ACTIONS(741),
    [anon_sym_int160] = ACTIONS(741),
    [anon_sym_int168] = ACTIONS(741),
    [anon_sym_int176] = ACTIONS(741),
    [anon_sym_int184] = ACTIONS(741),
    [anon_sym_int192] = ACTIONS(741),
    [anon_sym_int200] = ACTIONS(741),
    [anon_sym_int208] = ACTIONS(741),
    [anon_sym_int216] = ACTIONS(741),
    [anon_sym_int224] = ACTIONS(741),
    [anon_sym_int232] = ACTIONS(741),
    [anon_sym_int240] = ACTIONS(741),
    [anon_sym_int248] = ACTIONS(741),
    [anon_sym_int256] = ACTIONS(741),
    [anon_sym_uint] = ACTIONS(741),
    [anon_sym_uint8] = ACTIONS(741),
    [anon_sym_uint16] = ACTIONS(741),
    [anon_sym_uint24] = ACTIONS(741),
    [anon_sym_uint32] = ACTIONS(741),
    [anon_sym_uint40] = ACTIONS(741),
    [anon_sym_uint48] = ACTIONS(741),
    [anon_sym_uint56] = ACTIONS(741),
    [anon_sym_uint64] = ACTIONS(741),
    [anon_sym_uint72] = ACTIONS(741),
    [anon_sym_uint80] = ACTIONS(741),
    [anon_sym_uint88] = ACTIONS(741),
    [anon_sym_uint96] = ACTIONS(741),
    [anon_sym_uint104] = ACTIONS(741),
    [anon_sym_uint112] = ACTIONS(741),
    [anon_sym_uint120] = ACTIONS(741),
    [anon_sym_uint128] = ACTIONS(741),
    [anon_sym_uint136] = ACTIONS(741),
    [anon_sym_uint144] = ACTIONS(741),
    [anon_sym_uint152] = ACTIONS(741),
    [anon_sym_uint160] = ACTIONS(741),
    [anon_sym_uint168] = ACTIONS(741),
    [anon_sym_uint176] = ACTIONS(741),
    [anon_sym_uint184] = ACTIONS(741),
    [anon_sym_uint192] = ACTIONS(741),
    [anon_sym_uint200] = ACTIONS(741),
    [anon_sym_uint208] = ACTIONS(741),
    [anon_sym_uint216] = ACTIONS(741),
    [anon_sym_uint224] = ACTIONS(741),
    [anon_sym_uint232] = ACTIONS(741),
    [anon_sym_uint240] = ACTIONS(741),
    [anon_sym_uint248] = ACTIONS(741),
    [anon_sym_uint256] = ACTIONS(741),
    [anon_sym_bytes] = ACTIONS(741),
    [anon_sym_bytes1] = ACTIONS(741),
    [anon_sym_bytes2] = ACTIONS(741),
    [anon_sym_bytes3] = ACTIONS(741),
    [anon_sym_bytes4] = ACTIONS(741),
    [anon_sym_bytes5] = ACTIONS(741),
    [anon_sym_bytes6] = ACTIONS(741),
    [anon_sym_bytes7] = ACTIONS(741),
    [anon_sym_bytes8] = ACTIONS(741),
    [anon_sym_bytes9] = ACTIONS(741),
    [anon_sym_bytes10] = ACTIONS(741),
    [anon_sym_bytes11] = ACTIONS(741),
    [anon_sym_bytes12] = ACTIONS(741),
    [anon_sym_bytes13] = ACTIONS(741),
    [anon_sym_bytes14] = ACTIONS(741),
    [anon_sym_bytes15] = ACTIONS(741),
    [anon_sym_bytes16] = ACTIONS(741),
    [anon_sym_bytes17] = ACTIONS(741),
    [anon_sym_bytes18] = ACTIONS(741),
    [anon_sym_bytes19] = ACTIONS(741),
    [anon_sym_bytes20] = ACTIONS(741),
    [anon_sym_bytes21] = ACTIONS(741),
    [anon_sym_bytes22] = ACTIONS(741),
    [anon_sym_bytes23] = ACTIONS(741),
    [anon_sym_bytes24] = ACTIONS(741),
    [anon_sym_bytes25] = ACTIONS(741),
    [anon_sym_bytes26] = ACTIONS(741),
    [anon_sym_bytes27] = ACTIONS(741),
    [anon_sym_bytes28] = ACTIONS(741),
    [anon_sym_bytes29] = ACTIONS(741),
    [anon_sym_bytes30] = ACTIONS(741),
    [anon_sym_bytes31] = ACTIONS(741),
    [anon_sym_bytes32] = ACTIONS(741),
    [anon_sym_fixed] = ACTIONS(741),
    [aux_sym__fixed_token1] = ACTIONS(741),
    [anon_sym_ufixed] = ACTIONS(741),
    [aux_sym__ufixed_token1] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(695),
    [anon_sym_RBRACE] = ACTIONS(693),
    [anon_sym_type] = ACTIONS(695),
    [anon_sym_error] = ACTIONS(695),
    [anon_sym_struct] = ACTIONS(695),
    [anon_sym_enum] = ACTIONS(695),
    [anon_sym_event] = ACTIONS(695),
    [anon_sym_using] = ACTIONS(695),
    [anon_sym_function] = ACTIONS(695),
    [anon_sym_byte] = ACTIONS(695),
    [anon_sym_address] = ACTIONS(695),
    [anon_sym_var] = ACTIONS(695),
    [anon_sym_modifier] = ACTIONS(695),
    [anon_sym_constructor] = ACTIONS(695),
    [anon_sym_fallback] = ACTIONS(695),
    [anon_sym_receive] = ACTIONS(695),
    [anon_sym_mapping] = ACTIONS(695),
    [anon_sym_bool] = ACTIONS(695),
    [anon_sym_string] = ACTIONS(695),
    [anon_sym_int] = ACTIONS(695),
    [anon_sym_int8] = ACTIONS(695),
    [anon_sym_int16] = ACTIONS(695),
    [anon_sym_int24] = ACTIONS(695),
    [anon_sym_int32] = ACTIONS(695),
    [anon_sym_int40] = ACTIONS(695),
    [anon_sym_int48] = ACTIONS(695),
    [anon_sym_int56] = ACTIONS(695),
    [anon_sym_int64] = ACTIONS(695),
    [anon_sym_int72] = ACTIONS(695),
    [anon_sym_int80] = ACTIONS(695),
    [anon_sym_int88] = ACTIONS(695),
    [anon_sym_int96] = ACTIONS(695),
    [anon_sym_int104] = ACTIONS(695),
    [anon_sym_int112] = ACTIONS(695),
    [anon_sym_int120] = ACTIONS(695),
    [anon_sym_int128] = ACTIONS(695),
    [anon_sym_int136] = ACTIONS(695),
    [anon_sym_int144] = ACTIONS(695),
    [anon_sym_int152] = ACTIONS(695),
    [anon_sym_int160] = ACTIONS(695),
    [anon_sym_int168] = ACTIONS(695),
    [anon_sym_int176] = ACTIONS(695),
    [anon_sym_int184] = ACTIONS(695),
    [anon_sym_int192] = ACTIONS(695),
    [anon_sym_int200] = ACTIONS(695),
    [anon_sym_int208] = ACTIONS(695),
    [anon_sym_int216] = ACTIONS(695),
    [anon_sym_int224] = ACTIONS(695),
    [anon_sym_int232] = ACTIONS(695),
    [anon_sym_int240] = ACTIONS(695),
    [anon_sym_int248] = ACTIONS(695),
    [anon_sym_int256] = ACTIONS(695),
    [anon_sym_uint] = ACTIONS(695),
    [anon_sym_uint8] = ACTIONS(695),
    [anon_sym_uint16] = ACTIONS(695),
    [anon_sym_uint24] = ACTIONS(695),
    [anon_sym_uint32] = ACTIONS(695),
    [anon_sym_uint40] = ACTIONS(695),
    [anon_sym_uint48] = ACTIONS(695),
    [anon_sym_uint56] = ACTIONS(695),
    [anon_sym_uint64] = ACTIONS(695),
    [anon_sym_uint72] = ACTIONS(695),
    [anon_sym_uint80] = ACTIONS(695),
    [anon_sym_uint88] = ACTIONS(695),
    [anon_sym_uint96] = ACTIONS(695),
    [anon_sym_uint104] = ACTIONS(695),
    [anon_sym_uint112] = ACTIONS(695),
    [anon_sym_uint120] = ACTIONS(695),
    [anon_sym_uint128] = ACTIONS(695),
    [anon_sym_uint136] = ACTIONS(695),
    [anon_sym_uint144] = ACTIONS(695),
    [anon_sym_uint152] = ACTIONS(695),
    [anon_sym_uint160] = ACTIONS(695),
    [anon_sym_uint168] = ACTIONS(695),
    [anon_sym_uint176] = ACTIONS(695),
    [anon_sym_uint184] = ACTIONS(695),
    [anon_sym_uint192] = ACTIONS(695),
    [anon_sym_uint200] = ACTIONS(695),
    [anon_sym_uint208] = ACTIONS(695),
    [anon_sym_uint216] = ACTIONS(695),
    [anon_sym_uint224] = ACTIONS(695),
    [anon_sym_uint232] = ACTIONS(695),
    [anon_sym_uint240] = ACTIONS(695),
    [anon_sym_uint248] = ACTIONS(695),
    [anon_sym_uint256] = ACTIONS(695),
    [anon_sym_bytes] = ACTIONS(695),
    [anon_sym_bytes1] = ACTIONS(695),
    [anon_sym_bytes2] = ACTIONS(695),
    [anon_sym_bytes3] = ACTIONS(695),
    [anon_sym_bytes4] = ACTIONS(695),
    [anon_sym_bytes5] = ACTIONS(695),
    [anon_sym_bytes6] = ACTIONS(695),
    [anon_sym_bytes7] = ACTIONS(695),
    [anon_sym_bytes8] = ACTIONS(695),
    [anon_sym_bytes9] = ACTIONS(695),
    [anon_sym_bytes10] = ACTIONS(695),
    [anon_sym_bytes11] = ACTIONS(695),
    [anon_sym_bytes12] = ACTIONS(695),
    [anon_sym_bytes13] = ACTIONS(695),
    [anon_sym_bytes14] = ACTIONS(695),
    [anon_sym_bytes15] = ACTIONS(695),
    [anon_sym_bytes16] = ACTIONS(695),
    [anon_sym_bytes17] = ACTIONS(695),
    [anon_sym_bytes18] = ACTIONS(695),
    [anon_sym_bytes19] = ACTIONS(695),
    [anon_sym_bytes20] = ACTIONS(695),
    [anon_sym_bytes21] = ACTIONS(695),
    [anon_sym_bytes22] = ACTIONS(695),
    [anon_sym_bytes23] = ACTIONS(695),
    [anon_sym_bytes24] = ACTIONS(695),
    [anon_sym_bytes25] = ACTIONS(695),
    [anon_sym_bytes26] = ACTIONS(695),
    [anon_sym_bytes27] = ACTIONS(695),
    [anon_sym_bytes28] = ACTIONS(695),
    [anon_sym_bytes29] = ACTIONS(695),
    [anon_sym_bytes30] = ACTIONS(695),
    [anon_sym_bytes31] = ACTIONS(695),
    [anon_sym_bytes32] = ACTIONS(695),
    [anon_sym_fixed] = ACTIONS(695),
    [aux_sym__fixed_token1] = ACTIONS(695),
    [anon_sym_ufixed] = ACTIONS(695),
    [aux_sym__ufixed_token1] = ACTIONS(695),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(775),
    [anon_sym_RBRACE] = ACTIONS(777),
    [anon_sym_type] = ACTIONS(775),
    [anon_sym_error] = ACTIONS(775),
    [anon_sym_struct] = ACTIONS(775),
    [anon_sym_enum] = ACTIONS(775),
    [anon_sym_event] = ACTIONS(775),
    [anon_sym_using] = ACTIONS(775),
    [anon_sym_function] = ACTIONS(775),
    [anon_sym_byte] = ACTIONS(775),
    [anon_sym_address] = ACTIONS(775),
    [anon_sym_var] = ACTIONS(775),
    [anon_sym_modifier] = ACTIONS(775),
    [anon_sym_constructor] = ACTIONS(775),
    [anon_sym_fallback] = ACTIONS(775),
    [anon_sym_receive] = ACTIONS(775),
    [anon_sym_mapping] = ACTIONS(775),
    [anon_sym_bool] = ACTIONS(775),
    [anon_sym_string] = ACTIONS(775),
    [anon_sym_int] = ACTIONS(775),
    [anon_sym_int8] = ACTIONS(775),
    [anon_sym_int16] = ACTIONS(775),
    [anon_sym_int24] = ACTIONS(775),
    [anon_sym_int32] = ACTIONS(775),
    [anon_sym_int40] = ACTIONS(775),
    [anon_sym_int48] = ACTIONS(775),
    [anon_sym_int56] = ACTIONS(775),
    [anon_sym_int64] = ACTIONS(775),
    [anon_sym_int72] = ACTIONS(775),
    [anon_sym_int80] = ACTIONS(775),
    [anon_sym_int88] = ACTIONS(775),
    [anon_sym_int96] = ACTIONS(775),
    [anon_sym_int104] = ACTIONS(775),
    [anon_sym_int112] = ACTIONS(775),
    [anon_sym_int120] = ACTIONS(775),
    [anon_sym_int128] = ACTIONS(775),
    [anon_sym_int136] = ACTIONS(775),
    [anon_sym_int144] = ACTIONS(775),
    [anon_sym_int152] = ACTIONS(775),
    [anon_sym_int160] = ACTIONS(775),
    [anon_sym_int168] = ACTIONS(775),
    [anon_sym_int176] = ACTIONS(775),
    [anon_sym_int184] = ACTIONS(775),
    [anon_sym_int192] = ACTIONS(775),
    [anon_sym_int200] = ACTIONS(775),
    [anon_sym_int208] = ACTIONS(775),
    [anon_sym_int216] = ACTIONS(775),
    [anon_sym_int224] = ACTIONS(775),
    [anon_sym_int232] = ACTIONS(775),
    [anon_sym_int240] = ACTIONS(775),
    [anon_sym_int248] = ACTIONS(775),
    [anon_sym_int256] = ACTIONS(775),
    [anon_sym_uint] = ACTIONS(775),
    [anon_sym_uint8] = ACTIONS(775),
    [anon_sym_uint16] = ACTIONS(775),
    [anon_sym_uint24] = ACTIONS(775),
    [anon_sym_uint32] = ACTIONS(775),
    [anon_sym_uint40] = ACTIONS(775),
    [anon_sym_uint48] = ACTIONS(775),
    [anon_sym_uint56] = ACTIONS(775),
    [anon_sym_uint64] = ACTIONS(775),
    [anon_sym_uint72] = ACTIONS(775),
    [anon_sym_uint80] = ACTIONS(775),
    [anon_sym_uint88] = ACTIONS(775),
    [anon_sym_uint96] = ACTIONS(775),
    [anon_sym_uint104] = ACTIONS(775),
    [anon_sym_uint112] = ACTIONS(775),
    [anon_sym_uint120] = ACTIONS(775),
    [anon_sym_uint128] = ACTIONS(775),
    [anon_sym_uint136] = ACTIONS(775),
    [anon_sym_uint144] = ACTIONS(775),
    [anon_sym_uint152] = ACTIONS(775),
    [anon_sym_uint160] = ACTIONS(775),
    [anon_sym_uint168] = ACTIONS(775),
    [anon_sym_uint176] = ACTIONS(775),
    [anon_sym_uint184] = ACTIONS(775),
    [anon_sym_uint192] = ACTIONS(775),
    [anon_sym_uint200] = ACTIONS(775),
    [anon_sym_uint208] = ACTIONS(775),
    [anon_sym_uint216] = ACTIONS(775),
    [anon_sym_uint224] = ACTIONS(775),
    [anon_sym_uint232] = ACTIONS(775),
    [anon_sym_uint240] = ACTIONS(775),
    [anon_sym_uint248] = ACTIONS(775),
    [anon_sym_uint256] = ACTIONS(775),
    [anon_sym_bytes] = ACTIONS(775),
    [anon_sym_bytes1] = ACTIONS(775),
    [anon_sym_bytes2] = ACTIONS(775),
    [anon_sym_bytes3] = ACTIONS(775),
    [anon_sym_bytes4] = ACTIONS(775),
    [anon_sym_bytes5] = ACTIONS(775),
    [anon_sym_bytes6] = ACTIONS(775),
    [anon_sym_bytes7] = ACTIONS(775),
    [anon_sym_bytes8] = ACTIONS(775),
    [anon_sym_bytes9] = ACTIONS(775),
    [anon_sym_bytes10] = ACTIONS(775),
    [anon_sym_bytes11] = ACTIONS(775),
    [anon_sym_bytes12] = ACTIONS(775),
    [anon_sym_bytes13] = ACTIONS(775),
    [anon_sym_bytes14] = ACTIONS(775),
    [anon_sym_bytes15] = ACTIONS(775),
    [anon_sym_bytes16] = ACTIONS(775),
    [anon_sym_bytes17] = ACTIONS(775),
    [anon_sym_bytes18] = ACTIONS(775),
    [anon_sym_bytes19] = ACTIONS(775),
    [anon_sym_bytes20] = ACTIONS(775),
    [anon_sym_bytes21] = ACTIONS(775),
    [anon_sym_bytes22] = ACTIONS(775),
    [anon_sym_bytes23] = ACTIONS(775),
    [anon_sym_bytes24] = ACTIONS(775),
    [anon_sym_bytes25] = ACTIONS(775),
    [anon_sym_bytes26] = ACTIONS(775),
    [anon_sym_bytes27] = ACTIONS(775),
    [anon_sym_bytes28] = ACTIONS(775),
    [anon_sym_bytes29] = ACTIONS(775),
    [anon_sym_bytes30] = ACTIONS(775),
    [anon_sym_bytes31] = ACTIONS(775),
    [anon_sym_bytes32] = ACTIONS(775),
    [anon_sym_fixed] = ACTIONS(775),
    [aux_sym__fixed_token1] = ACTIONS(775),
    [anon_sym_ufixed] = ACTIONS(775),
    [aux_sym__ufixed_token1] = ACTIONS(775),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(779),
    [anon_sym_RBRACE] = ACTIONS(781),
    [anon_sym_type] = ACTIONS(779),
    [anon_sym_error] = ACTIONS(779),
    [anon_sym_struct] = ACTIONS(779),
    [anon_sym_enum] = ACTIONS(779),
    [anon_sym_event] = ACTIONS(779),
    [anon_sym_using] = ACTIONS(779),
    [anon_sym_function] = ACTIONS(779),
    [anon_sym_byte] = ACTIONS(779),
    [anon_sym_address] = ACTIONS(779),
    [anon_sym_var] = ACTIONS(779),
    [anon_sym_modifier] = ACTIONS(779),
    [anon_sym_constructor] = ACTIONS(779),
    [anon_sym_fallback] = ACTIONS(779),
    [anon_sym_receive] = ACTIONS(779),
    [anon_sym_mapping] = ACTIONS(779),
    [anon_sym_bool] = ACTIONS(779),
    [anon_sym_string] = ACTIONS(779),
    [anon_sym_int] = ACTIONS(779),
    [anon_sym_int8] = ACTIONS(779),
    [anon_sym_int16] = ACTIONS(779),
    [anon_sym_int24] = ACTIONS(779),
    [anon_sym_int32] = ACTIONS(779),
    [anon_sym_int40] = ACTIONS(779),
    [anon_sym_int48] = ACTIONS(779),
    [anon_sym_int56] = ACTIONS(779),
    [anon_sym_int64] = ACTIONS(779),
    [anon_sym_int72] = ACTIONS(779),
    [anon_sym_int80] = ACTIONS(779),
    [anon_sym_int88] = ACTIONS(779),
    [anon_sym_int96] = ACTIONS(779),
    [anon_sym_int104] = ACTIONS(779),
    [anon_sym_int112] = ACTIONS(779),
    [anon_sym_int120] = ACTIONS(779),
    [anon_sym_int128] = ACTIONS(779),
    [anon_sym_int136] = ACTIONS(779),
    [anon_sym_int144] = ACTIONS(779),
    [anon_sym_int152] = ACTIONS(779),
    [anon_sym_int160] = ACTIONS(779),
    [anon_sym_int168] = ACTIONS(779),
    [anon_sym_int176] = ACTIONS(779),
    [anon_sym_int184] = ACTIONS(779),
    [anon_sym_int192] = ACTIONS(779),
    [anon_sym_int200] = ACTIONS(779),
    [anon_sym_int208] = ACTIONS(779),
    [anon_sym_int216] = ACTIONS(779),
    [anon_sym_int224] = ACTIONS(779),
    [anon_sym_int232] = ACTIONS(779),
    [anon_sym_int240] = ACTIONS(779),
    [anon_sym_int248] = ACTIONS(779),
    [anon_sym_int256] = ACTIONS(779),
    [anon_sym_uint] = ACTIONS(779),
    [anon_sym_uint8] = ACTIONS(779),
    [anon_sym_uint16] = ACTIONS(779),
    [anon_sym_uint24] = ACTIONS(779),
    [anon_sym_uint32] = ACTIONS(779),
    [anon_sym_uint40] = ACTIONS(779),
    [anon_sym_uint48] = ACTIONS(779),
    [anon_sym_uint56] = ACTIONS(779),
    [anon_sym_uint64] = ACTIONS(779),
    [anon_sym_uint72] = ACTIONS(779),
    [anon_sym_uint80] = ACTIONS(779),
    [anon_sym_uint88] = ACTIONS(779),
    [anon_sym_uint96] = ACTIONS(779),
    [anon_sym_uint104] = ACTIONS(779),
    [anon_sym_uint112] = ACTIONS(779),
    [anon_sym_uint120] = ACTIONS(779),
    [anon_sym_uint128] = ACTIONS(779),
    [anon_sym_uint136] = ACTIONS(779),
    [anon_sym_uint144] = ACTIONS(779),
    [anon_sym_uint152] = ACTIONS(779),
    [anon_sym_uint160] = ACTIONS(779),
    [anon_sym_uint168] = ACTIONS(779),
    [anon_sym_uint176] = ACTIONS(779),
    [anon_sym_uint184] = ACTIONS(779),
    [anon_sym_uint192] = ACTIONS(779),
    [anon_sym_uint200] = ACTIONS(779),
    [anon_sym_uint208] = ACTIONS(779),
    [anon_sym_uint216] = ACTIONS(779),
    [anon_sym_uint224] = ACTIONS(779),
    [anon_sym_uint232] = ACTIONS(779),
    [anon_sym_uint240] = ACTIONS(779),
    [anon_sym_uint248] = ACTIONS(779),
    [anon_sym_uint256] = ACTIONS(779),
    [anon_sym_bytes] = ACTIONS(779),
    [anon_sym_bytes1] = ACTIONS(779),
    [anon_sym_bytes2] = ACTIONS(779),
    [anon_sym_bytes3] = ACTIONS(779),
    [anon_sym_bytes4] = ACTIONS(779),
    [anon_sym_bytes5] = ACTIONS(779),
    [anon_sym_bytes6] = ACTIONS(779),
    [anon_sym_bytes7] = ACTIONS(779),
    [anon_sym_bytes8] = ACTIONS(779),
    [anon_sym_bytes9] = ACTIONS(779),
    [anon_sym_bytes10] = ACTIONS(779),
    [anon_sym_bytes11] = ACTIONS(779),
    [anon_sym_bytes12] = ACTIONS(779),
    [anon_sym_bytes13] = ACTIONS(779),
    [anon_sym_bytes14] = ACTIONS(779),
    [anon_sym_bytes15] = ACTIONS(779),
    [anon_sym_bytes16] = ACTIONS(779),
    [anon_sym_bytes17] = ACTIONS(779),
    [anon_sym_bytes18] = ACTIONS(779),
    [anon_sym_bytes19] = ACTIONS(779),
    [anon_sym_bytes20] = ACTIONS(779),
    [anon_sym_bytes21] = ACTIONS(779),
    [anon_sym_bytes22] = ACTIONS(779),
    [anon_sym_bytes23] = ACTIONS(779),
    [anon_sym_bytes24] = ACTIONS(779),
    [anon_sym_bytes25] = ACTIONS(779),
    [anon_sym_bytes26] = ACTIONS(779),
    [anon_sym_bytes27] = ACTIONS(779),
    [anon_sym_bytes28] = ACTIONS(779),
    [anon_sym_bytes29] = ACTIONS(779),
    [anon_sym_bytes30] = ACTIONS(779),
    [anon_sym_bytes31] = ACTIONS(779),
    [anon_sym_bytes32] = ACTIONS(779),
    [anon_sym_fixed] = ACTIONS(779),
    [aux_sym__fixed_token1] = ACTIONS(779),
    [anon_sym_ufixed] = ACTIONS(779),
    [aux_sym__ufixed_token1] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_identifier] = ACTIONS(783),
    [anon_sym_RBRACE] = ACTIONS(785),
    [anon_sym_type] = ACTIONS(783),
    [anon_sym_error] = ACTIONS(783),
    [anon_sym_struct] = ACTIONS(783),
    [anon_sym_enum] = ACTIONS(783),
    [anon_sym_event] = ACTIONS(783),
    [anon_sym_using] = ACTIONS(783),
    [anon_sym_function] = ACTIONS(783),
    [anon_sym_byte] = ACTIONS(783),
    [anon_sym_address] = ACTIONS(783),
    [anon_sym_var] = ACTIONS(783),
    [anon_sym_modifier] = ACTIONS(783),
    [anon_sym_constructor] = ACTIONS(783),
    [anon_sym_fallback] = ACTIONS(783),
    [anon_sym_receive] = ACTIONS(783),
    [anon_sym_mapping] = ACTIONS(783),
    [anon_sym_bool] = ACTIONS(783),
    [anon_sym_string] = ACTIONS(783),
    [anon_sym_int] = ACTIONS(783),
    [anon_sym_int8] = ACTIONS(783),
    [anon_sym_int16] = ACTIONS(783),
    [anon_sym_int24] = ACTIONS(783),
    [anon_sym_int32] = ACTIONS(783),
    [anon_sym_int40] = ACTIONS(783),
    [anon_sym_int48] = ACTIONS(783),
    [anon_sym_int56] = ACTIONS(783),
    [anon_sym_int64] = ACTIONS(783),
    [anon_sym_int72] = ACTIONS(783),
    [anon_sym_int80] = ACTIONS(783),
    [anon_sym_int88] = ACTIONS(783),
    [anon_sym_int96] = ACTIONS(783),
    [anon_sym_int104] = ACTIONS(783),
    [anon_sym_int112] = ACTIONS(783),
    [anon_sym_int120] = ACTIONS(783),
    [anon_sym_int128] = ACTIONS(783),
    [anon_sym_int136] = ACTIONS(783),
    [anon_sym_int144] = ACTIONS(783),
    [anon_sym_int152] = ACTIONS(783),
    [anon_sym_int160] = ACTIONS(783),
    [anon_sym_int168] = ACTIONS(783),
    [anon_sym_int176] = ACTIONS(783),
    [anon_sym_int184] = ACTIONS(783),
    [anon_sym_int192] = ACTIONS(783),
    [anon_sym_int200] = ACTIONS(783),
    [anon_sym_int208] = ACTIONS(783),
    [anon_sym_int216] = ACTIONS(783),
    [anon_sym_int224] = ACTIONS(783),
    [anon_sym_int232] = ACTIONS(783),
    [anon_sym_int240] = ACTIONS(783),
    [anon_sym_int248] = ACTIONS(783),
    [anon_sym_int256] = ACTIONS(783),
    [anon_sym_uint] = ACTIONS(783),
    [anon_sym_uint8] = ACTIONS(783),
    [anon_sym_uint16] = ACTIONS(783),
    [anon_sym_uint24] = ACTIONS(783),
    [anon_sym_uint32] = ACTIONS(783),
    [anon_sym_uint40] = ACTIONS(783),
    [anon_sym_uint48] = ACTIONS(783),
    [anon_sym_uint56] = ACTIONS(783),
    [anon_sym_uint64] = ACTIONS(783),
    [anon_sym_uint72] = ACTIONS(783),
    [anon_sym_uint80] = ACTIONS(783),
    [anon_sym_uint88] = ACTIONS(783),
    [anon_sym_uint96] = ACTIONS(783),
    [anon_sym_uint104] = ACTIONS(783),
    [anon_sym_uint112] = ACTIONS(783),
    [anon_sym_uint120] = ACTIONS(783),
    [anon_sym_uint128] = ACTIONS(783),
    [anon_sym_uint136] = ACTIONS(783),
    [anon_sym_uint144] = ACTIONS(783),
    [anon_sym_uint152] = ACTIONS(783),
    [anon_sym_uint160] = ACTIONS(783),
    [anon_sym_uint168] = ACTIONS(783),
    [anon_sym_uint176] = ACTIONS(783),
    [anon_sym_uint184] = ACTIONS(783),
    [anon_sym_uint192] = ACTIONS(783),
    [anon_sym_uint200] = ACTIONS(783),
    [anon_sym_uint208] = ACTIONS(783),
    [anon_sym_uint216] = ACTIONS(783),
    [anon_sym_uint224] = ACTIONS(783),
    [anon_sym_uint232] = ACTIONS(783),
    [anon_sym_uint240] = ACTIONS(783),
    [anon_sym_uint248] = ACTIONS(783),
    [anon_sym_uint256] = ACTIONS(783),
    [anon_sym_bytes] = ACTIONS(783),
    [anon_sym_bytes1] = ACTIONS(783),
    [anon_sym_bytes2] = ACTIONS(783),
    [anon_sym_bytes3] = ACTIONS(783),
    [anon_sym_bytes4] = ACTIONS(783),
    [anon_sym_bytes5] = ACTIONS(783),
    [anon_sym_bytes6] = ACTIONS(783),
    [anon_sym_bytes7] = ACTIONS(783),
    [anon_sym_bytes8] = ACTIONS(783),
    [anon_sym_bytes9] = ACTIONS(783),
    [anon_sym_bytes10] = ACTIONS(783),
    [anon_sym_bytes11] = ACTIONS(783),
    [anon_sym_bytes12] = ACTIONS(783),
    [anon_sym_bytes13] = ACTIONS(783),
    [anon_sym_bytes14] = ACTIONS(783),
    [anon_sym_bytes15] = ACTIONS(783),
    [anon_sym_bytes16] = ACTIONS(783),
    [anon_sym_bytes17] = ACTIONS(783),
    [anon_sym_bytes18] = ACTIONS(783),
    [anon_sym_bytes19] = ACTIONS(783),
    [anon_sym_bytes20] = ACTIONS(783),
    [anon_sym_bytes21] = ACTIONS(783),
    [anon_sym_bytes22] = ACTIONS(783),
    [anon_sym_bytes23] = ACTIONS(783),
    [anon_sym_bytes24] = ACTIONS(783),
    [anon_sym_bytes25] = ACTIONS(783),
    [anon_sym_bytes26] = ACTIONS(783),
    [anon_sym_bytes27] = ACTIONS(783),
    [anon_sym_bytes28] = ACTIONS(783),
    [anon_sym_bytes29] = ACTIONS(783),
    [anon_sym_bytes30] = ACTIONS(783),
    [anon_sym_bytes31] = ACTIONS(783),
    [anon_sym_bytes32] = ACTIONS(783),
    [anon_sym_fixed] = ACTIONS(783),
    [aux_sym__fixed_token1] = ACTIONS(783),
    [anon_sym_ufixed] = ACTIONS(783),
    [aux_sym__ufixed_token1] = ACTIONS(783),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_type] = ACTIONS(787),
    [anon_sym_error] = ACTIONS(787),
    [anon_sym_struct] = ACTIONS(787),
    [anon_sym_enum] = ACTIONS(787),
    [anon_sym_event] = ACTIONS(787),
    [anon_sym_using] = ACTIONS(787),
    [anon_sym_function] = ACTIONS(787),
    [anon_sym_byte] = ACTIONS(787),
    [anon_sym_address] = ACTIONS(787),
    [anon_sym_var] = ACTIONS(787),
    [anon_sym_modifier] = ACTIONS(787),
    [anon_sym_constructor] = ACTIONS(787),
    [anon_sym_fallback] = ACTIONS(787),
    [anon_sym_receive] = ACTIONS(787),
    [anon_sym_mapping] = ACTIONS(787),
    [anon_sym_bool] = ACTIONS(787),
    [anon_sym_string] = ACTIONS(787),
    [anon_sym_int] = ACTIONS(787),
    [anon_sym_int8] = ACTIONS(787),
    [anon_sym_int16] = ACTIONS(787),
    [anon_sym_int24] = ACTIONS(787),
    [anon_sym_int32] = ACTIONS(787),
    [anon_sym_int40] = ACTIONS(787),
    [anon_sym_int48] = ACTIONS(787),
    [anon_sym_int56] = ACTIONS(787),
    [anon_sym_int64] = ACTIONS(787),
    [anon_sym_int72] = ACTIONS(787),
    [anon_sym_int80] = ACTIONS(787),
    [anon_sym_int88] = ACTIONS(787),
    [anon_sym_int96] = ACTIONS(787),
    [anon_sym_int104] = ACTIONS(787),
    [anon_sym_int112] = ACTIONS(787),
    [anon_sym_int120] = ACTIONS(787),
    [anon_sym_int128] = ACTIONS(787),
    [anon_sym_int136] = ACTIONS(787),
    [anon_sym_int144] = ACTIONS(787),
    [anon_sym_int152] = ACTIONS(787),
    [anon_sym_int160] = ACTIONS(787),
    [anon_sym_int168] = ACTIONS(787),
    [anon_sym_int176] = ACTIONS(787),
    [anon_sym_int184] = ACTIONS(787),
    [anon_sym_int192] = ACTIONS(787),
    [anon_sym_int200] = ACTIONS(787),
    [anon_sym_int208] = ACTIONS(787),
    [anon_sym_int216] = ACTIONS(787),
    [anon_sym_int224] = ACTIONS(787),
    [anon_sym_int232] = ACTIONS(787),
    [anon_sym_int240] = ACTIONS(787),
    [anon_sym_int248] = ACTIONS(787),
    [anon_sym_int256] = ACTIONS(787),
    [anon_sym_uint] = ACTIONS(787),
    [anon_sym_uint8] = ACTIONS(787),
    [anon_sym_uint16] = ACTIONS(787),
    [anon_sym_uint24] = ACTIONS(787),
    [anon_sym_uint32] = ACTIONS(787),
    [anon_sym_uint40] = ACTIONS(787),
    [anon_sym_uint48] = ACTIONS(787),
    [anon_sym_uint56] = ACTIONS(787),
    [anon_sym_uint64] = ACTIONS(787),
    [anon_sym_uint72] = ACTIONS(787),
    [anon_sym_uint80] = ACTIONS(787),
    [anon_sym_uint88] = ACTIONS(787),
    [anon_sym_uint96] = ACTIONS(787),
    [anon_sym_uint104] = ACTIONS(787),
    [anon_sym_uint112] = ACTIONS(787),
    [anon_sym_uint120] = ACTIONS(787),
    [anon_sym_uint128] = ACTIONS(787),
    [anon_sym_uint136] = ACTIONS(787),
    [anon_sym_uint144] = ACTIONS(787),
    [anon_sym_uint152] = ACTIONS(787),
    [anon_sym_uint160] = ACTIONS(787),
    [anon_sym_uint168] = ACTIONS(787),
    [anon_sym_uint176] = ACTIONS(787),
    [anon_sym_uint184] = ACTIONS(787),
    [anon_sym_uint192] = ACTIONS(787),
    [anon_sym_uint200] = ACTIONS(787),
    [anon_sym_uint208] = ACTIONS(787),
    [anon_sym_uint216] = ACTIONS(787),
    [anon_sym_uint224] = ACTIONS(787),
    [anon_sym_uint232] = ACTIONS(787),
    [anon_sym_uint240] = ACTIONS(787),
    [anon_sym_uint248] = ACTIONS(787),
    [anon_sym_uint256] = ACTIONS(787),
    [anon_sym_bytes] = ACTIONS(787),
    [anon_sym_bytes1] = ACTIONS(787),
    [anon_sym_bytes2] = ACTIONS(787),
    [anon_sym_bytes3] = ACTIONS(787),
    [anon_sym_bytes4] = ACTIONS(787),
    [anon_sym_bytes5] = ACTIONS(787),
    [anon_sym_bytes6] = ACTIONS(787),
    [anon_sym_bytes7] = ACTIONS(787),
    [anon_sym_bytes8] = ACTIONS(787),
    [anon_sym_bytes9] = ACTIONS(787),
    [anon_sym_bytes10] = ACTIONS(787),
    [anon_sym_bytes11] = ACTIONS(787),
    [anon_sym_bytes12] = ACTIONS(787),
    [anon_sym_bytes13] = ACTIONS(787),
    [anon_sym_bytes14] = ACTIONS(787),
    [anon_sym_bytes15] = ACTIONS(787),
    [anon_sym_bytes16] = ACTIONS(787),
    [anon_sym_bytes17] = ACTIONS(787),
    [anon_sym_bytes18] = ACTIONS(787),
    [anon_sym_bytes19] = ACTIONS(787),
    [anon_sym_bytes20] = ACTIONS(787),
    [anon_sym_bytes21] = ACTIONS(787),
    [anon_sym_bytes22] = ACTIONS(787),
    [anon_sym_bytes23] = ACTIONS(787),
    [anon_sym_bytes24] = ACTIONS(787),
    [anon_sym_bytes25] = ACTIONS(787),
    [anon_sym_bytes26] = ACTIONS(787),
    [anon_sym_bytes27] = ACTIONS(787),
    [anon_sym_bytes28] = ACTIONS(787),
    [anon_sym_bytes29] = ACTIONS(787),
    [anon_sym_bytes30] = ACTIONS(787),
    [anon_sym_bytes31] = ACTIONS(787),
    [anon_sym_bytes32] = ACTIONS(787),
    [anon_sym_fixed] = ACTIONS(787),
    [aux_sym__fixed_token1] = ACTIONS(787),
    [anon_sym_ufixed] = ACTIONS(787),
    [aux_sym__ufixed_token1] = ACTIONS(787),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(791),
    [anon_sym_RBRACE] = ACTIONS(793),
    [anon_sym_type] = ACTIONS(791),
    [anon_sym_error] = ACTIONS(791),
    [anon_sym_struct] = ACTIONS(791),
    [anon_sym_enum] = ACTIONS(791),
    [anon_sym_event] = ACTIONS(791),
    [anon_sym_using] = ACTIONS(791),
    [anon_sym_function] = ACTIONS(791),
    [anon_sym_byte] = ACTIONS(791),
    [anon_sym_address] = ACTIONS(791),
    [anon_sym_var] = ACTIONS(791),
    [anon_sym_modifier] = ACTIONS(791),
    [anon_sym_constructor] = ACTIONS(791),
    [anon_sym_fallback] = ACTIONS(791),
    [anon_sym_receive] = ACTIONS(791),
    [anon_sym_mapping] = ACTIONS(791),
    [anon_sym_bool] = ACTIONS(791),
    [anon_sym_string] = ACTIONS(791),
    [anon_sym_int] = ACTIONS(791),
    [anon_sym_int8] = ACTIONS(791),
    [anon_sym_int16] = ACTIONS(791),
    [anon_sym_int24] = ACTIONS(791),
    [anon_sym_int32] = ACTIONS(791),
    [anon_sym_int40] = ACTIONS(791),
    [anon_sym_int48] = ACTIONS(791),
    [anon_sym_int56] = ACTIONS(791),
    [anon_sym_int64] = ACTIONS(791),
    [anon_sym_int72] = ACTIONS(791),
    [anon_sym_int80] = ACTIONS(791),
    [anon_sym_int88] = ACTIONS(791),
    [anon_sym_int96] = ACTIONS(791),
    [anon_sym_int104] = ACTIONS(791),
    [anon_sym_int112] = ACTIONS(791),
    [anon_sym_int120] = ACTIONS(791),
    [anon_sym_int128] = ACTIONS(791),
    [anon_sym_int136] = ACTIONS(791),
    [anon_sym_int144] = ACTIONS(791),
    [anon_sym_int152] = ACTIONS(791),
    [anon_sym_int160] = ACTIONS(791),
    [anon_sym_int168] = ACTIONS(791),
    [anon_sym_int176] = ACTIONS(791),
    [anon_sym_int184] = ACTIONS(791),
    [anon_sym_int192] = ACTIONS(791),
    [anon_sym_int200] = ACTIONS(791),
    [anon_sym_int208] = ACTIONS(791),
    [anon_sym_int216] = ACTIONS(791),
    [anon_sym_int224] = ACTIONS(791),
    [anon_sym_int232] = ACTIONS(791),
    [anon_sym_int240] = ACTIONS(791),
    [anon_sym_int248] = ACTIONS(791),
    [anon_sym_int256] = ACTIONS(791),
    [anon_sym_uint] = ACTIONS(791),
    [anon_sym_uint8] = ACTIONS(791),
    [anon_sym_uint16] = ACTIONS(791),
    [anon_sym_uint24] = ACTIONS(791),
    [anon_sym_uint32] = ACTIONS(791),
    [anon_sym_uint40] = ACTIONS(791),
    [anon_sym_uint48] = ACTIONS(791),
    [anon_sym_uint56] = ACTIONS(791),
    [anon_sym_uint64] = ACTIONS(791),
    [anon_sym_uint72] = ACTIONS(791),
    [anon_sym_uint80] = ACTIONS(791),
    [anon_sym_uint88] = ACTIONS(791),
    [anon_sym_uint96] = ACTIONS(791),
    [anon_sym_uint104] = ACTIONS(791),
    [anon_sym_uint112] = ACTIONS(791),
    [anon_sym_uint120] = ACTIONS(791),
    [anon_sym_uint128] = ACTIONS(791),
    [anon_sym_uint136] = ACTIONS(791),
    [anon_sym_uint144] = ACTIONS(791),
    [anon_sym_uint152] = ACTIONS(791),
    [anon_sym_uint160] = ACTIONS(791),
    [anon_sym_uint168] = ACTIONS(791),
    [anon_sym_uint176] = ACTIONS(791),
    [anon_sym_uint184] = ACTIONS(791),
    [anon_sym_uint192] = ACTIONS(791),
    [anon_sym_uint200] = ACTIONS(791),
    [anon_sym_uint208] = ACTIONS(791),
    [anon_sym_uint216] = ACTIONS(791),
    [anon_sym_uint224] = ACTIONS(791),
    [anon_sym_uint232] = ACTIONS(791),
    [anon_sym_uint240] = ACTIONS(791),
    [anon_sym_uint248] = ACTIONS(791),
    [anon_sym_uint256] = ACTIONS(791),
    [anon_sym_bytes] = ACTIONS(791),
    [anon_sym_bytes1] = ACTIONS(791),
    [anon_sym_bytes2] = ACTIONS(791),
    [anon_sym_bytes3] = ACTIONS(791),
    [anon_sym_bytes4] = ACTIONS(791),
    [anon_sym_bytes5] = ACTIONS(791),
    [anon_sym_bytes6] = ACTIONS(791),
    [anon_sym_bytes7] = ACTIONS(791),
    [anon_sym_bytes8] = ACTIONS(791),
    [anon_sym_bytes9] = ACTIONS(791),
    [anon_sym_bytes10] = ACTIONS(791),
    [anon_sym_bytes11] = ACTIONS(791),
    [anon_sym_bytes12] = ACTIONS(791),
    [anon_sym_bytes13] = ACTIONS(791),
    [anon_sym_bytes14] = ACTIONS(791),
    [anon_sym_bytes15] = ACTIONS(791),
    [anon_sym_bytes16] = ACTIONS(791),
    [anon_sym_bytes17] = ACTIONS(791),
    [anon_sym_bytes18] = ACTIONS(791),
    [anon_sym_bytes19] = ACTIONS(791),
    [anon_sym_bytes20] = ACTIONS(791),
    [anon_sym_bytes21] = ACTIONS(791),
    [anon_sym_bytes22] = ACTIONS(791),
    [anon_sym_bytes23] = ACTIONS(791),
    [anon_sym_bytes24] = ACTIONS(791),
    [anon_sym_bytes25] = ACTIONS(791),
    [anon_sym_bytes26] = ACTIONS(791),
    [anon_sym_bytes27] = ACTIONS(791),
    [anon_sym_bytes28] = ACTIONS(791),
    [anon_sym_bytes29] = ACTIONS(791),
    [anon_sym_bytes30] = ACTIONS(791),
    [anon_sym_bytes31] = ACTIONS(791),
    [anon_sym_bytes32] = ACTIONS(791),
    [anon_sym_fixed] = ACTIONS(791),
    [aux_sym__fixed_token1] = ACTIONS(791),
    [anon_sym_ufixed] = ACTIONS(791),
    [aux_sym__ufixed_token1] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(795),
    [anon_sym_RBRACE] = ACTIONS(797),
    [anon_sym_type] = ACTIONS(795),
    [anon_sym_error] = ACTIONS(795),
    [anon_sym_struct] = ACTIONS(795),
    [anon_sym_enum] = ACTIONS(795),
    [anon_sym_event] = ACTIONS(795),
    [anon_sym_using] = ACTIONS(795),
    [anon_sym_function] = ACTIONS(795),
    [anon_sym_byte] = ACTIONS(795),
    [anon_sym_address] = ACTIONS(795),
    [anon_sym_var] = ACTIONS(795),
    [anon_sym_modifier] = ACTIONS(795),
    [anon_sym_constructor] = ACTIONS(795),
    [anon_sym_fallback] = ACTIONS(795),
    [anon_sym_receive] = ACTIONS(795),
    [anon_sym_mapping] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_string] = ACTIONS(795),
    [anon_sym_int] = ACTIONS(795),
    [anon_sym_int8] = ACTIONS(795),
    [anon_sym_int16] = ACTIONS(795),
    [anon_sym_int24] = ACTIONS(795),
    [anon_sym_int32] = ACTIONS(795),
    [anon_sym_int40] = ACTIONS(795),
    [anon_sym_int48] = ACTIONS(795),
    [anon_sym_int56] = ACTIONS(795),
    [anon_sym_int64] = ACTIONS(795),
    [anon_sym_int72] = ACTIONS(795),
    [anon_sym_int80] = ACTIONS(795),
    [anon_sym_int88] = ACTIONS(795),
    [anon_sym_int96] = ACTIONS(795),
    [anon_sym_int104] = ACTIONS(795),
    [anon_sym_int112] = ACTIONS(795),
    [anon_sym_int120] = ACTIONS(795),
    [anon_sym_int128] = ACTIONS(795),
    [anon_sym_int136] = ACTIONS(795),
    [anon_sym_int144] = ACTIONS(795),
    [anon_sym_int152] = ACTIONS(795),
    [anon_sym_int160] = ACTIONS(795),
    [anon_sym_int168] = ACTIONS(795),
    [anon_sym_int176] = ACTIONS(795),
    [anon_sym_int184] = ACTIONS(795),
    [anon_sym_int192] = ACTIONS(795),
    [anon_sym_int200] = ACTIONS(795),
    [anon_sym_int208] = ACTIONS(795),
    [anon_sym_int216] = ACTIONS(795),
    [anon_sym_int224] = ACTIONS(795),
    [anon_sym_int232] = ACTIONS(795),
    [anon_sym_int240] = ACTIONS(795),
    [anon_sym_int248] = ACTIONS(795),
    [anon_sym_int256] = ACTIONS(795),
    [anon_sym_uint] = ACTIONS(795),
    [anon_sym_uint8] = ACTIONS(795),
    [anon_sym_uint16] = ACTIONS(795),
    [anon_sym_uint24] = ACTIONS(795),
    [anon_sym_uint32] = ACTIONS(795),
    [anon_sym_uint40] = ACTIONS(795),
    [anon_sym_uint48] = ACTIONS(795),
    [anon_sym_uint56] = ACTIONS(795),
    [anon_sym_uint64] = ACTIONS(795),
    [anon_sym_uint72] = ACTIONS(795),
    [anon_sym_uint80] = ACTIONS(795),
    [anon_sym_uint88] = ACTIONS(795),
    [anon_sym_uint96] = ACTIONS(795),
    [anon_sym_uint104] = ACTIONS(795),
    [anon_sym_uint112] = ACTIONS(795),
    [anon_sym_uint120] = ACTIONS(795),
    [anon_sym_uint128] = ACTIONS(795),
    [anon_sym_uint136] = ACTIONS(795),
    [anon_sym_uint144] = ACTIONS(795),
    [anon_sym_uint152] = ACTIONS(795),
    [anon_sym_uint160] = ACTIONS(795),
    [anon_sym_uint168] = ACTIONS(795),
    [anon_sym_uint176] = ACTIONS(795),
    [anon_sym_uint184] = ACTIONS(795),
    [anon_sym_uint192] = ACTIONS(795),
    [anon_sym_uint200] = ACTIONS(795),
    [anon_sym_uint208] = ACTIONS(795),
    [anon_sym_uint216] = ACTIONS(795),
    [anon_sym_uint224] = ACTIONS(795),
    [anon_sym_uint232] = ACTIONS(795),
    [anon_sym_uint240] = ACTIONS(795),
    [anon_sym_uint248] = ACTIONS(795),
    [anon_sym_uint256] = ACTIONS(795),
    [anon_sym_bytes] = ACTIONS(795),
    [anon_sym_bytes1] = ACTIONS(795),
    [anon_sym_bytes2] = ACTIONS(795),
    [anon_sym_bytes3] = ACTIONS(795),
    [anon_sym_bytes4] = ACTIONS(795),
    [anon_sym_bytes5] = ACTIONS(795),
    [anon_sym_bytes6] = ACTIONS(795),
    [anon_sym_bytes7] = ACTIONS(795),
    [anon_sym_bytes8] = ACTIONS(795),
    [anon_sym_bytes9] = ACTIONS(795),
    [anon_sym_bytes10] = ACTIONS(795),
    [anon_sym_bytes11] = ACTIONS(795),
    [anon_sym_bytes12] = ACTIONS(795),
    [anon_sym_bytes13] = ACTIONS(795),
    [anon_sym_bytes14] = ACTIONS(795),
    [anon_sym_bytes15] = ACTIONS(795),
    [anon_sym_bytes16] = ACTIONS(795),
    [anon_sym_bytes17] = ACTIONS(795),
    [anon_sym_bytes18] = ACTIONS(795),
    [anon_sym_bytes19] = ACTIONS(795),
    [anon_sym_bytes20] = ACTIONS(795),
    [anon_sym_bytes21] = ACTIONS(795),
    [anon_sym_bytes22] = ACTIONS(795),
    [anon_sym_bytes23] = ACTIONS(795),
    [anon_sym_bytes24] = ACTIONS(795),
    [anon_sym_bytes25] = ACTIONS(795),
    [anon_sym_bytes26] = ACTIONS(795),
    [anon_sym_bytes27] = ACTIONS(795),
    [anon_sym_bytes28] = ACTIONS(795),
    [anon_sym_bytes29] = ACTIONS(795),
    [anon_sym_bytes30] = ACTIONS(795),
    [anon_sym_bytes31] = ACTIONS(795),
    [anon_sym_bytes32] = ACTIONS(795),
    [anon_sym_fixed] = ACTIONS(795),
    [aux_sym__fixed_token1] = ACTIONS(795),
    [anon_sym_ufixed] = ACTIONS(795),
    [aux_sym__ufixed_token1] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_identifier] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(799),
    [anon_sym_error] = ACTIONS(799),
    [anon_sym_struct] = ACTIONS(799),
    [anon_sym_enum] = ACTIONS(799),
    [anon_sym_event] = ACTIONS(799),
    [anon_sym_using] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(799),
    [anon_sym_byte] = ACTIONS(799),
    [anon_sym_address] = ACTIONS(799),
    [anon_sym_var] = ACTIONS(799),
    [anon_sym_modifier] = ACTIONS(799),
    [anon_sym_constructor] = ACTIONS(799),
    [anon_sym_fallback] = ACTIONS(799),
    [anon_sym_receive] = ACTIONS(799),
    [anon_sym_mapping] = ACTIONS(799),
    [anon_sym_bool] = ACTIONS(799),
    [anon_sym_string] = ACTIONS(799),
    [anon_sym_int] = ACTIONS(799),
    [anon_sym_int8] = ACTIONS(799),
    [anon_sym_int16] = ACTIONS(799),
    [anon_sym_int24] = ACTIONS(799),
    [anon_sym_int32] = ACTIONS(799),
    [anon_sym_int40] = ACTIONS(799),
    [anon_sym_int48] = ACTIONS(799),
    [anon_sym_int56] = ACTIONS(799),
    [anon_sym_int64] = ACTIONS(799),
    [anon_sym_int72] = ACTIONS(799),
    [anon_sym_int80] = ACTIONS(799),
    [anon_sym_int88] = ACTIONS(799),
    [anon_sym_int96] = ACTIONS(799),
    [anon_sym_int104] = ACTIONS(799),
    [anon_sym_int112] = ACTIONS(799),
    [anon_sym_int120] = ACTIONS(799),
    [anon_sym_int128] = ACTIONS(799),
    [anon_sym_int136] = ACTIONS(799),
    [anon_sym_int144] = ACTIONS(799),
    [anon_sym_int152] = ACTIONS(799),
    [anon_sym_int160] = ACTIONS(799),
    [anon_sym_int168] = ACTIONS(799),
    [anon_sym_int176] = ACTIONS(799),
    [anon_sym_int184] = ACTIONS(799),
    [anon_sym_int192] = ACTIONS(799),
    [anon_sym_int200] = ACTIONS(799),
    [anon_sym_int208] = ACTIONS(799),
    [anon_sym_int216] = ACTIONS(799),
    [anon_sym_int224] = ACTIONS(799),
    [anon_sym_int232] = ACTIONS(799),
    [anon_sym_int240] = ACTIONS(799),
    [anon_sym_int248] = ACTIONS(799),
    [anon_sym_int256] = ACTIONS(799),
    [anon_sym_uint] = ACTIONS(799),
    [anon_sym_uint8] = ACTIONS(799),
    [anon_sym_uint16] = ACTIONS(799),
    [anon_sym_uint24] = ACTIONS(799),
    [anon_sym_uint32] = ACTIONS(799),
    [anon_sym_uint40] = ACTIONS(799),
    [anon_sym_uint48] = ACTIONS(799),
    [anon_sym_uint56] = ACTIONS(799),
    [anon_sym_uint64] = ACTIONS(799),
    [anon_sym_uint72] = ACTIONS(799),
    [anon_sym_uint80] = ACTIONS(799),
    [anon_sym_uint88] = ACTIONS(799),
    [anon_sym_uint96] = ACTIONS(799),
    [anon_sym_uint104] = ACTIONS(799),
    [anon_sym_uint112] = ACTIONS(799),
    [anon_sym_uint120] = ACTIONS(799),
    [anon_sym_uint128] = ACTIONS(799),
    [anon_sym_uint136] = ACTIONS(799),
    [anon_sym_uint144] = ACTIONS(799),
    [anon_sym_uint152] = ACTIONS(799),
    [anon_sym_uint160] = ACTIONS(799),
    [anon_sym_uint168] = ACTIONS(799),
    [anon_sym_uint176] = ACTIONS(799),
    [anon_sym_uint184] = ACTIONS(799),
    [anon_sym_uint192] = ACTIONS(799),
    [anon_sym_uint200] = ACTIONS(799),
    [anon_sym_uint208] = ACTIONS(799),
    [anon_sym_uint216] = ACTIONS(799),
    [anon_sym_uint224] = ACTIONS(799),
    [anon_sym_uint232] = ACTIONS(799),
    [anon_sym_uint240] = ACTIONS(799),
    [anon_sym_uint248] = ACTIONS(799),
    [anon_sym_uint256] = ACTIONS(799),
    [anon_sym_bytes] = ACTIONS(799),
    [anon_sym_bytes1] = ACTIONS(799),
    [anon_sym_bytes2] = ACTIONS(799),
    [anon_sym_bytes3] = ACTIONS(799),
    [anon_sym_bytes4] = ACTIONS(799),
    [anon_sym_bytes5] = ACTIONS(799),
    [anon_sym_bytes6] = ACTIONS(799),
    [anon_sym_bytes7] = ACTIONS(799),
    [anon_sym_bytes8] = ACTIONS(799),
    [anon_sym_bytes9] = ACTIONS(799),
    [anon_sym_bytes10] = ACTIONS(799),
    [anon_sym_bytes11] = ACTIONS(799),
    [anon_sym_bytes12] = ACTIONS(799),
    [anon_sym_bytes13] = ACTIONS(799),
    [anon_sym_bytes14] = ACTIONS(799),
    [anon_sym_bytes15] = ACTIONS(799),
    [anon_sym_bytes16] = ACTIONS(799),
    [anon_sym_bytes17] = ACTIONS(799),
    [anon_sym_bytes18] = ACTIONS(799),
    [anon_sym_bytes19] = ACTIONS(799),
    [anon_sym_bytes20] = ACTIONS(799),
    [anon_sym_bytes21] = ACTIONS(799),
    [anon_sym_bytes22] = ACTIONS(799),
    [anon_sym_bytes23] = ACTIONS(799),
    [anon_sym_bytes24] = ACTIONS(799),
    [anon_sym_bytes25] = ACTIONS(799),
    [anon_sym_bytes26] = ACTIONS(799),
    [anon_sym_bytes27] = ACTIONS(799),
    [anon_sym_bytes28] = ACTIONS(799),
    [anon_sym_bytes29] = ACTIONS(799),
    [anon_sym_bytes30] = ACTIONS(799),
    [anon_sym_bytes31] = ACTIONS(799),
    [anon_sym_bytes32] = ACTIONS(799),
    [anon_sym_fixed] = ACTIONS(799),
    [aux_sym__fixed_token1] = ACTIONS(799),
    [anon_sym_ufixed] = ACTIONS(799),
    [aux_sym__ufixed_token1] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_identifier] = ACTIONS(803),
    [anon_sym_RBRACE] = ACTIONS(805),
    [anon_sym_type] = ACTIONS(803),
    [anon_sym_error] = ACTIONS(803),
    [anon_sym_struct] = ACTIONS(803),
    [anon_sym_enum] = ACTIONS(803),
    [anon_sym_event] = ACTIONS(803),
    [anon_sym_using] = ACTIONS(803),
    [anon_sym_function] = ACTIONS(803),
    [anon_sym_byte] = ACTIONS(803),
    [anon_sym_address] = ACTIONS(803),
    [anon_sym_var] = ACTIONS(803),
    [anon_sym_modifier] = ACTIONS(803),
    [anon_sym_constructor] = ACTIONS(803),
    [anon_sym_fallback] = ACTIONS(803),
    [anon_sym_receive] = ACTIONS(803),
    [anon_sym_mapping] = ACTIONS(803),
    [anon_sym_bool] = ACTIONS(803),
    [anon_sym_string] = ACTIONS(803),
    [anon_sym_int] = ACTIONS(803),
    [anon_sym_int8] = ACTIONS(803),
    [anon_sym_int16] = ACTIONS(803),
    [anon_sym_int24] = ACTIONS(803),
    [anon_sym_int32] = ACTIONS(803),
    [anon_sym_int40] = ACTIONS(803),
    [anon_sym_int48] = ACTIONS(803),
    [anon_sym_int56] = ACTIONS(803),
    [anon_sym_int64] = ACTIONS(803),
    [anon_sym_int72] = ACTIONS(803),
    [anon_sym_int80] = ACTIONS(803),
    [anon_sym_int88] = ACTIONS(803),
    [anon_sym_int96] = ACTIONS(803),
    [anon_sym_int104] = ACTIONS(803),
    [anon_sym_int112] = ACTIONS(803),
    [anon_sym_int120] = ACTIONS(803),
    [anon_sym_int128] = ACTIONS(803),
    [anon_sym_int136] = ACTIONS(803),
    [anon_sym_int144] = ACTIONS(803),
    [anon_sym_int152] = ACTIONS(803),
    [anon_sym_int160] = ACTIONS(803),
    [anon_sym_int168] = ACTIONS(803),
    [anon_sym_int176] = ACTIONS(803),
    [anon_sym_int184] = ACTIONS(803),
    [anon_sym_int192] = ACTIONS(803),
    [anon_sym_int200] = ACTIONS(803),
    [anon_sym_int208] = ACTIONS(803),
    [anon_sym_int216] = ACTIONS(803),
    [anon_sym_int224] = ACTIONS(803),
    [anon_sym_int232] = ACTIONS(803),
    [anon_sym_int240] = ACTIONS(803),
    [anon_sym_int248] = ACTIONS(803),
    [anon_sym_int256] = ACTIONS(803),
    [anon_sym_uint] = ACTIONS(803),
    [anon_sym_uint8] = ACTIONS(803),
    [anon_sym_uint16] = ACTIONS(803),
    [anon_sym_uint24] = ACTIONS(803),
    [anon_sym_uint32] = ACTIONS(803),
    [anon_sym_uint40] = ACTIONS(803),
    [anon_sym_uint48] = ACTIONS(803),
    [anon_sym_uint56] = ACTIONS(803),
    [anon_sym_uint64] = ACTIONS(803),
    [anon_sym_uint72] = ACTIONS(803),
    [anon_sym_uint80] = ACTIONS(803),
    [anon_sym_uint88] = ACTIONS(803),
    [anon_sym_uint96] = ACTIONS(803),
    [anon_sym_uint104] = ACTIONS(803),
    [anon_sym_uint112] = ACTIONS(803),
    [anon_sym_uint120] = ACTIONS(803),
    [anon_sym_uint128] = ACTIONS(803),
    [anon_sym_uint136] = ACTIONS(803),
    [anon_sym_uint144] = ACTIONS(803),
    [anon_sym_uint152] = ACTIONS(803),
    [anon_sym_uint160] = ACTIONS(803),
    [anon_sym_uint168] = ACTIONS(803),
    [anon_sym_uint176] = ACTIONS(803),
    [anon_sym_uint184] = ACTIONS(803),
    [anon_sym_uint192] = ACTIONS(803),
    [anon_sym_uint200] = ACTIONS(803),
    [anon_sym_uint208] = ACTIONS(803),
    [anon_sym_uint216] = ACTIONS(803),
    [anon_sym_uint224] = ACTIONS(803),
    [anon_sym_uint232] = ACTIONS(803),
    [anon_sym_uint240] = ACTIONS(803),
    [anon_sym_uint248] = ACTIONS(803),
    [anon_sym_uint256] = ACTIONS(803),
    [anon_sym_bytes] = ACTIONS(803),
    [anon_sym_bytes1] = ACTIONS(803),
    [anon_sym_bytes2] = ACTIONS(803),
    [anon_sym_bytes3] = ACTIONS(803),
    [anon_sym_bytes4] = ACTIONS(803),
    [anon_sym_bytes5] = ACTIONS(803),
    [anon_sym_bytes6] = ACTIONS(803),
    [anon_sym_bytes7] = ACTIONS(803),
    [anon_sym_bytes8] = ACTIONS(803),
    [anon_sym_bytes9] = ACTIONS(803),
    [anon_sym_bytes10] = ACTIONS(803),
    [anon_sym_bytes11] = ACTIONS(803),
    [anon_sym_bytes12] = ACTIONS(803),
    [anon_sym_bytes13] = ACTIONS(803),
    [anon_sym_bytes14] = ACTIONS(803),
    [anon_sym_bytes15] = ACTIONS(803),
    [anon_sym_bytes16] = ACTIONS(803),
    [anon_sym_bytes17] = ACTIONS(803),
    [anon_sym_bytes18] = ACTIONS(803),
    [anon_sym_bytes19] = ACTIONS(803),
    [anon_sym_bytes20] = ACTIONS(803),
    [anon_sym_bytes21] = ACTIONS(803),
    [anon_sym_bytes22] = ACTIONS(803),
    [anon_sym_bytes23] = ACTIONS(803),
    [anon_sym_bytes24] = ACTIONS(803),
    [anon_sym_bytes25] = ACTIONS(803),
    [anon_sym_bytes26] = ACTIONS(803),
    [anon_sym_bytes27] = ACTIONS(803),
    [anon_sym_bytes28] = ACTIONS(803),
    [anon_sym_bytes29] = ACTIONS(803),
    [anon_sym_bytes30] = ACTIONS(803),
    [anon_sym_bytes31] = ACTIONS(803),
    [anon_sym_bytes32] = ACTIONS(803),
    [anon_sym_fixed] = ACTIONS(803),
    [aux_sym__fixed_token1] = ACTIONS(803),
    [anon_sym_ufixed] = ACTIONS(803),
    [aux_sym__ufixed_token1] = ACTIONS(803),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_identifier] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(809),
    [anon_sym_type] = ACTIONS(807),
    [anon_sym_error] = ACTIONS(807),
    [anon_sym_struct] = ACTIONS(807),
    [anon_sym_enum] = ACTIONS(807),
    [anon_sym_event] = ACTIONS(807),
    [anon_sym_using] = ACTIONS(807),
    [anon_sym_function] = ACTIONS(807),
    [anon_sym_byte] = ACTIONS(807),
    [anon_sym_address] = ACTIONS(807),
    [anon_sym_var] = ACTIONS(807),
    [anon_sym_modifier] = ACTIONS(807),
    [anon_sym_constructor] = ACTIONS(807),
    [anon_sym_fallback] = ACTIONS(807),
    [anon_sym_receive] = ACTIONS(807),
    [anon_sym_mapping] = ACTIONS(807),
    [anon_sym_bool] = ACTIONS(807),
    [anon_sym_string] = ACTIONS(807),
    [anon_sym_int] = ACTIONS(807),
    [anon_sym_int8] = ACTIONS(807),
    [anon_sym_int16] = ACTIONS(807),
    [anon_sym_int24] = ACTIONS(807),
    [anon_sym_int32] = ACTIONS(807),
    [anon_sym_int40] = ACTIONS(807),
    [anon_sym_int48] = ACTIONS(807),
    [anon_sym_int56] = ACTIONS(807),
    [anon_sym_int64] = ACTIONS(807),
    [anon_sym_int72] = ACTIONS(807),
    [anon_sym_int80] = ACTIONS(807),
    [anon_sym_int88] = ACTIONS(807),
    [anon_sym_int96] = ACTIONS(807),
    [anon_sym_int104] = ACTIONS(807),
    [anon_sym_int112] = ACTIONS(807),
    [anon_sym_int120] = ACTIONS(807),
    [anon_sym_int128] = ACTIONS(807),
    [anon_sym_int136] = ACTIONS(807),
    [anon_sym_int144] = ACTIONS(807),
    [anon_sym_int152] = ACTIONS(807),
    [anon_sym_int160] = ACTIONS(807),
    [anon_sym_int168] = ACTIONS(807),
    [anon_sym_int176] = ACTIONS(807),
    [anon_sym_int184] = ACTIONS(807),
    [anon_sym_int192] = ACTIONS(807),
    [anon_sym_int200] = ACTIONS(807),
    [anon_sym_int208] = ACTIONS(807),
    [anon_sym_int216] = ACTIONS(807),
    [anon_sym_int224] = ACTIONS(807),
    [anon_sym_int232] = ACTIONS(807),
    [anon_sym_int240] = ACTIONS(807),
    [anon_sym_int248] = ACTIONS(807),
    [anon_sym_int256] = ACTIONS(807),
    [anon_sym_uint] = ACTIONS(807),
    [anon_sym_uint8] = ACTIONS(807),
    [anon_sym_uint16] = ACTIONS(807),
    [anon_sym_uint24] = ACTIONS(807),
    [anon_sym_uint32] = ACTIONS(807),
    [anon_sym_uint40] = ACTIONS(807),
    [anon_sym_uint48] = ACTIONS(807),
    [anon_sym_uint56] = ACTIONS(807),
    [anon_sym_uint64] = ACTIONS(807),
    [anon_sym_uint72] = ACTIONS(807),
    [anon_sym_uint80] = ACTIONS(807),
    [anon_sym_uint88] = ACTIONS(807),
    [anon_sym_uint96] = ACTIONS(807),
    [anon_sym_uint104] = ACTIONS(807),
    [anon_sym_uint112] = ACTIONS(807),
    [anon_sym_uint120] = ACTIONS(807),
    [anon_sym_uint128] = ACTIONS(807),
    [anon_sym_uint136] = ACTIONS(807),
    [anon_sym_uint144] = ACTIONS(807),
    [anon_sym_uint152] = ACTIONS(807),
    [anon_sym_uint160] = ACTIONS(807),
    [anon_sym_uint168] = ACTIONS(807),
    [anon_sym_uint176] = ACTIONS(807),
    [anon_sym_uint184] = ACTIONS(807),
    [anon_sym_uint192] = ACTIONS(807),
    [anon_sym_uint200] = ACTIONS(807),
    [anon_sym_uint208] = ACTIONS(807),
    [anon_sym_uint216] = ACTIONS(807),
    [anon_sym_uint224] = ACTIONS(807),
    [anon_sym_uint232] = ACTIONS(807),
    [anon_sym_uint240] = ACTIONS(807),
    [anon_sym_uint248] = ACTIONS(807),
    [anon_sym_uint256] = ACTIONS(807),
    [anon_sym_bytes] = ACTIONS(807),
    [anon_sym_bytes1] = ACTIONS(807),
    [anon_sym_bytes2] = ACTIONS(807),
    [anon_sym_bytes3] = ACTIONS(807),
    [anon_sym_bytes4] = ACTIONS(807),
    [anon_sym_bytes5] = ACTIONS(807),
    [anon_sym_bytes6] = ACTIONS(807),
    [anon_sym_bytes7] = ACTIONS(807),
    [anon_sym_bytes8] = ACTIONS(807),
    [anon_sym_bytes9] = ACTIONS(807),
    [anon_sym_bytes10] = ACTIONS(807),
    [anon_sym_bytes11] = ACTIONS(807),
    [anon_sym_bytes12] = ACTIONS(807),
    [anon_sym_bytes13] = ACTIONS(807),
    [anon_sym_bytes14] = ACTIONS(807),
    [anon_sym_bytes15] = ACTIONS(807),
    [anon_sym_bytes16] = ACTIONS(807),
    [anon_sym_bytes17] = ACTIONS(807),
    [anon_sym_bytes18] = ACTIONS(807),
    [anon_sym_bytes19] = ACTIONS(807),
    [anon_sym_bytes20] = ACTIONS(807),
    [anon_sym_bytes21] = ACTIONS(807),
    [anon_sym_bytes22] = ACTIONS(807),
    [anon_sym_bytes23] = ACTIONS(807),
    [anon_sym_bytes24] = ACTIONS(807),
    [anon_sym_bytes25] = ACTIONS(807),
    [anon_sym_bytes26] = ACTIONS(807),
    [anon_sym_bytes27] = ACTIONS(807),
    [anon_sym_bytes28] = ACTIONS(807),
    [anon_sym_bytes29] = ACTIONS(807),
    [anon_sym_bytes30] = ACTIONS(807),
    [anon_sym_bytes31] = ACTIONS(807),
    [anon_sym_bytes32] = ACTIONS(807),
    [anon_sym_fixed] = ACTIONS(807),
    [aux_sym__fixed_token1] = ACTIONS(807),
    [anon_sym_ufixed] = ACTIONS(807),
    [aux_sym__ufixed_token1] = ACTIONS(807),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_identifier] = ACTIONS(811),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_type] = ACTIONS(811),
    [anon_sym_error] = ACTIONS(811),
    [anon_sym_struct] = ACTIONS(811),
    [anon_sym_enum] = ACTIONS(811),
    [anon_sym_event] = ACTIONS(811),
    [anon_sym_using] = ACTIONS(811),
    [anon_sym_function] = ACTIONS(811),
    [anon_sym_byte] = ACTIONS(811),
    [anon_sym_address] = ACTIONS(811),
    [anon_sym_var] = ACTIONS(811),
    [anon_sym_modifier] = ACTIONS(811),
    [anon_sym_constructor] = ACTIONS(811),
    [anon_sym_fallback] = ACTIONS(811),
    [anon_sym_receive] = ACTIONS(811),
    [anon_sym_mapping] = ACTIONS(811),
    [anon_sym_bool] = ACTIONS(811),
    [anon_sym_string] = ACTIONS(811),
    [anon_sym_int] = ACTIONS(811),
    [anon_sym_int8] = ACTIONS(811),
    [anon_sym_int16] = ACTIONS(811),
    [anon_sym_int24] = ACTIONS(811),
    [anon_sym_int32] = ACTIONS(811),
    [anon_sym_int40] = ACTIONS(811),
    [anon_sym_int48] = ACTIONS(811),
    [anon_sym_int56] = ACTIONS(811),
    [anon_sym_int64] = ACTIONS(811),
    [anon_sym_int72] = ACTIONS(811),
    [anon_sym_int80] = ACTIONS(811),
    [anon_sym_int88] = ACTIONS(811),
    [anon_sym_int96] = ACTIONS(811),
    [anon_sym_int104] = ACTIONS(811),
    [anon_sym_int112] = ACTIONS(811),
    [anon_sym_int120] = ACTIONS(811),
    [anon_sym_int128] = ACTIONS(811),
    [anon_sym_int136] = ACTIONS(811),
    [anon_sym_int144] = ACTIONS(811),
    [anon_sym_int152] = ACTIONS(811),
    [anon_sym_int160] = ACTIONS(811),
    [anon_sym_int168] = ACTIONS(811),
    [anon_sym_int176] = ACTIONS(811),
    [anon_sym_int184] = ACTIONS(811),
    [anon_sym_int192] = ACTIONS(811),
    [anon_sym_int200] = ACTIONS(811),
    [anon_sym_int208] = ACTIONS(811),
    [anon_sym_int216] = ACTIONS(811),
    [anon_sym_int224] = ACTIONS(811),
    [anon_sym_int232] = ACTIONS(811),
    [anon_sym_int240] = ACTIONS(811),
    [anon_sym_int248] = ACTIONS(811),
    [anon_sym_int256] = ACTIONS(811),
    [anon_sym_uint] = ACTIONS(811),
    [anon_sym_uint8] = ACTIONS(811),
    [anon_sym_uint16] = ACTIONS(811),
    [anon_sym_uint24] = ACTIONS(811),
    [anon_sym_uint32] = ACTIONS(811),
    [anon_sym_uint40] = ACTIONS(811),
    [anon_sym_uint48] = ACTIONS(811),
    [anon_sym_uint56] = ACTIONS(811),
    [anon_sym_uint64] = ACTIONS(811),
    [anon_sym_uint72] = ACTIONS(811),
    [anon_sym_uint80] = ACTIONS(811),
    [anon_sym_uint88] = ACTIONS(811),
    [anon_sym_uint96] = ACTIONS(811),
    [anon_sym_uint104] = ACTIONS(811),
    [anon_sym_uint112] = ACTIONS(811),
    [anon_sym_uint120] = ACTIONS(811),
    [anon_sym_uint128] = ACTIONS(811),
    [anon_sym_uint136] = ACTIONS(811),
    [anon_sym_uint144] = ACTIONS(811),
    [anon_sym_uint152] = ACTIONS(811),
    [anon_sym_uint160] = ACTIONS(811),
    [anon_sym_uint168] = ACTIONS(811),
    [anon_sym_uint176] = ACTIONS(811),
    [anon_sym_uint184] = ACTIONS(811),
    [anon_sym_uint192] = ACTIONS(811),
    [anon_sym_uint200] = ACTIONS(811),
    [anon_sym_uint208] = ACTIONS(811),
    [anon_sym_uint216] = ACTIONS(811),
    [anon_sym_uint224] = ACTIONS(811),
    [anon_sym_uint232] = ACTIONS(811),
    [anon_sym_uint240] = ACTIONS(811),
    [anon_sym_uint248] = ACTIONS(811),
    [anon_sym_uint256] = ACTIONS(811),
    [anon_sym_bytes] = ACTIONS(811),
    [anon_sym_bytes1] = ACTIONS(811),
    [anon_sym_bytes2] = ACTIONS(811),
    [anon_sym_bytes3] = ACTIONS(811),
    [anon_sym_bytes4] = ACTIONS(811),
    [anon_sym_bytes5] = ACTIONS(811),
    [anon_sym_bytes6] = ACTIONS(811),
    [anon_sym_bytes7] = ACTIONS(811),
    [anon_sym_bytes8] = ACTIONS(811),
    [anon_sym_bytes9] = ACTIONS(811),
    [anon_sym_bytes10] = ACTIONS(811),
    [anon_sym_bytes11] = ACTIONS(811),
    [anon_sym_bytes12] = ACTIONS(811),
    [anon_sym_bytes13] = ACTIONS(811),
    [anon_sym_bytes14] = ACTIONS(811),
    [anon_sym_bytes15] = ACTIONS(811),
    [anon_sym_bytes16] = ACTIONS(811),
    [anon_sym_bytes17] = ACTIONS(811),
    [anon_sym_bytes18] = ACTIONS(811),
    [anon_sym_bytes19] = ACTIONS(811),
    [anon_sym_bytes20] = ACTIONS(811),
    [anon_sym_bytes21] = ACTIONS(811),
    [anon_sym_bytes22] = ACTIONS(811),
    [anon_sym_bytes23] = ACTIONS(811),
    [anon_sym_bytes24] = ACTIONS(811),
    [anon_sym_bytes25] = ACTIONS(811),
    [anon_sym_bytes26] = ACTIONS(811),
    [anon_sym_bytes27] = ACTIONS(811),
    [anon_sym_bytes28] = ACTIONS(811),
    [anon_sym_bytes29] = ACTIONS(811),
    [anon_sym_bytes30] = ACTIONS(811),
    [anon_sym_bytes31] = ACTIONS(811),
    [anon_sym_bytes32] = ACTIONS(811),
    [anon_sym_fixed] = ACTIONS(811),
    [aux_sym__fixed_token1] = ACTIONS(811),
    [anon_sym_ufixed] = ACTIONS(811),
    [aux_sym__ufixed_token1] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(817),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_error] = ACTIONS(815),
    [anon_sym_struct] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_event] = ACTIONS(815),
    [anon_sym_using] = ACTIONS(815),
    [anon_sym_function] = ACTIONS(815),
    [anon_sym_byte] = ACTIONS(815),
    [anon_sym_address] = ACTIONS(815),
    [anon_sym_var] = ACTIONS(815),
    [anon_sym_modifier] = ACTIONS(815),
    [anon_sym_constructor] = ACTIONS(815),
    [anon_sym_fallback] = ACTIONS(815),
    [anon_sym_receive] = ACTIONS(815),
    [anon_sym_mapping] = ACTIONS(815),
    [anon_sym_bool] = ACTIONS(815),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_int] = ACTIONS(815),
    [anon_sym_int8] = ACTIONS(815),
    [anon_sym_int16] = ACTIONS(815),
    [anon_sym_int24] = ACTIONS(815),
    [anon_sym_int32] = ACTIONS(815),
    [anon_sym_int40] = ACTIONS(815),
    [anon_sym_int48] = ACTIONS(815),
    [anon_sym_int56] = ACTIONS(815),
    [anon_sym_int64] = ACTIONS(815),
    [anon_sym_int72] = ACTIONS(815),
    [anon_sym_int80] = ACTIONS(815),
    [anon_sym_int88] = ACTIONS(815),
    [anon_sym_int96] = ACTIONS(815),
    [anon_sym_int104] = ACTIONS(815),
    [anon_sym_int112] = ACTIONS(815),
    [anon_sym_int120] = ACTIONS(815),
    [anon_sym_int128] = ACTIONS(815),
    [anon_sym_int136] = ACTIONS(815),
    [anon_sym_int144] = ACTIONS(815),
    [anon_sym_int152] = ACTIONS(815),
    [anon_sym_int160] = ACTIONS(815),
    [anon_sym_int168] = ACTIONS(815),
    [anon_sym_int176] = ACTIONS(815),
    [anon_sym_int184] = ACTIONS(815),
    [anon_sym_int192] = ACTIONS(815),
    [anon_sym_int200] = ACTIONS(815),
    [anon_sym_int208] = ACTIONS(815),
    [anon_sym_int216] = ACTIONS(815),
    [anon_sym_int224] = ACTIONS(815),
    [anon_sym_int232] = ACTIONS(815),
    [anon_sym_int240] = ACTIONS(815),
    [anon_sym_int248] = ACTIONS(815),
    [anon_sym_int256] = ACTIONS(815),
    [anon_sym_uint] = ACTIONS(815),
    [anon_sym_uint8] = ACTIONS(815),
    [anon_sym_uint16] = ACTIONS(815),
    [anon_sym_uint24] = ACTIONS(815),
    [anon_sym_uint32] = ACTIONS(815),
    [anon_sym_uint40] = ACTIONS(815),
    [anon_sym_uint48] = ACTIONS(815),
    [anon_sym_uint56] = ACTIONS(815),
    [anon_sym_uint64] = ACTIONS(815),
    [anon_sym_uint72] = ACTIONS(815),
    [anon_sym_uint80] = ACTIONS(815),
    [anon_sym_uint88] = ACTIONS(815),
    [anon_sym_uint96] = ACTIONS(815),
    [anon_sym_uint104] = ACTIONS(815),
    [anon_sym_uint112] = ACTIONS(815),
    [anon_sym_uint120] = ACTIONS(815),
    [anon_sym_uint128] = ACTIONS(815),
    [anon_sym_uint136] = ACTIONS(815),
    [anon_sym_uint144] = ACTIONS(815),
    [anon_sym_uint152] = ACTIONS(815),
    [anon_sym_uint160] = ACTIONS(815),
    [anon_sym_uint168] = ACTIONS(815),
    [anon_sym_uint176] = ACTIONS(815),
    [anon_sym_uint184] = ACTIONS(815),
    [anon_sym_uint192] = ACTIONS(815),
    [anon_sym_uint200] = ACTIONS(815),
    [anon_sym_uint208] = ACTIONS(815),
    [anon_sym_uint216] = ACTIONS(815),
    [anon_sym_uint224] = ACTIONS(815),
    [anon_sym_uint232] = ACTIONS(815),
    [anon_sym_uint240] = ACTIONS(815),
    [anon_sym_uint248] = ACTIONS(815),
    [anon_sym_uint256] = ACTIONS(815),
    [anon_sym_bytes] = ACTIONS(815),
    [anon_sym_bytes1] = ACTIONS(815),
    [anon_sym_bytes2] = ACTIONS(815),
    [anon_sym_bytes3] = ACTIONS(815),
    [anon_sym_bytes4] = ACTIONS(815),
    [anon_sym_bytes5] = ACTIONS(815),
    [anon_sym_bytes6] = ACTIONS(815),
    [anon_sym_bytes7] = ACTIONS(815),
    [anon_sym_bytes8] = ACTIONS(815),
    [anon_sym_bytes9] = ACTIONS(815),
    [anon_sym_bytes10] = ACTIONS(815),
    [anon_sym_bytes11] = ACTIONS(815),
    [anon_sym_bytes12] = ACTIONS(815),
    [anon_sym_bytes13] = ACTIONS(815),
    [anon_sym_bytes14] = ACTIONS(815),
    [anon_sym_bytes15] = ACTIONS(815),
    [anon_sym_bytes16] = ACTIONS(815),
    [anon_sym_bytes17] = ACTIONS(815),
    [anon_sym_bytes18] = ACTIONS(815),
    [anon_sym_bytes19] = ACTIONS(815),
    [anon_sym_bytes20] = ACTIONS(815),
    [anon_sym_bytes21] = ACTIONS(815),
    [anon_sym_bytes22] = ACTIONS(815),
    [anon_sym_bytes23] = ACTIONS(815),
    [anon_sym_bytes24] = ACTIONS(815),
    [anon_sym_bytes25] = ACTIONS(815),
    [anon_sym_bytes26] = ACTIONS(815),
    [anon_sym_bytes27] = ACTIONS(815),
    [anon_sym_bytes28] = ACTIONS(815),
    [anon_sym_bytes29] = ACTIONS(815),
    [anon_sym_bytes30] = ACTIONS(815),
    [anon_sym_bytes31] = ACTIONS(815),
    [anon_sym_bytes32] = ACTIONS(815),
    [anon_sym_fixed] = ACTIONS(815),
    [aux_sym__fixed_token1] = ACTIONS(815),
    [anon_sym_ufixed] = ACTIONS(815),
    [aux_sym__ufixed_token1] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(819),
    [anon_sym_RBRACE] = ACTIONS(821),
    [anon_sym_type] = ACTIONS(819),
    [anon_sym_error] = ACTIONS(819),
    [anon_sym_struct] = ACTIONS(819),
    [anon_sym_enum] = ACTIONS(819),
    [anon_sym_event] = ACTIONS(819),
    [anon_sym_using] = ACTIONS(819),
    [anon_sym_function] = ACTIONS(819),
    [anon_sym_byte] = ACTIONS(819),
    [anon_sym_address] = ACTIONS(819),
    [anon_sym_var] = ACTIONS(819),
    [anon_sym_modifier] = ACTIONS(819),
    [anon_sym_constructor] = ACTIONS(819),
    [anon_sym_fallback] = ACTIONS(819),
    [anon_sym_receive] = ACTIONS(819),
    [anon_sym_mapping] = ACTIONS(819),
    [anon_sym_bool] = ACTIONS(819),
    [anon_sym_string] = ACTIONS(819),
    [anon_sym_int] = ACTIONS(819),
    [anon_sym_int8] = ACTIONS(819),
    [anon_sym_int16] = ACTIONS(819),
    [anon_sym_int24] = ACTIONS(819),
    [anon_sym_int32] = ACTIONS(819),
    [anon_sym_int40] = ACTIONS(819),
    [anon_sym_int48] = ACTIONS(819),
    [anon_sym_int56] = ACTIONS(819),
    [anon_sym_int64] = ACTIONS(819),
    [anon_sym_int72] = ACTIONS(819),
    [anon_sym_int80] = ACTIONS(819),
    [anon_sym_int88] = ACTIONS(819),
    [anon_sym_int96] = ACTIONS(819),
    [anon_sym_int104] = ACTIONS(819),
    [anon_sym_int112] = ACTIONS(819),
    [anon_sym_int120] = ACTIONS(819),
    [anon_sym_int128] = ACTIONS(819),
    [anon_sym_int136] = ACTIONS(819),
    [anon_sym_int144] = ACTIONS(819),
    [anon_sym_int152] = ACTIONS(819),
    [anon_sym_int160] = ACTIONS(819),
    [anon_sym_int168] = ACTIONS(819),
    [anon_sym_int176] = ACTIONS(819),
    [anon_sym_int184] = ACTIONS(819),
    [anon_sym_int192] = ACTIONS(819),
    [anon_sym_int200] = ACTIONS(819),
    [anon_sym_int208] = ACTIONS(819),
    [anon_sym_int216] = ACTIONS(819),
    [anon_sym_int224] = ACTIONS(819),
    [anon_sym_int232] = ACTIONS(819),
    [anon_sym_int240] = ACTIONS(819),
    [anon_sym_int248] = ACTIONS(819),
    [anon_sym_int256] = ACTIONS(819),
    [anon_sym_uint] = ACTIONS(819),
    [anon_sym_uint8] = ACTIONS(819),
    [anon_sym_uint16] = ACTIONS(819),
    [anon_sym_uint24] = ACTIONS(819),
    [anon_sym_uint32] = ACTIONS(819),
    [anon_sym_uint40] = ACTIONS(819),
    [anon_sym_uint48] = ACTIONS(819),
    [anon_sym_uint56] = ACTIONS(819),
    [anon_sym_uint64] = ACTIONS(819),
    [anon_sym_uint72] = ACTIONS(819),
    [anon_sym_uint80] = ACTIONS(819),
    [anon_sym_uint88] = ACTIONS(819),
    [anon_sym_uint96] = ACTIONS(819),
    [anon_sym_uint104] = ACTIONS(819),
    [anon_sym_uint112] = ACTIONS(819),
    [anon_sym_uint120] = ACTIONS(819),
    [anon_sym_uint128] = ACTIONS(819),
    [anon_sym_uint136] = ACTIONS(819),
    [anon_sym_uint144] = ACTIONS(819),
    [anon_sym_uint152] = ACTIONS(819),
    [anon_sym_uint160] = ACTIONS(819),
    [anon_sym_uint168] = ACTIONS(819),
    [anon_sym_uint176] = ACTIONS(819),
    [anon_sym_uint184] = ACTIONS(819),
    [anon_sym_uint192] = ACTIONS(819),
    [anon_sym_uint200] = ACTIONS(819),
    [anon_sym_uint208] = ACTIONS(819),
    [anon_sym_uint216] = ACTIONS(819),
    [anon_sym_uint224] = ACTIONS(819),
    [anon_sym_uint232] = ACTIONS(819),
    [anon_sym_uint240] = ACTIONS(819),
    [anon_sym_uint248] = ACTIONS(819),
    [anon_sym_uint256] = ACTIONS(819),
    [anon_sym_bytes] = ACTIONS(819),
    [anon_sym_bytes1] = ACTIONS(819),
    [anon_sym_bytes2] = ACTIONS(819),
    [anon_sym_bytes3] = ACTIONS(819),
    [anon_sym_bytes4] = ACTIONS(819),
    [anon_sym_bytes5] = ACTIONS(819),
    [anon_sym_bytes6] = ACTIONS(819),
    [anon_sym_bytes7] = ACTIONS(819),
    [anon_sym_bytes8] = ACTIONS(819),
    [anon_sym_bytes9] = ACTIONS(819),
    [anon_sym_bytes10] = ACTIONS(819),
    [anon_sym_bytes11] = ACTIONS(819),
    [anon_sym_bytes12] = ACTIONS(819),
    [anon_sym_bytes13] = ACTIONS(819),
    [anon_sym_bytes14] = ACTIONS(819),
    [anon_sym_bytes15] = ACTIONS(819),
    [anon_sym_bytes16] = ACTIONS(819),
    [anon_sym_bytes17] = ACTIONS(819),
    [anon_sym_bytes18] = ACTIONS(819),
    [anon_sym_bytes19] = ACTIONS(819),
    [anon_sym_bytes20] = ACTIONS(819),
    [anon_sym_bytes21] = ACTIONS(819),
    [anon_sym_bytes22] = ACTIONS(819),
    [anon_sym_bytes23] = ACTIONS(819),
    [anon_sym_bytes24] = ACTIONS(819),
    [anon_sym_bytes25] = ACTIONS(819),
    [anon_sym_bytes26] = ACTIONS(819),
    [anon_sym_bytes27] = ACTIONS(819),
    [anon_sym_bytes28] = ACTIONS(819),
    [anon_sym_bytes29] = ACTIONS(819),
    [anon_sym_bytes30] = ACTIONS(819),
    [anon_sym_bytes31] = ACTIONS(819),
    [anon_sym_bytes32] = ACTIONS(819),
    [anon_sym_fixed] = ACTIONS(819),
    [aux_sym__fixed_token1] = ACTIONS(819),
    [anon_sym_ufixed] = ACTIONS(819),
    [aux_sym__ufixed_token1] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(823),
    [anon_sym_RBRACE] = ACTIONS(825),
    [anon_sym_type] = ACTIONS(823),
    [anon_sym_error] = ACTIONS(823),
    [anon_sym_struct] = ACTIONS(823),
    [anon_sym_enum] = ACTIONS(823),
    [anon_sym_event] = ACTIONS(823),
    [anon_sym_using] = ACTIONS(823),
    [anon_sym_function] = ACTIONS(823),
    [anon_sym_byte] = ACTIONS(823),
    [anon_sym_address] = ACTIONS(823),
    [anon_sym_var] = ACTIONS(823),
    [anon_sym_modifier] = ACTIONS(823),
    [anon_sym_constructor] = ACTIONS(823),
    [anon_sym_fallback] = ACTIONS(823),
    [anon_sym_receive] = ACTIONS(823),
    [anon_sym_mapping] = ACTIONS(823),
    [anon_sym_bool] = ACTIONS(823),
    [anon_sym_string] = ACTIONS(823),
    [anon_sym_int] = ACTIONS(823),
    [anon_sym_int8] = ACTIONS(823),
    [anon_sym_int16] = ACTIONS(823),
    [anon_sym_int24] = ACTIONS(823),
    [anon_sym_int32] = ACTIONS(823),
    [anon_sym_int40] = ACTIONS(823),
    [anon_sym_int48] = ACTIONS(823),
    [anon_sym_int56] = ACTIONS(823),
    [anon_sym_int64] = ACTIONS(823),
    [anon_sym_int72] = ACTIONS(823),
    [anon_sym_int80] = ACTIONS(823),
    [anon_sym_int88] = ACTIONS(823),
    [anon_sym_int96] = ACTIONS(823),
    [anon_sym_int104] = ACTIONS(823),
    [anon_sym_int112] = ACTIONS(823),
    [anon_sym_int120] = ACTIONS(823),
    [anon_sym_int128] = ACTIONS(823),
    [anon_sym_int136] = ACTIONS(823),
    [anon_sym_int144] = ACTIONS(823),
    [anon_sym_int152] = ACTIONS(823),
    [anon_sym_int160] = ACTIONS(823),
    [anon_sym_int168] = ACTIONS(823),
    [anon_sym_int176] = ACTIONS(823),
    [anon_sym_int184] = ACTIONS(823),
    [anon_sym_int192] = ACTIONS(823),
    [anon_sym_int200] = ACTIONS(823),
    [anon_sym_int208] = ACTIONS(823),
    [anon_sym_int216] = ACTIONS(823),
    [anon_sym_int224] = ACTIONS(823),
    [anon_sym_int232] = ACTIONS(823),
    [anon_sym_int240] = ACTIONS(823),
    [anon_sym_int248] = ACTIONS(823),
    [anon_sym_int256] = ACTIONS(823),
    [anon_sym_uint] = ACTIONS(823),
    [anon_sym_uint8] = ACTIONS(823),
    [anon_sym_uint16] = ACTIONS(823),
    [anon_sym_uint24] = ACTIONS(823),
    [anon_sym_uint32] = ACTIONS(823),
    [anon_sym_uint40] = ACTIONS(823),
    [anon_sym_uint48] = ACTIONS(823),
    [anon_sym_uint56] = ACTIONS(823),
    [anon_sym_uint64] = ACTIONS(823),
    [anon_sym_uint72] = ACTIONS(823),
    [anon_sym_uint80] = ACTIONS(823),
    [anon_sym_uint88] = ACTIONS(823),
    [anon_sym_uint96] = ACTIONS(823),
    [anon_sym_uint104] = ACTIONS(823),
    [anon_sym_uint112] = ACTIONS(823),
    [anon_sym_uint120] = ACTIONS(823),
    [anon_sym_uint128] = ACTIONS(823),
    [anon_sym_uint136] = ACTIONS(823),
    [anon_sym_uint144] = ACTIONS(823),
    [anon_sym_uint152] = ACTIONS(823),
    [anon_sym_uint160] = ACTIONS(823),
    [anon_sym_uint168] = ACTIONS(823),
    [anon_sym_uint176] = ACTIONS(823),
    [anon_sym_uint184] = ACTIONS(823),
    [anon_sym_uint192] = ACTIONS(823),
    [anon_sym_uint200] = ACTIONS(823),
    [anon_sym_uint208] = ACTIONS(823),
    [anon_sym_uint216] = ACTIONS(823),
    [anon_sym_uint224] = ACTIONS(823),
    [anon_sym_uint232] = ACTIONS(823),
    [anon_sym_uint240] = ACTIONS(823),
    [anon_sym_uint248] = ACTIONS(823),
    [anon_sym_uint256] = ACTIONS(823),
    [anon_sym_bytes] = ACTIONS(823),
    [anon_sym_bytes1] = ACTIONS(823),
    [anon_sym_bytes2] = ACTIONS(823),
    [anon_sym_bytes3] = ACTIONS(823),
    [anon_sym_bytes4] = ACTIONS(823),
    [anon_sym_bytes5] = ACTIONS(823),
    [anon_sym_bytes6] = ACTIONS(823),
    [anon_sym_bytes7] = ACTIONS(823),
    [anon_sym_bytes8] = ACTIONS(823),
    [anon_sym_bytes9] = ACTIONS(823),
    [anon_sym_bytes10] = ACTIONS(823),
    [anon_sym_bytes11] = ACTIONS(823),
    [anon_sym_bytes12] = ACTIONS(823),
    [anon_sym_bytes13] = ACTIONS(823),
    [anon_sym_bytes14] = ACTIONS(823),
    [anon_sym_bytes15] = ACTIONS(823),
    [anon_sym_bytes16] = ACTIONS(823),
    [anon_sym_bytes17] = ACTIONS(823),
    [anon_sym_bytes18] = ACTIONS(823),
    [anon_sym_bytes19] = ACTIONS(823),
    [anon_sym_bytes20] = ACTIONS(823),
    [anon_sym_bytes21] = ACTIONS(823),
    [anon_sym_bytes22] = ACTIONS(823),
    [anon_sym_bytes23] = ACTIONS(823),
    [anon_sym_bytes24] = ACTIONS(823),
    [anon_sym_bytes25] = ACTIONS(823),
    [anon_sym_bytes26] = ACTIONS(823),
    [anon_sym_bytes27] = ACTIONS(823),
    [anon_sym_bytes28] = ACTIONS(823),
    [anon_sym_bytes29] = ACTIONS(823),
    [anon_sym_bytes30] = ACTIONS(823),
    [anon_sym_bytes31] = ACTIONS(823),
    [anon_sym_bytes32] = ACTIONS(823),
    [anon_sym_fixed] = ACTIONS(823),
    [aux_sym__fixed_token1] = ACTIONS(823),
    [anon_sym_ufixed] = ACTIONS(823),
    [aux_sym__ufixed_token1] = ACTIONS(823),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(827),
    [anon_sym_RBRACE] = ACTIONS(829),
    [anon_sym_type] = ACTIONS(827),
    [anon_sym_error] = ACTIONS(827),
    [anon_sym_struct] = ACTIONS(827),
    [anon_sym_enum] = ACTIONS(827),
    [anon_sym_event] = ACTIONS(827),
    [anon_sym_using] = ACTIONS(827),
    [anon_sym_function] = ACTIONS(827),
    [anon_sym_byte] = ACTIONS(827),
    [anon_sym_address] = ACTIONS(827),
    [anon_sym_var] = ACTIONS(827),
    [anon_sym_modifier] = ACTIONS(827),
    [anon_sym_constructor] = ACTIONS(827),
    [anon_sym_fallback] = ACTIONS(827),
    [anon_sym_receive] = ACTIONS(827),
    [anon_sym_mapping] = ACTIONS(827),
    [anon_sym_bool] = ACTIONS(827),
    [anon_sym_string] = ACTIONS(827),
    [anon_sym_int] = ACTIONS(827),
    [anon_sym_int8] = ACTIONS(827),
    [anon_sym_int16] = ACTIONS(827),
    [anon_sym_int24] = ACTIONS(827),
    [anon_sym_int32] = ACTIONS(827),
    [anon_sym_int40] = ACTIONS(827),
    [anon_sym_int48] = ACTIONS(827),
    [anon_sym_int56] = ACTIONS(827),
    [anon_sym_int64] = ACTIONS(827),
    [anon_sym_int72] = ACTIONS(827),
    [anon_sym_int80] = ACTIONS(827),
    [anon_sym_int88] = ACTIONS(827),
    [anon_sym_int96] = ACTIONS(827),
    [anon_sym_int104] = ACTIONS(827),
    [anon_sym_int112] = ACTIONS(827),
    [anon_sym_int120] = ACTIONS(827),
    [anon_sym_int128] = ACTIONS(827),
    [anon_sym_int136] = ACTIONS(827),
    [anon_sym_int144] = ACTIONS(827),
    [anon_sym_int152] = ACTIONS(827),
    [anon_sym_int160] = ACTIONS(827),
    [anon_sym_int168] = ACTIONS(827),
    [anon_sym_int176] = ACTIONS(827),
    [anon_sym_int184] = ACTIONS(827),
    [anon_sym_int192] = ACTIONS(827),
    [anon_sym_int200] = ACTIONS(827),
    [anon_sym_int208] = ACTIONS(827),
    [anon_sym_int216] = ACTIONS(827),
    [anon_sym_int224] = ACTIONS(827),
    [anon_sym_int232] = ACTIONS(827),
    [anon_sym_int240] = ACTIONS(827),
    [anon_sym_int248] = ACTIONS(827),
    [anon_sym_int256] = ACTIONS(827),
    [anon_sym_uint] = ACTIONS(827),
    [anon_sym_uint8] = ACTIONS(827),
    [anon_sym_uint16] = ACTIONS(827),
    [anon_sym_uint24] = ACTIONS(827),
    [anon_sym_uint32] = ACTIONS(827),
    [anon_sym_uint40] = ACTIONS(827),
    [anon_sym_uint48] = ACTIONS(827),
    [anon_sym_uint56] = ACTIONS(827),
    [anon_sym_uint64] = ACTIONS(827),
    [anon_sym_uint72] = ACTIONS(827),
    [anon_sym_uint80] = ACTIONS(827),
    [anon_sym_uint88] = ACTIONS(827),
    [anon_sym_uint96] = ACTIONS(827),
    [anon_sym_uint104] = ACTIONS(827),
    [anon_sym_uint112] = ACTIONS(827),
    [anon_sym_uint120] = ACTIONS(827),
    [anon_sym_uint128] = ACTIONS(827),
    [anon_sym_uint136] = ACTIONS(827),
    [anon_sym_uint144] = ACTIONS(827),
    [anon_sym_uint152] = ACTIONS(827),
    [anon_sym_uint160] = ACTIONS(827),
    [anon_sym_uint168] = ACTIONS(827),
    [anon_sym_uint176] = ACTIONS(827),
    [anon_sym_uint184] = ACTIONS(827),
    [anon_sym_uint192] = ACTIONS(827),
    [anon_sym_uint200] = ACTIONS(827),
    [anon_sym_uint208] = ACTIONS(827),
    [anon_sym_uint216] = ACTIONS(827),
    [anon_sym_uint224] = ACTIONS(827),
    [anon_sym_uint232] = ACTIONS(827),
    [anon_sym_uint240] = ACTIONS(827),
    [anon_sym_uint248] = ACTIONS(827),
    [anon_sym_uint256] = ACTIONS(827),
    [anon_sym_bytes] = ACTIONS(827),
    [anon_sym_bytes1] = ACTIONS(827),
    [anon_sym_bytes2] = ACTIONS(827),
    [anon_sym_bytes3] = ACTIONS(827),
    [anon_sym_bytes4] = ACTIONS(827),
    [anon_sym_bytes5] = ACTIONS(827),
    [anon_sym_bytes6] = ACTIONS(827),
    [anon_sym_bytes7] = ACTIONS(827),
    [anon_sym_bytes8] = ACTIONS(827),
    [anon_sym_bytes9] = ACTIONS(827),
    [anon_sym_bytes10] = ACTIONS(827),
    [anon_sym_bytes11] = ACTIONS(827),
    [anon_sym_bytes12] = ACTIONS(827),
    [anon_sym_bytes13] = ACTIONS(827),
    [anon_sym_bytes14] = ACTIONS(827),
    [anon_sym_bytes15] = ACTIONS(827),
    [anon_sym_bytes16] = ACTIONS(827),
    [anon_sym_bytes17] = ACTIONS(827),
    [anon_sym_bytes18] = ACTIONS(827),
    [anon_sym_bytes19] = ACTIONS(827),
    [anon_sym_bytes20] = ACTIONS(827),
    [anon_sym_bytes21] = ACTIONS(827),
    [anon_sym_bytes22] = ACTIONS(827),
    [anon_sym_bytes23] = ACTIONS(827),
    [anon_sym_bytes24] = ACTIONS(827),
    [anon_sym_bytes25] = ACTIONS(827),
    [anon_sym_bytes26] = ACTIONS(827),
    [anon_sym_bytes27] = ACTIONS(827),
    [anon_sym_bytes28] = ACTIONS(827),
    [anon_sym_bytes29] = ACTIONS(827),
    [anon_sym_bytes30] = ACTIONS(827),
    [anon_sym_bytes31] = ACTIONS(827),
    [anon_sym_bytes32] = ACTIONS(827),
    [anon_sym_fixed] = ACTIONS(827),
    [aux_sym__fixed_token1] = ACTIONS(827),
    [anon_sym_ufixed] = ACTIONS(827),
    [aux_sym__ufixed_token1] = ACTIONS(827),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_identifier] = ACTIONS(831),
    [anon_sym_RBRACE] = ACTIONS(833),
    [anon_sym_type] = ACTIONS(831),
    [anon_sym_error] = ACTIONS(831),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_enum] = ACTIONS(831),
    [anon_sym_event] = ACTIONS(831),
    [anon_sym_using] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(831),
    [anon_sym_byte] = ACTIONS(831),
    [anon_sym_address] = ACTIONS(831),
    [anon_sym_var] = ACTIONS(831),
    [anon_sym_modifier] = ACTIONS(831),
    [anon_sym_constructor] = ACTIONS(831),
    [anon_sym_fallback] = ACTIONS(831),
    [anon_sym_receive] = ACTIONS(831),
    [anon_sym_mapping] = ACTIONS(831),
    [anon_sym_bool] = ACTIONS(831),
    [anon_sym_string] = ACTIONS(831),
    [anon_sym_int] = ACTIONS(831),
    [anon_sym_int8] = ACTIONS(831),
    [anon_sym_int16] = ACTIONS(831),
    [anon_sym_int24] = ACTIONS(831),
    [anon_sym_int32] = ACTIONS(831),
    [anon_sym_int40] = ACTIONS(831),
    [anon_sym_int48] = ACTIONS(831),
    [anon_sym_int56] = ACTIONS(831),
    [anon_sym_int64] = ACTIONS(831),
    [anon_sym_int72] = ACTIONS(831),
    [anon_sym_int80] = ACTIONS(831),
    [anon_sym_int88] = ACTIONS(831),
    [anon_sym_int96] = ACTIONS(831),
    [anon_sym_int104] = ACTIONS(831),
    [anon_sym_int112] = ACTIONS(831),
    [anon_sym_int120] = ACTIONS(831),
    [anon_sym_int128] = ACTIONS(831),
    [anon_sym_int136] = ACTIONS(831),
    [anon_sym_int144] = ACTIONS(831),
    [anon_sym_int152] = ACTIONS(831),
    [anon_sym_int160] = ACTIONS(831),
    [anon_sym_int168] = ACTIONS(831),
    [anon_sym_int176] = ACTIONS(831),
    [anon_sym_int184] = ACTIONS(831),
    [anon_sym_int192] = ACTIONS(831),
    [anon_sym_int200] = ACTIONS(831),
    [anon_sym_int208] = ACTIONS(831),
    [anon_sym_int216] = ACTIONS(831),
    [anon_sym_int224] = ACTIONS(831),
    [anon_sym_int232] = ACTIONS(831),
    [anon_sym_int240] = ACTIONS(831),
    [anon_sym_int248] = ACTIONS(831),
    [anon_sym_int256] = ACTIONS(831),
    [anon_sym_uint] = ACTIONS(831),
    [anon_sym_uint8] = ACTIONS(831),
    [anon_sym_uint16] = ACTIONS(831),
    [anon_sym_uint24] = ACTIONS(831),
    [anon_sym_uint32] = ACTIONS(831),
    [anon_sym_uint40] = ACTIONS(831),
    [anon_sym_uint48] = ACTIONS(831),
    [anon_sym_uint56] = ACTIONS(831),
    [anon_sym_uint64] = ACTIONS(831),
    [anon_sym_uint72] = ACTIONS(831),
    [anon_sym_uint80] = ACTIONS(831),
    [anon_sym_uint88] = ACTIONS(831),
    [anon_sym_uint96] = ACTIONS(831),
    [anon_sym_uint104] = ACTIONS(831),
    [anon_sym_uint112] = ACTIONS(831),
    [anon_sym_uint120] = ACTIONS(831),
    [anon_sym_uint128] = ACTIONS(831),
    [anon_sym_uint136] = ACTIONS(831),
    [anon_sym_uint144] = ACTIONS(831),
    [anon_sym_uint152] = ACTIONS(831),
    [anon_sym_uint160] = ACTIONS(831),
    [anon_sym_uint168] = ACTIONS(831),
    [anon_sym_uint176] = ACTIONS(831),
    [anon_sym_uint184] = ACTIONS(831),
    [anon_sym_uint192] = ACTIONS(831),
    [anon_sym_uint200] = ACTIONS(831),
    [anon_sym_uint208] = ACTIONS(831),
    [anon_sym_uint216] = ACTIONS(831),
    [anon_sym_uint224] = ACTIONS(831),
    [anon_sym_uint232] = ACTIONS(831),
    [anon_sym_uint240] = ACTIONS(831),
    [anon_sym_uint248] = ACTIONS(831),
    [anon_sym_uint256] = ACTIONS(831),
    [anon_sym_bytes] = ACTIONS(831),
    [anon_sym_bytes1] = ACTIONS(831),
    [anon_sym_bytes2] = ACTIONS(831),
    [anon_sym_bytes3] = ACTIONS(831),
    [anon_sym_bytes4] = ACTIONS(831),
    [anon_sym_bytes5] = ACTIONS(831),
    [anon_sym_bytes6] = ACTIONS(831),
    [anon_sym_bytes7] = ACTIONS(831),
    [anon_sym_bytes8] = ACTIONS(831),
    [anon_sym_bytes9] = ACTIONS(831),
    [anon_sym_bytes10] = ACTIONS(831),
    [anon_sym_bytes11] = ACTIONS(831),
    [anon_sym_bytes12] = ACTIONS(831),
    [anon_sym_bytes13] = ACTIONS(831),
    [anon_sym_bytes14] = ACTIONS(831),
    [anon_sym_bytes15] = ACTIONS(831),
    [anon_sym_bytes16] = ACTIONS(831),
    [anon_sym_bytes17] = ACTIONS(831),
    [anon_sym_bytes18] = ACTIONS(831),
    [anon_sym_bytes19] = ACTIONS(831),
    [anon_sym_bytes20] = ACTIONS(831),
    [anon_sym_bytes21] = ACTIONS(831),
    [anon_sym_bytes22] = ACTIONS(831),
    [anon_sym_bytes23] = ACTIONS(831),
    [anon_sym_bytes24] = ACTIONS(831),
    [anon_sym_bytes25] = ACTIONS(831),
    [anon_sym_bytes26] = ACTIONS(831),
    [anon_sym_bytes27] = ACTIONS(831),
    [anon_sym_bytes28] = ACTIONS(831),
    [anon_sym_bytes29] = ACTIONS(831),
    [anon_sym_bytes30] = ACTIONS(831),
    [anon_sym_bytes31] = ACTIONS(831),
    [anon_sym_bytes32] = ACTIONS(831),
    [anon_sym_fixed] = ACTIONS(831),
    [aux_sym__fixed_token1] = ACTIONS(831),
    [anon_sym_ufixed] = ACTIONS(831),
    [aux_sym__ufixed_token1] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_identifier] = ACTIONS(835),
    [anon_sym_RBRACE] = ACTIONS(837),
    [anon_sym_type] = ACTIONS(835),
    [anon_sym_error] = ACTIONS(835),
    [anon_sym_struct] = ACTIONS(835),
    [anon_sym_enum] = ACTIONS(835),
    [anon_sym_event] = ACTIONS(835),
    [anon_sym_using] = ACTIONS(835),
    [anon_sym_function] = ACTIONS(835),
    [anon_sym_byte] = ACTIONS(835),
    [anon_sym_address] = ACTIONS(835),
    [anon_sym_var] = ACTIONS(835),
    [anon_sym_modifier] = ACTIONS(835),
    [anon_sym_constructor] = ACTIONS(835),
    [anon_sym_fallback] = ACTIONS(835),
    [anon_sym_receive] = ACTIONS(835),
    [anon_sym_mapping] = ACTIONS(835),
    [anon_sym_bool] = ACTIONS(835),
    [anon_sym_string] = ACTIONS(835),
    [anon_sym_int] = ACTIONS(835),
    [anon_sym_int8] = ACTIONS(835),
    [anon_sym_int16] = ACTIONS(835),
    [anon_sym_int24] = ACTIONS(835),
    [anon_sym_int32] = ACTIONS(835),
    [anon_sym_int40] = ACTIONS(835),
    [anon_sym_int48] = ACTIONS(835),
    [anon_sym_int56] = ACTIONS(835),
    [anon_sym_int64] = ACTIONS(835),
    [anon_sym_int72] = ACTIONS(835),
    [anon_sym_int80] = ACTIONS(835),
    [anon_sym_int88] = ACTIONS(835),
    [anon_sym_int96] = ACTIONS(835),
    [anon_sym_int104] = ACTIONS(835),
    [anon_sym_int112] = ACTIONS(835),
    [anon_sym_int120] = ACTIONS(835),
    [anon_sym_int128] = ACTIONS(835),
    [anon_sym_int136] = ACTIONS(835),
    [anon_sym_int144] = ACTIONS(835),
    [anon_sym_int152] = ACTIONS(835),
    [anon_sym_int160] = ACTIONS(835),
    [anon_sym_int168] = ACTIONS(835),
    [anon_sym_int176] = ACTIONS(835),
    [anon_sym_int184] = ACTIONS(835),
    [anon_sym_int192] = ACTIONS(835),
    [anon_sym_int200] = ACTIONS(835),
    [anon_sym_int208] = ACTIONS(835),
    [anon_sym_int216] = ACTIONS(835),
    [anon_sym_int224] = ACTIONS(835),
    [anon_sym_int232] = ACTIONS(835),
    [anon_sym_int240] = ACTIONS(835),
    [anon_sym_int248] = ACTIONS(835),
    [anon_sym_int256] = ACTIONS(835),
    [anon_sym_uint] = ACTIONS(835),
    [anon_sym_uint8] = ACTIONS(835),
    [anon_sym_uint16] = ACTIONS(835),
    [anon_sym_uint24] = ACTIONS(835),
    [anon_sym_uint32] = ACTIONS(835),
    [anon_sym_uint40] = ACTIONS(835),
    [anon_sym_uint48] = ACTIONS(835),
    [anon_sym_uint56] = ACTIONS(835),
    [anon_sym_uint64] = ACTIONS(835),
    [anon_sym_uint72] = ACTIONS(835),
    [anon_sym_uint80] = ACTIONS(835),
    [anon_sym_uint88] = ACTIONS(835),
    [anon_sym_uint96] = ACTIONS(835),
    [anon_sym_uint104] = ACTIONS(835),
    [anon_sym_uint112] = ACTIONS(835),
    [anon_sym_uint120] = ACTIONS(835),
    [anon_sym_uint128] = ACTIONS(835),
    [anon_sym_uint136] = ACTIONS(835),
    [anon_sym_uint144] = ACTIONS(835),
    [anon_sym_uint152] = ACTIONS(835),
    [anon_sym_uint160] = ACTIONS(835),
    [anon_sym_uint168] = ACTIONS(835),
    [anon_sym_uint176] = ACTIONS(835),
    [anon_sym_uint184] = ACTIONS(835),
    [anon_sym_uint192] = ACTIONS(835),
    [anon_sym_uint200] = ACTIONS(835),
    [anon_sym_uint208] = ACTIONS(835),
    [anon_sym_uint216] = ACTIONS(835),
    [anon_sym_uint224] = ACTIONS(835),
    [anon_sym_uint232] = ACTIONS(835),
    [anon_sym_uint240] = ACTIONS(835),
    [anon_sym_uint248] = ACTIONS(835),
    [anon_sym_uint256] = ACTIONS(835),
    [anon_sym_bytes] = ACTIONS(835),
    [anon_sym_bytes1] = ACTIONS(835),
    [anon_sym_bytes2] = ACTIONS(835),
    [anon_sym_bytes3] = ACTIONS(835),
    [anon_sym_bytes4] = ACTIONS(835),
    [anon_sym_bytes5] = ACTIONS(835),
    [anon_sym_bytes6] = ACTIONS(835),
    [anon_sym_bytes7] = ACTIONS(835),
    [anon_sym_bytes8] = ACTIONS(835),
    [anon_sym_bytes9] = ACTIONS(835),
    [anon_sym_bytes10] = ACTIONS(835),
    [anon_sym_bytes11] = ACTIONS(835),
    [anon_sym_bytes12] = ACTIONS(835),
    [anon_sym_bytes13] = ACTIONS(835),
    [anon_sym_bytes14] = ACTIONS(835),
    [anon_sym_bytes15] = ACTIONS(835),
    [anon_sym_bytes16] = ACTIONS(835),
    [anon_sym_bytes17] = ACTIONS(835),
    [anon_sym_bytes18] = ACTIONS(835),
    [anon_sym_bytes19] = ACTIONS(835),
    [anon_sym_bytes20] = ACTIONS(835),
    [anon_sym_bytes21] = ACTIONS(835),
    [anon_sym_bytes22] = ACTIONS(835),
    [anon_sym_bytes23] = ACTIONS(835),
    [anon_sym_bytes24] = ACTIONS(835),
    [anon_sym_bytes25] = ACTIONS(835),
    [anon_sym_bytes26] = ACTIONS(835),
    [anon_sym_bytes27] = ACTIONS(835),
    [anon_sym_bytes28] = ACTIONS(835),
    [anon_sym_bytes29] = ACTIONS(835),
    [anon_sym_bytes30] = ACTIONS(835),
    [anon_sym_bytes31] = ACTIONS(835),
    [anon_sym_bytes32] = ACTIONS(835),
    [anon_sym_fixed] = ACTIONS(835),
    [aux_sym__fixed_token1] = ACTIONS(835),
    [anon_sym_ufixed] = ACTIONS(835),
    [aux_sym__ufixed_token1] = ACTIONS(835),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(765),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym_type] = ACTIONS(765),
    [anon_sym_error] = ACTIONS(765),
    [anon_sym_struct] = ACTIONS(765),
    [anon_sym_enum] = ACTIONS(765),
    [anon_sym_event] = ACTIONS(765),
    [anon_sym_using] = ACTIONS(765),
    [anon_sym_function] = ACTIONS(765),
    [anon_sym_byte] = ACTIONS(765),
    [anon_sym_address] = ACTIONS(765),
    [anon_sym_var] = ACTIONS(765),
    [anon_sym_modifier] = ACTIONS(765),
    [anon_sym_constructor] = ACTIONS(765),
    [anon_sym_fallback] = ACTIONS(765),
    [anon_sym_receive] = ACTIONS(765),
    [anon_sym_mapping] = ACTIONS(765),
    [anon_sym_bool] = ACTIONS(765),
    [anon_sym_string] = ACTIONS(765),
    [anon_sym_int] = ACTIONS(765),
    [anon_sym_int8] = ACTIONS(765),
    [anon_sym_int16] = ACTIONS(765),
    [anon_sym_int24] = ACTIONS(765),
    [anon_sym_int32] = ACTIONS(765),
    [anon_sym_int40] = ACTIONS(765),
    [anon_sym_int48] = ACTIONS(765),
    [anon_sym_int56] = ACTIONS(765),
    [anon_sym_int64] = ACTIONS(765),
    [anon_sym_int72] = ACTIONS(765),
    [anon_sym_int80] = ACTIONS(765),
    [anon_sym_int88] = ACTIONS(765),
    [anon_sym_int96] = ACTIONS(765),
    [anon_sym_int104] = ACTIONS(765),
    [anon_sym_int112] = ACTIONS(765),
    [anon_sym_int120] = ACTIONS(765),
    [anon_sym_int128] = ACTIONS(765),
    [anon_sym_int136] = ACTIONS(765),
    [anon_sym_int144] = ACTIONS(765),
    [anon_sym_int152] = ACTIONS(765),
    [anon_sym_int160] = ACTIONS(765),
    [anon_sym_int168] = ACTIONS(765),
    [anon_sym_int176] = ACTIONS(765),
    [anon_sym_int184] = ACTIONS(765),
    [anon_sym_int192] = ACTIONS(765),
    [anon_sym_int200] = ACTIONS(765),
    [anon_sym_int208] = ACTIONS(765),
    [anon_sym_int216] = ACTIONS(765),
    [anon_sym_int224] = ACTIONS(765),
    [anon_sym_int232] = ACTIONS(765),
    [anon_sym_int240] = ACTIONS(765),
    [anon_sym_int248] = ACTIONS(765),
    [anon_sym_int256] = ACTIONS(765),
    [anon_sym_uint] = ACTIONS(765),
    [anon_sym_uint8] = ACTIONS(765),
    [anon_sym_uint16] = ACTIONS(765),
    [anon_sym_uint24] = ACTIONS(765),
    [anon_sym_uint32] = ACTIONS(765),
    [anon_sym_uint40] = ACTIONS(765),
    [anon_sym_uint48] = ACTIONS(765),
    [anon_sym_uint56] = ACTIONS(765),
    [anon_sym_uint64] = ACTIONS(765),
    [anon_sym_uint72] = ACTIONS(765),
    [anon_sym_uint80] = ACTIONS(765),
    [anon_sym_uint88] = ACTIONS(765),
    [anon_sym_uint96] = ACTIONS(765),
    [anon_sym_uint104] = ACTIONS(765),
    [anon_sym_uint112] = ACTIONS(765),
    [anon_sym_uint120] = ACTIONS(765),
    [anon_sym_uint128] = ACTIONS(765),
    [anon_sym_uint136] = ACTIONS(765),
    [anon_sym_uint144] = ACTIONS(765),
    [anon_sym_uint152] = ACTIONS(765),
    [anon_sym_uint160] = ACTIONS(765),
    [anon_sym_uint168] = ACTIONS(765),
    [anon_sym_uint176] = ACTIONS(765),
    [anon_sym_uint184] = ACTIONS(765),
    [anon_sym_uint192] = ACTIONS(765),
    [anon_sym_uint200] = ACTIONS(765),
    [anon_sym_uint208] = ACTIONS(765),
    [anon_sym_uint216] = ACTIONS(765),
    [anon_sym_uint224] = ACTIONS(765),
    [anon_sym_uint232] = ACTIONS(765),
    [anon_sym_uint240] = ACTIONS(765),
    [anon_sym_uint248] = ACTIONS(765),
    [anon_sym_uint256] = ACTIONS(765),
    [anon_sym_bytes] = ACTIONS(765),
    [anon_sym_bytes1] = ACTIONS(765),
    [anon_sym_bytes2] = ACTIONS(765),
    [anon_sym_bytes3] = ACTIONS(765),
    [anon_sym_bytes4] = ACTIONS(765),
    [anon_sym_bytes5] = ACTIONS(765),
    [anon_sym_bytes6] = ACTIONS(765),
    [anon_sym_bytes7] = ACTIONS(765),
    [anon_sym_bytes8] = ACTIONS(765),
    [anon_sym_bytes9] = ACTIONS(765),
    [anon_sym_bytes10] = ACTIONS(765),
    [anon_sym_bytes11] = ACTIONS(765),
    [anon_sym_bytes12] = ACTIONS(765),
    [anon_sym_bytes13] = ACTIONS(765),
    [anon_sym_bytes14] = ACTIONS(765),
    [anon_sym_bytes15] = ACTIONS(765),
    [anon_sym_bytes16] = ACTIONS(765),
    [anon_sym_bytes17] = ACTIONS(765),
    [anon_sym_bytes18] = ACTIONS(765),
    [anon_sym_bytes19] = ACTIONS(765),
    [anon_sym_bytes20] = ACTIONS(765),
    [anon_sym_bytes21] = ACTIONS(765),
    [anon_sym_bytes22] = ACTIONS(765),
    [anon_sym_bytes23] = ACTIONS(765),
    [anon_sym_bytes24] = ACTIONS(765),
    [anon_sym_bytes25] = ACTIONS(765),
    [anon_sym_bytes26] = ACTIONS(765),
    [anon_sym_bytes27] = ACTIONS(765),
    [anon_sym_bytes28] = ACTIONS(765),
    [anon_sym_bytes29] = ACTIONS(765),
    [anon_sym_bytes30] = ACTIONS(765),
    [anon_sym_bytes31] = ACTIONS(765),
    [anon_sym_bytes32] = ACTIONS(765),
    [anon_sym_fixed] = ACTIONS(765),
    [aux_sym__fixed_token1] = ACTIONS(765),
    [anon_sym_ufixed] = ACTIONS(765),
    [aux_sym__ufixed_token1] = ACTIONS(765),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym_type] = ACTIONS(725),
    [anon_sym_error] = ACTIONS(725),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_enum] = ACTIONS(725),
    [anon_sym_event] = ACTIONS(725),
    [anon_sym_using] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(725),
    [anon_sym_byte] = ACTIONS(725),
    [anon_sym_address] = ACTIONS(725),
    [anon_sym_var] = ACTIONS(725),
    [anon_sym_modifier] = ACTIONS(725),
    [anon_sym_constructor] = ACTIONS(725),
    [anon_sym_fallback] = ACTIONS(725),
    [anon_sym_receive] = ACTIONS(725),
    [anon_sym_mapping] = ACTIONS(725),
    [anon_sym_bool] = ACTIONS(725),
    [anon_sym_string] = ACTIONS(725),
    [anon_sym_int] = ACTIONS(725),
    [anon_sym_int8] = ACTIONS(725),
    [anon_sym_int16] = ACTIONS(725),
    [anon_sym_int24] = ACTIONS(725),
    [anon_sym_int32] = ACTIONS(725),
    [anon_sym_int40] = ACTIONS(725),
    [anon_sym_int48] = ACTIONS(725),
    [anon_sym_int56] = ACTIONS(725),
    [anon_sym_int64] = ACTIONS(725),
    [anon_sym_int72] = ACTIONS(725),
    [anon_sym_int80] = ACTIONS(725),
    [anon_sym_int88] = ACTIONS(725),
    [anon_sym_int96] = ACTIONS(725),
    [anon_sym_int104] = ACTIONS(725),
    [anon_sym_int112] = ACTIONS(725),
    [anon_sym_int120] = ACTIONS(725),
    [anon_sym_int128] = ACTIONS(725),
    [anon_sym_int136] = ACTIONS(725),
    [anon_sym_int144] = ACTIONS(725),
    [anon_sym_int152] = ACTIONS(725),
    [anon_sym_int160] = ACTIONS(725),
    [anon_sym_int168] = ACTIONS(725),
    [anon_sym_int176] = ACTIONS(725),
    [anon_sym_int184] = ACTIONS(725),
    [anon_sym_int192] = ACTIONS(725),
    [anon_sym_int200] = ACTIONS(725),
    [anon_sym_int208] = ACTIONS(725),
    [anon_sym_int216] = ACTIONS(725),
    [anon_sym_int224] = ACTIONS(725),
    [anon_sym_int232] = ACTIONS(725),
    [anon_sym_int240] = ACTIONS(725),
    [anon_sym_int248] = ACTIONS(725),
    [anon_sym_int256] = ACTIONS(725),
    [anon_sym_uint] = ACTIONS(725),
    [anon_sym_uint8] = ACTIONS(725),
    [anon_sym_uint16] = ACTIONS(725),
    [anon_sym_uint24] = ACTIONS(725),
    [anon_sym_uint32] = ACTIONS(725),
    [anon_sym_uint40] = ACTIONS(725),
    [anon_sym_uint48] = ACTIONS(725),
    [anon_sym_uint56] = ACTIONS(725),
    [anon_sym_uint64] = ACTIONS(725),
    [anon_sym_uint72] = ACTIONS(725),
    [anon_sym_uint80] = ACTIONS(725),
    [anon_sym_uint88] = ACTIONS(725),
    [anon_sym_uint96] = ACTIONS(725),
    [anon_sym_uint104] = ACTIONS(725),
    [anon_sym_uint112] = ACTIONS(725),
    [anon_sym_uint120] = ACTIONS(725),
    [anon_sym_uint128] = ACTIONS(725),
    [anon_sym_uint136] = ACTIONS(725),
    [anon_sym_uint144] = ACTIONS(725),
    [anon_sym_uint152] = ACTIONS(725),
    [anon_sym_uint160] = ACTIONS(725),
    [anon_sym_uint168] = ACTIONS(725),
    [anon_sym_uint176] = ACTIONS(725),
    [anon_sym_uint184] = ACTIONS(725),
    [anon_sym_uint192] = ACTIONS(725),
    [anon_sym_uint200] = ACTIONS(725),
    [anon_sym_uint208] = ACTIONS(725),
    [anon_sym_uint216] = ACTIONS(725),
    [anon_sym_uint224] = ACTIONS(725),
    [anon_sym_uint232] = ACTIONS(725),
    [anon_sym_uint240] = ACTIONS(725),
    [anon_sym_uint248] = ACTIONS(725),
    [anon_sym_uint256] = ACTIONS(725),
    [anon_sym_bytes] = ACTIONS(725),
    [anon_sym_bytes1] = ACTIONS(725),
    [anon_sym_bytes2] = ACTIONS(725),
    [anon_sym_bytes3] = ACTIONS(725),
    [anon_sym_bytes4] = ACTIONS(725),
    [anon_sym_bytes5] = ACTIONS(725),
    [anon_sym_bytes6] = ACTIONS(725),
    [anon_sym_bytes7] = ACTIONS(725),
    [anon_sym_bytes8] = ACTIONS(725),
    [anon_sym_bytes9] = ACTIONS(725),
    [anon_sym_bytes10] = ACTIONS(725),
    [anon_sym_bytes11] = ACTIONS(725),
    [anon_sym_bytes12] = ACTIONS(725),
    [anon_sym_bytes13] = ACTIONS(725),
    [anon_sym_bytes14] = ACTIONS(725),
    [anon_sym_bytes15] = ACTIONS(725),
    [anon_sym_bytes16] = ACTIONS(725),
    [anon_sym_bytes17] = ACTIONS(725),
    [anon_sym_bytes18] = ACTIONS(725),
    [anon_sym_bytes19] = ACTIONS(725),
    [anon_sym_bytes20] = ACTIONS(725),
    [anon_sym_bytes21] = ACTIONS(725),
    [anon_sym_bytes22] = ACTIONS(725),
    [anon_sym_bytes23] = ACTIONS(725),
    [anon_sym_bytes24] = ACTIONS(725),
    [anon_sym_bytes25] = ACTIONS(725),
    [anon_sym_bytes26] = ACTIONS(725),
    [anon_sym_bytes27] = ACTIONS(725),
    [anon_sym_bytes28] = ACTIONS(725),
    [anon_sym_bytes29] = ACTIONS(725),
    [anon_sym_bytes30] = ACTIONS(725),
    [anon_sym_bytes31] = ACTIONS(725),
    [anon_sym_bytes32] = ACTIONS(725),
    [anon_sym_fixed] = ACTIONS(725),
    [aux_sym__fixed_token1] = ACTIONS(725),
    [anon_sym_ufixed] = ACTIONS(725),
    [aux_sym__ufixed_token1] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_identifier] = ACTIONS(675),
    [anon_sym_RBRACE] = ACTIONS(673),
    [anon_sym_type] = ACTIONS(675),
    [anon_sym_error] = ACTIONS(675),
    [anon_sym_struct] = ACTIONS(675),
    [anon_sym_enum] = ACTIONS(675),
    [anon_sym_event] = ACTIONS(675),
    [anon_sym_using] = ACTIONS(675),
    [anon_sym_function] = ACTIONS(675),
    [anon_sym_byte] = ACTIONS(675),
    [anon_sym_address] = ACTIONS(675),
    [anon_sym_var] = ACTIONS(675),
    [anon_sym_modifier] = ACTIONS(675),
    [anon_sym_constructor] = ACTIONS(675),
    [anon_sym_fallback] = ACTIONS(675),
    [anon_sym_receive] = ACTIONS(675),
    [anon_sym_mapping] = ACTIONS(675),
    [anon_sym_bool] = ACTIONS(675),
    [anon_sym_string] = ACTIONS(675),
    [anon_sym_int] = ACTIONS(675),
    [anon_sym_int8] = ACTIONS(675),
    [anon_sym_int16] = ACTIONS(675),
    [anon_sym_int24] = ACTIONS(675),
    [anon_sym_int32] = ACTIONS(675),
    [anon_sym_int40] = ACTIONS(675),
    [anon_sym_int48] = ACTIONS(675),
    [anon_sym_int56] = ACTIONS(675),
    [anon_sym_int64] = ACTIONS(675),
    [anon_sym_int72] = ACTIONS(675),
    [anon_sym_int80] = ACTIONS(675),
    [anon_sym_int88] = ACTIONS(675),
    [anon_sym_int96] = ACTIONS(675),
    [anon_sym_int104] = ACTIONS(675),
    [anon_sym_int112] = ACTIONS(675),
    [anon_sym_int120] = ACTIONS(675),
    [anon_sym_int128] = ACTIONS(675),
    [anon_sym_int136] = ACTIONS(675),
    [anon_sym_int144] = ACTIONS(675),
    [anon_sym_int152] = ACTIONS(675),
    [anon_sym_int160] = ACTIONS(675),
    [anon_sym_int168] = ACTIONS(675),
    [anon_sym_int176] = ACTIONS(675),
    [anon_sym_int184] = ACTIONS(675),
    [anon_sym_int192] = ACTIONS(675),
    [anon_sym_int200] = ACTIONS(675),
    [anon_sym_int208] = ACTIONS(675),
    [anon_sym_int216] = ACTIONS(675),
    [anon_sym_int224] = ACTIONS(675),
    [anon_sym_int232] = ACTIONS(675),
    [anon_sym_int240] = ACTIONS(675),
    [anon_sym_int248] = ACTIONS(675),
    [anon_sym_int256] = ACTIONS(675),
    [anon_sym_uint] = ACTIONS(675),
    [anon_sym_uint8] = ACTIONS(675),
    [anon_sym_uint16] = ACTIONS(675),
    [anon_sym_uint24] = ACTIONS(675),
    [anon_sym_uint32] = ACTIONS(675),
    [anon_sym_uint40] = ACTIONS(675),
    [anon_sym_uint48] = ACTIONS(675),
    [anon_sym_uint56] = ACTIONS(675),
    [anon_sym_uint64] = ACTIONS(675),
    [anon_sym_uint72] = ACTIONS(675),
    [anon_sym_uint80] = ACTIONS(675),
    [anon_sym_uint88] = ACTIONS(675),
    [anon_sym_uint96] = ACTIONS(675),
    [anon_sym_uint104] = ACTIONS(675),
    [anon_sym_uint112] = ACTIONS(675),
    [anon_sym_uint120] = ACTIONS(675),
    [anon_sym_uint128] = ACTIONS(675),
    [anon_sym_uint136] = ACTIONS(675),
    [anon_sym_uint144] = ACTIONS(675),
    [anon_sym_uint152] = ACTIONS(675),
    [anon_sym_uint160] = ACTIONS(675),
    [anon_sym_uint168] = ACTIONS(675),
    [anon_sym_uint176] = ACTIONS(675),
    [anon_sym_uint184] = ACTIONS(675),
    [anon_sym_uint192] = ACTIONS(675),
    [anon_sym_uint200] = ACTIONS(675),
    [anon_sym_uint208] = ACTIONS(675),
    [anon_sym_uint216] = ACTIONS(675),
    [anon_sym_uint224] = ACTIONS(675),
    [anon_sym_uint232] = ACTIONS(675),
    [anon_sym_uint240] = ACTIONS(675),
    [anon_sym_uint248] = ACTIONS(675),
    [anon_sym_uint256] = ACTIONS(675),
    [anon_sym_bytes] = ACTIONS(675),
    [anon_sym_bytes1] = ACTIONS(675),
    [anon_sym_bytes2] = ACTIONS(675),
    [anon_sym_bytes3] = ACTIONS(675),
    [anon_sym_bytes4] = ACTIONS(675),
    [anon_sym_bytes5] = ACTIONS(675),
    [anon_sym_bytes6] = ACTIONS(675),
    [anon_sym_bytes7] = ACTIONS(675),
    [anon_sym_bytes8] = ACTIONS(675),
    [anon_sym_bytes9] = ACTIONS(675),
    [anon_sym_bytes10] = ACTIONS(675),
    [anon_sym_bytes11] = ACTIONS(675),
    [anon_sym_bytes12] = ACTIONS(675),
    [anon_sym_bytes13] = ACTIONS(675),
    [anon_sym_bytes14] = ACTIONS(675),
    [anon_sym_bytes15] = ACTIONS(675),
    [anon_sym_bytes16] = ACTIONS(675),
    [anon_sym_bytes17] = ACTIONS(675),
    [anon_sym_bytes18] = ACTIONS(675),
    [anon_sym_bytes19] = ACTIONS(675),
    [anon_sym_bytes20] = ACTIONS(675),
    [anon_sym_bytes21] = ACTIONS(675),
    [anon_sym_bytes22] = ACTIONS(675),
    [anon_sym_bytes23] = ACTIONS(675),
    [anon_sym_bytes24] = ACTIONS(675),
    [anon_sym_bytes25] = ACTIONS(675),
    [anon_sym_bytes26] = ACTIONS(675),
    [anon_sym_bytes27] = ACTIONS(675),
    [anon_sym_bytes28] = ACTIONS(675),
    [anon_sym_bytes29] = ACTIONS(675),
    [anon_sym_bytes30] = ACTIONS(675),
    [anon_sym_bytes31] = ACTIONS(675),
    [anon_sym_bytes32] = ACTIONS(675),
    [anon_sym_fixed] = ACTIONS(675),
    [aux_sym__fixed_token1] = ACTIONS(675),
    [anon_sym_ufixed] = ACTIONS(675),
    [aux_sym__ufixed_token1] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_identifier] = ACTIONS(687),
    [anon_sym_RBRACE] = ACTIONS(685),
    [anon_sym_type] = ACTIONS(687),
    [anon_sym_error] = ACTIONS(687),
    [anon_sym_struct] = ACTIONS(687),
    [anon_sym_enum] = ACTIONS(687),
    [anon_sym_event] = ACTIONS(687),
    [anon_sym_using] = ACTIONS(687),
    [anon_sym_function] = ACTIONS(687),
    [anon_sym_byte] = ACTIONS(687),
    [anon_sym_address] = ACTIONS(687),
    [anon_sym_var] = ACTIONS(687),
    [anon_sym_modifier] = ACTIONS(687),
    [anon_sym_constructor] = ACTIONS(687),
    [anon_sym_fallback] = ACTIONS(687),
    [anon_sym_receive] = ACTIONS(687),
    [anon_sym_mapping] = ACTIONS(687),
    [anon_sym_bool] = ACTIONS(687),
    [anon_sym_string] = ACTIONS(687),
    [anon_sym_int] = ACTIONS(687),
    [anon_sym_int8] = ACTIONS(687),
    [anon_sym_int16] = ACTIONS(687),
    [anon_sym_int24] = ACTIONS(687),
    [anon_sym_int32] = ACTIONS(687),
    [anon_sym_int40] = ACTIONS(687),
    [anon_sym_int48] = ACTIONS(687),
    [anon_sym_int56] = ACTIONS(687),
    [anon_sym_int64] = ACTIONS(687),
    [anon_sym_int72] = ACTIONS(687),
    [anon_sym_int80] = ACTIONS(687),
    [anon_sym_int88] = ACTIONS(687),
    [anon_sym_int96] = ACTIONS(687),
    [anon_sym_int104] = ACTIONS(687),
    [anon_sym_int112] = ACTIONS(687),
    [anon_sym_int120] = ACTIONS(687),
    [anon_sym_int128] = ACTIONS(687),
    [anon_sym_int136] = ACTIONS(687),
    [anon_sym_int144] = ACTIONS(687),
    [anon_sym_int152] = ACTIONS(687),
    [anon_sym_int160] = ACTIONS(687),
    [anon_sym_int168] = ACTIONS(687),
    [anon_sym_int176] = ACTIONS(687),
    [anon_sym_int184] = ACTIONS(687),
    [anon_sym_int192] = ACTIONS(687),
    [anon_sym_int200] = ACTIONS(687),
    [anon_sym_int208] = ACTIONS(687),
    [anon_sym_int216] = ACTIONS(687),
    [anon_sym_int224] = ACTIONS(687),
    [anon_sym_int232] = ACTIONS(687),
    [anon_sym_int240] = ACTIONS(687),
    [anon_sym_int248] = ACTIONS(687),
    [anon_sym_int256] = ACTIONS(687),
    [anon_sym_uint] = ACTIONS(687),
    [anon_sym_uint8] = ACTIONS(687),
    [anon_sym_uint16] = ACTIONS(687),
    [anon_sym_uint24] = ACTIONS(687),
    [anon_sym_uint32] = ACTIONS(687),
    [anon_sym_uint40] = ACTIONS(687),
    [anon_sym_uint48] = ACTIONS(687),
    [anon_sym_uint56] = ACTIONS(687),
    [anon_sym_uint64] = ACTIONS(687),
    [anon_sym_uint72] = ACTIONS(687),
    [anon_sym_uint80] = ACTIONS(687),
    [anon_sym_uint88] = ACTIONS(687),
    [anon_sym_uint96] = ACTIONS(687),
    [anon_sym_uint104] = ACTIONS(687),
    [anon_sym_uint112] = ACTIONS(687),
    [anon_sym_uint120] = ACTIONS(687),
    [anon_sym_uint128] = ACTIONS(687),
    [anon_sym_uint136] = ACTIONS(687),
    [anon_sym_uint144] = ACTIONS(687),
    [anon_sym_uint152] = ACTIONS(687),
    [anon_sym_uint160] = ACTIONS(687),
    [anon_sym_uint168] = ACTIONS(687),
    [anon_sym_uint176] = ACTIONS(687),
    [anon_sym_uint184] = ACTIONS(687),
    [anon_sym_uint192] = ACTIONS(687),
    [anon_sym_uint200] = ACTIONS(687),
    [anon_sym_uint208] = ACTIONS(687),
    [anon_sym_uint216] = ACTIONS(687),
    [anon_sym_uint224] = ACTIONS(687),
    [anon_sym_uint232] = ACTIONS(687),
    [anon_sym_uint240] = ACTIONS(687),
    [anon_sym_uint248] = ACTIONS(687),
    [anon_sym_uint256] = ACTIONS(687),
    [anon_sym_bytes] = ACTIONS(687),
    [anon_sym_bytes1] = ACTIONS(687),
    [anon_sym_bytes2] = ACTIONS(687),
    [anon_sym_bytes3] = ACTIONS(687),
    [anon_sym_bytes4] = ACTIONS(687),
    [anon_sym_bytes5] = ACTIONS(687),
    [anon_sym_bytes6] = ACTIONS(687),
    [anon_sym_bytes7] = ACTIONS(687),
    [anon_sym_bytes8] = ACTIONS(687),
    [anon_sym_bytes9] = ACTIONS(687),
    [anon_sym_bytes10] = ACTIONS(687),
    [anon_sym_bytes11] = ACTIONS(687),
    [anon_sym_bytes12] = ACTIONS(687),
    [anon_sym_bytes13] = ACTIONS(687),
    [anon_sym_bytes14] = ACTIONS(687),
    [anon_sym_bytes15] = ACTIONS(687),
    [anon_sym_bytes16] = ACTIONS(687),
    [anon_sym_bytes17] = ACTIONS(687),
    [anon_sym_bytes18] = ACTIONS(687),
    [anon_sym_bytes19] = ACTIONS(687),
    [anon_sym_bytes20] = ACTIONS(687),
    [anon_sym_bytes21] = ACTIONS(687),
    [anon_sym_bytes22] = ACTIONS(687),
    [anon_sym_bytes23] = ACTIONS(687),
    [anon_sym_bytes24] = ACTIONS(687),
    [anon_sym_bytes25] = ACTIONS(687),
    [anon_sym_bytes26] = ACTIONS(687),
    [anon_sym_bytes27] = ACTIONS(687),
    [anon_sym_bytes28] = ACTIONS(687),
    [anon_sym_bytes29] = ACTIONS(687),
    [anon_sym_bytes30] = ACTIONS(687),
    [anon_sym_bytes31] = ACTIONS(687),
    [anon_sym_bytes32] = ACTIONS(687),
    [anon_sym_fixed] = ACTIONS(687),
    [aux_sym__fixed_token1] = ACTIONS(687),
    [anon_sym_ufixed] = ACTIONS(687),
    [aux_sym__ufixed_token1] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_identifier] = ACTIONS(663),
    [anon_sym_RBRACE] = ACTIONS(661),
    [anon_sym_type] = ACTIONS(663),
    [anon_sym_error] = ACTIONS(663),
    [anon_sym_struct] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(663),
    [anon_sym_event] = ACTIONS(663),
    [anon_sym_using] = ACTIONS(663),
    [anon_sym_function] = ACTIONS(663),
    [anon_sym_byte] = ACTIONS(663),
    [anon_sym_address] = ACTIONS(663),
    [anon_sym_var] = ACTIONS(663),
    [anon_sym_modifier] = ACTIONS(663),
    [anon_sym_constructor] = ACTIONS(663),
    [anon_sym_fallback] = ACTIONS(663),
    [anon_sym_receive] = ACTIONS(663),
    [anon_sym_mapping] = ACTIONS(663),
    [anon_sym_bool] = ACTIONS(663),
    [anon_sym_string] = ACTIONS(663),
    [anon_sym_int] = ACTIONS(663),
    [anon_sym_int8] = ACTIONS(663),
    [anon_sym_int16] = ACTIONS(663),
    [anon_sym_int24] = ACTIONS(663),
    [anon_sym_int32] = ACTIONS(663),
    [anon_sym_int40] = ACTIONS(663),
    [anon_sym_int48] = ACTIONS(663),
    [anon_sym_int56] = ACTIONS(663),
    [anon_sym_int64] = ACTIONS(663),
    [anon_sym_int72] = ACTIONS(663),
    [anon_sym_int80] = ACTIONS(663),
    [anon_sym_int88] = ACTIONS(663),
    [anon_sym_int96] = ACTIONS(663),
    [anon_sym_int104] = ACTIONS(663),
    [anon_sym_int112] = ACTIONS(663),
    [anon_sym_int120] = ACTIONS(663),
    [anon_sym_int128] = ACTIONS(663),
    [anon_sym_int136] = ACTIONS(663),
    [anon_sym_int144] = ACTIONS(663),
    [anon_sym_int152] = ACTIONS(663),
    [anon_sym_int160] = ACTIONS(663),
    [anon_sym_int168] = ACTIONS(663),
    [anon_sym_int176] = ACTIONS(663),
    [anon_sym_int184] = ACTIONS(663),
    [anon_sym_int192] = ACTIONS(663),
    [anon_sym_int200] = ACTIONS(663),
    [anon_sym_int208] = ACTIONS(663),
    [anon_sym_int216] = ACTIONS(663),
    [anon_sym_int224] = ACTIONS(663),
    [anon_sym_int232] = ACTIONS(663),
    [anon_sym_int240] = ACTIONS(663),
    [anon_sym_int248] = ACTIONS(663),
    [anon_sym_int256] = ACTIONS(663),
    [anon_sym_uint] = ACTIONS(663),
    [anon_sym_uint8] = ACTIONS(663),
    [anon_sym_uint16] = ACTIONS(663),
    [anon_sym_uint24] = ACTIONS(663),
    [anon_sym_uint32] = ACTIONS(663),
    [anon_sym_uint40] = ACTIONS(663),
    [anon_sym_uint48] = ACTIONS(663),
    [anon_sym_uint56] = ACTIONS(663),
    [anon_sym_uint64] = ACTIONS(663),
    [anon_sym_uint72] = ACTIONS(663),
    [anon_sym_uint80] = ACTIONS(663),
    [anon_sym_uint88] = ACTIONS(663),
    [anon_sym_uint96] = ACTIONS(663),
    [anon_sym_uint104] = ACTIONS(663),
    [anon_sym_uint112] = ACTIONS(663),
    [anon_sym_uint120] = ACTIONS(663),
    [anon_sym_uint128] = ACTIONS(663),
    [anon_sym_uint136] = ACTIONS(663),
    [anon_sym_uint144] = ACTIONS(663),
    [anon_sym_uint152] = ACTIONS(663),
    [anon_sym_uint160] = ACTIONS(663),
    [anon_sym_uint168] = ACTIONS(663),
    [anon_sym_uint176] = ACTIONS(663),
    [anon_sym_uint184] = ACTIONS(663),
    [anon_sym_uint192] = ACTIONS(663),
    [anon_sym_uint200] = ACTIONS(663),
    [anon_sym_uint208] = ACTIONS(663),
    [anon_sym_uint216] = ACTIONS(663),
    [anon_sym_uint224] = ACTIONS(663),
    [anon_sym_uint232] = ACTIONS(663),
    [anon_sym_uint240] = ACTIONS(663),
    [anon_sym_uint248] = ACTIONS(663),
    [anon_sym_uint256] = ACTIONS(663),
    [anon_sym_bytes] = ACTIONS(663),
    [anon_sym_bytes1] = ACTIONS(663),
    [anon_sym_bytes2] = ACTIONS(663),
    [anon_sym_bytes3] = ACTIONS(663),
    [anon_sym_bytes4] = ACTIONS(663),
    [anon_sym_bytes5] = ACTIONS(663),
    [anon_sym_bytes6] = ACTIONS(663),
    [anon_sym_bytes7] = ACTIONS(663),
    [anon_sym_bytes8] = ACTIONS(663),
    [anon_sym_bytes9] = ACTIONS(663),
    [anon_sym_bytes10] = ACTIONS(663),
    [anon_sym_bytes11] = ACTIONS(663),
    [anon_sym_bytes12] = ACTIONS(663),
    [anon_sym_bytes13] = ACTIONS(663),
    [anon_sym_bytes14] = ACTIONS(663),
    [anon_sym_bytes15] = ACTIONS(663),
    [anon_sym_bytes16] = ACTIONS(663),
    [anon_sym_bytes17] = ACTIONS(663),
    [anon_sym_bytes18] = ACTIONS(663),
    [anon_sym_bytes19] = ACTIONS(663),
    [anon_sym_bytes20] = ACTIONS(663),
    [anon_sym_bytes21] = ACTIONS(663),
    [anon_sym_bytes22] = ACTIONS(663),
    [anon_sym_bytes23] = ACTIONS(663),
    [anon_sym_bytes24] = ACTIONS(663),
    [anon_sym_bytes25] = ACTIONS(663),
    [anon_sym_bytes26] = ACTIONS(663),
    [anon_sym_bytes27] = ACTIONS(663),
    [anon_sym_bytes28] = ACTIONS(663),
    [anon_sym_bytes29] = ACTIONS(663),
    [anon_sym_bytes30] = ACTIONS(663),
    [anon_sym_bytes31] = ACTIONS(663),
    [anon_sym_bytes32] = ACTIONS(663),
    [anon_sym_fixed] = ACTIONS(663),
    [aux_sym__fixed_token1] = ACTIONS(663),
    [anon_sym_ufixed] = ACTIONS(663),
    [aux_sym__ufixed_token1] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_identifier] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(665),
    [anon_sym_type] = ACTIONS(667),
    [anon_sym_error] = ACTIONS(667),
    [anon_sym_struct] = ACTIONS(667),
    [anon_sym_enum] = ACTIONS(667),
    [anon_sym_event] = ACTIONS(667),
    [anon_sym_using] = ACTIONS(667),
    [anon_sym_function] = ACTIONS(667),
    [anon_sym_byte] = ACTIONS(667),
    [anon_sym_address] = ACTIONS(667),
    [anon_sym_var] = ACTIONS(667),
    [anon_sym_modifier] = ACTIONS(667),
    [anon_sym_constructor] = ACTIONS(667),
    [anon_sym_fallback] = ACTIONS(667),
    [anon_sym_receive] = ACTIONS(667),
    [anon_sym_mapping] = ACTIONS(667),
    [anon_sym_bool] = ACTIONS(667),
    [anon_sym_string] = ACTIONS(667),
    [anon_sym_int] = ACTIONS(667),
    [anon_sym_int8] = ACTIONS(667),
    [anon_sym_int16] = ACTIONS(667),
    [anon_sym_int24] = ACTIONS(667),
    [anon_sym_int32] = ACTIONS(667),
    [anon_sym_int40] = ACTIONS(667),
    [anon_sym_int48] = ACTIONS(667),
    [anon_sym_int56] = ACTIONS(667),
    [anon_sym_int64] = ACTIONS(667),
    [anon_sym_int72] = ACTIONS(667),
    [anon_sym_int80] = ACTIONS(667),
    [anon_sym_int88] = ACTIONS(667),
    [anon_sym_int96] = ACTIONS(667),
    [anon_sym_int104] = ACTIONS(667),
    [anon_sym_int112] = ACTIONS(667),
    [anon_sym_int120] = ACTIONS(667),
    [anon_sym_int128] = ACTIONS(667),
    [anon_sym_int136] = ACTIONS(667),
    [anon_sym_int144] = ACTIONS(667),
    [anon_sym_int152] = ACTIONS(667),
    [anon_sym_int160] = ACTIONS(667),
    [anon_sym_int168] = ACTIONS(667),
    [anon_sym_int176] = ACTIONS(667),
    [anon_sym_int184] = ACTIONS(667),
    [anon_sym_int192] = ACTIONS(667),
    [anon_sym_int200] = ACTIONS(667),
    [anon_sym_int208] = ACTIONS(667),
    [anon_sym_int216] = ACTIONS(667),
    [anon_sym_int224] = ACTIONS(667),
    [anon_sym_int232] = ACTIONS(667),
    [anon_sym_int240] = ACTIONS(667),
    [anon_sym_int248] = ACTIONS(667),
    [anon_sym_int256] = ACTIONS(667),
    [anon_sym_uint] = ACTIONS(667),
    [anon_sym_uint8] = ACTIONS(667),
    [anon_sym_uint16] = ACTIONS(667),
    [anon_sym_uint24] = ACTIONS(667),
    [anon_sym_uint32] = ACTIONS(667),
    [anon_sym_uint40] = ACTIONS(667),
    [anon_sym_uint48] = ACTIONS(667),
    [anon_sym_uint56] = ACTIONS(667),
    [anon_sym_uint64] = ACTIONS(667),
    [anon_sym_uint72] = ACTIONS(667),
    [anon_sym_uint80] = ACTIONS(667),
    [anon_sym_uint88] = ACTIONS(667),
    [anon_sym_uint96] = ACTIONS(667),
    [anon_sym_uint104] = ACTIONS(667),
    [anon_sym_uint112] = ACTIONS(667),
    [anon_sym_uint120] = ACTIONS(667),
    [anon_sym_uint128] = ACTIONS(667),
    [anon_sym_uint136] = ACTIONS(667),
    [anon_sym_uint144] = ACTIONS(667),
    [anon_sym_uint152] = ACTIONS(667),
    [anon_sym_uint160] = ACTIONS(667),
    [anon_sym_uint168] = ACTIONS(667),
    [anon_sym_uint176] = ACTIONS(667),
    [anon_sym_uint184] = ACTIONS(667),
    [anon_sym_uint192] = ACTIONS(667),
    [anon_sym_uint200] = ACTIONS(667),
    [anon_sym_uint208] = ACTIONS(667),
    [anon_sym_uint216] = ACTIONS(667),
    [anon_sym_uint224] = ACTIONS(667),
    [anon_sym_uint232] = ACTIONS(667),
    [anon_sym_uint240] = ACTIONS(667),
    [anon_sym_uint248] = ACTIONS(667),
    [anon_sym_uint256] = ACTIONS(667),
    [anon_sym_bytes] = ACTIONS(667),
    [anon_sym_bytes1] = ACTIONS(667),
    [anon_sym_bytes2] = ACTIONS(667),
    [anon_sym_bytes3] = ACTIONS(667),
    [anon_sym_bytes4] = ACTIONS(667),
    [anon_sym_bytes5] = ACTIONS(667),
    [anon_sym_bytes6] = ACTIONS(667),
    [anon_sym_bytes7] = ACTIONS(667),
    [anon_sym_bytes8] = ACTIONS(667),
    [anon_sym_bytes9] = ACTIONS(667),
    [anon_sym_bytes10] = ACTIONS(667),
    [anon_sym_bytes11] = ACTIONS(667),
    [anon_sym_bytes12] = ACTIONS(667),
    [anon_sym_bytes13] = ACTIONS(667),
    [anon_sym_bytes14] = ACTIONS(667),
    [anon_sym_bytes15] = ACTIONS(667),
    [anon_sym_bytes16] = ACTIONS(667),
    [anon_sym_bytes17] = ACTIONS(667),
    [anon_sym_bytes18] = ACTIONS(667),
    [anon_sym_bytes19] = ACTIONS(667),
    [anon_sym_bytes20] = ACTIONS(667),
    [anon_sym_bytes21] = ACTIONS(667),
    [anon_sym_bytes22] = ACTIONS(667),
    [anon_sym_bytes23] = ACTIONS(667),
    [anon_sym_bytes24] = ACTIONS(667),
    [anon_sym_bytes25] = ACTIONS(667),
    [anon_sym_bytes26] = ACTIONS(667),
    [anon_sym_bytes27] = ACTIONS(667),
    [anon_sym_bytes28] = ACTIONS(667),
    [anon_sym_bytes29] = ACTIONS(667),
    [anon_sym_bytes30] = ACTIONS(667),
    [anon_sym_bytes31] = ACTIONS(667),
    [anon_sym_bytes32] = ACTIONS(667),
    [anon_sym_fixed] = ACTIONS(667),
    [aux_sym__fixed_token1] = ACTIONS(667),
    [anon_sym_ufixed] = ACTIONS(667),
    [aux_sym__ufixed_token1] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_identifier] = ACTIONS(769),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_type] = ACTIONS(769),
    [anon_sym_error] = ACTIONS(769),
    [anon_sym_struct] = ACTIONS(769),
    [anon_sym_enum] = ACTIONS(769),
    [anon_sym_event] = ACTIONS(769),
    [anon_sym_using] = ACTIONS(769),
    [anon_sym_function] = ACTIONS(769),
    [anon_sym_byte] = ACTIONS(769),
    [anon_sym_address] = ACTIONS(769),
    [anon_sym_var] = ACTIONS(769),
    [anon_sym_modifier] = ACTIONS(769),
    [anon_sym_constructor] = ACTIONS(769),
    [anon_sym_fallback] = ACTIONS(769),
    [anon_sym_receive] = ACTIONS(769),
    [anon_sym_mapping] = ACTIONS(769),
    [anon_sym_bool] = ACTIONS(769),
    [anon_sym_string] = ACTIONS(769),
    [anon_sym_int] = ACTIONS(769),
    [anon_sym_int8] = ACTIONS(769),
    [anon_sym_int16] = ACTIONS(769),
    [anon_sym_int24] = ACTIONS(769),
    [anon_sym_int32] = ACTIONS(769),
    [anon_sym_int40] = ACTIONS(769),
    [anon_sym_int48] = ACTIONS(769),
    [anon_sym_int56] = ACTIONS(769),
    [anon_sym_int64] = ACTIONS(769),
    [anon_sym_int72] = ACTIONS(769),
    [anon_sym_int80] = ACTIONS(769),
    [anon_sym_int88] = ACTIONS(769),
    [anon_sym_int96] = ACTIONS(769),
    [anon_sym_int104] = ACTIONS(769),
    [anon_sym_int112] = ACTIONS(769),
    [anon_sym_int120] = ACTIONS(769),
    [anon_sym_int128] = ACTIONS(769),
    [anon_sym_int136] = ACTIONS(769),
    [anon_sym_int144] = ACTIONS(769),
    [anon_sym_int152] = ACTIONS(769),
    [anon_sym_int160] = ACTIONS(769),
    [anon_sym_int168] = ACTIONS(769),
    [anon_sym_int176] = ACTIONS(769),
    [anon_sym_int184] = ACTIONS(769),
    [anon_sym_int192] = ACTIONS(769),
    [anon_sym_int200] = ACTIONS(769),
    [anon_sym_int208] = ACTIONS(769),
    [anon_sym_int216] = ACTIONS(769),
    [anon_sym_int224] = ACTIONS(769),
    [anon_sym_int232] = ACTIONS(769),
    [anon_sym_int240] = ACTIONS(769),
    [anon_sym_int248] = ACTIONS(769),
    [anon_sym_int256] = ACTIONS(769),
    [anon_sym_uint] = ACTIONS(769),
    [anon_sym_uint8] = ACTIONS(769),
    [anon_sym_uint16] = ACTIONS(769),
    [anon_sym_uint24] = ACTIONS(769),
    [anon_sym_uint32] = ACTIONS(769),
    [anon_sym_uint40] = ACTIONS(769),
    [anon_sym_uint48] = ACTIONS(769),
    [anon_sym_uint56] = ACTIONS(769),
    [anon_sym_uint64] = ACTIONS(769),
    [anon_sym_uint72] = ACTIONS(769),
    [anon_sym_uint80] = ACTIONS(769),
    [anon_sym_uint88] = ACTIONS(769),
    [anon_sym_uint96] = ACTIONS(769),
    [anon_sym_uint104] = ACTIONS(769),
    [anon_sym_uint112] = ACTIONS(769),
    [anon_sym_uint120] = ACTIONS(769),
    [anon_sym_uint128] = ACTIONS(769),
    [anon_sym_uint136] = ACTIONS(769),
    [anon_sym_uint144] = ACTIONS(769),
    [anon_sym_uint152] = ACTIONS(769),
    [anon_sym_uint160] = ACTIONS(769),
    [anon_sym_uint168] = ACTIONS(769),
    [anon_sym_uint176] = ACTIONS(769),
    [anon_sym_uint184] = ACTIONS(769),
    [anon_sym_uint192] = ACTIONS(769),
    [anon_sym_uint200] = ACTIONS(769),
    [anon_sym_uint208] = ACTIONS(769),
    [anon_sym_uint216] = ACTIONS(769),
    [anon_sym_uint224] = ACTIONS(769),
    [anon_sym_uint232] = ACTIONS(769),
    [anon_sym_uint240] = ACTIONS(769),
    [anon_sym_uint248] = ACTIONS(769),
    [anon_sym_uint256] = ACTIONS(769),
    [anon_sym_bytes] = ACTIONS(769),
    [anon_sym_bytes1] = ACTIONS(769),
    [anon_sym_bytes2] = ACTIONS(769),
    [anon_sym_bytes3] = ACTIONS(769),
    [anon_sym_bytes4] = ACTIONS(769),
    [anon_sym_bytes5] = ACTIONS(769),
    [anon_sym_bytes6] = ACTIONS(769),
    [anon_sym_bytes7] = ACTIONS(769),
    [anon_sym_bytes8] = ACTIONS(769),
    [anon_sym_bytes9] = ACTIONS(769),
    [anon_sym_bytes10] = ACTIONS(769),
    [anon_sym_bytes11] = ACTIONS(769),
    [anon_sym_bytes12] = ACTIONS(769),
    [anon_sym_bytes13] = ACTIONS(769),
    [anon_sym_bytes14] = ACTIONS(769),
    [anon_sym_bytes15] = ACTIONS(769),
    [anon_sym_bytes16] = ACTIONS(769),
    [anon_sym_bytes17] = ACTIONS(769),
    [anon_sym_bytes18] = ACTIONS(769),
    [anon_sym_bytes19] = ACTIONS(769),
    [anon_sym_bytes20] = ACTIONS(769),
    [anon_sym_bytes21] = ACTIONS(769),
    [anon_sym_bytes22] = ACTIONS(769),
    [anon_sym_bytes23] = ACTIONS(769),
    [anon_sym_bytes24] = ACTIONS(769),
    [anon_sym_bytes25] = ACTIONS(769),
    [anon_sym_bytes26] = ACTIONS(769),
    [anon_sym_bytes27] = ACTIONS(769),
    [anon_sym_bytes28] = ACTIONS(769),
    [anon_sym_bytes29] = ACTIONS(769),
    [anon_sym_bytes30] = ACTIONS(769),
    [anon_sym_bytes31] = ACTIONS(769),
    [anon_sym_bytes32] = ACTIONS(769),
    [anon_sym_fixed] = ACTIONS(769),
    [aux_sym__fixed_token1] = ACTIONS(769),
    [anon_sym_ufixed] = ACTIONS(769),
    [aux_sym__ufixed_token1] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_identifier] = ACTIONS(647),
    [anon_sym_RBRACE] = ACTIONS(645),
    [anon_sym_type] = ACTIONS(647),
    [anon_sym_error] = ACTIONS(647),
    [anon_sym_struct] = ACTIONS(647),
    [anon_sym_enum] = ACTIONS(647),
    [anon_sym_event] = ACTIONS(647),
    [anon_sym_using] = ACTIONS(647),
    [anon_sym_function] = ACTIONS(647),
    [anon_sym_byte] = ACTIONS(647),
    [anon_sym_address] = ACTIONS(647),
    [anon_sym_var] = ACTIONS(647),
    [anon_sym_modifier] = ACTIONS(647),
    [anon_sym_constructor] = ACTIONS(647),
    [anon_sym_fallback] = ACTIONS(647),
    [anon_sym_receive] = ACTIONS(647),
    [anon_sym_mapping] = ACTIONS(647),
    [anon_sym_bool] = ACTIONS(647),
    [anon_sym_string] = ACTIONS(647),
    [anon_sym_int] = ACTIONS(647),
    [anon_sym_int8] = ACTIONS(647),
    [anon_sym_int16] = ACTIONS(647),
    [anon_sym_int24] = ACTIONS(647),
    [anon_sym_int32] = ACTIONS(647),
    [anon_sym_int40] = ACTIONS(647),
    [anon_sym_int48] = ACTIONS(647),
    [anon_sym_int56] = ACTIONS(647),
    [anon_sym_int64] = ACTIONS(647),
    [anon_sym_int72] = ACTIONS(647),
    [anon_sym_int80] = ACTIONS(647),
    [anon_sym_int88] = ACTIONS(647),
    [anon_sym_int96] = ACTIONS(647),
    [anon_sym_int104] = ACTIONS(647),
    [anon_sym_int112] = ACTIONS(647),
    [anon_sym_int120] = ACTIONS(647),
    [anon_sym_int128] = ACTIONS(647),
    [anon_sym_int136] = ACTIONS(647),
    [anon_sym_int144] = ACTIONS(647),
    [anon_sym_int152] = ACTIONS(647),
    [anon_sym_int160] = ACTIONS(647),
    [anon_sym_int168] = ACTIONS(647),
    [anon_sym_int176] = ACTIONS(647),
    [anon_sym_int184] = ACTIONS(647),
    [anon_sym_int192] = ACTIONS(647),
    [anon_sym_int200] = ACTIONS(647),
    [anon_sym_int208] = ACTIONS(647),
    [anon_sym_int216] = ACTIONS(647),
    [anon_sym_int224] = ACTIONS(647),
    [anon_sym_int232] = ACTIONS(647),
    [anon_sym_int240] = ACTIONS(647),
    [anon_sym_int248] = ACTIONS(647),
    [anon_sym_int256] = ACTIONS(647),
    [anon_sym_uint] = ACTIONS(647),
    [anon_sym_uint8] = ACTIONS(647),
    [anon_sym_uint16] = ACTIONS(647),
    [anon_sym_uint24] = ACTIONS(647),
    [anon_sym_uint32] = ACTIONS(647),
    [anon_sym_uint40] = ACTIONS(647),
    [anon_sym_uint48] = ACTIONS(647),
    [anon_sym_uint56] = ACTIONS(647),
    [anon_sym_uint64] = ACTIONS(647),
    [anon_sym_uint72] = ACTIONS(647),
    [anon_sym_uint80] = ACTIONS(647),
    [anon_sym_uint88] = ACTIONS(647),
    [anon_sym_uint96] = ACTIONS(647),
    [anon_sym_uint104] = ACTIONS(647),
    [anon_sym_uint112] = ACTIONS(647),
    [anon_sym_uint120] = ACTIONS(647),
    [anon_sym_uint128] = ACTIONS(647),
    [anon_sym_uint136] = ACTIONS(647),
    [anon_sym_uint144] = ACTIONS(647),
    [anon_sym_uint152] = ACTIONS(647),
    [anon_sym_uint160] = ACTIONS(647),
    [anon_sym_uint168] = ACTIONS(647),
    [anon_sym_uint176] = ACTIONS(647),
    [anon_sym_uint184] = ACTIONS(647),
    [anon_sym_uint192] = ACTIONS(647),
    [anon_sym_uint200] = ACTIONS(647),
    [anon_sym_uint208] = ACTIONS(647),
    [anon_sym_uint216] = ACTIONS(647),
    [anon_sym_uint224] = ACTIONS(647),
    [anon_sym_uint232] = ACTIONS(647),
    [anon_sym_uint240] = ACTIONS(647),
    [anon_sym_uint248] = ACTIONS(647),
    [anon_sym_uint256] = ACTIONS(647),
    [anon_sym_bytes] = ACTIONS(647),
    [anon_sym_bytes1] = ACTIONS(647),
    [anon_sym_bytes2] = ACTIONS(647),
    [anon_sym_bytes3] = ACTIONS(647),
    [anon_sym_bytes4] = ACTIONS(647),
    [anon_sym_bytes5] = ACTIONS(647),
    [anon_sym_bytes6] = ACTIONS(647),
    [anon_sym_bytes7] = ACTIONS(647),
    [anon_sym_bytes8] = ACTIONS(647),
    [anon_sym_bytes9] = ACTIONS(647),
    [anon_sym_bytes10] = ACTIONS(647),
    [anon_sym_bytes11] = ACTIONS(647),
    [anon_sym_bytes12] = ACTIONS(647),
    [anon_sym_bytes13] = ACTIONS(647),
    [anon_sym_bytes14] = ACTIONS(647),
    [anon_sym_bytes15] = ACTIONS(647),
    [anon_sym_bytes16] = ACTIONS(647),
    [anon_sym_bytes17] = ACTIONS(647),
    [anon_sym_bytes18] = ACTIONS(647),
    [anon_sym_bytes19] = ACTIONS(647),
    [anon_sym_bytes20] = ACTIONS(647),
    [anon_sym_bytes21] = ACTIONS(647),
    [anon_sym_bytes22] = ACTIONS(647),
    [anon_sym_bytes23] = ACTIONS(647),
    [anon_sym_bytes24] = ACTIONS(647),
    [anon_sym_bytes25] = ACTIONS(647),
    [anon_sym_bytes26] = ACTIONS(647),
    [anon_sym_bytes27] = ACTIONS(647),
    [anon_sym_bytes28] = ACTIONS(647),
    [anon_sym_bytes29] = ACTIONS(647),
    [anon_sym_bytes30] = ACTIONS(647),
    [anon_sym_bytes31] = ACTIONS(647),
    [anon_sym_bytes32] = ACTIONS(647),
    [anon_sym_fixed] = ACTIONS(647),
    [aux_sym__fixed_token1] = ACTIONS(647),
    [anon_sym_ufixed] = ACTIONS(647),
    [aux_sym__ufixed_token1] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_identifier] = ACTIONS(773),
    [anon_sym_RBRACE] = ACTIONS(771),
    [anon_sym_type] = ACTIONS(773),
    [anon_sym_error] = ACTIONS(773),
    [anon_sym_struct] = ACTIONS(773),
    [anon_sym_enum] = ACTIONS(773),
    [anon_sym_event] = ACTIONS(773),
    [anon_sym_using] = ACTIONS(773),
    [anon_sym_function] = ACTIONS(773),
    [anon_sym_byte] = ACTIONS(773),
    [anon_sym_address] = ACTIONS(773),
    [anon_sym_var] = ACTIONS(773),
    [anon_sym_modifier] = ACTIONS(773),
    [anon_sym_constructor] = ACTIONS(773),
    [anon_sym_fallback] = ACTIONS(773),
    [anon_sym_receive] = ACTIONS(773),
    [anon_sym_mapping] = ACTIONS(773),
    [anon_sym_bool] = ACTIONS(773),
    [anon_sym_string] = ACTIONS(773),
    [anon_sym_int] = ACTIONS(773),
    [anon_sym_int8] = ACTIONS(773),
    [anon_sym_int16] = ACTIONS(773),
    [anon_sym_int24] = ACTIONS(773),
    [anon_sym_int32] = ACTIONS(773),
    [anon_sym_int40] = ACTIONS(773),
    [anon_sym_int48] = ACTIONS(773),
    [anon_sym_int56] = ACTIONS(773),
    [anon_sym_int64] = ACTIONS(773),
    [anon_sym_int72] = ACTIONS(773),
    [anon_sym_int80] = ACTIONS(773),
    [anon_sym_int88] = ACTIONS(773),
    [anon_sym_int96] = ACTIONS(773),
    [anon_sym_int104] = ACTIONS(773),
    [anon_sym_int112] = ACTIONS(773),
    [anon_sym_int120] = ACTIONS(773),
    [anon_sym_int128] = ACTIONS(773),
    [anon_sym_int136] = ACTIONS(773),
    [anon_sym_int144] = ACTIONS(773),
    [anon_sym_int152] = ACTIONS(773),
    [anon_sym_int160] = ACTIONS(773),
    [anon_sym_int168] = ACTIONS(773),
    [anon_sym_int176] = ACTIONS(773),
    [anon_sym_int184] = ACTIONS(773),
    [anon_sym_int192] = ACTIONS(773),
    [anon_sym_int200] = ACTIONS(773),
    [anon_sym_int208] = ACTIONS(773),
    [anon_sym_int216] = ACTIONS(773),
    [anon_sym_int224] = ACTIONS(773),
    [anon_sym_int232] = ACTIONS(773),
    [anon_sym_int240] = ACTIONS(773),
    [anon_sym_int248] = ACTIONS(773),
    [anon_sym_int256] = ACTIONS(773),
    [anon_sym_uint] = ACTIONS(773),
    [anon_sym_uint8] = ACTIONS(773),
    [anon_sym_uint16] = ACTIONS(773),
    [anon_sym_uint24] = ACTIONS(773),
    [anon_sym_uint32] = ACTIONS(773),
    [anon_sym_uint40] = ACTIONS(773),
    [anon_sym_uint48] = ACTIONS(773),
    [anon_sym_uint56] = ACTIONS(773),
    [anon_sym_uint64] = ACTIONS(773),
    [anon_sym_uint72] = ACTIONS(773),
    [anon_sym_uint80] = ACTIONS(773),
    [anon_sym_uint88] = ACTIONS(773),
    [anon_sym_uint96] = ACTIONS(773),
    [anon_sym_uint104] = ACTIONS(773),
    [anon_sym_uint112] = ACTIONS(773),
    [anon_sym_uint120] = ACTIONS(773),
    [anon_sym_uint128] = ACTIONS(773),
    [anon_sym_uint136] = ACTIONS(773),
    [anon_sym_uint144] = ACTIONS(773),
    [anon_sym_uint152] = ACTIONS(773),
    [anon_sym_uint160] = ACTIONS(773),
    [anon_sym_uint168] = ACTIONS(773),
    [anon_sym_uint176] = ACTIONS(773),
    [anon_sym_uint184] = ACTIONS(773),
    [anon_sym_uint192] = ACTIONS(773),
    [anon_sym_uint200] = ACTIONS(773),
    [anon_sym_uint208] = ACTIONS(773),
    [anon_sym_uint216] = ACTIONS(773),
    [anon_sym_uint224] = ACTIONS(773),
    [anon_sym_uint232] = ACTIONS(773),
    [anon_sym_uint240] = ACTIONS(773),
    [anon_sym_uint248] = ACTIONS(773),
    [anon_sym_uint256] = ACTIONS(773),
    [anon_sym_bytes] = ACTIONS(773),
    [anon_sym_bytes1] = ACTIONS(773),
    [anon_sym_bytes2] = ACTIONS(773),
    [anon_sym_bytes3] = ACTIONS(773),
    [anon_sym_bytes4] = ACTIONS(773),
    [anon_sym_bytes5] = ACTIONS(773),
    [anon_sym_bytes6] = ACTIONS(773),
    [anon_sym_bytes7] = ACTIONS(773),
    [anon_sym_bytes8] = ACTIONS(773),
    [anon_sym_bytes9] = ACTIONS(773),
    [anon_sym_bytes10] = ACTIONS(773),
    [anon_sym_bytes11] = ACTIONS(773),
    [anon_sym_bytes12] = ACTIONS(773),
    [anon_sym_bytes13] = ACTIONS(773),
    [anon_sym_bytes14] = ACTIONS(773),
    [anon_sym_bytes15] = ACTIONS(773),
    [anon_sym_bytes16] = ACTIONS(773),
    [anon_sym_bytes17] = ACTIONS(773),
    [anon_sym_bytes18] = ACTIONS(773),
    [anon_sym_bytes19] = ACTIONS(773),
    [anon_sym_bytes20] = ACTIONS(773),
    [anon_sym_bytes21] = ACTIONS(773),
    [anon_sym_bytes22] = ACTIONS(773),
    [anon_sym_bytes23] = ACTIONS(773),
    [anon_sym_bytes24] = ACTIONS(773),
    [anon_sym_bytes25] = ACTIONS(773),
    [anon_sym_bytes26] = ACTIONS(773),
    [anon_sym_bytes27] = ACTIONS(773),
    [anon_sym_bytes28] = ACTIONS(773),
    [anon_sym_bytes29] = ACTIONS(773),
    [anon_sym_bytes30] = ACTIONS(773),
    [anon_sym_bytes31] = ACTIONS(773),
    [anon_sym_bytes32] = ACTIONS(773),
    [anon_sym_fixed] = ACTIONS(773),
    [aux_sym__fixed_token1] = ACTIONS(773),
    [anon_sym_ufixed] = ACTIONS(773),
    [aux_sym__ufixed_token1] = ACTIONS(773),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_identifier] = ACTIONS(717),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym_type] = ACTIONS(717),
    [anon_sym_error] = ACTIONS(717),
    [anon_sym_struct] = ACTIONS(717),
    [anon_sym_enum] = ACTIONS(717),
    [anon_sym_event] = ACTIONS(717),
    [anon_sym_using] = ACTIONS(717),
    [anon_sym_function] = ACTIONS(717),
    [anon_sym_byte] = ACTIONS(717),
    [anon_sym_address] = ACTIONS(717),
    [anon_sym_var] = ACTIONS(717),
    [anon_sym_modifier] = ACTIONS(717),
    [anon_sym_constructor] = ACTIONS(717),
    [anon_sym_fallback] = ACTIONS(717),
    [anon_sym_receive] = ACTIONS(717),
    [anon_sym_mapping] = ACTIONS(717),
    [anon_sym_bool] = ACTIONS(717),
    [anon_sym_string] = ACTIONS(717),
    [anon_sym_int] = ACTIONS(717),
    [anon_sym_int8] = ACTIONS(717),
    [anon_sym_int16] = ACTIONS(717),
    [anon_sym_int24] = ACTIONS(717),
    [anon_sym_int32] = ACTIONS(717),
    [anon_sym_int40] = ACTIONS(717),
    [anon_sym_int48] = ACTIONS(717),
    [anon_sym_int56] = ACTIONS(717),
    [anon_sym_int64] = ACTIONS(717),
    [anon_sym_int72] = ACTIONS(717),
    [anon_sym_int80] = ACTIONS(717),
    [anon_sym_int88] = ACTIONS(717),
    [anon_sym_int96] = ACTIONS(717),
    [anon_sym_int104] = ACTIONS(717),
    [anon_sym_int112] = ACTIONS(717),
    [anon_sym_int120] = ACTIONS(717),
    [anon_sym_int128] = ACTIONS(717),
    [anon_sym_int136] = ACTIONS(717),
    [anon_sym_int144] = ACTIONS(717),
    [anon_sym_int152] = ACTIONS(717),
    [anon_sym_int160] = ACTIONS(717),
    [anon_sym_int168] = ACTIONS(717),
    [anon_sym_int176] = ACTIONS(717),
    [anon_sym_int184] = ACTIONS(717),
    [anon_sym_int192] = ACTIONS(717),
    [anon_sym_int200] = ACTIONS(717),
    [anon_sym_int208] = ACTIONS(717),
    [anon_sym_int216] = ACTIONS(717),
    [anon_sym_int224] = ACTIONS(717),
    [anon_sym_int232] = ACTIONS(717),
    [anon_sym_int240] = ACTIONS(717),
    [anon_sym_int248] = ACTIONS(717),
    [anon_sym_int256] = ACTIONS(717),
    [anon_sym_uint] = ACTIONS(717),
    [anon_sym_uint8] = ACTIONS(717),
    [anon_sym_uint16] = ACTIONS(717),
    [anon_sym_uint24] = ACTIONS(717),
    [anon_sym_uint32] = ACTIONS(717),
    [anon_sym_uint40] = ACTIONS(717),
    [anon_sym_uint48] = ACTIONS(717),
    [anon_sym_uint56] = ACTIONS(717),
    [anon_sym_uint64] = ACTIONS(717),
    [anon_sym_uint72] = ACTIONS(717),
    [anon_sym_uint80] = ACTIONS(717),
    [anon_sym_uint88] = ACTIONS(717),
    [anon_sym_uint96] = ACTIONS(717),
    [anon_sym_uint104] = ACTIONS(717),
    [anon_sym_uint112] = ACTIONS(717),
    [anon_sym_uint120] = ACTIONS(717),
    [anon_sym_uint128] = ACTIONS(717),
    [anon_sym_uint136] = ACTIONS(717),
    [anon_sym_uint144] = ACTIONS(717),
    [anon_sym_uint152] = ACTIONS(717),
    [anon_sym_uint160] = ACTIONS(717),
    [anon_sym_uint168] = ACTIONS(717),
    [anon_sym_uint176] = ACTIONS(717),
    [anon_sym_uint184] = ACTIONS(717),
    [anon_sym_uint192] = ACTIONS(717),
    [anon_sym_uint200] = ACTIONS(717),
    [anon_sym_uint208] = ACTIONS(717),
    [anon_sym_uint216] = ACTIONS(717),
    [anon_sym_uint224] = ACTIONS(717),
    [anon_sym_uint232] = ACTIONS(717),
    [anon_sym_uint240] = ACTIONS(717),
    [anon_sym_uint248] = ACTIONS(717),
    [anon_sym_uint256] = ACTIONS(717),
    [anon_sym_bytes] = ACTIONS(717),
    [anon_sym_bytes1] = ACTIONS(717),
    [anon_sym_bytes2] = ACTIONS(717),
    [anon_sym_bytes3] = ACTIONS(717),
    [anon_sym_bytes4] = ACTIONS(717),
    [anon_sym_bytes5] = ACTIONS(717),
    [anon_sym_bytes6] = ACTIONS(717),
    [anon_sym_bytes7] = ACTIONS(717),
    [anon_sym_bytes8] = ACTIONS(717),
    [anon_sym_bytes9] = ACTIONS(717),
    [anon_sym_bytes10] = ACTIONS(717),
    [anon_sym_bytes11] = ACTIONS(717),
    [anon_sym_bytes12] = ACTIONS(717),
    [anon_sym_bytes13] = ACTIONS(717),
    [anon_sym_bytes14] = ACTIONS(717),
    [anon_sym_bytes15] = ACTIONS(717),
    [anon_sym_bytes16] = ACTIONS(717),
    [anon_sym_bytes17] = ACTIONS(717),
    [anon_sym_bytes18] = ACTIONS(717),
    [anon_sym_bytes19] = ACTIONS(717),
    [anon_sym_bytes20] = ACTIONS(717),
    [anon_sym_bytes21] = ACTIONS(717),
    [anon_sym_bytes22] = ACTIONS(717),
    [anon_sym_bytes23] = ACTIONS(717),
    [anon_sym_bytes24] = ACTIONS(717),
    [anon_sym_bytes25] = ACTIONS(717),
    [anon_sym_bytes26] = ACTIONS(717),
    [anon_sym_bytes27] = ACTIONS(717),
    [anon_sym_bytes28] = ACTIONS(717),
    [anon_sym_bytes29] = ACTIONS(717),
    [anon_sym_bytes30] = ACTIONS(717),
    [anon_sym_bytes31] = ACTIONS(717),
    [anon_sym_bytes32] = ACTIONS(717),
    [anon_sym_fixed] = ACTIONS(717),
    [aux_sym__fixed_token1] = ACTIONS(717),
    [anon_sym_ufixed] = ACTIONS(717),
    [aux_sym__ufixed_token1] = ACTIONS(717),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_identifier] = ACTIONS(761),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_type] = ACTIONS(761),
    [anon_sym_error] = ACTIONS(761),
    [anon_sym_struct] = ACTIONS(761),
    [anon_sym_enum] = ACTIONS(761),
    [anon_sym_event] = ACTIONS(761),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_function] = ACTIONS(761),
    [anon_sym_byte] = ACTIONS(761),
    [anon_sym_address] = ACTIONS(761),
    [anon_sym_var] = ACTIONS(761),
    [anon_sym_modifier] = ACTIONS(761),
    [anon_sym_constructor] = ACTIONS(761),
    [anon_sym_fallback] = ACTIONS(761),
    [anon_sym_receive] = ACTIONS(761),
    [anon_sym_mapping] = ACTIONS(761),
    [anon_sym_bool] = ACTIONS(761),
    [anon_sym_string] = ACTIONS(761),
    [anon_sym_int] = ACTIONS(761),
    [anon_sym_int8] = ACTIONS(761),
    [anon_sym_int16] = ACTIONS(761),
    [anon_sym_int24] = ACTIONS(761),
    [anon_sym_int32] = ACTIONS(761),
    [anon_sym_int40] = ACTIONS(761),
    [anon_sym_int48] = ACTIONS(761),
    [anon_sym_int56] = ACTIONS(761),
    [anon_sym_int64] = ACTIONS(761),
    [anon_sym_int72] = ACTIONS(761),
    [anon_sym_int80] = ACTIONS(761),
    [anon_sym_int88] = ACTIONS(761),
    [anon_sym_int96] = ACTIONS(761),
    [anon_sym_int104] = ACTIONS(761),
    [anon_sym_int112] = ACTIONS(761),
    [anon_sym_int120] = ACTIONS(761),
    [anon_sym_int128] = ACTIONS(761),
    [anon_sym_int136] = ACTIONS(761),
    [anon_sym_int144] = ACTIONS(761),
    [anon_sym_int152] = ACTIONS(761),
    [anon_sym_int160] = ACTIONS(761),
    [anon_sym_int168] = ACTIONS(761),
    [anon_sym_int176] = ACTIONS(761),
    [anon_sym_int184] = ACTIONS(761),
    [anon_sym_int192] = ACTIONS(761),
    [anon_sym_int200] = ACTIONS(761),
    [anon_sym_int208] = ACTIONS(761),
    [anon_sym_int216] = ACTIONS(761),
    [anon_sym_int224] = ACTIONS(761),
    [anon_sym_int232] = ACTIONS(761),
    [anon_sym_int240] = ACTIONS(761),
    [anon_sym_int248] = ACTIONS(761),
    [anon_sym_int256] = ACTIONS(761),
    [anon_sym_uint] = ACTIONS(761),
    [anon_sym_uint8] = ACTIONS(761),
    [anon_sym_uint16] = ACTIONS(761),
    [anon_sym_uint24] = ACTIONS(761),
    [anon_sym_uint32] = ACTIONS(761),
    [anon_sym_uint40] = ACTIONS(761),
    [anon_sym_uint48] = ACTIONS(761),
    [anon_sym_uint56] = ACTIONS(761),
    [anon_sym_uint64] = ACTIONS(761),
    [anon_sym_uint72] = ACTIONS(761),
    [anon_sym_uint80] = ACTIONS(761),
    [anon_sym_uint88] = ACTIONS(761),
    [anon_sym_uint96] = ACTIONS(761),
    [anon_sym_uint104] = ACTIONS(761),
    [anon_sym_uint112] = ACTIONS(761),
    [anon_sym_uint120] = ACTIONS(761),
    [anon_sym_uint128] = ACTIONS(761),
    [anon_sym_uint136] = ACTIONS(761),
    [anon_sym_uint144] = ACTIONS(761),
    [anon_sym_uint152] = ACTIONS(761),
    [anon_sym_uint160] = ACTIONS(761),
    [anon_sym_uint168] = ACTIONS(761),
    [anon_sym_uint176] = ACTIONS(761),
    [anon_sym_uint184] = ACTIONS(761),
    [anon_sym_uint192] = ACTIONS(761),
    [anon_sym_uint200] = ACTIONS(761),
    [anon_sym_uint208] = ACTIONS(761),
    [anon_sym_uint216] = ACTIONS(761),
    [anon_sym_uint224] = ACTIONS(761),
    [anon_sym_uint232] = ACTIONS(761),
    [anon_sym_uint240] = ACTIONS(761),
    [anon_sym_uint248] = ACTIONS(761),
    [anon_sym_uint256] = ACTIONS(761),
    [anon_sym_bytes] = ACTIONS(761),
    [anon_sym_bytes1] = ACTIONS(761),
    [anon_sym_bytes2] = ACTIONS(761),
    [anon_sym_bytes3] = ACTIONS(761),
    [anon_sym_bytes4] = ACTIONS(761),
    [anon_sym_bytes5] = ACTIONS(761),
    [anon_sym_bytes6] = ACTIONS(761),
    [anon_sym_bytes7] = ACTIONS(761),
    [anon_sym_bytes8] = ACTIONS(761),
    [anon_sym_bytes9] = ACTIONS(761),
    [anon_sym_bytes10] = ACTIONS(761),
    [anon_sym_bytes11] = ACTIONS(761),
    [anon_sym_bytes12] = ACTIONS(761),
    [anon_sym_bytes13] = ACTIONS(761),
    [anon_sym_bytes14] = ACTIONS(761),
    [anon_sym_bytes15] = ACTIONS(761),
    [anon_sym_bytes16] = ACTIONS(761),
    [anon_sym_bytes17] = ACTIONS(761),
    [anon_sym_bytes18] = ACTIONS(761),
    [anon_sym_bytes19] = ACTIONS(761),
    [anon_sym_bytes20] = ACTIONS(761),
    [anon_sym_bytes21] = ACTIONS(761),
    [anon_sym_bytes22] = ACTIONS(761),
    [anon_sym_bytes23] = ACTIONS(761),
    [anon_sym_bytes24] = ACTIONS(761),
    [anon_sym_bytes25] = ACTIONS(761),
    [anon_sym_bytes26] = ACTIONS(761),
    [anon_sym_bytes27] = ACTIONS(761),
    [anon_sym_bytes28] = ACTIONS(761),
    [anon_sym_bytes29] = ACTIONS(761),
    [anon_sym_bytes30] = ACTIONS(761),
    [anon_sym_bytes31] = ACTIONS(761),
    [anon_sym_bytes32] = ACTIONS(761),
    [anon_sym_fixed] = ACTIONS(761),
    [aux_sym__fixed_token1] = ACTIONS(761),
    [anon_sym_ufixed] = ACTIONS(761),
    [aux_sym__ufixed_token1] = ACTIONS(761),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_identifier] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(701),
    [anon_sym_type] = ACTIONS(703),
    [anon_sym_error] = ACTIONS(703),
    [anon_sym_struct] = ACTIONS(703),
    [anon_sym_enum] = ACTIONS(703),
    [anon_sym_event] = ACTIONS(703),
    [anon_sym_using] = ACTIONS(703),
    [anon_sym_function] = ACTIONS(703),
    [anon_sym_byte] = ACTIONS(703),
    [anon_sym_address] = ACTIONS(703),
    [anon_sym_var] = ACTIONS(703),
    [anon_sym_modifier] = ACTIONS(703),
    [anon_sym_constructor] = ACTIONS(703),
    [anon_sym_fallback] = ACTIONS(703),
    [anon_sym_receive] = ACTIONS(703),
    [anon_sym_mapping] = ACTIONS(703),
    [anon_sym_bool] = ACTIONS(703),
    [anon_sym_string] = ACTIONS(703),
    [anon_sym_int] = ACTIONS(703),
    [anon_sym_int8] = ACTIONS(703),
    [anon_sym_int16] = ACTIONS(703),
    [anon_sym_int24] = ACTIONS(703),
    [anon_sym_int32] = ACTIONS(703),
    [anon_sym_int40] = ACTIONS(703),
    [anon_sym_int48] = ACTIONS(703),
    [anon_sym_int56] = ACTIONS(703),
    [anon_sym_int64] = ACTIONS(703),
    [anon_sym_int72] = ACTIONS(703),
    [anon_sym_int80] = ACTIONS(703),
    [anon_sym_int88] = ACTIONS(703),
    [anon_sym_int96] = ACTIONS(703),
    [anon_sym_int104] = ACTIONS(703),
    [anon_sym_int112] = ACTIONS(703),
    [anon_sym_int120] = ACTIONS(703),
    [anon_sym_int128] = ACTIONS(703),
    [anon_sym_int136] = ACTIONS(703),
    [anon_sym_int144] = ACTIONS(703),
    [anon_sym_int152] = ACTIONS(703),
    [anon_sym_int160] = ACTIONS(703),
    [anon_sym_int168] = ACTIONS(703),
    [anon_sym_int176] = ACTIONS(703),
    [anon_sym_int184] = ACTIONS(703),
    [anon_sym_int192] = ACTIONS(703),
    [anon_sym_int200] = ACTIONS(703),
    [anon_sym_int208] = ACTIONS(703),
    [anon_sym_int216] = ACTIONS(703),
    [anon_sym_int224] = ACTIONS(703),
    [anon_sym_int232] = ACTIONS(703),
    [anon_sym_int240] = ACTIONS(703),
    [anon_sym_int248] = ACTIONS(703),
    [anon_sym_int256] = ACTIONS(703),
    [anon_sym_uint] = ACTIONS(703),
    [anon_sym_uint8] = ACTIONS(703),
    [anon_sym_uint16] = ACTIONS(703),
    [anon_sym_uint24] = ACTIONS(703),
    [anon_sym_uint32] = ACTIONS(703),
    [anon_sym_uint40] = ACTIONS(703),
    [anon_sym_uint48] = ACTIONS(703),
    [anon_sym_uint56] = ACTIONS(703),
    [anon_sym_uint64] = ACTIONS(703),
    [anon_sym_uint72] = ACTIONS(703),
    [anon_sym_uint80] = ACTIONS(703),
    [anon_sym_uint88] = ACTIONS(703),
    [anon_sym_uint96] = ACTIONS(703),
    [anon_sym_uint104] = ACTIONS(703),
    [anon_sym_uint112] = ACTIONS(703),
    [anon_sym_uint120] = ACTIONS(703),
    [anon_sym_uint128] = ACTIONS(703),
    [anon_sym_uint136] = ACTIONS(703),
    [anon_sym_uint144] = ACTIONS(703),
    [anon_sym_uint152] = ACTIONS(703),
    [anon_sym_uint160] = ACTIONS(703),
    [anon_sym_uint168] = ACTIONS(703),
    [anon_sym_uint176] = ACTIONS(703),
    [anon_sym_uint184] = ACTIONS(703),
    [anon_sym_uint192] = ACTIONS(703),
    [anon_sym_uint200] = ACTIONS(703),
    [anon_sym_uint208] = ACTIONS(703),
    [anon_sym_uint216] = ACTIONS(703),
    [anon_sym_uint224] = ACTIONS(703),
    [anon_sym_uint232] = ACTIONS(703),
    [anon_sym_uint240] = ACTIONS(703),
    [anon_sym_uint248] = ACTIONS(703),
    [anon_sym_uint256] = ACTIONS(703),
    [anon_sym_bytes] = ACTIONS(703),
    [anon_sym_bytes1] = ACTIONS(703),
    [anon_sym_bytes2] = ACTIONS(703),
    [anon_sym_bytes3] = ACTIONS(703),
    [anon_sym_bytes4] = ACTIONS(703),
    [anon_sym_bytes5] = ACTIONS(703),
    [anon_sym_bytes6] = ACTIONS(703),
    [anon_sym_bytes7] = ACTIONS(703),
    [anon_sym_bytes8] = ACTIONS(703),
    [anon_sym_bytes9] = ACTIONS(703),
    [anon_sym_bytes10] = ACTIONS(703),
    [anon_sym_bytes11] = ACTIONS(703),
    [anon_sym_bytes12] = ACTIONS(703),
    [anon_sym_bytes13] = ACTIONS(703),
    [anon_sym_bytes14] = ACTIONS(703),
    [anon_sym_bytes15] = ACTIONS(703),
    [anon_sym_bytes16] = ACTIONS(703),
    [anon_sym_bytes17] = ACTIONS(703),
    [anon_sym_bytes18] = ACTIONS(703),
    [anon_sym_bytes19] = ACTIONS(703),
    [anon_sym_bytes20] = ACTIONS(703),
    [anon_sym_bytes21] = ACTIONS(703),
    [anon_sym_bytes22] = ACTIONS(703),
    [anon_sym_bytes23] = ACTIONS(703),
    [anon_sym_bytes24] = ACTIONS(703),
    [anon_sym_bytes25] = ACTIONS(703),
    [anon_sym_bytes26] = ACTIONS(703),
    [anon_sym_bytes27] = ACTIONS(703),
    [anon_sym_bytes28] = ACTIONS(703),
    [anon_sym_bytes29] = ACTIONS(703),
    [anon_sym_bytes30] = ACTIONS(703),
    [anon_sym_bytes31] = ACTIONS(703),
    [anon_sym_bytes32] = ACTIONS(703),
    [anon_sym_fixed] = ACTIONS(703),
    [aux_sym__fixed_token1] = ACTIONS(703),
    [anon_sym_ufixed] = ACTIONS(703),
    [aux_sym__ufixed_token1] = ACTIONS(703),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_identifier] = ACTIONS(733),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym_type] = ACTIONS(733),
    [anon_sym_error] = ACTIONS(733),
    [anon_sym_struct] = ACTIONS(733),
    [anon_sym_enum] = ACTIONS(733),
    [anon_sym_event] = ACTIONS(733),
    [anon_sym_using] = ACTIONS(733),
    [anon_sym_function] = ACTIONS(733),
    [anon_sym_byte] = ACTIONS(733),
    [anon_sym_address] = ACTIONS(733),
    [anon_sym_var] = ACTIONS(733),
    [anon_sym_modifier] = ACTIONS(733),
    [anon_sym_constructor] = ACTIONS(733),
    [anon_sym_fallback] = ACTIONS(733),
    [anon_sym_receive] = ACTIONS(733),
    [anon_sym_mapping] = ACTIONS(733),
    [anon_sym_bool] = ACTIONS(733),
    [anon_sym_string] = ACTIONS(733),
    [anon_sym_int] = ACTIONS(733),
    [anon_sym_int8] = ACTIONS(733),
    [anon_sym_int16] = ACTIONS(733),
    [anon_sym_int24] = ACTIONS(733),
    [anon_sym_int32] = ACTIONS(733),
    [anon_sym_int40] = ACTIONS(733),
    [anon_sym_int48] = ACTIONS(733),
    [anon_sym_int56] = ACTIONS(733),
    [anon_sym_int64] = ACTIONS(733),
    [anon_sym_int72] = ACTIONS(733),
    [anon_sym_int80] = ACTIONS(733),
    [anon_sym_int88] = ACTIONS(733),
    [anon_sym_int96] = ACTIONS(733),
    [anon_sym_int104] = ACTIONS(733),
    [anon_sym_int112] = ACTIONS(733),
    [anon_sym_int120] = ACTIONS(733),
    [anon_sym_int128] = ACTIONS(733),
    [anon_sym_int136] = ACTIONS(733),
    [anon_sym_int144] = ACTIONS(733),
    [anon_sym_int152] = ACTIONS(733),
    [anon_sym_int160] = ACTIONS(733),
    [anon_sym_int168] = ACTIONS(733),
    [anon_sym_int176] = ACTIONS(733),
    [anon_sym_int184] = ACTIONS(733),
    [anon_sym_int192] = ACTIONS(733),
    [anon_sym_int200] = ACTIONS(733),
    [anon_sym_int208] = ACTIONS(733),
    [anon_sym_int216] = ACTIONS(733),
    [anon_sym_int224] = ACTIONS(733),
    [anon_sym_int232] = ACTIONS(733),
    [anon_sym_int240] = ACTIONS(733),
    [anon_sym_int248] = ACTIONS(733),
    [anon_sym_int256] = ACTIONS(733),
    [anon_sym_uint] = ACTIONS(733),
    [anon_sym_uint8] = ACTIONS(733),
    [anon_sym_uint16] = ACTIONS(733),
    [anon_sym_uint24] = ACTIONS(733),
    [anon_sym_uint32] = ACTIONS(733),
    [anon_sym_uint40] = ACTIONS(733),
    [anon_sym_uint48] = ACTIONS(733),
    [anon_sym_uint56] = ACTIONS(733),
    [anon_sym_uint64] = ACTIONS(733),
    [anon_sym_uint72] = ACTIONS(733),
    [anon_sym_uint80] = ACTIONS(733),
    [anon_sym_uint88] = ACTIONS(733),
    [anon_sym_uint96] = ACTIONS(733),
    [anon_sym_uint104] = ACTIONS(733),
    [anon_sym_uint112] = ACTIONS(733),
    [anon_sym_uint120] = ACTIONS(733),
    [anon_sym_uint128] = ACTIONS(733),
    [anon_sym_uint136] = ACTIONS(733),
    [anon_sym_uint144] = ACTIONS(733),
    [anon_sym_uint152] = ACTIONS(733),
    [anon_sym_uint160] = ACTIONS(733),
    [anon_sym_uint168] = ACTIONS(733),
    [anon_sym_uint176] = ACTIONS(733),
    [anon_sym_uint184] = ACTIONS(733),
    [anon_sym_uint192] = ACTIONS(733),
    [anon_sym_uint200] = ACTIONS(733),
    [anon_sym_uint208] = ACTIONS(733),
    [anon_sym_uint216] = ACTIONS(733),
    [anon_sym_uint224] = ACTIONS(733),
    [anon_sym_uint232] = ACTIONS(733),
    [anon_sym_uint240] = ACTIONS(733),
    [anon_sym_uint248] = ACTIONS(733),
    [anon_sym_uint256] = ACTIONS(733),
    [anon_sym_bytes] = ACTIONS(733),
    [anon_sym_bytes1] = ACTIONS(733),
    [anon_sym_bytes2] = ACTIONS(733),
    [anon_sym_bytes3] = ACTIONS(733),
    [anon_sym_bytes4] = ACTIONS(733),
    [anon_sym_bytes5] = ACTIONS(733),
    [anon_sym_bytes6] = ACTIONS(733),
    [anon_sym_bytes7] = ACTIONS(733),
    [anon_sym_bytes8] = ACTIONS(733),
    [anon_sym_bytes9] = ACTIONS(733),
    [anon_sym_bytes10] = ACTIONS(733),
    [anon_sym_bytes11] = ACTIONS(733),
    [anon_sym_bytes12] = ACTIONS(733),
    [anon_sym_bytes13] = ACTIONS(733),
    [anon_sym_bytes14] = ACTIONS(733),
    [anon_sym_bytes15] = ACTIONS(733),
    [anon_sym_bytes16] = ACTIONS(733),
    [anon_sym_bytes17] = ACTIONS(733),
    [anon_sym_bytes18] = ACTIONS(733),
    [anon_sym_bytes19] = ACTIONS(733),
    [anon_sym_bytes20] = ACTIONS(733),
    [anon_sym_bytes21] = ACTIONS(733),
    [anon_sym_bytes22] = ACTIONS(733),
    [anon_sym_bytes23] = ACTIONS(733),
    [anon_sym_bytes24] = ACTIONS(733),
    [anon_sym_bytes25] = ACTIONS(733),
    [anon_sym_bytes26] = ACTIONS(733),
    [anon_sym_bytes27] = ACTIONS(733),
    [anon_sym_bytes28] = ACTIONS(733),
    [anon_sym_bytes29] = ACTIONS(733),
    [anon_sym_bytes30] = ACTIONS(733),
    [anon_sym_bytes31] = ACTIONS(733),
    [anon_sym_bytes32] = ACTIONS(733),
    [anon_sym_fixed] = ACTIONS(733),
    [aux_sym__fixed_token1] = ACTIONS(733),
    [anon_sym_ufixed] = ACTIONS(733),
    [aux_sym__ufixed_token1] = ACTIONS(733),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_identifier] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym_type] = ACTIONS(737),
    [anon_sym_error] = ACTIONS(737),
    [anon_sym_struct] = ACTIONS(737),
    [anon_sym_enum] = ACTIONS(737),
    [anon_sym_event] = ACTIONS(737),
    [anon_sym_using] = ACTIONS(737),
    [anon_sym_function] = ACTIONS(737),
    [anon_sym_byte] = ACTIONS(737),
    [anon_sym_address] = ACTIONS(737),
    [anon_sym_var] = ACTIONS(737),
    [anon_sym_modifier] = ACTIONS(737),
    [anon_sym_constructor] = ACTIONS(737),
    [anon_sym_fallback] = ACTIONS(737),
    [anon_sym_receive] = ACTIONS(737),
    [anon_sym_mapping] = ACTIONS(737),
    [anon_sym_bool] = ACTIONS(737),
    [anon_sym_string] = ACTIONS(737),
    [anon_sym_int] = ACTIONS(737),
    [anon_sym_int8] = ACTIONS(737),
    [anon_sym_int16] = ACTIONS(737),
    [anon_sym_int24] = ACTIONS(737),
    [anon_sym_int32] = ACTIONS(737),
    [anon_sym_int40] = ACTIONS(737),
    [anon_sym_int48] = ACTIONS(737),
    [anon_sym_int56] = ACTIONS(737),
    [anon_sym_int64] = ACTIONS(737),
    [anon_sym_int72] = ACTIONS(737),
    [anon_sym_int80] = ACTIONS(737),
    [anon_sym_int88] = ACTIONS(737),
    [anon_sym_int96] = ACTIONS(737),
    [anon_sym_int104] = ACTIONS(737),
    [anon_sym_int112] = ACTIONS(737),
    [anon_sym_int120] = ACTIONS(737),
    [anon_sym_int128] = ACTIONS(737),
    [anon_sym_int136] = ACTIONS(737),
    [anon_sym_int144] = ACTIONS(737),
    [anon_sym_int152] = ACTIONS(737),
    [anon_sym_int160] = ACTIONS(737),
    [anon_sym_int168] = ACTIONS(737),
    [anon_sym_int176] = ACTIONS(737),
    [anon_sym_int184] = ACTIONS(737),
    [anon_sym_int192] = ACTIONS(737),
    [anon_sym_int200] = ACTIONS(737),
    [anon_sym_int208] = ACTIONS(737),
    [anon_sym_int216] = ACTIONS(737),
    [anon_sym_int224] = ACTIONS(737),
    [anon_sym_int232] = ACTIONS(737),
    [anon_sym_int240] = ACTIONS(737),
    [anon_sym_int248] = ACTIONS(737),
    [anon_sym_int256] = ACTIONS(737),
    [anon_sym_uint] = ACTIONS(737),
    [anon_sym_uint8] = ACTIONS(737),
    [anon_sym_uint16] = ACTIONS(737),
    [anon_sym_uint24] = ACTIONS(737),
    [anon_sym_uint32] = ACTIONS(737),
    [anon_sym_uint40] = ACTIONS(737),
    [anon_sym_uint48] = ACTIONS(737),
    [anon_sym_uint56] = ACTIONS(737),
    [anon_sym_uint64] = ACTIONS(737),
    [anon_sym_uint72] = ACTIONS(737),
    [anon_sym_uint80] = ACTIONS(737),
    [anon_sym_uint88] = ACTIONS(737),
    [anon_sym_uint96] = ACTIONS(737),
    [anon_sym_uint104] = ACTIONS(737),
    [anon_sym_uint112] = ACTIONS(737),
    [anon_sym_uint120] = ACTIONS(737),
    [anon_sym_uint128] = ACTIONS(737),
    [anon_sym_uint136] = ACTIONS(737),
    [anon_sym_uint144] = ACTIONS(737),
    [anon_sym_uint152] = ACTIONS(737),
    [anon_sym_uint160] = ACTIONS(737),
    [anon_sym_uint168] = ACTIONS(737),
    [anon_sym_uint176] = ACTIONS(737),
    [anon_sym_uint184] = ACTIONS(737),
    [anon_sym_uint192] = ACTIONS(737),
    [anon_sym_uint200] = ACTIONS(737),
    [anon_sym_uint208] = ACTIONS(737),
    [anon_sym_uint216] = ACTIONS(737),
    [anon_sym_uint224] = ACTIONS(737),
    [anon_sym_uint232] = ACTIONS(737),
    [anon_sym_uint240] = ACTIONS(737),
    [anon_sym_uint248] = ACTIONS(737),
    [anon_sym_uint256] = ACTIONS(737),
    [anon_sym_bytes] = ACTIONS(737),
    [anon_sym_bytes1] = ACTIONS(737),
    [anon_sym_bytes2] = ACTIONS(737),
    [anon_sym_bytes3] = ACTIONS(737),
    [anon_sym_bytes4] = ACTIONS(737),
    [anon_sym_bytes5] = ACTIONS(737),
    [anon_sym_bytes6] = ACTIONS(737),
    [anon_sym_bytes7] = ACTIONS(737),
    [anon_sym_bytes8] = ACTIONS(737),
    [anon_sym_bytes9] = ACTIONS(737),
    [anon_sym_bytes10] = ACTIONS(737),
    [anon_sym_bytes11] = ACTIONS(737),
    [anon_sym_bytes12] = ACTIONS(737),
    [anon_sym_bytes13] = ACTIONS(737),
    [anon_sym_bytes14] = ACTIONS(737),
    [anon_sym_bytes15] = ACTIONS(737),
    [anon_sym_bytes16] = ACTIONS(737),
    [anon_sym_bytes17] = ACTIONS(737),
    [anon_sym_bytes18] = ACTIONS(737),
    [anon_sym_bytes19] = ACTIONS(737),
    [anon_sym_bytes20] = ACTIONS(737),
    [anon_sym_bytes21] = ACTIONS(737),
    [anon_sym_bytes22] = ACTIONS(737),
    [anon_sym_bytes23] = ACTIONS(737),
    [anon_sym_bytes24] = ACTIONS(737),
    [anon_sym_bytes25] = ACTIONS(737),
    [anon_sym_bytes26] = ACTIONS(737),
    [anon_sym_bytes27] = ACTIONS(737),
    [anon_sym_bytes28] = ACTIONS(737),
    [anon_sym_bytes29] = ACTIONS(737),
    [anon_sym_bytes30] = ACTIONS(737),
    [anon_sym_bytes31] = ACTIONS(737),
    [anon_sym_bytes32] = ACTIONS(737),
    [anon_sym_fixed] = ACTIONS(737),
    [aux_sym__fixed_token1] = ACTIONS(737),
    [anon_sym_ufixed] = ACTIONS(737),
    [aux_sym__ufixed_token1] = ACTIONS(737),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_identifier] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym_type] = ACTIONS(753),
    [anon_sym_error] = ACTIONS(753),
    [anon_sym_struct] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(753),
    [anon_sym_event] = ACTIONS(753),
    [anon_sym_using] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(753),
    [anon_sym_byte] = ACTIONS(753),
    [anon_sym_address] = ACTIONS(753),
    [anon_sym_var] = ACTIONS(753),
    [anon_sym_modifier] = ACTIONS(753),
    [anon_sym_constructor] = ACTIONS(753),
    [anon_sym_fallback] = ACTIONS(753),
    [anon_sym_receive] = ACTIONS(753),
    [anon_sym_mapping] = ACTIONS(753),
    [anon_sym_bool] = ACTIONS(753),
    [anon_sym_string] = ACTIONS(753),
    [anon_sym_int] = ACTIONS(753),
    [anon_sym_int8] = ACTIONS(753),
    [anon_sym_int16] = ACTIONS(753),
    [anon_sym_int24] = ACTIONS(753),
    [anon_sym_int32] = ACTIONS(753),
    [anon_sym_int40] = ACTIONS(753),
    [anon_sym_int48] = ACTIONS(753),
    [anon_sym_int56] = ACTIONS(753),
    [anon_sym_int64] = ACTIONS(753),
    [anon_sym_int72] = ACTIONS(753),
    [anon_sym_int80] = ACTIONS(753),
    [anon_sym_int88] = ACTIONS(753),
    [anon_sym_int96] = ACTIONS(753),
    [anon_sym_int104] = ACTIONS(753),
    [anon_sym_int112] = ACTIONS(753),
    [anon_sym_int120] = ACTIONS(753),
    [anon_sym_int128] = ACTIONS(753),
    [anon_sym_int136] = ACTIONS(753),
    [anon_sym_int144] = ACTIONS(753),
    [anon_sym_int152] = ACTIONS(753),
    [anon_sym_int160] = ACTIONS(753),
    [anon_sym_int168] = ACTIONS(753),
    [anon_sym_int176] = ACTIONS(753),
    [anon_sym_int184] = ACTIONS(753),
    [anon_sym_int192] = ACTIONS(753),
    [anon_sym_int200] = ACTIONS(753),
    [anon_sym_int208] = ACTIONS(753),
    [anon_sym_int216] = ACTIONS(753),
    [anon_sym_int224] = ACTIONS(753),
    [anon_sym_int232] = ACTIONS(753),
    [anon_sym_int240] = ACTIONS(753),
    [anon_sym_int248] = ACTIONS(753),
    [anon_sym_int256] = ACTIONS(753),
    [anon_sym_uint] = ACTIONS(753),
    [anon_sym_uint8] = ACTIONS(753),
    [anon_sym_uint16] = ACTIONS(753),
    [anon_sym_uint24] = ACTIONS(753),
    [anon_sym_uint32] = ACTIONS(753),
    [anon_sym_uint40] = ACTIONS(753),
    [anon_sym_uint48] = ACTIONS(753),
    [anon_sym_uint56] = ACTIONS(753),
    [anon_sym_uint64] = ACTIONS(753),
    [anon_sym_uint72] = ACTIONS(753),
    [anon_sym_uint80] = ACTIONS(753),
    [anon_sym_uint88] = ACTIONS(753),
    [anon_sym_uint96] = ACTIONS(753),
    [anon_sym_uint104] = ACTIONS(753),
    [anon_sym_uint112] = ACTIONS(753),
    [anon_sym_uint120] = ACTIONS(753),
    [anon_sym_uint128] = ACTIONS(753),
    [anon_sym_uint136] = ACTIONS(753),
    [anon_sym_uint144] = ACTIONS(753),
    [anon_sym_uint152] = ACTIONS(753),
    [anon_sym_uint160] = ACTIONS(753),
    [anon_sym_uint168] = ACTIONS(753),
    [anon_sym_uint176] = ACTIONS(753),
    [anon_sym_uint184] = ACTIONS(753),
    [anon_sym_uint192] = ACTIONS(753),
    [anon_sym_uint200] = ACTIONS(753),
    [anon_sym_uint208] = ACTIONS(753),
    [anon_sym_uint216] = ACTIONS(753),
    [anon_sym_uint224] = ACTIONS(753),
    [anon_sym_uint232] = ACTIONS(753),
    [anon_sym_uint240] = ACTIONS(753),
    [anon_sym_uint248] = ACTIONS(753),
    [anon_sym_uint256] = ACTIONS(753),
    [anon_sym_bytes] = ACTIONS(753),
    [anon_sym_bytes1] = ACTIONS(753),
    [anon_sym_bytes2] = ACTIONS(753),
    [anon_sym_bytes3] = ACTIONS(753),
    [anon_sym_bytes4] = ACTIONS(753),
    [anon_sym_bytes5] = ACTIONS(753),
    [anon_sym_bytes6] = ACTIONS(753),
    [anon_sym_bytes7] = ACTIONS(753),
    [anon_sym_bytes8] = ACTIONS(753),
    [anon_sym_bytes9] = ACTIONS(753),
    [anon_sym_bytes10] = ACTIONS(753),
    [anon_sym_bytes11] = ACTIONS(753),
    [anon_sym_bytes12] = ACTIONS(753),
    [anon_sym_bytes13] = ACTIONS(753),
    [anon_sym_bytes14] = ACTIONS(753),
    [anon_sym_bytes15] = ACTIONS(753),
    [anon_sym_bytes16] = ACTIONS(753),
    [anon_sym_bytes17] = ACTIONS(753),
    [anon_sym_bytes18] = ACTIONS(753),
    [anon_sym_bytes19] = ACTIONS(753),
    [anon_sym_bytes20] = ACTIONS(753),
    [anon_sym_bytes21] = ACTIONS(753),
    [anon_sym_bytes22] = ACTIONS(753),
    [anon_sym_bytes23] = ACTIONS(753),
    [anon_sym_bytes24] = ACTIONS(753),
    [anon_sym_bytes25] = ACTIONS(753),
    [anon_sym_bytes26] = ACTIONS(753),
    [anon_sym_bytes27] = ACTIONS(753),
    [anon_sym_bytes28] = ACTIONS(753),
    [anon_sym_bytes29] = ACTIONS(753),
    [anon_sym_bytes30] = ACTIONS(753),
    [anon_sym_bytes31] = ACTIONS(753),
    [anon_sym_bytes32] = ACTIONS(753),
    [anon_sym_fixed] = ACTIONS(753),
    [aux_sym__fixed_token1] = ACTIONS(753),
    [anon_sym_ufixed] = ACTIONS(753),
    [aux_sym__ufixed_token1] = ACTIONS(753),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_identifier] = ACTIONS(671),
    [anon_sym_RBRACE] = ACTIONS(669),
    [anon_sym_type] = ACTIONS(671),
    [anon_sym_error] = ACTIONS(671),
    [anon_sym_struct] = ACTIONS(671),
    [anon_sym_enum] = ACTIONS(671),
    [anon_sym_event] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(671),
    [anon_sym_function] = ACTIONS(671),
    [anon_sym_byte] = ACTIONS(671),
    [anon_sym_address] = ACTIONS(671),
    [anon_sym_var] = ACTIONS(671),
    [anon_sym_modifier] = ACTIONS(671),
    [anon_sym_constructor] = ACTIONS(671),
    [anon_sym_fallback] = ACTIONS(671),
    [anon_sym_receive] = ACTIONS(671),
    [anon_sym_mapping] = ACTIONS(671),
    [anon_sym_bool] = ACTIONS(671),
    [anon_sym_string] = ACTIONS(671),
    [anon_sym_int] = ACTIONS(671),
    [anon_sym_int8] = ACTIONS(671),
    [anon_sym_int16] = ACTIONS(671),
    [anon_sym_int24] = ACTIONS(671),
    [anon_sym_int32] = ACTIONS(671),
    [anon_sym_int40] = ACTIONS(671),
    [anon_sym_int48] = ACTIONS(671),
    [anon_sym_int56] = ACTIONS(671),
    [anon_sym_int64] = ACTIONS(671),
    [anon_sym_int72] = ACTIONS(671),
    [anon_sym_int80] = ACTIONS(671),
    [anon_sym_int88] = ACTIONS(671),
    [anon_sym_int96] = ACTIONS(671),
    [anon_sym_int104] = ACTIONS(671),
    [anon_sym_int112] = ACTIONS(671),
    [anon_sym_int120] = ACTIONS(671),
    [anon_sym_int128] = ACTIONS(671),
    [anon_sym_int136] = ACTIONS(671),
    [anon_sym_int144] = ACTIONS(671),
    [anon_sym_int152] = ACTIONS(671),
    [anon_sym_int160] = ACTIONS(671),
    [anon_sym_int168] = ACTIONS(671),
    [anon_sym_int176] = ACTIONS(671),
    [anon_sym_int184] = ACTIONS(671),
    [anon_sym_int192] = ACTIONS(671),
    [anon_sym_int200] = ACTIONS(671),
    [anon_sym_int208] = ACTIONS(671),
    [anon_sym_int216] = ACTIONS(671),
    [anon_sym_int224] = ACTIONS(671),
    [anon_sym_int232] = ACTIONS(671),
    [anon_sym_int240] = ACTIONS(671),
    [anon_sym_int248] = ACTIONS(671),
    [anon_sym_int256] = ACTIONS(671),
    [anon_sym_uint] = ACTIONS(671),
    [anon_sym_uint8] = ACTIONS(671),
    [anon_sym_uint16] = ACTIONS(671),
    [anon_sym_uint24] = ACTIONS(671),
    [anon_sym_uint32] = ACTIONS(671),
    [anon_sym_uint40] = ACTIONS(671),
    [anon_sym_uint48] = ACTIONS(671),
    [anon_sym_uint56] = ACTIONS(671),
    [anon_sym_uint64] = ACTIONS(671),
    [anon_sym_uint72] = ACTIONS(671),
    [anon_sym_uint80] = ACTIONS(671),
    [anon_sym_uint88] = ACTIONS(671),
    [anon_sym_uint96] = ACTIONS(671),
    [anon_sym_uint104] = ACTIONS(671),
    [anon_sym_uint112] = ACTIONS(671),
    [anon_sym_uint120] = ACTIONS(671),
    [anon_sym_uint128] = ACTIONS(671),
    [anon_sym_uint136] = ACTIONS(671),
    [anon_sym_uint144] = ACTIONS(671),
    [anon_sym_uint152] = ACTIONS(671),
    [anon_sym_uint160] = ACTIONS(671),
    [anon_sym_uint168] = ACTIONS(671),
    [anon_sym_uint176] = ACTIONS(671),
    [anon_sym_uint184] = ACTIONS(671),
    [anon_sym_uint192] = ACTIONS(671),
    [anon_sym_uint200] = ACTIONS(671),
    [anon_sym_uint208] = ACTIONS(671),
    [anon_sym_uint216] = ACTIONS(671),
    [anon_sym_uint224] = ACTIONS(671),
    [anon_sym_uint232] = ACTIONS(671),
    [anon_sym_uint240] = ACTIONS(671),
    [anon_sym_uint248] = ACTIONS(671),
    [anon_sym_uint256] = ACTIONS(671),
    [anon_sym_bytes] = ACTIONS(671),
    [anon_sym_bytes1] = ACTIONS(671),
    [anon_sym_bytes2] = ACTIONS(671),
    [anon_sym_bytes3] = ACTIONS(671),
    [anon_sym_bytes4] = ACTIONS(671),
    [anon_sym_bytes5] = ACTIONS(671),
    [anon_sym_bytes6] = ACTIONS(671),
    [anon_sym_bytes7] = ACTIONS(671),
    [anon_sym_bytes8] = ACTIONS(671),
    [anon_sym_bytes9] = ACTIONS(671),
    [anon_sym_bytes10] = ACTIONS(671),
    [anon_sym_bytes11] = ACTIONS(671),
    [anon_sym_bytes12] = ACTIONS(671),
    [anon_sym_bytes13] = ACTIONS(671),
    [anon_sym_bytes14] = ACTIONS(671),
    [anon_sym_bytes15] = ACTIONS(671),
    [anon_sym_bytes16] = ACTIONS(671),
    [anon_sym_bytes17] = ACTIONS(671),
    [anon_sym_bytes18] = ACTIONS(671),
    [anon_sym_bytes19] = ACTIONS(671),
    [anon_sym_bytes20] = ACTIONS(671),
    [anon_sym_bytes21] = ACTIONS(671),
    [anon_sym_bytes22] = ACTIONS(671),
    [anon_sym_bytes23] = ACTIONS(671),
    [anon_sym_bytes24] = ACTIONS(671),
    [anon_sym_bytes25] = ACTIONS(671),
    [anon_sym_bytes26] = ACTIONS(671),
    [anon_sym_bytes27] = ACTIONS(671),
    [anon_sym_bytes28] = ACTIONS(671),
    [anon_sym_bytes29] = ACTIONS(671),
    [anon_sym_bytes30] = ACTIONS(671),
    [anon_sym_bytes31] = ACTIONS(671),
    [anon_sym_bytes32] = ACTIONS(671),
    [anon_sym_fixed] = ACTIONS(671),
    [aux_sym__fixed_token1] = ACTIONS(671),
    [anon_sym_ufixed] = ACTIONS(671),
    [aux_sym__ufixed_token1] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_type] = ACTIONS(691),
    [anon_sym_error] = ACTIONS(691),
    [anon_sym_struct] = ACTIONS(691),
    [anon_sym_enum] = ACTIONS(691),
    [anon_sym_event] = ACTIONS(691),
    [anon_sym_using] = ACTIONS(691),
    [anon_sym_function] = ACTIONS(691),
    [anon_sym_byte] = ACTIONS(691),
    [anon_sym_address] = ACTIONS(691),
    [anon_sym_var] = ACTIONS(691),
    [anon_sym_modifier] = ACTIONS(691),
    [anon_sym_constructor] = ACTIONS(691),
    [anon_sym_fallback] = ACTIONS(691),
    [anon_sym_receive] = ACTIONS(691),
    [anon_sym_mapping] = ACTIONS(691),
    [anon_sym_bool] = ACTIONS(691),
    [anon_sym_string] = ACTIONS(691),
    [anon_sym_int] = ACTIONS(691),
    [anon_sym_int8] = ACTIONS(691),
    [anon_sym_int16] = ACTIONS(691),
    [anon_sym_int24] = ACTIONS(691),
    [anon_sym_int32] = ACTIONS(691),
    [anon_sym_int40] = ACTIONS(691),
    [anon_sym_int48] = ACTIONS(691),
    [anon_sym_int56] = ACTIONS(691),
    [anon_sym_int64] = ACTIONS(691),
    [anon_sym_int72] = ACTIONS(691),
    [anon_sym_int80] = ACTIONS(691),
    [anon_sym_int88] = ACTIONS(691),
    [anon_sym_int96] = ACTIONS(691),
    [anon_sym_int104] = ACTIONS(691),
    [anon_sym_int112] = ACTIONS(691),
    [anon_sym_int120] = ACTIONS(691),
    [anon_sym_int128] = ACTIONS(691),
    [anon_sym_int136] = ACTIONS(691),
    [anon_sym_int144] = ACTIONS(691),
    [anon_sym_int152] = ACTIONS(691),
    [anon_sym_int160] = ACTIONS(691),
    [anon_sym_int168] = ACTIONS(691),
    [anon_sym_int176] = ACTIONS(691),
    [anon_sym_int184] = ACTIONS(691),
    [anon_sym_int192] = ACTIONS(691),
    [anon_sym_int200] = ACTIONS(691),
    [anon_sym_int208] = ACTIONS(691),
    [anon_sym_int216] = ACTIONS(691),
    [anon_sym_int224] = ACTIONS(691),
    [anon_sym_int232] = ACTIONS(691),
    [anon_sym_int240] = ACTIONS(691),
    [anon_sym_int248] = ACTIONS(691),
    [anon_sym_int256] = ACTIONS(691),
    [anon_sym_uint] = ACTIONS(691),
    [anon_sym_uint8] = ACTIONS(691),
    [anon_sym_uint16] = ACTIONS(691),
    [anon_sym_uint24] = ACTIONS(691),
    [anon_sym_uint32] = ACTIONS(691),
    [anon_sym_uint40] = ACTIONS(691),
    [anon_sym_uint48] = ACTIONS(691),
    [anon_sym_uint56] = ACTIONS(691),
    [anon_sym_uint64] = ACTIONS(691),
    [anon_sym_uint72] = ACTIONS(691),
    [anon_sym_uint80] = ACTIONS(691),
    [anon_sym_uint88] = ACTIONS(691),
    [anon_sym_uint96] = ACTIONS(691),
    [anon_sym_uint104] = ACTIONS(691),
    [anon_sym_uint112] = ACTIONS(691),
    [anon_sym_uint120] = ACTIONS(691),
    [anon_sym_uint128] = ACTIONS(691),
    [anon_sym_uint136] = ACTIONS(691),
    [anon_sym_uint144] = ACTIONS(691),
    [anon_sym_uint152] = ACTIONS(691),
    [anon_sym_uint160] = ACTIONS(691),
    [anon_sym_uint168] = ACTIONS(691),
    [anon_sym_uint176] = ACTIONS(691),
    [anon_sym_uint184] = ACTIONS(691),
    [anon_sym_uint192] = ACTIONS(691),
    [anon_sym_uint200] = ACTIONS(691),
    [anon_sym_uint208] = ACTIONS(691),
    [anon_sym_uint216] = ACTIONS(691),
    [anon_sym_uint224] = ACTIONS(691),
    [anon_sym_uint232] = ACTIONS(691),
    [anon_sym_uint240] = ACTIONS(691),
    [anon_sym_uint248] = ACTIONS(691),
    [anon_sym_uint256] = ACTIONS(691),
    [anon_sym_bytes] = ACTIONS(691),
    [anon_sym_bytes1] = ACTIONS(691),
    [anon_sym_bytes2] = ACTIONS(691),
    [anon_sym_bytes3] = ACTIONS(691),
    [anon_sym_bytes4] = ACTIONS(691),
    [anon_sym_bytes5] = ACTIONS(691),
    [anon_sym_bytes6] = ACTIONS(691),
    [anon_sym_bytes7] = ACTIONS(691),
    [anon_sym_bytes8] = ACTIONS(691),
    [anon_sym_bytes9] = ACTIONS(691),
    [anon_sym_bytes10] = ACTIONS(691),
    [anon_sym_bytes11] = ACTIONS(691),
    [anon_sym_bytes12] = ACTIONS(691),
    [anon_sym_bytes13] = ACTIONS(691),
    [anon_sym_bytes14] = ACTIONS(691),
    [anon_sym_bytes15] = ACTIONS(691),
    [anon_sym_bytes16] = ACTIONS(691),
    [anon_sym_bytes17] = ACTIONS(691),
    [anon_sym_bytes18] = ACTIONS(691),
    [anon_sym_bytes19] = ACTIONS(691),
    [anon_sym_bytes20] = ACTIONS(691),
    [anon_sym_bytes21] = ACTIONS(691),
    [anon_sym_bytes22] = ACTIONS(691),
    [anon_sym_bytes23] = ACTIONS(691),
    [anon_sym_bytes24] = ACTIONS(691),
    [anon_sym_bytes25] = ACTIONS(691),
    [anon_sym_bytes26] = ACTIONS(691),
    [anon_sym_bytes27] = ACTIONS(691),
    [anon_sym_bytes28] = ACTIONS(691),
    [anon_sym_bytes29] = ACTIONS(691),
    [anon_sym_bytes30] = ACTIONS(691),
    [anon_sym_bytes31] = ACTIONS(691),
    [anon_sym_bytes32] = ACTIONS(691),
    [anon_sym_fixed] = ACTIONS(691),
    [aux_sym__fixed_token1] = ACTIONS(691),
    [anon_sym_ufixed] = ACTIONS(691),
    [aux_sym__ufixed_token1] = ACTIONS(691),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_identifier] = ACTIONS(745),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym_type] = ACTIONS(745),
    [anon_sym_error] = ACTIONS(745),
    [anon_sym_struct] = ACTIONS(745),
    [anon_sym_enum] = ACTIONS(745),
    [anon_sym_event] = ACTIONS(745),
    [anon_sym_using] = ACTIONS(745),
    [anon_sym_function] = ACTIONS(745),
    [anon_sym_byte] = ACTIONS(745),
    [anon_sym_address] = ACTIONS(745),
    [anon_sym_var] = ACTIONS(745),
    [anon_sym_modifier] = ACTIONS(745),
    [anon_sym_constructor] = ACTIONS(745),
    [anon_sym_fallback] = ACTIONS(745),
    [anon_sym_receive] = ACTIONS(745),
    [anon_sym_mapping] = ACTIONS(745),
    [anon_sym_bool] = ACTIONS(745),
    [anon_sym_string] = ACTIONS(745),
    [anon_sym_int] = ACTIONS(745),
    [anon_sym_int8] = ACTIONS(745),
    [anon_sym_int16] = ACTIONS(745),
    [anon_sym_int24] = ACTIONS(745),
    [anon_sym_int32] = ACTIONS(745),
    [anon_sym_int40] = ACTIONS(745),
    [anon_sym_int48] = ACTIONS(745),
    [anon_sym_int56] = ACTIONS(745),
    [anon_sym_int64] = ACTIONS(745),
    [anon_sym_int72] = ACTIONS(745),
    [anon_sym_int80] = ACTIONS(745),
    [anon_sym_int88] = ACTIONS(745),
    [anon_sym_int96] = ACTIONS(745),
    [anon_sym_int104] = ACTIONS(745),
    [anon_sym_int112] = ACTIONS(745),
    [anon_sym_int120] = ACTIONS(745),
    [anon_sym_int128] = ACTIONS(745),
    [anon_sym_int136] = ACTIONS(745),
    [anon_sym_int144] = ACTIONS(745),
    [anon_sym_int152] = ACTIONS(745),
    [anon_sym_int160] = ACTIONS(745),
    [anon_sym_int168] = ACTIONS(745),
    [anon_sym_int176] = ACTIONS(745),
    [anon_sym_int184] = ACTIONS(745),
    [anon_sym_int192] = ACTIONS(745),
    [anon_sym_int200] = ACTIONS(745),
    [anon_sym_int208] = ACTIONS(745),
    [anon_sym_int216] = ACTIONS(745),
    [anon_sym_int224] = ACTIONS(745),
    [anon_sym_int232] = ACTIONS(745),
    [anon_sym_int240] = ACTIONS(745),
    [anon_sym_int248] = ACTIONS(745),
    [anon_sym_int256] = ACTIONS(745),
    [anon_sym_uint] = ACTIONS(745),
    [anon_sym_uint8] = ACTIONS(745),
    [anon_sym_uint16] = ACTIONS(745),
    [anon_sym_uint24] = ACTIONS(745),
    [anon_sym_uint32] = ACTIONS(745),
    [anon_sym_uint40] = ACTIONS(745),
    [anon_sym_uint48] = ACTIONS(745),
    [anon_sym_uint56] = ACTIONS(745),
    [anon_sym_uint64] = ACTIONS(745),
    [anon_sym_uint72] = ACTIONS(745),
    [anon_sym_uint80] = ACTIONS(745),
    [anon_sym_uint88] = ACTIONS(745),
    [anon_sym_uint96] = ACTIONS(745),
    [anon_sym_uint104] = ACTIONS(745),
    [anon_sym_uint112] = ACTIONS(745),
    [anon_sym_uint120] = ACTIONS(745),
    [anon_sym_uint128] = ACTIONS(745),
    [anon_sym_uint136] = ACTIONS(745),
    [anon_sym_uint144] = ACTIONS(745),
    [anon_sym_uint152] = ACTIONS(745),
    [anon_sym_uint160] = ACTIONS(745),
    [anon_sym_uint168] = ACTIONS(745),
    [anon_sym_uint176] = ACTIONS(745),
    [anon_sym_uint184] = ACTIONS(745),
    [anon_sym_uint192] = ACTIONS(745),
    [anon_sym_uint200] = ACTIONS(745),
    [anon_sym_uint208] = ACTIONS(745),
    [anon_sym_uint216] = ACTIONS(745),
    [anon_sym_uint224] = ACTIONS(745),
    [anon_sym_uint232] = ACTIONS(745),
    [anon_sym_uint240] = ACTIONS(745),
    [anon_sym_uint248] = ACTIONS(745),
    [anon_sym_uint256] = ACTIONS(745),
    [anon_sym_bytes] = ACTIONS(745),
    [anon_sym_bytes1] = ACTIONS(745),
    [anon_sym_bytes2] = ACTIONS(745),
    [anon_sym_bytes3] = ACTIONS(745),
    [anon_sym_bytes4] = ACTIONS(745),
    [anon_sym_bytes5] = ACTIONS(745),
    [anon_sym_bytes6] = ACTIONS(745),
    [anon_sym_bytes7] = ACTIONS(745),
    [anon_sym_bytes8] = ACTIONS(745),
    [anon_sym_bytes9] = ACTIONS(745),
    [anon_sym_bytes10] = ACTIONS(745),
    [anon_sym_bytes11] = ACTIONS(745),
    [anon_sym_bytes12] = ACTIONS(745),
    [anon_sym_bytes13] = ACTIONS(745),
    [anon_sym_bytes14] = ACTIONS(745),
    [anon_sym_bytes15] = ACTIONS(745),
    [anon_sym_bytes16] = ACTIONS(745),
    [anon_sym_bytes17] = ACTIONS(745),
    [anon_sym_bytes18] = ACTIONS(745),
    [anon_sym_bytes19] = ACTIONS(745),
    [anon_sym_bytes20] = ACTIONS(745),
    [anon_sym_bytes21] = ACTIONS(745),
    [anon_sym_bytes22] = ACTIONS(745),
    [anon_sym_bytes23] = ACTIONS(745),
    [anon_sym_bytes24] = ACTIONS(745),
    [anon_sym_bytes25] = ACTIONS(745),
    [anon_sym_bytes26] = ACTIONS(745),
    [anon_sym_bytes27] = ACTIONS(745),
    [anon_sym_bytes28] = ACTIONS(745),
    [anon_sym_bytes29] = ACTIONS(745),
    [anon_sym_bytes30] = ACTIONS(745),
    [anon_sym_bytes31] = ACTIONS(745),
    [anon_sym_bytes32] = ACTIONS(745),
    [anon_sym_fixed] = ACTIONS(745),
    [aux_sym__fixed_token1] = ACTIONS(745),
    [anon_sym_ufixed] = ACTIONS(745),
    [aux_sym__ufixed_token1] = ACTIONS(745),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_identifier] = ACTIONS(699),
    [anon_sym_RBRACE] = ACTIONS(697),
    [anon_sym_type] = ACTIONS(699),
    [anon_sym_error] = ACTIONS(699),
    [anon_sym_struct] = ACTIONS(699),
    [anon_sym_enum] = ACTIONS(699),
    [anon_sym_event] = ACTIONS(699),
    [anon_sym_using] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(699),
    [anon_sym_byte] = ACTIONS(699),
    [anon_sym_address] = ACTIONS(699),
    [anon_sym_var] = ACTIONS(699),
    [anon_sym_modifier] = ACTIONS(699),
    [anon_sym_constructor] = ACTIONS(699),
    [anon_sym_fallback] = ACTIONS(699),
    [anon_sym_receive] = ACTIONS(699),
    [anon_sym_mapping] = ACTIONS(699),
    [anon_sym_bool] = ACTIONS(699),
    [anon_sym_string] = ACTIONS(699),
    [anon_sym_int] = ACTIONS(699),
    [anon_sym_int8] = ACTIONS(699),
    [anon_sym_int16] = ACTIONS(699),
    [anon_sym_int24] = ACTIONS(699),
    [anon_sym_int32] = ACTIONS(699),
    [anon_sym_int40] = ACTIONS(699),
    [anon_sym_int48] = ACTIONS(699),
    [anon_sym_int56] = ACTIONS(699),
    [anon_sym_int64] = ACTIONS(699),
    [anon_sym_int72] = ACTIONS(699),
    [anon_sym_int80] = ACTIONS(699),
    [anon_sym_int88] = ACTIONS(699),
    [anon_sym_int96] = ACTIONS(699),
    [anon_sym_int104] = ACTIONS(699),
    [anon_sym_int112] = ACTIONS(699),
    [anon_sym_int120] = ACTIONS(699),
    [anon_sym_int128] = ACTIONS(699),
    [anon_sym_int136] = ACTIONS(699),
    [anon_sym_int144] = ACTIONS(699),
    [anon_sym_int152] = ACTIONS(699),
    [anon_sym_int160] = ACTIONS(699),
    [anon_sym_int168] = ACTIONS(699),
    [anon_sym_int176] = ACTIONS(699),
    [anon_sym_int184] = ACTIONS(699),
    [anon_sym_int192] = ACTIONS(699),
    [anon_sym_int200] = ACTIONS(699),
    [anon_sym_int208] = ACTIONS(699),
    [anon_sym_int216] = ACTIONS(699),
    [anon_sym_int224] = ACTIONS(699),
    [anon_sym_int232] = ACTIONS(699),
    [anon_sym_int240] = ACTIONS(699),
    [anon_sym_int248] = ACTIONS(699),
    [anon_sym_int256] = ACTIONS(699),
    [anon_sym_uint] = ACTIONS(699),
    [anon_sym_uint8] = ACTIONS(699),
    [anon_sym_uint16] = ACTIONS(699),
    [anon_sym_uint24] = ACTIONS(699),
    [anon_sym_uint32] = ACTIONS(699),
    [anon_sym_uint40] = ACTIONS(699),
    [anon_sym_uint48] = ACTIONS(699),
    [anon_sym_uint56] = ACTIONS(699),
    [anon_sym_uint64] = ACTIONS(699),
    [anon_sym_uint72] = ACTIONS(699),
    [anon_sym_uint80] = ACTIONS(699),
    [anon_sym_uint88] = ACTIONS(699),
    [anon_sym_uint96] = ACTIONS(699),
    [anon_sym_uint104] = ACTIONS(699),
    [anon_sym_uint112] = ACTIONS(699),
    [anon_sym_uint120] = ACTIONS(699),
    [anon_sym_uint128] = ACTIONS(699),
    [anon_sym_uint136] = ACTIONS(699),
    [anon_sym_uint144] = ACTIONS(699),
    [anon_sym_uint152] = ACTIONS(699),
    [anon_sym_uint160] = ACTIONS(699),
    [anon_sym_uint168] = ACTIONS(699),
    [anon_sym_uint176] = ACTIONS(699),
    [anon_sym_uint184] = ACTIONS(699),
    [anon_sym_uint192] = ACTIONS(699),
    [anon_sym_uint200] = ACTIONS(699),
    [anon_sym_uint208] = ACTIONS(699),
    [anon_sym_uint216] = ACTIONS(699),
    [anon_sym_uint224] = ACTIONS(699),
    [anon_sym_uint232] = ACTIONS(699),
    [anon_sym_uint240] = ACTIONS(699),
    [anon_sym_uint248] = ACTIONS(699),
    [anon_sym_uint256] = ACTIONS(699),
    [anon_sym_bytes] = ACTIONS(699),
    [anon_sym_bytes1] = ACTIONS(699),
    [anon_sym_bytes2] = ACTIONS(699),
    [anon_sym_bytes3] = ACTIONS(699),
    [anon_sym_bytes4] = ACTIONS(699),
    [anon_sym_bytes5] = ACTIONS(699),
    [anon_sym_bytes6] = ACTIONS(699),
    [anon_sym_bytes7] = ACTIONS(699),
    [anon_sym_bytes8] = ACTIONS(699),
    [anon_sym_bytes9] = ACTIONS(699),
    [anon_sym_bytes10] = ACTIONS(699),
    [anon_sym_bytes11] = ACTIONS(699),
    [anon_sym_bytes12] = ACTIONS(699),
    [anon_sym_bytes13] = ACTIONS(699),
    [anon_sym_bytes14] = ACTIONS(699),
    [anon_sym_bytes15] = ACTIONS(699),
    [anon_sym_bytes16] = ACTIONS(699),
    [anon_sym_bytes17] = ACTIONS(699),
    [anon_sym_bytes18] = ACTIONS(699),
    [anon_sym_bytes19] = ACTIONS(699),
    [anon_sym_bytes20] = ACTIONS(699),
    [anon_sym_bytes21] = ACTIONS(699),
    [anon_sym_bytes22] = ACTIONS(699),
    [anon_sym_bytes23] = ACTIONS(699),
    [anon_sym_bytes24] = ACTIONS(699),
    [anon_sym_bytes25] = ACTIONS(699),
    [anon_sym_bytes26] = ACTIONS(699),
    [anon_sym_bytes27] = ACTIONS(699),
    [anon_sym_bytes28] = ACTIONS(699),
    [anon_sym_bytes29] = ACTIONS(699),
    [anon_sym_bytes30] = ACTIONS(699),
    [anon_sym_bytes31] = ACTIONS(699),
    [anon_sym_bytes32] = ACTIONS(699),
    [anon_sym_fixed] = ACTIONS(699),
    [aux_sym__fixed_token1] = ACTIONS(699),
    [anon_sym_ufixed] = ACTIONS(699),
    [aux_sym__ufixed_token1] = ACTIONS(699),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_identifier] = ACTIONS(721),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym_type] = ACTIONS(721),
    [anon_sym_error] = ACTIONS(721),
    [anon_sym_struct] = ACTIONS(721),
    [anon_sym_enum] = ACTIONS(721),
    [anon_sym_event] = ACTIONS(721),
    [anon_sym_using] = ACTIONS(721),
    [anon_sym_function] = ACTIONS(721),
    [anon_sym_byte] = ACTIONS(721),
    [anon_sym_address] = ACTIONS(721),
    [anon_sym_var] = ACTIONS(721),
    [anon_sym_modifier] = ACTIONS(721),
    [anon_sym_constructor] = ACTIONS(721),
    [anon_sym_fallback] = ACTIONS(721),
    [anon_sym_receive] = ACTIONS(721),
    [anon_sym_mapping] = ACTIONS(721),
    [anon_sym_bool] = ACTIONS(721),
    [anon_sym_string] = ACTIONS(721),
    [anon_sym_int] = ACTIONS(721),
    [anon_sym_int8] = ACTIONS(721),
    [anon_sym_int16] = ACTIONS(721),
    [anon_sym_int24] = ACTIONS(721),
    [anon_sym_int32] = ACTIONS(721),
    [anon_sym_int40] = ACTIONS(721),
    [anon_sym_int48] = ACTIONS(721),
    [anon_sym_int56] = ACTIONS(721),
    [anon_sym_int64] = ACTIONS(721),
    [anon_sym_int72] = ACTIONS(721),
    [anon_sym_int80] = ACTIONS(721),
    [anon_sym_int88] = ACTIONS(721),
    [anon_sym_int96] = ACTIONS(721),
    [anon_sym_int104] = ACTIONS(721),
    [anon_sym_int112] = ACTIONS(721),
    [anon_sym_int120] = ACTIONS(721),
    [anon_sym_int128] = ACTIONS(721),
    [anon_sym_int136] = ACTIONS(721),
    [anon_sym_int144] = ACTIONS(721),
    [anon_sym_int152] = ACTIONS(721),
    [anon_sym_int160] = ACTIONS(721),
    [anon_sym_int168] = ACTIONS(721),
    [anon_sym_int176] = ACTIONS(721),
    [anon_sym_int184] = ACTIONS(721),
    [anon_sym_int192] = ACTIONS(721),
    [anon_sym_int200] = ACTIONS(721),
    [anon_sym_int208] = ACTIONS(721),
    [anon_sym_int216] = ACTIONS(721),
    [anon_sym_int224] = ACTIONS(721),
    [anon_sym_int232] = ACTIONS(721),
    [anon_sym_int240] = ACTIONS(721),
    [anon_sym_int248] = ACTIONS(721),
    [anon_sym_int256] = ACTIONS(721),
    [anon_sym_uint] = ACTIONS(721),
    [anon_sym_uint8] = ACTIONS(721),
    [anon_sym_uint16] = ACTIONS(721),
    [anon_sym_uint24] = ACTIONS(721),
    [anon_sym_uint32] = ACTIONS(721),
    [anon_sym_uint40] = ACTIONS(721),
    [anon_sym_uint48] = ACTIONS(721),
    [anon_sym_uint56] = ACTIONS(721),
    [anon_sym_uint64] = ACTIONS(721),
    [anon_sym_uint72] = ACTIONS(721),
    [anon_sym_uint80] = ACTIONS(721),
    [anon_sym_uint88] = ACTIONS(721),
    [anon_sym_uint96] = ACTIONS(721),
    [anon_sym_uint104] = ACTIONS(721),
    [anon_sym_uint112] = ACTIONS(721),
    [anon_sym_uint120] = ACTIONS(721),
    [anon_sym_uint128] = ACTIONS(721),
    [anon_sym_uint136] = ACTIONS(721),
    [anon_sym_uint144] = ACTIONS(721),
    [anon_sym_uint152] = ACTIONS(721),
    [anon_sym_uint160] = ACTIONS(721),
    [anon_sym_uint168] = ACTIONS(721),
    [anon_sym_uint176] = ACTIONS(721),
    [anon_sym_uint184] = ACTIONS(721),
    [anon_sym_uint192] = ACTIONS(721),
    [anon_sym_uint200] = ACTIONS(721),
    [anon_sym_uint208] = ACTIONS(721),
    [anon_sym_uint216] = ACTIONS(721),
    [anon_sym_uint224] = ACTIONS(721),
    [anon_sym_uint232] = ACTIONS(721),
    [anon_sym_uint240] = ACTIONS(721),
    [anon_sym_uint248] = ACTIONS(721),
    [anon_sym_uint256] = ACTIONS(721),
    [anon_sym_bytes] = ACTIONS(721),
    [anon_sym_bytes1] = ACTIONS(721),
    [anon_sym_bytes2] = ACTIONS(721),
    [anon_sym_bytes3] = ACTIONS(721),
    [anon_sym_bytes4] = ACTIONS(721),
    [anon_sym_bytes5] = ACTIONS(721),
    [anon_sym_bytes6] = ACTIONS(721),
    [anon_sym_bytes7] = ACTIONS(721),
    [anon_sym_bytes8] = ACTIONS(721),
    [anon_sym_bytes9] = ACTIONS(721),
    [anon_sym_bytes10] = ACTIONS(721),
    [anon_sym_bytes11] = ACTIONS(721),
    [anon_sym_bytes12] = ACTIONS(721),
    [anon_sym_bytes13] = ACTIONS(721),
    [anon_sym_bytes14] = ACTIONS(721),
    [anon_sym_bytes15] = ACTIONS(721),
    [anon_sym_bytes16] = ACTIONS(721),
    [anon_sym_bytes17] = ACTIONS(721),
    [anon_sym_bytes18] = ACTIONS(721),
    [anon_sym_bytes19] = ACTIONS(721),
    [anon_sym_bytes20] = ACTIONS(721),
    [anon_sym_bytes21] = ACTIONS(721),
    [anon_sym_bytes22] = ACTIONS(721),
    [anon_sym_bytes23] = ACTIONS(721),
    [anon_sym_bytes24] = ACTIONS(721),
    [anon_sym_bytes25] = ACTIONS(721),
    [anon_sym_bytes26] = ACTIONS(721),
    [anon_sym_bytes27] = ACTIONS(721),
    [anon_sym_bytes28] = ACTIONS(721),
    [anon_sym_bytes29] = ACTIONS(721),
    [anon_sym_bytes30] = ACTIONS(721),
    [anon_sym_bytes31] = ACTIONS(721),
    [anon_sym_bytes32] = ACTIONS(721),
    [anon_sym_fixed] = ACTIONS(721),
    [aux_sym__fixed_token1] = ACTIONS(721),
    [anon_sym_ufixed] = ACTIONS(721),
    [aux_sym__ufixed_token1] = ACTIONS(721),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_identifier] = ACTIONS(713),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_type] = ACTIONS(713),
    [anon_sym_error] = ACTIONS(713),
    [anon_sym_struct] = ACTIONS(713),
    [anon_sym_enum] = ACTIONS(713),
    [anon_sym_event] = ACTIONS(713),
    [anon_sym_using] = ACTIONS(713),
    [anon_sym_function] = ACTIONS(713),
    [anon_sym_byte] = ACTIONS(713),
    [anon_sym_address] = ACTIONS(713),
    [anon_sym_var] = ACTIONS(713),
    [anon_sym_modifier] = ACTIONS(713),
    [anon_sym_constructor] = ACTIONS(713),
    [anon_sym_fallback] = ACTIONS(713),
    [anon_sym_receive] = ACTIONS(713),
    [anon_sym_mapping] = ACTIONS(713),
    [anon_sym_bool] = ACTIONS(713),
    [anon_sym_string] = ACTIONS(713),
    [anon_sym_int] = ACTIONS(713),
    [anon_sym_int8] = ACTIONS(713),
    [anon_sym_int16] = ACTIONS(713),
    [anon_sym_int24] = ACTIONS(713),
    [anon_sym_int32] = ACTIONS(713),
    [anon_sym_int40] = ACTIONS(713),
    [anon_sym_int48] = ACTIONS(713),
    [anon_sym_int56] = ACTIONS(713),
    [anon_sym_int64] = ACTIONS(713),
    [anon_sym_int72] = ACTIONS(713),
    [anon_sym_int80] = ACTIONS(713),
    [anon_sym_int88] = ACTIONS(713),
    [anon_sym_int96] = ACTIONS(713),
    [anon_sym_int104] = ACTIONS(713),
    [anon_sym_int112] = ACTIONS(713),
    [anon_sym_int120] = ACTIONS(713),
    [anon_sym_int128] = ACTIONS(713),
    [anon_sym_int136] = ACTIONS(713),
    [anon_sym_int144] = ACTIONS(713),
    [anon_sym_int152] = ACTIONS(713),
    [anon_sym_int160] = ACTIONS(713),
    [anon_sym_int168] = ACTIONS(713),
    [anon_sym_int176] = ACTIONS(713),
    [anon_sym_int184] = ACTIONS(713),
    [anon_sym_int192] = ACTIONS(713),
    [anon_sym_int200] = ACTIONS(713),
    [anon_sym_int208] = ACTIONS(713),
    [anon_sym_int216] = ACTIONS(713),
    [anon_sym_int224] = ACTIONS(713),
    [anon_sym_int232] = ACTIONS(713),
    [anon_sym_int240] = ACTIONS(713),
    [anon_sym_int248] = ACTIONS(713),
    [anon_sym_int256] = ACTIONS(713),
    [anon_sym_uint] = ACTIONS(713),
    [anon_sym_uint8] = ACTIONS(713),
    [anon_sym_uint16] = ACTIONS(713),
    [anon_sym_uint24] = ACTIONS(713),
    [anon_sym_uint32] = ACTIONS(713),
    [anon_sym_uint40] = ACTIONS(713),
    [anon_sym_uint48] = ACTIONS(713),
    [anon_sym_uint56] = ACTIONS(713),
    [anon_sym_uint64] = ACTIONS(713),
    [anon_sym_uint72] = ACTIONS(713),
    [anon_sym_uint80] = ACTIONS(713),
    [anon_sym_uint88] = ACTIONS(713),
    [anon_sym_uint96] = ACTIONS(713),
    [anon_sym_uint104] = ACTIONS(713),
    [anon_sym_uint112] = ACTIONS(713),
    [anon_sym_uint120] = ACTIONS(713),
    [anon_sym_uint128] = ACTIONS(713),
    [anon_sym_uint136] = ACTIONS(713),
    [anon_sym_uint144] = ACTIONS(713),
    [anon_sym_uint152] = ACTIONS(713),
    [anon_sym_uint160] = ACTIONS(713),
    [anon_sym_uint168] = ACTIONS(713),
    [anon_sym_uint176] = ACTIONS(713),
    [anon_sym_uint184] = ACTIONS(713),
    [anon_sym_uint192] = ACTIONS(713),
    [anon_sym_uint200] = ACTIONS(713),
    [anon_sym_uint208] = ACTIONS(713),
    [anon_sym_uint216] = ACTIONS(713),
    [anon_sym_uint224] = ACTIONS(713),
    [anon_sym_uint232] = ACTIONS(713),
    [anon_sym_uint240] = ACTIONS(713),
    [anon_sym_uint248] = ACTIONS(713),
    [anon_sym_uint256] = ACTIONS(713),
    [anon_sym_bytes] = ACTIONS(713),
    [anon_sym_bytes1] = ACTIONS(713),
    [anon_sym_bytes2] = ACTIONS(713),
    [anon_sym_bytes3] = ACTIONS(713),
    [anon_sym_bytes4] = ACTIONS(713),
    [anon_sym_bytes5] = ACTIONS(713),
    [anon_sym_bytes6] = ACTIONS(713),
    [anon_sym_bytes7] = ACTIONS(713),
    [anon_sym_bytes8] = ACTIONS(713),
    [anon_sym_bytes9] = ACTIONS(713),
    [anon_sym_bytes10] = ACTIONS(713),
    [anon_sym_bytes11] = ACTIONS(713),
    [anon_sym_bytes12] = ACTIONS(713),
    [anon_sym_bytes13] = ACTIONS(713),
    [anon_sym_bytes14] = ACTIONS(713),
    [anon_sym_bytes15] = ACTIONS(713),
    [anon_sym_bytes16] = ACTIONS(713),
    [anon_sym_bytes17] = ACTIONS(713),
    [anon_sym_bytes18] = ACTIONS(713),
    [anon_sym_bytes19] = ACTIONS(713),
    [anon_sym_bytes20] = ACTIONS(713),
    [anon_sym_bytes21] = ACTIONS(713),
    [anon_sym_bytes22] = ACTIONS(713),
    [anon_sym_bytes23] = ACTIONS(713),
    [anon_sym_bytes24] = ACTIONS(713),
    [anon_sym_bytes25] = ACTIONS(713),
    [anon_sym_bytes26] = ACTIONS(713),
    [anon_sym_bytes27] = ACTIONS(713),
    [anon_sym_bytes28] = ACTIONS(713),
    [anon_sym_bytes29] = ACTIONS(713),
    [anon_sym_bytes30] = ACTIONS(713),
    [anon_sym_bytes31] = ACTIONS(713),
    [anon_sym_bytes32] = ACTIONS(713),
    [anon_sym_fixed] = ACTIONS(713),
    [aux_sym__fixed_token1] = ACTIONS(713),
    [anon_sym_ufixed] = ACTIONS(713),
    [aux_sym__ufixed_token1] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(729),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym_type] = ACTIONS(729),
    [anon_sym_error] = ACTIONS(729),
    [anon_sym_struct] = ACTIONS(729),
    [anon_sym_enum] = ACTIONS(729),
    [anon_sym_event] = ACTIONS(729),
    [anon_sym_using] = ACTIONS(729),
    [anon_sym_function] = ACTIONS(729),
    [anon_sym_byte] = ACTIONS(729),
    [anon_sym_address] = ACTIONS(729),
    [anon_sym_var] = ACTIONS(729),
    [anon_sym_modifier] = ACTIONS(729),
    [anon_sym_constructor] = ACTIONS(729),
    [anon_sym_fallback] = ACTIONS(729),
    [anon_sym_receive] = ACTIONS(729),
    [anon_sym_mapping] = ACTIONS(729),
    [anon_sym_bool] = ACTIONS(729),
    [anon_sym_string] = ACTIONS(729),
    [anon_sym_int] = ACTIONS(729),
    [anon_sym_int8] = ACTIONS(729),
    [anon_sym_int16] = ACTIONS(729),
    [anon_sym_int24] = ACTIONS(729),
    [anon_sym_int32] = ACTIONS(729),
    [anon_sym_int40] = ACTIONS(729),
    [anon_sym_int48] = ACTIONS(729),
    [anon_sym_int56] = ACTIONS(729),
    [anon_sym_int64] = ACTIONS(729),
    [anon_sym_int72] = ACTIONS(729),
    [anon_sym_int80] = ACTIONS(729),
    [anon_sym_int88] = ACTIONS(729),
    [anon_sym_int96] = ACTIONS(729),
    [anon_sym_int104] = ACTIONS(729),
    [anon_sym_int112] = ACTIONS(729),
    [anon_sym_int120] = ACTIONS(729),
    [anon_sym_int128] = ACTIONS(729),
    [anon_sym_int136] = ACTIONS(729),
    [anon_sym_int144] = ACTIONS(729),
    [anon_sym_int152] = ACTIONS(729),
    [anon_sym_int160] = ACTIONS(729),
    [anon_sym_int168] = ACTIONS(729),
    [anon_sym_int176] = ACTIONS(729),
    [anon_sym_int184] = ACTIONS(729),
    [anon_sym_int192] = ACTIONS(729),
    [anon_sym_int200] = ACTIONS(729),
    [anon_sym_int208] = ACTIONS(729),
    [anon_sym_int216] = ACTIONS(729),
    [anon_sym_int224] = ACTIONS(729),
    [anon_sym_int232] = ACTIONS(729),
    [anon_sym_int240] = ACTIONS(729),
    [anon_sym_int248] = ACTIONS(729),
    [anon_sym_int256] = ACTIONS(729),
    [anon_sym_uint] = ACTIONS(729),
    [anon_sym_uint8] = ACTIONS(729),
    [anon_sym_uint16] = ACTIONS(729),
    [anon_sym_uint24] = ACTIONS(729),
    [anon_sym_uint32] = ACTIONS(729),
    [anon_sym_uint40] = ACTIONS(729),
    [anon_sym_uint48] = ACTIONS(729),
    [anon_sym_uint56] = ACTIONS(729),
    [anon_sym_uint64] = ACTIONS(729),
    [anon_sym_uint72] = ACTIONS(729),
    [anon_sym_uint80] = ACTIONS(729),
    [anon_sym_uint88] = ACTIONS(729),
    [anon_sym_uint96] = ACTIONS(729),
    [anon_sym_uint104] = ACTIONS(729),
    [anon_sym_uint112] = ACTIONS(729),
    [anon_sym_uint120] = ACTIONS(729),
    [anon_sym_uint128] = ACTIONS(729),
    [anon_sym_uint136] = ACTIONS(729),
    [anon_sym_uint144] = ACTIONS(729),
    [anon_sym_uint152] = ACTIONS(729),
    [anon_sym_uint160] = ACTIONS(729),
    [anon_sym_uint168] = ACTIONS(729),
    [anon_sym_uint176] = ACTIONS(729),
    [anon_sym_uint184] = ACTIONS(729),
    [anon_sym_uint192] = ACTIONS(729),
    [anon_sym_uint200] = ACTIONS(729),
    [anon_sym_uint208] = ACTIONS(729),
    [anon_sym_uint216] = ACTIONS(729),
    [anon_sym_uint224] = ACTIONS(729),
    [anon_sym_uint232] = ACTIONS(729),
    [anon_sym_uint240] = ACTIONS(729),
    [anon_sym_uint248] = ACTIONS(729),
    [anon_sym_uint256] = ACTIONS(729),
    [anon_sym_bytes] = ACTIONS(729),
    [anon_sym_bytes1] = ACTIONS(729),
    [anon_sym_bytes2] = ACTIONS(729),
    [anon_sym_bytes3] = ACTIONS(729),
    [anon_sym_bytes4] = ACTIONS(729),
    [anon_sym_bytes5] = ACTIONS(729),
    [anon_sym_bytes6] = ACTIONS(729),
    [anon_sym_bytes7] = ACTIONS(729),
    [anon_sym_bytes8] = ACTIONS(729),
    [anon_sym_bytes9] = ACTIONS(729),
    [anon_sym_bytes10] = ACTIONS(729),
    [anon_sym_bytes11] = ACTIONS(729),
    [anon_sym_bytes12] = ACTIONS(729),
    [anon_sym_bytes13] = ACTIONS(729),
    [anon_sym_bytes14] = ACTIONS(729),
    [anon_sym_bytes15] = ACTIONS(729),
    [anon_sym_bytes16] = ACTIONS(729),
    [anon_sym_bytes17] = ACTIONS(729),
    [anon_sym_bytes18] = ACTIONS(729),
    [anon_sym_bytes19] = ACTIONS(729),
    [anon_sym_bytes20] = ACTIONS(729),
    [anon_sym_bytes21] = ACTIONS(729),
    [anon_sym_bytes22] = ACTIONS(729),
    [anon_sym_bytes23] = ACTIONS(729),
    [anon_sym_bytes24] = ACTIONS(729),
    [anon_sym_bytes25] = ACTIONS(729),
    [anon_sym_bytes26] = ACTIONS(729),
    [anon_sym_bytes27] = ACTIONS(729),
    [anon_sym_bytes28] = ACTIONS(729),
    [anon_sym_bytes29] = ACTIONS(729),
    [anon_sym_bytes30] = ACTIONS(729),
    [anon_sym_bytes31] = ACTIONS(729),
    [anon_sym_bytes32] = ACTIONS(729),
    [anon_sym_fixed] = ACTIONS(729),
    [aux_sym__fixed_token1] = ACTIONS(729),
    [anon_sym_ufixed] = ACTIONS(729),
    [aux_sym__ufixed_token1] = ACTIONS(729),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_type] = ACTIONS(839),
    [anon_sym_error] = ACTIONS(839),
    [anon_sym_struct] = ACTIONS(839),
    [anon_sym_enum] = ACTIONS(839),
    [anon_sym_event] = ACTIONS(839),
    [anon_sym_using] = ACTIONS(839),
    [anon_sym_function] = ACTIONS(839),
    [anon_sym_byte] = ACTIONS(839),
    [anon_sym_address] = ACTIONS(839),
    [anon_sym_var] = ACTIONS(839),
    [anon_sym_modifier] = ACTIONS(839),
    [anon_sym_constructor] = ACTIONS(839),
    [anon_sym_fallback] = ACTIONS(839),
    [anon_sym_receive] = ACTIONS(839),
    [anon_sym_mapping] = ACTIONS(839),
    [anon_sym_bool] = ACTIONS(839),
    [anon_sym_string] = ACTIONS(839),
    [anon_sym_int] = ACTIONS(839),
    [anon_sym_int8] = ACTIONS(839),
    [anon_sym_int16] = ACTIONS(839),
    [anon_sym_int24] = ACTIONS(839),
    [anon_sym_int32] = ACTIONS(839),
    [anon_sym_int40] = ACTIONS(839),
    [anon_sym_int48] = ACTIONS(839),
    [anon_sym_int56] = ACTIONS(839),
    [anon_sym_int64] = ACTIONS(839),
    [anon_sym_int72] = ACTIONS(839),
    [anon_sym_int80] = ACTIONS(839),
    [anon_sym_int88] = ACTIONS(839),
    [anon_sym_int96] = ACTIONS(839),
    [anon_sym_int104] = ACTIONS(839),
    [anon_sym_int112] = ACTIONS(839),
    [anon_sym_int120] = ACTIONS(839),
    [anon_sym_int128] = ACTIONS(839),
    [anon_sym_int136] = ACTIONS(839),
    [anon_sym_int144] = ACTIONS(839),
    [anon_sym_int152] = ACTIONS(839),
    [anon_sym_int160] = ACTIONS(839),
    [anon_sym_int168] = ACTIONS(839),
    [anon_sym_int176] = ACTIONS(839),
    [anon_sym_int184] = ACTIONS(839),
    [anon_sym_int192] = ACTIONS(839),
    [anon_sym_int200] = ACTIONS(839),
    [anon_sym_int208] = ACTIONS(839),
    [anon_sym_int216] = ACTIONS(839),
    [anon_sym_int224] = ACTIONS(839),
    [anon_sym_int232] = ACTIONS(839),
    [anon_sym_int240] = ACTIONS(839),
    [anon_sym_int248] = ACTIONS(839),
    [anon_sym_int256] = ACTIONS(839),
    [anon_sym_uint] = ACTIONS(839),
    [anon_sym_uint8] = ACTIONS(839),
    [anon_sym_uint16] = ACTIONS(839),
    [anon_sym_uint24] = ACTIONS(839),
    [anon_sym_uint32] = ACTIONS(839),
    [anon_sym_uint40] = ACTIONS(839),
    [anon_sym_uint48] = ACTIONS(839),
    [anon_sym_uint56] = ACTIONS(839),
    [anon_sym_uint64] = ACTIONS(839),
    [anon_sym_uint72] = ACTIONS(839),
    [anon_sym_uint80] = ACTIONS(839),
    [anon_sym_uint88] = ACTIONS(839),
    [anon_sym_uint96] = ACTIONS(839),
    [anon_sym_uint104] = ACTIONS(839),
    [anon_sym_uint112] = ACTIONS(839),
    [anon_sym_uint120] = ACTIONS(839),
    [anon_sym_uint128] = ACTIONS(839),
    [anon_sym_uint136] = ACTIONS(839),
    [anon_sym_uint144] = ACTIONS(839),
    [anon_sym_uint152] = ACTIONS(839),
    [anon_sym_uint160] = ACTIONS(839),
    [anon_sym_uint168] = ACTIONS(839),
    [anon_sym_uint176] = ACTIONS(839),
    [anon_sym_uint184] = ACTIONS(839),
    [anon_sym_uint192] = ACTIONS(839),
    [anon_sym_uint200] = ACTIONS(839),
    [anon_sym_uint208] = ACTIONS(839),
    [anon_sym_uint216] = ACTIONS(839),
    [anon_sym_uint224] = ACTIONS(839),
    [anon_sym_uint232] = ACTIONS(839),
    [anon_sym_uint240] = ACTIONS(839),
    [anon_sym_uint248] = ACTIONS(839),
    [anon_sym_uint256] = ACTIONS(839),
    [anon_sym_bytes] = ACTIONS(839),
    [anon_sym_bytes1] = ACTIONS(839),
    [anon_sym_bytes2] = ACTIONS(839),
    [anon_sym_bytes3] = ACTIONS(839),
    [anon_sym_bytes4] = ACTIONS(839),
    [anon_sym_bytes5] = ACTIONS(839),
    [anon_sym_bytes6] = ACTIONS(839),
    [anon_sym_bytes7] = ACTIONS(839),
    [anon_sym_bytes8] = ACTIONS(839),
    [anon_sym_bytes9] = ACTIONS(839),
    [anon_sym_bytes10] = ACTIONS(839),
    [anon_sym_bytes11] = ACTIONS(839),
    [anon_sym_bytes12] = ACTIONS(839),
    [anon_sym_bytes13] = ACTIONS(839),
    [anon_sym_bytes14] = ACTIONS(839),
    [anon_sym_bytes15] = ACTIONS(839),
    [anon_sym_bytes16] = ACTIONS(839),
    [anon_sym_bytes17] = ACTIONS(839),
    [anon_sym_bytes18] = ACTIONS(839),
    [anon_sym_bytes19] = ACTIONS(839),
    [anon_sym_bytes20] = ACTIONS(839),
    [anon_sym_bytes21] = ACTIONS(839),
    [anon_sym_bytes22] = ACTIONS(839),
    [anon_sym_bytes23] = ACTIONS(839),
    [anon_sym_bytes24] = ACTIONS(839),
    [anon_sym_bytes25] = ACTIONS(839),
    [anon_sym_bytes26] = ACTIONS(839),
    [anon_sym_bytes27] = ACTIONS(839),
    [anon_sym_bytes28] = ACTIONS(839),
    [anon_sym_bytes29] = ACTIONS(839),
    [anon_sym_bytes30] = ACTIONS(839),
    [anon_sym_bytes31] = ACTIONS(839),
    [anon_sym_bytes32] = ACTIONS(839),
    [anon_sym_fixed] = ACTIONS(839),
    [aux_sym__fixed_token1] = ACTIONS(839),
    [anon_sym_ufixed] = ACTIONS(839),
    [aux_sym__ufixed_token1] = ACTIONS(839),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_user_defined_type] = STATE(713),
    [sym__identifier_path] = STATE(336),
    [sym__mapping_key] = STATE(713),
    [sym_primitive_type] = STATE(713),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [sym__yul_statement] = STATE(238),
    [sym_yul_label] = STATE(238),
    [sym_yul_break] = STATE(238),
    [sym_yul_continue] = STATE(238),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(238),
    [sym_yul_string_literal] = STATE(238),
    [sym_yul_boolean] = STATE(238),
    [sym_yul_block] = STATE(238),
    [sym_yul_variable_declaration] = STATE(238),
    [sym_yul_assignment] = STATE(238),
    [sym_yul_function_call] = STATE(238),
    [sym_yul_if_statement] = STATE(238),
    [sym_yul_for_statement] = STATE(238),
    [sym_yul_switch_statement] = STATE(238),
    [sym_yul_function_definition] = STATE(238),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(238),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(851),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(851),
    [sym_yul_hex_number] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym__yul_statement] = STATE(236),
    [sym_yul_label] = STATE(236),
    [sym_yul_break] = STATE(236),
    [sym_yul_continue] = STATE(236),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(236),
    [sym_yul_string_literal] = STATE(236),
    [sym_yul_boolean] = STATE(236),
    [sym_yul_block] = STATE(236),
    [sym_yul_variable_declaration] = STATE(236),
    [sym_yul_assignment] = STATE(236),
    [sym_yul_function_call] = STATE(236),
    [sym_yul_if_statement] = STATE(236),
    [sym_yul_for_statement] = STATE(236),
    [sym_yul_switch_statement] = STATE(236),
    [sym_yul_function_definition] = STATE(236),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(875),
    [anon_sym_LBRACE] = ACTIONS(878),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(883),
    [sym_yul_leave] = ACTIONS(886),
    [anon_sym_break] = ACTIONS(889),
    [anon_sym_continue] = ACTIONS(892),
    [sym_yul_decimal_number] = ACTIONS(886),
    [sym_yul_hex_number] = ACTIONS(895),
    [anon_sym_true] = ACTIONS(898),
    [anon_sym_false] = ACTIONS(898),
    [anon_sym_let] = ACTIONS(901),
    [anon_sym_if] = ACTIONS(904),
    [anon_sym_switch] = ACTIONS(907),
    [anon_sym_function] = ACTIONS(910),
    [anon_sym_stop] = ACTIONS(913),
    [anon_sym_add] = ACTIONS(913),
    [anon_sym_sub] = ACTIONS(913),
    [anon_sym_mul] = ACTIONS(913),
    [anon_sym_div] = ACTIONS(913),
    [anon_sym_sdiv] = ACTIONS(913),
    [anon_sym_mod] = ACTIONS(913),
    [anon_sym_smod] = ACTIONS(913),
    [anon_sym_exp] = ACTIONS(913),
    [anon_sym_not] = ACTIONS(913),
    [anon_sym_lt] = ACTIONS(913),
    [anon_sym_gt] = ACTIONS(913),
    [anon_sym_slt] = ACTIONS(913),
    [anon_sym_sgt] = ACTIONS(913),
    [anon_sym_eq] = ACTIONS(913),
    [anon_sym_iszero] = ACTIONS(913),
    [anon_sym_and] = ACTIONS(913),
    [anon_sym_or] = ACTIONS(913),
    [anon_sym_xor] = ACTIONS(913),
    [anon_sym_byte] = ACTIONS(913),
    [anon_sym_shl] = ACTIONS(913),
    [anon_sym_shr] = ACTIONS(913),
    [anon_sym_sar] = ACTIONS(913),
    [anon_sym_addmod] = ACTIONS(913),
    [anon_sym_mulmod] = ACTIONS(913),
    [anon_sym_signextend] = ACTIONS(913),
    [anon_sym_keccak256] = ACTIONS(913),
    [anon_sym_pop] = ACTIONS(913),
    [anon_sym_mload] = ACTIONS(913),
    [anon_sym_mcopy] = ACTIONS(913),
    [anon_sym_tload] = ACTIONS(913),
    [anon_sym_tstore] = ACTIONS(913),
    [anon_sym_mstore] = ACTIONS(913),
    [anon_sym_mstore8] = ACTIONS(913),
    [anon_sym_sload] = ACTIONS(913),
    [anon_sym_sstore] = ACTIONS(913),
    [anon_sym_msize] = ACTIONS(913),
    [anon_sym_gas] = ACTIONS(913),
    [anon_sym_address] = ACTIONS(913),
    [anon_sym_balance] = ACTIONS(913),
    [anon_sym_selfbalance] = ACTIONS(913),
    [anon_sym_caller] = ACTIONS(913),
    [anon_sym_callvalue] = ACTIONS(913),
    [anon_sym_calldataload] = ACTIONS(913),
    [anon_sym_calldatasize] = ACTIONS(913),
    [anon_sym_calldatacopy] = ACTIONS(913),
    [anon_sym_extcodesize] = ACTIONS(913),
    [anon_sym_extcodecopy] = ACTIONS(913),
    [anon_sym_returndatasize] = ACTIONS(913),
    [anon_sym_returndatacopy] = ACTIONS(913),
    [anon_sym_extcodehash] = ACTIONS(913),
    [anon_sym_create] = ACTIONS(913),
    [anon_sym_create2] = ACTIONS(913),
    [anon_sym_call] = ACTIONS(913),
    [anon_sym_callcode] = ACTIONS(913),
    [anon_sym_delegatecall] = ACTIONS(913),
    [anon_sym_staticcall] = ACTIONS(913),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_revert] = ACTIONS(913),
    [anon_sym_selfdestruct] = ACTIONS(913),
    [anon_sym_invalid] = ACTIONS(913),
    [anon_sym_log0] = ACTIONS(913),
    [anon_sym_log1] = ACTIONS(913),
    [anon_sym_log2] = ACTIONS(913),
    [anon_sym_log3] = ACTIONS(913),
    [anon_sym_log4] = ACTIONS(913),
    [anon_sym_chainid] = ACTIONS(913),
    [anon_sym_origin] = ACTIONS(913),
    [anon_sym_gasprice] = ACTIONS(913),
    [anon_sym_blockhash] = ACTIONS(913),
    [anon_sym_blobhash] = ACTIONS(913),
    [anon_sym_basefee] = ACTIONS(913),
    [anon_sym_blobfee] = ACTIONS(913),
    [anon_sym_coinbase] = ACTIONS(913),
    [anon_sym_timestamp] = ACTIONS(913),
    [anon_sym_number] = ACTIONS(913),
    [anon_sym_difficulty] = ACTIONS(913),
    [anon_sym_gaslimit] = ACTIONS(913),
    [anon_sym_DQUOTE] = ACTIONS(916),
    [anon_sym_SQUOTE] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__yul_statement] = STATE(236),
    [sym_yul_label] = STATE(236),
    [sym_yul_break] = STATE(236),
    [sym_yul_continue] = STATE(236),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(236),
    [sym_yul_string_literal] = STATE(236),
    [sym_yul_boolean] = STATE(236),
    [sym_yul_block] = STATE(236),
    [sym_yul_variable_declaration] = STATE(236),
    [sym_yul_assignment] = STATE(236),
    [sym_yul_function_call] = STATE(236),
    [sym_yul_if_statement] = STATE(236),
    [sym_yul_for_statement] = STATE(236),
    [sym_yul_switch_statement] = STATE(236),
    [sym_yul_function_definition] = STATE(236),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(922),
    [sym_yul_hex_number] = ACTIONS(924),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym__yul_statement] = STATE(236),
    [sym_yul_label] = STATE(236),
    [sym_yul_break] = STATE(236),
    [sym_yul_continue] = STATE(236),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(236),
    [sym_yul_string_literal] = STATE(236),
    [sym_yul_boolean] = STATE(236),
    [sym_yul_block] = STATE(236),
    [sym_yul_variable_declaration] = STATE(236),
    [sym_yul_assignment] = STATE(236),
    [sym_yul_function_call] = STATE(236),
    [sym_yul_if_statement] = STATE(236),
    [sym_yul_for_statement] = STATE(236),
    [sym_yul_switch_statement] = STATE(236),
    [sym_yul_function_definition] = STATE(236),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(926),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(922),
    [sym_yul_hex_number] = ACTIONS(924),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym__yul_statement] = STATE(242),
    [sym_yul_label] = STATE(242),
    [sym_yul_break] = STATE(242),
    [sym_yul_continue] = STATE(242),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(242),
    [sym_yul_string_literal] = STATE(242),
    [sym_yul_boolean] = STATE(242),
    [sym_yul_block] = STATE(242),
    [sym_yul_variable_declaration] = STATE(242),
    [sym_yul_assignment] = STATE(242),
    [sym_yul_function_call] = STATE(242),
    [sym_yul_if_statement] = STATE(242),
    [sym_yul_for_statement] = STATE(242),
    [sym_yul_switch_statement] = STATE(242),
    [sym_yul_function_definition] = STATE(242),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(242),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(928),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(930),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(930),
    [sym_yul_hex_number] = ACTIONS(932),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__yul_statement] = STATE(236),
    [sym_yul_label] = STATE(236),
    [sym_yul_break] = STATE(236),
    [sym_yul_continue] = STATE(236),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(236),
    [sym_yul_string_literal] = STATE(236),
    [sym_yul_boolean] = STATE(236),
    [sym_yul_block] = STATE(236),
    [sym_yul_variable_declaration] = STATE(236),
    [sym_yul_assignment] = STATE(236),
    [sym_yul_function_call] = STATE(236),
    [sym_yul_if_statement] = STATE(236),
    [sym_yul_for_statement] = STATE(236),
    [sym_yul_switch_statement] = STATE(236),
    [sym_yul_function_definition] = STATE(236),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(922),
    [sym_yul_hex_number] = ACTIONS(924),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym__yul_statement] = STATE(237),
    [sym_yul_label] = STATE(237),
    [sym_yul_break] = STATE(237),
    [sym_yul_continue] = STATE(237),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(237),
    [sym_yul_string_literal] = STATE(237),
    [sym_yul_boolean] = STATE(237),
    [sym_yul_block] = STATE(237),
    [sym_yul_variable_declaration] = STATE(237),
    [sym_yul_assignment] = STATE(237),
    [sym_yul_function_call] = STATE(237),
    [sym_yul_if_statement] = STATE(237),
    [sym_yul_for_statement] = STATE(237),
    [sym_yul_switch_statement] = STATE(237),
    [sym_yul_function_definition] = STATE(237),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(237),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(934),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(936),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(936),
    [sym_yul_hex_number] = ACTIONS(938),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym__yul_statement] = STATE(236),
    [sym_yul_label] = STATE(236),
    [sym_yul_break] = STATE(236),
    [sym_yul_continue] = STATE(236),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(236),
    [sym_yul_string_literal] = STATE(236),
    [sym_yul_boolean] = STATE(236),
    [sym_yul_block] = STATE(236),
    [sym_yul_variable_declaration] = STATE(236),
    [sym_yul_assignment] = STATE(236),
    [sym_yul_function_call] = STATE(236),
    [sym_yul_if_statement] = STATE(236),
    [sym_yul_for_statement] = STATE(236),
    [sym_yul_switch_statement] = STATE(236),
    [sym_yul_function_definition] = STATE(236),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(236),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(940),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(922),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(922),
    [sym_yul_hex_number] = ACTIONS(924),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [sym__yul_statement] = STATE(240),
    [sym_yul_label] = STATE(240),
    [sym_yul_break] = STATE(240),
    [sym_yul_continue] = STATE(240),
    [sym_yul_identifier] = STATE(247),
    [sym_yul_path] = STATE(256),
    [sym__yul_literal] = STATE(240),
    [sym_yul_string_literal] = STATE(240),
    [sym_yul_boolean] = STATE(240),
    [sym_yul_block] = STATE(240),
    [sym_yul_variable_declaration] = STATE(240),
    [sym_yul_assignment] = STATE(240),
    [sym_yul_function_call] = STATE(240),
    [sym_yul_if_statement] = STATE(240),
    [sym_yul_for_statement] = STATE(240),
    [sym_yul_switch_statement] = STATE(240),
    [sym_yul_function_definition] = STATE(240),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [aux_sym_assembly_statement_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(843),
    [anon_sym_LBRACE] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(942),
    [anon_sym_for] = ACTIONS(849),
    [sym_yul_leave] = ACTIONS(944),
    [anon_sym_break] = ACTIONS(853),
    [anon_sym_continue] = ACTIONS(855),
    [sym_yul_decimal_number] = ACTIONS(944),
    [sym_yul_hex_number] = ACTIONS(946),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_let] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(863),
    [anon_sym_switch] = ACTIONS(865),
    [anon_sym_function] = ACTIONS(867),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_primitive_type] = STATE(729),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(950),
    [anon_sym_int40] = ACTIONS(950),
    [anon_sym_int48] = ACTIONS(950),
    [anon_sym_int56] = ACTIONS(950),
    [anon_sym_int64] = ACTIONS(950),
    [anon_sym_int72] = ACTIONS(950),
    [anon_sym_int80] = ACTIONS(950),
    [anon_sym_int88] = ACTIONS(950),
    [anon_sym_int96] = ACTIONS(950),
    [anon_sym_int104] = ACTIONS(950),
    [anon_sym_int112] = ACTIONS(950),
    [anon_sym_int120] = ACTIONS(950),
    [anon_sym_int128] = ACTIONS(950),
    [anon_sym_int136] = ACTIONS(950),
    [anon_sym_int144] = ACTIONS(950),
    [anon_sym_int152] = ACTIONS(950),
    [anon_sym_int160] = ACTIONS(950),
    [anon_sym_int168] = ACTIONS(950),
    [anon_sym_int176] = ACTIONS(950),
    [anon_sym_int184] = ACTIONS(950),
    [anon_sym_int192] = ACTIONS(950),
    [anon_sym_int200] = ACTIONS(950),
    [anon_sym_int208] = ACTIONS(950),
    [anon_sym_int216] = ACTIONS(950),
    [anon_sym_int224] = ACTIONS(950),
    [anon_sym_int232] = ACTIONS(950),
    [anon_sym_int240] = ACTIONS(950),
    [anon_sym_int248] = ACTIONS(950),
    [anon_sym_int256] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(950),
    [anon_sym_uint40] = ACTIONS(950),
    [anon_sym_uint48] = ACTIONS(950),
    [anon_sym_uint56] = ACTIONS(950),
    [anon_sym_uint64] = ACTIONS(950),
    [anon_sym_uint72] = ACTIONS(950),
    [anon_sym_uint80] = ACTIONS(950),
    [anon_sym_uint88] = ACTIONS(950),
    [anon_sym_uint96] = ACTIONS(950),
    [anon_sym_uint104] = ACTIONS(950),
    [anon_sym_uint112] = ACTIONS(950),
    [anon_sym_uint120] = ACTIONS(950),
    [anon_sym_uint128] = ACTIONS(950),
    [anon_sym_uint136] = ACTIONS(950),
    [anon_sym_uint144] = ACTIONS(950),
    [anon_sym_uint152] = ACTIONS(950),
    [anon_sym_uint160] = ACTIONS(950),
    [anon_sym_uint168] = ACTIONS(950),
    [anon_sym_uint176] = ACTIONS(950),
    [anon_sym_uint184] = ACTIONS(950),
    [anon_sym_uint192] = ACTIONS(950),
    [anon_sym_uint200] = ACTIONS(950),
    [anon_sym_uint208] = ACTIONS(950),
    [anon_sym_uint216] = ACTIONS(950),
    [anon_sym_uint224] = ACTIONS(950),
    [anon_sym_uint232] = ACTIONS(950),
    [anon_sym_uint240] = ACTIONS(950),
    [anon_sym_uint248] = ACTIONS(950),
    [anon_sym_uint256] = ACTIONS(950),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(950),
    [anon_sym_bytes5] = ACTIONS(950),
    [anon_sym_bytes6] = ACTIONS(950),
    [anon_sym_bytes7] = ACTIONS(950),
    [anon_sym_bytes8] = ACTIONS(950),
    [anon_sym_bytes9] = ACTIONS(950),
    [anon_sym_bytes10] = ACTIONS(950),
    [anon_sym_bytes11] = ACTIONS(950),
    [anon_sym_bytes12] = ACTIONS(950),
    [anon_sym_bytes13] = ACTIONS(950),
    [anon_sym_bytes14] = ACTIONS(950),
    [anon_sym_bytes15] = ACTIONS(950),
    [anon_sym_bytes16] = ACTIONS(950),
    [anon_sym_bytes17] = ACTIONS(950),
    [anon_sym_bytes18] = ACTIONS(950),
    [anon_sym_bytes19] = ACTIONS(950),
    [anon_sym_bytes20] = ACTIONS(950),
    [anon_sym_bytes21] = ACTIONS(950),
    [anon_sym_bytes22] = ACTIONS(950),
    [anon_sym_bytes23] = ACTIONS(950),
    [anon_sym_bytes24] = ACTIONS(950),
    [anon_sym_bytes25] = ACTIONS(950),
    [anon_sym_bytes26] = ACTIONS(950),
    [anon_sym_bytes27] = ACTIONS(950),
    [anon_sym_bytes28] = ACTIONS(950),
    [anon_sym_bytes29] = ACTIONS(950),
    [anon_sym_bytes30] = ACTIONS(950),
    [anon_sym_bytes31] = ACTIONS(950),
    [anon_sym_bytes32] = ACTIONS(950),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(950),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_primitive_type] = STATE(745),
    [sym__int] = STATE(338),
    [sym__uint] = STATE(338),
    [sym__bytes] = STATE(338),
    [sym__fixed] = STATE(338),
    [sym__ufixed] = STATE(338),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(948),
    [anon_sym_var] = ACTIONS(950),
    [anon_sym_bool] = ACTIONS(950),
    [anon_sym_string] = ACTIONS(950),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(950),
    [anon_sym_int40] = ACTIONS(950),
    [anon_sym_int48] = ACTIONS(950),
    [anon_sym_int56] = ACTIONS(950),
    [anon_sym_int64] = ACTIONS(950),
    [anon_sym_int72] = ACTIONS(950),
    [anon_sym_int80] = ACTIONS(950),
    [anon_sym_int88] = ACTIONS(950),
    [anon_sym_int96] = ACTIONS(950),
    [anon_sym_int104] = ACTIONS(950),
    [anon_sym_int112] = ACTIONS(950),
    [anon_sym_int120] = ACTIONS(950),
    [anon_sym_int128] = ACTIONS(950),
    [anon_sym_int136] = ACTIONS(950),
    [anon_sym_int144] = ACTIONS(950),
    [anon_sym_int152] = ACTIONS(950),
    [anon_sym_int160] = ACTIONS(950),
    [anon_sym_int168] = ACTIONS(950),
    [anon_sym_int176] = ACTIONS(950),
    [anon_sym_int184] = ACTIONS(950),
    [anon_sym_int192] = ACTIONS(950),
    [anon_sym_int200] = ACTIONS(950),
    [anon_sym_int208] = ACTIONS(950),
    [anon_sym_int216] = ACTIONS(950),
    [anon_sym_int224] = ACTIONS(950),
    [anon_sym_int232] = ACTIONS(950),
    [anon_sym_int240] = ACTIONS(950),
    [anon_sym_int248] = ACTIONS(950),
    [anon_sym_int256] = ACTIONS(950),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(950),
    [anon_sym_uint40] = ACTIONS(950),
    [anon_sym_uint48] = ACTIONS(950),
    [anon_sym_uint56] = ACTIONS(950),
    [anon_sym_uint64] = ACTIONS(950),
    [anon_sym_uint72] = ACTIONS(950),
    [anon_sym_uint80] = ACTIONS(950),
    [anon_sym_uint88] = ACTIONS(950),
    [anon_sym_uint96] = ACTIONS(950),
    [anon_sym_uint104] = ACTIONS(950),
    [anon_sym_uint112] = ACTIONS(950),
    [anon_sym_uint120] = ACTIONS(950),
    [anon_sym_uint128] = ACTIONS(950),
    [anon_sym_uint136] = ACTIONS(950),
    [anon_sym_uint144] = ACTIONS(950),
    [anon_sym_uint152] = ACTIONS(950),
    [anon_sym_uint160] = ACTIONS(950),
    [anon_sym_uint168] = ACTIONS(950),
    [anon_sym_uint176] = ACTIONS(950),
    [anon_sym_uint184] = ACTIONS(950),
    [anon_sym_uint192] = ACTIONS(950),
    [anon_sym_uint200] = ACTIONS(950),
    [anon_sym_uint208] = ACTIONS(950),
    [anon_sym_uint216] = ACTIONS(950),
    [anon_sym_uint224] = ACTIONS(950),
    [anon_sym_uint232] = ACTIONS(950),
    [anon_sym_uint240] = ACTIONS(950),
    [anon_sym_uint248] = ACTIONS(950),
    [anon_sym_uint256] = ACTIONS(950),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(950),
    [anon_sym_bytes5] = ACTIONS(950),
    [anon_sym_bytes6] = ACTIONS(950),
    [anon_sym_bytes7] = ACTIONS(950),
    [anon_sym_bytes8] = ACTIONS(950),
    [anon_sym_bytes9] = ACTIONS(950),
    [anon_sym_bytes10] = ACTIONS(950),
    [anon_sym_bytes11] = ACTIONS(950),
    [anon_sym_bytes12] = ACTIONS(950),
    [anon_sym_bytes13] = ACTIONS(950),
    [anon_sym_bytes14] = ACTIONS(950),
    [anon_sym_bytes15] = ACTIONS(950),
    [anon_sym_bytes16] = ACTIONS(950),
    [anon_sym_bytes17] = ACTIONS(950),
    [anon_sym_bytes18] = ACTIONS(950),
    [anon_sym_bytes19] = ACTIONS(950),
    [anon_sym_bytes20] = ACTIONS(950),
    [anon_sym_bytes21] = ACTIONS(950),
    [anon_sym_bytes22] = ACTIONS(950),
    [anon_sym_bytes23] = ACTIONS(950),
    [anon_sym_bytes24] = ACTIONS(950),
    [anon_sym_bytes25] = ACTIONS(950),
    [anon_sym_bytes26] = ACTIONS(950),
    [anon_sym_bytes27] = ACTIONS(950),
    [anon_sym_bytes28] = ACTIONS(950),
    [anon_sym_bytes29] = ACTIONS(950),
    [anon_sym_bytes30] = ACTIONS(950),
    [anon_sym_bytes31] = ACTIONS(950),
    [anon_sym_bytes32] = ACTIONS(950),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(950),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(950),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym_identifier] = ACTIONS(952),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_byte] = ACTIONS(952),
    [anon_sym_address] = ACTIONS(952),
    [anon_sym_var] = ACTIONS(952),
    [anon_sym_mapping] = ACTIONS(952),
    [anon_sym_bool] = ACTIONS(952),
    [anon_sym_string] = ACTIONS(952),
    [anon_sym_int] = ACTIONS(952),
    [anon_sym_int8] = ACTIONS(952),
    [anon_sym_int16] = ACTIONS(952),
    [anon_sym_int24] = ACTIONS(952),
    [anon_sym_int32] = ACTIONS(952),
    [anon_sym_int40] = ACTIONS(952),
    [anon_sym_int48] = ACTIONS(952),
    [anon_sym_int56] = ACTIONS(952),
    [anon_sym_int64] = ACTIONS(952),
    [anon_sym_int72] = ACTIONS(952),
    [anon_sym_int80] = ACTIONS(952),
    [anon_sym_int88] = ACTIONS(952),
    [anon_sym_int96] = ACTIONS(952),
    [anon_sym_int104] = ACTIONS(952),
    [anon_sym_int112] = ACTIONS(952),
    [anon_sym_int120] = ACTIONS(952),
    [anon_sym_int128] = ACTIONS(952),
    [anon_sym_int136] = ACTIONS(952),
    [anon_sym_int144] = ACTIONS(952),
    [anon_sym_int152] = ACTIONS(952),
    [anon_sym_int160] = ACTIONS(952),
    [anon_sym_int168] = ACTIONS(952),
    [anon_sym_int176] = ACTIONS(952),
    [anon_sym_int184] = ACTIONS(952),
    [anon_sym_int192] = ACTIONS(952),
    [anon_sym_int200] = ACTIONS(952),
    [anon_sym_int208] = ACTIONS(952),
    [anon_sym_int216] = ACTIONS(952),
    [anon_sym_int224] = ACTIONS(952),
    [anon_sym_int232] = ACTIONS(952),
    [anon_sym_int240] = ACTIONS(952),
    [anon_sym_int248] = ACTIONS(952),
    [anon_sym_int256] = ACTIONS(952),
    [anon_sym_uint] = ACTIONS(952),
    [anon_sym_uint8] = ACTIONS(952),
    [anon_sym_uint16] = ACTIONS(952),
    [anon_sym_uint24] = ACTIONS(952),
    [anon_sym_uint32] = ACTIONS(952),
    [anon_sym_uint40] = ACTIONS(952),
    [anon_sym_uint48] = ACTIONS(952),
    [anon_sym_uint56] = ACTIONS(952),
    [anon_sym_uint64] = ACTIONS(952),
    [anon_sym_uint72] = ACTIONS(952),
    [anon_sym_uint80] = ACTIONS(952),
    [anon_sym_uint88] = ACTIONS(952),
    [anon_sym_uint96] = ACTIONS(952),
    [anon_sym_uint104] = ACTIONS(952),
    [anon_sym_uint112] = ACTIONS(952),
    [anon_sym_uint120] = ACTIONS(952),
    [anon_sym_uint128] = ACTIONS(952),
    [anon_sym_uint136] = ACTIONS(952),
    [anon_sym_uint144] = ACTIONS(952),
    [anon_sym_uint152] = ACTIONS(952),
    [anon_sym_uint160] = ACTIONS(952),
    [anon_sym_uint168] = ACTIONS(952),
    [anon_sym_uint176] = ACTIONS(952),
    [anon_sym_uint184] = ACTIONS(952),
    [anon_sym_uint192] = ACTIONS(952),
    [anon_sym_uint200] = ACTIONS(952),
    [anon_sym_uint208] = ACTIONS(952),
    [anon_sym_uint216] = ACTIONS(952),
    [anon_sym_uint224] = ACTIONS(952),
    [anon_sym_uint232] = ACTIONS(952),
    [anon_sym_uint240] = ACTIONS(952),
    [anon_sym_uint248] = ACTIONS(952),
    [anon_sym_uint256] = ACTIONS(952),
    [anon_sym_bytes] = ACTIONS(952),
    [anon_sym_bytes1] = ACTIONS(952),
    [anon_sym_bytes2] = ACTIONS(952),
    [anon_sym_bytes3] = ACTIONS(952),
    [anon_sym_bytes4] = ACTIONS(952),
    [anon_sym_bytes5] = ACTIONS(952),
    [anon_sym_bytes6] = ACTIONS(952),
    [anon_sym_bytes7] = ACTIONS(952),
    [anon_sym_bytes8] = ACTIONS(952),
    [anon_sym_bytes9] = ACTIONS(952),
    [anon_sym_bytes10] = ACTIONS(952),
    [anon_sym_bytes11] = ACTIONS(952),
    [anon_sym_bytes12] = ACTIONS(952),
    [anon_sym_bytes13] = ACTIONS(952),
    [anon_sym_bytes14] = ACTIONS(952),
    [anon_sym_bytes15] = ACTIONS(952),
    [anon_sym_bytes16] = ACTIONS(952),
    [anon_sym_bytes17] = ACTIONS(952),
    [anon_sym_bytes18] = ACTIONS(952),
    [anon_sym_bytes19] = ACTIONS(952),
    [anon_sym_bytes20] = ACTIONS(952),
    [anon_sym_bytes21] = ACTIONS(952),
    [anon_sym_bytes22] = ACTIONS(952),
    [anon_sym_bytes23] = ACTIONS(952),
    [anon_sym_bytes24] = ACTIONS(952),
    [anon_sym_bytes25] = ACTIONS(952),
    [anon_sym_bytes26] = ACTIONS(952),
    [anon_sym_bytes27] = ACTIONS(952),
    [anon_sym_bytes28] = ACTIONS(952),
    [anon_sym_bytes29] = ACTIONS(952),
    [anon_sym_bytes30] = ACTIONS(952),
    [anon_sym_bytes31] = ACTIONS(952),
    [anon_sym_bytes32] = ACTIONS(952),
    [anon_sym_fixed] = ACTIONS(952),
    [aux_sym__fixed_token1] = ACTIONS(952),
    [anon_sym_ufixed] = ACTIONS(952),
    [aux_sym__ufixed_token1] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [aux_sym_yul_path_repeat1] = STATE(248),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_COLON] = ACTIONS(956),
    [sym_yul_leave] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_DOT] = ACTIONS(962),
    [sym_yul_decimal_number] = ACTIONS(956),
    [sym_yul_hex_number] = ACTIONS(958),
    [anon_sym_true] = ACTIONS(956),
    [anon_sym_false] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_COLON_EQ] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(956),
    [anon_sym_stop] = ACTIONS(956),
    [anon_sym_add] = ACTIONS(956),
    [anon_sym_sub] = ACTIONS(956),
    [anon_sym_mul] = ACTIONS(956),
    [anon_sym_div] = ACTIONS(956),
    [anon_sym_sdiv] = ACTIONS(956),
    [anon_sym_mod] = ACTIONS(956),
    [anon_sym_smod] = ACTIONS(956),
    [anon_sym_exp] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(956),
    [anon_sym_lt] = ACTIONS(956),
    [anon_sym_gt] = ACTIONS(956),
    [anon_sym_slt] = ACTIONS(956),
    [anon_sym_sgt] = ACTIONS(956),
    [anon_sym_eq] = ACTIONS(956),
    [anon_sym_iszero] = ACTIONS(956),
    [anon_sym_and] = ACTIONS(956),
    [anon_sym_or] = ACTIONS(956),
    [anon_sym_xor] = ACTIONS(956),
    [anon_sym_byte] = ACTIONS(956),
    [anon_sym_shl] = ACTIONS(956),
    [anon_sym_shr] = ACTIONS(956),
    [anon_sym_sar] = ACTIONS(956),
    [anon_sym_addmod] = ACTIONS(956),
    [anon_sym_mulmod] = ACTIONS(956),
    [anon_sym_signextend] = ACTIONS(956),
    [anon_sym_keccak256] = ACTIONS(956),
    [anon_sym_pop] = ACTIONS(956),
    [anon_sym_mload] = ACTIONS(956),
    [anon_sym_mcopy] = ACTIONS(956),
    [anon_sym_tload] = ACTIONS(956),
    [anon_sym_tstore] = ACTIONS(956),
    [anon_sym_mstore] = ACTIONS(956),
    [anon_sym_mstore8] = ACTIONS(956),
    [anon_sym_sload] = ACTIONS(956),
    [anon_sym_sstore] = ACTIONS(956),
    [anon_sym_msize] = ACTIONS(956),
    [anon_sym_gas] = ACTIONS(956),
    [anon_sym_address] = ACTIONS(956),
    [anon_sym_balance] = ACTIONS(956),
    [anon_sym_selfbalance] = ACTIONS(956),
    [anon_sym_caller] = ACTIONS(956),
    [anon_sym_callvalue] = ACTIONS(956),
    [anon_sym_calldataload] = ACTIONS(956),
    [anon_sym_calldatasize] = ACTIONS(956),
    [anon_sym_calldatacopy] = ACTIONS(956),
    [anon_sym_extcodesize] = ACTIONS(956),
    [anon_sym_extcodecopy] = ACTIONS(956),
    [anon_sym_returndatasize] = ACTIONS(956),
    [anon_sym_returndatacopy] = ACTIONS(956),
    [anon_sym_extcodehash] = ACTIONS(956),
    [anon_sym_create] = ACTIONS(956),
    [anon_sym_create2] = ACTIONS(956),
    [anon_sym_call] = ACTIONS(956),
    [anon_sym_callcode] = ACTIONS(956),
    [anon_sym_delegatecall] = ACTIONS(956),
    [anon_sym_staticcall] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_revert] = ACTIONS(956),
    [anon_sym_selfdestruct] = ACTIONS(956),
    [anon_sym_invalid] = ACTIONS(956),
    [anon_sym_log0] = ACTIONS(956),
    [anon_sym_log1] = ACTIONS(956),
    [anon_sym_log2] = ACTIONS(956),
    [anon_sym_log3] = ACTIONS(956),
    [anon_sym_log4] = ACTIONS(956),
    [anon_sym_chainid] = ACTIONS(956),
    [anon_sym_origin] = ACTIONS(956),
    [anon_sym_gasprice] = ACTIONS(956),
    [anon_sym_blockhash] = ACTIONS(956),
    [anon_sym_blobhash] = ACTIONS(956),
    [anon_sym_basefee] = ACTIONS(956),
    [anon_sym_blobfee] = ACTIONS(956),
    [anon_sym_coinbase] = ACTIONS(956),
    [anon_sym_timestamp] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_difficulty] = ACTIONS(956),
    [anon_sym_gaslimit] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [aux_sym_yul_path_repeat1] = STATE(249),
    [sym_identifier] = ACTIONS(964),
    [anon_sym_LBRACE] = ACTIONS(966),
    [anon_sym_COMMA] = ACTIONS(966),
    [anon_sym_RBRACE] = ACTIONS(966),
    [anon_sym_RPAREN] = ACTIONS(966),
    [anon_sym_for] = ACTIONS(964),
    [anon_sym_COLON] = ACTIONS(964),
    [sym_yul_leave] = ACTIONS(964),
    [anon_sym_break] = ACTIONS(964),
    [anon_sym_continue] = ACTIONS(964),
    [anon_sym_DOT] = ACTIONS(962),
    [sym_yul_decimal_number] = ACTIONS(964),
    [sym_yul_hex_number] = ACTIONS(966),
    [anon_sym_true] = ACTIONS(964),
    [anon_sym_false] = ACTIONS(964),
    [anon_sym_let] = ACTIONS(964),
    [anon_sym_COLON_EQ] = ACTIONS(966),
    [anon_sym_if] = ACTIONS(964),
    [anon_sym_switch] = ACTIONS(964),
    [anon_sym_default] = ACTIONS(964),
    [anon_sym_case] = ACTIONS(964),
    [anon_sym_function] = ACTIONS(964),
    [anon_sym_stop] = ACTIONS(964),
    [anon_sym_add] = ACTIONS(964),
    [anon_sym_sub] = ACTIONS(964),
    [anon_sym_mul] = ACTIONS(964),
    [anon_sym_div] = ACTIONS(964),
    [anon_sym_sdiv] = ACTIONS(964),
    [anon_sym_mod] = ACTIONS(964),
    [anon_sym_smod] = ACTIONS(964),
    [anon_sym_exp] = ACTIONS(964),
    [anon_sym_not] = ACTIONS(964),
    [anon_sym_lt] = ACTIONS(964),
    [anon_sym_gt] = ACTIONS(964),
    [anon_sym_slt] = ACTIONS(964),
    [anon_sym_sgt] = ACTIONS(964),
    [anon_sym_eq] = ACTIONS(964),
    [anon_sym_iszero] = ACTIONS(964),
    [anon_sym_and] = ACTIONS(964),
    [anon_sym_or] = ACTIONS(964),
    [anon_sym_xor] = ACTIONS(964),
    [anon_sym_byte] = ACTIONS(964),
    [anon_sym_shl] = ACTIONS(964),
    [anon_sym_shr] = ACTIONS(964),
    [anon_sym_sar] = ACTIONS(964),
    [anon_sym_addmod] = ACTIONS(964),
    [anon_sym_mulmod] = ACTIONS(964),
    [anon_sym_signextend] = ACTIONS(964),
    [anon_sym_keccak256] = ACTIONS(964),
    [anon_sym_pop] = ACTIONS(964),
    [anon_sym_mload] = ACTIONS(964),
    [anon_sym_mcopy] = ACTIONS(964),
    [anon_sym_tload] = ACTIONS(964),
    [anon_sym_tstore] = ACTIONS(964),
    [anon_sym_mstore] = ACTIONS(964),
    [anon_sym_mstore8] = ACTIONS(964),
    [anon_sym_sload] = ACTIONS(964),
    [anon_sym_sstore] = ACTIONS(964),
    [anon_sym_msize] = ACTIONS(964),
    [anon_sym_gas] = ACTIONS(964),
    [anon_sym_address] = ACTIONS(964),
    [anon_sym_balance] = ACTIONS(964),
    [anon_sym_selfbalance] = ACTIONS(964),
    [anon_sym_caller] = ACTIONS(964),
    [anon_sym_callvalue] = ACTIONS(964),
    [anon_sym_calldataload] = ACTIONS(964),
    [anon_sym_calldatasize] = ACTIONS(964),
    [anon_sym_calldatacopy] = ACTIONS(964),
    [anon_sym_extcodesize] = ACTIONS(964),
    [anon_sym_extcodecopy] = ACTIONS(964),
    [anon_sym_returndatasize] = ACTIONS(964),
    [anon_sym_returndatacopy] = ACTIONS(964),
    [anon_sym_extcodehash] = ACTIONS(964),
    [anon_sym_create] = ACTIONS(964),
    [anon_sym_create2] = ACTIONS(964),
    [anon_sym_call] = ACTIONS(964),
    [anon_sym_callcode] = ACTIONS(964),
    [anon_sym_delegatecall] = ACTIONS(964),
    [anon_sym_staticcall] = ACTIONS(964),
    [anon_sym_return] = ACTIONS(964),
    [anon_sym_revert] = ACTIONS(964),
    [anon_sym_selfdestruct] = ACTIONS(964),
    [anon_sym_invalid] = ACTIONS(964),
    [anon_sym_log0] = ACTIONS(964),
    [anon_sym_log1] = ACTIONS(964),
    [anon_sym_log2] = ACTIONS(964),
    [anon_sym_log3] = ACTIONS(964),
    [anon_sym_log4] = ACTIONS(964),
    [anon_sym_chainid] = ACTIONS(964),
    [anon_sym_origin] = ACTIONS(964),
    [anon_sym_gasprice] = ACTIONS(964),
    [anon_sym_blockhash] = ACTIONS(964),
    [anon_sym_blobhash] = ACTIONS(964),
    [anon_sym_basefee] = ACTIONS(964),
    [anon_sym_blobfee] = ACTIONS(964),
    [anon_sym_coinbase] = ACTIONS(964),
    [anon_sym_timestamp] = ACTIONS(964),
    [anon_sym_number] = ACTIONS(964),
    [anon_sym_difficulty] = ACTIONS(964),
    [anon_sym_gaslimit] = ACTIONS(964),
    [anon_sym_DQUOTE] = ACTIONS(966),
    [anon_sym_SQUOTE] = ACTIONS(966),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [aux_sym_yul_path_repeat1] = STATE(249),
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_COMMA] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_RPAREN] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(968),
    [sym_yul_leave] = ACTIONS(968),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_DOT] = ACTIONS(972),
    [sym_yul_decimal_number] = ACTIONS(968),
    [sym_yul_hex_number] = ACTIONS(970),
    [anon_sym_true] = ACTIONS(968),
    [anon_sym_false] = ACTIONS(968),
    [anon_sym_let] = ACTIONS(968),
    [anon_sym_COLON_EQ] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_function] = ACTIONS(968),
    [anon_sym_stop] = ACTIONS(968),
    [anon_sym_add] = ACTIONS(968),
    [anon_sym_sub] = ACTIONS(968),
    [anon_sym_mul] = ACTIONS(968),
    [anon_sym_div] = ACTIONS(968),
    [anon_sym_sdiv] = ACTIONS(968),
    [anon_sym_mod] = ACTIONS(968),
    [anon_sym_smod] = ACTIONS(968),
    [anon_sym_exp] = ACTIONS(968),
    [anon_sym_not] = ACTIONS(968),
    [anon_sym_lt] = ACTIONS(968),
    [anon_sym_gt] = ACTIONS(968),
    [anon_sym_slt] = ACTIONS(968),
    [anon_sym_sgt] = ACTIONS(968),
    [anon_sym_eq] = ACTIONS(968),
    [anon_sym_iszero] = ACTIONS(968),
    [anon_sym_and] = ACTIONS(968),
    [anon_sym_or] = ACTIONS(968),
    [anon_sym_xor] = ACTIONS(968),
    [anon_sym_byte] = ACTIONS(968),
    [anon_sym_shl] = ACTIONS(968),
    [anon_sym_shr] = ACTIONS(968),
    [anon_sym_sar] = ACTIONS(968),
    [anon_sym_addmod] = ACTIONS(968),
    [anon_sym_mulmod] = ACTIONS(968),
    [anon_sym_signextend] = ACTIONS(968),
    [anon_sym_keccak256] = ACTIONS(968),
    [anon_sym_pop] = ACTIONS(968),
    [anon_sym_mload] = ACTIONS(968),
    [anon_sym_mcopy] = ACTIONS(968),
    [anon_sym_tload] = ACTIONS(968),
    [anon_sym_tstore] = ACTIONS(968),
    [anon_sym_mstore] = ACTIONS(968),
    [anon_sym_mstore8] = ACTIONS(968),
    [anon_sym_sload] = ACTIONS(968),
    [anon_sym_sstore] = ACTIONS(968),
    [anon_sym_msize] = ACTIONS(968),
    [anon_sym_gas] = ACTIONS(968),
    [anon_sym_address] = ACTIONS(968),
    [anon_sym_balance] = ACTIONS(968),
    [anon_sym_selfbalance] = ACTIONS(968),
    [anon_sym_caller] = ACTIONS(968),
    [anon_sym_callvalue] = ACTIONS(968),
    [anon_sym_calldataload] = ACTIONS(968),
    [anon_sym_calldatasize] = ACTIONS(968),
    [anon_sym_calldatacopy] = ACTIONS(968),
    [anon_sym_extcodesize] = ACTIONS(968),
    [anon_sym_extcodecopy] = ACTIONS(968),
    [anon_sym_returndatasize] = ACTIONS(968),
    [anon_sym_returndatacopy] = ACTIONS(968),
    [anon_sym_extcodehash] = ACTIONS(968),
    [anon_sym_create] = ACTIONS(968),
    [anon_sym_create2] = ACTIONS(968),
    [anon_sym_call] = ACTIONS(968),
    [anon_sym_callcode] = ACTIONS(968),
    [anon_sym_delegatecall] = ACTIONS(968),
    [anon_sym_staticcall] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_revert] = ACTIONS(968),
    [anon_sym_selfdestruct] = ACTIONS(968),
    [anon_sym_invalid] = ACTIONS(968),
    [anon_sym_log0] = ACTIONS(968),
    [anon_sym_log1] = ACTIONS(968),
    [anon_sym_log2] = ACTIONS(968),
    [anon_sym_log3] = ACTIONS(968),
    [anon_sym_log4] = ACTIONS(968),
    [anon_sym_chainid] = ACTIONS(968),
    [anon_sym_origin] = ACTIONS(968),
    [anon_sym_gasprice] = ACTIONS(968),
    [anon_sym_blockhash] = ACTIONS(968),
    [anon_sym_blobhash] = ACTIONS(968),
    [anon_sym_basefee] = ACTIONS(968),
    [anon_sym_blobfee] = ACTIONS(968),
    [anon_sym_coinbase] = ACTIONS(968),
    [anon_sym_timestamp] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_difficulty] = ACTIONS(968),
    [anon_sym_gaslimit] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [anon_sym_SQUOTE] = ACTIONS(970),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [sym_identifier] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_COLON] = ACTIONS(975),
    [sym_yul_leave] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_yul_decimal_number] = ACTIONS(975),
    [sym_yul_hex_number] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [anon_sym_let] = ACTIONS(975),
    [anon_sym_COLON_EQ] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_default] = ACTIONS(975),
    [anon_sym_case] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_stop] = ACTIONS(975),
    [anon_sym_add] = ACTIONS(975),
    [anon_sym_sub] = ACTIONS(975),
    [anon_sym_mul] = ACTIONS(975),
    [anon_sym_div] = ACTIONS(975),
    [anon_sym_sdiv] = ACTIONS(975),
    [anon_sym_mod] = ACTIONS(975),
    [anon_sym_smod] = ACTIONS(975),
    [anon_sym_exp] = ACTIONS(975),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_lt] = ACTIONS(975),
    [anon_sym_gt] = ACTIONS(975),
    [anon_sym_slt] = ACTIONS(975),
    [anon_sym_sgt] = ACTIONS(975),
    [anon_sym_eq] = ACTIONS(975),
    [anon_sym_iszero] = ACTIONS(975),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_or] = ACTIONS(975),
    [anon_sym_xor] = ACTIONS(975),
    [anon_sym_byte] = ACTIONS(975),
    [anon_sym_shl] = ACTIONS(975),
    [anon_sym_shr] = ACTIONS(975),
    [anon_sym_sar] = ACTIONS(975),
    [anon_sym_addmod] = ACTIONS(975),
    [anon_sym_mulmod] = ACTIONS(975),
    [anon_sym_signextend] = ACTIONS(975),
    [anon_sym_keccak256] = ACTIONS(975),
    [anon_sym_pop] = ACTIONS(975),
    [anon_sym_mload] = ACTIONS(975),
    [anon_sym_mcopy] = ACTIONS(975),
    [anon_sym_tload] = ACTIONS(975),
    [anon_sym_tstore] = ACTIONS(975),
    [anon_sym_mstore] = ACTIONS(975),
    [anon_sym_mstore8] = ACTIONS(975),
    [anon_sym_sload] = ACTIONS(975),
    [anon_sym_sstore] = ACTIONS(975),
    [anon_sym_msize] = ACTIONS(975),
    [anon_sym_gas] = ACTIONS(975),
    [anon_sym_address] = ACTIONS(975),
    [anon_sym_balance] = ACTIONS(975),
    [anon_sym_selfbalance] = ACTIONS(975),
    [anon_sym_caller] = ACTIONS(975),
    [anon_sym_callvalue] = ACTIONS(975),
    [anon_sym_calldataload] = ACTIONS(975),
    [anon_sym_calldatasize] = ACTIONS(975),
    [anon_sym_calldatacopy] = ACTIONS(975),
    [anon_sym_extcodesize] = ACTIONS(975),
    [anon_sym_extcodecopy] = ACTIONS(975),
    [anon_sym_returndatasize] = ACTIONS(975),
    [anon_sym_returndatacopy] = ACTIONS(975),
    [anon_sym_extcodehash] = ACTIONS(975),
    [anon_sym_create] = ACTIONS(975),
    [anon_sym_create2] = ACTIONS(975),
    [anon_sym_call] = ACTIONS(975),
    [anon_sym_callcode] = ACTIONS(975),
    [anon_sym_delegatecall] = ACTIONS(975),
    [anon_sym_staticcall] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_revert] = ACTIONS(975),
    [anon_sym_selfdestruct] = ACTIONS(975),
    [anon_sym_invalid] = ACTIONS(975),
    [anon_sym_log0] = ACTIONS(975),
    [anon_sym_log1] = ACTIONS(975),
    [anon_sym_log2] = ACTIONS(975),
    [anon_sym_log3] = ACTIONS(975),
    [anon_sym_log4] = ACTIONS(975),
    [anon_sym_chainid] = ACTIONS(975),
    [anon_sym_origin] = ACTIONS(975),
    [anon_sym_gasprice] = ACTIONS(975),
    [anon_sym_blockhash] = ACTIONS(975),
    [anon_sym_blobhash] = ACTIONS(975),
    [anon_sym_basefee] = ACTIONS(975),
    [anon_sym_blobfee] = ACTIONS(975),
    [anon_sym_coinbase] = ACTIONS(975),
    [anon_sym_timestamp] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_difficulty] = ACTIONS(975),
    [anon_sym_gaslimit] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [sym_identifier] = ACTIONS(968),
    [anon_sym_LBRACE] = ACTIONS(970),
    [anon_sym_COMMA] = ACTIONS(970),
    [anon_sym_RBRACE] = ACTIONS(970),
    [anon_sym_RPAREN] = ACTIONS(970),
    [anon_sym_for] = ACTIONS(968),
    [anon_sym_COLON] = ACTIONS(968),
    [sym_yul_leave] = ACTIONS(968),
    [anon_sym_break] = ACTIONS(968),
    [anon_sym_continue] = ACTIONS(968),
    [anon_sym_DOT] = ACTIONS(970),
    [sym_yul_decimal_number] = ACTIONS(968),
    [sym_yul_hex_number] = ACTIONS(970),
    [anon_sym_true] = ACTIONS(968),
    [anon_sym_false] = ACTIONS(968),
    [anon_sym_let] = ACTIONS(968),
    [anon_sym_COLON_EQ] = ACTIONS(970),
    [anon_sym_if] = ACTIONS(968),
    [anon_sym_switch] = ACTIONS(968),
    [anon_sym_default] = ACTIONS(968),
    [anon_sym_case] = ACTIONS(968),
    [anon_sym_function] = ACTIONS(968),
    [anon_sym_stop] = ACTIONS(968),
    [anon_sym_add] = ACTIONS(968),
    [anon_sym_sub] = ACTIONS(968),
    [anon_sym_mul] = ACTIONS(968),
    [anon_sym_div] = ACTIONS(968),
    [anon_sym_sdiv] = ACTIONS(968),
    [anon_sym_mod] = ACTIONS(968),
    [anon_sym_smod] = ACTIONS(968),
    [anon_sym_exp] = ACTIONS(968),
    [anon_sym_not] = ACTIONS(968),
    [anon_sym_lt] = ACTIONS(968),
    [anon_sym_gt] = ACTIONS(968),
    [anon_sym_slt] = ACTIONS(968),
    [anon_sym_sgt] = ACTIONS(968),
    [anon_sym_eq] = ACTIONS(968),
    [anon_sym_iszero] = ACTIONS(968),
    [anon_sym_and] = ACTIONS(968),
    [anon_sym_or] = ACTIONS(968),
    [anon_sym_xor] = ACTIONS(968),
    [anon_sym_byte] = ACTIONS(968),
    [anon_sym_shl] = ACTIONS(968),
    [anon_sym_shr] = ACTIONS(968),
    [anon_sym_sar] = ACTIONS(968),
    [anon_sym_addmod] = ACTIONS(968),
    [anon_sym_mulmod] = ACTIONS(968),
    [anon_sym_signextend] = ACTIONS(968),
    [anon_sym_keccak256] = ACTIONS(968),
    [anon_sym_pop] = ACTIONS(968),
    [anon_sym_mload] = ACTIONS(968),
    [anon_sym_mcopy] = ACTIONS(968),
    [anon_sym_tload] = ACTIONS(968),
    [anon_sym_tstore] = ACTIONS(968),
    [anon_sym_mstore] = ACTIONS(968),
    [anon_sym_mstore8] = ACTIONS(968),
    [anon_sym_sload] = ACTIONS(968),
    [anon_sym_sstore] = ACTIONS(968),
    [anon_sym_msize] = ACTIONS(968),
    [anon_sym_gas] = ACTIONS(968),
    [anon_sym_address] = ACTIONS(968),
    [anon_sym_balance] = ACTIONS(968),
    [anon_sym_selfbalance] = ACTIONS(968),
    [anon_sym_caller] = ACTIONS(968),
    [anon_sym_callvalue] = ACTIONS(968),
    [anon_sym_calldataload] = ACTIONS(968),
    [anon_sym_calldatasize] = ACTIONS(968),
    [anon_sym_calldatacopy] = ACTIONS(968),
    [anon_sym_extcodesize] = ACTIONS(968),
    [anon_sym_extcodecopy] = ACTIONS(968),
    [anon_sym_returndatasize] = ACTIONS(968),
    [anon_sym_returndatacopy] = ACTIONS(968),
    [anon_sym_extcodehash] = ACTIONS(968),
    [anon_sym_create] = ACTIONS(968),
    [anon_sym_create2] = ACTIONS(968),
    [anon_sym_call] = ACTIONS(968),
    [anon_sym_callcode] = ACTIONS(968),
    [anon_sym_delegatecall] = ACTIONS(968),
    [anon_sym_staticcall] = ACTIONS(968),
    [anon_sym_return] = ACTIONS(968),
    [anon_sym_revert] = ACTIONS(968),
    [anon_sym_selfdestruct] = ACTIONS(968),
    [anon_sym_invalid] = ACTIONS(968),
    [anon_sym_log0] = ACTIONS(968),
    [anon_sym_log1] = ACTIONS(968),
    [anon_sym_log2] = ACTIONS(968),
    [anon_sym_log3] = ACTIONS(968),
    [anon_sym_log4] = ACTIONS(968),
    [anon_sym_chainid] = ACTIONS(968),
    [anon_sym_origin] = ACTIONS(968),
    [anon_sym_gasprice] = ACTIONS(968),
    [anon_sym_blockhash] = ACTIONS(968),
    [anon_sym_blobhash] = ACTIONS(968),
    [anon_sym_basefee] = ACTIONS(968),
    [anon_sym_blobfee] = ACTIONS(968),
    [anon_sym_coinbase] = ACTIONS(968),
    [anon_sym_timestamp] = ACTIONS(968),
    [anon_sym_number] = ACTIONS(968),
    [anon_sym_difficulty] = ACTIONS(968),
    [anon_sym_gaslimit] = ACTIONS(968),
    [anon_sym_DQUOTE] = ACTIONS(970),
    [anon_sym_SQUOTE] = ACTIONS(970),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym__yul_assignment_operator] = STATE(322),
    [aux_sym_yul_assignment_repeat1] = STATE(260),
    [sym_identifier] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_COMMA] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_COLON] = ACTIONS(985),
    [sym_yul_leave] = ACTIONS(979),
    [anon_sym_break] = ACTIONS(979),
    [anon_sym_continue] = ACTIONS(979),
    [sym_yul_decimal_number] = ACTIONS(979),
    [sym_yul_hex_number] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(979),
    [anon_sym_false] = ACTIONS(979),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_COLON_EQ] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_function] = ACTIONS(979),
    [anon_sym_stop] = ACTIONS(979),
    [anon_sym_add] = ACTIONS(979),
    [anon_sym_sub] = ACTIONS(979),
    [anon_sym_mul] = ACTIONS(979),
    [anon_sym_div] = ACTIONS(979),
    [anon_sym_sdiv] = ACTIONS(979),
    [anon_sym_mod] = ACTIONS(979),
    [anon_sym_smod] = ACTIONS(979),
    [anon_sym_exp] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(979),
    [anon_sym_lt] = ACTIONS(979),
    [anon_sym_gt] = ACTIONS(979),
    [anon_sym_slt] = ACTIONS(979),
    [anon_sym_sgt] = ACTIONS(979),
    [anon_sym_eq] = ACTIONS(979),
    [anon_sym_iszero] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(979),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_xor] = ACTIONS(979),
    [anon_sym_byte] = ACTIONS(979),
    [anon_sym_shl] = ACTIONS(979),
    [anon_sym_shr] = ACTIONS(979),
    [anon_sym_sar] = ACTIONS(979),
    [anon_sym_addmod] = ACTIONS(979),
    [anon_sym_mulmod] = ACTIONS(979),
    [anon_sym_signextend] = ACTIONS(979),
    [anon_sym_keccak256] = ACTIONS(979),
    [anon_sym_pop] = ACTIONS(979),
    [anon_sym_mload] = ACTIONS(979),
    [anon_sym_mcopy] = ACTIONS(979),
    [anon_sym_tload] = ACTIONS(979),
    [anon_sym_tstore] = ACTIONS(979),
    [anon_sym_mstore] = ACTIONS(979),
    [anon_sym_mstore8] = ACTIONS(979),
    [anon_sym_sload] = ACTIONS(979),
    [anon_sym_sstore] = ACTIONS(979),
    [anon_sym_msize] = ACTIONS(979),
    [anon_sym_gas] = ACTIONS(979),
    [anon_sym_address] = ACTIONS(979),
    [anon_sym_balance] = ACTIONS(979),
    [anon_sym_selfbalance] = ACTIONS(979),
    [anon_sym_caller] = ACTIONS(979),
    [anon_sym_callvalue] = ACTIONS(979),
    [anon_sym_calldataload] = ACTIONS(979),
    [anon_sym_calldatasize] = ACTIONS(979),
    [anon_sym_calldatacopy] = ACTIONS(979),
    [anon_sym_extcodesize] = ACTIONS(979),
    [anon_sym_extcodecopy] = ACTIONS(979),
    [anon_sym_returndatasize] = ACTIONS(979),
    [anon_sym_returndatacopy] = ACTIONS(979),
    [anon_sym_extcodehash] = ACTIONS(979),
    [anon_sym_create] = ACTIONS(979),
    [anon_sym_create2] = ACTIONS(979),
    [anon_sym_call] = ACTIONS(979),
    [anon_sym_callcode] = ACTIONS(979),
    [anon_sym_delegatecall] = ACTIONS(979),
    [anon_sym_staticcall] = ACTIONS(979),
    [anon_sym_return] = ACTIONS(979),
    [anon_sym_revert] = ACTIONS(979),
    [anon_sym_selfdestruct] = ACTIONS(979),
    [anon_sym_invalid] = ACTIONS(979),
    [anon_sym_log0] = ACTIONS(979),
    [anon_sym_log1] = ACTIONS(979),
    [anon_sym_log2] = ACTIONS(979),
    [anon_sym_log3] = ACTIONS(979),
    [anon_sym_log4] = ACTIONS(979),
    [anon_sym_chainid] = ACTIONS(979),
    [anon_sym_origin] = ACTIONS(979),
    [anon_sym_gasprice] = ACTIONS(979),
    [anon_sym_blockhash] = ACTIONS(979),
    [anon_sym_blobhash] = ACTIONS(979),
    [anon_sym_basefee] = ACTIONS(979),
    [anon_sym_blobfee] = ACTIONS(979),
    [anon_sym_coinbase] = ACTIONS(979),
    [anon_sym_timestamp] = ACTIONS(979),
    [anon_sym_number] = ACTIONS(979),
    [anon_sym_difficulty] = ACTIONS(979),
    [anon_sym_gaslimit] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [aux_sym_yul_path_repeat1] = STATE(248),
    [sym_identifier] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_COLON] = ACTIONS(956),
    [sym_yul_leave] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_DOT] = ACTIONS(962),
    [sym_yul_decimal_number] = ACTIONS(956),
    [sym_yul_hex_number] = ACTIONS(958),
    [anon_sym_true] = ACTIONS(956),
    [anon_sym_false] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_COLON_EQ] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(956),
    [anon_sym_stop] = ACTIONS(956),
    [anon_sym_add] = ACTIONS(956),
    [anon_sym_sub] = ACTIONS(956),
    [anon_sym_mul] = ACTIONS(956),
    [anon_sym_div] = ACTIONS(956),
    [anon_sym_sdiv] = ACTIONS(956),
    [anon_sym_mod] = ACTIONS(956),
    [anon_sym_smod] = ACTIONS(956),
    [anon_sym_exp] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(956),
    [anon_sym_lt] = ACTIONS(956),
    [anon_sym_gt] = ACTIONS(956),
    [anon_sym_slt] = ACTIONS(956),
    [anon_sym_sgt] = ACTIONS(956),
    [anon_sym_eq] = ACTIONS(956),
    [anon_sym_iszero] = ACTIONS(956),
    [anon_sym_and] = ACTIONS(956),
    [anon_sym_or] = ACTIONS(956),
    [anon_sym_xor] = ACTIONS(956),
    [anon_sym_byte] = ACTIONS(956),
    [anon_sym_shl] = ACTIONS(956),
    [anon_sym_shr] = ACTIONS(956),
    [anon_sym_sar] = ACTIONS(956),
    [anon_sym_addmod] = ACTIONS(956),
    [anon_sym_mulmod] = ACTIONS(956),
    [anon_sym_signextend] = ACTIONS(956),
    [anon_sym_keccak256] = ACTIONS(956),
    [anon_sym_pop] = ACTIONS(956),
    [anon_sym_mload] = ACTIONS(956),
    [anon_sym_mcopy] = ACTIONS(956),
    [anon_sym_tload] = ACTIONS(956),
    [anon_sym_tstore] = ACTIONS(956),
    [anon_sym_mstore] = ACTIONS(956),
    [anon_sym_mstore8] = ACTIONS(956),
    [anon_sym_sload] = ACTIONS(956),
    [anon_sym_sstore] = ACTIONS(956),
    [anon_sym_msize] = ACTIONS(956),
    [anon_sym_gas] = ACTIONS(956),
    [anon_sym_address] = ACTIONS(956),
    [anon_sym_balance] = ACTIONS(956),
    [anon_sym_selfbalance] = ACTIONS(956),
    [anon_sym_caller] = ACTIONS(956),
    [anon_sym_callvalue] = ACTIONS(956),
    [anon_sym_calldataload] = ACTIONS(956),
    [anon_sym_calldatasize] = ACTIONS(956),
    [anon_sym_calldatacopy] = ACTIONS(956),
    [anon_sym_extcodesize] = ACTIONS(956),
    [anon_sym_extcodecopy] = ACTIONS(956),
    [anon_sym_returndatasize] = ACTIONS(956),
    [anon_sym_returndatacopy] = ACTIONS(956),
    [anon_sym_extcodehash] = ACTIONS(956),
    [anon_sym_create] = ACTIONS(956),
    [anon_sym_create2] = ACTIONS(956),
    [anon_sym_call] = ACTIONS(956),
    [anon_sym_callcode] = ACTIONS(956),
    [anon_sym_delegatecall] = ACTIONS(956),
    [anon_sym_staticcall] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_revert] = ACTIONS(956),
    [anon_sym_selfdestruct] = ACTIONS(956),
    [anon_sym_invalid] = ACTIONS(956),
    [anon_sym_log0] = ACTIONS(956),
    [anon_sym_log1] = ACTIONS(956),
    [anon_sym_log2] = ACTIONS(956),
    [anon_sym_log3] = ACTIONS(956),
    [anon_sym_log4] = ACTIONS(956),
    [anon_sym_chainid] = ACTIONS(956),
    [anon_sym_origin] = ACTIONS(956),
    [anon_sym_gasprice] = ACTIONS(956),
    [anon_sym_blockhash] = ACTIONS(956),
    [anon_sym_blobhash] = ACTIONS(956),
    [anon_sym_basefee] = ACTIONS(956),
    [anon_sym_blobfee] = ACTIONS(956),
    [anon_sym_coinbase] = ACTIONS(956),
    [anon_sym_timestamp] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_difficulty] = ACTIONS(956),
    [anon_sym_gaslimit] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [sym_yul_identifier] = STATE(253),
    [sym_yul_path] = STATE(272),
    [sym__yul_assignment_operator] = STATE(323),
    [sym_identifier] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(991),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(989),
    [anon_sym_COLON] = ACTIONS(985),
    [sym_yul_leave] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [sym_yul_decimal_number] = ACTIONS(989),
    [sym_yul_hex_number] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(989),
    [anon_sym_false] = ACTIONS(989),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_COLON_EQ] = ACTIONS(993),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_switch] = ACTIONS(989),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_stop] = ACTIONS(989),
    [anon_sym_add] = ACTIONS(989),
    [anon_sym_sub] = ACTIONS(989),
    [anon_sym_mul] = ACTIONS(989),
    [anon_sym_div] = ACTIONS(989),
    [anon_sym_sdiv] = ACTIONS(989),
    [anon_sym_mod] = ACTIONS(989),
    [anon_sym_smod] = ACTIONS(989),
    [anon_sym_exp] = ACTIONS(989),
    [anon_sym_not] = ACTIONS(989),
    [anon_sym_lt] = ACTIONS(989),
    [anon_sym_gt] = ACTIONS(989),
    [anon_sym_slt] = ACTIONS(989),
    [anon_sym_sgt] = ACTIONS(989),
    [anon_sym_eq] = ACTIONS(989),
    [anon_sym_iszero] = ACTIONS(989),
    [anon_sym_and] = ACTIONS(989),
    [anon_sym_or] = ACTIONS(989),
    [anon_sym_xor] = ACTIONS(989),
    [anon_sym_byte] = ACTIONS(989),
    [anon_sym_shl] = ACTIONS(989),
    [anon_sym_shr] = ACTIONS(989),
    [anon_sym_sar] = ACTIONS(989),
    [anon_sym_addmod] = ACTIONS(989),
    [anon_sym_mulmod] = ACTIONS(989),
    [anon_sym_signextend] = ACTIONS(989),
    [anon_sym_keccak256] = ACTIONS(989),
    [anon_sym_pop] = ACTIONS(989),
    [anon_sym_mload] = ACTIONS(989),
    [anon_sym_mcopy] = ACTIONS(989),
    [anon_sym_tload] = ACTIONS(989),
    [anon_sym_tstore] = ACTIONS(989),
    [anon_sym_mstore] = ACTIONS(989),
    [anon_sym_mstore8] = ACTIONS(989),
    [anon_sym_sload] = ACTIONS(989),
    [anon_sym_sstore] = ACTIONS(989),
    [anon_sym_msize] = ACTIONS(989),
    [anon_sym_gas] = ACTIONS(989),
    [anon_sym_address] = ACTIONS(989),
    [anon_sym_balance] = ACTIONS(989),
    [anon_sym_selfbalance] = ACTIONS(989),
    [anon_sym_caller] = ACTIONS(989),
    [anon_sym_callvalue] = ACTIONS(989),
    [anon_sym_calldataload] = ACTIONS(989),
    [anon_sym_calldatasize] = ACTIONS(989),
    [anon_sym_calldatacopy] = ACTIONS(989),
    [anon_sym_extcodesize] = ACTIONS(989),
    [anon_sym_extcodecopy] = ACTIONS(989),
    [anon_sym_returndatasize] = ACTIONS(989),
    [anon_sym_returndatacopy] = ACTIONS(989),
    [anon_sym_extcodehash] = ACTIONS(989),
    [anon_sym_create] = ACTIONS(989),
    [anon_sym_create2] = ACTIONS(989),
    [anon_sym_call] = ACTIONS(989),
    [anon_sym_callcode] = ACTIONS(989),
    [anon_sym_delegatecall] = ACTIONS(989),
    [anon_sym_staticcall] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_revert] = ACTIONS(989),
    [anon_sym_selfdestruct] = ACTIONS(989),
    [anon_sym_invalid] = ACTIONS(989),
    [anon_sym_log0] = ACTIONS(989),
    [anon_sym_log1] = ACTIONS(989),
    [anon_sym_log2] = ACTIONS(989),
    [anon_sym_log3] = ACTIONS(989),
    [anon_sym_log4] = ACTIONS(989),
    [anon_sym_chainid] = ACTIONS(989),
    [anon_sym_origin] = ACTIONS(989),
    [anon_sym_gasprice] = ACTIONS(989),
    [anon_sym_blockhash] = ACTIONS(989),
    [anon_sym_blobhash] = ACTIONS(989),
    [anon_sym_basefee] = ACTIONS(989),
    [anon_sym_blobfee] = ACTIONS(989),
    [anon_sym_coinbase] = ACTIONS(989),
    [anon_sym_timestamp] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_difficulty] = ACTIONS(989),
    [anon_sym_gaslimit] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(991),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(975),
    [anon_sym_LBRACE] = ACTIONS(977),
    [anon_sym_COMMA] = ACTIONS(977),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym_LPAREN] = ACTIONS(977),
    [anon_sym_for] = ACTIONS(975),
    [anon_sym_COLON] = ACTIONS(995),
    [sym_yul_leave] = ACTIONS(975),
    [anon_sym_break] = ACTIONS(975),
    [anon_sym_continue] = ACTIONS(975),
    [anon_sym_DOT] = ACTIONS(977),
    [sym_yul_decimal_number] = ACTIONS(975),
    [sym_yul_hex_number] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(975),
    [anon_sym_false] = ACTIONS(975),
    [anon_sym_let] = ACTIONS(975),
    [anon_sym_COLON_EQ] = ACTIONS(977),
    [anon_sym_if] = ACTIONS(975),
    [anon_sym_switch] = ACTIONS(975),
    [anon_sym_function] = ACTIONS(975),
    [anon_sym_stop] = ACTIONS(975),
    [anon_sym_add] = ACTIONS(975),
    [anon_sym_sub] = ACTIONS(975),
    [anon_sym_mul] = ACTIONS(975),
    [anon_sym_div] = ACTIONS(975),
    [anon_sym_sdiv] = ACTIONS(975),
    [anon_sym_mod] = ACTIONS(975),
    [anon_sym_smod] = ACTIONS(975),
    [anon_sym_exp] = ACTIONS(975),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_lt] = ACTIONS(975),
    [anon_sym_gt] = ACTIONS(975),
    [anon_sym_slt] = ACTIONS(975),
    [anon_sym_sgt] = ACTIONS(975),
    [anon_sym_eq] = ACTIONS(975),
    [anon_sym_iszero] = ACTIONS(975),
    [anon_sym_and] = ACTIONS(975),
    [anon_sym_or] = ACTIONS(975),
    [anon_sym_xor] = ACTIONS(975),
    [anon_sym_byte] = ACTIONS(975),
    [anon_sym_shl] = ACTIONS(975),
    [anon_sym_shr] = ACTIONS(975),
    [anon_sym_sar] = ACTIONS(975),
    [anon_sym_addmod] = ACTIONS(975),
    [anon_sym_mulmod] = ACTIONS(975),
    [anon_sym_signextend] = ACTIONS(975),
    [anon_sym_keccak256] = ACTIONS(975),
    [anon_sym_pop] = ACTIONS(975),
    [anon_sym_mload] = ACTIONS(975),
    [anon_sym_mcopy] = ACTIONS(975),
    [anon_sym_tload] = ACTIONS(975),
    [anon_sym_tstore] = ACTIONS(975),
    [anon_sym_mstore] = ACTIONS(975),
    [anon_sym_mstore8] = ACTIONS(975),
    [anon_sym_sload] = ACTIONS(975),
    [anon_sym_sstore] = ACTIONS(975),
    [anon_sym_msize] = ACTIONS(975),
    [anon_sym_gas] = ACTIONS(975),
    [anon_sym_address] = ACTIONS(975),
    [anon_sym_balance] = ACTIONS(975),
    [anon_sym_selfbalance] = ACTIONS(975),
    [anon_sym_caller] = ACTIONS(975),
    [anon_sym_callvalue] = ACTIONS(975),
    [anon_sym_calldataload] = ACTIONS(975),
    [anon_sym_calldatasize] = ACTIONS(975),
    [anon_sym_calldatacopy] = ACTIONS(975),
    [anon_sym_extcodesize] = ACTIONS(975),
    [anon_sym_extcodecopy] = ACTIONS(975),
    [anon_sym_returndatasize] = ACTIONS(975),
    [anon_sym_returndatacopy] = ACTIONS(975),
    [anon_sym_extcodehash] = ACTIONS(975),
    [anon_sym_create] = ACTIONS(975),
    [anon_sym_create2] = ACTIONS(975),
    [anon_sym_call] = ACTIONS(975),
    [anon_sym_callcode] = ACTIONS(975),
    [anon_sym_delegatecall] = ACTIONS(975),
    [anon_sym_staticcall] = ACTIONS(975),
    [anon_sym_return] = ACTIONS(975),
    [anon_sym_revert] = ACTIONS(975),
    [anon_sym_selfdestruct] = ACTIONS(975),
    [anon_sym_invalid] = ACTIONS(975),
    [anon_sym_log0] = ACTIONS(975),
    [anon_sym_log1] = ACTIONS(975),
    [anon_sym_log2] = ACTIONS(975),
    [anon_sym_log3] = ACTIONS(975),
    [anon_sym_log4] = ACTIONS(975),
    [anon_sym_chainid] = ACTIONS(975),
    [anon_sym_origin] = ACTIONS(975),
    [anon_sym_gasprice] = ACTIONS(975),
    [anon_sym_blockhash] = ACTIONS(975),
    [anon_sym_blobhash] = ACTIONS(975),
    [anon_sym_basefee] = ACTIONS(975),
    [anon_sym_blobfee] = ACTIONS(975),
    [anon_sym_coinbase] = ACTIONS(975),
    [anon_sym_timestamp] = ACTIONS(975),
    [anon_sym_number] = ACTIONS(975),
    [anon_sym_difficulty] = ACTIONS(975),
    [anon_sym_gaslimit] = ACTIONS(975),
    [anon_sym_DQUOTE] = ACTIONS(977),
    [anon_sym_SQUOTE] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym__yul_assignment_operator] = STATE(316),
    [aux_sym_yul_assignment_repeat1] = STATE(252),
    [sym_identifier] = ACTIONS(998),
    [anon_sym_LBRACE] = ACTIONS(1000),
    [anon_sym_COMMA] = ACTIONS(1002),
    [anon_sym_RBRACE] = ACTIONS(1000),
    [anon_sym_for] = ACTIONS(998),
    [anon_sym_COLON] = ACTIONS(985),
    [sym_yul_leave] = ACTIONS(998),
    [anon_sym_break] = ACTIONS(998),
    [anon_sym_continue] = ACTIONS(998),
    [sym_yul_decimal_number] = ACTIONS(998),
    [sym_yul_hex_number] = ACTIONS(1000),
    [anon_sym_true] = ACTIONS(998),
    [anon_sym_false] = ACTIONS(998),
    [anon_sym_let] = ACTIONS(998),
    [anon_sym_COLON_EQ] = ACTIONS(1004),
    [anon_sym_if] = ACTIONS(998),
    [anon_sym_switch] = ACTIONS(998),
    [anon_sym_function] = ACTIONS(998),
    [anon_sym_stop] = ACTIONS(998),
    [anon_sym_add] = ACTIONS(998),
    [anon_sym_sub] = ACTIONS(998),
    [anon_sym_mul] = ACTIONS(998),
    [anon_sym_div] = ACTIONS(998),
    [anon_sym_sdiv] = ACTIONS(998),
    [anon_sym_mod] = ACTIONS(998),
    [anon_sym_smod] = ACTIONS(998),
    [anon_sym_exp] = ACTIONS(998),
    [anon_sym_not] = ACTIONS(998),
    [anon_sym_lt] = ACTIONS(998),
    [anon_sym_gt] = ACTIONS(998),
    [anon_sym_slt] = ACTIONS(998),
    [anon_sym_sgt] = ACTIONS(998),
    [anon_sym_eq] = ACTIONS(998),
    [anon_sym_iszero] = ACTIONS(998),
    [anon_sym_and] = ACTIONS(998),
    [anon_sym_or] = ACTIONS(998),
    [anon_sym_xor] = ACTIONS(998),
    [anon_sym_byte] = ACTIONS(998),
    [anon_sym_shl] = ACTIONS(998),
    [anon_sym_shr] = ACTIONS(998),
    [anon_sym_sar] = ACTIONS(998),
    [anon_sym_addmod] = ACTIONS(998),
    [anon_sym_mulmod] = ACTIONS(998),
    [anon_sym_signextend] = ACTIONS(998),
    [anon_sym_keccak256] = ACTIONS(998),
    [anon_sym_pop] = ACTIONS(998),
    [anon_sym_mload] = ACTIONS(998),
    [anon_sym_mcopy] = ACTIONS(998),
    [anon_sym_tload] = ACTIONS(998),
    [anon_sym_tstore] = ACTIONS(998),
    [anon_sym_mstore] = ACTIONS(998),
    [anon_sym_mstore8] = ACTIONS(998),
    [anon_sym_sload] = ACTIONS(998),
    [anon_sym_sstore] = ACTIONS(998),
    [anon_sym_msize] = ACTIONS(998),
    [anon_sym_gas] = ACTIONS(998),
    [anon_sym_address] = ACTIONS(998),
    [anon_sym_balance] = ACTIONS(998),
    [anon_sym_selfbalance] = ACTIONS(998),
    [anon_sym_caller] = ACTIONS(998),
    [anon_sym_callvalue] = ACTIONS(998),
    [anon_sym_calldataload] = ACTIONS(998),
    [anon_sym_calldatasize] = ACTIONS(998),
    [anon_sym_calldatacopy] = ACTIONS(998),
    [anon_sym_extcodesize] = ACTIONS(998),
    [anon_sym_extcodecopy] = ACTIONS(998),
    [anon_sym_returndatasize] = ACTIONS(998),
    [anon_sym_returndatacopy] = ACTIONS(998),
    [anon_sym_extcodehash] = ACTIONS(998),
    [anon_sym_create] = ACTIONS(998),
    [anon_sym_create2] = ACTIONS(998),
    [anon_sym_call] = ACTIONS(998),
    [anon_sym_callcode] = ACTIONS(998),
    [anon_sym_delegatecall] = ACTIONS(998),
    [anon_sym_staticcall] = ACTIONS(998),
    [anon_sym_return] = ACTIONS(998),
    [anon_sym_revert] = ACTIONS(998),
    [anon_sym_selfdestruct] = ACTIONS(998),
    [anon_sym_invalid] = ACTIONS(998),
    [anon_sym_log0] = ACTIONS(998),
    [anon_sym_log1] = ACTIONS(998),
    [anon_sym_log2] = ACTIONS(998),
    [anon_sym_log3] = ACTIONS(998),
    [anon_sym_log4] = ACTIONS(998),
    [anon_sym_chainid] = ACTIONS(998),
    [anon_sym_origin] = ACTIONS(998),
    [anon_sym_gasprice] = ACTIONS(998),
    [anon_sym_blockhash] = ACTIONS(998),
    [anon_sym_blobhash] = ACTIONS(998),
    [anon_sym_basefee] = ACTIONS(998),
    [anon_sym_blobfee] = ACTIONS(998),
    [anon_sym_coinbase] = ACTIONS(998),
    [anon_sym_timestamp] = ACTIONS(998),
    [anon_sym_number] = ACTIONS(998),
    [anon_sym_difficulty] = ACTIONS(998),
    [anon_sym_gaslimit] = ACTIONS(998),
    [anon_sym_DQUOTE] = ACTIONS(1000),
    [anon_sym_SQUOTE] = ACTIONS(1000),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACE] = ACTIONS(1008),
    [anon_sym_COMMA] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(1008),
    [anon_sym_LPAREN] = ACTIONS(1008),
    [anon_sym_RPAREN] = ACTIONS(1008),
    [anon_sym_for] = ACTIONS(1006),
    [sym_yul_leave] = ACTIONS(1006),
    [anon_sym_break] = ACTIONS(1006),
    [anon_sym_continue] = ACTIONS(1006),
    [sym_yul_decimal_number] = ACTIONS(1006),
    [sym_yul_hex_number] = ACTIONS(1008),
    [anon_sym_true] = ACTIONS(1006),
    [anon_sym_false] = ACTIONS(1006),
    [anon_sym_let] = ACTIONS(1006),
    [anon_sym_if] = ACTIONS(1006),
    [anon_sym_switch] = ACTIONS(1006),
    [anon_sym_default] = ACTIONS(1006),
    [anon_sym_case] = ACTIONS(1006),
    [anon_sym_function] = ACTIONS(1006),
    [anon_sym_stop] = ACTIONS(1006),
    [anon_sym_add] = ACTIONS(1006),
    [anon_sym_sub] = ACTIONS(1006),
    [anon_sym_mul] = ACTIONS(1006),
    [anon_sym_div] = ACTIONS(1006),
    [anon_sym_sdiv] = ACTIONS(1006),
    [anon_sym_mod] = ACTIONS(1006),
    [anon_sym_smod] = ACTIONS(1006),
    [anon_sym_exp] = ACTIONS(1006),
    [anon_sym_not] = ACTIONS(1006),
    [anon_sym_lt] = ACTIONS(1006),
    [anon_sym_gt] = ACTIONS(1006),
    [anon_sym_slt] = ACTIONS(1006),
    [anon_sym_sgt] = ACTIONS(1006),
    [anon_sym_eq] = ACTIONS(1006),
    [anon_sym_iszero] = ACTIONS(1006),
    [anon_sym_and] = ACTIONS(1006),
    [anon_sym_or] = ACTIONS(1006),
    [anon_sym_xor] = ACTIONS(1006),
    [anon_sym_byte] = ACTIONS(1006),
    [anon_sym_shl] = ACTIONS(1006),
    [anon_sym_shr] = ACTIONS(1006),
    [anon_sym_sar] = ACTIONS(1006),
    [anon_sym_addmod] = ACTIONS(1006),
    [anon_sym_mulmod] = ACTIONS(1006),
    [anon_sym_signextend] = ACTIONS(1006),
    [anon_sym_keccak256] = ACTIONS(1006),
    [anon_sym_pop] = ACTIONS(1006),
    [anon_sym_mload] = ACTIONS(1006),
    [anon_sym_mcopy] = ACTIONS(1006),
    [anon_sym_tload] = ACTIONS(1006),
    [anon_sym_tstore] = ACTIONS(1006),
    [anon_sym_mstore] = ACTIONS(1006),
    [anon_sym_mstore8] = ACTIONS(1006),
    [anon_sym_sload] = ACTIONS(1006),
    [anon_sym_sstore] = ACTIONS(1006),
    [anon_sym_msize] = ACTIONS(1006),
    [anon_sym_gas] = ACTIONS(1006),
    [anon_sym_address] = ACTIONS(1006),
    [anon_sym_balance] = ACTIONS(1006),
    [anon_sym_selfbalance] = ACTIONS(1006),
    [anon_sym_caller] = ACTIONS(1006),
    [anon_sym_callvalue] = ACTIONS(1006),
    [anon_sym_calldataload] = ACTIONS(1006),
    [anon_sym_calldatasize] = ACTIONS(1006),
    [anon_sym_calldatacopy] = ACTIONS(1006),
    [anon_sym_extcodesize] = ACTIONS(1006),
    [anon_sym_extcodecopy] = ACTIONS(1006),
    [anon_sym_returndatasize] = ACTIONS(1006),
    [anon_sym_returndatacopy] = ACTIONS(1006),
    [anon_sym_extcodehash] = ACTIONS(1006),
    [anon_sym_create] = ACTIONS(1006),
    [anon_sym_create2] = ACTIONS(1006),
    [anon_sym_call] = ACTIONS(1006),
    [anon_sym_callcode] = ACTIONS(1006),
    [anon_sym_delegatecall] = ACTIONS(1006),
    [anon_sym_staticcall] = ACTIONS(1006),
    [anon_sym_return] = ACTIONS(1006),
    [anon_sym_revert] = ACTIONS(1006),
    [anon_sym_selfdestruct] = ACTIONS(1006),
    [anon_sym_invalid] = ACTIONS(1006),
    [anon_sym_log0] = ACTIONS(1006),
    [anon_sym_log1] = ACTIONS(1006),
    [anon_sym_log2] = ACTIONS(1006),
    [anon_sym_log3] = ACTIONS(1006),
    [anon_sym_log4] = ACTIONS(1006),
    [anon_sym_chainid] = ACTIONS(1006),
    [anon_sym_origin] = ACTIONS(1006),
    [anon_sym_gasprice] = ACTIONS(1006),
    [anon_sym_blockhash] = ACTIONS(1006),
    [anon_sym_blobhash] = ACTIONS(1006),
    [anon_sym_basefee] = ACTIONS(1006),
    [anon_sym_blobfee] = ACTIONS(1006),
    [anon_sym_coinbase] = ACTIONS(1006),
    [anon_sym_timestamp] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_difficulty] = ACTIONS(1006),
    [anon_sym_gaslimit] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_SQUOTE] = ACTIONS(1008),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(960),
    [anon_sym_RPAREN] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1010),
    [sym_yul_leave] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [sym_yul_decimal_number] = ACTIONS(1010),
    [sym_yul_hex_number] = ACTIONS(1012),
    [anon_sym_true] = ACTIONS(1010),
    [anon_sym_false] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1010),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_default] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_stop] = ACTIONS(1010),
    [anon_sym_add] = ACTIONS(1010),
    [anon_sym_sub] = ACTIONS(1010),
    [anon_sym_mul] = ACTIONS(1010),
    [anon_sym_div] = ACTIONS(1010),
    [anon_sym_sdiv] = ACTIONS(1010),
    [anon_sym_mod] = ACTIONS(1010),
    [anon_sym_smod] = ACTIONS(1010),
    [anon_sym_exp] = ACTIONS(1010),
    [anon_sym_not] = ACTIONS(1010),
    [anon_sym_lt] = ACTIONS(1010),
    [anon_sym_gt] = ACTIONS(1010),
    [anon_sym_slt] = ACTIONS(1010),
    [anon_sym_sgt] = ACTIONS(1010),
    [anon_sym_eq] = ACTIONS(1010),
    [anon_sym_iszero] = ACTIONS(1010),
    [anon_sym_and] = ACTIONS(1010),
    [anon_sym_or] = ACTIONS(1010),
    [anon_sym_xor] = ACTIONS(1010),
    [anon_sym_byte] = ACTIONS(1010),
    [anon_sym_shl] = ACTIONS(1010),
    [anon_sym_shr] = ACTIONS(1010),
    [anon_sym_sar] = ACTIONS(1010),
    [anon_sym_addmod] = ACTIONS(1010),
    [anon_sym_mulmod] = ACTIONS(1010),
    [anon_sym_signextend] = ACTIONS(1010),
    [anon_sym_keccak256] = ACTIONS(1010),
    [anon_sym_pop] = ACTIONS(1010),
    [anon_sym_mload] = ACTIONS(1010),
    [anon_sym_mcopy] = ACTIONS(1010),
    [anon_sym_tload] = ACTIONS(1010),
    [anon_sym_tstore] = ACTIONS(1010),
    [anon_sym_mstore] = ACTIONS(1010),
    [anon_sym_mstore8] = ACTIONS(1010),
    [anon_sym_sload] = ACTIONS(1010),
    [anon_sym_sstore] = ACTIONS(1010),
    [anon_sym_msize] = ACTIONS(1010),
    [anon_sym_gas] = ACTIONS(1010),
    [anon_sym_address] = ACTIONS(1010),
    [anon_sym_balance] = ACTIONS(1010),
    [anon_sym_selfbalance] = ACTIONS(1010),
    [anon_sym_caller] = ACTIONS(1010),
    [anon_sym_callvalue] = ACTIONS(1010),
    [anon_sym_calldataload] = ACTIONS(1010),
    [anon_sym_calldatasize] = ACTIONS(1010),
    [anon_sym_calldatacopy] = ACTIONS(1010),
    [anon_sym_extcodesize] = ACTIONS(1010),
    [anon_sym_extcodecopy] = ACTIONS(1010),
    [anon_sym_returndatasize] = ACTIONS(1010),
    [anon_sym_returndatacopy] = ACTIONS(1010),
    [anon_sym_extcodehash] = ACTIONS(1010),
    [anon_sym_create] = ACTIONS(1010),
    [anon_sym_create2] = ACTIONS(1010),
    [anon_sym_call] = ACTIONS(1010),
    [anon_sym_callcode] = ACTIONS(1010),
    [anon_sym_delegatecall] = ACTIONS(1010),
    [anon_sym_staticcall] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_revert] = ACTIONS(1010),
    [anon_sym_selfdestruct] = ACTIONS(1010),
    [anon_sym_invalid] = ACTIONS(1010),
    [anon_sym_log0] = ACTIONS(1010),
    [anon_sym_log1] = ACTIONS(1010),
    [anon_sym_log2] = ACTIONS(1010),
    [anon_sym_log3] = ACTIONS(1010),
    [anon_sym_log4] = ACTIONS(1010),
    [anon_sym_chainid] = ACTIONS(1010),
    [anon_sym_origin] = ACTIONS(1010),
    [anon_sym_gasprice] = ACTIONS(1010),
    [anon_sym_blockhash] = ACTIONS(1010),
    [anon_sym_blobhash] = ACTIONS(1010),
    [anon_sym_basefee] = ACTIONS(1010),
    [anon_sym_blobfee] = ACTIONS(1010),
    [anon_sym_coinbase] = ACTIONS(1010),
    [anon_sym_timestamp] = ACTIONS(1010),
    [anon_sym_number] = ACTIONS(1010),
    [anon_sym_difficulty] = ACTIONS(1010),
    [anon_sym_gaslimit] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_yul_identifier] = STATE(253),
    [sym_yul_path] = STATE(272),
    [sym__yul_assignment_operator] = STATE(322),
    [sym_identifier] = ACTIONS(979),
    [anon_sym_LBRACE] = ACTIONS(981),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym_for] = ACTIONS(979),
    [anon_sym_COLON] = ACTIONS(985),
    [sym_yul_leave] = ACTIONS(979),
    [anon_sym_break] = ACTIONS(979),
    [anon_sym_continue] = ACTIONS(979),
    [sym_yul_decimal_number] = ACTIONS(979),
    [sym_yul_hex_number] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(979),
    [anon_sym_false] = ACTIONS(979),
    [anon_sym_let] = ACTIONS(979),
    [anon_sym_COLON_EQ] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(979),
    [anon_sym_switch] = ACTIONS(979),
    [anon_sym_function] = ACTIONS(979),
    [anon_sym_stop] = ACTIONS(979),
    [anon_sym_add] = ACTIONS(979),
    [anon_sym_sub] = ACTIONS(979),
    [anon_sym_mul] = ACTIONS(979),
    [anon_sym_div] = ACTIONS(979),
    [anon_sym_sdiv] = ACTIONS(979),
    [anon_sym_mod] = ACTIONS(979),
    [anon_sym_smod] = ACTIONS(979),
    [anon_sym_exp] = ACTIONS(979),
    [anon_sym_not] = ACTIONS(979),
    [anon_sym_lt] = ACTIONS(979),
    [anon_sym_gt] = ACTIONS(979),
    [anon_sym_slt] = ACTIONS(979),
    [anon_sym_sgt] = ACTIONS(979),
    [anon_sym_eq] = ACTIONS(979),
    [anon_sym_iszero] = ACTIONS(979),
    [anon_sym_and] = ACTIONS(979),
    [anon_sym_or] = ACTIONS(979),
    [anon_sym_xor] = ACTIONS(979),
    [anon_sym_byte] = ACTIONS(979),
    [anon_sym_shl] = ACTIONS(979),
    [anon_sym_shr] = ACTIONS(979),
    [anon_sym_sar] = ACTIONS(979),
    [anon_sym_addmod] = ACTIONS(979),
    [anon_sym_mulmod] = ACTIONS(979),
    [anon_sym_signextend] = ACTIONS(979),
    [anon_sym_keccak256] = ACTIONS(979),
    [anon_sym_pop] = ACTIONS(979),
    [anon_sym_mload] = ACTIONS(979),
    [anon_sym_mcopy] = ACTIONS(979),
    [anon_sym_tload] = ACTIONS(979),
    [anon_sym_tstore] = ACTIONS(979),
    [anon_sym_mstore] = ACTIONS(979),
    [anon_sym_mstore8] = ACTIONS(979),
    [anon_sym_sload] = ACTIONS(979),
    [anon_sym_sstore] = ACTIONS(979),
    [anon_sym_msize] = ACTIONS(979),
    [anon_sym_gas] = ACTIONS(979),
    [anon_sym_address] = ACTIONS(979),
    [anon_sym_balance] = ACTIONS(979),
    [anon_sym_selfbalance] = ACTIONS(979),
    [anon_sym_caller] = ACTIONS(979),
    [anon_sym_callvalue] = ACTIONS(979),
    [anon_sym_calldataload] = ACTIONS(979),
    [anon_sym_calldatasize] = ACTIONS(979),
    [anon_sym_calldatacopy] = ACTIONS(979),
    [anon_sym_extcodesize] = ACTIONS(979),
    [anon_sym_extcodecopy] = ACTIONS(979),
    [anon_sym_returndatasize] = ACTIONS(979),
    [anon_sym_returndatacopy] = ACTIONS(979),
    [anon_sym_extcodehash] = ACTIONS(979),
    [anon_sym_create] = ACTIONS(979),
    [anon_sym_create2] = ACTIONS(979),
    [anon_sym_call] = ACTIONS(979),
    [anon_sym_callcode] = ACTIONS(979),
    [anon_sym_delegatecall] = ACTIONS(979),
    [anon_sym_staticcall] = ACTIONS(979),
    [anon_sym_return] = ACTIONS(979),
    [anon_sym_revert] = ACTIONS(979),
    [anon_sym_selfdestruct] = ACTIONS(979),
    [anon_sym_invalid] = ACTIONS(979),
    [anon_sym_log0] = ACTIONS(979),
    [anon_sym_log1] = ACTIONS(979),
    [anon_sym_log2] = ACTIONS(979),
    [anon_sym_log3] = ACTIONS(979),
    [anon_sym_log4] = ACTIONS(979),
    [anon_sym_chainid] = ACTIONS(979),
    [anon_sym_origin] = ACTIONS(979),
    [anon_sym_gasprice] = ACTIONS(979),
    [anon_sym_blockhash] = ACTIONS(979),
    [anon_sym_blobhash] = ACTIONS(979),
    [anon_sym_basefee] = ACTIONS(979),
    [anon_sym_blobfee] = ACTIONS(979),
    [anon_sym_coinbase] = ACTIONS(979),
    [anon_sym_timestamp] = ACTIONS(979),
    [anon_sym_number] = ACTIONS(979),
    [anon_sym_difficulty] = ACTIONS(979),
    [anon_sym_gaslimit] = ACTIONS(979),
    [anon_sym_DQUOTE] = ACTIONS(981),
    [anon_sym_SQUOTE] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [aux_sym_yul_assignment_repeat1] = STATE(260),
    [sym_identifier] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1018),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1014),
    [anon_sym_COLON] = ACTIONS(1014),
    [sym_yul_leave] = ACTIONS(1014),
    [anon_sym_break] = ACTIONS(1014),
    [anon_sym_continue] = ACTIONS(1014),
    [sym_yul_decimal_number] = ACTIONS(1014),
    [sym_yul_hex_number] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1014),
    [anon_sym_false] = ACTIONS(1014),
    [anon_sym_let] = ACTIONS(1014),
    [anon_sym_COLON_EQ] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1014),
    [anon_sym_switch] = ACTIONS(1014),
    [anon_sym_function] = ACTIONS(1014),
    [anon_sym_stop] = ACTIONS(1014),
    [anon_sym_add] = ACTIONS(1014),
    [anon_sym_sub] = ACTIONS(1014),
    [anon_sym_mul] = ACTIONS(1014),
    [anon_sym_div] = ACTIONS(1014),
    [anon_sym_sdiv] = ACTIONS(1014),
    [anon_sym_mod] = ACTIONS(1014),
    [anon_sym_smod] = ACTIONS(1014),
    [anon_sym_exp] = ACTIONS(1014),
    [anon_sym_not] = ACTIONS(1014),
    [anon_sym_lt] = ACTIONS(1014),
    [anon_sym_gt] = ACTIONS(1014),
    [anon_sym_slt] = ACTIONS(1014),
    [anon_sym_sgt] = ACTIONS(1014),
    [anon_sym_eq] = ACTIONS(1014),
    [anon_sym_iszero] = ACTIONS(1014),
    [anon_sym_and] = ACTIONS(1014),
    [anon_sym_or] = ACTIONS(1014),
    [anon_sym_xor] = ACTIONS(1014),
    [anon_sym_byte] = ACTIONS(1014),
    [anon_sym_shl] = ACTIONS(1014),
    [anon_sym_shr] = ACTIONS(1014),
    [anon_sym_sar] = ACTIONS(1014),
    [anon_sym_addmod] = ACTIONS(1014),
    [anon_sym_mulmod] = ACTIONS(1014),
    [anon_sym_signextend] = ACTIONS(1014),
    [anon_sym_keccak256] = ACTIONS(1014),
    [anon_sym_pop] = ACTIONS(1014),
    [anon_sym_mload] = ACTIONS(1014),
    [anon_sym_mcopy] = ACTIONS(1014),
    [anon_sym_tload] = ACTIONS(1014),
    [anon_sym_tstore] = ACTIONS(1014),
    [anon_sym_mstore] = ACTIONS(1014),
    [anon_sym_mstore8] = ACTIONS(1014),
    [anon_sym_sload] = ACTIONS(1014),
    [anon_sym_sstore] = ACTIONS(1014),
    [anon_sym_msize] = ACTIONS(1014),
    [anon_sym_gas] = ACTIONS(1014),
    [anon_sym_address] = ACTIONS(1014),
    [anon_sym_balance] = ACTIONS(1014),
    [anon_sym_selfbalance] = ACTIONS(1014),
    [anon_sym_caller] = ACTIONS(1014),
    [anon_sym_callvalue] = ACTIONS(1014),
    [anon_sym_calldataload] = ACTIONS(1014),
    [anon_sym_calldatasize] = ACTIONS(1014),
    [anon_sym_calldatacopy] = ACTIONS(1014),
    [anon_sym_extcodesize] = ACTIONS(1014),
    [anon_sym_extcodecopy] = ACTIONS(1014),
    [anon_sym_returndatasize] = ACTIONS(1014),
    [anon_sym_returndatacopy] = ACTIONS(1014),
    [anon_sym_extcodehash] = ACTIONS(1014),
    [anon_sym_create] = ACTIONS(1014),
    [anon_sym_create2] = ACTIONS(1014),
    [anon_sym_call] = ACTIONS(1014),
    [anon_sym_callcode] = ACTIONS(1014),
    [anon_sym_delegatecall] = ACTIONS(1014),
    [anon_sym_staticcall] = ACTIONS(1014),
    [anon_sym_return] = ACTIONS(1014),
    [anon_sym_revert] = ACTIONS(1014),
    [anon_sym_selfdestruct] = ACTIONS(1014),
    [anon_sym_invalid] = ACTIONS(1014),
    [anon_sym_log0] = ACTIONS(1014),
    [anon_sym_log1] = ACTIONS(1014),
    [anon_sym_log2] = ACTIONS(1014),
    [anon_sym_log3] = ACTIONS(1014),
    [anon_sym_log4] = ACTIONS(1014),
    [anon_sym_chainid] = ACTIONS(1014),
    [anon_sym_origin] = ACTIONS(1014),
    [anon_sym_gasprice] = ACTIONS(1014),
    [anon_sym_blockhash] = ACTIONS(1014),
    [anon_sym_blobhash] = ACTIONS(1014),
    [anon_sym_basefee] = ACTIONS(1014),
    [anon_sym_blobfee] = ACTIONS(1014),
    [anon_sym_coinbase] = ACTIONS(1014),
    [anon_sym_timestamp] = ACTIONS(1014),
    [anon_sym_number] = ACTIONS(1014),
    [anon_sym_difficulty] = ACTIONS(1014),
    [anon_sym_gaslimit] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(261),
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1025),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1021),
    [sym_yul_leave] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [sym_yul_decimal_number] = ACTIONS(1021),
    [sym_yul_hex_number] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1021),
    [anon_sym_false] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_COLON_EQ] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1021),
    [anon_sym_stop] = ACTIONS(1021),
    [anon_sym_add] = ACTIONS(1021),
    [anon_sym_sub] = ACTIONS(1021),
    [anon_sym_mul] = ACTIONS(1021),
    [anon_sym_div] = ACTIONS(1021),
    [anon_sym_sdiv] = ACTIONS(1021),
    [anon_sym_mod] = ACTIONS(1021),
    [anon_sym_smod] = ACTIONS(1021),
    [anon_sym_exp] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1021),
    [anon_sym_lt] = ACTIONS(1021),
    [anon_sym_gt] = ACTIONS(1021),
    [anon_sym_slt] = ACTIONS(1021),
    [anon_sym_sgt] = ACTIONS(1021),
    [anon_sym_eq] = ACTIONS(1021),
    [anon_sym_iszero] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1021),
    [anon_sym_or] = ACTIONS(1021),
    [anon_sym_xor] = ACTIONS(1021),
    [anon_sym_byte] = ACTIONS(1021),
    [anon_sym_shl] = ACTIONS(1021),
    [anon_sym_shr] = ACTIONS(1021),
    [anon_sym_sar] = ACTIONS(1021),
    [anon_sym_addmod] = ACTIONS(1021),
    [anon_sym_mulmod] = ACTIONS(1021),
    [anon_sym_signextend] = ACTIONS(1021),
    [anon_sym_keccak256] = ACTIONS(1021),
    [anon_sym_pop] = ACTIONS(1021),
    [anon_sym_mload] = ACTIONS(1021),
    [anon_sym_mcopy] = ACTIONS(1021),
    [anon_sym_tload] = ACTIONS(1021),
    [anon_sym_tstore] = ACTIONS(1021),
    [anon_sym_mstore] = ACTIONS(1021),
    [anon_sym_mstore8] = ACTIONS(1021),
    [anon_sym_sload] = ACTIONS(1021),
    [anon_sym_sstore] = ACTIONS(1021),
    [anon_sym_msize] = ACTIONS(1021),
    [anon_sym_gas] = ACTIONS(1021),
    [anon_sym_address] = ACTIONS(1021),
    [anon_sym_balance] = ACTIONS(1021),
    [anon_sym_selfbalance] = ACTIONS(1021),
    [anon_sym_caller] = ACTIONS(1021),
    [anon_sym_callvalue] = ACTIONS(1021),
    [anon_sym_calldataload] = ACTIONS(1021),
    [anon_sym_calldatasize] = ACTIONS(1021),
    [anon_sym_calldatacopy] = ACTIONS(1021),
    [anon_sym_extcodesize] = ACTIONS(1021),
    [anon_sym_extcodecopy] = ACTIONS(1021),
    [anon_sym_returndatasize] = ACTIONS(1021),
    [anon_sym_returndatacopy] = ACTIONS(1021),
    [anon_sym_extcodehash] = ACTIONS(1021),
    [anon_sym_create] = ACTIONS(1021),
    [anon_sym_create2] = ACTIONS(1021),
    [anon_sym_call] = ACTIONS(1021),
    [anon_sym_callcode] = ACTIONS(1021),
    [anon_sym_delegatecall] = ACTIONS(1021),
    [anon_sym_staticcall] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_revert] = ACTIONS(1021),
    [anon_sym_selfdestruct] = ACTIONS(1021),
    [anon_sym_invalid] = ACTIONS(1021),
    [anon_sym_log0] = ACTIONS(1021),
    [anon_sym_log1] = ACTIONS(1021),
    [anon_sym_log2] = ACTIONS(1021),
    [anon_sym_log3] = ACTIONS(1021),
    [anon_sym_log4] = ACTIONS(1021),
    [anon_sym_chainid] = ACTIONS(1021),
    [anon_sym_origin] = ACTIONS(1021),
    [anon_sym_gasprice] = ACTIONS(1021),
    [anon_sym_blockhash] = ACTIONS(1021),
    [anon_sym_blobhash] = ACTIONS(1021),
    [anon_sym_basefee] = ACTIONS(1021),
    [anon_sym_blobfee] = ACTIONS(1021),
    [anon_sym_coinbase] = ACTIONS(1021),
    [anon_sym_timestamp] = ACTIONS(1021),
    [anon_sym_number] = ACTIONS(1021),
    [anon_sym_difficulty] = ACTIONS(1021),
    [anon_sym_gaslimit] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1028),
    [anon_sym_LBRACE] = ACTIONS(1030),
    [anon_sym_COMMA] = ACTIONS(1030),
    [anon_sym_RBRACE] = ACTIONS(1030),
    [anon_sym_RPAREN] = ACTIONS(1030),
    [anon_sym_for] = ACTIONS(1028),
    [sym_yul_leave] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1028),
    [anon_sym_continue] = ACTIONS(1028),
    [sym_yul_decimal_number] = ACTIONS(1028),
    [sym_yul_hex_number] = ACTIONS(1030),
    [anon_sym_true] = ACTIONS(1028),
    [anon_sym_false] = ACTIONS(1028),
    [anon_sym_let] = ACTIONS(1028),
    [anon_sym_if] = ACTIONS(1028),
    [anon_sym_switch] = ACTIONS(1028),
    [anon_sym_default] = ACTIONS(1028),
    [anon_sym_case] = ACTIONS(1028),
    [anon_sym_function] = ACTIONS(1028),
    [anon_sym_stop] = ACTIONS(1028),
    [anon_sym_add] = ACTIONS(1028),
    [anon_sym_sub] = ACTIONS(1028),
    [anon_sym_mul] = ACTIONS(1028),
    [anon_sym_div] = ACTIONS(1028),
    [anon_sym_sdiv] = ACTIONS(1028),
    [anon_sym_mod] = ACTIONS(1028),
    [anon_sym_smod] = ACTIONS(1028),
    [anon_sym_exp] = ACTIONS(1028),
    [anon_sym_not] = ACTIONS(1028),
    [anon_sym_lt] = ACTIONS(1028),
    [anon_sym_gt] = ACTIONS(1028),
    [anon_sym_slt] = ACTIONS(1028),
    [anon_sym_sgt] = ACTIONS(1028),
    [anon_sym_eq] = ACTIONS(1028),
    [anon_sym_iszero] = ACTIONS(1028),
    [anon_sym_and] = ACTIONS(1028),
    [anon_sym_or] = ACTIONS(1028),
    [anon_sym_xor] = ACTIONS(1028),
    [anon_sym_byte] = ACTIONS(1028),
    [anon_sym_shl] = ACTIONS(1028),
    [anon_sym_shr] = ACTIONS(1028),
    [anon_sym_sar] = ACTIONS(1028),
    [anon_sym_addmod] = ACTIONS(1028),
    [anon_sym_mulmod] = ACTIONS(1028),
    [anon_sym_signextend] = ACTIONS(1028),
    [anon_sym_keccak256] = ACTIONS(1028),
    [anon_sym_pop] = ACTIONS(1028),
    [anon_sym_mload] = ACTIONS(1028),
    [anon_sym_mcopy] = ACTIONS(1028),
    [anon_sym_tload] = ACTIONS(1028),
    [anon_sym_tstore] = ACTIONS(1028),
    [anon_sym_mstore] = ACTIONS(1028),
    [anon_sym_mstore8] = ACTIONS(1028),
    [anon_sym_sload] = ACTIONS(1028),
    [anon_sym_sstore] = ACTIONS(1028),
    [anon_sym_msize] = ACTIONS(1028),
    [anon_sym_gas] = ACTIONS(1028),
    [anon_sym_address] = ACTIONS(1028),
    [anon_sym_balance] = ACTIONS(1028),
    [anon_sym_selfbalance] = ACTIONS(1028),
    [anon_sym_caller] = ACTIONS(1028),
    [anon_sym_callvalue] = ACTIONS(1028),
    [anon_sym_calldataload] = ACTIONS(1028),
    [anon_sym_calldatasize] = ACTIONS(1028),
    [anon_sym_calldatacopy] = ACTIONS(1028),
    [anon_sym_extcodesize] = ACTIONS(1028),
    [anon_sym_extcodecopy] = ACTIONS(1028),
    [anon_sym_returndatasize] = ACTIONS(1028),
    [anon_sym_returndatacopy] = ACTIONS(1028),
    [anon_sym_extcodehash] = ACTIONS(1028),
    [anon_sym_create] = ACTIONS(1028),
    [anon_sym_create2] = ACTIONS(1028),
    [anon_sym_call] = ACTIONS(1028),
    [anon_sym_callcode] = ACTIONS(1028),
    [anon_sym_delegatecall] = ACTIONS(1028),
    [anon_sym_staticcall] = ACTIONS(1028),
    [anon_sym_return] = ACTIONS(1028),
    [anon_sym_revert] = ACTIONS(1028),
    [anon_sym_selfdestruct] = ACTIONS(1028),
    [anon_sym_invalid] = ACTIONS(1028),
    [anon_sym_log0] = ACTIONS(1028),
    [anon_sym_log1] = ACTIONS(1028),
    [anon_sym_log2] = ACTIONS(1028),
    [anon_sym_log3] = ACTIONS(1028),
    [anon_sym_log4] = ACTIONS(1028),
    [anon_sym_chainid] = ACTIONS(1028),
    [anon_sym_origin] = ACTIONS(1028),
    [anon_sym_gasprice] = ACTIONS(1028),
    [anon_sym_blockhash] = ACTIONS(1028),
    [anon_sym_blobhash] = ACTIONS(1028),
    [anon_sym_basefee] = ACTIONS(1028),
    [anon_sym_blobfee] = ACTIONS(1028),
    [anon_sym_coinbase] = ACTIONS(1028),
    [anon_sym_timestamp] = ACTIONS(1028),
    [anon_sym_number] = ACTIONS(1028),
    [anon_sym_difficulty] = ACTIONS(1028),
    [anon_sym_gaslimit] = ACTIONS(1028),
    [anon_sym_DQUOTE] = ACTIONS(1030),
    [anon_sym_SQUOTE] = ACTIONS(1030),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1032),
    [anon_sym_LBRACE] = ACTIONS(1034),
    [anon_sym_COMMA] = ACTIONS(1034),
    [anon_sym_RBRACE] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1034),
    [anon_sym_for] = ACTIONS(1032),
    [sym_yul_leave] = ACTIONS(1032),
    [anon_sym_break] = ACTIONS(1032),
    [anon_sym_continue] = ACTIONS(1032),
    [sym_yul_decimal_number] = ACTIONS(1032),
    [sym_yul_hex_number] = ACTIONS(1034),
    [anon_sym_true] = ACTIONS(1032),
    [anon_sym_false] = ACTIONS(1032),
    [anon_sym_let] = ACTIONS(1032),
    [anon_sym_if] = ACTIONS(1032),
    [anon_sym_switch] = ACTIONS(1032),
    [anon_sym_default] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(1032),
    [anon_sym_function] = ACTIONS(1032),
    [anon_sym_stop] = ACTIONS(1032),
    [anon_sym_add] = ACTIONS(1032),
    [anon_sym_sub] = ACTIONS(1032),
    [anon_sym_mul] = ACTIONS(1032),
    [anon_sym_div] = ACTIONS(1032),
    [anon_sym_sdiv] = ACTIONS(1032),
    [anon_sym_mod] = ACTIONS(1032),
    [anon_sym_smod] = ACTIONS(1032),
    [anon_sym_exp] = ACTIONS(1032),
    [anon_sym_not] = ACTIONS(1032),
    [anon_sym_lt] = ACTIONS(1032),
    [anon_sym_gt] = ACTIONS(1032),
    [anon_sym_slt] = ACTIONS(1032),
    [anon_sym_sgt] = ACTIONS(1032),
    [anon_sym_eq] = ACTIONS(1032),
    [anon_sym_iszero] = ACTIONS(1032),
    [anon_sym_and] = ACTIONS(1032),
    [anon_sym_or] = ACTIONS(1032),
    [anon_sym_xor] = ACTIONS(1032),
    [anon_sym_byte] = ACTIONS(1032),
    [anon_sym_shl] = ACTIONS(1032),
    [anon_sym_shr] = ACTIONS(1032),
    [anon_sym_sar] = ACTIONS(1032),
    [anon_sym_addmod] = ACTIONS(1032),
    [anon_sym_mulmod] = ACTIONS(1032),
    [anon_sym_signextend] = ACTIONS(1032),
    [anon_sym_keccak256] = ACTIONS(1032),
    [anon_sym_pop] = ACTIONS(1032),
    [anon_sym_mload] = ACTIONS(1032),
    [anon_sym_mcopy] = ACTIONS(1032),
    [anon_sym_tload] = ACTIONS(1032),
    [anon_sym_tstore] = ACTIONS(1032),
    [anon_sym_mstore] = ACTIONS(1032),
    [anon_sym_mstore8] = ACTIONS(1032),
    [anon_sym_sload] = ACTIONS(1032),
    [anon_sym_sstore] = ACTIONS(1032),
    [anon_sym_msize] = ACTIONS(1032),
    [anon_sym_gas] = ACTIONS(1032),
    [anon_sym_address] = ACTIONS(1032),
    [anon_sym_balance] = ACTIONS(1032),
    [anon_sym_selfbalance] = ACTIONS(1032),
    [anon_sym_caller] = ACTIONS(1032),
    [anon_sym_callvalue] = ACTIONS(1032),
    [anon_sym_calldataload] = ACTIONS(1032),
    [anon_sym_calldatasize] = ACTIONS(1032),
    [anon_sym_calldatacopy] = ACTIONS(1032),
    [anon_sym_extcodesize] = ACTIONS(1032),
    [anon_sym_extcodecopy] = ACTIONS(1032),
    [anon_sym_returndatasize] = ACTIONS(1032),
    [anon_sym_returndatacopy] = ACTIONS(1032),
    [anon_sym_extcodehash] = ACTIONS(1032),
    [anon_sym_create] = ACTIONS(1032),
    [anon_sym_create2] = ACTIONS(1032),
    [anon_sym_call] = ACTIONS(1032),
    [anon_sym_callcode] = ACTIONS(1032),
    [anon_sym_delegatecall] = ACTIONS(1032),
    [anon_sym_staticcall] = ACTIONS(1032),
    [anon_sym_return] = ACTIONS(1032),
    [anon_sym_revert] = ACTIONS(1032),
    [anon_sym_selfdestruct] = ACTIONS(1032),
    [anon_sym_invalid] = ACTIONS(1032),
    [anon_sym_log0] = ACTIONS(1032),
    [anon_sym_log1] = ACTIONS(1032),
    [anon_sym_log2] = ACTIONS(1032),
    [anon_sym_log3] = ACTIONS(1032),
    [anon_sym_log4] = ACTIONS(1032),
    [anon_sym_chainid] = ACTIONS(1032),
    [anon_sym_origin] = ACTIONS(1032),
    [anon_sym_gasprice] = ACTIONS(1032),
    [anon_sym_blockhash] = ACTIONS(1032),
    [anon_sym_blobhash] = ACTIONS(1032),
    [anon_sym_basefee] = ACTIONS(1032),
    [anon_sym_blobfee] = ACTIONS(1032),
    [anon_sym_coinbase] = ACTIONS(1032),
    [anon_sym_timestamp] = ACTIONS(1032),
    [anon_sym_number] = ACTIONS(1032),
    [anon_sym_difficulty] = ACTIONS(1032),
    [anon_sym_gaslimit] = ACTIONS(1032),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_SQUOTE] = ACTIONS(1034),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1036),
    [anon_sym_LBRACE] = ACTIONS(1038),
    [anon_sym_COMMA] = ACTIONS(1038),
    [anon_sym_RBRACE] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_for] = ACTIONS(1036),
    [sym_yul_leave] = ACTIONS(1036),
    [anon_sym_break] = ACTIONS(1036),
    [anon_sym_continue] = ACTIONS(1036),
    [sym_yul_decimal_number] = ACTIONS(1036),
    [sym_yul_hex_number] = ACTIONS(1038),
    [anon_sym_true] = ACTIONS(1036),
    [anon_sym_false] = ACTIONS(1036),
    [anon_sym_let] = ACTIONS(1036),
    [anon_sym_if] = ACTIONS(1036),
    [anon_sym_switch] = ACTIONS(1036),
    [anon_sym_default] = ACTIONS(1036),
    [anon_sym_case] = ACTIONS(1036),
    [anon_sym_function] = ACTIONS(1036),
    [anon_sym_stop] = ACTIONS(1036),
    [anon_sym_add] = ACTIONS(1036),
    [anon_sym_sub] = ACTIONS(1036),
    [anon_sym_mul] = ACTIONS(1036),
    [anon_sym_div] = ACTIONS(1036),
    [anon_sym_sdiv] = ACTIONS(1036),
    [anon_sym_mod] = ACTIONS(1036),
    [anon_sym_smod] = ACTIONS(1036),
    [anon_sym_exp] = ACTIONS(1036),
    [anon_sym_not] = ACTIONS(1036),
    [anon_sym_lt] = ACTIONS(1036),
    [anon_sym_gt] = ACTIONS(1036),
    [anon_sym_slt] = ACTIONS(1036),
    [anon_sym_sgt] = ACTIONS(1036),
    [anon_sym_eq] = ACTIONS(1036),
    [anon_sym_iszero] = ACTIONS(1036),
    [anon_sym_and] = ACTIONS(1036),
    [anon_sym_or] = ACTIONS(1036),
    [anon_sym_xor] = ACTIONS(1036),
    [anon_sym_byte] = ACTIONS(1036),
    [anon_sym_shl] = ACTIONS(1036),
    [anon_sym_shr] = ACTIONS(1036),
    [anon_sym_sar] = ACTIONS(1036),
    [anon_sym_addmod] = ACTIONS(1036),
    [anon_sym_mulmod] = ACTIONS(1036),
    [anon_sym_signextend] = ACTIONS(1036),
    [anon_sym_keccak256] = ACTIONS(1036),
    [anon_sym_pop] = ACTIONS(1036),
    [anon_sym_mload] = ACTIONS(1036),
    [anon_sym_mcopy] = ACTIONS(1036),
    [anon_sym_tload] = ACTIONS(1036),
    [anon_sym_tstore] = ACTIONS(1036),
    [anon_sym_mstore] = ACTIONS(1036),
    [anon_sym_mstore8] = ACTIONS(1036),
    [anon_sym_sload] = ACTIONS(1036),
    [anon_sym_sstore] = ACTIONS(1036),
    [anon_sym_msize] = ACTIONS(1036),
    [anon_sym_gas] = ACTIONS(1036),
    [anon_sym_address] = ACTIONS(1036),
    [anon_sym_balance] = ACTIONS(1036),
    [anon_sym_selfbalance] = ACTIONS(1036),
    [anon_sym_caller] = ACTIONS(1036),
    [anon_sym_callvalue] = ACTIONS(1036),
    [anon_sym_calldataload] = ACTIONS(1036),
    [anon_sym_calldatasize] = ACTIONS(1036),
    [anon_sym_calldatacopy] = ACTIONS(1036),
    [anon_sym_extcodesize] = ACTIONS(1036),
    [anon_sym_extcodecopy] = ACTIONS(1036),
    [anon_sym_returndatasize] = ACTIONS(1036),
    [anon_sym_returndatacopy] = ACTIONS(1036),
    [anon_sym_extcodehash] = ACTIONS(1036),
    [anon_sym_create] = ACTIONS(1036),
    [anon_sym_create2] = ACTIONS(1036),
    [anon_sym_call] = ACTIONS(1036),
    [anon_sym_callcode] = ACTIONS(1036),
    [anon_sym_delegatecall] = ACTIONS(1036),
    [anon_sym_staticcall] = ACTIONS(1036),
    [anon_sym_return] = ACTIONS(1036),
    [anon_sym_revert] = ACTIONS(1036),
    [anon_sym_selfdestruct] = ACTIONS(1036),
    [anon_sym_invalid] = ACTIONS(1036),
    [anon_sym_log0] = ACTIONS(1036),
    [anon_sym_log1] = ACTIONS(1036),
    [anon_sym_log2] = ACTIONS(1036),
    [anon_sym_log3] = ACTIONS(1036),
    [anon_sym_log4] = ACTIONS(1036),
    [anon_sym_chainid] = ACTIONS(1036),
    [anon_sym_origin] = ACTIONS(1036),
    [anon_sym_gasprice] = ACTIONS(1036),
    [anon_sym_blockhash] = ACTIONS(1036),
    [anon_sym_blobhash] = ACTIONS(1036),
    [anon_sym_basefee] = ACTIONS(1036),
    [anon_sym_blobfee] = ACTIONS(1036),
    [anon_sym_coinbase] = ACTIONS(1036),
    [anon_sym_timestamp] = ACTIONS(1036),
    [anon_sym_number] = ACTIONS(1036),
    [anon_sym_difficulty] = ACTIONS(1036),
    [anon_sym_gaslimit] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_SQUOTE] = ACTIONS(1038),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_COMMA] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1040),
    [sym_yul_leave] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [sym_yul_decimal_number] = ACTIONS(1040),
    [sym_yul_hex_number] = ACTIONS(1042),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1040),
    [anon_sym_case] = ACTIONS(1040),
    [anon_sym_function] = ACTIONS(1040),
    [anon_sym_stop] = ACTIONS(1040),
    [anon_sym_add] = ACTIONS(1040),
    [anon_sym_sub] = ACTIONS(1040),
    [anon_sym_mul] = ACTIONS(1040),
    [anon_sym_div] = ACTIONS(1040),
    [anon_sym_sdiv] = ACTIONS(1040),
    [anon_sym_mod] = ACTIONS(1040),
    [anon_sym_smod] = ACTIONS(1040),
    [anon_sym_exp] = ACTIONS(1040),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_lt] = ACTIONS(1040),
    [anon_sym_gt] = ACTIONS(1040),
    [anon_sym_slt] = ACTIONS(1040),
    [anon_sym_sgt] = ACTIONS(1040),
    [anon_sym_eq] = ACTIONS(1040),
    [anon_sym_iszero] = ACTIONS(1040),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_byte] = ACTIONS(1040),
    [anon_sym_shl] = ACTIONS(1040),
    [anon_sym_shr] = ACTIONS(1040),
    [anon_sym_sar] = ACTIONS(1040),
    [anon_sym_addmod] = ACTIONS(1040),
    [anon_sym_mulmod] = ACTIONS(1040),
    [anon_sym_signextend] = ACTIONS(1040),
    [anon_sym_keccak256] = ACTIONS(1040),
    [anon_sym_pop] = ACTIONS(1040),
    [anon_sym_mload] = ACTIONS(1040),
    [anon_sym_mcopy] = ACTIONS(1040),
    [anon_sym_tload] = ACTIONS(1040),
    [anon_sym_tstore] = ACTIONS(1040),
    [anon_sym_mstore] = ACTIONS(1040),
    [anon_sym_mstore8] = ACTIONS(1040),
    [anon_sym_sload] = ACTIONS(1040),
    [anon_sym_sstore] = ACTIONS(1040),
    [anon_sym_msize] = ACTIONS(1040),
    [anon_sym_gas] = ACTIONS(1040),
    [anon_sym_address] = ACTIONS(1040),
    [anon_sym_balance] = ACTIONS(1040),
    [anon_sym_selfbalance] = ACTIONS(1040),
    [anon_sym_caller] = ACTIONS(1040),
    [anon_sym_callvalue] = ACTIONS(1040),
    [anon_sym_calldataload] = ACTIONS(1040),
    [anon_sym_calldatasize] = ACTIONS(1040),
    [anon_sym_calldatacopy] = ACTIONS(1040),
    [anon_sym_extcodesize] = ACTIONS(1040),
    [anon_sym_extcodecopy] = ACTIONS(1040),
    [anon_sym_returndatasize] = ACTIONS(1040),
    [anon_sym_returndatacopy] = ACTIONS(1040),
    [anon_sym_extcodehash] = ACTIONS(1040),
    [anon_sym_create] = ACTIONS(1040),
    [anon_sym_create2] = ACTIONS(1040),
    [anon_sym_call] = ACTIONS(1040),
    [anon_sym_callcode] = ACTIONS(1040),
    [anon_sym_delegatecall] = ACTIONS(1040),
    [anon_sym_staticcall] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_revert] = ACTIONS(1040),
    [anon_sym_selfdestruct] = ACTIONS(1040),
    [anon_sym_invalid] = ACTIONS(1040),
    [anon_sym_log0] = ACTIONS(1040),
    [anon_sym_log1] = ACTIONS(1040),
    [anon_sym_log2] = ACTIONS(1040),
    [anon_sym_log3] = ACTIONS(1040),
    [anon_sym_log4] = ACTIONS(1040),
    [anon_sym_chainid] = ACTIONS(1040),
    [anon_sym_origin] = ACTIONS(1040),
    [anon_sym_gasprice] = ACTIONS(1040),
    [anon_sym_blockhash] = ACTIONS(1040),
    [anon_sym_blobhash] = ACTIONS(1040),
    [anon_sym_basefee] = ACTIONS(1040),
    [anon_sym_blobfee] = ACTIONS(1040),
    [anon_sym_coinbase] = ACTIONS(1040),
    [anon_sym_timestamp] = ACTIONS(1040),
    [anon_sym_number] = ACTIONS(1040),
    [anon_sym_difficulty] = ACTIONS(1040),
    [anon_sym_gaslimit] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_identifier] = ACTIONS(1044),
    [anon_sym_LBRACE] = ACTIONS(1046),
    [anon_sym_COMMA] = ACTIONS(1046),
    [anon_sym_RBRACE] = ACTIONS(1046),
    [anon_sym_RPAREN] = ACTIONS(1046),
    [anon_sym_for] = ACTIONS(1044),
    [sym_yul_leave] = ACTIONS(1044),
    [anon_sym_break] = ACTIONS(1044),
    [anon_sym_continue] = ACTIONS(1044),
    [sym_yul_decimal_number] = ACTIONS(1044),
    [sym_yul_hex_number] = ACTIONS(1046),
    [anon_sym_true] = ACTIONS(1044),
    [anon_sym_false] = ACTIONS(1044),
    [anon_sym_let] = ACTIONS(1044),
    [anon_sym_if] = ACTIONS(1044),
    [anon_sym_switch] = ACTIONS(1044),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1044),
    [anon_sym_function] = ACTIONS(1044),
    [anon_sym_stop] = ACTIONS(1044),
    [anon_sym_add] = ACTIONS(1044),
    [anon_sym_sub] = ACTIONS(1044),
    [anon_sym_mul] = ACTIONS(1044),
    [anon_sym_div] = ACTIONS(1044),
    [anon_sym_sdiv] = ACTIONS(1044),
    [anon_sym_mod] = ACTIONS(1044),
    [anon_sym_smod] = ACTIONS(1044),
    [anon_sym_exp] = ACTIONS(1044),
    [anon_sym_not] = ACTIONS(1044),
    [anon_sym_lt] = ACTIONS(1044),
    [anon_sym_gt] = ACTIONS(1044),
    [anon_sym_slt] = ACTIONS(1044),
    [anon_sym_sgt] = ACTIONS(1044),
    [anon_sym_eq] = ACTIONS(1044),
    [anon_sym_iszero] = ACTIONS(1044),
    [anon_sym_and] = ACTIONS(1044),
    [anon_sym_or] = ACTIONS(1044),
    [anon_sym_xor] = ACTIONS(1044),
    [anon_sym_byte] = ACTIONS(1044),
    [anon_sym_shl] = ACTIONS(1044),
    [anon_sym_shr] = ACTIONS(1044),
    [anon_sym_sar] = ACTIONS(1044),
    [anon_sym_addmod] = ACTIONS(1044),
    [anon_sym_mulmod] = ACTIONS(1044),
    [anon_sym_signextend] = ACTIONS(1044),
    [anon_sym_keccak256] = ACTIONS(1044),
    [anon_sym_pop] = ACTIONS(1044),
    [anon_sym_mload] = ACTIONS(1044),
    [anon_sym_mcopy] = ACTIONS(1044),
    [anon_sym_tload] = ACTIONS(1044),
    [anon_sym_tstore] = ACTIONS(1044),
    [anon_sym_mstore] = ACTIONS(1044),
    [anon_sym_mstore8] = ACTIONS(1044),
    [anon_sym_sload] = ACTIONS(1044),
    [anon_sym_sstore] = ACTIONS(1044),
    [anon_sym_msize] = ACTIONS(1044),
    [anon_sym_gas] = ACTIONS(1044),
    [anon_sym_address] = ACTIONS(1044),
    [anon_sym_balance] = ACTIONS(1044),
    [anon_sym_selfbalance] = ACTIONS(1044),
    [anon_sym_caller] = ACTIONS(1044),
    [anon_sym_callvalue] = ACTIONS(1044),
    [anon_sym_calldataload] = ACTIONS(1044),
    [anon_sym_calldatasize] = ACTIONS(1044),
    [anon_sym_calldatacopy] = ACTIONS(1044),
    [anon_sym_extcodesize] = ACTIONS(1044),
    [anon_sym_extcodecopy] = ACTIONS(1044),
    [anon_sym_returndatasize] = ACTIONS(1044),
    [anon_sym_returndatacopy] = ACTIONS(1044),
    [anon_sym_extcodehash] = ACTIONS(1044),
    [anon_sym_create] = ACTIONS(1044),
    [anon_sym_create2] = ACTIONS(1044),
    [anon_sym_call] = ACTIONS(1044),
    [anon_sym_callcode] = ACTIONS(1044),
    [anon_sym_delegatecall] = ACTIONS(1044),
    [anon_sym_staticcall] = ACTIONS(1044),
    [anon_sym_return] = ACTIONS(1044),
    [anon_sym_revert] = ACTIONS(1044),
    [anon_sym_selfdestruct] = ACTIONS(1044),
    [anon_sym_invalid] = ACTIONS(1044),
    [anon_sym_log0] = ACTIONS(1044),
    [anon_sym_log1] = ACTIONS(1044),
    [anon_sym_log2] = ACTIONS(1044),
    [anon_sym_log3] = ACTIONS(1044),
    [anon_sym_log4] = ACTIONS(1044),
    [anon_sym_chainid] = ACTIONS(1044),
    [anon_sym_origin] = ACTIONS(1044),
    [anon_sym_gasprice] = ACTIONS(1044),
    [anon_sym_blockhash] = ACTIONS(1044),
    [anon_sym_blobhash] = ACTIONS(1044),
    [anon_sym_basefee] = ACTIONS(1044),
    [anon_sym_blobfee] = ACTIONS(1044),
    [anon_sym_coinbase] = ACTIONS(1044),
    [anon_sym_timestamp] = ACTIONS(1044),
    [anon_sym_number] = ACTIONS(1044),
    [anon_sym_difficulty] = ACTIONS(1044),
    [anon_sym_gaslimit] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [anon_sym_SQUOTE] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_COMMA] = ACTIONS(1050),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_RPAREN] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1048),
    [sym_yul_leave] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [sym_yul_decimal_number] = ACTIONS(1048),
    [sym_yul_hex_number] = ACTIONS(1050),
    [anon_sym_true] = ACTIONS(1048),
    [anon_sym_false] = ACTIONS(1048),
    [anon_sym_let] = ACTIONS(1048),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_default] = ACTIONS(1048),
    [anon_sym_case] = ACTIONS(1048),
    [anon_sym_function] = ACTIONS(1048),
    [anon_sym_stop] = ACTIONS(1048),
    [anon_sym_add] = ACTIONS(1048),
    [anon_sym_sub] = ACTIONS(1048),
    [anon_sym_mul] = ACTIONS(1048),
    [anon_sym_div] = ACTIONS(1048),
    [anon_sym_sdiv] = ACTIONS(1048),
    [anon_sym_mod] = ACTIONS(1048),
    [anon_sym_smod] = ACTIONS(1048),
    [anon_sym_exp] = ACTIONS(1048),
    [anon_sym_not] = ACTIONS(1048),
    [anon_sym_lt] = ACTIONS(1048),
    [anon_sym_gt] = ACTIONS(1048),
    [anon_sym_slt] = ACTIONS(1048),
    [anon_sym_sgt] = ACTIONS(1048),
    [anon_sym_eq] = ACTIONS(1048),
    [anon_sym_iszero] = ACTIONS(1048),
    [anon_sym_and] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(1048),
    [anon_sym_xor] = ACTIONS(1048),
    [anon_sym_byte] = ACTIONS(1048),
    [anon_sym_shl] = ACTIONS(1048),
    [anon_sym_shr] = ACTIONS(1048),
    [anon_sym_sar] = ACTIONS(1048),
    [anon_sym_addmod] = ACTIONS(1048),
    [anon_sym_mulmod] = ACTIONS(1048),
    [anon_sym_signextend] = ACTIONS(1048),
    [anon_sym_keccak256] = ACTIONS(1048),
    [anon_sym_pop] = ACTIONS(1048),
    [anon_sym_mload] = ACTIONS(1048),
    [anon_sym_mcopy] = ACTIONS(1048),
    [anon_sym_tload] = ACTIONS(1048),
    [anon_sym_tstore] = ACTIONS(1048),
    [anon_sym_mstore] = ACTIONS(1048),
    [anon_sym_mstore8] = ACTIONS(1048),
    [anon_sym_sload] = ACTIONS(1048),
    [anon_sym_sstore] = ACTIONS(1048),
    [anon_sym_msize] = ACTIONS(1048),
    [anon_sym_gas] = ACTIONS(1048),
    [anon_sym_address] = ACTIONS(1048),
    [anon_sym_balance] = ACTIONS(1048),
    [anon_sym_selfbalance] = ACTIONS(1048),
    [anon_sym_caller] = ACTIONS(1048),
    [anon_sym_callvalue] = ACTIONS(1048),
    [anon_sym_calldataload] = ACTIONS(1048),
    [anon_sym_calldatasize] = ACTIONS(1048),
    [anon_sym_calldatacopy] = ACTIONS(1048),
    [anon_sym_extcodesize] = ACTIONS(1048),
    [anon_sym_extcodecopy] = ACTIONS(1048),
    [anon_sym_returndatasize] = ACTIONS(1048),
    [anon_sym_returndatacopy] = ACTIONS(1048),
    [anon_sym_extcodehash] = ACTIONS(1048),
    [anon_sym_create] = ACTIONS(1048),
    [anon_sym_create2] = ACTIONS(1048),
    [anon_sym_call] = ACTIONS(1048),
    [anon_sym_callcode] = ACTIONS(1048),
    [anon_sym_delegatecall] = ACTIONS(1048),
    [anon_sym_staticcall] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_revert] = ACTIONS(1048),
    [anon_sym_selfdestruct] = ACTIONS(1048),
    [anon_sym_invalid] = ACTIONS(1048),
    [anon_sym_log0] = ACTIONS(1048),
    [anon_sym_log1] = ACTIONS(1048),
    [anon_sym_log2] = ACTIONS(1048),
    [anon_sym_log3] = ACTIONS(1048),
    [anon_sym_log4] = ACTIONS(1048),
    [anon_sym_chainid] = ACTIONS(1048),
    [anon_sym_origin] = ACTIONS(1048),
    [anon_sym_gasprice] = ACTIONS(1048),
    [anon_sym_blockhash] = ACTIONS(1048),
    [anon_sym_blobhash] = ACTIONS(1048),
    [anon_sym_basefee] = ACTIONS(1048),
    [anon_sym_blobfee] = ACTIONS(1048),
    [anon_sym_coinbase] = ACTIONS(1048),
    [anon_sym_timestamp] = ACTIONS(1048),
    [anon_sym_number] = ACTIONS(1048),
    [anon_sym_difficulty] = ACTIONS(1048),
    [anon_sym_gaslimit] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_COMMA] = ACTIONS(1023),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym_RPAREN] = ACTIONS(1023),
    [anon_sym_for] = ACTIONS(1021),
    [sym_yul_leave] = ACTIONS(1021),
    [anon_sym_break] = ACTIONS(1021),
    [anon_sym_continue] = ACTIONS(1021),
    [sym_yul_decimal_number] = ACTIONS(1021),
    [sym_yul_hex_number] = ACTIONS(1023),
    [anon_sym_true] = ACTIONS(1021),
    [anon_sym_false] = ACTIONS(1021),
    [anon_sym_let] = ACTIONS(1021),
    [anon_sym_COLON_EQ] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(1021),
    [anon_sym_switch] = ACTIONS(1021),
    [anon_sym_function] = ACTIONS(1021),
    [anon_sym_stop] = ACTIONS(1021),
    [anon_sym_add] = ACTIONS(1021),
    [anon_sym_sub] = ACTIONS(1021),
    [anon_sym_mul] = ACTIONS(1021),
    [anon_sym_div] = ACTIONS(1021),
    [anon_sym_sdiv] = ACTIONS(1021),
    [anon_sym_mod] = ACTIONS(1021),
    [anon_sym_smod] = ACTIONS(1021),
    [anon_sym_exp] = ACTIONS(1021),
    [anon_sym_not] = ACTIONS(1021),
    [anon_sym_lt] = ACTIONS(1021),
    [anon_sym_gt] = ACTIONS(1021),
    [anon_sym_slt] = ACTIONS(1021),
    [anon_sym_sgt] = ACTIONS(1021),
    [anon_sym_eq] = ACTIONS(1021),
    [anon_sym_iszero] = ACTIONS(1021),
    [anon_sym_and] = ACTIONS(1021),
    [anon_sym_or] = ACTIONS(1021),
    [anon_sym_xor] = ACTIONS(1021),
    [anon_sym_byte] = ACTIONS(1021),
    [anon_sym_shl] = ACTIONS(1021),
    [anon_sym_shr] = ACTIONS(1021),
    [anon_sym_sar] = ACTIONS(1021),
    [anon_sym_addmod] = ACTIONS(1021),
    [anon_sym_mulmod] = ACTIONS(1021),
    [anon_sym_signextend] = ACTIONS(1021),
    [anon_sym_keccak256] = ACTIONS(1021),
    [anon_sym_pop] = ACTIONS(1021),
    [anon_sym_mload] = ACTIONS(1021),
    [anon_sym_mcopy] = ACTIONS(1021),
    [anon_sym_tload] = ACTIONS(1021),
    [anon_sym_tstore] = ACTIONS(1021),
    [anon_sym_mstore] = ACTIONS(1021),
    [anon_sym_mstore8] = ACTIONS(1021),
    [anon_sym_sload] = ACTIONS(1021),
    [anon_sym_sstore] = ACTIONS(1021),
    [anon_sym_msize] = ACTIONS(1021),
    [anon_sym_gas] = ACTIONS(1021),
    [anon_sym_address] = ACTIONS(1021),
    [anon_sym_balance] = ACTIONS(1021),
    [anon_sym_selfbalance] = ACTIONS(1021),
    [anon_sym_caller] = ACTIONS(1021),
    [anon_sym_callvalue] = ACTIONS(1021),
    [anon_sym_calldataload] = ACTIONS(1021),
    [anon_sym_calldatasize] = ACTIONS(1021),
    [anon_sym_calldatacopy] = ACTIONS(1021),
    [anon_sym_extcodesize] = ACTIONS(1021),
    [anon_sym_extcodecopy] = ACTIONS(1021),
    [anon_sym_returndatasize] = ACTIONS(1021),
    [anon_sym_returndatacopy] = ACTIONS(1021),
    [anon_sym_extcodehash] = ACTIONS(1021),
    [anon_sym_create] = ACTIONS(1021),
    [anon_sym_create2] = ACTIONS(1021),
    [anon_sym_call] = ACTIONS(1021),
    [anon_sym_callcode] = ACTIONS(1021),
    [anon_sym_delegatecall] = ACTIONS(1021),
    [anon_sym_staticcall] = ACTIONS(1021),
    [anon_sym_return] = ACTIONS(1021),
    [anon_sym_revert] = ACTIONS(1021),
    [anon_sym_selfdestruct] = ACTIONS(1021),
    [anon_sym_invalid] = ACTIONS(1021),
    [anon_sym_log0] = ACTIONS(1021),
    [anon_sym_log1] = ACTIONS(1021),
    [anon_sym_log2] = ACTIONS(1021),
    [anon_sym_log3] = ACTIONS(1021),
    [anon_sym_log4] = ACTIONS(1021),
    [anon_sym_chainid] = ACTIONS(1021),
    [anon_sym_origin] = ACTIONS(1021),
    [anon_sym_gasprice] = ACTIONS(1021),
    [anon_sym_blockhash] = ACTIONS(1021),
    [anon_sym_blobhash] = ACTIONS(1021),
    [anon_sym_basefee] = ACTIONS(1021),
    [anon_sym_blobfee] = ACTIONS(1021),
    [anon_sym_coinbase] = ACTIONS(1021),
    [anon_sym_timestamp] = ACTIONS(1021),
    [anon_sym_number] = ACTIONS(1021),
    [anon_sym_difficulty] = ACTIONS(1021),
    [anon_sym_gaslimit] = ACTIONS(1021),
    [anon_sym_DQUOTE] = ACTIONS(1023),
    [anon_sym_SQUOTE] = ACTIONS(1023),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [aux_sym_yul_switch_statement_repeat1] = STATE(269),
    [sym_identifier] = ACTIONS(1052),
    [anon_sym_LBRACE] = ACTIONS(1054),
    [anon_sym_RBRACE] = ACTIONS(1054),
    [anon_sym_for] = ACTIONS(1052),
    [sym_yul_leave] = ACTIONS(1052),
    [anon_sym_break] = ACTIONS(1052),
    [anon_sym_continue] = ACTIONS(1052),
    [sym_yul_decimal_number] = ACTIONS(1052),
    [sym_yul_hex_number] = ACTIONS(1054),
    [anon_sym_true] = ACTIONS(1052),
    [anon_sym_false] = ACTIONS(1052),
    [anon_sym_let] = ACTIONS(1052),
    [anon_sym_if] = ACTIONS(1052),
    [anon_sym_switch] = ACTIONS(1052),
    [anon_sym_default] = ACTIONS(1052),
    [anon_sym_case] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(1052),
    [anon_sym_stop] = ACTIONS(1052),
    [anon_sym_add] = ACTIONS(1052),
    [anon_sym_sub] = ACTIONS(1052),
    [anon_sym_mul] = ACTIONS(1052),
    [anon_sym_div] = ACTIONS(1052),
    [anon_sym_sdiv] = ACTIONS(1052),
    [anon_sym_mod] = ACTIONS(1052),
    [anon_sym_smod] = ACTIONS(1052),
    [anon_sym_exp] = ACTIONS(1052),
    [anon_sym_not] = ACTIONS(1052),
    [anon_sym_lt] = ACTIONS(1052),
    [anon_sym_gt] = ACTIONS(1052),
    [anon_sym_slt] = ACTIONS(1052),
    [anon_sym_sgt] = ACTIONS(1052),
    [anon_sym_eq] = ACTIONS(1052),
    [anon_sym_iszero] = ACTIONS(1052),
    [anon_sym_and] = ACTIONS(1052),
    [anon_sym_or] = ACTIONS(1052),
    [anon_sym_xor] = ACTIONS(1052),
    [anon_sym_byte] = ACTIONS(1052),
    [anon_sym_shl] = ACTIONS(1052),
    [anon_sym_shr] = ACTIONS(1052),
    [anon_sym_sar] = ACTIONS(1052),
    [anon_sym_addmod] = ACTIONS(1052),
    [anon_sym_mulmod] = ACTIONS(1052),
    [anon_sym_signextend] = ACTIONS(1052),
    [anon_sym_keccak256] = ACTIONS(1052),
    [anon_sym_pop] = ACTIONS(1052),
    [anon_sym_mload] = ACTIONS(1052),
    [anon_sym_mcopy] = ACTIONS(1052),
    [anon_sym_tload] = ACTIONS(1052),
    [anon_sym_tstore] = ACTIONS(1052),
    [anon_sym_mstore] = ACTIONS(1052),
    [anon_sym_mstore8] = ACTIONS(1052),
    [anon_sym_sload] = ACTIONS(1052),
    [anon_sym_sstore] = ACTIONS(1052),
    [anon_sym_msize] = ACTIONS(1052),
    [anon_sym_gas] = ACTIONS(1052),
    [anon_sym_address] = ACTIONS(1052),
    [anon_sym_balance] = ACTIONS(1052),
    [anon_sym_selfbalance] = ACTIONS(1052),
    [anon_sym_caller] = ACTIONS(1052),
    [anon_sym_callvalue] = ACTIONS(1052),
    [anon_sym_calldataload] = ACTIONS(1052),
    [anon_sym_calldatasize] = ACTIONS(1052),
    [anon_sym_calldatacopy] = ACTIONS(1052),
    [anon_sym_extcodesize] = ACTIONS(1052),
    [anon_sym_extcodecopy] = ACTIONS(1052),
    [anon_sym_returndatasize] = ACTIONS(1052),
    [anon_sym_returndatacopy] = ACTIONS(1052),
    [anon_sym_extcodehash] = ACTIONS(1052),
    [anon_sym_create] = ACTIONS(1052),
    [anon_sym_create2] = ACTIONS(1052),
    [anon_sym_call] = ACTIONS(1052),
    [anon_sym_callcode] = ACTIONS(1052),
    [anon_sym_delegatecall] = ACTIONS(1052),
    [anon_sym_staticcall] = ACTIONS(1052),
    [anon_sym_return] = ACTIONS(1052),
    [anon_sym_revert] = ACTIONS(1052),
    [anon_sym_selfdestruct] = ACTIONS(1052),
    [anon_sym_invalid] = ACTIONS(1052),
    [anon_sym_log0] = ACTIONS(1052),
    [anon_sym_log1] = ACTIONS(1052),
    [anon_sym_log2] = ACTIONS(1052),
    [anon_sym_log3] = ACTIONS(1052),
    [anon_sym_log4] = ACTIONS(1052),
    [anon_sym_chainid] = ACTIONS(1052),
    [anon_sym_origin] = ACTIONS(1052),
    [anon_sym_gasprice] = ACTIONS(1052),
    [anon_sym_blockhash] = ACTIONS(1052),
    [anon_sym_blobhash] = ACTIONS(1052),
    [anon_sym_basefee] = ACTIONS(1052),
    [anon_sym_blobfee] = ACTIONS(1052),
    [anon_sym_coinbase] = ACTIONS(1052),
    [anon_sym_timestamp] = ACTIONS(1052),
    [anon_sym_number] = ACTIONS(1052),
    [anon_sym_difficulty] = ACTIONS(1052),
    [anon_sym_gaslimit] = ACTIONS(1052),
    [anon_sym_DQUOTE] = ACTIONS(1054),
    [anon_sym_SQUOTE] = ACTIONS(1054),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(261),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_COMMA] = ACTIONS(1063),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1059),
    [sym_yul_leave] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1059),
    [sym_yul_decimal_number] = ACTIONS(1059),
    [sym_yul_hex_number] = ACTIONS(1061),
    [anon_sym_true] = ACTIONS(1059),
    [anon_sym_false] = ACTIONS(1059),
    [anon_sym_let] = ACTIONS(1059),
    [anon_sym_COLON_EQ] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_stop] = ACTIONS(1059),
    [anon_sym_add] = ACTIONS(1059),
    [anon_sym_sub] = ACTIONS(1059),
    [anon_sym_mul] = ACTIONS(1059),
    [anon_sym_div] = ACTIONS(1059),
    [anon_sym_sdiv] = ACTIONS(1059),
    [anon_sym_mod] = ACTIONS(1059),
    [anon_sym_smod] = ACTIONS(1059),
    [anon_sym_exp] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1059),
    [anon_sym_lt] = ACTIONS(1059),
    [anon_sym_gt] = ACTIONS(1059),
    [anon_sym_slt] = ACTIONS(1059),
    [anon_sym_sgt] = ACTIONS(1059),
    [anon_sym_eq] = ACTIONS(1059),
    [anon_sym_iszero] = ACTIONS(1059),
    [anon_sym_and] = ACTIONS(1059),
    [anon_sym_or] = ACTIONS(1059),
    [anon_sym_xor] = ACTIONS(1059),
    [anon_sym_byte] = ACTIONS(1059),
    [anon_sym_shl] = ACTIONS(1059),
    [anon_sym_shr] = ACTIONS(1059),
    [anon_sym_sar] = ACTIONS(1059),
    [anon_sym_addmod] = ACTIONS(1059),
    [anon_sym_mulmod] = ACTIONS(1059),
    [anon_sym_signextend] = ACTIONS(1059),
    [anon_sym_keccak256] = ACTIONS(1059),
    [anon_sym_pop] = ACTIONS(1059),
    [anon_sym_mload] = ACTIONS(1059),
    [anon_sym_mcopy] = ACTIONS(1059),
    [anon_sym_tload] = ACTIONS(1059),
    [anon_sym_tstore] = ACTIONS(1059),
    [anon_sym_mstore] = ACTIONS(1059),
    [anon_sym_mstore8] = ACTIONS(1059),
    [anon_sym_sload] = ACTIONS(1059),
    [anon_sym_sstore] = ACTIONS(1059),
    [anon_sym_msize] = ACTIONS(1059),
    [anon_sym_gas] = ACTIONS(1059),
    [anon_sym_address] = ACTIONS(1059),
    [anon_sym_balance] = ACTIONS(1059),
    [anon_sym_selfbalance] = ACTIONS(1059),
    [anon_sym_caller] = ACTIONS(1059),
    [anon_sym_callvalue] = ACTIONS(1059),
    [anon_sym_calldataload] = ACTIONS(1059),
    [anon_sym_calldatasize] = ACTIONS(1059),
    [anon_sym_calldatacopy] = ACTIONS(1059),
    [anon_sym_extcodesize] = ACTIONS(1059),
    [anon_sym_extcodecopy] = ACTIONS(1059),
    [anon_sym_returndatasize] = ACTIONS(1059),
    [anon_sym_returndatacopy] = ACTIONS(1059),
    [anon_sym_extcodehash] = ACTIONS(1059),
    [anon_sym_create] = ACTIONS(1059),
    [anon_sym_create2] = ACTIONS(1059),
    [anon_sym_call] = ACTIONS(1059),
    [anon_sym_callcode] = ACTIONS(1059),
    [anon_sym_delegatecall] = ACTIONS(1059),
    [anon_sym_staticcall] = ACTIONS(1059),
    [anon_sym_return] = ACTIONS(1059),
    [anon_sym_revert] = ACTIONS(1059),
    [anon_sym_selfdestruct] = ACTIONS(1059),
    [anon_sym_invalid] = ACTIONS(1059),
    [anon_sym_log0] = ACTIONS(1059),
    [anon_sym_log1] = ACTIONS(1059),
    [anon_sym_log2] = ACTIONS(1059),
    [anon_sym_log3] = ACTIONS(1059),
    [anon_sym_log4] = ACTIONS(1059),
    [anon_sym_chainid] = ACTIONS(1059),
    [anon_sym_origin] = ACTIONS(1059),
    [anon_sym_gasprice] = ACTIONS(1059),
    [anon_sym_blockhash] = ACTIONS(1059),
    [anon_sym_blobhash] = ACTIONS(1059),
    [anon_sym_basefee] = ACTIONS(1059),
    [anon_sym_blobfee] = ACTIONS(1059),
    [anon_sym_coinbase] = ACTIONS(1059),
    [anon_sym_timestamp] = ACTIONS(1059),
    [anon_sym_number] = ACTIONS(1059),
    [anon_sym_difficulty] = ACTIONS(1059),
    [anon_sym_gaslimit] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [aux_sym_yul_switch_statement_repeat1] = STATE(269),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_LBRACE] = ACTIONS(1069),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym_for] = ACTIONS(1067),
    [sym_yul_leave] = ACTIONS(1067),
    [anon_sym_break] = ACTIONS(1067),
    [anon_sym_continue] = ACTIONS(1067),
    [sym_yul_decimal_number] = ACTIONS(1067),
    [sym_yul_hex_number] = ACTIONS(1069),
    [anon_sym_true] = ACTIONS(1067),
    [anon_sym_false] = ACTIONS(1067),
    [anon_sym_let] = ACTIONS(1067),
    [anon_sym_if] = ACTIONS(1067),
    [anon_sym_switch] = ACTIONS(1067),
    [anon_sym_default] = ACTIONS(1071),
    [anon_sym_case] = ACTIONS(1073),
    [anon_sym_function] = ACTIONS(1067),
    [anon_sym_stop] = ACTIONS(1067),
    [anon_sym_add] = ACTIONS(1067),
    [anon_sym_sub] = ACTIONS(1067),
    [anon_sym_mul] = ACTIONS(1067),
    [anon_sym_div] = ACTIONS(1067),
    [anon_sym_sdiv] = ACTIONS(1067),
    [anon_sym_mod] = ACTIONS(1067),
    [anon_sym_smod] = ACTIONS(1067),
    [anon_sym_exp] = ACTIONS(1067),
    [anon_sym_not] = ACTIONS(1067),
    [anon_sym_lt] = ACTIONS(1067),
    [anon_sym_gt] = ACTIONS(1067),
    [anon_sym_slt] = ACTIONS(1067),
    [anon_sym_sgt] = ACTIONS(1067),
    [anon_sym_eq] = ACTIONS(1067),
    [anon_sym_iszero] = ACTIONS(1067),
    [anon_sym_and] = ACTIONS(1067),
    [anon_sym_or] = ACTIONS(1067),
    [anon_sym_xor] = ACTIONS(1067),
    [anon_sym_byte] = ACTIONS(1067),
    [anon_sym_shl] = ACTIONS(1067),
    [anon_sym_shr] = ACTIONS(1067),
    [anon_sym_sar] = ACTIONS(1067),
    [anon_sym_addmod] = ACTIONS(1067),
    [anon_sym_mulmod] = ACTIONS(1067),
    [anon_sym_signextend] = ACTIONS(1067),
    [anon_sym_keccak256] = ACTIONS(1067),
    [anon_sym_pop] = ACTIONS(1067),
    [anon_sym_mload] = ACTIONS(1067),
    [anon_sym_mcopy] = ACTIONS(1067),
    [anon_sym_tload] = ACTIONS(1067),
    [anon_sym_tstore] = ACTIONS(1067),
    [anon_sym_mstore] = ACTIONS(1067),
    [anon_sym_mstore8] = ACTIONS(1067),
    [anon_sym_sload] = ACTIONS(1067),
    [anon_sym_sstore] = ACTIONS(1067),
    [anon_sym_msize] = ACTIONS(1067),
    [anon_sym_gas] = ACTIONS(1067),
    [anon_sym_address] = ACTIONS(1067),
    [anon_sym_balance] = ACTIONS(1067),
    [anon_sym_selfbalance] = ACTIONS(1067),
    [anon_sym_caller] = ACTIONS(1067),
    [anon_sym_callvalue] = ACTIONS(1067),
    [anon_sym_calldataload] = ACTIONS(1067),
    [anon_sym_calldatasize] = ACTIONS(1067),
    [anon_sym_calldatacopy] = ACTIONS(1067),
    [anon_sym_extcodesize] = ACTIONS(1067),
    [anon_sym_extcodecopy] = ACTIONS(1067),
    [anon_sym_returndatasize] = ACTIONS(1067),
    [anon_sym_returndatacopy] = ACTIONS(1067),
    [anon_sym_extcodehash] = ACTIONS(1067),
    [anon_sym_create] = ACTIONS(1067),
    [anon_sym_create2] = ACTIONS(1067),
    [anon_sym_call] = ACTIONS(1067),
    [anon_sym_callcode] = ACTIONS(1067),
    [anon_sym_delegatecall] = ACTIONS(1067),
    [anon_sym_staticcall] = ACTIONS(1067),
    [anon_sym_return] = ACTIONS(1067),
    [anon_sym_revert] = ACTIONS(1067),
    [anon_sym_selfdestruct] = ACTIONS(1067),
    [anon_sym_invalid] = ACTIONS(1067),
    [anon_sym_log0] = ACTIONS(1067),
    [anon_sym_log1] = ACTIONS(1067),
    [anon_sym_log2] = ACTIONS(1067),
    [anon_sym_log3] = ACTIONS(1067),
    [anon_sym_log4] = ACTIONS(1067),
    [anon_sym_chainid] = ACTIONS(1067),
    [anon_sym_origin] = ACTIONS(1067),
    [anon_sym_gasprice] = ACTIONS(1067),
    [anon_sym_blockhash] = ACTIONS(1067),
    [anon_sym_blobhash] = ACTIONS(1067),
    [anon_sym_basefee] = ACTIONS(1067),
    [anon_sym_blobfee] = ACTIONS(1067),
    [anon_sym_coinbase] = ACTIONS(1067),
    [anon_sym_timestamp] = ACTIONS(1067),
    [anon_sym_number] = ACTIONS(1067),
    [anon_sym_difficulty] = ACTIONS(1067),
    [anon_sym_gaslimit] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1014),
    [anon_sym_COLON] = ACTIONS(1014),
    [sym_yul_leave] = ACTIONS(1014),
    [anon_sym_break] = ACTIONS(1014),
    [anon_sym_continue] = ACTIONS(1014),
    [sym_yul_decimal_number] = ACTIONS(1014),
    [sym_yul_hex_number] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1014),
    [anon_sym_false] = ACTIONS(1014),
    [anon_sym_let] = ACTIONS(1014),
    [anon_sym_COLON_EQ] = ACTIONS(1016),
    [anon_sym_if] = ACTIONS(1014),
    [anon_sym_switch] = ACTIONS(1014),
    [anon_sym_function] = ACTIONS(1014),
    [anon_sym_stop] = ACTIONS(1014),
    [anon_sym_add] = ACTIONS(1014),
    [anon_sym_sub] = ACTIONS(1014),
    [anon_sym_mul] = ACTIONS(1014),
    [anon_sym_div] = ACTIONS(1014),
    [anon_sym_sdiv] = ACTIONS(1014),
    [anon_sym_mod] = ACTIONS(1014),
    [anon_sym_smod] = ACTIONS(1014),
    [anon_sym_exp] = ACTIONS(1014),
    [anon_sym_not] = ACTIONS(1014),
    [anon_sym_lt] = ACTIONS(1014),
    [anon_sym_gt] = ACTIONS(1014),
    [anon_sym_slt] = ACTIONS(1014),
    [anon_sym_sgt] = ACTIONS(1014),
    [anon_sym_eq] = ACTIONS(1014),
    [anon_sym_iszero] = ACTIONS(1014),
    [anon_sym_and] = ACTIONS(1014),
    [anon_sym_or] = ACTIONS(1014),
    [anon_sym_xor] = ACTIONS(1014),
    [anon_sym_byte] = ACTIONS(1014),
    [anon_sym_shl] = ACTIONS(1014),
    [anon_sym_shr] = ACTIONS(1014),
    [anon_sym_sar] = ACTIONS(1014),
    [anon_sym_addmod] = ACTIONS(1014),
    [anon_sym_mulmod] = ACTIONS(1014),
    [anon_sym_signextend] = ACTIONS(1014),
    [anon_sym_keccak256] = ACTIONS(1014),
    [anon_sym_pop] = ACTIONS(1014),
    [anon_sym_mload] = ACTIONS(1014),
    [anon_sym_mcopy] = ACTIONS(1014),
    [anon_sym_tload] = ACTIONS(1014),
    [anon_sym_tstore] = ACTIONS(1014),
    [anon_sym_mstore] = ACTIONS(1014),
    [anon_sym_mstore8] = ACTIONS(1014),
    [anon_sym_sload] = ACTIONS(1014),
    [anon_sym_sstore] = ACTIONS(1014),
    [anon_sym_msize] = ACTIONS(1014),
    [anon_sym_gas] = ACTIONS(1014),
    [anon_sym_address] = ACTIONS(1014),
    [anon_sym_balance] = ACTIONS(1014),
    [anon_sym_selfbalance] = ACTIONS(1014),
    [anon_sym_caller] = ACTIONS(1014),
    [anon_sym_callvalue] = ACTIONS(1014),
    [anon_sym_calldataload] = ACTIONS(1014),
    [anon_sym_calldatasize] = ACTIONS(1014),
    [anon_sym_calldatacopy] = ACTIONS(1014),
    [anon_sym_extcodesize] = ACTIONS(1014),
    [anon_sym_extcodecopy] = ACTIONS(1014),
    [anon_sym_returndatasize] = ACTIONS(1014),
    [anon_sym_returndatacopy] = ACTIONS(1014),
    [anon_sym_extcodehash] = ACTIONS(1014),
    [anon_sym_create] = ACTIONS(1014),
    [anon_sym_create2] = ACTIONS(1014),
    [anon_sym_call] = ACTIONS(1014),
    [anon_sym_callcode] = ACTIONS(1014),
    [anon_sym_delegatecall] = ACTIONS(1014),
    [anon_sym_staticcall] = ACTIONS(1014),
    [anon_sym_return] = ACTIONS(1014),
    [anon_sym_revert] = ACTIONS(1014),
    [anon_sym_selfdestruct] = ACTIONS(1014),
    [anon_sym_invalid] = ACTIONS(1014),
    [anon_sym_log0] = ACTIONS(1014),
    [anon_sym_log1] = ACTIONS(1014),
    [anon_sym_log2] = ACTIONS(1014),
    [anon_sym_log3] = ACTIONS(1014),
    [anon_sym_log4] = ACTIONS(1014),
    [anon_sym_chainid] = ACTIONS(1014),
    [anon_sym_origin] = ACTIONS(1014),
    [anon_sym_gasprice] = ACTIONS(1014),
    [anon_sym_blockhash] = ACTIONS(1014),
    [anon_sym_blobhash] = ACTIONS(1014),
    [anon_sym_basefee] = ACTIONS(1014),
    [anon_sym_blobfee] = ACTIONS(1014),
    [anon_sym_coinbase] = ACTIONS(1014),
    [anon_sym_timestamp] = ACTIONS(1014),
    [anon_sym_number] = ACTIONS(1014),
    [anon_sym_difficulty] = ACTIONS(1014),
    [anon_sym_gaslimit] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(270),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_COMMA] = ACTIONS(1079),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym_for] = ACTIONS(1075),
    [sym_yul_leave] = ACTIONS(1075),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [sym_yul_decimal_number] = ACTIONS(1075),
    [sym_yul_hex_number] = ACTIONS(1077),
    [anon_sym_true] = ACTIONS(1075),
    [anon_sym_false] = ACTIONS(1075),
    [anon_sym_let] = ACTIONS(1075),
    [anon_sym_COLON_EQ] = ACTIONS(1081),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_switch] = ACTIONS(1075),
    [anon_sym_function] = ACTIONS(1075),
    [anon_sym_stop] = ACTIONS(1075),
    [anon_sym_add] = ACTIONS(1075),
    [anon_sym_sub] = ACTIONS(1075),
    [anon_sym_mul] = ACTIONS(1075),
    [anon_sym_div] = ACTIONS(1075),
    [anon_sym_sdiv] = ACTIONS(1075),
    [anon_sym_mod] = ACTIONS(1075),
    [anon_sym_smod] = ACTIONS(1075),
    [anon_sym_exp] = ACTIONS(1075),
    [anon_sym_not] = ACTIONS(1075),
    [anon_sym_lt] = ACTIONS(1075),
    [anon_sym_gt] = ACTIONS(1075),
    [anon_sym_slt] = ACTIONS(1075),
    [anon_sym_sgt] = ACTIONS(1075),
    [anon_sym_eq] = ACTIONS(1075),
    [anon_sym_iszero] = ACTIONS(1075),
    [anon_sym_and] = ACTIONS(1075),
    [anon_sym_or] = ACTIONS(1075),
    [anon_sym_xor] = ACTIONS(1075),
    [anon_sym_byte] = ACTIONS(1075),
    [anon_sym_shl] = ACTIONS(1075),
    [anon_sym_shr] = ACTIONS(1075),
    [anon_sym_sar] = ACTIONS(1075),
    [anon_sym_addmod] = ACTIONS(1075),
    [anon_sym_mulmod] = ACTIONS(1075),
    [anon_sym_signextend] = ACTIONS(1075),
    [anon_sym_keccak256] = ACTIONS(1075),
    [anon_sym_pop] = ACTIONS(1075),
    [anon_sym_mload] = ACTIONS(1075),
    [anon_sym_mcopy] = ACTIONS(1075),
    [anon_sym_tload] = ACTIONS(1075),
    [anon_sym_tstore] = ACTIONS(1075),
    [anon_sym_mstore] = ACTIONS(1075),
    [anon_sym_mstore8] = ACTIONS(1075),
    [anon_sym_sload] = ACTIONS(1075),
    [anon_sym_sstore] = ACTIONS(1075),
    [anon_sym_msize] = ACTIONS(1075),
    [anon_sym_gas] = ACTIONS(1075),
    [anon_sym_address] = ACTIONS(1075),
    [anon_sym_balance] = ACTIONS(1075),
    [anon_sym_selfbalance] = ACTIONS(1075),
    [anon_sym_caller] = ACTIONS(1075),
    [anon_sym_callvalue] = ACTIONS(1075),
    [anon_sym_calldataload] = ACTIONS(1075),
    [anon_sym_calldatasize] = ACTIONS(1075),
    [anon_sym_calldatacopy] = ACTIONS(1075),
    [anon_sym_extcodesize] = ACTIONS(1075),
    [anon_sym_extcodecopy] = ACTIONS(1075),
    [anon_sym_returndatasize] = ACTIONS(1075),
    [anon_sym_returndatacopy] = ACTIONS(1075),
    [anon_sym_extcodehash] = ACTIONS(1075),
    [anon_sym_create] = ACTIONS(1075),
    [anon_sym_create2] = ACTIONS(1075),
    [anon_sym_call] = ACTIONS(1075),
    [anon_sym_callcode] = ACTIONS(1075),
    [anon_sym_delegatecall] = ACTIONS(1075),
    [anon_sym_staticcall] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_revert] = ACTIONS(1075),
    [anon_sym_selfdestruct] = ACTIONS(1075),
    [anon_sym_invalid] = ACTIONS(1075),
    [anon_sym_log0] = ACTIONS(1075),
    [anon_sym_log1] = ACTIONS(1075),
    [anon_sym_log2] = ACTIONS(1075),
    [anon_sym_log3] = ACTIONS(1075),
    [anon_sym_log4] = ACTIONS(1075),
    [anon_sym_chainid] = ACTIONS(1075),
    [anon_sym_origin] = ACTIONS(1075),
    [anon_sym_gasprice] = ACTIONS(1075),
    [anon_sym_blockhash] = ACTIONS(1075),
    [anon_sym_blobhash] = ACTIONS(1075),
    [anon_sym_basefee] = ACTIONS(1075),
    [anon_sym_blobfee] = ACTIONS(1075),
    [anon_sym_coinbase] = ACTIONS(1075),
    [anon_sym_timestamp] = ACTIONS(1075),
    [anon_sym_number] = ACTIONS(1075),
    [anon_sym_difficulty] = ACTIONS(1075),
    [anon_sym_gaslimit] = ACTIONS(1075),
    [anon_sym_DQUOTE] = ACTIONS(1077),
    [anon_sym_SQUOTE] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_yul_identifier] = STATE(268),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1083),
    [sym_yul_leave] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [sym_yul_decimal_number] = ACTIONS(1083),
    [sym_yul_hex_number] = ACTIONS(1085),
    [anon_sym_true] = ACTIONS(1083),
    [anon_sym_false] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_COLON_EQ] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_function] = ACTIONS(1083),
    [anon_sym_stop] = ACTIONS(1083),
    [anon_sym_add] = ACTIONS(1083),
    [anon_sym_sub] = ACTIONS(1083),
    [anon_sym_mul] = ACTIONS(1083),
    [anon_sym_div] = ACTIONS(1083),
    [anon_sym_sdiv] = ACTIONS(1083),
    [anon_sym_mod] = ACTIONS(1083),
    [anon_sym_smod] = ACTIONS(1083),
    [anon_sym_exp] = ACTIONS(1083),
    [anon_sym_not] = ACTIONS(1083),
    [anon_sym_lt] = ACTIONS(1083),
    [anon_sym_gt] = ACTIONS(1083),
    [anon_sym_slt] = ACTIONS(1083),
    [anon_sym_sgt] = ACTIONS(1083),
    [anon_sym_eq] = ACTIONS(1083),
    [anon_sym_iszero] = ACTIONS(1083),
    [anon_sym_and] = ACTIONS(1083),
    [anon_sym_or] = ACTIONS(1083),
    [anon_sym_xor] = ACTIONS(1083),
    [anon_sym_byte] = ACTIONS(1083),
    [anon_sym_shl] = ACTIONS(1083),
    [anon_sym_shr] = ACTIONS(1083),
    [anon_sym_sar] = ACTIONS(1083),
    [anon_sym_addmod] = ACTIONS(1083),
    [anon_sym_mulmod] = ACTIONS(1083),
    [anon_sym_signextend] = ACTIONS(1083),
    [anon_sym_keccak256] = ACTIONS(1083),
    [anon_sym_pop] = ACTIONS(1083),
    [anon_sym_mload] = ACTIONS(1083),
    [anon_sym_mcopy] = ACTIONS(1083),
    [anon_sym_tload] = ACTIONS(1083),
    [anon_sym_tstore] = ACTIONS(1083),
    [anon_sym_mstore] = ACTIONS(1083),
    [anon_sym_mstore8] = ACTIONS(1083),
    [anon_sym_sload] = ACTIONS(1083),
    [anon_sym_sstore] = ACTIONS(1083),
    [anon_sym_msize] = ACTIONS(1083),
    [anon_sym_gas] = ACTIONS(1083),
    [anon_sym_address] = ACTIONS(1083),
    [anon_sym_balance] = ACTIONS(1083),
    [anon_sym_selfbalance] = ACTIONS(1083),
    [anon_sym_caller] = ACTIONS(1083),
    [anon_sym_callvalue] = ACTIONS(1083),
    [anon_sym_calldataload] = ACTIONS(1083),
    [anon_sym_calldatasize] = ACTIONS(1083),
    [anon_sym_calldatacopy] = ACTIONS(1083),
    [anon_sym_extcodesize] = ACTIONS(1083),
    [anon_sym_extcodecopy] = ACTIONS(1083),
    [anon_sym_returndatasize] = ACTIONS(1083),
    [anon_sym_returndatacopy] = ACTIONS(1083),
    [anon_sym_extcodehash] = ACTIONS(1083),
    [anon_sym_create] = ACTIONS(1083),
    [anon_sym_create2] = ACTIONS(1083),
    [anon_sym_call] = ACTIONS(1083),
    [anon_sym_callcode] = ACTIONS(1083),
    [anon_sym_delegatecall] = ACTIONS(1083),
    [anon_sym_staticcall] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_revert] = ACTIONS(1083),
    [anon_sym_selfdestruct] = ACTIONS(1083),
    [anon_sym_invalid] = ACTIONS(1083),
    [anon_sym_log0] = ACTIONS(1083),
    [anon_sym_log1] = ACTIONS(1083),
    [anon_sym_log2] = ACTIONS(1083),
    [anon_sym_log3] = ACTIONS(1083),
    [anon_sym_log4] = ACTIONS(1083),
    [anon_sym_chainid] = ACTIONS(1083),
    [anon_sym_origin] = ACTIONS(1083),
    [anon_sym_gasprice] = ACTIONS(1083),
    [anon_sym_blockhash] = ACTIONS(1083),
    [anon_sym_blobhash] = ACTIONS(1083),
    [anon_sym_basefee] = ACTIONS(1083),
    [anon_sym_blobfee] = ACTIONS(1083),
    [anon_sym_coinbase] = ACTIONS(1083),
    [anon_sym_timestamp] = ACTIONS(1083),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_difficulty] = ACTIONS(1083),
    [anon_sym_gaslimit] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_SQUOTE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1089),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym_for] = ACTIONS(1089),
    [sym_yul_leave] = ACTIONS(1089),
    [anon_sym_break] = ACTIONS(1089),
    [anon_sym_continue] = ACTIONS(1089),
    [sym_yul_decimal_number] = ACTIONS(1089),
    [sym_yul_hex_number] = ACTIONS(1091),
    [anon_sym_true] = ACTIONS(1089),
    [anon_sym_false] = ACTIONS(1089),
    [anon_sym_let] = ACTIONS(1089),
    [anon_sym_if] = ACTIONS(1089),
    [anon_sym_switch] = ACTIONS(1089),
    [anon_sym_default] = ACTIONS(1089),
    [anon_sym_case] = ACTIONS(1089),
    [anon_sym_function] = ACTIONS(1089),
    [anon_sym_stop] = ACTIONS(1089),
    [anon_sym_add] = ACTIONS(1089),
    [anon_sym_sub] = ACTIONS(1089),
    [anon_sym_mul] = ACTIONS(1089),
    [anon_sym_div] = ACTIONS(1089),
    [anon_sym_sdiv] = ACTIONS(1089),
    [anon_sym_mod] = ACTIONS(1089),
    [anon_sym_smod] = ACTIONS(1089),
    [anon_sym_exp] = ACTIONS(1089),
    [anon_sym_not] = ACTIONS(1089),
    [anon_sym_lt] = ACTIONS(1089),
    [anon_sym_gt] = ACTIONS(1089),
    [anon_sym_slt] = ACTIONS(1089),
    [anon_sym_sgt] = ACTIONS(1089),
    [anon_sym_eq] = ACTIONS(1089),
    [anon_sym_iszero] = ACTIONS(1089),
    [anon_sym_and] = ACTIONS(1089),
    [anon_sym_or] = ACTIONS(1089),
    [anon_sym_xor] = ACTIONS(1089),
    [anon_sym_byte] = ACTIONS(1089),
    [anon_sym_shl] = ACTIONS(1089),
    [anon_sym_shr] = ACTIONS(1089),
    [anon_sym_sar] = ACTIONS(1089),
    [anon_sym_addmod] = ACTIONS(1089),
    [anon_sym_mulmod] = ACTIONS(1089),
    [anon_sym_signextend] = ACTIONS(1089),
    [anon_sym_keccak256] = ACTIONS(1089),
    [anon_sym_pop] = ACTIONS(1089),
    [anon_sym_mload] = ACTIONS(1089),
    [anon_sym_mcopy] = ACTIONS(1089),
    [anon_sym_tload] = ACTIONS(1089),
    [anon_sym_tstore] = ACTIONS(1089),
    [anon_sym_mstore] = ACTIONS(1089),
    [anon_sym_mstore8] = ACTIONS(1089),
    [anon_sym_sload] = ACTIONS(1089),
    [anon_sym_sstore] = ACTIONS(1089),
    [anon_sym_msize] = ACTIONS(1089),
    [anon_sym_gas] = ACTIONS(1089),
    [anon_sym_address] = ACTIONS(1089),
    [anon_sym_balance] = ACTIONS(1089),
    [anon_sym_selfbalance] = ACTIONS(1089),
    [anon_sym_caller] = ACTIONS(1089),
    [anon_sym_callvalue] = ACTIONS(1089),
    [anon_sym_calldataload] = ACTIONS(1089),
    [anon_sym_calldatasize] = ACTIONS(1089),
    [anon_sym_calldatacopy] = ACTIONS(1089),
    [anon_sym_extcodesize] = ACTIONS(1089),
    [anon_sym_extcodecopy] = ACTIONS(1089),
    [anon_sym_returndatasize] = ACTIONS(1089),
    [anon_sym_returndatacopy] = ACTIONS(1089),
    [anon_sym_extcodehash] = ACTIONS(1089),
    [anon_sym_create] = ACTIONS(1089),
    [anon_sym_create2] = ACTIONS(1089),
    [anon_sym_call] = ACTIONS(1089),
    [anon_sym_callcode] = ACTIONS(1089),
    [anon_sym_delegatecall] = ACTIONS(1089),
    [anon_sym_staticcall] = ACTIONS(1089),
    [anon_sym_return] = ACTIONS(1089),
    [anon_sym_revert] = ACTIONS(1089),
    [anon_sym_selfdestruct] = ACTIONS(1089),
    [anon_sym_invalid] = ACTIONS(1089),
    [anon_sym_log0] = ACTIONS(1089),
    [anon_sym_log1] = ACTIONS(1089),
    [anon_sym_log2] = ACTIONS(1089),
    [anon_sym_log3] = ACTIONS(1089),
    [anon_sym_log4] = ACTIONS(1089),
    [anon_sym_chainid] = ACTIONS(1089),
    [anon_sym_origin] = ACTIONS(1089),
    [anon_sym_gasprice] = ACTIONS(1089),
    [anon_sym_blockhash] = ACTIONS(1089),
    [anon_sym_blobhash] = ACTIONS(1089),
    [anon_sym_basefee] = ACTIONS(1089),
    [anon_sym_blobfee] = ACTIONS(1089),
    [anon_sym_coinbase] = ACTIONS(1089),
    [anon_sym_timestamp] = ACTIONS(1089),
    [anon_sym_number] = ACTIONS(1089),
    [anon_sym_difficulty] = ACTIONS(1089),
    [anon_sym_gaslimit] = ACTIONS(1089),
    [anon_sym_DQUOTE] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_identifier] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1093),
    [sym_yul_leave] = ACTIONS(1093),
    [anon_sym_break] = ACTIONS(1093),
    [anon_sym_continue] = ACTIONS(1093),
    [sym_yul_decimal_number] = ACTIONS(1093),
    [sym_yul_hex_number] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1093),
    [anon_sym_false] = ACTIONS(1093),
    [anon_sym_let] = ACTIONS(1093),
    [anon_sym_if] = ACTIONS(1093),
    [anon_sym_switch] = ACTIONS(1093),
    [anon_sym_default] = ACTIONS(1093),
    [anon_sym_case] = ACTIONS(1093),
    [anon_sym_function] = ACTIONS(1093),
    [anon_sym_stop] = ACTIONS(1093),
    [anon_sym_add] = ACTIONS(1093),
    [anon_sym_sub] = ACTIONS(1093),
    [anon_sym_mul] = ACTIONS(1093),
    [anon_sym_div] = ACTIONS(1093),
    [anon_sym_sdiv] = ACTIONS(1093),
    [anon_sym_mod] = ACTIONS(1093),
    [anon_sym_smod] = ACTIONS(1093),
    [anon_sym_exp] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1093),
    [anon_sym_lt] = ACTIONS(1093),
    [anon_sym_gt] = ACTIONS(1093),
    [anon_sym_slt] = ACTIONS(1093),
    [anon_sym_sgt] = ACTIONS(1093),
    [anon_sym_eq] = ACTIONS(1093),
    [anon_sym_iszero] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1093),
    [anon_sym_or] = ACTIONS(1093),
    [anon_sym_xor] = ACTIONS(1093),
    [anon_sym_byte] = ACTIONS(1093),
    [anon_sym_shl] = ACTIONS(1093),
    [anon_sym_shr] = ACTIONS(1093),
    [anon_sym_sar] = ACTIONS(1093),
    [anon_sym_addmod] = ACTIONS(1093),
    [anon_sym_mulmod] = ACTIONS(1093),
    [anon_sym_signextend] = ACTIONS(1093),
    [anon_sym_keccak256] = ACTIONS(1093),
    [anon_sym_pop] = ACTIONS(1093),
    [anon_sym_mload] = ACTIONS(1093),
    [anon_sym_mcopy] = ACTIONS(1093),
    [anon_sym_tload] = ACTIONS(1093),
    [anon_sym_tstore] = ACTIONS(1093),
    [anon_sym_mstore] = ACTIONS(1093),
    [anon_sym_mstore8] = ACTIONS(1093),
    [anon_sym_sload] = ACTIONS(1093),
    [anon_sym_sstore] = ACTIONS(1093),
    [anon_sym_msize] = ACTIONS(1093),
    [anon_sym_gas] = ACTIONS(1093),
    [anon_sym_address] = ACTIONS(1093),
    [anon_sym_balance] = ACTIONS(1093),
    [anon_sym_selfbalance] = ACTIONS(1093),
    [anon_sym_caller] = ACTIONS(1093),
    [anon_sym_callvalue] = ACTIONS(1093),
    [anon_sym_calldataload] = ACTIONS(1093),
    [anon_sym_calldatasize] = ACTIONS(1093),
    [anon_sym_calldatacopy] = ACTIONS(1093),
    [anon_sym_extcodesize] = ACTIONS(1093),
    [anon_sym_extcodecopy] = ACTIONS(1093),
    [anon_sym_returndatasize] = ACTIONS(1093),
    [anon_sym_returndatacopy] = ACTIONS(1093),
    [anon_sym_extcodehash] = ACTIONS(1093),
    [anon_sym_create] = ACTIONS(1093),
    [anon_sym_create2] = ACTIONS(1093),
    [anon_sym_call] = ACTIONS(1093),
    [anon_sym_callcode] = ACTIONS(1093),
    [anon_sym_delegatecall] = ACTIONS(1093),
    [anon_sym_staticcall] = ACTIONS(1093),
    [anon_sym_return] = ACTIONS(1093),
    [anon_sym_revert] = ACTIONS(1093),
    [anon_sym_selfdestruct] = ACTIONS(1093),
    [anon_sym_invalid] = ACTIONS(1093),
    [anon_sym_log0] = ACTIONS(1093),
    [anon_sym_log1] = ACTIONS(1093),
    [anon_sym_log2] = ACTIONS(1093),
    [anon_sym_log3] = ACTIONS(1093),
    [anon_sym_log4] = ACTIONS(1093),
    [anon_sym_chainid] = ACTIONS(1093),
    [anon_sym_origin] = ACTIONS(1093),
    [anon_sym_gasprice] = ACTIONS(1093),
    [anon_sym_blockhash] = ACTIONS(1093),
    [anon_sym_blobhash] = ACTIONS(1093),
    [anon_sym_basefee] = ACTIONS(1093),
    [anon_sym_blobfee] = ACTIONS(1093),
    [anon_sym_coinbase] = ACTIONS(1093),
    [anon_sym_timestamp] = ACTIONS(1093),
    [anon_sym_number] = ACTIONS(1093),
    [anon_sym_difficulty] = ACTIONS(1093),
    [anon_sym_gaslimit] = ACTIONS(1093),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_yul_identifier] = STATE(268),
    [sym_identifier] = ACTIONS(1059),
    [anon_sym_LBRACE] = ACTIONS(1061),
    [anon_sym_RBRACE] = ACTIONS(1061),
    [anon_sym_for] = ACTIONS(1059),
    [sym_yul_leave] = ACTIONS(1059),
    [anon_sym_break] = ACTIONS(1059),
    [anon_sym_continue] = ACTIONS(1059),
    [sym_yul_decimal_number] = ACTIONS(1059),
    [sym_yul_hex_number] = ACTIONS(1061),
    [anon_sym_true] = ACTIONS(1059),
    [anon_sym_false] = ACTIONS(1059),
    [anon_sym_let] = ACTIONS(1059),
    [anon_sym_COLON_EQ] = ACTIONS(1065),
    [anon_sym_if] = ACTIONS(1059),
    [anon_sym_switch] = ACTIONS(1059),
    [anon_sym_function] = ACTIONS(1059),
    [anon_sym_stop] = ACTIONS(1059),
    [anon_sym_add] = ACTIONS(1059),
    [anon_sym_sub] = ACTIONS(1059),
    [anon_sym_mul] = ACTIONS(1059),
    [anon_sym_div] = ACTIONS(1059),
    [anon_sym_sdiv] = ACTIONS(1059),
    [anon_sym_mod] = ACTIONS(1059),
    [anon_sym_smod] = ACTIONS(1059),
    [anon_sym_exp] = ACTIONS(1059),
    [anon_sym_not] = ACTIONS(1059),
    [anon_sym_lt] = ACTIONS(1059),
    [anon_sym_gt] = ACTIONS(1059),
    [anon_sym_slt] = ACTIONS(1059),
    [anon_sym_sgt] = ACTIONS(1059),
    [anon_sym_eq] = ACTIONS(1059),
    [anon_sym_iszero] = ACTIONS(1059),
    [anon_sym_and] = ACTIONS(1059),
    [anon_sym_or] = ACTIONS(1059),
    [anon_sym_xor] = ACTIONS(1059),
    [anon_sym_byte] = ACTIONS(1059),
    [anon_sym_shl] = ACTIONS(1059),
    [anon_sym_shr] = ACTIONS(1059),
    [anon_sym_sar] = ACTIONS(1059),
    [anon_sym_addmod] = ACTIONS(1059),
    [anon_sym_mulmod] = ACTIONS(1059),
    [anon_sym_signextend] = ACTIONS(1059),
    [anon_sym_keccak256] = ACTIONS(1059),
    [anon_sym_pop] = ACTIONS(1059),
    [anon_sym_mload] = ACTIONS(1059),
    [anon_sym_mcopy] = ACTIONS(1059),
    [anon_sym_tload] = ACTIONS(1059),
    [anon_sym_tstore] = ACTIONS(1059),
    [anon_sym_mstore] = ACTIONS(1059),
    [anon_sym_mstore8] = ACTIONS(1059),
    [anon_sym_sload] = ACTIONS(1059),
    [anon_sym_sstore] = ACTIONS(1059),
    [anon_sym_msize] = ACTIONS(1059),
    [anon_sym_gas] = ACTIONS(1059),
    [anon_sym_address] = ACTIONS(1059),
    [anon_sym_balance] = ACTIONS(1059),
    [anon_sym_selfbalance] = ACTIONS(1059),
    [anon_sym_caller] = ACTIONS(1059),
    [anon_sym_callvalue] = ACTIONS(1059),
    [anon_sym_calldataload] = ACTIONS(1059),
    [anon_sym_calldatasize] = ACTIONS(1059),
    [anon_sym_calldatacopy] = ACTIONS(1059),
    [anon_sym_extcodesize] = ACTIONS(1059),
    [anon_sym_extcodecopy] = ACTIONS(1059),
    [anon_sym_returndatasize] = ACTIONS(1059),
    [anon_sym_returndatacopy] = ACTIONS(1059),
    [anon_sym_extcodehash] = ACTIONS(1059),
    [anon_sym_create] = ACTIONS(1059),
    [anon_sym_create2] = ACTIONS(1059),
    [anon_sym_call] = ACTIONS(1059),
    [anon_sym_callcode] = ACTIONS(1059),
    [anon_sym_delegatecall] = ACTIONS(1059),
    [anon_sym_staticcall] = ACTIONS(1059),
    [anon_sym_return] = ACTIONS(1059),
    [anon_sym_revert] = ACTIONS(1059),
    [anon_sym_selfdestruct] = ACTIONS(1059),
    [anon_sym_invalid] = ACTIONS(1059),
    [anon_sym_log0] = ACTIONS(1059),
    [anon_sym_log1] = ACTIONS(1059),
    [anon_sym_log2] = ACTIONS(1059),
    [anon_sym_log3] = ACTIONS(1059),
    [anon_sym_log4] = ACTIONS(1059),
    [anon_sym_chainid] = ACTIONS(1059),
    [anon_sym_origin] = ACTIONS(1059),
    [anon_sym_gasprice] = ACTIONS(1059),
    [anon_sym_blockhash] = ACTIONS(1059),
    [anon_sym_blobhash] = ACTIONS(1059),
    [anon_sym_basefee] = ACTIONS(1059),
    [anon_sym_blobfee] = ACTIONS(1059),
    [anon_sym_coinbase] = ACTIONS(1059),
    [anon_sym_timestamp] = ACTIONS(1059),
    [anon_sym_number] = ACTIONS(1059),
    [anon_sym_difficulty] = ACTIONS(1059),
    [anon_sym_gaslimit] = ACTIONS(1059),
    [anon_sym_DQUOTE] = ACTIONS(1061),
    [anon_sym_SQUOTE] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1097),
    [anon_sym_LBRACE] = ACTIONS(1099),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym_for] = ACTIONS(1097),
    [sym_yul_leave] = ACTIONS(1097),
    [anon_sym_break] = ACTIONS(1097),
    [anon_sym_continue] = ACTIONS(1097),
    [sym_yul_decimal_number] = ACTIONS(1097),
    [sym_yul_hex_number] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(1097),
    [anon_sym_false] = ACTIONS(1097),
    [anon_sym_let] = ACTIONS(1097),
    [anon_sym_if] = ACTIONS(1097),
    [anon_sym_switch] = ACTIONS(1097),
    [anon_sym_default] = ACTIONS(1097),
    [anon_sym_case] = ACTIONS(1097),
    [anon_sym_function] = ACTIONS(1097),
    [anon_sym_stop] = ACTIONS(1097),
    [anon_sym_add] = ACTIONS(1097),
    [anon_sym_sub] = ACTIONS(1097),
    [anon_sym_mul] = ACTIONS(1097),
    [anon_sym_div] = ACTIONS(1097),
    [anon_sym_sdiv] = ACTIONS(1097),
    [anon_sym_mod] = ACTIONS(1097),
    [anon_sym_smod] = ACTIONS(1097),
    [anon_sym_exp] = ACTIONS(1097),
    [anon_sym_not] = ACTIONS(1097),
    [anon_sym_lt] = ACTIONS(1097),
    [anon_sym_gt] = ACTIONS(1097),
    [anon_sym_slt] = ACTIONS(1097),
    [anon_sym_sgt] = ACTIONS(1097),
    [anon_sym_eq] = ACTIONS(1097),
    [anon_sym_iszero] = ACTIONS(1097),
    [anon_sym_and] = ACTIONS(1097),
    [anon_sym_or] = ACTIONS(1097),
    [anon_sym_xor] = ACTIONS(1097),
    [anon_sym_byte] = ACTIONS(1097),
    [anon_sym_shl] = ACTIONS(1097),
    [anon_sym_shr] = ACTIONS(1097),
    [anon_sym_sar] = ACTIONS(1097),
    [anon_sym_addmod] = ACTIONS(1097),
    [anon_sym_mulmod] = ACTIONS(1097),
    [anon_sym_signextend] = ACTIONS(1097),
    [anon_sym_keccak256] = ACTIONS(1097),
    [anon_sym_pop] = ACTIONS(1097),
    [anon_sym_mload] = ACTIONS(1097),
    [anon_sym_mcopy] = ACTIONS(1097),
    [anon_sym_tload] = ACTIONS(1097),
    [anon_sym_tstore] = ACTIONS(1097),
    [anon_sym_mstore] = ACTIONS(1097),
    [anon_sym_mstore8] = ACTIONS(1097),
    [anon_sym_sload] = ACTIONS(1097),
    [anon_sym_sstore] = ACTIONS(1097),
    [anon_sym_msize] = ACTIONS(1097),
    [anon_sym_gas] = ACTIONS(1097),
    [anon_sym_address] = ACTIONS(1097),
    [anon_sym_balance] = ACTIONS(1097),
    [anon_sym_selfbalance] = ACTIONS(1097),
    [anon_sym_caller] = ACTIONS(1097),
    [anon_sym_callvalue] = ACTIONS(1097),
    [anon_sym_calldataload] = ACTIONS(1097),
    [anon_sym_calldatasize] = ACTIONS(1097),
    [anon_sym_calldatacopy] = ACTIONS(1097),
    [anon_sym_extcodesize] = ACTIONS(1097),
    [anon_sym_extcodecopy] = ACTIONS(1097),
    [anon_sym_returndatasize] = ACTIONS(1097),
    [anon_sym_returndatacopy] = ACTIONS(1097),
    [anon_sym_extcodehash] = ACTIONS(1097),
    [anon_sym_create] = ACTIONS(1097),
    [anon_sym_create2] = ACTIONS(1097),
    [anon_sym_call] = ACTIONS(1097),
    [anon_sym_callcode] = ACTIONS(1097),
    [anon_sym_delegatecall] = ACTIONS(1097),
    [anon_sym_staticcall] = ACTIONS(1097),
    [anon_sym_return] = ACTIONS(1097),
    [anon_sym_revert] = ACTIONS(1097),
    [anon_sym_selfdestruct] = ACTIONS(1097),
    [anon_sym_invalid] = ACTIONS(1097),
    [anon_sym_log0] = ACTIONS(1097),
    [anon_sym_log1] = ACTIONS(1097),
    [anon_sym_log2] = ACTIONS(1097),
    [anon_sym_log3] = ACTIONS(1097),
    [anon_sym_log4] = ACTIONS(1097),
    [anon_sym_chainid] = ACTIONS(1097),
    [anon_sym_origin] = ACTIONS(1097),
    [anon_sym_gasprice] = ACTIONS(1097),
    [anon_sym_blockhash] = ACTIONS(1097),
    [anon_sym_blobhash] = ACTIONS(1097),
    [anon_sym_basefee] = ACTIONS(1097),
    [anon_sym_blobfee] = ACTIONS(1097),
    [anon_sym_coinbase] = ACTIONS(1097),
    [anon_sym_timestamp] = ACTIONS(1097),
    [anon_sym_number] = ACTIONS(1097),
    [anon_sym_difficulty] = ACTIONS(1097),
    [anon_sym_gaslimit] = ACTIONS(1097),
    [anon_sym_DQUOTE] = ACTIONS(1099),
    [anon_sym_SQUOTE] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LBRACE] = ACTIONS(1085),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym_for] = ACTIONS(1083),
    [sym_yul_leave] = ACTIONS(1083),
    [anon_sym_break] = ACTIONS(1083),
    [anon_sym_continue] = ACTIONS(1083),
    [sym_yul_decimal_number] = ACTIONS(1083),
    [sym_yul_hex_number] = ACTIONS(1085),
    [anon_sym_true] = ACTIONS(1083),
    [anon_sym_false] = ACTIONS(1083),
    [anon_sym_let] = ACTIONS(1083),
    [anon_sym_COLON_EQ] = ACTIONS(1087),
    [anon_sym_if] = ACTIONS(1083),
    [anon_sym_switch] = ACTIONS(1083),
    [anon_sym_function] = ACTIONS(1083),
    [anon_sym_stop] = ACTIONS(1083),
    [anon_sym_add] = ACTIONS(1083),
    [anon_sym_sub] = ACTIONS(1083),
    [anon_sym_mul] = ACTIONS(1083),
    [anon_sym_div] = ACTIONS(1083),
    [anon_sym_sdiv] = ACTIONS(1083),
    [anon_sym_mod] = ACTIONS(1083),
    [anon_sym_smod] = ACTIONS(1083),
    [anon_sym_exp] = ACTIONS(1083),
    [anon_sym_not] = ACTIONS(1083),
    [anon_sym_lt] = ACTIONS(1083),
    [anon_sym_gt] = ACTIONS(1083),
    [anon_sym_slt] = ACTIONS(1083),
    [anon_sym_sgt] = ACTIONS(1083),
    [anon_sym_eq] = ACTIONS(1083),
    [anon_sym_iszero] = ACTIONS(1083),
    [anon_sym_and] = ACTIONS(1083),
    [anon_sym_or] = ACTIONS(1083),
    [anon_sym_xor] = ACTIONS(1083),
    [anon_sym_byte] = ACTIONS(1083),
    [anon_sym_shl] = ACTIONS(1083),
    [anon_sym_shr] = ACTIONS(1083),
    [anon_sym_sar] = ACTIONS(1083),
    [anon_sym_addmod] = ACTIONS(1083),
    [anon_sym_mulmod] = ACTIONS(1083),
    [anon_sym_signextend] = ACTIONS(1083),
    [anon_sym_keccak256] = ACTIONS(1083),
    [anon_sym_pop] = ACTIONS(1083),
    [anon_sym_mload] = ACTIONS(1083),
    [anon_sym_mcopy] = ACTIONS(1083),
    [anon_sym_tload] = ACTIONS(1083),
    [anon_sym_tstore] = ACTIONS(1083),
    [anon_sym_mstore] = ACTIONS(1083),
    [anon_sym_mstore8] = ACTIONS(1083),
    [anon_sym_sload] = ACTIONS(1083),
    [anon_sym_sstore] = ACTIONS(1083),
    [anon_sym_msize] = ACTIONS(1083),
    [anon_sym_gas] = ACTIONS(1083),
    [anon_sym_address] = ACTIONS(1083),
    [anon_sym_balance] = ACTIONS(1083),
    [anon_sym_selfbalance] = ACTIONS(1083),
    [anon_sym_caller] = ACTIONS(1083),
    [anon_sym_callvalue] = ACTIONS(1083),
    [anon_sym_calldataload] = ACTIONS(1083),
    [anon_sym_calldatasize] = ACTIONS(1083),
    [anon_sym_calldatacopy] = ACTIONS(1083),
    [anon_sym_extcodesize] = ACTIONS(1083),
    [anon_sym_extcodecopy] = ACTIONS(1083),
    [anon_sym_returndatasize] = ACTIONS(1083),
    [anon_sym_returndatacopy] = ACTIONS(1083),
    [anon_sym_extcodehash] = ACTIONS(1083),
    [anon_sym_create] = ACTIONS(1083),
    [anon_sym_create2] = ACTIONS(1083),
    [anon_sym_call] = ACTIONS(1083),
    [anon_sym_callcode] = ACTIONS(1083),
    [anon_sym_delegatecall] = ACTIONS(1083),
    [anon_sym_staticcall] = ACTIONS(1083),
    [anon_sym_return] = ACTIONS(1083),
    [anon_sym_revert] = ACTIONS(1083),
    [anon_sym_selfdestruct] = ACTIONS(1083),
    [anon_sym_invalid] = ACTIONS(1083),
    [anon_sym_log0] = ACTIONS(1083),
    [anon_sym_log1] = ACTIONS(1083),
    [anon_sym_log2] = ACTIONS(1083),
    [anon_sym_log3] = ACTIONS(1083),
    [anon_sym_log4] = ACTIONS(1083),
    [anon_sym_chainid] = ACTIONS(1083),
    [anon_sym_origin] = ACTIONS(1083),
    [anon_sym_gasprice] = ACTIONS(1083),
    [anon_sym_blockhash] = ACTIONS(1083),
    [anon_sym_blobhash] = ACTIONS(1083),
    [anon_sym_basefee] = ACTIONS(1083),
    [anon_sym_blobfee] = ACTIONS(1083),
    [anon_sym_coinbase] = ACTIONS(1083),
    [anon_sym_timestamp] = ACTIONS(1083),
    [anon_sym_number] = ACTIONS(1083),
    [anon_sym_difficulty] = ACTIONS(1083),
    [anon_sym_gaslimit] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1085),
    [anon_sym_SQUOTE] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_RBRACE] = ACTIONS(1103),
    [anon_sym_for] = ACTIONS(1101),
    [sym_yul_leave] = ACTIONS(1101),
    [anon_sym_break] = ACTIONS(1101),
    [anon_sym_continue] = ACTIONS(1101),
    [sym_yul_decimal_number] = ACTIONS(1101),
    [sym_yul_hex_number] = ACTIONS(1103),
    [anon_sym_true] = ACTIONS(1101),
    [anon_sym_false] = ACTIONS(1101),
    [anon_sym_let] = ACTIONS(1101),
    [anon_sym_COLON_EQ] = ACTIONS(1105),
    [anon_sym_if] = ACTIONS(1101),
    [anon_sym_switch] = ACTIONS(1101),
    [anon_sym_function] = ACTIONS(1101),
    [anon_sym_stop] = ACTIONS(1101),
    [anon_sym_add] = ACTIONS(1101),
    [anon_sym_sub] = ACTIONS(1101),
    [anon_sym_mul] = ACTIONS(1101),
    [anon_sym_div] = ACTIONS(1101),
    [anon_sym_sdiv] = ACTIONS(1101),
    [anon_sym_mod] = ACTIONS(1101),
    [anon_sym_smod] = ACTIONS(1101),
    [anon_sym_exp] = ACTIONS(1101),
    [anon_sym_not] = ACTIONS(1101),
    [anon_sym_lt] = ACTIONS(1101),
    [anon_sym_gt] = ACTIONS(1101),
    [anon_sym_slt] = ACTIONS(1101),
    [anon_sym_sgt] = ACTIONS(1101),
    [anon_sym_eq] = ACTIONS(1101),
    [anon_sym_iszero] = ACTIONS(1101),
    [anon_sym_and] = ACTIONS(1101),
    [anon_sym_or] = ACTIONS(1101),
    [anon_sym_xor] = ACTIONS(1101),
    [anon_sym_byte] = ACTIONS(1101),
    [anon_sym_shl] = ACTIONS(1101),
    [anon_sym_shr] = ACTIONS(1101),
    [anon_sym_sar] = ACTIONS(1101),
    [anon_sym_addmod] = ACTIONS(1101),
    [anon_sym_mulmod] = ACTIONS(1101),
    [anon_sym_signextend] = ACTIONS(1101),
    [anon_sym_keccak256] = ACTIONS(1101),
    [anon_sym_pop] = ACTIONS(1101),
    [anon_sym_mload] = ACTIONS(1101),
    [anon_sym_mcopy] = ACTIONS(1101),
    [anon_sym_tload] = ACTIONS(1101),
    [anon_sym_tstore] = ACTIONS(1101),
    [anon_sym_mstore] = ACTIONS(1101),
    [anon_sym_mstore8] = ACTIONS(1101),
    [anon_sym_sload] = ACTIONS(1101),
    [anon_sym_sstore] = ACTIONS(1101),
    [anon_sym_msize] = ACTIONS(1101),
    [anon_sym_gas] = ACTIONS(1101),
    [anon_sym_address] = ACTIONS(1101),
    [anon_sym_balance] = ACTIONS(1101),
    [anon_sym_selfbalance] = ACTIONS(1101),
    [anon_sym_caller] = ACTIONS(1101),
    [anon_sym_callvalue] = ACTIONS(1101),
    [anon_sym_calldataload] = ACTIONS(1101),
    [anon_sym_calldatasize] = ACTIONS(1101),
    [anon_sym_calldatacopy] = ACTIONS(1101),
    [anon_sym_extcodesize] = ACTIONS(1101),
    [anon_sym_extcodecopy] = ACTIONS(1101),
    [anon_sym_returndatasize] = ACTIONS(1101),
    [anon_sym_returndatacopy] = ACTIONS(1101),
    [anon_sym_extcodehash] = ACTIONS(1101),
    [anon_sym_create] = ACTIONS(1101),
    [anon_sym_create2] = ACTIONS(1101),
    [anon_sym_call] = ACTIONS(1101),
    [anon_sym_callcode] = ACTIONS(1101),
    [anon_sym_delegatecall] = ACTIONS(1101),
    [anon_sym_staticcall] = ACTIONS(1101),
    [anon_sym_return] = ACTIONS(1101),
    [anon_sym_revert] = ACTIONS(1101),
    [anon_sym_selfdestruct] = ACTIONS(1101),
    [anon_sym_invalid] = ACTIONS(1101),
    [anon_sym_log0] = ACTIONS(1101),
    [anon_sym_log1] = ACTIONS(1101),
    [anon_sym_log2] = ACTIONS(1101),
    [anon_sym_log3] = ACTIONS(1101),
    [anon_sym_log4] = ACTIONS(1101),
    [anon_sym_chainid] = ACTIONS(1101),
    [anon_sym_origin] = ACTIONS(1101),
    [anon_sym_gasprice] = ACTIONS(1101),
    [anon_sym_blockhash] = ACTIONS(1101),
    [anon_sym_blobhash] = ACTIONS(1101),
    [anon_sym_basefee] = ACTIONS(1101),
    [anon_sym_blobfee] = ACTIONS(1101),
    [anon_sym_coinbase] = ACTIONS(1101),
    [anon_sym_timestamp] = ACTIONS(1101),
    [anon_sym_number] = ACTIONS(1101),
    [anon_sym_difficulty] = ACTIONS(1101),
    [anon_sym_gaslimit] = ACTIONS(1101),
    [anon_sym_DQUOTE] = ACTIONS(1103),
    [anon_sym_SQUOTE] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_identifier] = ACTIONS(1107),
    [anon_sym_LBRACE] = ACTIONS(1109),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym_for] = ACTIONS(1107),
    [sym_yul_leave] = ACTIONS(1107),
    [anon_sym_break] = ACTIONS(1107),
    [anon_sym_continue] = ACTIONS(1107),
    [sym_yul_decimal_number] = ACTIONS(1107),
    [sym_yul_hex_number] = ACTIONS(1109),
    [anon_sym_true] = ACTIONS(1107),
    [anon_sym_false] = ACTIONS(1107),
    [anon_sym_let] = ACTIONS(1107),
    [anon_sym_COLON_EQ] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1107),
    [anon_sym_switch] = ACTIONS(1107),
    [anon_sym_function] = ACTIONS(1107),
    [anon_sym_stop] = ACTIONS(1107),
    [anon_sym_add] = ACTIONS(1107),
    [anon_sym_sub] = ACTIONS(1107),
    [anon_sym_mul] = ACTIONS(1107),
    [anon_sym_div] = ACTIONS(1107),
    [anon_sym_sdiv] = ACTIONS(1107),
    [anon_sym_mod] = ACTIONS(1107),
    [anon_sym_smod] = ACTIONS(1107),
    [anon_sym_exp] = ACTIONS(1107),
    [anon_sym_not] = ACTIONS(1107),
    [anon_sym_lt] = ACTIONS(1107),
    [anon_sym_gt] = ACTIONS(1107),
    [anon_sym_slt] = ACTIONS(1107),
    [anon_sym_sgt] = ACTIONS(1107),
    [anon_sym_eq] = ACTIONS(1107),
    [anon_sym_iszero] = ACTIONS(1107),
    [anon_sym_and] = ACTIONS(1107),
    [anon_sym_or] = ACTIONS(1107),
    [anon_sym_xor] = ACTIONS(1107),
    [anon_sym_byte] = ACTIONS(1107),
    [anon_sym_shl] = ACTIONS(1107),
    [anon_sym_shr] = ACTIONS(1107),
    [anon_sym_sar] = ACTIONS(1107),
    [anon_sym_addmod] = ACTIONS(1107),
    [anon_sym_mulmod] = ACTIONS(1107),
    [anon_sym_signextend] = ACTIONS(1107),
    [anon_sym_keccak256] = ACTIONS(1107),
    [anon_sym_pop] = ACTIONS(1107),
    [anon_sym_mload] = ACTIONS(1107),
    [anon_sym_mcopy] = ACTIONS(1107),
    [anon_sym_tload] = ACTIONS(1107),
    [anon_sym_tstore] = ACTIONS(1107),
    [anon_sym_mstore] = ACTIONS(1107),
    [anon_sym_mstore8] = ACTIONS(1107),
    [anon_sym_sload] = ACTIONS(1107),
    [anon_sym_sstore] = ACTIONS(1107),
    [anon_sym_msize] = ACTIONS(1107),
    [anon_sym_gas] = ACTIONS(1107),
    [anon_sym_address] = ACTIONS(1107),
    [anon_sym_balance] = ACTIONS(1107),
    [anon_sym_selfbalance] = ACTIONS(1107),
    [anon_sym_caller] = ACTIONS(1107),
    [anon_sym_callvalue] = ACTIONS(1107),
    [anon_sym_calldataload] = ACTIONS(1107),
    [anon_sym_calldatasize] = ACTIONS(1107),
    [anon_sym_calldatacopy] = ACTIONS(1107),
    [anon_sym_extcodesize] = ACTIONS(1107),
    [anon_sym_extcodecopy] = ACTIONS(1107),
    [anon_sym_returndatasize] = ACTIONS(1107),
    [anon_sym_returndatacopy] = ACTIONS(1107),
    [anon_sym_extcodehash] = ACTIONS(1107),
    [anon_sym_create] = ACTIONS(1107),
    [anon_sym_create2] = ACTIONS(1107),
    [anon_sym_call] = ACTIONS(1107),
    [anon_sym_callcode] = ACTIONS(1107),
    [anon_sym_delegatecall] = ACTIONS(1107),
    [anon_sym_staticcall] = ACTIONS(1107),
    [anon_sym_return] = ACTIONS(1107),
    [anon_sym_revert] = ACTIONS(1107),
    [anon_sym_selfdestruct] = ACTIONS(1107),
    [anon_sym_invalid] = ACTIONS(1107),
    [anon_sym_log0] = ACTIONS(1107),
    [anon_sym_log1] = ACTIONS(1107),
    [anon_sym_log2] = ACTIONS(1107),
    [anon_sym_log3] = ACTIONS(1107),
    [anon_sym_log4] = ACTIONS(1107),
    [anon_sym_chainid] = ACTIONS(1107),
    [anon_sym_origin] = ACTIONS(1107),
    [anon_sym_gasprice] = ACTIONS(1107),
    [anon_sym_blockhash] = ACTIONS(1107),
    [anon_sym_blobhash] = ACTIONS(1107),
    [anon_sym_basefee] = ACTIONS(1107),
    [anon_sym_blobfee] = ACTIONS(1107),
    [anon_sym_coinbase] = ACTIONS(1107),
    [anon_sym_timestamp] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1107),
    [anon_sym_difficulty] = ACTIONS(1107),
    [anon_sym_gaslimit] = ACTIONS(1107),
    [anon_sym_DQUOTE] = ACTIONS(1109),
    [anon_sym_SQUOTE] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_identifier] = ACTIONS(1113),
    [anon_sym_LBRACE] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym_for] = ACTIONS(1113),
    [sym_yul_leave] = ACTIONS(1113),
    [anon_sym_break] = ACTIONS(1113),
    [anon_sym_continue] = ACTIONS(1113),
    [sym_yul_decimal_number] = ACTIONS(1113),
    [sym_yul_hex_number] = ACTIONS(1115),
    [anon_sym_true] = ACTIONS(1113),
    [anon_sym_false] = ACTIONS(1113),
    [anon_sym_let] = ACTIONS(1113),
    [anon_sym_if] = ACTIONS(1113),
    [anon_sym_switch] = ACTIONS(1113),
    [anon_sym_function] = ACTIONS(1113),
    [anon_sym_stop] = ACTIONS(1113),
    [anon_sym_add] = ACTIONS(1113),
    [anon_sym_sub] = ACTIONS(1113),
    [anon_sym_mul] = ACTIONS(1113),
    [anon_sym_div] = ACTIONS(1113),
    [anon_sym_sdiv] = ACTIONS(1113),
    [anon_sym_mod] = ACTIONS(1113),
    [anon_sym_smod] = ACTIONS(1113),
    [anon_sym_exp] = ACTIONS(1113),
    [anon_sym_not] = ACTIONS(1113),
    [anon_sym_lt] = ACTIONS(1113),
    [anon_sym_gt] = ACTIONS(1113),
    [anon_sym_slt] = ACTIONS(1113),
    [anon_sym_sgt] = ACTIONS(1113),
    [anon_sym_eq] = ACTIONS(1113),
    [anon_sym_iszero] = ACTIONS(1113),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1113),
    [anon_sym_xor] = ACTIONS(1113),
    [anon_sym_byte] = ACTIONS(1113),
    [anon_sym_shl] = ACTIONS(1113),
    [anon_sym_shr] = ACTIONS(1113),
    [anon_sym_sar] = ACTIONS(1113),
    [anon_sym_addmod] = ACTIONS(1113),
    [anon_sym_mulmod] = ACTIONS(1113),
    [anon_sym_signextend] = ACTIONS(1113),
    [anon_sym_keccak256] = ACTIONS(1113),
    [anon_sym_pop] = ACTIONS(1113),
    [anon_sym_mload] = ACTIONS(1113),
    [anon_sym_mcopy] = ACTIONS(1113),
    [anon_sym_tload] = ACTIONS(1113),
    [anon_sym_tstore] = ACTIONS(1113),
    [anon_sym_mstore] = ACTIONS(1113),
    [anon_sym_mstore8] = ACTIONS(1113),
    [anon_sym_sload] = ACTIONS(1113),
    [anon_sym_sstore] = ACTIONS(1113),
    [anon_sym_msize] = ACTIONS(1113),
    [anon_sym_gas] = ACTIONS(1113),
    [anon_sym_address] = ACTIONS(1113),
    [anon_sym_balance] = ACTIONS(1113),
    [anon_sym_selfbalance] = ACTIONS(1113),
    [anon_sym_caller] = ACTIONS(1113),
    [anon_sym_callvalue] = ACTIONS(1113),
    [anon_sym_calldataload] = ACTIONS(1113),
    [anon_sym_calldatasize] = ACTIONS(1113),
    [anon_sym_calldatacopy] = ACTIONS(1113),
    [anon_sym_extcodesize] = ACTIONS(1113),
    [anon_sym_extcodecopy] = ACTIONS(1113),
    [anon_sym_returndatasize] = ACTIONS(1113),
    [anon_sym_returndatacopy] = ACTIONS(1113),
    [anon_sym_extcodehash] = ACTIONS(1113),
    [anon_sym_create] = ACTIONS(1113),
    [anon_sym_create2] = ACTIONS(1113),
    [anon_sym_call] = ACTIONS(1113),
    [anon_sym_callcode] = ACTIONS(1113),
    [anon_sym_delegatecall] = ACTIONS(1113),
    [anon_sym_staticcall] = ACTIONS(1113),
    [anon_sym_return] = ACTIONS(1113),
    [anon_sym_revert] = ACTIONS(1113),
    [anon_sym_selfdestruct] = ACTIONS(1113),
    [anon_sym_invalid] = ACTIONS(1113),
    [anon_sym_log0] = ACTIONS(1113),
    [anon_sym_log1] = ACTIONS(1113),
    [anon_sym_log2] = ACTIONS(1113),
    [anon_sym_log3] = ACTIONS(1113),
    [anon_sym_log4] = ACTIONS(1113),
    [anon_sym_chainid] = ACTIONS(1113),
    [anon_sym_origin] = ACTIONS(1113),
    [anon_sym_gasprice] = ACTIONS(1113),
    [anon_sym_blockhash] = ACTIONS(1113),
    [anon_sym_blobhash] = ACTIONS(1113),
    [anon_sym_basefee] = ACTIONS(1113),
    [anon_sym_blobfee] = ACTIONS(1113),
    [anon_sym_coinbase] = ACTIONS(1113),
    [anon_sym_timestamp] = ACTIONS(1113),
    [anon_sym_number] = ACTIONS(1113),
    [anon_sym_difficulty] = ACTIONS(1113),
    [anon_sym_gaslimit] = ACTIONS(1113),
    [anon_sym_DQUOTE] = ACTIONS(1115),
    [anon_sym_SQUOTE] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_identifier] = ACTIONS(989),
    [anon_sym_LBRACE] = ACTIONS(991),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(989),
    [sym_yul_leave] = ACTIONS(989),
    [anon_sym_break] = ACTIONS(989),
    [anon_sym_continue] = ACTIONS(989),
    [sym_yul_decimal_number] = ACTIONS(989),
    [sym_yul_hex_number] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(989),
    [anon_sym_false] = ACTIONS(989),
    [anon_sym_let] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(989),
    [anon_sym_switch] = ACTIONS(989),
    [anon_sym_function] = ACTIONS(989),
    [anon_sym_stop] = ACTIONS(989),
    [anon_sym_add] = ACTIONS(989),
    [anon_sym_sub] = ACTIONS(989),
    [anon_sym_mul] = ACTIONS(989),
    [anon_sym_div] = ACTIONS(989),
    [anon_sym_sdiv] = ACTIONS(989),
    [anon_sym_mod] = ACTIONS(989),
    [anon_sym_smod] = ACTIONS(989),
    [anon_sym_exp] = ACTIONS(989),
    [anon_sym_not] = ACTIONS(989),
    [anon_sym_lt] = ACTIONS(989),
    [anon_sym_gt] = ACTIONS(989),
    [anon_sym_slt] = ACTIONS(989),
    [anon_sym_sgt] = ACTIONS(989),
    [anon_sym_eq] = ACTIONS(989),
    [anon_sym_iszero] = ACTIONS(989),
    [anon_sym_and] = ACTIONS(989),
    [anon_sym_or] = ACTIONS(989),
    [anon_sym_xor] = ACTIONS(989),
    [anon_sym_byte] = ACTIONS(989),
    [anon_sym_shl] = ACTIONS(989),
    [anon_sym_shr] = ACTIONS(989),
    [anon_sym_sar] = ACTIONS(989),
    [anon_sym_addmod] = ACTIONS(989),
    [anon_sym_mulmod] = ACTIONS(989),
    [anon_sym_signextend] = ACTIONS(989),
    [anon_sym_keccak256] = ACTIONS(989),
    [anon_sym_pop] = ACTIONS(989),
    [anon_sym_mload] = ACTIONS(989),
    [anon_sym_mcopy] = ACTIONS(989),
    [anon_sym_tload] = ACTIONS(989),
    [anon_sym_tstore] = ACTIONS(989),
    [anon_sym_mstore] = ACTIONS(989),
    [anon_sym_mstore8] = ACTIONS(989),
    [anon_sym_sload] = ACTIONS(989),
    [anon_sym_sstore] = ACTIONS(989),
    [anon_sym_msize] = ACTIONS(989),
    [anon_sym_gas] = ACTIONS(989),
    [anon_sym_address] = ACTIONS(989),
    [anon_sym_balance] = ACTIONS(989),
    [anon_sym_selfbalance] = ACTIONS(989),
    [anon_sym_caller] = ACTIONS(989),
    [anon_sym_callvalue] = ACTIONS(989),
    [anon_sym_calldataload] = ACTIONS(989),
    [anon_sym_calldatasize] = ACTIONS(989),
    [anon_sym_calldatacopy] = ACTIONS(989),
    [anon_sym_extcodesize] = ACTIONS(989),
    [anon_sym_extcodecopy] = ACTIONS(989),
    [anon_sym_returndatasize] = ACTIONS(989),
    [anon_sym_returndatacopy] = ACTIONS(989),
    [anon_sym_extcodehash] = ACTIONS(989),
    [anon_sym_create] = ACTIONS(989),
    [anon_sym_create2] = ACTIONS(989),
    [anon_sym_call] = ACTIONS(989),
    [anon_sym_callcode] = ACTIONS(989),
    [anon_sym_delegatecall] = ACTIONS(989),
    [anon_sym_staticcall] = ACTIONS(989),
    [anon_sym_return] = ACTIONS(989),
    [anon_sym_revert] = ACTIONS(989),
    [anon_sym_selfdestruct] = ACTIONS(989),
    [anon_sym_invalid] = ACTIONS(989),
    [anon_sym_log0] = ACTIONS(989),
    [anon_sym_log1] = ACTIONS(989),
    [anon_sym_log2] = ACTIONS(989),
    [anon_sym_log3] = ACTIONS(989),
    [anon_sym_log4] = ACTIONS(989),
    [anon_sym_chainid] = ACTIONS(989),
    [anon_sym_origin] = ACTIONS(989),
    [anon_sym_gasprice] = ACTIONS(989),
    [anon_sym_blockhash] = ACTIONS(989),
    [anon_sym_blobhash] = ACTIONS(989),
    [anon_sym_basefee] = ACTIONS(989),
    [anon_sym_blobfee] = ACTIONS(989),
    [anon_sym_coinbase] = ACTIONS(989),
    [anon_sym_timestamp] = ACTIONS(989),
    [anon_sym_number] = ACTIONS(989),
    [anon_sym_difficulty] = ACTIONS(989),
    [anon_sym_gaslimit] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(991),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(710),
    [sym_yul_path] = STATE(710),
    [sym__yul_literal] = STATE(710),
    [sym_yul_string_literal] = STATE(710),
    [sym_yul_boolean] = STATE(710),
    [sym_yul_function_call] = STATE(710),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1119),
    [sym_yul_decimal_number] = ACTIONS(1121),
    [sym_yul_hex_number] = ACTIONS(1123),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(1125),
    [anon_sym_LBRACE] = ACTIONS(1127),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym_for] = ACTIONS(1125),
    [sym_yul_leave] = ACTIONS(1125),
    [anon_sym_break] = ACTIONS(1125),
    [anon_sym_continue] = ACTIONS(1125),
    [sym_yul_decimal_number] = ACTIONS(1125),
    [sym_yul_hex_number] = ACTIONS(1127),
    [anon_sym_true] = ACTIONS(1125),
    [anon_sym_false] = ACTIONS(1125),
    [anon_sym_let] = ACTIONS(1125),
    [anon_sym_if] = ACTIONS(1125),
    [anon_sym_switch] = ACTIONS(1125),
    [anon_sym_function] = ACTIONS(1125),
    [anon_sym_stop] = ACTIONS(1125),
    [anon_sym_add] = ACTIONS(1125),
    [anon_sym_sub] = ACTIONS(1125),
    [anon_sym_mul] = ACTIONS(1125),
    [anon_sym_div] = ACTIONS(1125),
    [anon_sym_sdiv] = ACTIONS(1125),
    [anon_sym_mod] = ACTIONS(1125),
    [anon_sym_smod] = ACTIONS(1125),
    [anon_sym_exp] = ACTIONS(1125),
    [anon_sym_not] = ACTIONS(1125),
    [anon_sym_lt] = ACTIONS(1125),
    [anon_sym_gt] = ACTIONS(1125),
    [anon_sym_slt] = ACTIONS(1125),
    [anon_sym_sgt] = ACTIONS(1125),
    [anon_sym_eq] = ACTIONS(1125),
    [anon_sym_iszero] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(1125),
    [anon_sym_or] = ACTIONS(1125),
    [anon_sym_xor] = ACTIONS(1125),
    [anon_sym_byte] = ACTIONS(1125),
    [anon_sym_shl] = ACTIONS(1125),
    [anon_sym_shr] = ACTIONS(1125),
    [anon_sym_sar] = ACTIONS(1125),
    [anon_sym_addmod] = ACTIONS(1125),
    [anon_sym_mulmod] = ACTIONS(1125),
    [anon_sym_signextend] = ACTIONS(1125),
    [anon_sym_keccak256] = ACTIONS(1125),
    [anon_sym_pop] = ACTIONS(1125),
    [anon_sym_mload] = ACTIONS(1125),
    [anon_sym_mcopy] = ACTIONS(1125),
    [anon_sym_tload] = ACTIONS(1125),
    [anon_sym_tstore] = ACTIONS(1125),
    [anon_sym_mstore] = ACTIONS(1125),
    [anon_sym_mstore8] = ACTIONS(1125),
    [anon_sym_sload] = ACTIONS(1125),
    [anon_sym_sstore] = ACTIONS(1125),
    [anon_sym_msize] = ACTIONS(1125),
    [anon_sym_gas] = ACTIONS(1125),
    [anon_sym_address] = ACTIONS(1125),
    [anon_sym_balance] = ACTIONS(1125),
    [anon_sym_selfbalance] = ACTIONS(1125),
    [anon_sym_caller] = ACTIONS(1125),
    [anon_sym_callvalue] = ACTIONS(1125),
    [anon_sym_calldataload] = ACTIONS(1125),
    [anon_sym_calldatasize] = ACTIONS(1125),
    [anon_sym_calldatacopy] = ACTIONS(1125),
    [anon_sym_extcodesize] = ACTIONS(1125),
    [anon_sym_extcodecopy] = ACTIONS(1125),
    [anon_sym_returndatasize] = ACTIONS(1125),
    [anon_sym_returndatacopy] = ACTIONS(1125),
    [anon_sym_extcodehash] = ACTIONS(1125),
    [anon_sym_create] = ACTIONS(1125),
    [anon_sym_create2] = ACTIONS(1125),
    [anon_sym_call] = ACTIONS(1125),
    [anon_sym_callcode] = ACTIONS(1125),
    [anon_sym_delegatecall] = ACTIONS(1125),
    [anon_sym_staticcall] = ACTIONS(1125),
    [anon_sym_return] = ACTIONS(1125),
    [anon_sym_revert] = ACTIONS(1125),
    [anon_sym_selfdestruct] = ACTIONS(1125),
    [anon_sym_invalid] = ACTIONS(1125),
    [anon_sym_log0] = ACTIONS(1125),
    [anon_sym_log1] = ACTIONS(1125),
    [anon_sym_log2] = ACTIONS(1125),
    [anon_sym_log3] = ACTIONS(1125),
    [anon_sym_log4] = ACTIONS(1125),
    [anon_sym_chainid] = ACTIONS(1125),
    [anon_sym_origin] = ACTIONS(1125),
    [anon_sym_gasprice] = ACTIONS(1125),
    [anon_sym_blockhash] = ACTIONS(1125),
    [anon_sym_blobhash] = ACTIONS(1125),
    [anon_sym_basefee] = ACTIONS(1125),
    [anon_sym_blobfee] = ACTIONS(1125),
    [anon_sym_coinbase] = ACTIONS(1125),
    [anon_sym_timestamp] = ACTIONS(1125),
    [anon_sym_number] = ACTIONS(1125),
    [anon_sym_difficulty] = ACTIONS(1125),
    [anon_sym_gaslimit] = ACTIONS(1125),
    [anon_sym_DQUOTE] = ACTIONS(1127),
    [anon_sym_SQUOTE] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1129),
    [anon_sym_LBRACE] = ACTIONS(1131),
    [anon_sym_RBRACE] = ACTIONS(1131),
    [anon_sym_for] = ACTIONS(1129),
    [sym_yul_leave] = ACTIONS(1129),
    [anon_sym_break] = ACTIONS(1129),
    [anon_sym_continue] = ACTIONS(1129),
    [sym_yul_decimal_number] = ACTIONS(1129),
    [sym_yul_hex_number] = ACTIONS(1131),
    [anon_sym_true] = ACTIONS(1129),
    [anon_sym_false] = ACTIONS(1129),
    [anon_sym_let] = ACTIONS(1129),
    [anon_sym_if] = ACTIONS(1129),
    [anon_sym_switch] = ACTIONS(1129),
    [anon_sym_function] = ACTIONS(1129),
    [anon_sym_stop] = ACTIONS(1129),
    [anon_sym_add] = ACTIONS(1129),
    [anon_sym_sub] = ACTIONS(1129),
    [anon_sym_mul] = ACTIONS(1129),
    [anon_sym_div] = ACTIONS(1129),
    [anon_sym_sdiv] = ACTIONS(1129),
    [anon_sym_mod] = ACTIONS(1129),
    [anon_sym_smod] = ACTIONS(1129),
    [anon_sym_exp] = ACTIONS(1129),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_lt] = ACTIONS(1129),
    [anon_sym_gt] = ACTIONS(1129),
    [anon_sym_slt] = ACTIONS(1129),
    [anon_sym_sgt] = ACTIONS(1129),
    [anon_sym_eq] = ACTIONS(1129),
    [anon_sym_iszero] = ACTIONS(1129),
    [anon_sym_and] = ACTIONS(1129),
    [anon_sym_or] = ACTIONS(1129),
    [anon_sym_xor] = ACTIONS(1129),
    [anon_sym_byte] = ACTIONS(1129),
    [anon_sym_shl] = ACTIONS(1129),
    [anon_sym_shr] = ACTIONS(1129),
    [anon_sym_sar] = ACTIONS(1129),
    [anon_sym_addmod] = ACTIONS(1129),
    [anon_sym_mulmod] = ACTIONS(1129),
    [anon_sym_signextend] = ACTIONS(1129),
    [anon_sym_keccak256] = ACTIONS(1129),
    [anon_sym_pop] = ACTIONS(1129),
    [anon_sym_mload] = ACTIONS(1129),
    [anon_sym_mcopy] = ACTIONS(1129),
    [anon_sym_tload] = ACTIONS(1129),
    [anon_sym_tstore] = ACTIONS(1129),
    [anon_sym_mstore] = ACTIONS(1129),
    [anon_sym_mstore8] = ACTIONS(1129),
    [anon_sym_sload] = ACTIONS(1129),
    [anon_sym_sstore] = ACTIONS(1129),
    [anon_sym_msize] = ACTIONS(1129),
    [anon_sym_gas] = ACTIONS(1129),
    [anon_sym_address] = ACTIONS(1129),
    [anon_sym_balance] = ACTIONS(1129),
    [anon_sym_selfbalance] = ACTIONS(1129),
    [anon_sym_caller] = ACTIONS(1129),
    [anon_sym_callvalue] = ACTIONS(1129),
    [anon_sym_calldataload] = ACTIONS(1129),
    [anon_sym_calldatasize] = ACTIONS(1129),
    [anon_sym_calldatacopy] = ACTIONS(1129),
    [anon_sym_extcodesize] = ACTIONS(1129),
    [anon_sym_extcodecopy] = ACTIONS(1129),
    [anon_sym_returndatasize] = ACTIONS(1129),
    [anon_sym_returndatacopy] = ACTIONS(1129),
    [anon_sym_extcodehash] = ACTIONS(1129),
    [anon_sym_create] = ACTIONS(1129),
    [anon_sym_create2] = ACTIONS(1129),
    [anon_sym_call] = ACTIONS(1129),
    [anon_sym_callcode] = ACTIONS(1129),
    [anon_sym_delegatecall] = ACTIONS(1129),
    [anon_sym_staticcall] = ACTIONS(1129),
    [anon_sym_return] = ACTIONS(1129),
    [anon_sym_revert] = ACTIONS(1129),
    [anon_sym_selfdestruct] = ACTIONS(1129),
    [anon_sym_invalid] = ACTIONS(1129),
    [anon_sym_log0] = ACTIONS(1129),
    [anon_sym_log1] = ACTIONS(1129),
    [anon_sym_log2] = ACTIONS(1129),
    [anon_sym_log3] = ACTIONS(1129),
    [anon_sym_log4] = ACTIONS(1129),
    [anon_sym_chainid] = ACTIONS(1129),
    [anon_sym_origin] = ACTIONS(1129),
    [anon_sym_gasprice] = ACTIONS(1129),
    [anon_sym_blockhash] = ACTIONS(1129),
    [anon_sym_blobhash] = ACTIONS(1129),
    [anon_sym_basefee] = ACTIONS(1129),
    [anon_sym_blobfee] = ACTIONS(1129),
    [anon_sym_coinbase] = ACTIONS(1129),
    [anon_sym_timestamp] = ACTIONS(1129),
    [anon_sym_number] = ACTIONS(1129),
    [anon_sym_difficulty] = ACTIONS(1129),
    [anon_sym_gaslimit] = ACTIONS(1129),
    [anon_sym_DQUOTE] = ACTIONS(1131),
    [anon_sym_SQUOTE] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_identifier] = ACTIONS(1133),
    [anon_sym_LBRACE] = ACTIONS(1135),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym_for] = ACTIONS(1133),
    [sym_yul_leave] = ACTIONS(1133),
    [anon_sym_break] = ACTIONS(1133),
    [anon_sym_continue] = ACTIONS(1133),
    [sym_yul_decimal_number] = ACTIONS(1133),
    [sym_yul_hex_number] = ACTIONS(1135),
    [anon_sym_true] = ACTIONS(1133),
    [anon_sym_false] = ACTIONS(1133),
    [anon_sym_let] = ACTIONS(1133),
    [anon_sym_if] = ACTIONS(1133),
    [anon_sym_switch] = ACTIONS(1133),
    [anon_sym_function] = ACTIONS(1133),
    [anon_sym_stop] = ACTIONS(1133),
    [anon_sym_add] = ACTIONS(1133),
    [anon_sym_sub] = ACTIONS(1133),
    [anon_sym_mul] = ACTIONS(1133),
    [anon_sym_div] = ACTIONS(1133),
    [anon_sym_sdiv] = ACTIONS(1133),
    [anon_sym_mod] = ACTIONS(1133),
    [anon_sym_smod] = ACTIONS(1133),
    [anon_sym_exp] = ACTIONS(1133),
    [anon_sym_not] = ACTIONS(1133),
    [anon_sym_lt] = ACTIONS(1133),
    [anon_sym_gt] = ACTIONS(1133),
    [anon_sym_slt] = ACTIONS(1133),
    [anon_sym_sgt] = ACTIONS(1133),
    [anon_sym_eq] = ACTIONS(1133),
    [anon_sym_iszero] = ACTIONS(1133),
    [anon_sym_and] = ACTIONS(1133),
    [anon_sym_or] = ACTIONS(1133),
    [anon_sym_xor] = ACTIONS(1133),
    [anon_sym_byte] = ACTIONS(1133),
    [anon_sym_shl] = ACTIONS(1133),
    [anon_sym_shr] = ACTIONS(1133),
    [anon_sym_sar] = ACTIONS(1133),
    [anon_sym_addmod] = ACTIONS(1133),
    [anon_sym_mulmod] = ACTIONS(1133),
    [anon_sym_signextend] = ACTIONS(1133),
    [anon_sym_keccak256] = ACTIONS(1133),
    [anon_sym_pop] = ACTIONS(1133),
    [anon_sym_mload] = ACTIONS(1133),
    [anon_sym_mcopy] = ACTIONS(1133),
    [anon_sym_tload] = ACTIONS(1133),
    [anon_sym_tstore] = ACTIONS(1133),
    [anon_sym_mstore] = ACTIONS(1133),
    [anon_sym_mstore8] = ACTIONS(1133),
    [anon_sym_sload] = ACTIONS(1133),
    [anon_sym_sstore] = ACTIONS(1133),
    [anon_sym_msize] = ACTIONS(1133),
    [anon_sym_gas] = ACTIONS(1133),
    [anon_sym_address] = ACTIONS(1133),
    [anon_sym_balance] = ACTIONS(1133),
    [anon_sym_selfbalance] = ACTIONS(1133),
    [anon_sym_caller] = ACTIONS(1133),
    [anon_sym_callvalue] = ACTIONS(1133),
    [anon_sym_calldataload] = ACTIONS(1133),
    [anon_sym_calldatasize] = ACTIONS(1133),
    [anon_sym_calldatacopy] = ACTIONS(1133),
    [anon_sym_extcodesize] = ACTIONS(1133),
    [anon_sym_extcodecopy] = ACTIONS(1133),
    [anon_sym_returndatasize] = ACTIONS(1133),
    [anon_sym_returndatacopy] = ACTIONS(1133),
    [anon_sym_extcodehash] = ACTIONS(1133),
    [anon_sym_create] = ACTIONS(1133),
    [anon_sym_create2] = ACTIONS(1133),
    [anon_sym_call] = ACTIONS(1133),
    [anon_sym_callcode] = ACTIONS(1133),
    [anon_sym_delegatecall] = ACTIONS(1133),
    [anon_sym_staticcall] = ACTIONS(1133),
    [anon_sym_return] = ACTIONS(1133),
    [anon_sym_revert] = ACTIONS(1133),
    [anon_sym_selfdestruct] = ACTIONS(1133),
    [anon_sym_invalid] = ACTIONS(1133),
    [anon_sym_log0] = ACTIONS(1133),
    [anon_sym_log1] = ACTIONS(1133),
    [anon_sym_log2] = ACTIONS(1133),
    [anon_sym_log3] = ACTIONS(1133),
    [anon_sym_log4] = ACTIONS(1133),
    [anon_sym_chainid] = ACTIONS(1133),
    [anon_sym_origin] = ACTIONS(1133),
    [anon_sym_gasprice] = ACTIONS(1133),
    [anon_sym_blockhash] = ACTIONS(1133),
    [anon_sym_blobhash] = ACTIONS(1133),
    [anon_sym_basefee] = ACTIONS(1133),
    [anon_sym_blobfee] = ACTIONS(1133),
    [anon_sym_coinbase] = ACTIONS(1133),
    [anon_sym_timestamp] = ACTIONS(1133),
    [anon_sym_number] = ACTIONS(1133),
    [anon_sym_difficulty] = ACTIONS(1133),
    [anon_sym_gaslimit] = ACTIONS(1133),
    [anon_sym_DQUOTE] = ACTIONS(1135),
    [anon_sym_SQUOTE] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1137),
    [anon_sym_LBRACE] = ACTIONS(1139),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym_for] = ACTIONS(1137),
    [sym_yul_leave] = ACTIONS(1137),
    [anon_sym_break] = ACTIONS(1137),
    [anon_sym_continue] = ACTIONS(1137),
    [sym_yul_decimal_number] = ACTIONS(1137),
    [sym_yul_hex_number] = ACTIONS(1139),
    [anon_sym_true] = ACTIONS(1137),
    [anon_sym_false] = ACTIONS(1137),
    [anon_sym_let] = ACTIONS(1137),
    [anon_sym_if] = ACTIONS(1137),
    [anon_sym_switch] = ACTIONS(1137),
    [anon_sym_function] = ACTIONS(1137),
    [anon_sym_stop] = ACTIONS(1137),
    [anon_sym_add] = ACTIONS(1137),
    [anon_sym_sub] = ACTIONS(1137),
    [anon_sym_mul] = ACTIONS(1137),
    [anon_sym_div] = ACTIONS(1137),
    [anon_sym_sdiv] = ACTIONS(1137),
    [anon_sym_mod] = ACTIONS(1137),
    [anon_sym_smod] = ACTIONS(1137),
    [anon_sym_exp] = ACTIONS(1137),
    [anon_sym_not] = ACTIONS(1137),
    [anon_sym_lt] = ACTIONS(1137),
    [anon_sym_gt] = ACTIONS(1137),
    [anon_sym_slt] = ACTIONS(1137),
    [anon_sym_sgt] = ACTIONS(1137),
    [anon_sym_eq] = ACTIONS(1137),
    [anon_sym_iszero] = ACTIONS(1137),
    [anon_sym_and] = ACTIONS(1137),
    [anon_sym_or] = ACTIONS(1137),
    [anon_sym_xor] = ACTIONS(1137),
    [anon_sym_byte] = ACTIONS(1137),
    [anon_sym_shl] = ACTIONS(1137),
    [anon_sym_shr] = ACTIONS(1137),
    [anon_sym_sar] = ACTIONS(1137),
    [anon_sym_addmod] = ACTIONS(1137),
    [anon_sym_mulmod] = ACTIONS(1137),
    [anon_sym_signextend] = ACTIONS(1137),
    [anon_sym_keccak256] = ACTIONS(1137),
    [anon_sym_pop] = ACTIONS(1137),
    [anon_sym_mload] = ACTIONS(1137),
    [anon_sym_mcopy] = ACTIONS(1137),
    [anon_sym_tload] = ACTIONS(1137),
    [anon_sym_tstore] = ACTIONS(1137),
    [anon_sym_mstore] = ACTIONS(1137),
    [anon_sym_mstore8] = ACTIONS(1137),
    [anon_sym_sload] = ACTIONS(1137),
    [anon_sym_sstore] = ACTIONS(1137),
    [anon_sym_msize] = ACTIONS(1137),
    [anon_sym_gas] = ACTIONS(1137),
    [anon_sym_address] = ACTIONS(1137),
    [anon_sym_balance] = ACTIONS(1137),
    [anon_sym_selfbalance] = ACTIONS(1137),
    [anon_sym_caller] = ACTIONS(1137),
    [anon_sym_callvalue] = ACTIONS(1137),
    [anon_sym_calldataload] = ACTIONS(1137),
    [anon_sym_calldatasize] = ACTIONS(1137),
    [anon_sym_calldatacopy] = ACTIONS(1137),
    [anon_sym_extcodesize] = ACTIONS(1137),
    [anon_sym_extcodecopy] = ACTIONS(1137),
    [anon_sym_returndatasize] = ACTIONS(1137),
    [anon_sym_returndatacopy] = ACTIONS(1137),
    [anon_sym_extcodehash] = ACTIONS(1137),
    [anon_sym_create] = ACTIONS(1137),
    [anon_sym_create2] = ACTIONS(1137),
    [anon_sym_call] = ACTIONS(1137),
    [anon_sym_callcode] = ACTIONS(1137),
    [anon_sym_delegatecall] = ACTIONS(1137),
    [anon_sym_staticcall] = ACTIONS(1137),
    [anon_sym_return] = ACTIONS(1137),
    [anon_sym_revert] = ACTIONS(1137),
    [anon_sym_selfdestruct] = ACTIONS(1137),
    [anon_sym_invalid] = ACTIONS(1137),
    [anon_sym_log0] = ACTIONS(1137),
    [anon_sym_log1] = ACTIONS(1137),
    [anon_sym_log2] = ACTIONS(1137),
    [anon_sym_log3] = ACTIONS(1137),
    [anon_sym_log4] = ACTIONS(1137),
    [anon_sym_chainid] = ACTIONS(1137),
    [anon_sym_origin] = ACTIONS(1137),
    [anon_sym_gasprice] = ACTIONS(1137),
    [anon_sym_blockhash] = ACTIONS(1137),
    [anon_sym_blobhash] = ACTIONS(1137),
    [anon_sym_basefee] = ACTIONS(1137),
    [anon_sym_blobfee] = ACTIONS(1137),
    [anon_sym_coinbase] = ACTIONS(1137),
    [anon_sym_timestamp] = ACTIONS(1137),
    [anon_sym_number] = ACTIONS(1137),
    [anon_sym_difficulty] = ACTIONS(1137),
    [anon_sym_gaslimit] = ACTIONS(1137),
    [anon_sym_DQUOTE] = ACTIONS(1139),
    [anon_sym_SQUOTE] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1141),
    [anon_sym_LBRACE] = ACTIONS(1143),
    [anon_sym_RBRACE] = ACTIONS(1143),
    [anon_sym_for] = ACTIONS(1141),
    [sym_yul_leave] = ACTIONS(1141),
    [anon_sym_break] = ACTIONS(1141),
    [anon_sym_continue] = ACTIONS(1141),
    [sym_yul_decimal_number] = ACTIONS(1141),
    [sym_yul_hex_number] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(1141),
    [anon_sym_false] = ACTIONS(1141),
    [anon_sym_let] = ACTIONS(1141),
    [anon_sym_if] = ACTIONS(1141),
    [anon_sym_switch] = ACTIONS(1141),
    [anon_sym_function] = ACTIONS(1141),
    [anon_sym_stop] = ACTIONS(1141),
    [anon_sym_add] = ACTIONS(1141),
    [anon_sym_sub] = ACTIONS(1141),
    [anon_sym_mul] = ACTIONS(1141),
    [anon_sym_div] = ACTIONS(1141),
    [anon_sym_sdiv] = ACTIONS(1141),
    [anon_sym_mod] = ACTIONS(1141),
    [anon_sym_smod] = ACTIONS(1141),
    [anon_sym_exp] = ACTIONS(1141),
    [anon_sym_not] = ACTIONS(1141),
    [anon_sym_lt] = ACTIONS(1141),
    [anon_sym_gt] = ACTIONS(1141),
    [anon_sym_slt] = ACTIONS(1141),
    [anon_sym_sgt] = ACTIONS(1141),
    [anon_sym_eq] = ACTIONS(1141),
    [anon_sym_iszero] = ACTIONS(1141),
    [anon_sym_and] = ACTIONS(1141),
    [anon_sym_or] = ACTIONS(1141),
    [anon_sym_xor] = ACTIONS(1141),
    [anon_sym_byte] = ACTIONS(1141),
    [anon_sym_shl] = ACTIONS(1141),
    [anon_sym_shr] = ACTIONS(1141),
    [anon_sym_sar] = ACTIONS(1141),
    [anon_sym_addmod] = ACTIONS(1141),
    [anon_sym_mulmod] = ACTIONS(1141),
    [anon_sym_signextend] = ACTIONS(1141),
    [anon_sym_keccak256] = ACTIONS(1141),
    [anon_sym_pop] = ACTIONS(1141),
    [anon_sym_mload] = ACTIONS(1141),
    [anon_sym_mcopy] = ACTIONS(1141),
    [anon_sym_tload] = ACTIONS(1141),
    [anon_sym_tstore] = ACTIONS(1141),
    [anon_sym_mstore] = ACTIONS(1141),
    [anon_sym_mstore8] = ACTIONS(1141),
    [anon_sym_sload] = ACTIONS(1141),
    [anon_sym_sstore] = ACTIONS(1141),
    [anon_sym_msize] = ACTIONS(1141),
    [anon_sym_gas] = ACTIONS(1141),
    [anon_sym_address] = ACTIONS(1141),
    [anon_sym_balance] = ACTIONS(1141),
    [anon_sym_selfbalance] = ACTIONS(1141),
    [anon_sym_caller] = ACTIONS(1141),
    [anon_sym_callvalue] = ACTIONS(1141),
    [anon_sym_calldataload] = ACTIONS(1141),
    [anon_sym_calldatasize] = ACTIONS(1141),
    [anon_sym_calldatacopy] = ACTIONS(1141),
    [anon_sym_extcodesize] = ACTIONS(1141),
    [anon_sym_extcodecopy] = ACTIONS(1141),
    [anon_sym_returndatasize] = ACTIONS(1141),
    [anon_sym_returndatacopy] = ACTIONS(1141),
    [anon_sym_extcodehash] = ACTIONS(1141),
    [anon_sym_create] = ACTIONS(1141),
    [anon_sym_create2] = ACTIONS(1141),
    [anon_sym_call] = ACTIONS(1141),
    [anon_sym_callcode] = ACTIONS(1141),
    [anon_sym_delegatecall] = ACTIONS(1141),
    [anon_sym_staticcall] = ACTIONS(1141),
    [anon_sym_return] = ACTIONS(1141),
    [anon_sym_revert] = ACTIONS(1141),
    [anon_sym_selfdestruct] = ACTIONS(1141),
    [anon_sym_invalid] = ACTIONS(1141),
    [anon_sym_log0] = ACTIONS(1141),
    [anon_sym_log1] = ACTIONS(1141),
    [anon_sym_log2] = ACTIONS(1141),
    [anon_sym_log3] = ACTIONS(1141),
    [anon_sym_log4] = ACTIONS(1141),
    [anon_sym_chainid] = ACTIONS(1141),
    [anon_sym_origin] = ACTIONS(1141),
    [anon_sym_gasprice] = ACTIONS(1141),
    [anon_sym_blockhash] = ACTIONS(1141),
    [anon_sym_blobhash] = ACTIONS(1141),
    [anon_sym_basefee] = ACTIONS(1141),
    [anon_sym_blobfee] = ACTIONS(1141),
    [anon_sym_coinbase] = ACTIONS(1141),
    [anon_sym_timestamp] = ACTIONS(1141),
    [anon_sym_number] = ACTIONS(1141),
    [anon_sym_difficulty] = ACTIONS(1141),
    [anon_sym_gaslimit] = ACTIONS(1141),
    [anon_sym_DQUOTE] = ACTIONS(1143),
    [anon_sym_SQUOTE] = ACTIONS(1143),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_LBRACE] = ACTIONS(1148),
    [anon_sym_RBRACE] = ACTIONS(1148),
    [anon_sym_for] = ACTIONS(1145),
    [sym_yul_leave] = ACTIONS(1145),
    [anon_sym_break] = ACTIONS(1145),
    [anon_sym_continue] = ACTIONS(1145),
    [sym_yul_decimal_number] = ACTIONS(1145),
    [sym_yul_hex_number] = ACTIONS(1148),
    [anon_sym_true] = ACTIONS(1145),
    [anon_sym_false] = ACTIONS(1145),
    [anon_sym_let] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_switch] = ACTIONS(1145),
    [anon_sym_function] = ACTIONS(1145),
    [anon_sym_stop] = ACTIONS(1145),
    [anon_sym_add] = ACTIONS(1145),
    [anon_sym_sub] = ACTIONS(1145),
    [anon_sym_mul] = ACTIONS(1145),
    [anon_sym_div] = ACTIONS(1145),
    [anon_sym_sdiv] = ACTIONS(1145),
    [anon_sym_mod] = ACTIONS(1145),
    [anon_sym_smod] = ACTIONS(1145),
    [anon_sym_exp] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_lt] = ACTIONS(1145),
    [anon_sym_gt] = ACTIONS(1145),
    [anon_sym_slt] = ACTIONS(1145),
    [anon_sym_sgt] = ACTIONS(1145),
    [anon_sym_eq] = ACTIONS(1145),
    [anon_sym_iszero] = ACTIONS(1145),
    [anon_sym_and] = ACTIONS(1145),
    [anon_sym_or] = ACTIONS(1145),
    [anon_sym_xor] = ACTIONS(1145),
    [anon_sym_byte] = ACTIONS(1145),
    [anon_sym_shl] = ACTIONS(1145),
    [anon_sym_shr] = ACTIONS(1145),
    [anon_sym_sar] = ACTIONS(1145),
    [anon_sym_addmod] = ACTIONS(1145),
    [anon_sym_mulmod] = ACTIONS(1145),
    [anon_sym_signextend] = ACTIONS(1145),
    [anon_sym_keccak256] = ACTIONS(1145),
    [anon_sym_pop] = ACTIONS(1145),
    [anon_sym_mload] = ACTIONS(1145),
    [anon_sym_mcopy] = ACTIONS(1145),
    [anon_sym_tload] = ACTIONS(1145),
    [anon_sym_tstore] = ACTIONS(1145),
    [anon_sym_mstore] = ACTIONS(1145),
    [anon_sym_mstore8] = ACTIONS(1145),
    [anon_sym_sload] = ACTIONS(1145),
    [anon_sym_sstore] = ACTIONS(1145),
    [anon_sym_msize] = ACTIONS(1145),
    [anon_sym_gas] = ACTIONS(1145),
    [anon_sym_address] = ACTIONS(1145),
    [anon_sym_balance] = ACTIONS(1145),
    [anon_sym_selfbalance] = ACTIONS(1145),
    [anon_sym_caller] = ACTIONS(1145),
    [anon_sym_callvalue] = ACTIONS(1145),
    [anon_sym_calldataload] = ACTIONS(1145),
    [anon_sym_calldatasize] = ACTIONS(1145),
    [anon_sym_calldatacopy] = ACTIONS(1145),
    [anon_sym_extcodesize] = ACTIONS(1145),
    [anon_sym_extcodecopy] = ACTIONS(1145),
    [anon_sym_returndatasize] = ACTIONS(1145),
    [anon_sym_returndatacopy] = ACTIONS(1145),
    [anon_sym_extcodehash] = ACTIONS(1145),
    [anon_sym_create] = ACTIONS(1145),
    [anon_sym_create2] = ACTIONS(1145),
    [anon_sym_call] = ACTIONS(1145),
    [anon_sym_callcode] = ACTIONS(1145),
    [anon_sym_delegatecall] = ACTIONS(1145),
    [anon_sym_staticcall] = ACTIONS(1145),
    [anon_sym_return] = ACTIONS(1145),
    [anon_sym_revert] = ACTIONS(1145),
    [anon_sym_selfdestruct] = ACTIONS(1145),
    [anon_sym_invalid] = ACTIONS(1145),
    [anon_sym_log0] = ACTIONS(1145),
    [anon_sym_log1] = ACTIONS(1145),
    [anon_sym_log2] = ACTIONS(1145),
    [anon_sym_log3] = ACTIONS(1145),
    [anon_sym_log4] = ACTIONS(1145),
    [anon_sym_chainid] = ACTIONS(1145),
    [anon_sym_origin] = ACTIONS(1145),
    [anon_sym_gasprice] = ACTIONS(1145),
    [anon_sym_blockhash] = ACTIONS(1145),
    [anon_sym_blobhash] = ACTIONS(1145),
    [anon_sym_basefee] = ACTIONS(1145),
    [anon_sym_blobfee] = ACTIONS(1145),
    [anon_sym_coinbase] = ACTIONS(1145),
    [anon_sym_timestamp] = ACTIONS(1145),
    [anon_sym_number] = ACTIONS(1145),
    [anon_sym_difficulty] = ACTIONS(1145),
    [anon_sym_gaslimit] = ACTIONS(1145),
    [anon_sym_DQUOTE] = ACTIONS(1148),
    [anon_sym_SQUOTE] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1151),
    [anon_sym_LBRACE] = ACTIONS(1153),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym_for] = ACTIONS(1151),
    [sym_yul_leave] = ACTIONS(1151),
    [anon_sym_break] = ACTIONS(1151),
    [anon_sym_continue] = ACTIONS(1151),
    [sym_yul_decimal_number] = ACTIONS(1151),
    [sym_yul_hex_number] = ACTIONS(1153),
    [anon_sym_true] = ACTIONS(1151),
    [anon_sym_false] = ACTIONS(1151),
    [anon_sym_let] = ACTIONS(1151),
    [anon_sym_if] = ACTIONS(1151),
    [anon_sym_switch] = ACTIONS(1151),
    [anon_sym_function] = ACTIONS(1151),
    [anon_sym_stop] = ACTIONS(1151),
    [anon_sym_add] = ACTIONS(1151),
    [anon_sym_sub] = ACTIONS(1151),
    [anon_sym_mul] = ACTIONS(1151),
    [anon_sym_div] = ACTIONS(1151),
    [anon_sym_sdiv] = ACTIONS(1151),
    [anon_sym_mod] = ACTIONS(1151),
    [anon_sym_smod] = ACTIONS(1151),
    [anon_sym_exp] = ACTIONS(1151),
    [anon_sym_not] = ACTIONS(1151),
    [anon_sym_lt] = ACTIONS(1151),
    [anon_sym_gt] = ACTIONS(1151),
    [anon_sym_slt] = ACTIONS(1151),
    [anon_sym_sgt] = ACTIONS(1151),
    [anon_sym_eq] = ACTIONS(1151),
    [anon_sym_iszero] = ACTIONS(1151),
    [anon_sym_and] = ACTIONS(1151),
    [anon_sym_or] = ACTIONS(1151),
    [anon_sym_xor] = ACTIONS(1151),
    [anon_sym_byte] = ACTIONS(1151),
    [anon_sym_shl] = ACTIONS(1151),
    [anon_sym_shr] = ACTIONS(1151),
    [anon_sym_sar] = ACTIONS(1151),
    [anon_sym_addmod] = ACTIONS(1151),
    [anon_sym_mulmod] = ACTIONS(1151),
    [anon_sym_signextend] = ACTIONS(1151),
    [anon_sym_keccak256] = ACTIONS(1151),
    [anon_sym_pop] = ACTIONS(1151),
    [anon_sym_mload] = ACTIONS(1151),
    [anon_sym_mcopy] = ACTIONS(1151),
    [anon_sym_tload] = ACTIONS(1151),
    [anon_sym_tstore] = ACTIONS(1151),
    [anon_sym_mstore] = ACTIONS(1151),
    [anon_sym_mstore8] = ACTIONS(1151),
    [anon_sym_sload] = ACTIONS(1151),
    [anon_sym_sstore] = ACTIONS(1151),
    [anon_sym_msize] = ACTIONS(1151),
    [anon_sym_gas] = ACTIONS(1151),
    [anon_sym_address] = ACTIONS(1151),
    [anon_sym_balance] = ACTIONS(1151),
    [anon_sym_selfbalance] = ACTIONS(1151),
    [anon_sym_caller] = ACTIONS(1151),
    [anon_sym_callvalue] = ACTIONS(1151),
    [anon_sym_calldataload] = ACTIONS(1151),
    [anon_sym_calldatasize] = ACTIONS(1151),
    [anon_sym_calldatacopy] = ACTIONS(1151),
    [anon_sym_extcodesize] = ACTIONS(1151),
    [anon_sym_extcodecopy] = ACTIONS(1151),
    [anon_sym_returndatasize] = ACTIONS(1151),
    [anon_sym_returndatacopy] = ACTIONS(1151),
    [anon_sym_extcodehash] = ACTIONS(1151),
    [anon_sym_create] = ACTIONS(1151),
    [anon_sym_create2] = ACTIONS(1151),
    [anon_sym_call] = ACTIONS(1151),
    [anon_sym_callcode] = ACTIONS(1151),
    [anon_sym_delegatecall] = ACTIONS(1151),
    [anon_sym_staticcall] = ACTIONS(1151),
    [anon_sym_return] = ACTIONS(1151),
    [anon_sym_revert] = ACTIONS(1151),
    [anon_sym_selfdestruct] = ACTIONS(1151),
    [anon_sym_invalid] = ACTIONS(1151),
    [anon_sym_log0] = ACTIONS(1151),
    [anon_sym_log1] = ACTIONS(1151),
    [anon_sym_log2] = ACTIONS(1151),
    [anon_sym_log3] = ACTIONS(1151),
    [anon_sym_log4] = ACTIONS(1151),
    [anon_sym_chainid] = ACTIONS(1151),
    [anon_sym_origin] = ACTIONS(1151),
    [anon_sym_gasprice] = ACTIONS(1151),
    [anon_sym_blockhash] = ACTIONS(1151),
    [anon_sym_blobhash] = ACTIONS(1151),
    [anon_sym_basefee] = ACTIONS(1151),
    [anon_sym_blobfee] = ACTIONS(1151),
    [anon_sym_coinbase] = ACTIONS(1151),
    [anon_sym_timestamp] = ACTIONS(1151),
    [anon_sym_number] = ACTIONS(1151),
    [anon_sym_difficulty] = ACTIONS(1151),
    [anon_sym_gaslimit] = ACTIONS(1151),
    [anon_sym_DQUOTE] = ACTIONS(1153),
    [anon_sym_SQUOTE] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1155),
    [anon_sym_LBRACE] = ACTIONS(1157),
    [anon_sym_RBRACE] = ACTIONS(1157),
    [anon_sym_for] = ACTIONS(1155),
    [sym_yul_leave] = ACTIONS(1155),
    [anon_sym_break] = ACTIONS(1155),
    [anon_sym_continue] = ACTIONS(1155),
    [sym_yul_decimal_number] = ACTIONS(1155),
    [sym_yul_hex_number] = ACTIONS(1157),
    [anon_sym_true] = ACTIONS(1155),
    [anon_sym_false] = ACTIONS(1155),
    [anon_sym_let] = ACTIONS(1155),
    [anon_sym_if] = ACTIONS(1155),
    [anon_sym_switch] = ACTIONS(1155),
    [anon_sym_function] = ACTIONS(1155),
    [anon_sym_stop] = ACTIONS(1155),
    [anon_sym_add] = ACTIONS(1155),
    [anon_sym_sub] = ACTIONS(1155),
    [anon_sym_mul] = ACTIONS(1155),
    [anon_sym_div] = ACTIONS(1155),
    [anon_sym_sdiv] = ACTIONS(1155),
    [anon_sym_mod] = ACTIONS(1155),
    [anon_sym_smod] = ACTIONS(1155),
    [anon_sym_exp] = ACTIONS(1155),
    [anon_sym_not] = ACTIONS(1155),
    [anon_sym_lt] = ACTIONS(1155),
    [anon_sym_gt] = ACTIONS(1155),
    [anon_sym_slt] = ACTIONS(1155),
    [anon_sym_sgt] = ACTIONS(1155),
    [anon_sym_eq] = ACTIONS(1155),
    [anon_sym_iszero] = ACTIONS(1155),
    [anon_sym_and] = ACTIONS(1155),
    [anon_sym_or] = ACTIONS(1155),
    [anon_sym_xor] = ACTIONS(1155),
    [anon_sym_byte] = ACTIONS(1155),
    [anon_sym_shl] = ACTIONS(1155),
    [anon_sym_shr] = ACTIONS(1155),
    [anon_sym_sar] = ACTIONS(1155),
    [anon_sym_addmod] = ACTIONS(1155),
    [anon_sym_mulmod] = ACTIONS(1155),
    [anon_sym_signextend] = ACTIONS(1155),
    [anon_sym_keccak256] = ACTIONS(1155),
    [anon_sym_pop] = ACTIONS(1155),
    [anon_sym_mload] = ACTIONS(1155),
    [anon_sym_mcopy] = ACTIONS(1155),
    [anon_sym_tload] = ACTIONS(1155),
    [anon_sym_tstore] = ACTIONS(1155),
    [anon_sym_mstore] = ACTIONS(1155),
    [anon_sym_mstore8] = ACTIONS(1155),
    [anon_sym_sload] = ACTIONS(1155),
    [anon_sym_sstore] = ACTIONS(1155),
    [anon_sym_msize] = ACTIONS(1155),
    [anon_sym_gas] = ACTIONS(1155),
    [anon_sym_address] = ACTIONS(1155),
    [anon_sym_balance] = ACTIONS(1155),
    [anon_sym_selfbalance] = ACTIONS(1155),
    [anon_sym_caller] = ACTIONS(1155),
    [anon_sym_callvalue] = ACTIONS(1155),
    [anon_sym_calldataload] = ACTIONS(1155),
    [anon_sym_calldatasize] = ACTIONS(1155),
    [anon_sym_calldatacopy] = ACTIONS(1155),
    [anon_sym_extcodesize] = ACTIONS(1155),
    [anon_sym_extcodecopy] = ACTIONS(1155),
    [anon_sym_returndatasize] = ACTIONS(1155),
    [anon_sym_returndatacopy] = ACTIONS(1155),
    [anon_sym_extcodehash] = ACTIONS(1155),
    [anon_sym_create] = ACTIONS(1155),
    [anon_sym_create2] = ACTIONS(1155),
    [anon_sym_call] = ACTIONS(1155),
    [anon_sym_callcode] = ACTIONS(1155),
    [anon_sym_delegatecall] = ACTIONS(1155),
    [anon_sym_staticcall] = ACTIONS(1155),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_revert] = ACTIONS(1155),
    [anon_sym_selfdestruct] = ACTIONS(1155),
    [anon_sym_invalid] = ACTIONS(1155),
    [anon_sym_log0] = ACTIONS(1155),
    [anon_sym_log1] = ACTIONS(1155),
    [anon_sym_log2] = ACTIONS(1155),
    [anon_sym_log3] = ACTIONS(1155),
    [anon_sym_log4] = ACTIONS(1155),
    [anon_sym_chainid] = ACTIONS(1155),
    [anon_sym_origin] = ACTIONS(1155),
    [anon_sym_gasprice] = ACTIONS(1155),
    [anon_sym_blockhash] = ACTIONS(1155),
    [anon_sym_blobhash] = ACTIONS(1155),
    [anon_sym_basefee] = ACTIONS(1155),
    [anon_sym_blobfee] = ACTIONS(1155),
    [anon_sym_coinbase] = ACTIONS(1155),
    [anon_sym_timestamp] = ACTIONS(1155),
    [anon_sym_number] = ACTIONS(1155),
    [anon_sym_difficulty] = ACTIONS(1155),
    [anon_sym_gaslimit] = ACTIONS(1155),
    [anon_sym_DQUOTE] = ACTIONS(1157),
    [anon_sym_SQUOTE] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_identifier] = ACTIONS(1159),
    [anon_sym_LBRACE] = ACTIONS(1161),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym_for] = ACTIONS(1159),
    [sym_yul_leave] = ACTIONS(1159),
    [anon_sym_break] = ACTIONS(1159),
    [anon_sym_continue] = ACTIONS(1159),
    [sym_yul_decimal_number] = ACTIONS(1159),
    [sym_yul_hex_number] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(1159),
    [anon_sym_false] = ACTIONS(1159),
    [anon_sym_let] = ACTIONS(1159),
    [anon_sym_if] = ACTIONS(1159),
    [anon_sym_switch] = ACTIONS(1159),
    [anon_sym_function] = ACTIONS(1159),
    [anon_sym_stop] = ACTIONS(1159),
    [anon_sym_add] = ACTIONS(1159),
    [anon_sym_sub] = ACTIONS(1159),
    [anon_sym_mul] = ACTIONS(1159),
    [anon_sym_div] = ACTIONS(1159),
    [anon_sym_sdiv] = ACTIONS(1159),
    [anon_sym_mod] = ACTIONS(1159),
    [anon_sym_smod] = ACTIONS(1159),
    [anon_sym_exp] = ACTIONS(1159),
    [anon_sym_not] = ACTIONS(1159),
    [anon_sym_lt] = ACTIONS(1159),
    [anon_sym_gt] = ACTIONS(1159),
    [anon_sym_slt] = ACTIONS(1159),
    [anon_sym_sgt] = ACTIONS(1159),
    [anon_sym_eq] = ACTIONS(1159),
    [anon_sym_iszero] = ACTIONS(1159),
    [anon_sym_and] = ACTIONS(1159),
    [anon_sym_or] = ACTIONS(1159),
    [anon_sym_xor] = ACTIONS(1159),
    [anon_sym_byte] = ACTIONS(1159),
    [anon_sym_shl] = ACTIONS(1159),
    [anon_sym_shr] = ACTIONS(1159),
    [anon_sym_sar] = ACTIONS(1159),
    [anon_sym_addmod] = ACTIONS(1159),
    [anon_sym_mulmod] = ACTIONS(1159),
    [anon_sym_signextend] = ACTIONS(1159),
    [anon_sym_keccak256] = ACTIONS(1159),
    [anon_sym_pop] = ACTIONS(1159),
    [anon_sym_mload] = ACTIONS(1159),
    [anon_sym_mcopy] = ACTIONS(1159),
    [anon_sym_tload] = ACTIONS(1159),
    [anon_sym_tstore] = ACTIONS(1159),
    [anon_sym_mstore] = ACTIONS(1159),
    [anon_sym_mstore8] = ACTIONS(1159),
    [anon_sym_sload] = ACTIONS(1159),
    [anon_sym_sstore] = ACTIONS(1159),
    [anon_sym_msize] = ACTIONS(1159),
    [anon_sym_gas] = ACTIONS(1159),
    [anon_sym_address] = ACTIONS(1159),
    [anon_sym_balance] = ACTIONS(1159),
    [anon_sym_selfbalance] = ACTIONS(1159),
    [anon_sym_caller] = ACTIONS(1159),
    [anon_sym_callvalue] = ACTIONS(1159),
    [anon_sym_calldataload] = ACTIONS(1159),
    [anon_sym_calldatasize] = ACTIONS(1159),
    [anon_sym_calldatacopy] = ACTIONS(1159),
    [anon_sym_extcodesize] = ACTIONS(1159),
    [anon_sym_extcodecopy] = ACTIONS(1159),
    [anon_sym_returndatasize] = ACTIONS(1159),
    [anon_sym_returndatacopy] = ACTIONS(1159),
    [anon_sym_extcodehash] = ACTIONS(1159),
    [anon_sym_create] = ACTIONS(1159),
    [anon_sym_create2] = ACTIONS(1159),
    [anon_sym_call] = ACTIONS(1159),
    [anon_sym_callcode] = ACTIONS(1159),
    [anon_sym_delegatecall] = ACTIONS(1159),
    [anon_sym_staticcall] = ACTIONS(1159),
    [anon_sym_return] = ACTIONS(1159),
    [anon_sym_revert] = ACTIONS(1159),
    [anon_sym_selfdestruct] = ACTIONS(1159),
    [anon_sym_invalid] = ACTIONS(1159),
    [anon_sym_log0] = ACTIONS(1159),
    [anon_sym_log1] = ACTIONS(1159),
    [anon_sym_log2] = ACTIONS(1159),
    [anon_sym_log3] = ACTIONS(1159),
    [anon_sym_log4] = ACTIONS(1159),
    [anon_sym_chainid] = ACTIONS(1159),
    [anon_sym_origin] = ACTIONS(1159),
    [anon_sym_gasprice] = ACTIONS(1159),
    [anon_sym_blockhash] = ACTIONS(1159),
    [anon_sym_blobhash] = ACTIONS(1159),
    [anon_sym_basefee] = ACTIONS(1159),
    [anon_sym_blobfee] = ACTIONS(1159),
    [anon_sym_coinbase] = ACTIONS(1159),
    [anon_sym_timestamp] = ACTIONS(1159),
    [anon_sym_number] = ACTIONS(1159),
    [anon_sym_difficulty] = ACTIONS(1159),
    [anon_sym_gaslimit] = ACTIONS(1159),
    [anon_sym_DQUOTE] = ACTIONS(1161),
    [anon_sym_SQUOTE] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_identifier] = ACTIONS(1163),
    [anon_sym_LBRACE] = ACTIONS(1165),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym_for] = ACTIONS(1163),
    [sym_yul_leave] = ACTIONS(1163),
    [anon_sym_break] = ACTIONS(1163),
    [anon_sym_continue] = ACTIONS(1163),
    [sym_yul_decimal_number] = ACTIONS(1163),
    [sym_yul_hex_number] = ACTIONS(1165),
    [anon_sym_true] = ACTIONS(1163),
    [anon_sym_false] = ACTIONS(1163),
    [anon_sym_let] = ACTIONS(1163),
    [anon_sym_if] = ACTIONS(1163),
    [anon_sym_switch] = ACTIONS(1163),
    [anon_sym_function] = ACTIONS(1163),
    [anon_sym_stop] = ACTIONS(1163),
    [anon_sym_add] = ACTIONS(1163),
    [anon_sym_sub] = ACTIONS(1163),
    [anon_sym_mul] = ACTIONS(1163),
    [anon_sym_div] = ACTIONS(1163),
    [anon_sym_sdiv] = ACTIONS(1163),
    [anon_sym_mod] = ACTIONS(1163),
    [anon_sym_smod] = ACTIONS(1163),
    [anon_sym_exp] = ACTIONS(1163),
    [anon_sym_not] = ACTIONS(1163),
    [anon_sym_lt] = ACTIONS(1163),
    [anon_sym_gt] = ACTIONS(1163),
    [anon_sym_slt] = ACTIONS(1163),
    [anon_sym_sgt] = ACTIONS(1163),
    [anon_sym_eq] = ACTIONS(1163),
    [anon_sym_iszero] = ACTIONS(1163),
    [anon_sym_and] = ACTIONS(1163),
    [anon_sym_or] = ACTIONS(1163),
    [anon_sym_xor] = ACTIONS(1163),
    [anon_sym_byte] = ACTIONS(1163),
    [anon_sym_shl] = ACTIONS(1163),
    [anon_sym_shr] = ACTIONS(1163),
    [anon_sym_sar] = ACTIONS(1163),
    [anon_sym_addmod] = ACTIONS(1163),
    [anon_sym_mulmod] = ACTIONS(1163),
    [anon_sym_signextend] = ACTIONS(1163),
    [anon_sym_keccak256] = ACTIONS(1163),
    [anon_sym_pop] = ACTIONS(1163),
    [anon_sym_mload] = ACTIONS(1163),
    [anon_sym_mcopy] = ACTIONS(1163),
    [anon_sym_tload] = ACTIONS(1163),
    [anon_sym_tstore] = ACTIONS(1163),
    [anon_sym_mstore] = ACTIONS(1163),
    [anon_sym_mstore8] = ACTIONS(1163),
    [anon_sym_sload] = ACTIONS(1163),
    [anon_sym_sstore] = ACTIONS(1163),
    [anon_sym_msize] = ACTIONS(1163),
    [anon_sym_gas] = ACTIONS(1163),
    [anon_sym_address] = ACTIONS(1163),
    [anon_sym_balance] = ACTIONS(1163),
    [anon_sym_selfbalance] = ACTIONS(1163),
    [anon_sym_caller] = ACTIONS(1163),
    [anon_sym_callvalue] = ACTIONS(1163),
    [anon_sym_calldataload] = ACTIONS(1163),
    [anon_sym_calldatasize] = ACTIONS(1163),
    [anon_sym_calldatacopy] = ACTIONS(1163),
    [anon_sym_extcodesize] = ACTIONS(1163),
    [anon_sym_extcodecopy] = ACTIONS(1163),
    [anon_sym_returndatasize] = ACTIONS(1163),
    [anon_sym_returndatacopy] = ACTIONS(1163),
    [anon_sym_extcodehash] = ACTIONS(1163),
    [anon_sym_create] = ACTIONS(1163),
    [anon_sym_create2] = ACTIONS(1163),
    [anon_sym_call] = ACTIONS(1163),
    [anon_sym_callcode] = ACTIONS(1163),
    [anon_sym_delegatecall] = ACTIONS(1163),
    [anon_sym_staticcall] = ACTIONS(1163),
    [anon_sym_return] = ACTIONS(1163),
    [anon_sym_revert] = ACTIONS(1163),
    [anon_sym_selfdestruct] = ACTIONS(1163),
    [anon_sym_invalid] = ACTIONS(1163),
    [anon_sym_log0] = ACTIONS(1163),
    [anon_sym_log1] = ACTIONS(1163),
    [anon_sym_log2] = ACTIONS(1163),
    [anon_sym_log3] = ACTIONS(1163),
    [anon_sym_log4] = ACTIONS(1163),
    [anon_sym_chainid] = ACTIONS(1163),
    [anon_sym_origin] = ACTIONS(1163),
    [anon_sym_gasprice] = ACTIONS(1163),
    [anon_sym_blockhash] = ACTIONS(1163),
    [anon_sym_blobhash] = ACTIONS(1163),
    [anon_sym_basefee] = ACTIONS(1163),
    [anon_sym_blobfee] = ACTIONS(1163),
    [anon_sym_coinbase] = ACTIONS(1163),
    [anon_sym_timestamp] = ACTIONS(1163),
    [anon_sym_number] = ACTIONS(1163),
    [anon_sym_difficulty] = ACTIONS(1163),
    [anon_sym_gaslimit] = ACTIONS(1163),
    [anon_sym_DQUOTE] = ACTIONS(1165),
    [anon_sym_SQUOTE] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_identifier] = ACTIONS(1167),
    [anon_sym_LBRACE] = ACTIONS(1169),
    [anon_sym_RBRACE] = ACTIONS(1169),
    [anon_sym_for] = ACTIONS(1167),
    [sym_yul_leave] = ACTIONS(1167),
    [anon_sym_break] = ACTIONS(1167),
    [anon_sym_continue] = ACTIONS(1167),
    [sym_yul_decimal_number] = ACTIONS(1167),
    [sym_yul_hex_number] = ACTIONS(1169),
    [anon_sym_true] = ACTIONS(1167),
    [anon_sym_false] = ACTIONS(1167),
    [anon_sym_let] = ACTIONS(1167),
    [anon_sym_if] = ACTIONS(1167),
    [anon_sym_switch] = ACTIONS(1167),
    [anon_sym_function] = ACTIONS(1167),
    [anon_sym_stop] = ACTIONS(1167),
    [anon_sym_add] = ACTIONS(1167),
    [anon_sym_sub] = ACTIONS(1167),
    [anon_sym_mul] = ACTIONS(1167),
    [anon_sym_div] = ACTIONS(1167),
    [anon_sym_sdiv] = ACTIONS(1167),
    [anon_sym_mod] = ACTIONS(1167),
    [anon_sym_smod] = ACTIONS(1167),
    [anon_sym_exp] = ACTIONS(1167),
    [anon_sym_not] = ACTIONS(1167),
    [anon_sym_lt] = ACTIONS(1167),
    [anon_sym_gt] = ACTIONS(1167),
    [anon_sym_slt] = ACTIONS(1167),
    [anon_sym_sgt] = ACTIONS(1167),
    [anon_sym_eq] = ACTIONS(1167),
    [anon_sym_iszero] = ACTIONS(1167),
    [anon_sym_and] = ACTIONS(1167),
    [anon_sym_or] = ACTIONS(1167),
    [anon_sym_xor] = ACTIONS(1167),
    [anon_sym_byte] = ACTIONS(1167),
    [anon_sym_shl] = ACTIONS(1167),
    [anon_sym_shr] = ACTIONS(1167),
    [anon_sym_sar] = ACTIONS(1167),
    [anon_sym_addmod] = ACTIONS(1167),
    [anon_sym_mulmod] = ACTIONS(1167),
    [anon_sym_signextend] = ACTIONS(1167),
    [anon_sym_keccak256] = ACTIONS(1167),
    [anon_sym_pop] = ACTIONS(1167),
    [anon_sym_mload] = ACTIONS(1167),
    [anon_sym_mcopy] = ACTIONS(1167),
    [anon_sym_tload] = ACTIONS(1167),
    [anon_sym_tstore] = ACTIONS(1167),
    [anon_sym_mstore] = ACTIONS(1167),
    [anon_sym_mstore8] = ACTIONS(1167),
    [anon_sym_sload] = ACTIONS(1167),
    [anon_sym_sstore] = ACTIONS(1167),
    [anon_sym_msize] = ACTIONS(1167),
    [anon_sym_gas] = ACTIONS(1167),
    [anon_sym_address] = ACTIONS(1167),
    [anon_sym_balance] = ACTIONS(1167),
    [anon_sym_selfbalance] = ACTIONS(1167),
    [anon_sym_caller] = ACTIONS(1167),
    [anon_sym_callvalue] = ACTIONS(1167),
    [anon_sym_calldataload] = ACTIONS(1167),
    [anon_sym_calldatasize] = ACTIONS(1167),
    [anon_sym_calldatacopy] = ACTIONS(1167),
    [anon_sym_extcodesize] = ACTIONS(1167),
    [anon_sym_extcodecopy] = ACTIONS(1167),
    [anon_sym_returndatasize] = ACTIONS(1167),
    [anon_sym_returndatacopy] = ACTIONS(1167),
    [anon_sym_extcodehash] = ACTIONS(1167),
    [anon_sym_create] = ACTIONS(1167),
    [anon_sym_create2] = ACTIONS(1167),
    [anon_sym_call] = ACTIONS(1167),
    [anon_sym_callcode] = ACTIONS(1167),
    [anon_sym_delegatecall] = ACTIONS(1167),
    [anon_sym_staticcall] = ACTIONS(1167),
    [anon_sym_return] = ACTIONS(1167),
    [anon_sym_revert] = ACTIONS(1167),
    [anon_sym_selfdestruct] = ACTIONS(1167),
    [anon_sym_invalid] = ACTIONS(1167),
    [anon_sym_log0] = ACTIONS(1167),
    [anon_sym_log1] = ACTIONS(1167),
    [anon_sym_log2] = ACTIONS(1167),
    [anon_sym_log3] = ACTIONS(1167),
    [anon_sym_log4] = ACTIONS(1167),
    [anon_sym_chainid] = ACTIONS(1167),
    [anon_sym_origin] = ACTIONS(1167),
    [anon_sym_gasprice] = ACTIONS(1167),
    [anon_sym_blockhash] = ACTIONS(1167),
    [anon_sym_blobhash] = ACTIONS(1167),
    [anon_sym_basefee] = ACTIONS(1167),
    [anon_sym_blobfee] = ACTIONS(1167),
    [anon_sym_coinbase] = ACTIONS(1167),
    [anon_sym_timestamp] = ACTIONS(1167),
    [anon_sym_number] = ACTIONS(1167),
    [anon_sym_difficulty] = ACTIONS(1167),
    [anon_sym_gaslimit] = ACTIONS(1167),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_SQUOTE] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_identifier] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_RBRACE] = ACTIONS(1173),
    [anon_sym_for] = ACTIONS(1171),
    [sym_yul_leave] = ACTIONS(1171),
    [anon_sym_break] = ACTIONS(1171),
    [anon_sym_continue] = ACTIONS(1171),
    [sym_yul_decimal_number] = ACTIONS(1171),
    [sym_yul_hex_number] = ACTIONS(1173),
    [anon_sym_true] = ACTIONS(1171),
    [anon_sym_false] = ACTIONS(1171),
    [anon_sym_let] = ACTIONS(1171),
    [anon_sym_if] = ACTIONS(1171),
    [anon_sym_switch] = ACTIONS(1171),
    [anon_sym_function] = ACTIONS(1171),
    [anon_sym_stop] = ACTIONS(1171),
    [anon_sym_add] = ACTIONS(1171),
    [anon_sym_sub] = ACTIONS(1171),
    [anon_sym_mul] = ACTIONS(1171),
    [anon_sym_div] = ACTIONS(1171),
    [anon_sym_sdiv] = ACTIONS(1171),
    [anon_sym_mod] = ACTIONS(1171),
    [anon_sym_smod] = ACTIONS(1171),
    [anon_sym_exp] = ACTIONS(1171),
    [anon_sym_not] = ACTIONS(1171),
    [anon_sym_lt] = ACTIONS(1171),
    [anon_sym_gt] = ACTIONS(1171),
    [anon_sym_slt] = ACTIONS(1171),
    [anon_sym_sgt] = ACTIONS(1171),
    [anon_sym_eq] = ACTIONS(1171),
    [anon_sym_iszero] = ACTIONS(1171),
    [anon_sym_and] = ACTIONS(1171),
    [anon_sym_or] = ACTIONS(1171),
    [anon_sym_xor] = ACTIONS(1171),
    [anon_sym_byte] = ACTIONS(1171),
    [anon_sym_shl] = ACTIONS(1171),
    [anon_sym_shr] = ACTIONS(1171),
    [anon_sym_sar] = ACTIONS(1171),
    [anon_sym_addmod] = ACTIONS(1171),
    [anon_sym_mulmod] = ACTIONS(1171),
    [anon_sym_signextend] = ACTIONS(1171),
    [anon_sym_keccak256] = ACTIONS(1171),
    [anon_sym_pop] = ACTIONS(1171),
    [anon_sym_mload] = ACTIONS(1171),
    [anon_sym_mcopy] = ACTIONS(1171),
    [anon_sym_tload] = ACTIONS(1171),
    [anon_sym_tstore] = ACTIONS(1171),
    [anon_sym_mstore] = ACTIONS(1171),
    [anon_sym_mstore8] = ACTIONS(1171),
    [anon_sym_sload] = ACTIONS(1171),
    [anon_sym_sstore] = ACTIONS(1171),
    [anon_sym_msize] = ACTIONS(1171),
    [anon_sym_gas] = ACTIONS(1171),
    [anon_sym_address] = ACTIONS(1171),
    [anon_sym_balance] = ACTIONS(1171),
    [anon_sym_selfbalance] = ACTIONS(1171),
    [anon_sym_caller] = ACTIONS(1171),
    [anon_sym_callvalue] = ACTIONS(1171),
    [anon_sym_calldataload] = ACTIONS(1171),
    [anon_sym_calldatasize] = ACTIONS(1171),
    [anon_sym_calldatacopy] = ACTIONS(1171),
    [anon_sym_extcodesize] = ACTIONS(1171),
    [anon_sym_extcodecopy] = ACTIONS(1171),
    [anon_sym_returndatasize] = ACTIONS(1171),
    [anon_sym_returndatacopy] = ACTIONS(1171),
    [anon_sym_extcodehash] = ACTIONS(1171),
    [anon_sym_create] = ACTIONS(1171),
    [anon_sym_create2] = ACTIONS(1171),
    [anon_sym_call] = ACTIONS(1171),
    [anon_sym_callcode] = ACTIONS(1171),
    [anon_sym_delegatecall] = ACTIONS(1171),
    [anon_sym_staticcall] = ACTIONS(1171),
    [anon_sym_return] = ACTIONS(1171),
    [anon_sym_revert] = ACTIONS(1171),
    [anon_sym_selfdestruct] = ACTIONS(1171),
    [anon_sym_invalid] = ACTIONS(1171),
    [anon_sym_log0] = ACTIONS(1171),
    [anon_sym_log1] = ACTIONS(1171),
    [anon_sym_log2] = ACTIONS(1171),
    [anon_sym_log3] = ACTIONS(1171),
    [anon_sym_log4] = ACTIONS(1171),
    [anon_sym_chainid] = ACTIONS(1171),
    [anon_sym_origin] = ACTIONS(1171),
    [anon_sym_gasprice] = ACTIONS(1171),
    [anon_sym_blockhash] = ACTIONS(1171),
    [anon_sym_blobhash] = ACTIONS(1171),
    [anon_sym_basefee] = ACTIONS(1171),
    [anon_sym_blobfee] = ACTIONS(1171),
    [anon_sym_coinbase] = ACTIONS(1171),
    [anon_sym_timestamp] = ACTIONS(1171),
    [anon_sym_number] = ACTIONS(1171),
    [anon_sym_difficulty] = ACTIONS(1171),
    [anon_sym_gaslimit] = ACTIONS(1171),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_SQUOTE] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_identifier] = ACTIONS(1175),
    [anon_sym_LBRACE] = ACTIONS(1177),
    [anon_sym_RBRACE] = ACTIONS(1177),
    [anon_sym_for] = ACTIONS(1175),
    [sym_yul_leave] = ACTIONS(1175),
    [anon_sym_break] = ACTIONS(1175),
    [anon_sym_continue] = ACTIONS(1175),
    [sym_yul_decimal_number] = ACTIONS(1175),
    [sym_yul_hex_number] = ACTIONS(1177),
    [anon_sym_true] = ACTIONS(1175),
    [anon_sym_false] = ACTIONS(1175),
    [anon_sym_let] = ACTIONS(1175),
    [anon_sym_if] = ACTIONS(1175),
    [anon_sym_switch] = ACTIONS(1175),
    [anon_sym_function] = ACTIONS(1175),
    [anon_sym_stop] = ACTIONS(1175),
    [anon_sym_add] = ACTIONS(1175),
    [anon_sym_sub] = ACTIONS(1175),
    [anon_sym_mul] = ACTIONS(1175),
    [anon_sym_div] = ACTIONS(1175),
    [anon_sym_sdiv] = ACTIONS(1175),
    [anon_sym_mod] = ACTIONS(1175),
    [anon_sym_smod] = ACTIONS(1175),
    [anon_sym_exp] = ACTIONS(1175),
    [anon_sym_not] = ACTIONS(1175),
    [anon_sym_lt] = ACTIONS(1175),
    [anon_sym_gt] = ACTIONS(1175),
    [anon_sym_slt] = ACTIONS(1175),
    [anon_sym_sgt] = ACTIONS(1175),
    [anon_sym_eq] = ACTIONS(1175),
    [anon_sym_iszero] = ACTIONS(1175),
    [anon_sym_and] = ACTIONS(1175),
    [anon_sym_or] = ACTIONS(1175),
    [anon_sym_xor] = ACTIONS(1175),
    [anon_sym_byte] = ACTIONS(1175),
    [anon_sym_shl] = ACTIONS(1175),
    [anon_sym_shr] = ACTIONS(1175),
    [anon_sym_sar] = ACTIONS(1175),
    [anon_sym_addmod] = ACTIONS(1175),
    [anon_sym_mulmod] = ACTIONS(1175),
    [anon_sym_signextend] = ACTIONS(1175),
    [anon_sym_keccak256] = ACTIONS(1175),
    [anon_sym_pop] = ACTIONS(1175),
    [anon_sym_mload] = ACTIONS(1175),
    [anon_sym_mcopy] = ACTIONS(1175),
    [anon_sym_tload] = ACTIONS(1175),
    [anon_sym_tstore] = ACTIONS(1175),
    [anon_sym_mstore] = ACTIONS(1175),
    [anon_sym_mstore8] = ACTIONS(1175),
    [anon_sym_sload] = ACTIONS(1175),
    [anon_sym_sstore] = ACTIONS(1175),
    [anon_sym_msize] = ACTIONS(1175),
    [anon_sym_gas] = ACTIONS(1175),
    [anon_sym_address] = ACTIONS(1175),
    [anon_sym_balance] = ACTIONS(1175),
    [anon_sym_selfbalance] = ACTIONS(1175),
    [anon_sym_caller] = ACTIONS(1175),
    [anon_sym_callvalue] = ACTIONS(1175),
    [anon_sym_calldataload] = ACTIONS(1175),
    [anon_sym_calldatasize] = ACTIONS(1175),
    [anon_sym_calldatacopy] = ACTIONS(1175),
    [anon_sym_extcodesize] = ACTIONS(1175),
    [anon_sym_extcodecopy] = ACTIONS(1175),
    [anon_sym_returndatasize] = ACTIONS(1175),
    [anon_sym_returndatacopy] = ACTIONS(1175),
    [anon_sym_extcodehash] = ACTIONS(1175),
    [anon_sym_create] = ACTIONS(1175),
    [anon_sym_create2] = ACTIONS(1175),
    [anon_sym_call] = ACTIONS(1175),
    [anon_sym_callcode] = ACTIONS(1175),
    [anon_sym_delegatecall] = ACTIONS(1175),
    [anon_sym_staticcall] = ACTIONS(1175),
    [anon_sym_return] = ACTIONS(1175),
    [anon_sym_revert] = ACTIONS(1175),
    [anon_sym_selfdestruct] = ACTIONS(1175),
    [anon_sym_invalid] = ACTIONS(1175),
    [anon_sym_log0] = ACTIONS(1175),
    [anon_sym_log1] = ACTIONS(1175),
    [anon_sym_log2] = ACTIONS(1175),
    [anon_sym_log3] = ACTIONS(1175),
    [anon_sym_log4] = ACTIONS(1175),
    [anon_sym_chainid] = ACTIONS(1175),
    [anon_sym_origin] = ACTIONS(1175),
    [anon_sym_gasprice] = ACTIONS(1175),
    [anon_sym_blockhash] = ACTIONS(1175),
    [anon_sym_blobhash] = ACTIONS(1175),
    [anon_sym_basefee] = ACTIONS(1175),
    [anon_sym_blobfee] = ACTIONS(1175),
    [anon_sym_coinbase] = ACTIONS(1175),
    [anon_sym_timestamp] = ACTIONS(1175),
    [anon_sym_number] = ACTIONS(1175),
    [anon_sym_difficulty] = ACTIONS(1175),
    [anon_sym_gaslimit] = ACTIONS(1175),
    [anon_sym_DQUOTE] = ACTIONS(1177),
    [anon_sym_SQUOTE] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_identifier] = ACTIONS(1179),
    [anon_sym_LBRACE] = ACTIONS(1181),
    [anon_sym_RBRACE] = ACTIONS(1181),
    [anon_sym_for] = ACTIONS(1179),
    [sym_yul_leave] = ACTIONS(1179),
    [anon_sym_break] = ACTIONS(1179),
    [anon_sym_continue] = ACTIONS(1179),
    [sym_yul_decimal_number] = ACTIONS(1179),
    [sym_yul_hex_number] = ACTIONS(1181),
    [anon_sym_true] = ACTIONS(1179),
    [anon_sym_false] = ACTIONS(1179),
    [anon_sym_let] = ACTIONS(1179),
    [anon_sym_if] = ACTIONS(1179),
    [anon_sym_switch] = ACTIONS(1179),
    [anon_sym_function] = ACTIONS(1179),
    [anon_sym_stop] = ACTIONS(1179),
    [anon_sym_add] = ACTIONS(1179),
    [anon_sym_sub] = ACTIONS(1179),
    [anon_sym_mul] = ACTIONS(1179),
    [anon_sym_div] = ACTIONS(1179),
    [anon_sym_sdiv] = ACTIONS(1179),
    [anon_sym_mod] = ACTIONS(1179),
    [anon_sym_smod] = ACTIONS(1179),
    [anon_sym_exp] = ACTIONS(1179),
    [anon_sym_not] = ACTIONS(1179),
    [anon_sym_lt] = ACTIONS(1179),
    [anon_sym_gt] = ACTIONS(1179),
    [anon_sym_slt] = ACTIONS(1179),
    [anon_sym_sgt] = ACTIONS(1179),
    [anon_sym_eq] = ACTIONS(1179),
    [anon_sym_iszero] = ACTIONS(1179),
    [anon_sym_and] = ACTIONS(1179),
    [anon_sym_or] = ACTIONS(1179),
    [anon_sym_xor] = ACTIONS(1179),
    [anon_sym_byte] = ACTIONS(1179),
    [anon_sym_shl] = ACTIONS(1179),
    [anon_sym_shr] = ACTIONS(1179),
    [anon_sym_sar] = ACTIONS(1179),
    [anon_sym_addmod] = ACTIONS(1179),
    [anon_sym_mulmod] = ACTIONS(1179),
    [anon_sym_signextend] = ACTIONS(1179),
    [anon_sym_keccak256] = ACTIONS(1179),
    [anon_sym_pop] = ACTIONS(1179),
    [anon_sym_mload] = ACTIONS(1179),
    [anon_sym_mcopy] = ACTIONS(1179),
    [anon_sym_tload] = ACTIONS(1179),
    [anon_sym_tstore] = ACTIONS(1179),
    [anon_sym_mstore] = ACTIONS(1179),
    [anon_sym_mstore8] = ACTIONS(1179),
    [anon_sym_sload] = ACTIONS(1179),
    [anon_sym_sstore] = ACTIONS(1179),
    [anon_sym_msize] = ACTIONS(1179),
    [anon_sym_gas] = ACTIONS(1179),
    [anon_sym_address] = ACTIONS(1179),
    [anon_sym_balance] = ACTIONS(1179),
    [anon_sym_selfbalance] = ACTIONS(1179),
    [anon_sym_caller] = ACTIONS(1179),
    [anon_sym_callvalue] = ACTIONS(1179),
    [anon_sym_calldataload] = ACTIONS(1179),
    [anon_sym_calldatasize] = ACTIONS(1179),
    [anon_sym_calldatacopy] = ACTIONS(1179),
    [anon_sym_extcodesize] = ACTIONS(1179),
    [anon_sym_extcodecopy] = ACTIONS(1179),
    [anon_sym_returndatasize] = ACTIONS(1179),
    [anon_sym_returndatacopy] = ACTIONS(1179),
    [anon_sym_extcodehash] = ACTIONS(1179),
    [anon_sym_create] = ACTIONS(1179),
    [anon_sym_create2] = ACTIONS(1179),
    [anon_sym_call] = ACTIONS(1179),
    [anon_sym_callcode] = ACTIONS(1179),
    [anon_sym_delegatecall] = ACTIONS(1179),
    [anon_sym_staticcall] = ACTIONS(1179),
    [anon_sym_return] = ACTIONS(1179),
    [anon_sym_revert] = ACTIONS(1179),
    [anon_sym_selfdestruct] = ACTIONS(1179),
    [anon_sym_invalid] = ACTIONS(1179),
    [anon_sym_log0] = ACTIONS(1179),
    [anon_sym_log1] = ACTIONS(1179),
    [anon_sym_log2] = ACTIONS(1179),
    [anon_sym_log3] = ACTIONS(1179),
    [anon_sym_log4] = ACTIONS(1179),
    [anon_sym_chainid] = ACTIONS(1179),
    [anon_sym_origin] = ACTIONS(1179),
    [anon_sym_gasprice] = ACTIONS(1179),
    [anon_sym_blockhash] = ACTIONS(1179),
    [anon_sym_blobhash] = ACTIONS(1179),
    [anon_sym_basefee] = ACTIONS(1179),
    [anon_sym_blobfee] = ACTIONS(1179),
    [anon_sym_coinbase] = ACTIONS(1179),
    [anon_sym_timestamp] = ACTIONS(1179),
    [anon_sym_number] = ACTIONS(1179),
    [anon_sym_difficulty] = ACTIONS(1179),
    [anon_sym_gaslimit] = ACTIONS(1179),
    [anon_sym_DQUOTE] = ACTIONS(1181),
    [anon_sym_SQUOTE] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_identifier] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1185),
    [anon_sym_RBRACE] = ACTIONS(1185),
    [anon_sym_for] = ACTIONS(1183),
    [sym_yul_leave] = ACTIONS(1183),
    [anon_sym_break] = ACTIONS(1183),
    [anon_sym_continue] = ACTIONS(1183),
    [sym_yul_decimal_number] = ACTIONS(1183),
    [sym_yul_hex_number] = ACTIONS(1185),
    [anon_sym_true] = ACTIONS(1183),
    [anon_sym_false] = ACTIONS(1183),
    [anon_sym_let] = ACTIONS(1183),
    [anon_sym_if] = ACTIONS(1183),
    [anon_sym_switch] = ACTIONS(1183),
    [anon_sym_function] = ACTIONS(1183),
    [anon_sym_stop] = ACTIONS(1183),
    [anon_sym_add] = ACTIONS(1183),
    [anon_sym_sub] = ACTIONS(1183),
    [anon_sym_mul] = ACTIONS(1183),
    [anon_sym_div] = ACTIONS(1183),
    [anon_sym_sdiv] = ACTIONS(1183),
    [anon_sym_mod] = ACTIONS(1183),
    [anon_sym_smod] = ACTIONS(1183),
    [anon_sym_exp] = ACTIONS(1183),
    [anon_sym_not] = ACTIONS(1183),
    [anon_sym_lt] = ACTIONS(1183),
    [anon_sym_gt] = ACTIONS(1183),
    [anon_sym_slt] = ACTIONS(1183),
    [anon_sym_sgt] = ACTIONS(1183),
    [anon_sym_eq] = ACTIONS(1183),
    [anon_sym_iszero] = ACTIONS(1183),
    [anon_sym_and] = ACTIONS(1183),
    [anon_sym_or] = ACTIONS(1183),
    [anon_sym_xor] = ACTIONS(1183),
    [anon_sym_byte] = ACTIONS(1183),
    [anon_sym_shl] = ACTIONS(1183),
    [anon_sym_shr] = ACTIONS(1183),
    [anon_sym_sar] = ACTIONS(1183),
    [anon_sym_addmod] = ACTIONS(1183),
    [anon_sym_mulmod] = ACTIONS(1183),
    [anon_sym_signextend] = ACTIONS(1183),
    [anon_sym_keccak256] = ACTIONS(1183),
    [anon_sym_pop] = ACTIONS(1183),
    [anon_sym_mload] = ACTIONS(1183),
    [anon_sym_mcopy] = ACTIONS(1183),
    [anon_sym_tload] = ACTIONS(1183),
    [anon_sym_tstore] = ACTIONS(1183),
    [anon_sym_mstore] = ACTIONS(1183),
    [anon_sym_mstore8] = ACTIONS(1183),
    [anon_sym_sload] = ACTIONS(1183),
    [anon_sym_sstore] = ACTIONS(1183),
    [anon_sym_msize] = ACTIONS(1183),
    [anon_sym_gas] = ACTIONS(1183),
    [anon_sym_address] = ACTIONS(1183),
    [anon_sym_balance] = ACTIONS(1183),
    [anon_sym_selfbalance] = ACTIONS(1183),
    [anon_sym_caller] = ACTIONS(1183),
    [anon_sym_callvalue] = ACTIONS(1183),
    [anon_sym_calldataload] = ACTIONS(1183),
    [anon_sym_calldatasize] = ACTIONS(1183),
    [anon_sym_calldatacopy] = ACTIONS(1183),
    [anon_sym_extcodesize] = ACTIONS(1183),
    [anon_sym_extcodecopy] = ACTIONS(1183),
    [anon_sym_returndatasize] = ACTIONS(1183),
    [anon_sym_returndatacopy] = ACTIONS(1183),
    [anon_sym_extcodehash] = ACTIONS(1183),
    [anon_sym_create] = ACTIONS(1183),
    [anon_sym_create2] = ACTIONS(1183),
    [anon_sym_call] = ACTIONS(1183),
    [anon_sym_callcode] = ACTIONS(1183),
    [anon_sym_delegatecall] = ACTIONS(1183),
    [anon_sym_staticcall] = ACTIONS(1183),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_revert] = ACTIONS(1183),
    [anon_sym_selfdestruct] = ACTIONS(1183),
    [anon_sym_invalid] = ACTIONS(1183),
    [anon_sym_log0] = ACTIONS(1183),
    [anon_sym_log1] = ACTIONS(1183),
    [anon_sym_log2] = ACTIONS(1183),
    [anon_sym_log3] = ACTIONS(1183),
    [anon_sym_log4] = ACTIONS(1183),
    [anon_sym_chainid] = ACTIONS(1183),
    [anon_sym_origin] = ACTIONS(1183),
    [anon_sym_gasprice] = ACTIONS(1183),
    [anon_sym_blockhash] = ACTIONS(1183),
    [anon_sym_blobhash] = ACTIONS(1183),
    [anon_sym_basefee] = ACTIONS(1183),
    [anon_sym_blobfee] = ACTIONS(1183),
    [anon_sym_coinbase] = ACTIONS(1183),
    [anon_sym_timestamp] = ACTIONS(1183),
    [anon_sym_number] = ACTIONS(1183),
    [anon_sym_difficulty] = ACTIONS(1183),
    [anon_sym_gaslimit] = ACTIONS(1183),
    [anon_sym_DQUOTE] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(710),
    [sym_yul_path] = STATE(710),
    [sym__yul_literal] = STATE(710),
    [sym_yul_string_literal] = STATE(710),
    [sym_yul_boolean] = STATE(710),
    [sym_yul_function_call] = STATE(710),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1187),
    [sym_yul_decimal_number] = ACTIONS(1121),
    [sym_yul_hex_number] = ACTIONS(1123),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_identifier] = ACTIONS(1189),
    [anon_sym_LBRACE] = ACTIONS(1191),
    [anon_sym_RBRACE] = ACTIONS(1191),
    [anon_sym_for] = ACTIONS(1189),
    [sym_yul_leave] = ACTIONS(1189),
    [anon_sym_break] = ACTIONS(1189),
    [anon_sym_continue] = ACTIONS(1189),
    [sym_yul_decimal_number] = ACTIONS(1189),
    [sym_yul_hex_number] = ACTIONS(1191),
    [anon_sym_true] = ACTIONS(1189),
    [anon_sym_false] = ACTIONS(1189),
    [anon_sym_let] = ACTIONS(1189),
    [anon_sym_if] = ACTIONS(1189),
    [anon_sym_switch] = ACTIONS(1189),
    [anon_sym_function] = ACTIONS(1189),
    [anon_sym_stop] = ACTIONS(1189),
    [anon_sym_add] = ACTIONS(1189),
    [anon_sym_sub] = ACTIONS(1189),
    [anon_sym_mul] = ACTIONS(1189),
    [anon_sym_div] = ACTIONS(1189),
    [anon_sym_sdiv] = ACTIONS(1189),
    [anon_sym_mod] = ACTIONS(1189),
    [anon_sym_smod] = ACTIONS(1189),
    [anon_sym_exp] = ACTIONS(1189),
    [anon_sym_not] = ACTIONS(1189),
    [anon_sym_lt] = ACTIONS(1189),
    [anon_sym_gt] = ACTIONS(1189),
    [anon_sym_slt] = ACTIONS(1189),
    [anon_sym_sgt] = ACTIONS(1189),
    [anon_sym_eq] = ACTIONS(1189),
    [anon_sym_iszero] = ACTIONS(1189),
    [anon_sym_and] = ACTIONS(1189),
    [anon_sym_or] = ACTIONS(1189),
    [anon_sym_xor] = ACTIONS(1189),
    [anon_sym_byte] = ACTIONS(1189),
    [anon_sym_shl] = ACTIONS(1189),
    [anon_sym_shr] = ACTIONS(1189),
    [anon_sym_sar] = ACTIONS(1189),
    [anon_sym_addmod] = ACTIONS(1189),
    [anon_sym_mulmod] = ACTIONS(1189),
    [anon_sym_signextend] = ACTIONS(1189),
    [anon_sym_keccak256] = ACTIONS(1189),
    [anon_sym_pop] = ACTIONS(1189),
    [anon_sym_mload] = ACTIONS(1189),
    [anon_sym_mcopy] = ACTIONS(1189),
    [anon_sym_tload] = ACTIONS(1189),
    [anon_sym_tstore] = ACTIONS(1189),
    [anon_sym_mstore] = ACTIONS(1189),
    [anon_sym_mstore8] = ACTIONS(1189),
    [anon_sym_sload] = ACTIONS(1189),
    [anon_sym_sstore] = ACTIONS(1189),
    [anon_sym_msize] = ACTIONS(1189),
    [anon_sym_gas] = ACTIONS(1189),
    [anon_sym_address] = ACTIONS(1189),
    [anon_sym_balance] = ACTIONS(1189),
    [anon_sym_selfbalance] = ACTIONS(1189),
    [anon_sym_caller] = ACTIONS(1189),
    [anon_sym_callvalue] = ACTIONS(1189),
    [anon_sym_calldataload] = ACTIONS(1189),
    [anon_sym_calldatasize] = ACTIONS(1189),
    [anon_sym_calldatacopy] = ACTIONS(1189),
    [anon_sym_extcodesize] = ACTIONS(1189),
    [anon_sym_extcodecopy] = ACTIONS(1189),
    [anon_sym_returndatasize] = ACTIONS(1189),
    [anon_sym_returndatacopy] = ACTIONS(1189),
    [anon_sym_extcodehash] = ACTIONS(1189),
    [anon_sym_create] = ACTIONS(1189),
    [anon_sym_create2] = ACTIONS(1189),
    [anon_sym_call] = ACTIONS(1189),
    [anon_sym_callcode] = ACTIONS(1189),
    [anon_sym_delegatecall] = ACTIONS(1189),
    [anon_sym_staticcall] = ACTIONS(1189),
    [anon_sym_return] = ACTIONS(1189),
    [anon_sym_revert] = ACTIONS(1189),
    [anon_sym_selfdestruct] = ACTIONS(1189),
    [anon_sym_invalid] = ACTIONS(1189),
    [anon_sym_log0] = ACTIONS(1189),
    [anon_sym_log1] = ACTIONS(1189),
    [anon_sym_log2] = ACTIONS(1189),
    [anon_sym_log3] = ACTIONS(1189),
    [anon_sym_log4] = ACTIONS(1189),
    [anon_sym_chainid] = ACTIONS(1189),
    [anon_sym_origin] = ACTIONS(1189),
    [anon_sym_gasprice] = ACTIONS(1189),
    [anon_sym_blockhash] = ACTIONS(1189),
    [anon_sym_blobhash] = ACTIONS(1189),
    [anon_sym_basefee] = ACTIONS(1189),
    [anon_sym_blobfee] = ACTIONS(1189),
    [anon_sym_coinbase] = ACTIONS(1189),
    [anon_sym_timestamp] = ACTIONS(1189),
    [anon_sym_number] = ACTIONS(1189),
    [anon_sym_difficulty] = ACTIONS(1189),
    [anon_sym_gaslimit] = ACTIONS(1189),
    [anon_sym_DQUOTE] = ACTIONS(1191),
    [anon_sym_SQUOTE] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1193),
    [anon_sym_LBRACE] = ACTIONS(1195),
    [anon_sym_RBRACE] = ACTIONS(1195),
    [anon_sym_for] = ACTIONS(1193),
    [sym_yul_leave] = ACTIONS(1193),
    [anon_sym_break] = ACTIONS(1193),
    [anon_sym_continue] = ACTIONS(1193),
    [sym_yul_decimal_number] = ACTIONS(1193),
    [sym_yul_hex_number] = ACTIONS(1195),
    [anon_sym_true] = ACTIONS(1193),
    [anon_sym_false] = ACTIONS(1193),
    [anon_sym_let] = ACTIONS(1193),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_switch] = ACTIONS(1193),
    [anon_sym_function] = ACTIONS(1193),
    [anon_sym_stop] = ACTIONS(1193),
    [anon_sym_add] = ACTIONS(1193),
    [anon_sym_sub] = ACTIONS(1193),
    [anon_sym_mul] = ACTIONS(1193),
    [anon_sym_div] = ACTIONS(1193),
    [anon_sym_sdiv] = ACTIONS(1193),
    [anon_sym_mod] = ACTIONS(1193),
    [anon_sym_smod] = ACTIONS(1193),
    [anon_sym_exp] = ACTIONS(1193),
    [anon_sym_not] = ACTIONS(1193),
    [anon_sym_lt] = ACTIONS(1193),
    [anon_sym_gt] = ACTIONS(1193),
    [anon_sym_slt] = ACTIONS(1193),
    [anon_sym_sgt] = ACTIONS(1193),
    [anon_sym_eq] = ACTIONS(1193),
    [anon_sym_iszero] = ACTIONS(1193),
    [anon_sym_and] = ACTIONS(1193),
    [anon_sym_or] = ACTIONS(1193),
    [anon_sym_xor] = ACTIONS(1193),
    [anon_sym_byte] = ACTIONS(1193),
    [anon_sym_shl] = ACTIONS(1193),
    [anon_sym_shr] = ACTIONS(1193),
    [anon_sym_sar] = ACTIONS(1193),
    [anon_sym_addmod] = ACTIONS(1193),
    [anon_sym_mulmod] = ACTIONS(1193),
    [anon_sym_signextend] = ACTIONS(1193),
    [anon_sym_keccak256] = ACTIONS(1193),
    [anon_sym_pop] = ACTIONS(1193),
    [anon_sym_mload] = ACTIONS(1193),
    [anon_sym_mcopy] = ACTIONS(1193),
    [anon_sym_tload] = ACTIONS(1193),
    [anon_sym_tstore] = ACTIONS(1193),
    [anon_sym_mstore] = ACTIONS(1193),
    [anon_sym_mstore8] = ACTIONS(1193),
    [anon_sym_sload] = ACTIONS(1193),
    [anon_sym_sstore] = ACTIONS(1193),
    [anon_sym_msize] = ACTIONS(1193),
    [anon_sym_gas] = ACTIONS(1193),
    [anon_sym_address] = ACTIONS(1193),
    [anon_sym_balance] = ACTIONS(1193),
    [anon_sym_selfbalance] = ACTIONS(1193),
    [anon_sym_caller] = ACTIONS(1193),
    [anon_sym_callvalue] = ACTIONS(1193),
    [anon_sym_calldataload] = ACTIONS(1193),
    [anon_sym_calldatasize] = ACTIONS(1193),
    [anon_sym_calldatacopy] = ACTIONS(1193),
    [anon_sym_extcodesize] = ACTIONS(1193),
    [anon_sym_extcodecopy] = ACTIONS(1193),
    [anon_sym_returndatasize] = ACTIONS(1193),
    [anon_sym_returndatacopy] = ACTIONS(1193),
    [anon_sym_extcodehash] = ACTIONS(1193),
    [anon_sym_create] = ACTIONS(1193),
    [anon_sym_create2] = ACTIONS(1193),
    [anon_sym_call] = ACTIONS(1193),
    [anon_sym_callcode] = ACTIONS(1193),
    [anon_sym_delegatecall] = ACTIONS(1193),
    [anon_sym_staticcall] = ACTIONS(1193),
    [anon_sym_return] = ACTIONS(1193),
    [anon_sym_revert] = ACTIONS(1193),
    [anon_sym_selfdestruct] = ACTIONS(1193),
    [anon_sym_invalid] = ACTIONS(1193),
    [anon_sym_log0] = ACTIONS(1193),
    [anon_sym_log1] = ACTIONS(1193),
    [anon_sym_log2] = ACTIONS(1193),
    [anon_sym_log3] = ACTIONS(1193),
    [anon_sym_log4] = ACTIONS(1193),
    [anon_sym_chainid] = ACTIONS(1193),
    [anon_sym_origin] = ACTIONS(1193),
    [anon_sym_gasprice] = ACTIONS(1193),
    [anon_sym_blockhash] = ACTIONS(1193),
    [anon_sym_blobhash] = ACTIONS(1193),
    [anon_sym_basefee] = ACTIONS(1193),
    [anon_sym_blobfee] = ACTIONS(1193),
    [anon_sym_coinbase] = ACTIONS(1193),
    [anon_sym_timestamp] = ACTIONS(1193),
    [anon_sym_number] = ACTIONS(1193),
    [anon_sym_difficulty] = ACTIONS(1193),
    [anon_sym_gaslimit] = ACTIONS(1193),
    [anon_sym_DQUOTE] = ACTIONS(1195),
    [anon_sym_SQUOTE] = ACTIONS(1195),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_identifier] = ACTIONS(1197),
    [anon_sym_LBRACE] = ACTIONS(1199),
    [anon_sym_RBRACE] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1197),
    [sym_yul_leave] = ACTIONS(1197),
    [anon_sym_break] = ACTIONS(1197),
    [anon_sym_continue] = ACTIONS(1197),
    [sym_yul_decimal_number] = ACTIONS(1197),
    [sym_yul_hex_number] = ACTIONS(1199),
    [anon_sym_true] = ACTIONS(1197),
    [anon_sym_false] = ACTIONS(1197),
    [anon_sym_let] = ACTIONS(1197),
    [anon_sym_if] = ACTIONS(1197),
    [anon_sym_switch] = ACTIONS(1197),
    [anon_sym_function] = ACTIONS(1197),
    [anon_sym_stop] = ACTIONS(1197),
    [anon_sym_add] = ACTIONS(1197),
    [anon_sym_sub] = ACTIONS(1197),
    [anon_sym_mul] = ACTIONS(1197),
    [anon_sym_div] = ACTIONS(1197),
    [anon_sym_sdiv] = ACTIONS(1197),
    [anon_sym_mod] = ACTIONS(1197),
    [anon_sym_smod] = ACTIONS(1197),
    [anon_sym_exp] = ACTIONS(1197),
    [anon_sym_not] = ACTIONS(1197),
    [anon_sym_lt] = ACTIONS(1197),
    [anon_sym_gt] = ACTIONS(1197),
    [anon_sym_slt] = ACTIONS(1197),
    [anon_sym_sgt] = ACTIONS(1197),
    [anon_sym_eq] = ACTIONS(1197),
    [anon_sym_iszero] = ACTIONS(1197),
    [anon_sym_and] = ACTIONS(1197),
    [anon_sym_or] = ACTIONS(1197),
    [anon_sym_xor] = ACTIONS(1197),
    [anon_sym_byte] = ACTIONS(1197),
    [anon_sym_shl] = ACTIONS(1197),
    [anon_sym_shr] = ACTIONS(1197),
    [anon_sym_sar] = ACTIONS(1197),
    [anon_sym_addmod] = ACTIONS(1197),
    [anon_sym_mulmod] = ACTIONS(1197),
    [anon_sym_signextend] = ACTIONS(1197),
    [anon_sym_keccak256] = ACTIONS(1197),
    [anon_sym_pop] = ACTIONS(1197),
    [anon_sym_mload] = ACTIONS(1197),
    [anon_sym_mcopy] = ACTIONS(1197),
    [anon_sym_tload] = ACTIONS(1197),
    [anon_sym_tstore] = ACTIONS(1197),
    [anon_sym_mstore] = ACTIONS(1197),
    [anon_sym_mstore8] = ACTIONS(1197),
    [anon_sym_sload] = ACTIONS(1197),
    [anon_sym_sstore] = ACTIONS(1197),
    [anon_sym_msize] = ACTIONS(1197),
    [anon_sym_gas] = ACTIONS(1197),
    [anon_sym_address] = ACTIONS(1197),
    [anon_sym_balance] = ACTIONS(1197),
    [anon_sym_selfbalance] = ACTIONS(1197),
    [anon_sym_caller] = ACTIONS(1197),
    [anon_sym_callvalue] = ACTIONS(1197),
    [anon_sym_calldataload] = ACTIONS(1197),
    [anon_sym_calldatasize] = ACTIONS(1197),
    [anon_sym_calldatacopy] = ACTIONS(1197),
    [anon_sym_extcodesize] = ACTIONS(1197),
    [anon_sym_extcodecopy] = ACTIONS(1197),
    [anon_sym_returndatasize] = ACTIONS(1197),
    [anon_sym_returndatacopy] = ACTIONS(1197),
    [anon_sym_extcodehash] = ACTIONS(1197),
    [anon_sym_create] = ACTIONS(1197),
    [anon_sym_create2] = ACTIONS(1197),
    [anon_sym_call] = ACTIONS(1197),
    [anon_sym_callcode] = ACTIONS(1197),
    [anon_sym_delegatecall] = ACTIONS(1197),
    [anon_sym_staticcall] = ACTIONS(1197),
    [anon_sym_return] = ACTIONS(1197),
    [anon_sym_revert] = ACTIONS(1197),
    [anon_sym_selfdestruct] = ACTIONS(1197),
    [anon_sym_invalid] = ACTIONS(1197),
    [anon_sym_log0] = ACTIONS(1197),
    [anon_sym_log1] = ACTIONS(1197),
    [anon_sym_log2] = ACTIONS(1197),
    [anon_sym_log3] = ACTIONS(1197),
    [anon_sym_log4] = ACTIONS(1197),
    [anon_sym_chainid] = ACTIONS(1197),
    [anon_sym_origin] = ACTIONS(1197),
    [anon_sym_gasprice] = ACTIONS(1197),
    [anon_sym_blockhash] = ACTIONS(1197),
    [anon_sym_blobhash] = ACTIONS(1197),
    [anon_sym_basefee] = ACTIONS(1197),
    [anon_sym_blobfee] = ACTIONS(1197),
    [anon_sym_coinbase] = ACTIONS(1197),
    [anon_sym_timestamp] = ACTIONS(1197),
    [anon_sym_number] = ACTIONS(1197),
    [anon_sym_difficulty] = ACTIONS(1197),
    [anon_sym_gaslimit] = ACTIONS(1197),
    [anon_sym_DQUOTE] = ACTIONS(1199),
    [anon_sym_SQUOTE] = ACTIONS(1199),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_identifier] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1203),
    [anon_sym_RBRACE] = ACTIONS(1203),
    [anon_sym_for] = ACTIONS(1201),
    [sym_yul_leave] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1201),
    [anon_sym_continue] = ACTIONS(1201),
    [sym_yul_decimal_number] = ACTIONS(1201),
    [sym_yul_hex_number] = ACTIONS(1203),
    [anon_sym_true] = ACTIONS(1201),
    [anon_sym_false] = ACTIONS(1201),
    [anon_sym_let] = ACTIONS(1201),
    [anon_sym_if] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1201),
    [anon_sym_stop] = ACTIONS(1201),
    [anon_sym_add] = ACTIONS(1201),
    [anon_sym_sub] = ACTIONS(1201),
    [anon_sym_mul] = ACTIONS(1201),
    [anon_sym_div] = ACTIONS(1201),
    [anon_sym_sdiv] = ACTIONS(1201),
    [anon_sym_mod] = ACTIONS(1201),
    [anon_sym_smod] = ACTIONS(1201),
    [anon_sym_exp] = ACTIONS(1201),
    [anon_sym_not] = ACTIONS(1201),
    [anon_sym_lt] = ACTIONS(1201),
    [anon_sym_gt] = ACTIONS(1201),
    [anon_sym_slt] = ACTIONS(1201),
    [anon_sym_sgt] = ACTIONS(1201),
    [anon_sym_eq] = ACTIONS(1201),
    [anon_sym_iszero] = ACTIONS(1201),
    [anon_sym_and] = ACTIONS(1201),
    [anon_sym_or] = ACTIONS(1201),
    [anon_sym_xor] = ACTIONS(1201),
    [anon_sym_byte] = ACTIONS(1201),
    [anon_sym_shl] = ACTIONS(1201),
    [anon_sym_shr] = ACTIONS(1201),
    [anon_sym_sar] = ACTIONS(1201),
    [anon_sym_addmod] = ACTIONS(1201),
    [anon_sym_mulmod] = ACTIONS(1201),
    [anon_sym_signextend] = ACTIONS(1201),
    [anon_sym_keccak256] = ACTIONS(1201),
    [anon_sym_pop] = ACTIONS(1201),
    [anon_sym_mload] = ACTIONS(1201),
    [anon_sym_mcopy] = ACTIONS(1201),
    [anon_sym_tload] = ACTIONS(1201),
    [anon_sym_tstore] = ACTIONS(1201),
    [anon_sym_mstore] = ACTIONS(1201),
    [anon_sym_mstore8] = ACTIONS(1201),
    [anon_sym_sload] = ACTIONS(1201),
    [anon_sym_sstore] = ACTIONS(1201),
    [anon_sym_msize] = ACTIONS(1201),
    [anon_sym_gas] = ACTIONS(1201),
    [anon_sym_address] = ACTIONS(1201),
    [anon_sym_balance] = ACTIONS(1201),
    [anon_sym_selfbalance] = ACTIONS(1201),
    [anon_sym_caller] = ACTIONS(1201),
    [anon_sym_callvalue] = ACTIONS(1201),
    [anon_sym_calldataload] = ACTIONS(1201),
    [anon_sym_calldatasize] = ACTIONS(1201),
    [anon_sym_calldatacopy] = ACTIONS(1201),
    [anon_sym_extcodesize] = ACTIONS(1201),
    [anon_sym_extcodecopy] = ACTIONS(1201),
    [anon_sym_returndatasize] = ACTIONS(1201),
    [anon_sym_returndatacopy] = ACTIONS(1201),
    [anon_sym_extcodehash] = ACTIONS(1201),
    [anon_sym_create] = ACTIONS(1201),
    [anon_sym_create2] = ACTIONS(1201),
    [anon_sym_call] = ACTIONS(1201),
    [anon_sym_callcode] = ACTIONS(1201),
    [anon_sym_delegatecall] = ACTIONS(1201),
    [anon_sym_staticcall] = ACTIONS(1201),
    [anon_sym_return] = ACTIONS(1201),
    [anon_sym_revert] = ACTIONS(1201),
    [anon_sym_selfdestruct] = ACTIONS(1201),
    [anon_sym_invalid] = ACTIONS(1201),
    [anon_sym_log0] = ACTIONS(1201),
    [anon_sym_log1] = ACTIONS(1201),
    [anon_sym_log2] = ACTIONS(1201),
    [anon_sym_log3] = ACTIONS(1201),
    [anon_sym_log4] = ACTIONS(1201),
    [anon_sym_chainid] = ACTIONS(1201),
    [anon_sym_origin] = ACTIONS(1201),
    [anon_sym_gasprice] = ACTIONS(1201),
    [anon_sym_blockhash] = ACTIONS(1201),
    [anon_sym_blobhash] = ACTIONS(1201),
    [anon_sym_basefee] = ACTIONS(1201),
    [anon_sym_blobfee] = ACTIONS(1201),
    [anon_sym_coinbase] = ACTIONS(1201),
    [anon_sym_timestamp] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1201),
    [anon_sym_difficulty] = ACTIONS(1201),
    [anon_sym_gaslimit] = ACTIONS(1201),
    [anon_sym_DQUOTE] = ACTIONS(1203),
    [anon_sym_SQUOTE] = ACTIONS(1203),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1205),
    [sym_yul_leave] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [sym_yul_decimal_number] = ACTIONS(1205),
    [sym_yul_hex_number] = ACTIONS(1207),
    [anon_sym_true] = ACTIONS(1205),
    [anon_sym_false] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_stop] = ACTIONS(1205),
    [anon_sym_add] = ACTIONS(1205),
    [anon_sym_sub] = ACTIONS(1205),
    [anon_sym_mul] = ACTIONS(1205),
    [anon_sym_div] = ACTIONS(1205),
    [anon_sym_sdiv] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_smod] = ACTIONS(1205),
    [anon_sym_exp] = ACTIONS(1205),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_lt] = ACTIONS(1205),
    [anon_sym_gt] = ACTIONS(1205),
    [anon_sym_slt] = ACTIONS(1205),
    [anon_sym_sgt] = ACTIONS(1205),
    [anon_sym_eq] = ACTIONS(1205),
    [anon_sym_iszero] = ACTIONS(1205),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_xor] = ACTIONS(1205),
    [anon_sym_byte] = ACTIONS(1205),
    [anon_sym_shl] = ACTIONS(1205),
    [anon_sym_shr] = ACTIONS(1205),
    [anon_sym_sar] = ACTIONS(1205),
    [anon_sym_addmod] = ACTIONS(1205),
    [anon_sym_mulmod] = ACTIONS(1205),
    [anon_sym_signextend] = ACTIONS(1205),
    [anon_sym_keccak256] = ACTIONS(1205),
    [anon_sym_pop] = ACTIONS(1205),
    [anon_sym_mload] = ACTIONS(1205),
    [anon_sym_mcopy] = ACTIONS(1205),
    [anon_sym_tload] = ACTIONS(1205),
    [anon_sym_tstore] = ACTIONS(1205),
    [anon_sym_mstore] = ACTIONS(1205),
    [anon_sym_mstore8] = ACTIONS(1205),
    [anon_sym_sload] = ACTIONS(1205),
    [anon_sym_sstore] = ACTIONS(1205),
    [anon_sym_msize] = ACTIONS(1205),
    [anon_sym_gas] = ACTIONS(1205),
    [anon_sym_address] = ACTIONS(1205),
    [anon_sym_balance] = ACTIONS(1205),
    [anon_sym_selfbalance] = ACTIONS(1205),
    [anon_sym_caller] = ACTIONS(1205),
    [anon_sym_callvalue] = ACTIONS(1205),
    [anon_sym_calldataload] = ACTIONS(1205),
    [anon_sym_calldatasize] = ACTIONS(1205),
    [anon_sym_calldatacopy] = ACTIONS(1205),
    [anon_sym_extcodesize] = ACTIONS(1205),
    [anon_sym_extcodecopy] = ACTIONS(1205),
    [anon_sym_returndatasize] = ACTIONS(1205),
    [anon_sym_returndatacopy] = ACTIONS(1205),
    [anon_sym_extcodehash] = ACTIONS(1205),
    [anon_sym_create] = ACTIONS(1205),
    [anon_sym_create2] = ACTIONS(1205),
    [anon_sym_call] = ACTIONS(1205),
    [anon_sym_callcode] = ACTIONS(1205),
    [anon_sym_delegatecall] = ACTIONS(1205),
    [anon_sym_staticcall] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_revert] = ACTIONS(1205),
    [anon_sym_selfdestruct] = ACTIONS(1205),
    [anon_sym_invalid] = ACTIONS(1205),
    [anon_sym_log0] = ACTIONS(1205),
    [anon_sym_log1] = ACTIONS(1205),
    [anon_sym_log2] = ACTIONS(1205),
    [anon_sym_log3] = ACTIONS(1205),
    [anon_sym_log4] = ACTIONS(1205),
    [anon_sym_chainid] = ACTIONS(1205),
    [anon_sym_origin] = ACTIONS(1205),
    [anon_sym_gasprice] = ACTIONS(1205),
    [anon_sym_blockhash] = ACTIONS(1205),
    [anon_sym_blobhash] = ACTIONS(1205),
    [anon_sym_basefee] = ACTIONS(1205),
    [anon_sym_blobfee] = ACTIONS(1205),
    [anon_sym_coinbase] = ACTIONS(1205),
    [anon_sym_timestamp] = ACTIONS(1205),
    [anon_sym_number] = ACTIONS(1205),
    [anon_sym_difficulty] = ACTIONS(1205),
    [anon_sym_gaslimit] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_identifier] = ACTIONS(1209),
    [anon_sym_LBRACE] = ACTIONS(1211),
    [anon_sym_RBRACE] = ACTIONS(1211),
    [anon_sym_for] = ACTIONS(1209),
    [sym_yul_leave] = ACTIONS(1209),
    [anon_sym_break] = ACTIONS(1209),
    [anon_sym_continue] = ACTIONS(1209),
    [sym_yul_decimal_number] = ACTIONS(1209),
    [sym_yul_hex_number] = ACTIONS(1211),
    [anon_sym_true] = ACTIONS(1209),
    [anon_sym_false] = ACTIONS(1209),
    [anon_sym_let] = ACTIONS(1209),
    [anon_sym_if] = ACTIONS(1209),
    [anon_sym_switch] = ACTIONS(1209),
    [anon_sym_function] = ACTIONS(1209),
    [anon_sym_stop] = ACTIONS(1209),
    [anon_sym_add] = ACTIONS(1209),
    [anon_sym_sub] = ACTIONS(1209),
    [anon_sym_mul] = ACTIONS(1209),
    [anon_sym_div] = ACTIONS(1209),
    [anon_sym_sdiv] = ACTIONS(1209),
    [anon_sym_mod] = ACTIONS(1209),
    [anon_sym_smod] = ACTIONS(1209),
    [anon_sym_exp] = ACTIONS(1209),
    [anon_sym_not] = ACTIONS(1209),
    [anon_sym_lt] = ACTIONS(1209),
    [anon_sym_gt] = ACTIONS(1209),
    [anon_sym_slt] = ACTIONS(1209),
    [anon_sym_sgt] = ACTIONS(1209),
    [anon_sym_eq] = ACTIONS(1209),
    [anon_sym_iszero] = ACTIONS(1209),
    [anon_sym_and] = ACTIONS(1209),
    [anon_sym_or] = ACTIONS(1209),
    [anon_sym_xor] = ACTIONS(1209),
    [anon_sym_byte] = ACTIONS(1209),
    [anon_sym_shl] = ACTIONS(1209),
    [anon_sym_shr] = ACTIONS(1209),
    [anon_sym_sar] = ACTIONS(1209),
    [anon_sym_addmod] = ACTIONS(1209),
    [anon_sym_mulmod] = ACTIONS(1209),
    [anon_sym_signextend] = ACTIONS(1209),
    [anon_sym_keccak256] = ACTIONS(1209),
    [anon_sym_pop] = ACTIONS(1209),
    [anon_sym_mload] = ACTIONS(1209),
    [anon_sym_mcopy] = ACTIONS(1209),
    [anon_sym_tload] = ACTIONS(1209),
    [anon_sym_tstore] = ACTIONS(1209),
    [anon_sym_mstore] = ACTIONS(1209),
    [anon_sym_mstore8] = ACTIONS(1209),
    [anon_sym_sload] = ACTIONS(1209),
    [anon_sym_sstore] = ACTIONS(1209),
    [anon_sym_msize] = ACTIONS(1209),
    [anon_sym_gas] = ACTIONS(1209),
    [anon_sym_address] = ACTIONS(1209),
    [anon_sym_balance] = ACTIONS(1209),
    [anon_sym_selfbalance] = ACTIONS(1209),
    [anon_sym_caller] = ACTIONS(1209),
    [anon_sym_callvalue] = ACTIONS(1209),
    [anon_sym_calldataload] = ACTIONS(1209),
    [anon_sym_calldatasize] = ACTIONS(1209),
    [anon_sym_calldatacopy] = ACTIONS(1209),
    [anon_sym_extcodesize] = ACTIONS(1209),
    [anon_sym_extcodecopy] = ACTIONS(1209),
    [anon_sym_returndatasize] = ACTIONS(1209),
    [anon_sym_returndatacopy] = ACTIONS(1209),
    [anon_sym_extcodehash] = ACTIONS(1209),
    [anon_sym_create] = ACTIONS(1209),
    [anon_sym_create2] = ACTIONS(1209),
    [anon_sym_call] = ACTIONS(1209),
    [anon_sym_callcode] = ACTIONS(1209),
    [anon_sym_delegatecall] = ACTIONS(1209),
    [anon_sym_staticcall] = ACTIONS(1209),
    [anon_sym_return] = ACTIONS(1209),
    [anon_sym_revert] = ACTIONS(1209),
    [anon_sym_selfdestruct] = ACTIONS(1209),
    [anon_sym_invalid] = ACTIONS(1209),
    [anon_sym_log0] = ACTIONS(1209),
    [anon_sym_log1] = ACTIONS(1209),
    [anon_sym_log2] = ACTIONS(1209),
    [anon_sym_log3] = ACTIONS(1209),
    [anon_sym_log4] = ACTIONS(1209),
    [anon_sym_chainid] = ACTIONS(1209),
    [anon_sym_origin] = ACTIONS(1209),
    [anon_sym_gasprice] = ACTIONS(1209),
    [anon_sym_blockhash] = ACTIONS(1209),
    [anon_sym_blobhash] = ACTIONS(1209),
    [anon_sym_basefee] = ACTIONS(1209),
    [anon_sym_blobfee] = ACTIONS(1209),
    [anon_sym_coinbase] = ACTIONS(1209),
    [anon_sym_timestamp] = ACTIONS(1209),
    [anon_sym_number] = ACTIONS(1209),
    [anon_sym_difficulty] = ACTIONS(1209),
    [anon_sym_gaslimit] = ACTIONS(1209),
    [anon_sym_DQUOTE] = ACTIONS(1211),
    [anon_sym_SQUOTE] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [sym_identifier] = ACTIONS(1205),
    [anon_sym_LBRACE] = ACTIONS(1207),
    [anon_sym_RBRACE] = ACTIONS(1207),
    [anon_sym_for] = ACTIONS(1205),
    [sym_yul_leave] = ACTIONS(1205),
    [anon_sym_break] = ACTIONS(1205),
    [anon_sym_continue] = ACTIONS(1205),
    [sym_yul_decimal_number] = ACTIONS(1205),
    [sym_yul_hex_number] = ACTIONS(1207),
    [anon_sym_true] = ACTIONS(1205),
    [anon_sym_false] = ACTIONS(1205),
    [anon_sym_let] = ACTIONS(1205),
    [anon_sym_if] = ACTIONS(1205),
    [anon_sym_switch] = ACTIONS(1205),
    [anon_sym_function] = ACTIONS(1205),
    [anon_sym_stop] = ACTIONS(1205),
    [anon_sym_add] = ACTIONS(1205),
    [anon_sym_sub] = ACTIONS(1205),
    [anon_sym_mul] = ACTIONS(1205),
    [anon_sym_div] = ACTIONS(1205),
    [anon_sym_sdiv] = ACTIONS(1205),
    [anon_sym_mod] = ACTIONS(1205),
    [anon_sym_smod] = ACTIONS(1205),
    [anon_sym_exp] = ACTIONS(1205),
    [anon_sym_not] = ACTIONS(1205),
    [anon_sym_lt] = ACTIONS(1205),
    [anon_sym_gt] = ACTIONS(1205),
    [anon_sym_slt] = ACTIONS(1205),
    [anon_sym_sgt] = ACTIONS(1205),
    [anon_sym_eq] = ACTIONS(1205),
    [anon_sym_iszero] = ACTIONS(1205),
    [anon_sym_and] = ACTIONS(1205),
    [anon_sym_or] = ACTIONS(1205),
    [anon_sym_xor] = ACTIONS(1205),
    [anon_sym_byte] = ACTIONS(1205),
    [anon_sym_shl] = ACTIONS(1205),
    [anon_sym_shr] = ACTIONS(1205),
    [anon_sym_sar] = ACTIONS(1205),
    [anon_sym_addmod] = ACTIONS(1205),
    [anon_sym_mulmod] = ACTIONS(1205),
    [anon_sym_signextend] = ACTIONS(1205),
    [anon_sym_keccak256] = ACTIONS(1205),
    [anon_sym_pop] = ACTIONS(1205),
    [anon_sym_mload] = ACTIONS(1205),
    [anon_sym_mcopy] = ACTIONS(1205),
    [anon_sym_tload] = ACTIONS(1205),
    [anon_sym_tstore] = ACTIONS(1205),
    [anon_sym_mstore] = ACTIONS(1205),
    [anon_sym_mstore8] = ACTIONS(1205),
    [anon_sym_sload] = ACTIONS(1205),
    [anon_sym_sstore] = ACTIONS(1205),
    [anon_sym_msize] = ACTIONS(1205),
    [anon_sym_gas] = ACTIONS(1205),
    [anon_sym_address] = ACTIONS(1205),
    [anon_sym_balance] = ACTIONS(1205),
    [anon_sym_selfbalance] = ACTIONS(1205),
    [anon_sym_caller] = ACTIONS(1205),
    [anon_sym_callvalue] = ACTIONS(1205),
    [anon_sym_calldataload] = ACTIONS(1205),
    [anon_sym_calldatasize] = ACTIONS(1205),
    [anon_sym_calldatacopy] = ACTIONS(1205),
    [anon_sym_extcodesize] = ACTIONS(1205),
    [anon_sym_extcodecopy] = ACTIONS(1205),
    [anon_sym_returndatasize] = ACTIONS(1205),
    [anon_sym_returndatacopy] = ACTIONS(1205),
    [anon_sym_extcodehash] = ACTIONS(1205),
    [anon_sym_create] = ACTIONS(1205),
    [anon_sym_create2] = ACTIONS(1205),
    [anon_sym_call] = ACTIONS(1205),
    [anon_sym_callcode] = ACTIONS(1205),
    [anon_sym_delegatecall] = ACTIONS(1205),
    [anon_sym_staticcall] = ACTIONS(1205),
    [anon_sym_return] = ACTIONS(1205),
    [anon_sym_revert] = ACTIONS(1205),
    [anon_sym_selfdestruct] = ACTIONS(1205),
    [anon_sym_invalid] = ACTIONS(1205),
    [anon_sym_log0] = ACTIONS(1205),
    [anon_sym_log1] = ACTIONS(1205),
    [anon_sym_log2] = ACTIONS(1205),
    [anon_sym_log3] = ACTIONS(1205),
    [anon_sym_log4] = ACTIONS(1205),
    [anon_sym_chainid] = ACTIONS(1205),
    [anon_sym_origin] = ACTIONS(1205),
    [anon_sym_gasprice] = ACTIONS(1205),
    [anon_sym_blockhash] = ACTIONS(1205),
    [anon_sym_blobhash] = ACTIONS(1205),
    [anon_sym_basefee] = ACTIONS(1205),
    [anon_sym_blobfee] = ACTIONS(1205),
    [anon_sym_coinbase] = ACTIONS(1205),
    [anon_sym_timestamp] = ACTIONS(1205),
    [anon_sym_number] = ACTIONS(1205),
    [anon_sym_difficulty] = ACTIONS(1205),
    [anon_sym_gaslimit] = ACTIONS(1205),
    [anon_sym_DQUOTE] = ACTIONS(1207),
    [anon_sym_SQUOTE] = ACTIONS(1207),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_identifier] = ACTIONS(1213),
    [anon_sym_LBRACE] = ACTIONS(1215),
    [anon_sym_RBRACE] = ACTIONS(1215),
    [anon_sym_for] = ACTIONS(1213),
    [sym_yul_leave] = ACTIONS(1213),
    [anon_sym_break] = ACTIONS(1213),
    [anon_sym_continue] = ACTIONS(1213),
    [sym_yul_decimal_number] = ACTIONS(1213),
    [sym_yul_hex_number] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1213),
    [anon_sym_false] = ACTIONS(1213),
    [anon_sym_let] = ACTIONS(1213),
    [anon_sym_if] = ACTIONS(1213),
    [anon_sym_switch] = ACTIONS(1213),
    [anon_sym_function] = ACTIONS(1213),
    [anon_sym_stop] = ACTIONS(1213),
    [anon_sym_add] = ACTIONS(1213),
    [anon_sym_sub] = ACTIONS(1213),
    [anon_sym_mul] = ACTIONS(1213),
    [anon_sym_div] = ACTIONS(1213),
    [anon_sym_sdiv] = ACTIONS(1213),
    [anon_sym_mod] = ACTIONS(1213),
    [anon_sym_smod] = ACTIONS(1213),
    [anon_sym_exp] = ACTIONS(1213),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_lt] = ACTIONS(1213),
    [anon_sym_gt] = ACTIONS(1213),
    [anon_sym_slt] = ACTIONS(1213),
    [anon_sym_sgt] = ACTIONS(1213),
    [anon_sym_eq] = ACTIONS(1213),
    [anon_sym_iszero] = ACTIONS(1213),
    [anon_sym_and] = ACTIONS(1213),
    [anon_sym_or] = ACTIONS(1213),
    [anon_sym_xor] = ACTIONS(1213),
    [anon_sym_byte] = ACTIONS(1213),
    [anon_sym_shl] = ACTIONS(1213),
    [anon_sym_shr] = ACTIONS(1213),
    [anon_sym_sar] = ACTIONS(1213),
    [anon_sym_addmod] = ACTIONS(1213),
    [anon_sym_mulmod] = ACTIONS(1213),
    [anon_sym_signextend] = ACTIONS(1213),
    [anon_sym_keccak256] = ACTIONS(1213),
    [anon_sym_pop] = ACTIONS(1213),
    [anon_sym_mload] = ACTIONS(1213),
    [anon_sym_mcopy] = ACTIONS(1213),
    [anon_sym_tload] = ACTIONS(1213),
    [anon_sym_tstore] = ACTIONS(1213),
    [anon_sym_mstore] = ACTIONS(1213),
    [anon_sym_mstore8] = ACTIONS(1213),
    [anon_sym_sload] = ACTIONS(1213),
    [anon_sym_sstore] = ACTIONS(1213),
    [anon_sym_msize] = ACTIONS(1213),
    [anon_sym_gas] = ACTIONS(1213),
    [anon_sym_address] = ACTIONS(1213),
    [anon_sym_balance] = ACTIONS(1213),
    [anon_sym_selfbalance] = ACTIONS(1213),
    [anon_sym_caller] = ACTIONS(1213),
    [anon_sym_callvalue] = ACTIONS(1213),
    [anon_sym_calldataload] = ACTIONS(1213),
    [anon_sym_calldatasize] = ACTIONS(1213),
    [anon_sym_calldatacopy] = ACTIONS(1213),
    [anon_sym_extcodesize] = ACTIONS(1213),
    [anon_sym_extcodecopy] = ACTIONS(1213),
    [anon_sym_returndatasize] = ACTIONS(1213),
    [anon_sym_returndatacopy] = ACTIONS(1213),
    [anon_sym_extcodehash] = ACTIONS(1213),
    [anon_sym_create] = ACTIONS(1213),
    [anon_sym_create2] = ACTIONS(1213),
    [anon_sym_call] = ACTIONS(1213),
    [anon_sym_callcode] = ACTIONS(1213),
    [anon_sym_delegatecall] = ACTIONS(1213),
    [anon_sym_staticcall] = ACTIONS(1213),
    [anon_sym_return] = ACTIONS(1213),
    [anon_sym_revert] = ACTIONS(1213),
    [anon_sym_selfdestruct] = ACTIONS(1213),
    [anon_sym_invalid] = ACTIONS(1213),
    [anon_sym_log0] = ACTIONS(1213),
    [anon_sym_log1] = ACTIONS(1213),
    [anon_sym_log2] = ACTIONS(1213),
    [anon_sym_log3] = ACTIONS(1213),
    [anon_sym_log4] = ACTIONS(1213),
    [anon_sym_chainid] = ACTIONS(1213),
    [anon_sym_origin] = ACTIONS(1213),
    [anon_sym_gasprice] = ACTIONS(1213),
    [anon_sym_blockhash] = ACTIONS(1213),
    [anon_sym_blobhash] = ACTIONS(1213),
    [anon_sym_basefee] = ACTIONS(1213),
    [anon_sym_blobfee] = ACTIONS(1213),
    [anon_sym_coinbase] = ACTIONS(1213),
    [anon_sym_timestamp] = ACTIONS(1213),
    [anon_sym_number] = ACTIONS(1213),
    [anon_sym_difficulty] = ACTIONS(1213),
    [anon_sym_gaslimit] = ACTIONS(1213),
    [anon_sym_DQUOTE] = ACTIONS(1215),
    [anon_sym_SQUOTE] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(603),
    [sym_yul_path] = STATE(603),
    [sym__yul_literal] = STATE(603),
    [sym_yul_string_literal] = STATE(603),
    [sym_yul_boolean] = STATE(603),
    [sym_yul_function_call] = STATE(603),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_RPAREN] = ACTIONS(1217),
    [sym_yul_decimal_number] = ACTIONS(1219),
    [sym_yul_hex_number] = ACTIONS(1221),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_identifier] = ACTIONS(1223),
    [anon_sym_LBRACE] = ACTIONS(1225),
    [anon_sym_RBRACE] = ACTIONS(1225),
    [anon_sym_for] = ACTIONS(1223),
    [sym_yul_leave] = ACTIONS(1223),
    [anon_sym_break] = ACTIONS(1223),
    [anon_sym_continue] = ACTIONS(1223),
    [sym_yul_decimal_number] = ACTIONS(1223),
    [sym_yul_hex_number] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(1223),
    [anon_sym_false] = ACTIONS(1223),
    [anon_sym_let] = ACTIONS(1223),
    [anon_sym_if] = ACTIONS(1223),
    [anon_sym_switch] = ACTIONS(1223),
    [anon_sym_function] = ACTIONS(1223),
    [anon_sym_stop] = ACTIONS(1223),
    [anon_sym_add] = ACTIONS(1223),
    [anon_sym_sub] = ACTIONS(1223),
    [anon_sym_mul] = ACTIONS(1223),
    [anon_sym_div] = ACTIONS(1223),
    [anon_sym_sdiv] = ACTIONS(1223),
    [anon_sym_mod] = ACTIONS(1223),
    [anon_sym_smod] = ACTIONS(1223),
    [anon_sym_exp] = ACTIONS(1223),
    [anon_sym_not] = ACTIONS(1223),
    [anon_sym_lt] = ACTIONS(1223),
    [anon_sym_gt] = ACTIONS(1223),
    [anon_sym_slt] = ACTIONS(1223),
    [anon_sym_sgt] = ACTIONS(1223),
    [anon_sym_eq] = ACTIONS(1223),
    [anon_sym_iszero] = ACTIONS(1223),
    [anon_sym_and] = ACTIONS(1223),
    [anon_sym_or] = ACTIONS(1223),
    [anon_sym_xor] = ACTIONS(1223),
    [anon_sym_byte] = ACTIONS(1223),
    [anon_sym_shl] = ACTIONS(1223),
    [anon_sym_shr] = ACTIONS(1223),
    [anon_sym_sar] = ACTIONS(1223),
    [anon_sym_addmod] = ACTIONS(1223),
    [anon_sym_mulmod] = ACTIONS(1223),
    [anon_sym_signextend] = ACTIONS(1223),
    [anon_sym_keccak256] = ACTIONS(1223),
    [anon_sym_pop] = ACTIONS(1223),
    [anon_sym_mload] = ACTIONS(1223),
    [anon_sym_mcopy] = ACTIONS(1223),
    [anon_sym_tload] = ACTIONS(1223),
    [anon_sym_tstore] = ACTIONS(1223),
    [anon_sym_mstore] = ACTIONS(1223),
    [anon_sym_mstore8] = ACTIONS(1223),
    [anon_sym_sload] = ACTIONS(1223),
    [anon_sym_sstore] = ACTIONS(1223),
    [anon_sym_msize] = ACTIONS(1223),
    [anon_sym_gas] = ACTIONS(1223),
    [anon_sym_address] = ACTIONS(1223),
    [anon_sym_balance] = ACTIONS(1223),
    [anon_sym_selfbalance] = ACTIONS(1223),
    [anon_sym_caller] = ACTIONS(1223),
    [anon_sym_callvalue] = ACTIONS(1223),
    [anon_sym_calldataload] = ACTIONS(1223),
    [anon_sym_calldatasize] = ACTIONS(1223),
    [anon_sym_calldatacopy] = ACTIONS(1223),
    [anon_sym_extcodesize] = ACTIONS(1223),
    [anon_sym_extcodecopy] = ACTIONS(1223),
    [anon_sym_returndatasize] = ACTIONS(1223),
    [anon_sym_returndatacopy] = ACTIONS(1223),
    [anon_sym_extcodehash] = ACTIONS(1223),
    [anon_sym_create] = ACTIONS(1223),
    [anon_sym_create2] = ACTIONS(1223),
    [anon_sym_call] = ACTIONS(1223),
    [anon_sym_callcode] = ACTIONS(1223),
    [anon_sym_delegatecall] = ACTIONS(1223),
    [anon_sym_staticcall] = ACTIONS(1223),
    [anon_sym_return] = ACTIONS(1223),
    [anon_sym_revert] = ACTIONS(1223),
    [anon_sym_selfdestruct] = ACTIONS(1223),
    [anon_sym_invalid] = ACTIONS(1223),
    [anon_sym_log0] = ACTIONS(1223),
    [anon_sym_log1] = ACTIONS(1223),
    [anon_sym_log2] = ACTIONS(1223),
    [anon_sym_log3] = ACTIONS(1223),
    [anon_sym_log4] = ACTIONS(1223),
    [anon_sym_chainid] = ACTIONS(1223),
    [anon_sym_origin] = ACTIONS(1223),
    [anon_sym_gasprice] = ACTIONS(1223),
    [anon_sym_blockhash] = ACTIONS(1223),
    [anon_sym_blobhash] = ACTIONS(1223),
    [anon_sym_basefee] = ACTIONS(1223),
    [anon_sym_blobfee] = ACTIONS(1223),
    [anon_sym_coinbase] = ACTIONS(1223),
    [anon_sym_timestamp] = ACTIONS(1223),
    [anon_sym_number] = ACTIONS(1223),
    [anon_sym_difficulty] = ACTIONS(1223),
    [anon_sym_gaslimit] = ACTIONS(1223),
    [anon_sym_DQUOTE] = ACTIONS(1225),
    [anon_sym_SQUOTE] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_LBRACE] = ACTIONS(1229),
    [anon_sym_RBRACE] = ACTIONS(1229),
    [anon_sym_for] = ACTIONS(1227),
    [sym_yul_leave] = ACTIONS(1227),
    [anon_sym_break] = ACTIONS(1227),
    [anon_sym_continue] = ACTIONS(1227),
    [sym_yul_decimal_number] = ACTIONS(1227),
    [sym_yul_hex_number] = ACTIONS(1229),
    [anon_sym_true] = ACTIONS(1227),
    [anon_sym_false] = ACTIONS(1227),
    [anon_sym_let] = ACTIONS(1227),
    [anon_sym_if] = ACTIONS(1227),
    [anon_sym_switch] = ACTIONS(1227),
    [anon_sym_function] = ACTIONS(1227),
    [anon_sym_stop] = ACTIONS(1227),
    [anon_sym_add] = ACTIONS(1227),
    [anon_sym_sub] = ACTIONS(1227),
    [anon_sym_mul] = ACTIONS(1227),
    [anon_sym_div] = ACTIONS(1227),
    [anon_sym_sdiv] = ACTIONS(1227),
    [anon_sym_mod] = ACTIONS(1227),
    [anon_sym_smod] = ACTIONS(1227),
    [anon_sym_exp] = ACTIONS(1227),
    [anon_sym_not] = ACTIONS(1227),
    [anon_sym_lt] = ACTIONS(1227),
    [anon_sym_gt] = ACTIONS(1227),
    [anon_sym_slt] = ACTIONS(1227),
    [anon_sym_sgt] = ACTIONS(1227),
    [anon_sym_eq] = ACTIONS(1227),
    [anon_sym_iszero] = ACTIONS(1227),
    [anon_sym_and] = ACTIONS(1227),
    [anon_sym_or] = ACTIONS(1227),
    [anon_sym_xor] = ACTIONS(1227),
    [anon_sym_byte] = ACTIONS(1227),
    [anon_sym_shl] = ACTIONS(1227),
    [anon_sym_shr] = ACTIONS(1227),
    [anon_sym_sar] = ACTIONS(1227),
    [anon_sym_addmod] = ACTIONS(1227),
    [anon_sym_mulmod] = ACTIONS(1227),
    [anon_sym_signextend] = ACTIONS(1227),
    [anon_sym_keccak256] = ACTIONS(1227),
    [anon_sym_pop] = ACTIONS(1227),
    [anon_sym_mload] = ACTIONS(1227),
    [anon_sym_mcopy] = ACTIONS(1227),
    [anon_sym_tload] = ACTIONS(1227),
    [anon_sym_tstore] = ACTIONS(1227),
    [anon_sym_mstore] = ACTIONS(1227),
    [anon_sym_mstore8] = ACTIONS(1227),
    [anon_sym_sload] = ACTIONS(1227),
    [anon_sym_sstore] = ACTIONS(1227),
    [anon_sym_msize] = ACTIONS(1227),
    [anon_sym_gas] = ACTIONS(1227),
    [anon_sym_address] = ACTIONS(1227),
    [anon_sym_balance] = ACTIONS(1227),
    [anon_sym_selfbalance] = ACTIONS(1227),
    [anon_sym_caller] = ACTIONS(1227),
    [anon_sym_callvalue] = ACTIONS(1227),
    [anon_sym_calldataload] = ACTIONS(1227),
    [anon_sym_calldatasize] = ACTIONS(1227),
    [anon_sym_calldatacopy] = ACTIONS(1227),
    [anon_sym_extcodesize] = ACTIONS(1227),
    [anon_sym_extcodecopy] = ACTIONS(1227),
    [anon_sym_returndatasize] = ACTIONS(1227),
    [anon_sym_returndatacopy] = ACTIONS(1227),
    [anon_sym_extcodehash] = ACTIONS(1227),
    [anon_sym_create] = ACTIONS(1227),
    [anon_sym_create2] = ACTIONS(1227),
    [anon_sym_call] = ACTIONS(1227),
    [anon_sym_callcode] = ACTIONS(1227),
    [anon_sym_delegatecall] = ACTIONS(1227),
    [anon_sym_staticcall] = ACTIONS(1227),
    [anon_sym_return] = ACTIONS(1227),
    [anon_sym_revert] = ACTIONS(1227),
    [anon_sym_selfdestruct] = ACTIONS(1227),
    [anon_sym_invalid] = ACTIONS(1227),
    [anon_sym_log0] = ACTIONS(1227),
    [anon_sym_log1] = ACTIONS(1227),
    [anon_sym_log2] = ACTIONS(1227),
    [anon_sym_log3] = ACTIONS(1227),
    [anon_sym_log4] = ACTIONS(1227),
    [anon_sym_chainid] = ACTIONS(1227),
    [anon_sym_origin] = ACTIONS(1227),
    [anon_sym_gasprice] = ACTIONS(1227),
    [anon_sym_blockhash] = ACTIONS(1227),
    [anon_sym_blobhash] = ACTIONS(1227),
    [anon_sym_basefee] = ACTIONS(1227),
    [anon_sym_blobfee] = ACTIONS(1227),
    [anon_sym_coinbase] = ACTIONS(1227),
    [anon_sym_timestamp] = ACTIONS(1227),
    [anon_sym_number] = ACTIONS(1227),
    [anon_sym_difficulty] = ACTIONS(1227),
    [anon_sym_gaslimit] = ACTIONS(1227),
    [anon_sym_DQUOTE] = ACTIONS(1229),
    [anon_sym_SQUOTE] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(712),
    [sym_yul_path] = STATE(712),
    [sym__yul_literal] = STATE(712),
    [sym_yul_string_literal] = STATE(712),
    [sym_yul_boolean] = STATE(712),
    [sym_yul_function_call] = STATE(712),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [sym_yul_decimal_number] = ACTIONS(1231),
    [sym_yul_hex_number] = ACTIONS(1233),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(305),
    [sym_yul_path] = STATE(305),
    [sym__yul_literal] = STATE(305),
    [sym_yul_string_literal] = STATE(305),
    [sym_yul_boolean] = STATE(305),
    [sym_yul_function_call] = STATE(307),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [sym_yul_decimal_number] = ACTIONS(1235),
    [sym_yul_hex_number] = ACTIONS(1237),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(710),
    [sym_yul_path] = STATE(710),
    [sym__yul_literal] = STATE(710),
    [sym_yul_string_literal] = STATE(710),
    [sym_yul_boolean] = STATE(710),
    [sym_yul_function_call] = STATE(710),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [sym_yul_decimal_number] = ACTIONS(1121),
    [sym_yul_hex_number] = ACTIONS(1123),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(579),
    [sym_yul_path] = STATE(579),
    [sym__yul_literal] = STATE(579),
    [sym_yul_string_literal] = STATE(579),
    [sym_yul_boolean] = STATE(579),
    [sym_yul_function_call] = STATE(579),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [sym_yul_decimal_number] = ACTIONS(1239),
    [sym_yul_hex_number] = ACTIONS(1241),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(283),
    [sym_yul_path] = STATE(283),
    [sym__yul_literal] = STATE(283),
    [sym_yul_string_literal] = STATE(283),
    [sym_yul_boolean] = STATE(283),
    [sym_yul_function_call] = STATE(290),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [sym_yul_decimal_number] = ACTIONS(1243),
    [sym_yul_hex_number] = ACTIONS(1245),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(871),
    [anon_sym_SQUOTE] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym_yul_identifier] = STATE(247),
    [sym__yul_expression] = STATE(756),
    [sym_yul_path] = STATE(756),
    [sym__yul_literal] = STATE(756),
    [sym_yul_string_literal] = STATE(756),
    [sym_yul_boolean] = STATE(756),
    [sym_yul_function_call] = STATE(756),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_string] = STATE(266),
    [sym_identifier] = ACTIONS(1117),
    [sym_yul_decimal_number] = ACTIONS(1247),
    [sym_yul_hex_number] = ACTIONS(1249),
    [anon_sym_true] = ACTIONS(859),
    [anon_sym_false] = ACTIONS(859),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_identifier] = ACTIONS(1251),
    [sym_yul_decimal_number] = ACTIONS(1251),
    [sym_yul_hex_number] = ACTIONS(1253),
    [anon_sym_true] = ACTIONS(1251),
    [anon_sym_false] = ACTIONS(1251),
    [anon_sym_stop] = ACTIONS(1251),
    [anon_sym_add] = ACTIONS(1251),
    [anon_sym_sub] = ACTIONS(1251),
    [anon_sym_mul] = ACTIONS(1251),
    [anon_sym_div] = ACTIONS(1251),
    [anon_sym_sdiv] = ACTIONS(1251),
    [anon_sym_mod] = ACTIONS(1251),
    [anon_sym_smod] = ACTIONS(1251),
    [anon_sym_exp] = ACTIONS(1251),
    [anon_sym_not] = ACTIONS(1251),
    [anon_sym_lt] = ACTIONS(1251),
    [anon_sym_gt] = ACTIONS(1251),
    [anon_sym_slt] = ACTIONS(1251),
    [anon_sym_sgt] = ACTIONS(1251),
    [anon_sym_eq] = ACTIONS(1251),
    [anon_sym_iszero] = ACTIONS(1251),
    [anon_sym_and] = ACTIONS(1251),
    [anon_sym_or] = ACTIONS(1251),
    [anon_sym_xor] = ACTIONS(1251),
    [anon_sym_byte] = ACTIONS(1251),
    [anon_sym_shl] = ACTIONS(1251),
    [anon_sym_shr] = ACTIONS(1251),
    [anon_sym_sar] = ACTIONS(1251),
    [anon_sym_addmod] = ACTIONS(1251),
    [anon_sym_mulmod] = ACTIONS(1251),
    [anon_sym_signextend] = ACTIONS(1251),
    [anon_sym_keccak256] = ACTIONS(1251),
    [anon_sym_pop] = ACTIONS(1251),
    [anon_sym_mload] = ACTIONS(1251),
    [anon_sym_mcopy] = ACTIONS(1251),
    [anon_sym_tload] = ACTIONS(1251),
    [anon_sym_tstore] = ACTIONS(1251),
    [anon_sym_mstore] = ACTIONS(1251),
    [anon_sym_mstore8] = ACTIONS(1251),
    [anon_sym_sload] = ACTIONS(1251),
    [anon_sym_sstore] = ACTIONS(1251),
    [anon_sym_msize] = ACTIONS(1251),
    [anon_sym_gas] = ACTIONS(1251),
    [anon_sym_address] = ACTIONS(1251),
    [anon_sym_balance] = ACTIONS(1251),
    [anon_sym_selfbalance] = ACTIONS(1251),
    [anon_sym_caller] = ACTIONS(1251),
    [anon_sym_callvalue] = ACTIONS(1251),
    [anon_sym_calldataload] = ACTIONS(1251),
    [anon_sym_calldatasize] = ACTIONS(1251),
    [anon_sym_calldatacopy] = ACTIONS(1251),
    [anon_sym_extcodesize] = ACTIONS(1251),
    [anon_sym_extcodecopy] = ACTIONS(1251),
    [anon_sym_returndatasize] = ACTIONS(1251),
    [anon_sym_returndatacopy] = ACTIONS(1251),
    [anon_sym_extcodehash] = ACTIONS(1251),
    [anon_sym_create] = ACTIONS(1251),
    [anon_sym_create2] = ACTIONS(1251),
    [anon_sym_call] = ACTIONS(1251),
    [anon_sym_callcode] = ACTIONS(1251),
    [anon_sym_delegatecall] = ACTIONS(1251),
    [anon_sym_staticcall] = ACTIONS(1251),
    [anon_sym_return] = ACTIONS(1251),
    [anon_sym_revert] = ACTIONS(1251),
    [anon_sym_selfdestruct] = ACTIONS(1251),
    [anon_sym_invalid] = ACTIONS(1251),
    [anon_sym_log0] = ACTIONS(1251),
    [anon_sym_log1] = ACTIONS(1251),
    [anon_sym_log2] = ACTIONS(1251),
    [anon_sym_log3] = ACTIONS(1251),
    [anon_sym_log4] = ACTIONS(1251),
    [anon_sym_chainid] = ACTIONS(1251),
    [anon_sym_origin] = ACTIONS(1251),
    [anon_sym_gasprice] = ACTIONS(1251),
    [anon_sym_blockhash] = ACTIONS(1251),
    [anon_sym_blobhash] = ACTIONS(1251),
    [anon_sym_basefee] = ACTIONS(1251),
    [anon_sym_blobfee] = ACTIONS(1251),
    [anon_sym_coinbase] = ACTIONS(1251),
    [anon_sym_timestamp] = ACTIONS(1251),
    [anon_sym_number] = ACTIONS(1251),
    [anon_sym_difficulty] = ACTIONS(1251),
    [anon_sym_gaslimit] = ACTIONS(1251),
    [anon_sym_DQUOTE] = ACTIONS(1253),
    [anon_sym_SQUOTE] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
  },
  [319] = {
    [sym_yul_identifier] = STATE(871),
    [sym_yul_function_call] = STATE(288),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
  },
  [320] = {
    [sym_yul_identifier] = STATE(871),
    [sym_yul_function_call] = STATE(306),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
  },
  [321] = {
    [sym_yul_identifier] = STATE(871),
    [sym_yul_function_call] = STATE(291),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym_yul_identifier] = STATE(871),
    [sym_yul_function_call] = STATE(302),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym_yul_identifier] = STATE(871),
    [sym_yul_function_call] = STATE(285),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym_yul_identifier] = STATE(871),
    [sym_yul_function_call] = STATE(293),
    [sym_yul_evm_builtin] = STATE(258),
    [sym_identifier] = ACTIONS(1117),
    [anon_sym_stop] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_sub] = ACTIONS(869),
    [anon_sym_mul] = ACTIONS(869),
    [anon_sym_div] = ACTIONS(869),
    [anon_sym_sdiv] = ACTIONS(869),
    [anon_sym_mod] = ACTIONS(869),
    [anon_sym_smod] = ACTIONS(869),
    [anon_sym_exp] = ACTIONS(869),
    [anon_sym_not] = ACTIONS(869),
    [anon_sym_lt] = ACTIONS(869),
    [anon_sym_gt] = ACTIONS(869),
    [anon_sym_slt] = ACTIONS(869),
    [anon_sym_sgt] = ACTIONS(869),
    [anon_sym_eq] = ACTIONS(869),
    [anon_sym_iszero] = ACTIONS(869),
    [anon_sym_and] = ACTIONS(869),
    [anon_sym_or] = ACTIONS(869),
    [anon_sym_xor] = ACTIONS(869),
    [anon_sym_byte] = ACTIONS(869),
    [anon_sym_shl] = ACTIONS(869),
    [anon_sym_shr] = ACTIONS(869),
    [anon_sym_sar] = ACTIONS(869),
    [anon_sym_addmod] = ACTIONS(869),
    [anon_sym_mulmod] = ACTIONS(869),
    [anon_sym_signextend] = ACTIONS(869),
    [anon_sym_keccak256] = ACTIONS(869),
    [anon_sym_pop] = ACTIONS(869),
    [anon_sym_mload] = ACTIONS(869),
    [anon_sym_mcopy] = ACTIONS(869),
    [anon_sym_tload] = ACTIONS(869),
    [anon_sym_tstore] = ACTIONS(869),
    [anon_sym_mstore] = ACTIONS(869),
    [anon_sym_mstore8] = ACTIONS(869),
    [anon_sym_sload] = ACTIONS(869),
    [anon_sym_sstore] = ACTIONS(869),
    [anon_sym_msize] = ACTIONS(869),
    [anon_sym_gas] = ACTIONS(869),
    [anon_sym_address] = ACTIONS(869),
    [anon_sym_balance] = ACTIONS(869),
    [anon_sym_selfbalance] = ACTIONS(869),
    [anon_sym_caller] = ACTIONS(869),
    [anon_sym_callvalue] = ACTIONS(869),
    [anon_sym_calldataload] = ACTIONS(869),
    [anon_sym_calldatasize] = ACTIONS(869),
    [anon_sym_calldatacopy] = ACTIONS(869),
    [anon_sym_extcodesize] = ACTIONS(869),
    [anon_sym_extcodecopy] = ACTIONS(869),
    [anon_sym_returndatasize] = ACTIONS(869),
    [anon_sym_returndatacopy] = ACTIONS(869),
    [anon_sym_extcodehash] = ACTIONS(869),
    [anon_sym_create] = ACTIONS(869),
    [anon_sym_create2] = ACTIONS(869),
    [anon_sym_call] = ACTIONS(869),
    [anon_sym_callcode] = ACTIONS(869),
    [anon_sym_delegatecall] = ACTIONS(869),
    [anon_sym_staticcall] = ACTIONS(869),
    [anon_sym_return] = ACTIONS(869),
    [anon_sym_revert] = ACTIONS(869),
    [anon_sym_selfdestruct] = ACTIONS(869),
    [anon_sym_invalid] = ACTIONS(869),
    [anon_sym_log0] = ACTIONS(869),
    [anon_sym_log1] = ACTIONS(869),
    [anon_sym_log2] = ACTIONS(869),
    [anon_sym_log3] = ACTIONS(869),
    [anon_sym_log4] = ACTIONS(869),
    [anon_sym_chainid] = ACTIONS(869),
    [anon_sym_origin] = ACTIONS(869),
    [anon_sym_gasprice] = ACTIONS(869),
    [anon_sym_blockhash] = ACTIONS(869),
    [anon_sym_blobhash] = ACTIONS(869),
    [anon_sym_basefee] = ACTIONS(869),
    [anon_sym_blobfee] = ACTIONS(869),
    [anon_sym_coinbase] = ACTIONS(869),
    [anon_sym_timestamp] = ACTIONS(869),
    [anon_sym_number] = ACTIONS(869),
    [anon_sym_difficulty] = ACTIONS(869),
    [anon_sym_gaslimit] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [aux_sym__identifier_path_repeat1] = STATE(325),
    [sym_identifier] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_constant] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_indexed] = ACTIONS(1255),
    [anon_sym_for] = ACTIONS(1255),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_DOT] = ACTIONS(1259),
    [sym_unchecked] = ACTIONS(1255),
    [anon_sym_memory] = ACTIONS(1255),
    [anon_sym_storage] = ACTIONS(1255),
    [anon_sym_calldata] = ACTIONS(1255),
    [anon_sym_returns] = ACTIONS(1255),
    [anon_sym_public] = ACTIONS(1255),
    [anon_sym_internal] = ACTIONS(1255),
    [anon_sym_private] = ACTIONS(1255),
    [anon_sym_external] = ACTIONS(1255),
    [anon_sym_pure] = ACTIONS(1255),
    [anon_sym_view] = ACTIONS(1255),
    [anon_sym_payable] = ACTIONS(1255),
    [anon_sym_transient] = ACTIONS(1255),
    [sym_immutable] = ACTIONS(1255),
    [anon_sym_override] = ACTIONS(1255),
    [sym_virtual] = ACTIONS(1255),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1257),
    [anon_sym_PLUS_EQ] = ACTIONS(1257),
    [anon_sym_DASH_EQ] = ACTIONS(1257),
    [anon_sym_STAR_EQ] = ACTIONS(1257),
    [anon_sym_SLASH_EQ] = ACTIONS(1257),
    [anon_sym_PERCENT_EQ] = ACTIONS(1257),
    [anon_sym_CARET_EQ] = ACTIONS(1257),
    [anon_sym_AMP_EQ] = ACTIONS(1257),
    [anon_sym_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_GT_GT_EQ] = ACTIONS(1257),
    [anon_sym_LT_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_GT] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_visibility] = STATE(328),
    [sym_state_mutability] = STATE(328),
    [sym__return_parameters] = STATE(344),
    [aux_sym__function_type_repeat1] = STATE(328),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_PIPE_PIPE] = ACTIONS(1264),
    [anon_sym_DASH] = ACTIONS(1262),
    [anon_sym_LT_EQ] = ACTIONS(1264),
    [anon_sym_LT] = ACTIONS(1262),
    [anon_sym_CARET] = ACTIONS(1262),
    [anon_sym_GT] = ACTIONS(1262),
    [anon_sym_GT_EQ] = ACTIONS(1264),
    [anon_sym_EQ] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(1262),
    [anon_sym_LBRACE] = ACTIONS(1264),
    [anon_sym_COMMA] = ACTIONS(1264),
    [anon_sym_RBRACE] = ACTIONS(1264),
    [anon_sym_constant] = ACTIONS(1262),
    [anon_sym_LPAREN] = ACTIONS(1264),
    [anon_sym_RPAREN] = ACTIONS(1264),
    [anon_sym_indexed] = ACTIONS(1262),
    [anon_sym_COLON] = ACTIONS(1264),
    [anon_sym_DOT] = ACTIONS(1264),
    [sym_unchecked] = ACTIONS(1262),
    [anon_sym_memory] = ACTIONS(1262),
    [anon_sym_storage] = ACTIONS(1262),
    [anon_sym_calldata] = ACTIONS(1262),
    [anon_sym_returns] = ACTIONS(1266),
    [anon_sym_public] = ACTIONS(1268),
    [anon_sym_internal] = ACTIONS(1268),
    [anon_sym_private] = ACTIONS(1268),
    [anon_sym_external] = ACTIONS(1268),
    [anon_sym_pure] = ACTIONS(1270),
    [anon_sym_view] = ACTIONS(1270),
    [anon_sym_payable] = ACTIONS(1270),
    [anon_sym_transient] = ACTIONS(1262),
    [sym_immutable] = ACTIONS(1262),
    [anon_sym_override] = ACTIONS(1262),
    [anon_sym_QMARK] = ACTIONS(1264),
    [anon_sym_LBRACK] = ACTIONS(1264),
    [anon_sym_RBRACK] = ACTIONS(1264),
    [anon_sym_AMP_AMP] = ACTIONS(1264),
    [anon_sym_EQ_EQ] = ACTIONS(1264),
    [anon_sym_BANG_EQ] = ACTIONS(1264),
    [anon_sym_PIPE] = ACTIONS(1262),
    [anon_sym_AMP] = ACTIONS(1262),
    [anon_sym_LT_LT] = ACTIONS(1262),
    [anon_sym_GT_GT] = ACTIONS(1262),
    [anon_sym_PLUS] = ACTIONS(1262),
    [anon_sym_SLASH] = ACTIONS(1262),
    [anon_sym_PERCENT] = ACTIONS(1262),
    [anon_sym_STAR_STAR] = ACTIONS(1264),
    [anon_sym_PLUS_PLUS] = ACTIONS(1264),
    [anon_sym_DASH_DASH] = ACTIONS(1264),
    [anon_sym_PLUS_EQ] = ACTIONS(1264),
    [anon_sym_DASH_EQ] = ACTIONS(1264),
    [anon_sym_STAR_EQ] = ACTIONS(1264),
    [anon_sym_SLASH_EQ] = ACTIONS(1264),
    [anon_sym_PERCENT_EQ] = ACTIONS(1264),
    [anon_sym_CARET_EQ] = ACTIONS(1264),
    [anon_sym_AMP_EQ] = ACTIONS(1264),
    [anon_sym_PIPE_EQ] = ACTIONS(1264),
    [anon_sym_GT_GT_EQ] = ACTIONS(1264),
    [anon_sym_LT_LT_EQ] = ACTIONS(1264),
    [anon_sym_SEMI] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
  },
  [327] = {
    [sym_identifier] = ACTIONS(1255),
    [anon_sym_PIPE_PIPE] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1255),
    [anon_sym_LT_EQ] = ACTIONS(1257),
    [anon_sym_LT] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_GT] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1257),
    [anon_sym_EQ] = ACTIONS(1255),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_LBRACE] = ACTIONS(1257),
    [anon_sym_COMMA] = ACTIONS(1257),
    [anon_sym_RBRACE] = ACTIONS(1257),
    [anon_sym_constant] = ACTIONS(1255),
    [anon_sym_LPAREN] = ACTIONS(1257),
    [anon_sym_RPAREN] = ACTIONS(1257),
    [anon_sym_indexed] = ACTIONS(1255),
    [anon_sym_for] = ACTIONS(1255),
    [anon_sym_COLON] = ACTIONS(1257),
    [anon_sym_DOT] = ACTIONS(1257),
    [sym_unchecked] = ACTIONS(1255),
    [anon_sym_memory] = ACTIONS(1255),
    [anon_sym_storage] = ACTIONS(1255),
    [anon_sym_calldata] = ACTIONS(1255),
    [anon_sym_returns] = ACTIONS(1255),
    [anon_sym_public] = ACTIONS(1255),
    [anon_sym_internal] = ACTIONS(1255),
    [anon_sym_private] = ACTIONS(1255),
    [anon_sym_external] = ACTIONS(1255),
    [anon_sym_pure] = ACTIONS(1255),
    [anon_sym_view] = ACTIONS(1255),
    [anon_sym_payable] = ACTIONS(1255),
    [anon_sym_transient] = ACTIONS(1255),
    [sym_immutable] = ACTIONS(1255),
    [anon_sym_override] = ACTIONS(1255),
    [sym_virtual] = ACTIONS(1255),
    [anon_sym_QMARK] = ACTIONS(1257),
    [anon_sym_LBRACK] = ACTIONS(1257),
    [anon_sym_RBRACK] = ACTIONS(1257),
    [anon_sym_AMP_AMP] = ACTIONS(1257),
    [anon_sym_EQ_EQ] = ACTIONS(1257),
    [anon_sym_BANG_EQ] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_LT_LT] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1255),
    [anon_sym_PLUS] = ACTIONS(1255),
    [anon_sym_SLASH] = ACTIONS(1255),
    [anon_sym_PERCENT] = ACTIONS(1255),
    [anon_sym_STAR_STAR] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1257),
    [anon_sym_DASH_DASH] = ACTIONS(1257),
    [anon_sym_PLUS_EQ] = ACTIONS(1257),
    [anon_sym_DASH_EQ] = ACTIONS(1257),
    [anon_sym_STAR_EQ] = ACTIONS(1257),
    [anon_sym_SLASH_EQ] = ACTIONS(1257),
    [anon_sym_PERCENT_EQ] = ACTIONS(1257),
    [anon_sym_CARET_EQ] = ACTIONS(1257),
    [anon_sym_AMP_EQ] = ACTIONS(1257),
    [anon_sym_PIPE_EQ] = ACTIONS(1257),
    [anon_sym_GT_GT_EQ] = ACTIONS(1257),
    [anon_sym_LT_LT_EQ] = ACTIONS(1257),
    [anon_sym_EQ_GT] = ACTIONS(1257),
    [anon_sym_SEMI] = ACTIONS(1257),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_visibility] = STATE(328),
    [sym_state_mutability] = STATE(328),
    [aux_sym__function_type_repeat1] = STATE(328),
    [sym_identifier] = ACTIONS(1272),
    [anon_sym_PIPE_PIPE] = ACTIONS(1274),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LT_EQ] = ACTIONS(1274),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_CARET] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_EQ] = ACTIONS(1274),
    [anon_sym_EQ] = ACTIONS(1272),
    [anon_sym_STAR] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(1274),
    [anon_sym_COMMA] = ACTIONS(1274),
    [anon_sym_RBRACE] = ACTIONS(1274),
    [anon_sym_constant] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(1274),
    [anon_sym_RPAREN] = ACTIONS(1274),
    [anon_sym_indexed] = ACTIONS(1272),
    [anon_sym_COLON] = ACTIONS(1274),
    [anon_sym_DOT] = ACTIONS(1274),
    [sym_unchecked] = ACTIONS(1272),
    [anon_sym_memory] = ACTIONS(1272),
    [anon_sym_storage] = ACTIONS(1272),
    [anon_sym_calldata] = ACTIONS(1272),
    [anon_sym_returns] = ACTIONS(1272),
    [anon_sym_public] = ACTIONS(1276),
    [anon_sym_internal] = ACTIONS(1276),
    [anon_sym_private] = ACTIONS(1276),
    [anon_sym_external] = ACTIONS(1276),
    [anon_sym_pure] = ACTIONS(1279),
    [anon_sym_view] = ACTIONS(1279),
    [anon_sym_payable] = ACTIONS(1279),
    [anon_sym_transient] = ACTIONS(1272),
    [sym_immutable] = ACTIONS(1272),
    [anon_sym_override] = ACTIONS(1272),
    [anon_sym_QMARK] = ACTIONS(1274),
    [anon_sym_LBRACK] = ACTIONS(1274),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_AMP_AMP] = ACTIONS(1274),
    [anon_sym_EQ_EQ] = ACTIONS(1274),
    [anon_sym_BANG_EQ] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_LT_LT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(1272),
    [anon_sym_PLUS] = ACTIONS(1272),
    [anon_sym_SLASH] = ACTIONS(1272),
    [anon_sym_PERCENT] = ACTIONS(1272),
    [anon_sym_STAR_STAR] = ACTIONS(1274),
    [anon_sym_PLUS_PLUS] = ACTIONS(1274),
    [anon_sym_DASH_DASH] = ACTIONS(1274),
    [anon_sym_PLUS_EQ] = ACTIONS(1274),
    [anon_sym_DASH_EQ] = ACTIONS(1274),
    [anon_sym_STAR_EQ] = ACTIONS(1274),
    [anon_sym_SLASH_EQ] = ACTIONS(1274),
    [anon_sym_PERCENT_EQ] = ACTIONS(1274),
    [anon_sym_CARET_EQ] = ACTIONS(1274),
    [anon_sym_AMP_EQ] = ACTIONS(1274),
    [anon_sym_PIPE_EQ] = ACTIONS(1274),
    [anon_sym_GT_GT_EQ] = ACTIONS(1274),
    [anon_sym_LT_LT_EQ] = ACTIONS(1274),
    [anon_sym_SEMI] = ACTIONS(1274),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 1,
      anon_sym_returns,
    STATE(354), 1,
      sym__return_parameters,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    STATE(326), 3,
      sym_visibility,
      sym_state_mutability,
      aux_sym__function_type_repeat1,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    ACTIONS(1282), 20,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1284), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [80] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1288), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
    ACTIONS(1286), 32,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
  [150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1292), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
    ACTIONS(1290), 32,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
  [220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1296), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
    ACTIONS(1294), 32,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
  [290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1300), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
    ACTIONS(1298), 32,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
  [360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1304), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
    ACTIONS(1302), 32,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
  [430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1308), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
    ACTIONS(1306), 32,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
  [500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1312), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_SEMI,
  [568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 1,
      anon_sym_payable,
    ACTIONS(1314), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1316), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_SEMI,
  [638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1314), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1316), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_SEMI,
  [705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1320), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1322), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      anon_sym_SEMI,
  [772] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1324), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1326), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1330), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1334), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1336), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1338), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1340), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1342), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1344), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1346), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1350), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1354), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1354), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1356), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1358), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1360), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1362), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1364), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1366), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1368), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1370), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1372), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1374), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 28,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1264), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(420), 1,
      sym_number_unit,
    ACTIONS(1380), 11,
      anon_sym_wei,
      anon_sym_szabo,
      anon_sym_finney,
      anon_sym_gwei,
      anon_sym_ether,
      anon_sym_seconds,
      anon_sym_minutes,
      anon_sym_hours,
      anon_sym_days,
      anon_sym_weeks,
      anon_sym_years,
    ACTIONS(1378), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1376), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 25,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1384), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 25,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1388), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [1957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 25,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1392), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1394), 25,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1396), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 1,
      anon_sym_DOT,
    STATE(362), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1398), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1403), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1400), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1189), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1191), 37,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_case,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [2205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(325), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1410), 19,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1412), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1185), 37,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_case,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [2323] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    STATE(365), 2,
      sym_string,
      aux_sym_string_literal_repeat1,
    ACTIONS(1416), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1414), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1422), 1,
      anon_sym_DQUOTE,
    ACTIONS(1425), 1,
      anon_sym_SQUOTE,
    STATE(365), 2,
      sym_string,
      aux_sym_string_literal_repeat1,
    ACTIONS(1420), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1418), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1431), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1428), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2508] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1438), 1,
      anon_sym_hex,
    STATE(369), 1,
      aux_sym_hex_string_literal_repeat2,
    ACTIONS(1436), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1434), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1444), 1,
      anon_sym_unicode,
    STATE(370), 1,
      aux_sym_unicode_string_literal_repeat3,
    ACTIONS(1442), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1440), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2626] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1450), 1,
      anon_sym_hex,
    STATE(369), 1,
      aux_sym_hex_string_literal_repeat2,
    ACTIONS(1448), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1446), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_unicode,
    STATE(370), 1,
      aux_sym_unicode_string_literal_repeat3,
    ACTIONS(1455), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1453), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2744] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1464), 8,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2810] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1464), 10,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2874] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1464), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [2948] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1464), 5,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3018] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1492), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_RBRACK,
      anon_sym_SEMI,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [3112] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1464), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_LPAREN,
    STATE(418), 1,
      sym__call_arguments,
    ACTIONS(1508), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1506), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    STATE(425), 1,
      sym__call_arguments,
    ACTIONS(1515), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1513), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1519), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_hex,
  [3344] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1525), 22,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3428] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 1,
      anon_sym_EQ,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1460), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3508] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 1,
      anon_sym_EQ,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1460), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1529), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1527), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_hex,
  [3640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1533), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1531), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_unicode,
  [3694] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1464), 4,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1464), 6,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
    ACTIONS(1460), 28,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1535), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_hex,
  [3888] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1541), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1539), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [3948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1545), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1543), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
      anon_sym_unicode,
  [4002] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1464), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1460), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4062] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1547), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_RBRACK,
      anon_sym_SEMI,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [4156] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1464), 1,
      anon_sym_EQ,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1460), 23,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4238] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1551), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1549), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1553), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1559), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1557), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1563), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1561), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1567), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1565), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1569), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1575), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1573), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1579), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1577), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1583), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1581), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1585), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1510), 1,
      anon_sym_LPAREN,
    ACTIONS(1589), 1,
      anon_sym_LBRACK,
    STATE(418), 1,
      sym__call_arguments,
    ACTIONS(1344), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1508), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1506), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1592), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1596), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1600), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [4995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1604), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1608), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1612), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1616), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1620), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1624), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1628), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1632), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1636), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1640), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5578] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1648), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1654), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1652), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1658), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1656), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1662), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1660), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1666), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1664), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1670), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1668), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1672), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [5949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1678), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1676), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [6002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1682), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1680), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [6055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 1,
      anon_sym_LBRACK,
    ACTIONS(1344), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1508), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1506), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [6111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 1,
      anon_sym_DOT,
    ACTIONS(1684), 1,
      anon_sym_COLON,
    STATE(362), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1398), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1403), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1400), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [6171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1686), 1,
      anon_sym_LPAREN,
    ACTIONS(1314), 17,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      sym_identifier,
    ACTIONS(1316), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [6223] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1688), 1,
      anon_sym_COMMA,
    ACTIONS(1690), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    STATE(599), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6316] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1692), 1,
      anon_sym_LBRACE,
    ACTIONS(1694), 1,
      sym_unchecked,
    ACTIONS(1696), 1,
      anon_sym_returns,
    STATE(417), 1,
      sym__call_arguments,
    STATE(654), 1,
      sym_block_statement,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6409] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1698), 1,
      anon_sym_COMMA,
    ACTIONS(1700), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym__call_arguments,
    STATE(606), 1,
      aux_sym_inline_array_expression_repeat1,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6502] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1688), 1,
      anon_sym_COMMA,
    ACTIONS(1690), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    STATE(599), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6595] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1702), 1,
      anon_sym_SEMI,
    STATE(96), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6685] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1702), 1,
      anon_sym_SEMI,
    STATE(96), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6775] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1704), 1,
      anon_sym_SEMI,
    STATE(203), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6865] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1706), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6953] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1708), 1,
      anon_sym_SEMI,
    STATE(204), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7043] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1710), 1,
      anon_sym_SEMI,
    STATE(92), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(392), 1,
      anon_sym_catch,
    ACTIONS(1610), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1608), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7183] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1712), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7271] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1714), 1,
      anon_sym_SEMI,
    STATE(154), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7361] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7449] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1718), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7537] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1720), 1,
      anon_sym_COLON,
    ACTIONS(1722), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7627] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1710), 1,
      anon_sym_SEMI,
    STATE(92), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1724), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7807] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1724), 1,
      anon_sym_SEMI,
    STATE(107), 1,
      sym__semicolon,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7897] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1726), 1,
      anon_sym_SEMI,
    STATE(108), 1,
      sym__semicolon,
    STATE(462), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7987] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1726), 1,
      anon_sym_SEMI,
    STATE(108), 1,
      sym__semicolon,
    STATE(456), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8077] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1728), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8165] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1730), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8252] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1732), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8339] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1734), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8426] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1736), 1,
      anon_sym_COLON,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 1,
      anon_sym_SEMI,
    STATE(111), 1,
      sym__semicolon,
    ACTIONS(1646), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8564] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1740), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_SEMI,
    STATE(112), 1,
      sym__semicolon,
    ACTIONS(1646), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8702] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1744), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8789] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1746), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8876] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1748), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 1,
      anon_sym_SEMI,
    STATE(111), 1,
      sym__semicolon,
    ACTIONS(1646), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 1,
      anon_sym_SEMI,
    STATE(112), 1,
      sym__semicolon,
    ACTIONS(1646), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1644), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9065] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1750), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9152] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9239] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1754), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9326] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(417), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 1,
      anon_sym_SEMI,
    ACTIONS(1606), 13,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1604), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1758), 1,
      anon_sym_EQ,
    ACTIONS(1583), 12,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1581), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [9509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 1,
      anon_sym_EQ,
    ACTIONS(1606), 12,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1604), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_STAR_STAR,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_SEMI,
  [9557] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(458), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9641] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    ACTIONS(1470), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_CARET,
    ACTIONS(1476), 1,
      anon_sym_PIPE,
    ACTIONS(1478), 1,
      anon_sym_AMP,
    ACTIONS(1482), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1488), 1,
      anon_sym_EQ,
    ACTIONS(1490), 1,
      anon_sym_LBRACE,
    ACTIONS(1494), 1,
      anon_sym_DOT,
    ACTIONS(1496), 1,
      anon_sym_QMARK,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1500), 1,
      anon_sym_AMP_AMP,
    STATE(463), 1,
      sym__call_arguments,
    ACTIONS(1462), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1472), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1480), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(1484), 2,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(1486), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1502), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1466), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1504), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [9725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    STATE(474), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1762), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_SEMI,
    ACTIONS(1398), 19,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [9765] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    STATE(325), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1412), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      anon_sym_SEMI,
    ACTIONS(1410), 19,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [9805] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1266), 1,
      anon_sym_returns,
    ACTIONS(1284), 1,
      anon_sym_LBRACK,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1770), 1,
      sym_virtual,
    ACTIONS(1772), 1,
      anon_sym_SEMI,
    STATE(205), 1,
      sym_function_body,
    STATE(206), 1,
      sym__semicolon,
    STATE(326), 1,
      aux_sym__function_type_repeat1,
    STATE(354), 1,
      sym__return_parameters,
    STATE(489), 1,
      sym__identifier_path,
    STATE(485), 2,
      sym_visibility,
      sym_state_mutability,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1282), 3,
      anon_sym_constant,
      anon_sym_transient,
      sym_immutable,
    STATE(481), 3,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [9870] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1774), 1,
      anon_sym_LBRACE,
    ACTIONS(1776), 1,
      anon_sym_returns,
    ACTIONS(1778), 1,
      sym_virtual,
    ACTIONS(1780), 1,
      anon_sym_SEMI,
    STATE(162), 1,
      sym_function_body,
    STATE(163), 1,
      sym__semicolon,
    STATE(489), 1,
      sym__identifier_path,
    STATE(541), 1,
      sym_return_type_definition,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(479), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [9922] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1776), 1,
      anon_sym_returns,
    ACTIONS(1782), 1,
      sym_virtual,
    ACTIONS(1784), 1,
      anon_sym_SEMI,
    STATE(215), 1,
      sym_function_body,
    STATE(216), 1,
      sym__semicolon,
    STATE(489), 1,
      sym__identifier_path,
    STATE(543), 1,
      sym_return_type_definition,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(478), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [9974] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1776), 1,
      anon_sym_returns,
    ACTIONS(1786), 1,
      sym_virtual,
    ACTIONS(1788), 1,
      anon_sym_SEMI,
    STATE(193), 1,
      sym_function_body,
    STATE(225), 1,
      sym__semicolon,
    STATE(489), 1,
      sym__identifier_path,
    STATE(551), 1,
      sym_return_type_definition,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(482), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [10026] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1774), 1,
      anon_sym_LBRACE,
    ACTIONS(1776), 1,
      anon_sym_returns,
    ACTIONS(1786), 1,
      sym_virtual,
    ACTIONS(1790), 1,
      anon_sym_SEMI,
    STATE(184), 1,
      sym_function_body,
    STATE(187), 1,
      sym__semicolon,
    STATE(489), 1,
      sym__identifier_path,
    STATE(576), 1,
      sym_return_type_definition,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(482), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [10078] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1770), 1,
      sym_virtual,
    ACTIONS(1772), 1,
      anon_sym_SEMI,
    STATE(205), 1,
      sym_function_body,
    STATE(206), 1,
      sym__semicolon,
    STATE(489), 1,
      sym__identifier_path,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(481), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [10124] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1792), 1,
      sym_virtual,
    ACTIONS(1794), 1,
      anon_sym_SEMI,
    STATE(195), 1,
      sym__semicolon,
    STATE(233), 1,
      sym_function_body,
    STATE(489), 1,
      sym__identifier_path,
    ACTIONS(1270), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(483), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [10170] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      sym_identifier,
    ACTIONS(1801), 1,
      anon_sym_returns,
    ACTIONS(1809), 1,
      anon_sym_override,
    ACTIONS(1812), 1,
      sym_virtual,
    STATE(489), 1,
      sym__identifier_path,
    ACTIONS(1799), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1806), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1803), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(482), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [10211] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1815), 1,
      sym_identifier,
    ACTIONS(1826), 1,
      anon_sym_override,
    ACTIONS(1829), 1,
      sym_virtual,
    STATE(489), 1,
      sym__identifier_path,
    ACTIONS(1818), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1823), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1820), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(483), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [10249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      anon_sym_LPAREN,
    ACTIONS(1834), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1832), 14,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [10276] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 1,
      sym_virtual,
    ACTIONS(1847), 1,
      anon_sym_LBRACK,
    ACTIONS(1841), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1843), 4,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_transient,
      sym_immutable,
    ACTIONS(1838), 9,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_identifier,
  [10307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1851), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1849), 14,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [10331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1855), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1853), 14,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [10355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1857), 14,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [10379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    STATE(491), 1,
      sym__call_arguments,
    ACTIONS(1863), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1861), 11,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [10406] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1865), 1,
      sym_identifier,
    ACTIONS(1869), 1,
      anon_sym_transient,
    STATE(502), 1,
      sym_state_location,
    STATE(504), 1,
      sym_visibility,
    ACTIONS(1867), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(492), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [10442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    ACTIONS(1871), 11,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [10463] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 1,
      anon_sym_override,
    ACTIONS(1869), 1,
      anon_sym_transient,
    ACTIONS(1875), 1,
      sym_identifier,
    STATE(502), 1,
      sym_state_location,
    STATE(504), 1,
      sym_visibility,
    ACTIONS(1877), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(493), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1268), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [10496] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      sym_identifier,
    ACTIONS(1887), 1,
      anon_sym_transient,
    ACTIONS(1890), 1,
      anon_sym_override,
    STATE(502), 1,
      sym_state_location,
    STATE(504), 1,
      sym_visibility,
    ACTIONS(1881), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(493), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1884), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [10529] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 1,
      sym_solidity_version,
    ACTIONS(1899), 1,
      anon_sym_SEMI,
    STATE(496), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(497), 1,
      sym__pragma_version_constraint,
    STATE(830), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1897), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1895), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [10559] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 1,
      sym_solidity_version,
    ACTIONS(1910), 1,
      anon_sym_SEMI,
    STATE(495), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(497), 1,
      sym__pragma_version_constraint,
    STATE(830), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1907), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1904), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [10589] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 1,
      sym_solidity_version,
    ACTIONS(1912), 1,
      anon_sym_SEMI,
    STATE(495), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(497), 1,
      sym__pragma_version_constraint,
    STATE(830), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1897), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1895), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [10619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH,
    ACTIONS(1918), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1916), 7,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      anon_sym_SEMI,
  [10640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1920), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      anon_sym_SEMI,
  [10659] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(1924), 1,
      sym_yul_decimal_number,
    ACTIONS(1926), 1,
      sym_yul_hex_number,
    STATE(266), 1,
      sym_string,
    ACTIONS(1928), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(694), 3,
      sym__yul_literal,
      sym_yul_string_literal,
      sym_yul_boolean,
  [10687] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(1930), 1,
      sym_identifier,
    ACTIONS(1932), 1,
      anon_sym_STAR,
    ACTIONS(1934), 1,
      anon_sym_LBRACE,
    STATE(643), 1,
      sym_string,
    STATE(723), 1,
      sym__source_import,
    STATE(726), 1,
      sym__import_clause,
    STATE(827), 1,
      sym__single_import,
    STATE(846), 1,
      sym__multiple_import,
  [10721] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(1938), 1,
      anon_sym_override,
    ACTIONS(1940), 1,
      sym_virtual,
    ACTIONS(1942), 1,
      anon_sym_SEMI,
    STATE(207), 1,
      sym_function_body,
    STATE(208), 1,
      sym__semicolon,
    STATE(512), 1,
      sym__parameter_list,
    STATE(511), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [10753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 9,
      anon_sym_constant,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_identifier,
  [10768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1946), 9,
      anon_sym_constant,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_identifier,
  [10783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 9,
      anon_sym_constant,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_transient,
      sym_immutable,
      anon_sym_override,
      sym_identifier,
  [10798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1952), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1950), 7,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      anon_sym_SEMI,
  [10815] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_function_body,
    STATE(489), 1,
      sym__identifier_path,
    STATE(507), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1954), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [10840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    STATE(198), 1,
      sym_function_body,
    STATE(489), 1,
      sym__identifier_path,
    STATE(510), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1956), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [10865] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1938), 1,
      anon_sym_override,
    ACTIONS(1958), 1,
      sym_virtual,
    ACTIONS(1960), 1,
      anon_sym_SEMI,
    STATE(201), 1,
      sym_function_body,
    STATE(202), 1,
      sym__semicolon,
    STATE(514), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [10891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(1962), 1,
      sym_identifier,
    STATE(642), 1,
      sym__storage_location,
    ACTIONS(1964), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1966), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [10913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1968), 1,
      sym_identifier,
    ACTIONS(1971), 1,
      anon_sym_LBRACE,
    STATE(489), 1,
      sym__identifier_path,
    STATE(510), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1973), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [10935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1938), 1,
      anon_sym_override,
    ACTIONS(1958), 1,
      sym_virtual,
    ACTIONS(1976), 1,
      anon_sym_SEMI,
    STATE(196), 1,
      sym_function_body,
    STATE(197), 1,
      sym__semicolon,
    STATE(514), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [10961] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(1938), 1,
      anon_sym_override,
    ACTIONS(1976), 1,
      anon_sym_SEMI,
    ACTIONS(1978), 1,
      sym_virtual,
    STATE(196), 1,
      sym_function_body,
    STATE(197), 1,
      sym__semicolon,
    STATE(508), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [10987] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    STATE(796), 1,
      sym__storage_location,
    ACTIONS(1980), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1982), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [11006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1986), 1,
      anon_sym_override,
    ACTIONS(1989), 1,
      sym_virtual,
    ACTIONS(1984), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
    STATE(514), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [11024] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym_unchecked,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(1992), 1,
      sym_identifier,
    STATE(98), 1,
      sym_block_statement,
    STATE(617), 1,
      sym__parameter_list,
  [11046] = 5,
    ACTIONS(1994), 1,
      anon_sym_DQUOTE,
    ACTIONS(1996), 1,
      sym__escape_sequence,
    ACTIONS(1998), 1,
      aux_sym__double_quoted_unicode_char_token1,
    ACTIONS(2000), 1,
      sym_comment,
    STATE(530), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [11063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    ACTIONS(2004), 1,
      anon_sym_LBRACE,
    STATE(336), 1,
      sym__identifier_path,
    STATE(561), 1,
      sym_user_defined_type,
    STATE(716), 1,
      sym_inheritance_specifier,
  [11082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      sym_identifier,
    ACTIONS(2010), 1,
      anon_sym_indexed,
    ACTIONS(2008), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11099] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    ACTIONS(2012), 1,
      anon_sym_LBRACE,
    STATE(336), 1,
      sym__identifier_path,
    STATE(561), 1,
      sym_user_defined_type,
    STATE(716), 1,
      sym_inheritance_specifier,
  [11118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2014), 1,
      sym__hex_digit,
    ACTIONS(2019), 1,
      anon_sym__,
    STATE(520), 1,
      aux_sym_hex_string_literal_repeat1,
    ACTIONS(2017), 2,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [11135] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_DQUOTE,
    ACTIONS(2024), 1,
      sym__escape_sequence,
    ACTIONS(2026), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(524), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [11152] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_SQUOTE,
    ACTIONS(2028), 1,
      sym__escape_sequence,
    ACTIONS(2030), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(525), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [11169] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2032), 1,
      anon_sym_SQUOTE,
    ACTIONS(2034), 1,
      sym__escape_sequence,
    ACTIONS(2037), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(523), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [11186] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_DQUOTE,
    ACTIONS(2042), 1,
      sym__escape_sequence,
    ACTIONS(2044), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(528), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [11203] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_SQUOTE,
    ACTIONS(2046), 1,
      sym__escape_sequence,
    ACTIONS(2048), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(523), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [11220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2050), 1,
      sym_identifier,
    ACTIONS(2052), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [11235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym_identifier,
    ACTIONS(2056), 1,
      anon_sym_solidity,
    STATE(494), 1,
      sym__solidity,
    STATE(739), 2,
      sym_solidity_pragma_token,
      sym_any_pragma_token,
  [11252] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2058), 1,
      anon_sym_DQUOTE,
    ACTIONS(2060), 1,
      sym__escape_sequence,
    ACTIONS(2063), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(528), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [11269] = 5,
    ACTIONS(1994), 1,
      anon_sym_SQUOTE,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2066), 1,
      sym__escape_sequence,
    ACTIONS(2068), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(531), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [11286] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2042), 1,
      sym__escape_sequence,
    ACTIONS(2044), 1,
      aux_sym__double_quoted_unicode_char_token1,
    ACTIONS(2070), 1,
      anon_sym_DQUOTE,
    STATE(528), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [11303] = 5,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2046), 1,
      sym__escape_sequence,
    ACTIONS(2048), 1,
      aux_sym__single_quoted_unicode_char_token1,
    ACTIONS(2070), 1,
      anon_sym_SQUOTE,
    STATE(523), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [11320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 4,
      sym__hex_digit,
      anon_sym_DQUOTE,
      anon_sym__,
      anon_sym_SQUOTE,
  [11330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(261), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(295), 1,
      sym_yul_block,
  [11346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(268), 1,
      sym_yul_identifier,
    STATE(296), 1,
      sym_yul_block,
  [11362] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_COMMA,
    STATE(261), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(296), 1,
      sym_yul_block,
  [11378] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2076), 1,
      anon_sym_COMMA,
    STATE(296), 1,
      sym_yul_block,
    STATE(539), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11394] = 4,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2078), 1,
      anon_sym_SQUOTE,
    ACTIONS(2080), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(537), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [11408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(268), 1,
      sym_yul_identifier,
    STATE(311), 1,
      sym_yul_block,
  [11424] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2083), 1,
      anon_sym_COMMA,
    STATE(261), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(311), 1,
      sym_yul_block,
  [11440] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(268), 1,
      sym_yul_identifier,
    STATE(298), 1,
      sym_yul_block,
  [11456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1774), 1,
      anon_sym_LBRACE,
    ACTIONS(2085), 1,
      anon_sym_SEMI,
    STATE(181), 1,
      sym_function_body,
    STATE(183), 1,
      sym__semicolon,
  [11472] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    ACTIONS(2089), 1,
      anon_sym_is,
    STATE(174), 1,
      sym_contract_body,
    STATE(794), 1,
      sym__class_heritage,
  [11488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(2091), 1,
      anon_sym_SEMI,
    STATE(223), 1,
      sym_function_body,
    STATE(224), 1,
      sym__semicolon,
  [11504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    ACTIONS(2093), 1,
      anon_sym_RPAREN,
    STATE(336), 1,
      sym__identifier_path,
    STATE(786), 1,
      sym_user_defined_type,
  [11520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2095), 1,
      sym__hex_digit,
    ACTIONS(2097), 1,
      anon_sym_DQUOTE,
    ACTIONS(2099), 1,
      anon_sym__,
    STATE(559), 1,
      aux_sym_hex_string_literal_repeat1,
  [11536] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(2101), 1,
      anon_sym_RPAREN,
    STATE(744), 1,
      sym_string,
  [11552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    ACTIONS(2089), 1,
      anon_sym_is,
    STATE(155), 1,
      sym_contract_body,
    STATE(799), 1,
      sym__class_heritage,
  [11568] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_as,
    STATE(758), 1,
      sym__import_alias,
    ACTIONS(2103), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [11582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(2107), 1,
      anon_sym_RPAREN,
    STATE(626), 1,
      sym_string,
  [11598] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 1,
      anon_sym_SQUOTE,
    ACTIONS(2099), 1,
      anon_sym__,
    ACTIONS(2109), 1,
      sym__hex_digit,
    STATE(573), 1,
      aux_sym_hex_string_literal_repeat1,
  [11614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1766), 1,
      anon_sym_LBRACE,
    ACTIONS(2111), 1,
      anon_sym_SEMI,
    STATE(229), 1,
      sym_function_body,
    STATE(230), 1,
      sym__semicolon,
  [11630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2113), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [11640] = 4,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_DQUOTE,
    ACTIONS(2117), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(566), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [11654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      anon_sym_LBRACE,
    ACTIONS(2121), 1,
      anon_sym_LPAREN,
    ACTIONS(2123), 1,
      anon_sym_DQUOTEevmasm_DQUOTE,
    STATE(804), 1,
      sym_assembly_flags,
  [11670] = 4,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2115), 1,
      anon_sym_SQUOTE,
    ACTIONS(2125), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(537), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [11684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2127), 1,
      anon_sym_COMMA,
    STATE(292), 1,
      sym_yul_block,
    STATE(564), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11700] = 4,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2129), 1,
      anon_sym_DQUOTE,
    ACTIONS(2131), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(553), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [11714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    ACTIONS(2133), 1,
      anon_sym_RPAREN,
    STATE(744), 1,
      sym_string,
  [11730] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2099), 1,
      anon_sym__,
    ACTIONS(2135), 1,
      sym__hex_digit,
    ACTIONS(2137), 1,
      anon_sym_DQUOTE,
    STATE(520), 1,
      aux_sym_hex_string_literal_repeat1,
  [11746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    ACTIONS(2139), 1,
      anon_sym_RPAREN,
    STATE(336), 1,
      sym__identifier_path,
    STATE(786), 1,
      sym_user_defined_type,
  [11762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    STATE(709), 1,
      sym__call_arguments,
    ACTIONS(2141), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [11776] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 1,
      sym_identifier,
    ACTIONS(2145), 1,
      anon_sym_COMMA,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    STATE(649), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [11792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(268), 1,
      sym_yul_identifier,
    STATE(294), 1,
      sym_yul_block,
  [11808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2149), 1,
      anon_sym_COMMA,
    STATE(261), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(294), 1,
      sym_yul_block,
  [11824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2149), 1,
      anon_sym_COMMA,
    STATE(294), 1,
      sym_yul_block,
    STATE(533), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11840] = 4,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2151), 1,
      anon_sym_DQUOTE,
    ACTIONS(2153), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(566), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [11854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(268), 1,
      sym_yul_identifier,
    STATE(295), 1,
      sym_yul_block,
  [11870] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    ACTIONS(2089), 1,
      anon_sym_is,
    STATE(188), 1,
      sym_contract_body,
    STATE(732), 1,
      sym__class_heritage,
  [11886] = 4,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2129), 1,
      anon_sym_SQUOTE,
    ACTIONS(2156), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(555), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [11900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [11910] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    STATE(336), 1,
      sym__identifier_path,
    STATE(561), 1,
      sym_user_defined_type,
    STATE(624), 1,
      sym_inheritance_specifier,
  [11926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 4,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
  [11936] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2099), 1,
      anon_sym__,
    ACTIONS(2135), 1,
      sym__hex_digit,
    ACTIONS(2137), 1,
      anon_sym_SQUOTE,
    STATE(520), 1,
      aux_sym_hex_string_literal_repeat1,
  [11952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2162), 1,
      sym_identifier,
    ACTIONS(2164), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11966] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(295), 1,
      sym_yul_block,
    STATE(535), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1774), 1,
      anon_sym_LBRACE,
    ACTIONS(2166), 1,
      anon_sym_SEMI,
    STATE(171), 1,
      sym_function_body,
    STATE(178), 1,
      sym__semicolon,
  [11998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    STATE(336), 1,
      sym__identifier_path,
    STATE(561), 1,
      sym_user_defined_type,
    STATE(716), 1,
      sym_inheritance_specifier,
  [12014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2168), 1,
      anon_sym_COMMA,
    ACTIONS(2170), 1,
      anon_sym_RBRACE,
    STATE(686), 1,
      aux_sym_enum_body_repeat1,
  [12027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2172), 1,
      anon_sym_default,
    ACTIONS(2174), 1,
      anon_sym_case,
    STATE(271), 1,
      aux_sym_yul_switch_statement_repeat1,
  [12040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_EQ,
    ACTIONS(2178), 1,
      anon_sym_SEMI,
    STATE(93), 1,
      sym__semicolon,
  [12053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_RPAREN,
    ACTIONS(2180), 1,
      anon_sym_COMMA,
    STATE(608), 1,
      aux_sym_assembly_flags_repeat1,
  [12066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(589), 1,
      anon_sym_RPAREN,
    ACTIONS(2182), 1,
      sym_identifier,
    ACTIONS(2184), 1,
      anon_sym_COMMA,
  [12079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(589), 1,
      anon_sym_RPAREN,
    ACTIONS(2186), 1,
      anon_sym_COMMA,
    STATE(584), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [12092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 1,
      anon_sym_COMMA,
    ACTIONS(2191), 1,
      anon_sym_RPAREN,
    STATE(584), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [12105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    STATE(336), 1,
      sym__identifier_path,
    STATE(687), 1,
      sym_user_defined_type,
  [12118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(1694), 1,
      sym_unchecked,
    STATE(616), 1,
      sym_block_statement,
  [12131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_RBRACE,
    STATE(764), 1,
      sym__import_declaration,
  [12144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2197), 1,
      anon_sym_RBRACE,
    STATE(764), 1,
      sym__import_declaration,
  [12157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 1,
      anon_sym_COMMA,
    ACTIONS(2202), 1,
      anon_sym_RPAREN,
    STATE(589), 1,
      aux_sym_override_specifier_repeat1,
  [12170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2206), 1,
      anon_sym_RBRACE,
    STATE(597), 1,
      aux_sym__multiple_import_repeat1,
  [12183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_RPAREN,
    ACTIONS(2208), 1,
      anon_sym_COMMA,
    STATE(592), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [12196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2210), 1,
      anon_sym_COMMA,
    ACTIONS(2213), 1,
      anon_sym_RPAREN,
    STATE(592), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [12209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      sym_identifier,
    ACTIONS(2217), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      sym_call_struct_argument,
  [12222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2222), 1,
      anon_sym_RBRACE,
    STATE(594), 1,
      aux_sym_call_argument_repeat1,
  [12235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2224), 1,
      anon_sym_COMMA,
    ACTIONS(2226), 1,
      anon_sym_RPAREN,
    STATE(688), 1,
      aux_sym__return_parameters_repeat1,
  [12248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2228), 1,
      sym_identifier,
    ACTIONS(2230), 1,
      anon_sym_RPAREN,
  [12261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2232), 1,
      anon_sym_COMMA,
    ACTIONS(2235), 1,
      anon_sym_RBRACE,
    STATE(597), 1,
      aux_sym__multiple_import_repeat1,
  [12274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 1,
      anon_sym_COMMA,
    ACTIONS(2239), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [12287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(295), 1,
      anon_sym_RPAREN,
    ACTIONS(2241), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      aux_sym_tuple_expression_repeat1,
  [12300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1716), 1,
      anon_sym_RPAREN,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      aux_sym_tuple_expression_repeat1,
  [12313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    ACTIONS(2246), 1,
      anon_sym_RPAREN,
    STATE(629), 1,
      sym_yul_identifier,
  [12326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      sym_identifier,
    ACTIONS(2248), 1,
      anon_sym_RBRACE,
    STATE(611), 1,
      sym_call_struct_argument,
  [12339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2250), 1,
      anon_sym_COMMA,
    ACTIONS(2252), 1,
      anon_sym_RPAREN,
    STATE(630), 1,
      aux_sym_yul_function_call_repeat1,
  [12352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2254), 1,
      anon_sym_COMMA,
    ACTIONS(2256), 1,
      anon_sym_RPAREN,
    STATE(658), 1,
      aux_sym__call_arguments_repeat1,
  [12365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    ACTIONS(2258), 1,
      anon_sym_LPAREN,
    STATE(273), 1,
      sym_yul_identifier,
  [12378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(303), 1,
      anon_sym_RBRACK,
    ACTIONS(2260), 1,
      anon_sym_COMMA,
    STATE(683), 1,
      aux_sym_inline_array_expression_repeat1,
  [12391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    STATE(336), 1,
      sym__identifier_path,
    STATE(831), 1,
      sym_user_defined_type,
  [12404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_COMMA,
    ACTIONS(2265), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      aux_sym_assembly_flags_repeat1,
  [12417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      sym_identifier,
    ACTIONS(2269), 1,
      anon_sym_RBRACE,
    STATE(771), 1,
      sym_struct_field_assignment,
  [12430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(2271), 1,
      sym_identifier,
    STATE(475), 1,
      sym__parameter_list,
  [12443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 1,
      anon_sym_COMMA,
    ACTIONS(2275), 1,
      anon_sym_RBRACE,
    STATE(671), 1,
      aux_sym_call_argument_repeat1,
  [12456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 1,
      sym_identifier,
    ACTIONS(2184), 1,
      anon_sym_COMMA,
    ACTIONS(2277), 1,
      anon_sym_RPAREN,
  [12469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2182), 1,
      sym_identifier,
    ACTIONS(2184), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_EQ,
    ACTIONS(2281), 1,
      anon_sym_SEMI,
    STATE(210), 1,
      sym__semicolon,
  [12493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 1,
      anon_sym_RBRACE,
    ACTIONS(2283), 1,
      anon_sym_COMMA,
    STATE(681), 1,
      aux_sym_struct_expression_repeat1,
  [12506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 1,
      anon_sym_catch,
    STATE(91), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [12517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(1694), 1,
      sym_unchecked,
    STATE(102), 1,
      sym_block_statement,
  [12530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_anonymous,
    ACTIONS(2289), 1,
      anon_sym_SEMI,
    STATE(168), 1,
      sym__semicolon,
  [12543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    STATE(336), 1,
      sym__identifier_path,
    STATE(786), 1,
      sym_user_defined_type,
  [12556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_as,
    ACTIONS(2291), 1,
      anon_sym_from,
    STATE(847), 1,
      sym__import_alias,
  [12569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    ACTIONS(2293), 1,
      anon_sym_RPAREN,
    STATE(268), 1,
      sym_yul_identifier,
  [12582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    ACTIONS(2295), 1,
      sym_identifier,
    STATE(329), 1,
      sym__parameter_list,
  [12595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 1,
      anon_sym_RPAREN,
    ACTIONS(2297), 1,
      anon_sym_COMMA,
    STATE(261), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [12608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 1,
      anon_sym_LBRACE,
    ACTIONS(2301), 1,
      anon_sym_COMMA,
    STATE(637), 1,
      aux_sym__class_heritage_repeat1,
  [12621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      anon_sym_COMMA,
    ACTIONS(2305), 1,
      anon_sym_RBRACE,
    STATE(615), 1,
      aux_sym_struct_expression_repeat1,
  [12634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 1,
      anon_sym_COMMA,
    ACTIONS(2309), 1,
      anon_sym_RPAREN,
    STATE(581), 1,
      aux_sym_assembly_flags_repeat1,
  [12647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2311), 1,
      anon_sym_COMMA,
    ACTIONS(2313), 1,
      anon_sym_RPAREN,
    STATE(656), 1,
      aux_sym_error_declaration_repeat1,
  [12660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      anon_sym_DASH_GT,
    STATE(297), 1,
      sym_yul_block,
  [12673] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2317), 1,
      anon_sym_COMMA,
    ACTIONS(2319), 1,
      anon_sym_RPAREN,
    STATE(640), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [12686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 1,
      anon_sym_RPAREN,
    ACTIONS(2321), 1,
      anon_sym_COMMA,
    STATE(641), 1,
      aux_sym_yul_function_call_repeat1,
  [12699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(253), 1,
      sym_yul_identifier,
    STATE(272), 1,
      sym_yul_path,
  [12712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    STATE(744), 1,
      sym_string,
  [12725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_COMMA,
    ACTIONS(2325), 1,
      anon_sym_RBRACE,
    STATE(665), 1,
      aux_sym_enum_body_repeat1,
  [12738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2327), 1,
      sym_identifier,
    ACTIONS(2329), 1,
      anon_sym_RPAREN,
  [12751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      anon_sym_COMMA,
    ACTIONS(2333), 1,
      anon_sym_RPAREN,
    STATE(674), 1,
      aux_sym__event_parameter_list_repeat1,
  [12764] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    ACTIONS(2335), 1,
      anon_sym_RPAREN,
    STATE(268), 1,
      sym_yul_identifier,
  [12777] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2004), 1,
      anon_sym_LBRACE,
    ACTIONS(2337), 1,
      anon_sym_COMMA,
    STATE(650), 1,
      aux_sym__class_heritage_repeat1,
  [12790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    ACTIONS(2339), 1,
      anon_sym_RPAREN,
    STATE(268), 1,
      sym_yul_identifier,
  [12803] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2341), 1,
      anon_sym_DASH_GT,
    STATE(282), 1,
      sym_yul_block,
  [12816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_RPAREN,
    ACTIONS(2343), 1,
      anon_sym_COMMA,
    STATE(261), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [12829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2345), 1,
      anon_sym_COMMA,
    ACTIONS(2348), 1,
      anon_sym_RPAREN,
    STATE(641), 1,
      aux_sym_yul_function_call_repeat1,
  [12842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 1,
      sym_identifier,
    ACTIONS(2352), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_as,
    ACTIONS(2354), 1,
      anon_sym_SEMI,
    STATE(838), 1,
      sym__import_alias,
  [12866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 1,
      anon_sym_EQ,
    ACTIONS(2358), 1,
      anon_sym_SEMI,
    STATE(199), 1,
      sym__semicolon,
  [12879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_RPAREN,
    ACTIONS(2182), 1,
      sym_identifier,
    ACTIONS(2184), 1,
      anon_sym_COMMA,
  [12892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_RPAREN,
    ACTIONS(2360), 1,
      anon_sym_COMMA,
    STATE(583), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [12905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2362), 1,
      anon_sym_DASH_GT,
    STATE(292), 1,
      sym_yul_block,
  [12918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    ACTIONS(2364), 1,
      anon_sym_RPAREN,
    STATE(268), 1,
      sym_yul_identifier,
  [12931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(587), 1,
      anon_sym_RPAREN,
    ACTIONS(2360), 1,
      anon_sym_COMMA,
    STATE(584), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [12944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 1,
      anon_sym_LBRACE,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    STATE(650), 1,
      aux_sym__class_heritage_repeat1,
  [12957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(615), 1,
      anon_sym_RPAREN,
    ACTIONS(2371), 1,
      anon_sym_COMMA,
    STATE(684), 1,
      aux_sym__parameter_list_repeat1,
  [12970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    ACTIONS(2373), 1,
      anon_sym_DASH_GT,
    STATE(294), 1,
      sym_yul_block,
  [12983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 1,
      anon_sym_COMMA,
    ACTIONS(2378), 1,
      anon_sym_RPAREN,
    STATE(653), 1,
      aux_sym_error_declaration_repeat1,
  [12996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 1,
      anon_sym_catch,
    STATE(89), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [13007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2380), 1,
      anon_sym_SEMI,
    STATE(200), 1,
      sym__semicolon,
  [13020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(601), 1,
      anon_sym_RPAREN,
    ACTIONS(2382), 1,
      anon_sym_COMMA,
    STATE(653), 1,
      aux_sym_error_declaration_repeat1,
  [13033] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 1,
      anon_sym_COMMA,
    ACTIONS(2386), 1,
      anon_sym_RPAREN,
    STATE(651), 1,
      aux_sym__parameter_list_repeat1,
  [13046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(275), 1,
      anon_sym_RPAREN,
    ACTIONS(2388), 1,
      anon_sym_COMMA,
    STATE(673), 1,
      aux_sym__call_arguments_repeat1,
  [13059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      sym_identifier,
    ACTIONS(2390), 1,
      anon_sym_RBRACE,
    STATE(625), 1,
      sym_struct_field_assignment,
  [13072] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_RPAREN,
    ACTIONS(2392), 1,
      anon_sym_COMMA,
    STATE(589), 1,
      aux_sym_override_specifier_repeat1,
  [13085] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_COMMA,
    ACTIONS(2397), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      aux_sym_enum_body_repeat1,
  [13098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2399), 1,
      anon_sym_anonymous,
    ACTIONS(2401), 1,
      anon_sym_SEMI,
    STATE(214), 1,
      sym__semicolon,
  [13111] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2403), 1,
      anon_sym_COMMA,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
    STATE(663), 1,
      aux_sym__return_parameters_repeat1,
  [13124] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_COMMA,
    ACTIONS(2411), 1,
      anon_sym_RPAREN,
    STATE(664), 1,
      aux_sym__event_parameter_list_repeat1,
  [13137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 1,
      anon_sym_COMMA,
    ACTIONS(2415), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      aux_sym_enum_body_repeat1,
  [13150] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    ACTIONS(2417), 1,
      anon_sym_COMMA,
    STATE(591), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [13163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    ACTIONS(2417), 1,
      anon_sym_COMMA,
    STATE(592), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [13176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      sym_identifier,
    ACTIONS(2419), 1,
      anon_sym_RBRACE,
    STATE(697), 1,
      sym_call_struct_argument,
  [13189] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2421), 1,
      anon_sym_COMMA,
    ACTIONS(2423), 1,
      anon_sym_RBRACE,
    STATE(590), 1,
      aux_sym__multiple_import_repeat1,
  [13202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2178), 1,
      anon_sym_SEMI,
    ACTIONS(2425), 1,
      anon_sym_EQ,
    STATE(93), 1,
      sym__semicolon,
  [13215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 1,
      anon_sym_RBRACE,
    ACTIONS(2427), 1,
      anon_sym_COMMA,
    STATE(594), 1,
      aux_sym_call_argument_repeat1,
  [13228] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 1,
      anon_sym_LPAREN,
    ACTIONS(2429), 1,
      anon_sym_LBRACE,
    STATE(855), 1,
      sym_assembly_flags,
  [13241] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 1,
      anon_sym_COMMA,
    ACTIONS(2434), 1,
      anon_sym_RPAREN,
    STATE(673), 1,
      aux_sym__call_arguments_repeat1,
  [13254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(621), 1,
      anon_sym_RPAREN,
    ACTIONS(2436), 1,
      anon_sym_COMMA,
    STATE(664), 1,
      aux_sym__event_parameter_list_repeat1,
  [13267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 1,
      sym_identifier,
    ACTIONS(2440), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2442), 1,
      anon_sym_RBRACE,
    STATE(669), 1,
      sym__import_declaration,
  [13291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2105), 1,
      anon_sym_as,
    ACTIONS(2444), 1,
      anon_sym_from,
    STATE(806), 1,
      sym__import_alias,
  [13304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(101), 1,
      anon_sym_SQUOTE,
    STATE(832), 1,
      sym_string,
  [13317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(291), 1,
      anon_sym_RPAREN,
    ACTIONS(1688), 1,
      anon_sym_COMMA,
    STATE(600), 1,
      aux_sym_tuple_expression_repeat1,
  [13330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      sym_identifier,
    ACTIONS(2446), 1,
      anon_sym_RBRACE,
    STATE(771), 1,
      sym_struct_field_assignment,
  [13343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_COMMA,
    ACTIONS(2451), 1,
      anon_sym_RBRACE,
    STATE(681), 1,
      aux_sym_struct_expression_repeat1,
  [13356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 1,
      anon_sym_COMMA,
    ACTIONS(2455), 1,
      anon_sym_RPAREN,
    STATE(685), 1,
      aux_sym_error_declaration_repeat1,
  [13369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 1,
      anon_sym_RBRACK,
    ACTIONS(2457), 1,
      anon_sym_COMMA,
    STATE(683), 1,
      aux_sym_inline_array_expression_repeat1,
  [13382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_COMMA,
    ACTIONS(2463), 1,
      anon_sym_RPAREN,
    STATE(684), 1,
      aux_sym__parameter_list_repeat1,
  [13395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(609), 1,
      anon_sym_RPAREN,
    ACTIONS(2465), 1,
      anon_sym_COMMA,
    STATE(653), 1,
      aux_sym_error_declaration_repeat1,
  [13408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 1,
      anon_sym_COMMA,
    ACTIONS(2469), 1,
      anon_sym_RBRACE,
    STATE(661), 1,
      aux_sym_enum_body_repeat1,
  [13421] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 1,
      anon_sym_COMMA,
    ACTIONS(2473), 1,
      anon_sym_RPAREN,
    STATE(660), 1,
      aux_sym_override_specifier_repeat1,
  [13434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 1,
      anon_sym_COMMA,
    ACTIONS(2477), 1,
      anon_sym_RPAREN,
    STATE(663), 1,
      aux_sym__return_parameters_repeat1,
  [13447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(1694), 1,
      sym_unchecked,
    STATE(103), 1,
      sym_block_statement,
  [13460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(251), 1,
      sym_yul_identifier,
  [13478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(476), 1,
      sym__parameter_list,
  [13488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 1,
      anon_sym_SEMI,
    STATE(158), 1,
      sym__semicolon,
  [13498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_yul_block,
  [13508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(310), 1,
      sym_yul_block,
  [13518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2222), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [13534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2483), 1,
      sym_identifier,
  [13544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_SEMI,
    STATE(120), 1,
      sym__semicolon,
  [13554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      sym_identifier,
    STATE(771), 1,
      sym_struct_field_assignment,
  [13564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 2,
      anon_sym_anonymous,
      anon_sym_SEMI,
  [13572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    STATE(764), 1,
      sym__import_declaration,
  [13582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(329), 1,
      sym__parameter_list,
  [13592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(268), 1,
      sym_yul_identifier,
  [13602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2489), 1,
      anon_sym_SEMI,
    STATE(189), 1,
      sym__semicolon,
  [13612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(556), 1,
      sym_yul_identifier,
  [13622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2491), 1,
      anon_sym_RPAREN,
  [13632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(312), 1,
      sym_yul_block,
  [13642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2493), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [13650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2348), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13666] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(787), 1,
      sym_yul_block,
  [13676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2497), 1,
      sym_identifier,
    ACTIONS(2499), 1,
      anon_sym_EQ_GT,
  [13686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(289), 1,
      sym_yul_block,
  [13696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(565), 1,
      sym_yul_identifier,
  [13706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [13714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2501), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2503), 1,
      anon_sym_LBRACE,
    STATE(179), 1,
      sym_enum_body,
  [13732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 1,
      anon_sym_SEMI,
    STATE(170), 1,
      sym__semicolon,
  [13742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 1,
      anon_sym_SEMI,
    STATE(175), 1,
      sym__semicolon,
  [13752] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2378), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2380), 1,
      anon_sym_SEMI,
    STATE(200), 1,
      sym__semicolon,
  [13770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 1,
      anon_sym_SEMI,
    STATE(152), 1,
      sym__semicolon,
  [13780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(575), 1,
      sym_yul_identifier,
  [13790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_SEMI,
    STATE(164), 1,
      sym__semicolon,
  [13800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2513), 1,
      anon_sym_from,
    STATE(772), 1,
      sym__from_clause,
  [13810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(586), 1,
      sym__parameter_list,
  [13820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 2,
      anon_sym_anonymous,
      anon_sym_SEMI,
  [13828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 1,
      anon_sym_SEMI,
    STATE(191), 1,
      sym__semicolon,
  [13838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(536), 1,
      sym_yul_identifier,
  [13848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(753), 1,
      sym__parameter_list,
  [13858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    STATE(166), 1,
      sym_contract_body,
  [13868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [13900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 1,
      anon_sym_SEMI,
    STATE(246), 1,
      sym__semicolon,
  [13910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2529), 1,
      anon_sym_RBRACE,
  [13920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_SEMI,
    STATE(161), 1,
      sym__semicolon,
  [13930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 2,
      anon_sym_anonymous,
      anon_sym_SEMI,
  [13938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1468), 1,
      anon_sym_LPAREN,
    STATE(400), 1,
      sym__call_arguments,
  [13956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(598), 1,
      sym_yul_identifier,
  [13966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2265), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [13974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2535), 1,
      anon_sym_SEMI,
    STATE(217), 1,
      sym__semicolon,
  [13984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      anon_sym_SEMI,
    STATE(218), 1,
      sym__semicolon,
  [13994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      anon_sym_SEMI,
    STATE(221), 1,
      sym__semicolon,
  [14012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 1,
      anon_sym_RBRACE,
    ACTIONS(2527), 1,
      sym_identifier,
  [14022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_SEMI,
    STATE(226), 1,
      sym__semicolon,
  [14032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 1,
      sym_identifier,
    STATE(814), 1,
      sym_yul_identifier,
  [14042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_LPAREN,
    STATE(618), 1,
      sym__event_parameter_list,
  [14052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 2,
      anon_sym_LBRACE,
      anon_sym_SEMI,
  [14060] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 1,
      anon_sym_SEMI,
    STATE(121), 1,
      sym__semicolon,
  [14070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_SEMI,
    STATE(122), 1,
      sym__semicolon,
  [14080] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_yul_block,
  [14090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [14106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 1,
      anon_sym_SEMI,
    STATE(122), 1,
      sym__semicolon,
  [14116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 1,
      anon_sym_SEMI,
    STATE(231), 1,
      sym__semicolon,
  [14126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 2,
      anon_sym_anonymous,
      anon_sym_SEMI,
  [14142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_SEMI,
    STATE(104), 1,
      sym__semicolon,
  [14152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [14160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(689), 1,
      sym__parameter_list,
  [14170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_SEMI,
    STATE(104), 1,
      sym__semicolon,
  [14180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_SEMI,
    STATE(194), 1,
      sym__semicolon,
  [14190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      sym_identifier,
    ACTIONS(2571), 1,
      anon_sym_RBRACE,
  [14208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(506), 1,
      sym__parameter_list,
  [14218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2451), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [14226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_SEMI,
    STATE(186), 1,
      sym__semicolon,
  [14236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_SEMI,
    STATE(120), 1,
      sym__semicolon,
  [14254] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14262] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14270] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2579), 1,
      anon_sym_LBRACE,
    STATE(211), 1,
      sym_struct_body,
  [14280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_LBRACE,
    STATE(212), 1,
      sym_enum_body,
  [14290] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_LPAREN,
    STATE(662), 1,
      sym__event_parameter_list,
  [14300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(477), 1,
      sym__parameter_list,
  [14310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    STATE(167), 1,
      sym_contract_body,
  [14320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      sym_identifier,
    ACTIONS(2585), 1,
      anon_sym_RBRACE,
  [14330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      sym_identifier,
    STATE(697), 1,
      sym_call_struct_argument,
  [14340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1936), 1,
      anon_sym_LPAREN,
    STATE(480), 1,
      sym__parameter_list,
  [14350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 1,
      anon_sym_DQUOTE,
    ACTIONS(2589), 1,
      anon_sym_SQUOTE,
  [14360] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(845), 1,
      anon_sym_LBRACE,
    STATE(304), 1,
      sym_yul_block,
  [14378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 1,
      anon_sym_RBRACE,
    ACTIONS(2527), 1,
      sym_identifier,
  [14388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_LBRACK,
    ACTIONS(2591), 1,
      anon_sym_constant,
  [14398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      anon_sym_DQUOTE,
    ACTIONS(2595), 1,
      anon_sym_SQUOTE,
  [14408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      sym_identifier,
    ACTIONS(2597), 1,
      anon_sym_RBRACE,
  [14418] = 3,
    ACTIONS(2000), 1,
      sym_comment,
    ACTIONS(2599), 1,
      aux_sym_pragma_value_token1,
    STATE(822), 1,
      sym_pragma_value,
  [14428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2601), 1,
      anon_sym_LBRACE,
    STATE(190), 1,
      sym_struct_body,
  [14438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_contract_body,
  [14448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 1,
      anon_sym_while,
    ACTIONS(2603), 1,
      anon_sym_else,
  [14458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      sym__hex_digit,
    ACTIONS(2609), 1,
      anon_sym_DQUOTE,
  [14476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      anon_sym_SQUOTE,
    ACTIONS(2611), 1,
      sym__hex_digit,
  [14486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2087), 1,
      anon_sym_LBRACE,
    STATE(157), 1,
      sym_contract_body,
  [14496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 1,
      anon_sym_SEMI,
    STATE(121), 1,
      sym__semicolon,
  [14506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      sym_identifier,
  [14513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_SEMI,
  [14520] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 1,
      sym_identifier,
  [14527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2429), 1,
      anon_sym_LBRACE,
  [14534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      anon_sym_LPAREN,
  [14541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_from,
  [14548] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      anon_sym_EQ_GT,
  [14555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      sym_identifier,
  [14562] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_LPAREN,
  [14569] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2627), 1,
      sym_solidity_version,
  [14576] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 1,
      sym_identifier,
  [14583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_EQ,
  [14590] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_from,
  [14597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_LPAREN,
  [14604] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_LBRACE,
  [14611] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 1,
      anon_sym_COLON,
  [14618] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 1,
      sym_identifier,
  [14625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 1,
      sym_identifier,
  [14632] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym_identifier,
  [14639] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_contract,
  [14646] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      sym_identifier,
  [14653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 1,
      anon_sym_SEMI,
  [14660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 1,
      sym_identifier,
  [14667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 1,
      anon_sym_SEMI,
  [14674] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      anon_sym_EQ,
  [14681] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 1,
      anon_sym_while,
  [14688] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_from,
  [14695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 1,
      sym_identifier,
  [14702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_is,
  [14709] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      sym_solidity_version,
  [14716] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_for,
  [14723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_SEMI,
  [14730] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_LBRACE,
  [14737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_LBRACE,
  [14744] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_COLON,
  [14751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
  [14758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      sym_identifier,
  [14765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_SEMI,
  [14772] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2683), 1,
      ts_builtin_sym_end,
  [14779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2685), 1,
      anon_sym_LBRACE,
  [14786] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_EQ,
  [14793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      anon_sym_from,
  [14800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      sym_identifier,
  [14807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_LPAREN,
  [14814] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2695), 1,
      anon_sym_from,
  [14821] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_from,
  [14828] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_from,
  [14835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_EQ,
  [14842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
  [14849] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      anon_sym_LPAREN,
  [14856] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2705), 1,
      anon_sym_from,
  [14863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2707), 1,
      sym_identifier,
  [14870] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2709), 1,
      anon_sym_LPAREN,
  [14877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 1,
      sym__hex_digit,
  [14884] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2713), 1,
      anon_sym_LBRACE,
  [14891] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2176), 1,
      anon_sym_EQ,
  [14898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2715), 1,
      anon_sym_EQ,
  [14905] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2717), 1,
      anon_sym_LBRACE,
  [14912] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2719), 1,
      anon_sym_LPAREN,
  [14919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2721), 1,
      sym_identifier,
  [14926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2723), 1,
      sym_identifier,
  [14933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2725), 1,
      sym_identifier,
  [14940] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2727), 1,
      anon_sym_is,
  [14947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2729), 1,
      anon_sym_LPAREN,
  [14954] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2731), 1,
      sym_identifier,
  [14961] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2733), 1,
      sym_identifier,
  [14968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      anon_sym_EQ,
  [14975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2735), 1,
      anon_sym_LPAREN,
  [14982] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2737), 1,
      sym_identifier,
  [14989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2739), 1,
      anon_sym_from,
  [14996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 1,
      anon_sym_LPAREN,
  [15003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2741), 1,
      sym_identifier,
  [15010] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2743), 1,
      sym_identifier,
  [15017] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2745), 1,
      anon_sym_LPAREN,
  [15024] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2747), 1,
      anon_sym_LPAREN,
  [15031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2749), 1,
      anon_sym_RPAREN,
  [15038] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 1,
      anon_sym_LPAREN,
  [15045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 1,
      anon_sym_LPAREN,
  [15052] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2755), 1,
      anon_sym_while,
  [15059] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2757), 1,
      anon_sym_EQ,
  [15066] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(329)] = 0,
  [SMALL_STATE(330)] = 80,
  [SMALL_STATE(331)] = 150,
  [SMALL_STATE(332)] = 220,
  [SMALL_STATE(333)] = 290,
  [SMALL_STATE(334)] = 360,
  [SMALL_STATE(335)] = 430,
  [SMALL_STATE(336)] = 500,
  [SMALL_STATE(337)] = 568,
  [SMALL_STATE(338)] = 638,
  [SMALL_STATE(339)] = 705,
  [SMALL_STATE(340)] = 772,
  [SMALL_STATE(341)] = 838,
  [SMALL_STATE(342)] = 904,
  [SMALL_STATE(343)] = 970,
  [SMALL_STATE(344)] = 1036,
  [SMALL_STATE(345)] = 1102,
  [SMALL_STATE(346)] = 1168,
  [SMALL_STATE(347)] = 1234,
  [SMALL_STATE(348)] = 1300,
  [SMALL_STATE(349)] = 1366,
  [SMALL_STATE(350)] = 1432,
  [SMALL_STATE(351)] = 1498,
  [SMALL_STATE(352)] = 1564,
  [SMALL_STATE(353)] = 1630,
  [SMALL_STATE(354)] = 1696,
  [SMALL_STATE(355)] = 1762,
  [SMALL_STATE(356)] = 1831,
  [SMALL_STATE(357)] = 1894,
  [SMALL_STATE(358)] = 1957,
  [SMALL_STATE(359)] = 2020,
  [SMALL_STATE(360)] = 2083,
  [SMALL_STATE(361)] = 2147,
  [SMALL_STATE(362)] = 2205,
  [SMALL_STATE(363)] = 2265,
  [SMALL_STATE(364)] = 2323,
  [SMALL_STATE(365)] = 2386,
  [SMALL_STATE(366)] = 2449,
  [SMALL_STATE(367)] = 2508,
  [SMALL_STATE(368)] = 2567,
  [SMALL_STATE(369)] = 2626,
  [SMALL_STATE(370)] = 2685,
  [SMALL_STATE(371)] = 2744,
  [SMALL_STATE(372)] = 2810,
  [SMALL_STATE(373)] = 2874,
  [SMALL_STATE(374)] = 2948,
  [SMALL_STATE(375)] = 3018,
  [SMALL_STATE(376)] = 3112,
  [SMALL_STATE(377)] = 3174,
  [SMALL_STATE(378)] = 3232,
  [SMALL_STATE(379)] = 3290,
  [SMALL_STATE(380)] = 3344,
  [SMALL_STATE(381)] = 3428,
  [SMALL_STATE(382)] = 3508,
  [SMALL_STATE(383)] = 3586,
  [SMALL_STATE(384)] = 3640,
  [SMALL_STATE(385)] = 3694,
  [SMALL_STATE(386)] = 3766,
  [SMALL_STATE(387)] = 3834,
  [SMALL_STATE(388)] = 3888,
  [SMALL_STATE(389)] = 3948,
  [SMALL_STATE(390)] = 4002,
  [SMALL_STATE(391)] = 4062,
  [SMALL_STATE(392)] = 4156,
  [SMALL_STATE(393)] = 4238,
  [SMALL_STATE(394)] = 4298,
  [SMALL_STATE(395)] = 4351,
  [SMALL_STATE(396)] = 4404,
  [SMALL_STATE(397)] = 4457,
  [SMALL_STATE(398)] = 4510,
  [SMALL_STATE(399)] = 4563,
  [SMALL_STATE(400)] = 4616,
  [SMALL_STATE(401)] = 4669,
  [SMALL_STATE(402)] = 4722,
  [SMALL_STATE(403)] = 4775,
  [SMALL_STATE(404)] = 4836,
  [SMALL_STATE(405)] = 4889,
  [SMALL_STATE(406)] = 4942,
  [SMALL_STATE(407)] = 4995,
  [SMALL_STATE(408)] = 5048,
  [SMALL_STATE(409)] = 5101,
  [SMALL_STATE(410)] = 5154,
  [SMALL_STATE(411)] = 5207,
  [SMALL_STATE(412)] = 5260,
  [SMALL_STATE(413)] = 5313,
  [SMALL_STATE(414)] = 5366,
  [SMALL_STATE(415)] = 5419,
  [SMALL_STATE(416)] = 5472,
  [SMALL_STATE(417)] = 5525,
  [SMALL_STATE(418)] = 5578,
  [SMALL_STATE(419)] = 5631,
  [SMALL_STATE(420)] = 5684,
  [SMALL_STATE(421)] = 5737,
  [SMALL_STATE(422)] = 5790,
  [SMALL_STATE(423)] = 5843,
  [SMALL_STATE(424)] = 5896,
  [SMALL_STATE(425)] = 5949,
  [SMALL_STATE(426)] = 6002,
  [SMALL_STATE(427)] = 6055,
  [SMALL_STATE(428)] = 6111,
  [SMALL_STATE(429)] = 6171,
  [SMALL_STATE(430)] = 6223,
  [SMALL_STATE(431)] = 6316,
  [SMALL_STATE(432)] = 6409,
  [SMALL_STATE(433)] = 6502,
  [SMALL_STATE(434)] = 6595,
  [SMALL_STATE(435)] = 6685,
  [SMALL_STATE(436)] = 6775,
  [SMALL_STATE(437)] = 6865,
  [SMALL_STATE(438)] = 6953,
  [SMALL_STATE(439)] = 7043,
  [SMALL_STATE(440)] = 7133,
  [SMALL_STATE(441)] = 7183,
  [SMALL_STATE(442)] = 7271,
  [SMALL_STATE(443)] = 7361,
  [SMALL_STATE(444)] = 7449,
  [SMALL_STATE(445)] = 7537,
  [SMALL_STATE(446)] = 7627,
  [SMALL_STATE(447)] = 7717,
  [SMALL_STATE(448)] = 7807,
  [SMALL_STATE(449)] = 7897,
  [SMALL_STATE(450)] = 7987,
  [SMALL_STATE(451)] = 8077,
  [SMALL_STATE(452)] = 8165,
  [SMALL_STATE(453)] = 8252,
  [SMALL_STATE(454)] = 8339,
  [SMALL_STATE(455)] = 8426,
  [SMALL_STATE(456)] = 8513,
  [SMALL_STATE(457)] = 8564,
  [SMALL_STATE(458)] = 8651,
  [SMALL_STATE(459)] = 8702,
  [SMALL_STATE(460)] = 8789,
  [SMALL_STATE(461)] = 8876,
  [SMALL_STATE(462)] = 8963,
  [SMALL_STATE(463)] = 9014,
  [SMALL_STATE(464)] = 9065,
  [SMALL_STATE(465)] = 9152,
  [SMALL_STATE(466)] = 9239,
  [SMALL_STATE(467)] = 9326,
  [SMALL_STATE(468)] = 9413,
  [SMALL_STATE(469)] = 9461,
  [SMALL_STATE(470)] = 9509,
  [SMALL_STATE(471)] = 9557,
  [SMALL_STATE(472)] = 9641,
  [SMALL_STATE(473)] = 9725,
  [SMALL_STATE(474)] = 9765,
  [SMALL_STATE(475)] = 9805,
  [SMALL_STATE(476)] = 9870,
  [SMALL_STATE(477)] = 9922,
  [SMALL_STATE(478)] = 9974,
  [SMALL_STATE(479)] = 10026,
  [SMALL_STATE(480)] = 10078,
  [SMALL_STATE(481)] = 10124,
  [SMALL_STATE(482)] = 10170,
  [SMALL_STATE(483)] = 10211,
  [SMALL_STATE(484)] = 10249,
  [SMALL_STATE(485)] = 10276,
  [SMALL_STATE(486)] = 10307,
  [SMALL_STATE(487)] = 10331,
  [SMALL_STATE(488)] = 10355,
  [SMALL_STATE(489)] = 10379,
  [SMALL_STATE(490)] = 10406,
  [SMALL_STATE(491)] = 10442,
  [SMALL_STATE(492)] = 10463,
  [SMALL_STATE(493)] = 10496,
  [SMALL_STATE(494)] = 10529,
  [SMALL_STATE(495)] = 10559,
  [SMALL_STATE(496)] = 10589,
  [SMALL_STATE(497)] = 10619,
  [SMALL_STATE(498)] = 10640,
  [SMALL_STATE(499)] = 10659,
  [SMALL_STATE(500)] = 10687,
  [SMALL_STATE(501)] = 10721,
  [SMALL_STATE(502)] = 10753,
  [SMALL_STATE(503)] = 10768,
  [SMALL_STATE(504)] = 10783,
  [SMALL_STATE(505)] = 10798,
  [SMALL_STATE(506)] = 10815,
  [SMALL_STATE(507)] = 10840,
  [SMALL_STATE(508)] = 10865,
  [SMALL_STATE(509)] = 10891,
  [SMALL_STATE(510)] = 10913,
  [SMALL_STATE(511)] = 10935,
  [SMALL_STATE(512)] = 10961,
  [SMALL_STATE(513)] = 10987,
  [SMALL_STATE(514)] = 11006,
  [SMALL_STATE(515)] = 11024,
  [SMALL_STATE(516)] = 11046,
  [SMALL_STATE(517)] = 11063,
  [SMALL_STATE(518)] = 11082,
  [SMALL_STATE(519)] = 11099,
  [SMALL_STATE(520)] = 11118,
  [SMALL_STATE(521)] = 11135,
  [SMALL_STATE(522)] = 11152,
  [SMALL_STATE(523)] = 11169,
  [SMALL_STATE(524)] = 11186,
  [SMALL_STATE(525)] = 11203,
  [SMALL_STATE(526)] = 11220,
  [SMALL_STATE(527)] = 11235,
  [SMALL_STATE(528)] = 11252,
  [SMALL_STATE(529)] = 11269,
  [SMALL_STATE(530)] = 11286,
  [SMALL_STATE(531)] = 11303,
  [SMALL_STATE(532)] = 11320,
  [SMALL_STATE(533)] = 11330,
  [SMALL_STATE(534)] = 11346,
  [SMALL_STATE(535)] = 11362,
  [SMALL_STATE(536)] = 11378,
  [SMALL_STATE(537)] = 11394,
  [SMALL_STATE(538)] = 11408,
  [SMALL_STATE(539)] = 11424,
  [SMALL_STATE(540)] = 11440,
  [SMALL_STATE(541)] = 11456,
  [SMALL_STATE(542)] = 11472,
  [SMALL_STATE(543)] = 11488,
  [SMALL_STATE(544)] = 11504,
  [SMALL_STATE(545)] = 11520,
  [SMALL_STATE(546)] = 11536,
  [SMALL_STATE(547)] = 11552,
  [SMALL_STATE(548)] = 11568,
  [SMALL_STATE(549)] = 11582,
  [SMALL_STATE(550)] = 11598,
  [SMALL_STATE(551)] = 11614,
  [SMALL_STATE(552)] = 11630,
  [SMALL_STATE(553)] = 11640,
  [SMALL_STATE(554)] = 11654,
  [SMALL_STATE(555)] = 11670,
  [SMALL_STATE(556)] = 11684,
  [SMALL_STATE(557)] = 11700,
  [SMALL_STATE(558)] = 11714,
  [SMALL_STATE(559)] = 11730,
  [SMALL_STATE(560)] = 11746,
  [SMALL_STATE(561)] = 11762,
  [SMALL_STATE(562)] = 11776,
  [SMALL_STATE(563)] = 11792,
  [SMALL_STATE(564)] = 11808,
  [SMALL_STATE(565)] = 11824,
  [SMALL_STATE(566)] = 11840,
  [SMALL_STATE(567)] = 11854,
  [SMALL_STATE(568)] = 11870,
  [SMALL_STATE(569)] = 11886,
  [SMALL_STATE(570)] = 11900,
  [SMALL_STATE(571)] = 11910,
  [SMALL_STATE(572)] = 11926,
  [SMALL_STATE(573)] = 11936,
  [SMALL_STATE(574)] = 11952,
  [SMALL_STATE(575)] = 11966,
  [SMALL_STATE(576)] = 11982,
  [SMALL_STATE(577)] = 11998,
  [SMALL_STATE(578)] = 12014,
  [SMALL_STATE(579)] = 12027,
  [SMALL_STATE(580)] = 12040,
  [SMALL_STATE(581)] = 12053,
  [SMALL_STATE(582)] = 12066,
  [SMALL_STATE(583)] = 12079,
  [SMALL_STATE(584)] = 12092,
  [SMALL_STATE(585)] = 12105,
  [SMALL_STATE(586)] = 12118,
  [SMALL_STATE(587)] = 12131,
  [SMALL_STATE(588)] = 12144,
  [SMALL_STATE(589)] = 12157,
  [SMALL_STATE(590)] = 12170,
  [SMALL_STATE(591)] = 12183,
  [SMALL_STATE(592)] = 12196,
  [SMALL_STATE(593)] = 12209,
  [SMALL_STATE(594)] = 12222,
  [SMALL_STATE(595)] = 12235,
  [SMALL_STATE(596)] = 12248,
  [SMALL_STATE(597)] = 12261,
  [SMALL_STATE(598)] = 12274,
  [SMALL_STATE(599)] = 12287,
  [SMALL_STATE(600)] = 12300,
  [SMALL_STATE(601)] = 12313,
  [SMALL_STATE(602)] = 12326,
  [SMALL_STATE(603)] = 12339,
  [SMALL_STATE(604)] = 12352,
  [SMALL_STATE(605)] = 12365,
  [SMALL_STATE(606)] = 12378,
  [SMALL_STATE(607)] = 12391,
  [SMALL_STATE(608)] = 12404,
  [SMALL_STATE(609)] = 12417,
  [SMALL_STATE(610)] = 12430,
  [SMALL_STATE(611)] = 12443,
  [SMALL_STATE(612)] = 12456,
  [SMALL_STATE(613)] = 12469,
  [SMALL_STATE(614)] = 12480,
  [SMALL_STATE(615)] = 12493,
  [SMALL_STATE(616)] = 12506,
  [SMALL_STATE(617)] = 12517,
  [SMALL_STATE(618)] = 12530,
  [SMALL_STATE(619)] = 12543,
  [SMALL_STATE(620)] = 12556,
  [SMALL_STATE(621)] = 12569,
  [SMALL_STATE(622)] = 12582,
  [SMALL_STATE(623)] = 12595,
  [SMALL_STATE(624)] = 12608,
  [SMALL_STATE(625)] = 12621,
  [SMALL_STATE(626)] = 12634,
  [SMALL_STATE(627)] = 12647,
  [SMALL_STATE(628)] = 12660,
  [SMALL_STATE(629)] = 12673,
  [SMALL_STATE(630)] = 12686,
  [SMALL_STATE(631)] = 12699,
  [SMALL_STATE(632)] = 12712,
  [SMALL_STATE(633)] = 12725,
  [SMALL_STATE(634)] = 12738,
  [SMALL_STATE(635)] = 12751,
  [SMALL_STATE(636)] = 12764,
  [SMALL_STATE(637)] = 12777,
  [SMALL_STATE(638)] = 12790,
  [SMALL_STATE(639)] = 12803,
  [SMALL_STATE(640)] = 12816,
  [SMALL_STATE(641)] = 12829,
  [SMALL_STATE(642)] = 12842,
  [SMALL_STATE(643)] = 12853,
  [SMALL_STATE(644)] = 12866,
  [SMALL_STATE(645)] = 12879,
  [SMALL_STATE(646)] = 12892,
  [SMALL_STATE(647)] = 12905,
  [SMALL_STATE(648)] = 12918,
  [SMALL_STATE(649)] = 12931,
  [SMALL_STATE(650)] = 12944,
  [SMALL_STATE(651)] = 12957,
  [SMALL_STATE(652)] = 12970,
  [SMALL_STATE(653)] = 12983,
  [SMALL_STATE(654)] = 12996,
  [SMALL_STATE(655)] = 13007,
  [SMALL_STATE(656)] = 13020,
  [SMALL_STATE(657)] = 13033,
  [SMALL_STATE(658)] = 13046,
  [SMALL_STATE(659)] = 13059,
  [SMALL_STATE(660)] = 13072,
  [SMALL_STATE(661)] = 13085,
  [SMALL_STATE(662)] = 13098,
  [SMALL_STATE(663)] = 13111,
  [SMALL_STATE(664)] = 13124,
  [SMALL_STATE(665)] = 13137,
  [SMALL_STATE(666)] = 13150,
  [SMALL_STATE(667)] = 13163,
  [SMALL_STATE(668)] = 13176,
  [SMALL_STATE(669)] = 13189,
  [SMALL_STATE(670)] = 13202,
  [SMALL_STATE(671)] = 13215,
  [SMALL_STATE(672)] = 13228,
  [SMALL_STATE(673)] = 13241,
  [SMALL_STATE(674)] = 13254,
  [SMALL_STATE(675)] = 13267,
  [SMALL_STATE(676)] = 13278,
  [SMALL_STATE(677)] = 13291,
  [SMALL_STATE(678)] = 13304,
  [SMALL_STATE(679)] = 13317,
  [SMALL_STATE(680)] = 13330,
  [SMALL_STATE(681)] = 13343,
  [SMALL_STATE(682)] = 13356,
  [SMALL_STATE(683)] = 13369,
  [SMALL_STATE(684)] = 13382,
  [SMALL_STATE(685)] = 13395,
  [SMALL_STATE(686)] = 13408,
  [SMALL_STATE(687)] = 13421,
  [SMALL_STATE(688)] = 13434,
  [SMALL_STATE(689)] = 13447,
  [SMALL_STATE(690)] = 13460,
  [SMALL_STATE(691)] = 13468,
  [SMALL_STATE(692)] = 13478,
  [SMALL_STATE(693)] = 13488,
  [SMALL_STATE(694)] = 13498,
  [SMALL_STATE(695)] = 13508,
  [SMALL_STATE(696)] = 13518,
  [SMALL_STATE(697)] = 13526,
  [SMALL_STATE(698)] = 13534,
  [SMALL_STATE(699)] = 13544,
  [SMALL_STATE(700)] = 13554,
  [SMALL_STATE(701)] = 13564,
  [SMALL_STATE(702)] = 13572,
  [SMALL_STATE(703)] = 13582,
  [SMALL_STATE(704)] = 13592,
  [SMALL_STATE(705)] = 13602,
  [SMALL_STATE(706)] = 13612,
  [SMALL_STATE(707)] = 13622,
  [SMALL_STATE(708)] = 13632,
  [SMALL_STATE(709)] = 13642,
  [SMALL_STATE(710)] = 13650,
  [SMALL_STATE(711)] = 13658,
  [SMALL_STATE(712)] = 13666,
  [SMALL_STATE(713)] = 13676,
  [SMALL_STATE(714)] = 13686,
  [SMALL_STATE(715)] = 13696,
  [SMALL_STATE(716)] = 13706,
  [SMALL_STATE(717)] = 13714,
  [SMALL_STATE(718)] = 13722,
  [SMALL_STATE(719)] = 13732,
  [SMALL_STATE(720)] = 13742,
  [SMALL_STATE(721)] = 13752,
  [SMALL_STATE(722)] = 13760,
  [SMALL_STATE(723)] = 13770,
  [SMALL_STATE(724)] = 13780,
  [SMALL_STATE(725)] = 13790,
  [SMALL_STATE(726)] = 13800,
  [SMALL_STATE(727)] = 13810,
  [SMALL_STATE(728)] = 13820,
  [SMALL_STATE(729)] = 13828,
  [SMALL_STATE(730)] = 13838,
  [SMALL_STATE(731)] = 13848,
  [SMALL_STATE(732)] = 13858,
  [SMALL_STATE(733)] = 13868,
  [SMALL_STATE(734)] = 13876,
  [SMALL_STATE(735)] = 13884,
  [SMALL_STATE(736)] = 13892,
  [SMALL_STATE(737)] = 13900,
  [SMALL_STATE(738)] = 13910,
  [SMALL_STATE(739)] = 13920,
  [SMALL_STATE(740)] = 13930,
  [SMALL_STATE(741)] = 13938,
  [SMALL_STATE(742)] = 13946,
  [SMALL_STATE(743)] = 13956,
  [SMALL_STATE(744)] = 13966,
  [SMALL_STATE(745)] = 13974,
  [SMALL_STATE(746)] = 13984,
  [SMALL_STATE(747)] = 13994,
  [SMALL_STATE(748)] = 14002,
  [SMALL_STATE(749)] = 14012,
  [SMALL_STATE(750)] = 14022,
  [SMALL_STATE(751)] = 14032,
  [SMALL_STATE(752)] = 14042,
  [SMALL_STATE(753)] = 14052,
  [SMALL_STATE(754)] = 14060,
  [SMALL_STATE(755)] = 14070,
  [SMALL_STATE(756)] = 14080,
  [SMALL_STATE(757)] = 14090,
  [SMALL_STATE(758)] = 14098,
  [SMALL_STATE(759)] = 14106,
  [SMALL_STATE(760)] = 14116,
  [SMALL_STATE(761)] = 14126,
  [SMALL_STATE(762)] = 14134,
  [SMALL_STATE(763)] = 14142,
  [SMALL_STATE(764)] = 14152,
  [SMALL_STATE(765)] = 14160,
  [SMALL_STATE(766)] = 14170,
  [SMALL_STATE(767)] = 14180,
  [SMALL_STATE(768)] = 14190,
  [SMALL_STATE(769)] = 14198,
  [SMALL_STATE(770)] = 14208,
  [SMALL_STATE(771)] = 14218,
  [SMALL_STATE(772)] = 14226,
  [SMALL_STATE(773)] = 14236,
  [SMALL_STATE(774)] = 14244,
  [SMALL_STATE(775)] = 14254,
  [SMALL_STATE(776)] = 14262,
  [SMALL_STATE(777)] = 14270,
  [SMALL_STATE(778)] = 14280,
  [SMALL_STATE(779)] = 14290,
  [SMALL_STATE(780)] = 14300,
  [SMALL_STATE(781)] = 14310,
  [SMALL_STATE(782)] = 14320,
  [SMALL_STATE(783)] = 14330,
  [SMALL_STATE(784)] = 14340,
  [SMALL_STATE(785)] = 14350,
  [SMALL_STATE(786)] = 14360,
  [SMALL_STATE(787)] = 14368,
  [SMALL_STATE(788)] = 14378,
  [SMALL_STATE(789)] = 14388,
  [SMALL_STATE(790)] = 14398,
  [SMALL_STATE(791)] = 14408,
  [SMALL_STATE(792)] = 14418,
  [SMALL_STATE(793)] = 14428,
  [SMALL_STATE(794)] = 14438,
  [SMALL_STATE(795)] = 14448,
  [SMALL_STATE(796)] = 14458,
  [SMALL_STATE(797)] = 14466,
  [SMALL_STATE(798)] = 14476,
  [SMALL_STATE(799)] = 14486,
  [SMALL_STATE(800)] = 14496,
  [SMALL_STATE(801)] = 14506,
  [SMALL_STATE(802)] = 14513,
  [SMALL_STATE(803)] = 14520,
  [SMALL_STATE(804)] = 14527,
  [SMALL_STATE(805)] = 14534,
  [SMALL_STATE(806)] = 14541,
  [SMALL_STATE(807)] = 14548,
  [SMALL_STATE(808)] = 14555,
  [SMALL_STATE(809)] = 14562,
  [SMALL_STATE(810)] = 14569,
  [SMALL_STATE(811)] = 14576,
  [SMALL_STATE(812)] = 14583,
  [SMALL_STATE(813)] = 14590,
  [SMALL_STATE(814)] = 14597,
  [SMALL_STATE(815)] = 14604,
  [SMALL_STATE(816)] = 14611,
  [SMALL_STATE(817)] = 14618,
  [SMALL_STATE(818)] = 14625,
  [SMALL_STATE(819)] = 14632,
  [SMALL_STATE(820)] = 14639,
  [SMALL_STATE(821)] = 14646,
  [SMALL_STATE(822)] = 14653,
  [SMALL_STATE(823)] = 14660,
  [SMALL_STATE(824)] = 14667,
  [SMALL_STATE(825)] = 14674,
  [SMALL_STATE(826)] = 14681,
  [SMALL_STATE(827)] = 14688,
  [SMALL_STATE(828)] = 14695,
  [SMALL_STATE(829)] = 14702,
  [SMALL_STATE(830)] = 14709,
  [SMALL_STATE(831)] = 14716,
  [SMALL_STATE(832)] = 14723,
  [SMALL_STATE(833)] = 14730,
  [SMALL_STATE(834)] = 14737,
  [SMALL_STATE(835)] = 14744,
  [SMALL_STATE(836)] = 14751,
  [SMALL_STATE(837)] = 14758,
  [SMALL_STATE(838)] = 14765,
  [SMALL_STATE(839)] = 14772,
  [SMALL_STATE(840)] = 14779,
  [SMALL_STATE(841)] = 14786,
  [SMALL_STATE(842)] = 14793,
  [SMALL_STATE(843)] = 14800,
  [SMALL_STATE(844)] = 14807,
  [SMALL_STATE(845)] = 14814,
  [SMALL_STATE(846)] = 14821,
  [SMALL_STATE(847)] = 14828,
  [SMALL_STATE(848)] = 14835,
  [SMALL_STATE(849)] = 14842,
  [SMALL_STATE(850)] = 14849,
  [SMALL_STATE(851)] = 14856,
  [SMALL_STATE(852)] = 14863,
  [SMALL_STATE(853)] = 14870,
  [SMALL_STATE(854)] = 14877,
  [SMALL_STATE(855)] = 14884,
  [SMALL_STATE(856)] = 14891,
  [SMALL_STATE(857)] = 14898,
  [SMALL_STATE(858)] = 14905,
  [SMALL_STATE(859)] = 14912,
  [SMALL_STATE(860)] = 14919,
  [SMALL_STATE(861)] = 14926,
  [SMALL_STATE(862)] = 14933,
  [SMALL_STATE(863)] = 14940,
  [SMALL_STATE(864)] = 14947,
  [SMALL_STATE(865)] = 14954,
  [SMALL_STATE(866)] = 14961,
  [SMALL_STATE(867)] = 14968,
  [SMALL_STATE(868)] = 14975,
  [SMALL_STATE(869)] = 14982,
  [SMALL_STATE(870)] = 14989,
  [SMALL_STATE(871)] = 14996,
  [SMALL_STATE(872)] = 15003,
  [SMALL_STATE(873)] = 15010,
  [SMALL_STATE(874)] = 15017,
  [SMALL_STATE(875)] = 15024,
  [SMALL_STATE(876)] = 15031,
  [SMALL_STATE(877)] = 15038,
  [SMALL_STATE(878)] = 15045,
  [SMALL_STATE(879)] = 15052,
  [SMALL_STATE(880)] = 15059,
  [SMALL_STATE(881)] = 15066,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(622),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(360),
  [118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(57),
  [121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(57),
  [124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(844),
  [132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(26),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(859),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(800),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(759),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(409),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(412),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(836),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(703),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(39),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(858),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(429),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(853),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(56),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(742),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(173),
  [195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(59),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(809),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(355),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(785),
  [213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(521),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(522),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(790),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 1, 0, 0), REDUCE(aux_sym_tuple_expression_repeat1, 1, 0, 0),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 1, 0, 0),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(527),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(500),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(837),
  [327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(818),
  [333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(823),
  [336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(866),
  [339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(828),
  [342] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(811),
  [345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(869),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(852),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(622),
  [354] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(809),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 67),
  [367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 67),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(515),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 78),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 78),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_statement, 2, 0, 0),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_statement, 2, 0, 0),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 2, 0, 0),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 2, 0, 0),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_statement, 4, 0, 68),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_statement, 4, 0, 68),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 74),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 74),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 4, 0, 0),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 4, 0, 0),
  [430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0),
  [435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(872),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(873),
  [441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(860),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(861),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(862),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(607),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(610),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(817),
  [465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(770),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(784),
  [471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(809),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 3, 0, 0),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 3, 0, 0),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 44),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 44),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 4, 0, 53),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, 0, 53),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 3, 0, 55),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 3, 0, 55),
  [490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 2, 0, 0),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 2, 0, 0),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 3, 0, 0),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 3, 0, 0),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 3, 0, 56),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 3, 0, 56),
  [506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 4, 0, 0),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 4, 0, 0),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 4, 0, 66),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 4, 0, 66),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_emit_statement, 4, 0, 23),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_emit_statement, 4, 0, 23),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 5, 0, 0),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 5, 0, 0),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 73),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 73),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 73),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 73),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 75),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 75),
  [540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 6, 0, 0),
  [542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 6, 0, 0),
  [544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 79),
  [546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 79),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 82),
  [550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 82),
  [552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_while_statement, 7, 0, 83),
  [554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_while_statement, 7, 0, 83),
  [556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [560] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [564] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(703),
  [576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(809),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 1, 0, 0),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 3, 0, 11),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_directive, 3, 0, 11),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_variable_declaration, 6, 0, 51),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_variable_declaration, 6, 0, 51),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 13),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 13),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 4, 0, 22),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 4, 0, 22),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 22),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 22),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 5, 0, 23),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 5, 0, 23),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_body, 3, 0, 0),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_body, 3, 0, 0),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_body, 2, 0, 0),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_body, 2, 0, 0),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 3, 0, 0),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_directive, 3, 0, 0),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 22),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 22),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 23),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 23),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 6, 0, 23),
  [671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 6, 0, 23),
  [673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2, 0, 0),
  [677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 5, 0, 31),
  [679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 5, 0, 31),
  [681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_declaration, 3, 0, 13),
  [683] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_declaration, 3, 0, 13),
  [685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_definition, 4, 0, 23),
  [687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_definition, 4, 0, 23),
  [689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 35),
  [691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 35),
  [693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 8, 0, 23),
  [695] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 8, 0, 23),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 47),
  [699] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 47),
  [701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 0),
  [703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2, 0, 0),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 3, 0, 13),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 3, 0, 13),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 7, 0, 23),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 7, 0, 23),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 35),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 35),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 48),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 48),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 13),
  [725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 13),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 35),
  [729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 35),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 37),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 37),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 38),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 38),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 39),
  [741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 39),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3, 0, 0),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3, 0, 0),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 4, 0, 19),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_directive, 4, 0, 19),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 23),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 23),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 4, 0, 20),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 4, 0, 20),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_definition, 5, 0, 23),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_definition, 5, 0, 23),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3, 0, 13),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3, 0, 13),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_type_definition, 5, 0, 23),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_type_definition, 5, 0, 23),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 3, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_body, 3, 0, 0),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 4, 0, 0),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 4, 0, 0),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 4, 0, 22),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 4, 0, 22),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 4, 0, 23),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 4, 0, 23),
  [787] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 4, 0, 53),
  [789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 4, 0, 53),
  [791] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 4, 0, 54),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 4, 0, 54),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 63),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 63),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 5, 0, 39),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 5, 0, 39),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 5, 0, 23),
  [805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 5, 0, 23),
  [807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 5, 0, 64),
  [809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 5, 0, 64),
  [811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 6, 0, 71),
  [813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 6, 0, 71),
  [815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 3, 0, 44),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 3, 0, 44),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 3, 0, 0),
  [821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 3, 0, 0),
  [823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 3, 0, 13),
  [825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 3, 0, 13),
  [827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 3, 0, 23),
  [829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 3, 0, 23),
  [831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 3, 0, 44),
  [833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 3, 0, 44),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 3, 0, 24),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 3, 0, 24),
  [839] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 4, 0, 53),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 4, 0, 53),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(255),
  [878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(239),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(708),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(236),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(286),
  [892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(287),
  [895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(236),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(264),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(605),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(315),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(257),
  [916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(516),
  [919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_member, 3, 0, 24),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 3, 0, 24),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_path, 1, 0, 0),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_path, 1, 0, 0),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_path, 2, 0, 0),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_path, 2, 0, 0),
  [968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_path_repeat1, 2, 0, 0),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_path_repeat1, 2, 0, 0),
  [972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_path_repeat1, 2, 0, 0), SHIFT_REPEAT(691),
  [975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_identifier, 1, 0, 0),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_identifier, 1, 0, 0),
  [979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 2, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 2, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 3, 0, 0),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 3, 0, 0),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_yul_identifier, 1, 0, 0), SHIFT(308),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 1, 0, 0),
  [1000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 1, 0, 0),
  [1002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_evm_builtin, 1, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_evm_builtin, 1, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 1, 0, 28),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 1, 0, 28),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_assignment_repeat1, 2, 0, 0),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_assignment_repeat1, 2, 0, 0),
  [1018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_assignment_repeat1, 2, 0, 0), SHIFT_REPEAT(631),
  [1021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2, 0, 0),
  [1023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2, 0, 0),
  [1025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(704),
  [1028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 4, 0, 28),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 4, 0, 28),
  [1032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 5, 0, 28),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 5, 0, 28),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_boolean, 1, 0, 0),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_boolean, 1, 0, 0),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 6, 0, 28),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 6, 0, 28),
  [1044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_string_literal, 1, 0, 0),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_string_literal, 1, 0, 0),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 3, 0, 28),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 3, 0, 28),
  [1052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2, 0, 0),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2, 0, 0),
  [1056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(499),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 3, 0, 72),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 3, 0, 72),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 3, 0, 0),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 3, 0, 0),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 2, 0, 65),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 2, 0, 65),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 4, 0, 76),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 4, 0, 76),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 3, 0, 0),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 3, 0, 0),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_block, 3, 0, 0),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_block, 3, 0, 0),
  [1097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_block, 2, 0, 0),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_block, 2, 0, 0),
  [1101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 5, 0, 80),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 5, 0, 80),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 6, 0, 85),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 6, 0, 85),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 6, 0, 0),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 6, 0, 0),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 5, 0, 0),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 5, 0, 0),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_break, 1, 0, 0),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_break, 1, 0, 0),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_continue, 1, 0, 0),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_continue, 1, 0, 0),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 6, 0, 84),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 6, 0, 84),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 4, 0, 0),
  [1143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 4, 0, 0),
  [1145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__yul_expression, 1, 0, 0), REDUCE(sym_yul_assignment, 3, 0, 0),
  [1148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__yul_expression, 1, 0, 0), REDUCE(sym_yul_assignment, 3, 0, 0),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 7, 0, 86),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 7, 0, 86),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 7, 0, 0),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 7, 0, 0),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 8, 0, 87),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 8, 0, 87),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 8, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 8, 0, 0),
  [1167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 9, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 9, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 10, 0, 0),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 10, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 5, 0, 0),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 5, 0, 0),
  [1179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 12, 0, 0),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 12, 0, 0),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 4, 0, 0),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 4, 0, 0),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_if_statement, 3, 0, 0),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_if_statement, 3, 0, 0),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_for_statement, 5, 0, 0),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_for_statement, 5, 0, 0),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 4, 0, 77),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 4, 0, 77),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 5, 0, 81),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 5, 0, 81),
  [1213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_label, 2, 0, 0),
  [1215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_label, 2, 0, 0),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 5, 0, 0),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 5, 0, 0),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 11, 0, 0),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 11, 0, 0),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__yul_assignment_operator, 2, 0, 0),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__yul_assignment_operator, 2, 0, 0),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0),
  [1259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0), SHIFT_REPEAT(803),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3, 0, 6),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3, 0, 6),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0),
  [1276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(335),
  [1279] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(333),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 2, 0, 6),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 2, 0, 6),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 3, 0, 0),
  [1288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 3, 0, 0),
  [1290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 4, 0, 0),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 4, 0, 0),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 5, 0, 0),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 5, 0, 0),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_mutability, 1, 0, 0),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_mutability, 1, 0, 0),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility, 1, 0, 0),
  [1308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility, 1, 0, 0),
  [1310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_type, 1, 0, 0),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_type, 1, 0, 0),
  [1314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [1318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 2, 0, 0),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 2, 0, 0),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_type, 3, 0, 0),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 3, 0, 0),
  [1328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 4, 0, 49),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 4, 0, 49),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 6, 0, 49),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 6, 0, 49),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 8, 0, 69),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 8, 0, 69),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 4, 0, 6),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 4, 0, 6),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 0),
  [1346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 0),
  [1348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 6, 0, 50),
  [1350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 6, 0, 50),
  [1352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 5, 0, 49),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 5, 0, 49),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 7, 0, 58),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 7, 0, 58),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 7, 0, 59),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 7, 0, 59),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 1),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 1),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_type, 4, 0, 0),
  [1370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 4, 0, 0),
  [1372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 2),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 2),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1, 0, 0),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1, 0, 0),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 4, 0, 0),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 4, 0, 0),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 2, 0, 0),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 2, 0, 0),
  [1390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 5, 0, 0),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 5, 0, 0),
  [1394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 3, 0, 0),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 3, 0, 0),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_path, 1, 0, 0),
  [1400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym__identifier_path, 1, 0, 0),
  [1403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym__identifier_path, 1, 0, 0),
  [1406] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym__identifier_path, 1, 0, 0), SHIFT(865),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_path, 2, 0, 0),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_path, 2, 0, 0),
  [1414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1, 0, 0),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1, 0, 0),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [1420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [1422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(521),
  [1425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(522),
  [1428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0), REDUCE(sym_member_expression, 3, 1, 40),
  [1431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0), REDUCE(sym_member_expression, 3, 1, 40),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hex_string_literal, 1, 0, 0),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hex_string_literal, 1, 0, 0),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_string_literal, 1, 0, 0),
  [1442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unicode_string_literal, 1, 0, 0),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2, 0, 0),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2, 0, 0),
  [1450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(785),
  [1453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2, 0, 0),
  [1455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2, 0, 0),
  [1457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2, 0, 0), SHIFT_REPEAT(790),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 41),
  [1462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 41),
  [1466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [1478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [1480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [1488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 42),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [1508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [1510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(35),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 23),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 23),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 5, 0, 0),
  [1521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 5, 0, 0),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 4, 0, 0),
  [1529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 4, 0, 0),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 4, 0, 0),
  [1533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 4, 0, 0),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 3, 0, 0),
  [1537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 3, 0, 0),
  [1539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 26),
  [1541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 26),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 3, 0, 0),
  [1545] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 3, 0, 0),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, 0, 42),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 26),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 26),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 6, 0, 14),
  [1555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 6, 0, 14),
  [1557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 2, 0, 0),
  [1559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 2, 0, 0),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 3, 0, 0),
  [1563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 3, 0, 0),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 5, 0, 62),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 5, 0, 62),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 5, 0, 14),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 5, 0, 14),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payable_conversion_expression, 2, 0, 0),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payable_conversion_expression, 2, 0, 0),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 1, 40),
  [1587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 1, 40),
  [1589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym_type_name, 1, 0, 0),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 4, 0, 0),
  [1598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 4, 0, 0),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 3, 0, 14),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 3, 0, 14),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_true, 1, 0, 0),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_true, 1, 0, 0),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 4, 0, 14),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 4, 0, 14),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 6, 0, 70),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 6, 0, 70),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_false, 1, 0, 0),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_false, 1, 0, 0),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 5, 0, 61),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 5, 0, 61),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 27),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 27),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_type_expression, 4, 0, 0),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_type_expression, 4, 0, 0),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 4, 0, 43),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 4, 0, 43),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 28),
  [1646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 28),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 2, 0, 0),
  [1650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 2, 0, 0),
  [1652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_unit, 1, 0, 0),
  [1654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_unit, 1, 0, 0),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 2, 0, 0),
  [1658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 2, 0, 0),
  [1660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 3, 0, 43),
  [1662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 3, 0, 43),
  [1664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, 0, 52),
  [1666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, 0, 52),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [1670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [1672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [1674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 23),
  [1678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 23),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 5, 0, 0),
  [1682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 5, 0, 0),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_field_assignment, 3, 0, 60),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_struct_argument, 3, 0, 60),
  [1714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [1718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 1, 0, 0),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_array_expression_repeat1, 2, 0, 0),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_tuple, 3, 0, 0),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_tuple, 2, 0, 0),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_path, 1, 0, 0),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [1803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(335),
  [1806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(333),
  [1809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [1812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(482),
  [1815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0),
  [1820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(335),
  [1823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(333),
  [1826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [1829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 1, 0, 0),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 1, 0, 0),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [1838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1, 0, 0), REDUCE(aux_sym__function_type_repeat1, 1, 0, 0),
  [1841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1, 0, 0),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 1, 0, 0),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1, 0, 0),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_repeat1, 1, 0, 0),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 4, 0, 0),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 4, 0, 0),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 5, 0, 0),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 5, 0, 0),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 6, 0, 0),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 6, 0, 0),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_invocation, 1, 0, 0),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_invocation, 1, 0, 0),
  [1865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_invocation, 2, 0, 0),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_invocation, 2, 0, 0),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 45),
  [1881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 45), SHIFT_REPEAT(493),
  [1884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 45), SHIFT_REPEAT(335),
  [1887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 45), SHIFT_REPEAT(503),
  [1890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 45), SHIFT_REPEAT(484),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [1899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_pragma_token, 1, 0, 0),
  [1901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15), SHIFT_REPEAT(497),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15), SHIFT_REPEAT(810),
  [1907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15), SHIFT_REPEAT(810),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15),
  [1912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_pragma_token, 2, 0, 8),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 1, 0, 7),
  [1918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 1, 0, 7),
  [1920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pragma_version_constraint, 2, 0, 0),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pragma_version_constraint, 2, 0, 0),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 1, 0, 33),
  [1946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_location, 1, 0, 0),
  [1948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 1, 0, 32),
  [1950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 7),
  [1952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 7),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 14),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(473),
  [1971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_definition_repeat1, 2, 0, 0),
  [1973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(510),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nameless_parameter, 1, 0, 14),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2, 0, 0),
  [1986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(484),
  [1989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(514),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [1996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2000] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 3, 0, 0),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [2008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 1, 0, 14),
  [2010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 4, 0, 0),
  [2014] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(520),
  [2017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2, 0, 0),
  [2019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(854),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [2024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [2034] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(523),
  [2037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(523),
  [2040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [2042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [2056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [2060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(528),
  [2063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(528),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat2, 2, 0, 0),
  [2080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(537),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_declaration, 1, 0, 3),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 36),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inheritance_specifier, 1, 0, 21),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat1, 2, 0, 0),
  [2153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(566),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 24),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_alias, 2, 0, 16),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_parameter, 1, 0, 14),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 1, 0, 0),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [2188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 2, 0, 0), SHIFT_REPEAT(613),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 2, 0, 0),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_override_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(619),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_specifier_repeat1, 2, 0, 0),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 2, 0, 0),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_argument_repeat1, 2, 0, 0),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, 0, 30), SHIFT_REPEAT(702),
  [2235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, 0, 30),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(43),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_flags_repeat1, 2, 0, 0), SHIFT_REPEAT(632),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assembly_flags_repeat1, 2, 0, 0),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 1, 0, 0),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 2, 0, 0),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [2345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_function_call_repeat1, 2, 0, 0), SHIFT_REPEAT(314),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_function_call_repeat1, 2, 0, 0),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 25),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__source_import, 1, 0, 5),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_heritage_repeat1, 2, 0, 0),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_heritage_repeat1, 2, 0, 0), SHIFT_REPEAT(577),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_error_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(147),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_error_declaration_repeat1, 2, 0, 0),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [2394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(808),
  [2397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(151),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, 0, 0),
  [2408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__event_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(148),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__event_parameter_list_repeat1, 2, 0, 0),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__call_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__call_arguments_repeat1, 2, 0, 0),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 2, 0, 14),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 1, 0, 3),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [2448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(700),
  [2451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_expression_repeat1, 2, 0, 0),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_array_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(66),
  [2460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(150),
  [2463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 4, 0, 0),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 2, 0, 0),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inheritance_specifier, 2, 0, 34),
  [2495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 24),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [2501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 2, 0, 0),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [2515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 5, 0, 0),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_parameter, 2, 0, 24),
  [2521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, 0, 57),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 35),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 4, 0, 0),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 3, 0, 46),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [2547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_type_definition, 2, 0, 0),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 3, 0, 0),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_declaration, 2, 0, 10),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 3, 0, 0),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [2563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, 0, 17),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 2, 0, 24),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 5, 0, 0),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 36),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nameless_parameter, 2, 0, 25),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_value, 1, 0, 0),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 2, 0, 10),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [2627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_version_comparison_operator, 1, 0, 0),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 4, 0, 29),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 5, 0, 0),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_pragma_token, 2, 0, 0),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_source_type, 1, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 6, 0, 0),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_clause, 1, 0, 4),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, 0, 18),
  [2673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 3, 0, 0),
  [2675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 4, 0, 0),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__source_import, 2, 0, 12),
  [2683] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 2, 0, 0),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 5, 0, 29),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 4, 0, 17),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 2, 0, 9),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 3, 0, 0),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 2, 0, 0),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 4, 0, 0),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [2739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 3, 0, 17),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 5, 0, 0),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_solidity(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
